Package: ape
Version: 5.4-1
Date: 2020-08-12
Title: Analyses of Phylogenetics and Evolution
Authors@R: c(person("Emmanuel", "Paradis", role = c("aut", "cre", "cph"), email = "Emmanuel.Paradis@ird.fr", comment = c(ORCID = "0000-0003-3092-2199")),
  person("Simon", "Blomberg", role = c("aut", "cph"), comment = c(ORCID = "0000-0003-1062-0839")),
  person("Ben", "Bolker", role = c("aut", "cph"), comment = c(ORCID = "0000-0002-2127-0443")),
  person("Joseph", "Brown", role = c("aut", "cph")),
  person("Santiago", "Claramunt", role = c("aut", "cph"), comment = c(ORCID = "0000-0002-8926-5974")),
  person("Julien", "Claude", role = c("aut", "cph"), , comment = c(ORCID = "0000-0002-9267-1228")),
  person("Hoa Sien", "Cuong", role = c("aut", "cph")),
  person("Richard", "Desper", role = c("aut", "cph")),
  person("Gilles", "Didier", role = c("aut", "cph"), comment = c(ORCID = "0000-0003-0596-9112")),
  person("Benoit", "Durand", role = c("aut", "cph")),
  person("Julien", "Dutheil", role = c("aut", "cph"), comment = c(ORCID = "0000-0001-7753-4121")),
  person("RJ", "Ewing", role = c("aut", "cph")),
  person("Olivier", "Gascuel", role = c("aut", "cph")),
  person("Thomas", "Guillerme", role = c("aut", "cph"), comment = c(ORCID = "0000-0003-4325-1275")),
  person("Christoph", "Heibl", role = c("aut", "cph"), comment = c(ORCID = "0000-0002-7655-3299")),
  person("Anthony", "Ives", role = c("aut", "cph")),
  person("Bradley", "Jones", role = c("aut", "cph"), comment = c(ORCID = "0000-0003-4498-1069")),
  person("Franz", "Krah", role = c("aut", "cph"), comment = c(ORCID = "0000-0001-7866-7508")),
  person("Daniel", "Lawson", role = c("aut", "cph"), comment = c(ORCID = "0000-0002-5311-6213")),
  person("Vincent", "Lefort", role = c("aut", "cph")),
  person("Pierre", "Legendre", role = c("aut", "cph"), comment = c(ORCID = "0000-0002-3838-3305")),
  person("Jim", "Lemon", role = c("aut", "cph")),
  person("Guillaume", "Louvel", role = c("aut", "cph")),
  person("Eric", "Marcon", role = c("aut", "cph"), comment = c(ORCID = "0000-0002-5249-321X")),
  person("Rosemary", "McCloskey", role = c("aut", "cph")),
  person("Johan", "Nylander", role = c("aut", "cph")),
  person("Rainer", "Opgen-Rhein", role = c("aut", "cph")),
  person("Andrei-Alin", "Popescu", role = c("aut", "cph")),
  person("Manuela", "Royer-Carenzi", role = c("aut", "cph")),
  person("Klaus", "Schliep", role = c("aut", "cph"), comment = c(ORCID = "0000-0003-2941-0161")),
  person("Korbinian", "Strimmer", role = c("aut", "cph"), comment = c(ORCID = "0000-0001-7917-2056")),
  person("Damien", "de Vienne", role = c("aut", "cph"), comment = c(ORCID = "0000-0001-9532-5251")))
Depends: R (>= 3.2.0)
Suggests: gee, expm, igraph
Imports: nlme, lattice, graphics, methods, stats, tools, utils,
        parallel, Rcpp (>= 0.12.0)
LinkingTo: Rcpp
ZipData: no
Description: Functions for reading, writing, plotting, and manipulating phylogenetic trees, analyses of comparative data in a phylogenetic framework, ancestral character analyses, analyses of diversification and macroevolution, computing distances from DNA sequences, reading and writing nucleotide sequences as well as importing from BioConductor, and several tools such as Mantel's test, generalized skyline plots, graphical exploration of phylogenetic data (alex, trex, kronoviz), estimation of absolute evolutionary rates and clock-like trees using mean path lengths and penalized likelihood, dating trees with non-contemporaneous sequences, translating DNA into AA sequences, and assessing sequence alignments. Phylogeny estimation can be done with the NJ, BIONJ, ME, MVR, SDM, and triangle methods, and several methods handling incomplete distance matrices (NJ*, BIONJ*, MVR*, and the corresponding triangle method). Some functions call external applications (PhyML, Clustal, T-Coffee, Muscle) whose results are returned into R.
License: GPL-2 | GPL-3
URL: http://ape-package.ird.fr/
NeedsCompilation: yes
Packaged: 2020-08-12 09:57:49 UTC; paradis
Author: Emmanuel Paradis [aut, cre, cph]
    (<https://orcid.org/0000-0003-3092-2199>),
  Simon Blomberg [aut, cph] (<https://orcid.org/0000-0003-1062-0839>),
  Ben Bolker [aut, cph] (<https://orcid.org/0000-0002-2127-0443>),
  Joseph Brown [aut, cph],
  Santiago Claramunt [aut, cph] (<https://orcid.org/0000-0002-8926-5974>),
  Julien Claude [aut, cph] (<https://orcid.org/0000-0002-9267-1228>),
  Hoa Sien Cuong [aut, cph],
  Richard Desper [aut, cph],
  Gilles Didier [aut, cph] (<https://orcid.org/0000-0003-0596-9112>),
  Benoit Durand [aut, cph],
  Julien Dutheil [aut, cph] (<https://orcid.org/0000-0001-7753-4121>),
  RJ Ewing [aut, cph],
  Olivier Gascuel [aut, cph],
  Thomas Guillerme [aut, cph] (<https://orcid.org/0000-0003-4325-1275>),
  Christoph Heibl [aut, cph] (<https://orcid.org/0000-0002-7655-3299>),
  Anthony Ives [aut, cph],
  Bradley Jones [aut, cph] (<https://orcid.org/0000-0003-4498-1069>),
  Franz Krah [aut, cph] (<https://orcid.org/0000-0001-7866-7508>),
  Daniel Lawson [aut, cph] (<https://orcid.org/0000-0002-5311-6213>),
  Vincent Lefort [aut, cph],
  Pierre Legendre [aut, cph] (<https://orcid.org/0000-0002-3838-3305>),
  Jim Lemon [aut, cph],
  Guillaume Louvel [aut, cph],
  Eric Marcon [aut, cph] (<https://orcid.org/0000-0002-5249-321X>),
  Rosemary McCloskey [aut, cph],
  Johan Nylander [aut, cph],
  Rainer Opgen-Rhein [aut, cph],
  Andrei-Alin Popescu [aut, cph],
  Manuela Royer-Carenzi [aut, cph],
  Klaus Schliep [aut, cph] (<https://orcid.org/0000-0003-2941-0161>),
  Korbinian Strimmer [aut, cph] (<https://orcid.org/0000-0001-7917-2056>),
  Damien de Vienne [aut, cph] (<https://orcid.org/0000-0001-9532-5251>)
Maintainer: Emmanuel Paradis <Emmanuel.Paradis@ird.fr>
Repository: CRAN
Date/Publication: 2020-08-13 05:20:14 UTC

## multi2di.R (2020-08-11)

##   Collapse or Resolve Multichotomies

## Copyright 2005-2020 Emmanuel Paradis, 2018 Klaus Schliep

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

multi2di <- function(phy, ...) UseMethod("multi2di")

.multi2di_ape <- function(phy, random, equiprob, n)
{
    ## n: number of tips of phy
    degree <- tabulate(phy$edge[, 1])
    target <- which(degree > 2)
    if (!length(target)) return(phy)
    nb.edge <- dim(phy$edge)[1]
    nextnode <- n + phy$Nnode + 1L
    new.edge <- edge2delete <- NULL
    wbl <- FALSE
    if (!is.null(phy$edge.length)) {
        wbl <- TRUE
        new.edge.length <- NULL
    }

    for (node in target) {
        ind <- which(phy$edge[, 1] == node)
        N <- length(ind)
        desc <- phy$edge[ind, 2]
        if (random) {
          ## if we shuffle the descendants, we need to eventually
          ## reorder the corresponding branch lenghts (see below)
          ## so we store the result of sample()
            tmp <- sample(length(desc))
            desc <- desc[tmp]
            res <- rtree(N, equiprob = equiprob)$edge
        } else {
            res <- matrix(0L, 2*N - 2, 2)
            res[, 1] <- N + rep(1:(N - 1), each = 2)
            res[, 2] <- N + rep(2:N, each = 2)
            res[seq(1, by = 2, length.out = N - 1), 2] <- 1:(N - 1)
            res[length(res)] <- N
        }
       if (wbl) {
            ## keep the branch lengths coming from `node'
            el <- numeric(dim(res)[1]) # initialized with 0's
            el[res[, 2] <= N] <-
              if (random) phy$edge.length[ind][tmp] else phy$edge.length[ind]
        }
        ## now substitute the nodes in `res'
        ## `node' stays at the "root" of these new
        ## edges whereas their "tips" are `desc'
        Nodes <- c(node, nextnode:(nextnode + N - 3L))
        res[, 1] <- Nodes[res[, 1] - N]
        tmp <- res[, 2] > N
        res[tmp, 2] <- Nodes[res[tmp, 2] - N]
        res[!tmp, 2] <- desc[res[!tmp, 2]]
        new.edge <- rbind(new.edge, res)
        edge2delete <- c(edge2delete, ind)
        if (wbl) new.edge.length <- c(new.edge.length, el)
        nextnode <- nextnode + N - 2L
        phy$Nnode <- phy$Nnode + N - 2L
    }
    phy$edge <- rbind(phy$edge[-edge2delete, ], new.edge)
    if (wbl)
        phy$edge.length <- c(phy$edge.length[-edge2delete], new.edge.length)
    if (!is.null(attr(phy, "order"))) attr(phy, "order") <- NULL
    if (!is.null(phy$node.label))
        phy$node.label <-
            c(phy$node.label, rep("", phy$Nnode - length(phy$node.label)))
    phy <- .reorder_ape(phy, "cladewise", FALSE, n, 1L) # fix by Klaus (2017-01-16)

    ## the node numbers are not in increasing order in edge[, 2]: this
    ## will confuse drop.tip and other functions (root), so renumber them
    newNb <- integer(phy$Nnode)
    newNb[1] <- n + 1L
    sndcol <- phy$edge[, 2] > n

    ## reorder node labels before changing edge:
    if (!is.null(phy$node.label)) {
        o <- 1 + rank(phy$edge[sndcol, 2])
        ## the root's label is not changed:
        phy$node.label <- phy$node.label[c(1, o)]
    }

    ## executed from right to left, so newNb is modified before phy$edge:
    phy$edge[sndcol, 2] <- newNb[phy$edge[sndcol, 2] - n] <-
        n + 2:phy$Nnode
    phy$edge[, 1] <- newNb[phy$edge[, 1] - n]
    phy
}

multi2di.phylo <- function (phy, random = TRUE, equiprob = TRUE, ...)
    .multi2di_ape(phy, random, equiprob = equiprob, length(phy$tip.label))

multi2di.multiPhylo <- function(phy, random = TRUE, equiprob = TRUE, ...)
{
    labs <- attr(phy, "TipLabel")
    oc <- oldClass(phy)
    class(phy) <- NULL
    if (is.null(labs)) phy <- lapply(phy, multi2di.phylo, random = random, equiprob = equiprob)
    else {
        phy <- lapply(phy, .multi2di_ape, random = random, equiprob = equiprob, n = length(labs))
        attr(phy, "TipLabel") <- labs
    }
    class(phy) <- oc
    phy
}

di2multi <- function(phy, ...) UseMethod("di2multi")

## by Klaus (2018-05-28)
.di2multi_ape <- function (phy, tol = 1e-08, ntips)
{
    if (is.null(phy$edge.length)) stop("the tree has no branch length")
    phy <- reorder(phy)
    e1 <- seq_len(max(phy$edge))
    ind <- which(phy$edge.length < tol & phy$edge[, 2] > ntips)
    n <- length(ind)
    if (!n) return(phy)

    for (i in ind)
        e1[phy$edge[i,2]] <-  e1[phy$edge[i,1]]

    phy$edge[, 1] <- e1[phy$edge[, 1]]
    node2del <- phy$edge[ind, 2]
    phy$edge <- phy$edge[-ind, ]
    phy$edge.length <- phy$edge.length[-ind]

    phy$Nnode <- phy$Nnode - n

    e1 <- sort(unique(phy$edge[, 1]))
    tmp <- integer(max(phy$edge))
    tmp[e1] <- ntips + seq_len(phy$Nnode)
    tmp[1:ntips] <- seq_len(ntips)

    phy$edge[] <- tmp[phy$edge]
    if (!is.null(phy$node.label))
        phy$node.label <- phy$node.label[-(node2del - ntips)]
    phy
}

di2multi.phylo <- function (phy, tol = 1e-08, ...)
    .di2multi_ape(phy, tol, length(phy$tip.label))

di2multi.multiPhylo <- function(phy, tol = 1e-08, ...)
{
    labs <- attr(phy, "TipLabel")
    oc <- oldClass(phy)
    class(phy) <- NULL
    if (is.null(labs)) phy <- lapply(phy, di2multi.phylo, tol = tol)
    else {
        phy <- lapply(phy, .di2multi_ape, tol = tol, ntips = length(labs))
        attr(phy, "TipLabel") <- labs
    }
    class(phy) <- oc
    phy
}

## pic.R (2017-08-22)

##   Phylogenetically Independent Contrasts

## Copyright 2002-2017 Emmanuel Paradis

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

pic <- function(x, phy, scaled = TRUE, var.contrasts = FALSE, rescaled.tree = FALSE)
{
    if (!inherits(phy, "phylo")) stop("object 'phy' is not of class \"phylo\"")
    if (is.null(phy$edge.length)) stop("your tree has no branch lengths")
    nb.tip <- length(phy$tip.label)
    nb.node <- phy$Nnode
    if (nb.node != nb.tip - 1)
        stop("'phy' is not rooted and fully dichotomous")
    if (length(x) != nb.tip)
        stop("length of phenotypic and of phylogenetic data do not match")
    if (any(is.na(x)))
        stop("missing data in 'x': you may consider removing the species with missing data from your tree with the function 'drop.tip'.")

    phy <- reorder(phy, "postorder")
    phenotype <- numeric(nb.tip + nb.node)

    if (is.null(names(x))) {
        phenotype[1:nb.tip] <- x
    } else {
        if (all(names(x) %in% phy$tip.label))
          phenotype[1:nb.tip] <- x[phy$tip.label]
        else {
            phenotype[1:nb.tip] <- x
            warning("the names of argument 'x' and the tip labels of the tree did not match: the former were ignored in the analysis.")
        }
    }

    ## No need to copy the branch lengths: they are rescaled
    ## in the C code, so it's important to leave the default
    ## `DUP = TRUE' of .C.
    ans <- .C(C_pic, as.integer(nb.tip),
              as.integer(phy$edge[, 1]), as.integer(phy$edge[, 2]),
              as.double(phy$edge.length), as.double(phenotype),
              double(nb.node), double(nb.node),
              as.integer(var.contrasts), as.integer(scaled))

    contr <- ans[[6]]
    lbls <-
        if (is.null(phy$node.label)) as.character(1:nb.node + nb.tip)
        else phy$node.label
    if (var.contrasts) {
        contr <- cbind(contr, ans[[7]])
        dimnames(contr) <- list(lbls, c("contrasts", "variance"))
    } else names(contr) <- lbls
    if (rescaled.tree) {
        phy$edge.length <- ans[[4]]
        contr <- list(contr = contr, rescaled.tree = phy)
    }
    contr
}

pic.ortho <- function(x, phy, var.contrasts = FALSE, intra = FALSE)
{
    n <- length(x)
    m <- n - 1L # number of nodes
    phy <- reorder(phy, "postorder")
    xx <- unlist(lapply(x, mean)) # 'x' in Felsenstein's paper
    xx <- c(xx, numeric(m))
    delta.v <- numeric(n + m)
    s <- 1/lengths(x)
    s <- c(s, numeric(m))
    contrast <- var.cont <- numeric(m)

    i <- 1L
    while (i < m + n) {
        d1 <- phy$edge[i, 2]
        d2 <- phy$edge[i + 1L, 2]
        a <- phy$edge[i, 1]
        tmp1 <- 1/(phy$edge.length[i] + delta.v[d1])
        tmp2 <- 1/(phy$edge.length[i + 1L] + delta.v[d2])
        xx[a] <- (tmp1 * xx[d1] + tmp2 * xx[d2])/(tmp1 + tmp2)
        delta.v[a] <- 1/(tmp1 + tmp2)
        f1 <- tmp1/(tmp1 + tmp2)
        f2 <- tmp2/(tmp1 + tmp2)
        s[a] <- f1*f1 * s[d1] + f2*f2 * s[d2]
        tmp <- 1/(s[d1] + s[d2])
        contrast[a - n] <- (xx[d1] - xx[d2]) * sqrt(tmp)
        var.cont[a - n] <- (1/tmp1 + 1/tmp2) * tmp
        i <- i + 2L
    }

    lbls <-
        if (is.null(phy$node.label)) as.character(1:m + n)
        else phy$node.label

    if (var.contrasts) {
        contrast <- cbind(contrast, var.cont)
        dimnames(contrast) <- list(lbls, c("contrasts", "variance"))
    } else names(contrast) <- lbls

    if (intra) {
        intraspe.ctr <- function(x) {
            k <- length(x) - 1L
            if (!k) return(NULL)
            ctr <- numeric(k)
            ctr[1L] <- x[1L] - x[2L]
            if (k > 1)
                for (i in 2:k)
                    ctr[i] <- x[i + 1L] - mean(x[1:i])
            sqrt((1:k)/(1:k + 1)) * ctr
        }
        tmp <- lapply(x, intraspe.ctr)
        names(tmp) <- phy$tip.label
        attr(contrast, "intra") <- tmp
    }

    contrast
}

varCompPhylip <- function(x, phy, exec = NULL)
{
    n <- Ntip(phy)
    if (is.vector(x)) x <- as.list(x)
    if (is.matrix(x) || is.data.frame(x)) {
        tmpx <- vector("list", n)
        for (i in 1:n) tmpx[[i]] <- x[i, , drop = FALSE]
        names(tmpx) <- rownames(x)
        x <- tmpx
    }
    p <- if (is.vector(x[[1]])) 1L else ncol(x[[1]])
    if (!is.null(names(x))) x <- x[phy$tip.label]

    phy <- makeLabel(phy, len = 10)
    lbs <- phy$tip.label

    ni <- sapply(x, function(xx) if (is.vector(xx)) 1L else nrow(xx))

    pfx <- tempdir()
    write.tree(phy, file = paste(pfx, "intree", sep = "/"))
    infile <- paste(pfx, "infile", sep = "/")
    file.create(infile)
    cat(n, " ", p, "\n", sep = "", file = infile, append = TRUE)
    for (i in 1:n) {
        cat(lbs[i], file = infile, append = TRUE)
        ## can surely be better but OK for the moment:
        cat(paste(rep(" ", 11 - nchar(lbs[i])), collapse = ""),
            file = infile, append = TRUE)
        cat(ni[i], "\n", sep = "", file = infile, append = TRUE)
        if (ni[i] == 1) {
            cat(x[[i]], sep = " ", file = infile, append = TRUE)
            cat("\n", file = infile, append = TRUE)
        } else write(t(x[[i]]), file = infile, ncolumns = p, append = TRUE)
    }

    if (is.null(exec))
        exec <-
            if (.Platform$OS.type == "unix") "phylip contrast"
            else "contrast"

    odir <- setwd(pfx)
    on.exit(setwd(odir))
    if (file.exists("outfile")) unlink("outfile")
    system(exec, intern = TRUE, input = c("W", "A", "Y"))
    varA <- scan("outfile", skip = 7, nlines = p, quiet = TRUE)
    varE <- scan("outfile", skip = 11 + p, nlines = p, quiet = TRUE)
    if (p > 1) {
        varA <- matrix(varA, p, p, byrow = TRUE)
        varE <- matrix(varE, p, p, byrow = TRUE)
    }
    list(varA = varA, varE = varE)
}

## PGLS.R (2020-04-13)

##   Phylogenetic Generalized Least Squares

## Copyright 2004-2020 Julien Dutheil, and 2006-2017 Emmanuel Paradis

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

corBrownian <- function(value = 1, phy, form = ~1)
{
    if (!inherits(phy, "phylo"))
        stop('object "phy" is not of class "phylo"')
    attr(value, "formula") <- form
    attr(value, "fixed") <- TRUE
    attr(value, "tree") <- phy
    class(value) <- c("corBrownian", "corPhyl", "corStruct")
    value
}

corMartins <- function(value, phy, form = ~1, fixed = FALSE)
{
    if (length(value) > 1)
        stop("only one parameter is allowed")
    if (value < 0) stop("the parameter alpha must be positive")
    if (!inherits(phy, "phylo"))
        stop('object "phy" is not of class "phylo"')
    attr(value, "formula") <- form
    attr(value, "fixed") <- fixed
    attr(value, "tree") <- phy
    class(value) <- c("corMartins", "corPhyl", "corStruct")
    value
}

corGrafen <- function(value, phy, form = ~1, fixed = FALSE)
{
    if (length(value) > 1)
        stop("only one parameter is allowed")
    if (value < 0) stop("parameter rho must be positive")
    value <- log(value) # Optimization under constraint, use exponential transform.
    if (!inherits(phy, "phylo"))
        stop('object "phy" is not of class "phylo"')
    attr(value, "formula") <- form
    attr(value, "fixed") <- fixed
    attr(value, "tree") <- phy
    class(value) <- c("corGrafen", "corPhyl", "corStruct")

    value
}

Initialize.corPhyl <- function(object, data, ...)
{
    ## The same as in Initialize corStruct:
    form <- formula(object)
    if (getCovariateFormula(object) == ~1) {
      warning("No covariate specified, species will be taken as ordered in the data frame. To avoid this message, specify a covariate containing the species names with the 'form' argument.")
    }
    ## Obtaining the group information, if any
    if (!is.null(getGroupsFormula(form))) {
        attr(object, "groups") <- getGroups(object, form, data = data)
        attr(object, "Dim") <- Dim(object, attr(object, "groups"))
    } else { # no groups
        attr(object, "Dim") <- Dim(object, as.factor(rep(1, nrow(data))))
    }
    ## Obtaining the covariate(s)
    attr(object, "covariate") <- getCovariate(object, data = data)

    object
}

corMatrix.corBrownian <-
    function(object, covariate = getCovariate(object), corr = TRUE, ...)
{
    if (!("corBrownian" %in% class(object)))
        stop('object is not of class "corBrownian"')
    if (data.class(covariate) == "list") {
        as.list(lapply(covariate, function(el) corMatrix(object, covariate = el)))
    } else {
        tree <- attr(object, "tree")
        mat <- vcv.phylo(tree, corr = corr)
        mat[covariate, covariate]
    }
}

corMatrix.corMartins <-
    function(object, covariate = getCovariate(object), corr = TRUE, ...)
{
    if (!("corMartins" %in% class(object)))
        stop('object is not of class "corMartins"')
    if (data.class(covariate) == "list") {
        as.list(lapply(covariate, function(el) corMatrix(object, covariate = el)))
    } else {
        tree <- attr(object, "tree")
        dist <- cophenetic.phylo(tree)
        mat <- exp(-object[1] * dist)
        if (corr) mat <- cov2cor(mat)
        mat[covariate, covariate]
    }
}

corMatrix.corGrafen <-
    function(object, covariate = getCovariate(object), corr = TRUE, ...)
{
    if (!("corGrafen" %in% class(object)))
        stop('object is not of class "corGrafen"')
    if (data.class(covariate) == "list") {
        as.list(lapply(covariate, function(el) corMatrix(object, covariate = el)))
    } else {
        tree <- compute.brlen(attr(object, "tree"),
                              method = "Grafen", power = exp(object[1]))
        mat <- vcv.phylo(tree, corr = corr)
        mat[covariate, covariate]
    }
}

coef.corBrownian <- function(object, unconstrained = TRUE, ...)
{
    if (!("corBrownian" %in% class(object)))
        stop('object is not of class "corBrownian"')
    numeric(0)
}

coef.corMartins <- function(object, unconstrained = TRUE, ...)
{
    if (!("corMartins" %in% class(object)))
        stop('object is not of class "corMartins"')
    if (unconstrained) {
        if (attr(object, "fixed")) {
            return(numeric(0))
        } else {
            return(as.vector(object))
        }
    }
    aux <- as.vector(object)
    names(aux) <- "alpha"
    aux
}

coef.corGrafen <- function(object, unconstrained = TRUE, ...)
{
    if (!("corGrafen" %in% class(object)))
        stop('object is not of class "corGrafen"')
    if (unconstrained) {
        if (attr(object, "fixed")) {
            return(numeric(0))
        } else {
            return(as.vector(object))
        }
    }
    aux <- exp(as.vector(object))
    names(aux) <- "rho"
    aux
}

## changed by EP (2006-10-12):

compute.brlen <- function(phy, method = "Grafen", power = 1, ...)
{
    if (!inherits(phy, "phylo"))
        stop('object "phy" is not of class "phylo"')
    Ntip <- length(phy$tip.label)
    Nnode <- phy$Nnode
    Nedge <- dim(phy$edge)[1]
    if (is.numeric(method)) {
        phy$edge.length <- rep(method, length.out = Nedge)
        return(phy)
    }
    if (is.function(method)) {
        phy$edge.length <- method(Nedge, ...)
        return(phy)
    }
    if (is.character(method)) { # == "Grafen"
        tr <- reorder(phy, "postorder")
        xx <- .C(node_depth, as.integer(Ntip),
                 as.integer(tr$edge[, 1]), as.integer(tr$edge[, 2]),
                 as.integer(Nedge), double(Ntip + Nnode), 1L)[[5]] - 1
        m <- Ntip - 1
        phy$edge.length <-
          (xx[phy$edge[, 1]]/m)^power - (xx[phy$edge[, 2]]/m)^power
        return(phy)
    }
}

## by EP:

corPagel <- function(value, phy, form = ~1, fixed = FALSE)
{
    if (value < 0 || value > 1)
        stop("the value of lambda must be between 0 and 1.")
    if (!inherits(phy, "phylo"))
        stop('object "phy" is not of class "phylo"')
    attr(value, "formula") <- form
    attr(value, "fixed") <- fixed
    attr(value, "tree") <- phy
    class(value) <- c("corPagel", "corPhyl", "corStruct")
    value
}

corMatrix.corPagel <-
    function(object, covariate = getCovariate(object), corr = TRUE, ...)
{
    if (!("corPagel" %in% class(object)))
        stop('object is not of class "corPagel"')
    if (data.class(covariate) == "list") {
        as.list(lapply(covariate, function(el) corMatrix(object, covariate = el)))
    } else {
        mat <- vcv.phylo(attr(object, "tree"), corr = corr)
        mat <- mat[covariate, covariate]
        tmp <- diag(mat)
        mat <- object[1]*mat
        diag(mat) <- tmp
        mat
    }
}

coef.corPagel <- function(object, unconstrained = TRUE, ...)
{
    if (unconstrained) {
        if (attr(object, "fixed")) return(numeric(0))
        else return(object[1])
    }
    aux <- object[1]
    names(aux) <- "lambda"
    aux
}

corBlomberg <- function(value, phy, form = ~1, fixed = FALSE)
{
    if (value <= 0)
        stop("the value of g must be greater than 0.")
    if (!inherits(phy, "phylo"))
        stop('object "phy" is not of class "phylo"')
    attr(value, "formula") <- form
    attr(value, "fixed") <- fixed
    attr(value, "tree") <- phy
    class(value) <- c("corBlomberg", "corPhyl", "corStruct")
    value
}

corMatrix.corBlomberg <-
    function(object, covariate = getCovariate(object), corr = TRUE, ...)
{
    if (object[1] <= 0)
        stop("the optimization has reached a value <= 0 for parameter 'g':
probably need to set 'fixed = TRUE' in corBlomberg().")
    if (data.class(covariate) == "list") {
        as.list(lapply(covariate, function(el) corMatrix(object, covariate = el)))
    } else {
        phy <- attr(object, "tree")
        d <- (dist.nodes(phy)[length(phy$tip.label) + 1, ])^(1/object[1])
        phy$edge.length <- d[phy$edge[, 2]] - d[phy$edge[, 1]]
        mat <- vcv.phylo(phy, corr = corr)
        mat[covariate, covariate]
    }
}

coef.corBlomberg <- function(object, unconstrained = TRUE, ...)
{
    if (unconstrained) {
        if (attr(object, "fixed")) return(numeric(0))
        else return(object[1])
    }
    aux <- object[1]
    names(aux) <- "g"
    aux
}

## as.phylo.R (2018-02-19)

##     Conversion Among Tree Objects

## Copyright 2005-2018 Emmanuel Paradis

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

old2new.phylo <- function(phy)
{
    mode(phy$edge) <- "numeric"
    phy$Nnode <- -min(phy$edge)
    n <- length(phy$tip.label)
    NODES <- phy$edge < 0
    phy$edge[NODES] <- n - phy$edge[NODES]
    phy
}

new2old.phylo <- function(phy)
{
    NTIP <- length(phy$tip.label)
    NODES <- phy$edge > NTIP
    phy$edge[NODES] <- NTIP - phy$edge[NODES]
    mode(phy$edge) <- "character"
    phy$Nnode <- NULL
    phy
}

as.phylo <- function (x, ...)
{
    if (identical(class(x), "phylo")) return(x)
    UseMethod("as.phylo")
}

as.phylo.hclust <- function(x, ...)
{
    N <- dim(x$merge)[1]
    edge <- matrix(0L, 2*N, 2)
    edge.length <- numeric(2*N)
    ## `node' gives the number of the node for the i-th row of x$merge
    node <- integer(N)
    node[N] <- N + 2L
    cur.nod <- N + 3L
    j <- 1L
    for (i in N:1) {
        edge[j:(j + 1), 1] <- node[i]
        for (l in 1:2) {
            k <- j + l - 1L
            y <- x$merge[i, l]
            if (y > 0) {
                edge[k, 2] <- node[y] <- cur.nod
                cur.nod <- cur.nod + 1L
                edge.length[k] <- x$height[i] - x$height[y]
            } else {
                edge[k, 2] <- -y
                edge.length[k] <- x$height[i]
            }
        }
        j <- j + 2L
    }
    if (is.null(x$labels))
        x$labels <- as.character(1:(N + 1))
    obj <- list(edge = edge, edge.length = edge.length / 2,
                tip.label = x$labels, Nnode = N)
    class(obj) <- "phylo"
    reorder(obj)
}

as.phylo.phylog <- function(x, ...)
{
    tr <- read.tree(text = x$tre)
    n <- length(tr$tip.label)
    edge.length <- numeric(dim(tr$edge)[1])
    term  <- which(tr$edge[, 2] <= n)
    inte  <- which(tr$edge[, 2] > n)
    edge.length[term] <- x$leaves[tr$tip.label]
    edge.length[inte] <- x$nodes[tr$node.label][-1]
    tr$edge.length <- edge.length
    if (x$nodes["Root"] != 0) {
        tr$edge.root <- x$nodes["Root"]
        names(tr$edge.root) <- NULL
    }
    tr
}

as.hclust.phylo <- function(x, ...)
{
    if (!is.ultrametric(x)) stop("the tree is not ultrametric")
    if (!is.binary.phylo(x)) stop("the tree is not binary")
    if (!is.rooted(x)) stop("the tree is not rooted")
    n <- length(x$tip.label)
    if (n == 1) stop("needs n >= 2 observations for a classification")
    if (n == 2) {
        m <- matrix(c(-1L, -2L), 1, 2)
        bt <- x$edge.length[1]
    } else {
        x$node.label <- NULL # by Jinlong Zhang (2010-12-15)
        bt <- branching.times(x)
        N <- n - 1L
        x <- reorder(x, "postorder")
        m <- matrix(x$edge[, 2], N, 2, byrow = TRUE)
        anc <- x$edge[c(TRUE, FALSE), 1]
        bt <- bt[as.character(anc)] # 1st, reorder
        ## 2nd, sort keeping the root branching time in last (in case of
        ## rounding error if there zero-lengthed branches nead the root)
        bt <- c(sort(bt[-N]), bt[N])
        o <- match(names(bt), anc)
        m <- m[o, ]
        ## first renumber the tips:
        TIPS <- m <= n
        m[TIPS] <- -m[TIPS]
        ## then renumber the nodes:
        oldnodes <- as.numeric(names(bt))[-N]
        m[match(oldnodes, m)] <- 1:(N - 1)
        names(bt) <- NULL
    }
    obj <- list(merge = m, height = 2*bt, order = 1:n, labels = x$tip.label,
                call = match.call(), method = "unknown")
    class(obj) <- "hclust"
    obj
}

if (getRversion() >= "2.15.1") utils::globalVariables(c("network", "network.vertex.names<-"))
as.network.phylo <- function(x, directed = is.rooted(x), ...)
{
    if (is.null(x$node.label)) x <- makeNodeLabel(x)
    res <- network(x$edge, directed = directed, ...)
    network.vertex.names(res) <- c(x$tip.label, x$node.label)
    res
}

as.igraph.phylo <- function(x, directed = is.rooted(x), use.labels = TRUE, ...)
{
    ## local copy because x will be changed before evaluating is.rooted(x):
    directed <- directed
    if (use.labels) {
        if (is.null(x$node.label)) x <- makeNodeLabel(x)
        ## check added by Klaus:
        if (anyDuplicated(c(x$tip.label, x$node.label)))
            stop("Duplicated labels!")
        x$edge <- matrix(c(x$tip.label, x$node.label)[x$edge], ncol = 2)
    }
    igraph::graph_from_edgelist(x$edge, directed = directed)
}

## read.GenBank.R (2020-05-15)

##   Read DNA Sequences and Annotations from GenBank

## Copyright 2002-2020 Emmanuel Paradis

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

read.GenBank <- function(access.nb, seq.names = access.nb, species.names = TRUE,
                         as.character = FALSE, chunk.size = 400, quiet = TRUE)
{
    chunk.size <- as.integer(chunk.size)
    N <- length(access.nb)
    ## if more than 400 sequences, we break down the requests
    a <- 1L
    b <- if (N > chunk.size) chunk.size else N
    fl <- paste0(tempfile(), ".fas")
    if (!quiet)
        cat("Note: chunk.size =", chunk.size, "(max nb of sequences downloaded together)\n")
    repeat {
        if (!quiet) cat("\rDownloading sequences:", b, "/", N, "...")
        URL <- paste0("https://eutils.ncbi.nlm.nih.gov/entrez/eutils/efetch.fcgi?db=nucleotide&id=",
                      paste(access.nb[a:b], collapse = ","), "&rettype=fasta&retmode=text")
        X <- scan(file = URL, what = "", sep = "\n", quiet = TRUE)
        cat(X, sep = "\n", file = fl, append = TRUE)
        if (b == N) break
        a <- b + 1L
        b <- b + chunk.size
        if (b > N) b <- N
    }
    if (!quiet) {
        cat(" Done.\nNote: the downloaded sequences are in file:", fl)
        cat("\nReading sequences...")
    }
    res <- read.FASTA(fl)
    if (is.null(res)) return(NULL)
    attr(res, "description") <- names(res)
    if (length(access.nb) != length(res)) {
        names(res) <- gsub("\\..*$", "", names(res))
        failed <- paste(access.nb[! access.nb %in% names(res)], collapse = ", ")
        warning(paste0("cannot get the following sequence(s):\n", failed))
    } else names(res) <- access.nb

    if (as.character) res <- as.character(res)
    if (!quiet) cat("\n")
    if (species.names) {
        a <- 1L
        b <- if (N > chunk.size) chunk.size else N
        sp <- character(0)
        repeat {
            if (!quiet) cat("\rDownloading species names:", b, "/", N)
            URL <- paste("https://eutils.ncbi.nlm.nih.gov/entrez/eutils/efetch.fcgi?db=nucleotide&id=",
                     paste(access.nb[a:b], collapse = ","), "&rettype=gb&retmode=text", sep = "")
            X <- scan(file = URL, what = "", sep = "\n", quiet = TRUE, n = -1)
            sp <- c(sp, gsub(" +ORGANISM +", "", grep("ORGANISM", X, value = TRUE)))
            if (b == N) break
            a <- b + 1L
            b <- b + chunk.size
            if (b > N) b <- N
        }
        if (!quiet) cat(".\n")
        attr(res, "species") <- gsub(" ", "_", sp)
    }
    if (!quiet) cat("Done.\n")
    res
}

.parse.annotations.file <- function(file) {
    get.product.others.gene <- function(a, b) {
        res <- rep(NA_character_, 3L)
        if (a > b) return(res)
        y <- x[a:b]
        li <- length(i <- grep("product\t", y))
        lj <- length(j <- grep("gene\t", y))
        if (li) res[1L] <- gsub("product\t", "", y[i])
        if (lj) res[2L] <- gsub("gene\t", "", y[j])
        if (length(y) > li + lj) res[3L] <- paste(y[-c(i, j)], collapse = "; ")
        res
    }
    convert.with.incomplete <- function(vec) {
        i <- grep("<|>", vec)
        if (length(i)) {
            incomplete <<- c(incomplete, i)
            vec[i] <- gsub("<|>", "", vec[i])
        }
        as.integer(vec)
    }
    x <- scan(file, what = "", sep = "\n", quiet = TRUE, skip = 1)
    n <- length(x)
    i <- grep("^\t\t\t", x)
    i2 <- seq_len(n)[-i]
    Y <- strsplit(x[i2], "\t")

    incomplete <- NULL
    start <- convert.with.incomplete(sapply(Y, "[", 1L))
    end <- convert.with.incomplete(sapply(Y, "[", 2L))
    if (!is.null(incomplete)) {
        incomplete <- sort(unique(incomplete))
        warning(paste("features were incomplete in row(s):",
                      paste(incomplete, collapse = ", ")))
    }

    res <- data.frame(start, end)
    sel <- which(!duplicated.data.frame(res))
    res <- res[sel, ]
    res$type <- sapply(Y, "[", 3L)[sel]

    i3 <- i2[sel]
    from <- i3 + 1L
    to <- c(i3[-1L] - 1L, n)

    x[i] <- gsub("^\t\t\t", "", x[i])
    Z <- mapply(get.product.others.gene, from, to)
    res$product <- Z[1L, ]
    gene <- Z[2L, ]
    res$others <- gsub("\t", ": ", Z[3L, ])
    if (!all(is.na(gene))) res$gene <- gene
    row.names(res) <- as.character(seq_len(nrow(res)))
    res
}

getAnnotationsGenBank <- function(access.nb, quiet = TRUE)
{
    N <- length(access.nb)
    res <- setNames(vector("list", N), access.nb)
    notfound <- NULL
    s1 <- "https://eutils.ncbi.nlm.nih.gov/entrez/eutils/efetch.fcgi?db=nucleotide&id="
    s3 <- "&rettype=ft&retmode=text"
    for (i in 1:N) {
        if (!quiet) cat("\rDownloading annotations:", i, "/", N)
        URL <- paste0(s1, access.nb[i], s3)
        fl <- tempfile()
        ans <- try(download.file(URL, fl, quiet = TRUE), silent = TRUE)
        if (class(ans) == "try-error") {
            notfound <- c(notfound, access.nb[i])
            next
        }
        res[[i]] <- .parse.annotations.file(fl)
    }
    if (!quiet) cat(". Done.\n")
    if (!is.null(notfound)) {
        warning(paste0("cannot get features for the following accession(s):\n",
                       paste(notfound, collapse = ", ")))
        if (length(notfound) == N) return(NULL)
    }
    if (N == 1) res[[1L]] else res
}

## SDM.R (2012-04-02)

## Construction of Consensus Distance Matrix With SDM

## Copyright 2011-2012 Andrei-Alin Popescu

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

SDM <- function(...)
{
    st <- list(...) # first half contains matrices, second half s_p
    k <- length(st)/2
    ONEtoK <- seq_len(k)

    ## make sure we have only matrices:
    for (i in ONEtoK) st[[i]] <- as.matrix(st[[i]])

    ## store the rownames of each matrix in a list because they are often called:
    ROWNAMES <- lapply(st[ONEtoK], rownames)

    ## the number of rows of each matrix:
    NROWS <- lengths(ROWNAMES)
    tot <- sum(NROWS)

    labels <- unique(unlist(ROWNAMES))
    sp <- unlist(st[k + ONEtoK])

    astart <- numeric(tot) # start of aip, astart[p] is start of aip
    astart[1] <- k
    for (i in 2:k)
        astart[i] <- astart[i - 1] + NROWS[i - 1]

    ## apparently erased by the operation below so no need to initialize:
    ## a <- mat.or.vec(1, k + tot + k + length(labels))

    ## first k are alphas, subsequent ones aip
    ## each matrix p starting at astart[p], next are
    ## Lagrange multipliers, miu, niu, lambda in that order
    n <- length(labels)
    miustart <- k + tot
    niustart <- miustart + n
    lambstart <- niustart + k - 1

    X <- matrix(0, n, n, dimnames = list(labels, labels))
    V <- w <- X

    tmp <- 2 * k + tot + n
    col <- numeric(tmp) # free terms of system

    for (i in 1:(n - 1)) {
        for (j in (i + 1):n) {
            for (p in ONEtoK) {
                ## d <- st[[p]] # not needed anymore
                if (is.element(labels[i], ROWNAMES[[p]]) && is.element(labels[j], ROWNAMES[[p]])) {
                    w[i, j] <- w[j, i] <- w[i, j] + sp[p]
                }
            }
        }
    }

    ONEtoN <- seq_len(n)

    Q <- matrix(0, tmp, tmp)
    ## first decompose first sum in paper
    for (p in ONEtoK) {
        d_p <- st[[p]]
        for (l in ONEtoK) { # first compute coefficients of alphas
            d <- st[[l]]
            sum <- 0
            dijp <- -1
            if (l == p) { # calculate alpha_p
                for (i in ONEtoN) {
                    for (j in ONEtoN) { # check if {i,j}\subset L_l
                        if (i == j) next # make sure i != j
                        ## d <- st[[l]] # <- moved-up
                        pos <- match(labels[c(i, j)], ROWNAMES[[l]]) # <- returns NA if not in this matrix
                        if (all(!is.na(pos))) {
                            ipos <- pos[1L]
                            jpos <- pos[2L]
                            dij <- d[ipos, jpos]
                            sum <- sum + dij * dij - sp[l] * dij * dij / w[i,j]
                            tmp2 <- dij - sp[l] * dij / w[i,j]
                            Q[p, astart[l] + ipos] <- Q[p, astart[l] + ipos] + tmp2
                            Q[p, astart[l] + jpos] <- Q[p, astart[l] + jpos] + tmp2
                        }
                    }
                }
            } else {
                for (i in ONEtoN) {
                    for (j in ONEtoN) { # check if {i,j}\subset L_l
                        if (i == j) next
                        ## d <- st[[l]] # <- moved-up
                        pos <- match(labels[c(i, j)], ROWNAMES[[l]])
                        posp <- match(labels[c(i, j)], ROWNAMES[[p]])
                        if (all(!is.na(pos)) && all(!is.na(posp))) {
                            ipos <- pos[1L]
                            jpos <- pos[2L]
                            dij <- d[ipos, jpos]
                            dijp <- d_p[posp[1L], posp[2L]]
                            sum <- sum - sp[l] * dij * dijp / w[i, j]
                            tmp2 <- sp[l] * dijp / w[i, j]
                            Q[p,astart[l] + ipos] <- Q[p, astart[l] + ipos] - tmp2
                            Q[p,astart[l] + jpos] <- Q[p, astart[l] + jpos] - tmp2
                        }
                    }
                }
            }
            Q[p, l] <- sum
        }
        Q[p, lambstart + 1] <- 1
    }

    r <- k

    for (p in ONEtoK) {
        dp <- st[[p]]
        for (i in ONEtoN) {
            if (is.element(labels[i], ROWNAMES[[p]])) {
                r <- r + 1
                for (l in ONEtoK) {
                    d <- st[[l]]
                    if (l == p) {
                        ipos <- match(labels[i], ROWNAMES[[p]])
                        for (j in ONEtoN) {
                            if (i == j) next
                            jpos <- match(labels[j], ROWNAMES[[p]])
                            if (!is.na(jpos)) {
                                dij <- d[ipos, jpos]
                                Q[r, l] <- Q[r, l] + dij - sp[l] * dij / w[i, j]
                                tmp2 <- 1 - sp[l] / w[i, j]
                                Q[r, astart[l] + ipos] <- Q[r, astart[l] + ipos] + tmp2
                                Q[r, astart[l] + jpos] <- Q[r, astart[l] + jpos] + tmp2
                            }
                        }
                    } else {
                        for (j in ONEtoN) {
                            if (i == j) next
                            if (!is.element(labels[j], rownames(dp))) next
                            pos <- match(labels[c(i, j)], ROWNAMES[[l]])
                            if (all(!is.na(pos))) {
                                ipos <- pos[1L]
                                jpos <- pos[2L]
                                dij <- d[ipos, jpos]
                                Q[r, l] <- Q[r, l] - sp[l] * dij / w[i, j]
                                tmp2 <- sp[l]/w[i, j]
                                Q[r, astart[l] + ipos] <- Q[r, astart[l] + ipos] - tmp2
                                Q[r, astart[l] + jpos] <- Q[r, astart[l] + jpos] - tmp2
                            }
                        }
                    }
                }
                if (p < k) Q[r, ] <- Q[r, ] * sp[p]
                Q[r, miustart + i] <- 1
                if (p < k) Q[r, niustart + p] <- 1
            }
        }
    }

    r <- r + 1
    col[r] <- k
    Q[r, ONEtoK] <- 1
    ## for (i in 1:k) Q[r, i] <- 1

    for (i in ONEtoN) {
        r <- r + 1
        for (p in ONEtoK) {
            ## d <- st[[p]] # not needed
            ipos <- match(labels[i], ROWNAMES[[p]])
            if (!is.na(ipos)) Q[r, astart[p] + ipos] <- 1
        }
    }

    for (p in 1:(k - 1)) {
        r <- r + 1
        for (i in ONEtoN) {
            ## d <- st[[p]]
            ipos <- match(labels[i], ROWNAMES[[p]])
            if (!is.na(ipos)) Q[r, astart[p] + ipos] <- 1
        }
    }
    a <- solve(Q, col, 1e-19)
    for (i in ONEtoN) {
        for (j in ONEtoN) {
            if (i == j) {
                X[i, j] <- V[i, j] <- 0
                next
            }
            sum <- 0
            sumv <- 0
            for (p in ONEtoK) {
                d <- st[[p]]
                pos <- match(labels[c(i, j)], ROWNAMES[[p]])
                if (all(!is.na(pos))) {
                    ipos <- pos[1L]
                    jpos <- pos[2L]
                    dij <- d[ipos, jpos]
                    sum <- sum + sp[p] * (a[p] * dij + a[astart[p] + ipos] + a[astart[p] + jpos])
                    sumv <- sumv + sp[p] * (a[p] * dij)^2
                }
            }
            X[i, j] <- sum / w[i, j]
            V[i, j] <- sumv / (w[i, j])^2
        }
    }
    list(X, V)
}

## ladderize.R (2007-10-08)

##   Matrix Exponential

## Copyright 2007 Emmanuel Paradis

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

matexpo <- function(x)
{
    if (!is.matrix(x)) stop('"x" must be a matrix')
    nr <- dim(x)[1]
    if (nr != dim(x)[2]) stop('"x" must be a square matrix')
    ans <- .C(mat_expo, as.double(x), as.integer(nr))[[1]]
    dim(ans) <- c(nr, nr)
    ans
}

## unique.multiPhylo.R (2014-01-15)

##   Revomes Duplicate Trees from a List

## Copyright 2007-2014 Emmanuel Paradis

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

unique.multiPhylo <-
    function(x, incomparables = FALSE,
             use.edge.length = FALSE,
             use.tip.label = TRUE, ...)
{
    n <- length(x)
    keep <- 1L
    old.index <- seq_len(n)
    for (i in 2:n) {
        already.seen <- FALSE
        for (j in keep) {
            if (all.equal(x[[j]], x[[i]],
                          use.edge.length = use.edge.length,
                          use.tip.label = use.tip.label)) {
                already.seen <- TRUE
                old.index[i] <- j
                break
            }
        }
        if (!already.seen) keep <- c(keep, i)
    }
    res <- x[keep]
    attr(res, "old.index") <- old.index
    res
}

## compar.ou.R (2010-11-04)

##   Ornstein--Uhlenbeck Model for Continuous Characters

## Copyright 2005-2010 Emmanuel Paradis

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

compar.ou <- function(x, phy, node = NULL, alpha = NULL)
{
    if (!inherits(phy, "phylo"))
        stop('object "phy" is not of class "phylo".')
    if (!is.numeric(x)) stop("'x' must be numeric.")
    if (!is.null(names(x))) {
        if (all(names(x) %in% phy$tip.label)) x <- x[phy$tip.label]
        else warning('the names of argument "x" and the tip labels of the tree did not match: the former were ignored in the analysis.')
    }
    n <- length(phy$tip.label)
    root <- n + 1L
    if (is.null(node)) node <- numeric(0)
    if (is.character(node)) {
        if (is.null(phy$node.label))
            stop("argument 'node' is character but 'phy' has no node labels")
        node <- match(node, phy$node.label) + n
        phy$node.label <- NULL
    }
    if (root %in% node) node <- node[-1]
    bt <- branching.times(phy)
    Tmax <- bt[1]
    Wend <- matrix(0, n, length(node) + 1)
    colnames(Wend) <- c(names(sort(bt[node - n])), as.character(root))
    Wstart <- Wend
    Wstart[, ncol(Wstart)] <- Tmax
    root2tip <- .Call(seq_root2tip, phy$edge, n, phy$Nnode)
    for (i in 1:n) {
        last.change <- names(Tmax)
        for (j in root2tip[[i]]) {
            if (j %in% node) {
                jb <- as.character(j)
                Wend[i, last.change] <- Wstart[i, jb] <- bt[jb]
                last.change <- jb
            }
        }
    }
    W <- cophenetic.phylo(phy)
    dev <- function(p) {
        alpha <- p[1]
        sigma2 <- p[2]
        if (sigma2 <= 0) return(1e100)
        theta <- p[-(1:2)]
        ## fixed a bug below: must be '%*% theta' instead of '* theta' (2010-03-15)
        M <- rowSums((exp(-alpha * Wend) - exp(-alpha * Wstart)) %*% theta)
        V <- exp(-alpha * W) * (1 - exp(-2 * alpha * (Tmax - W/2)))
        R <- chol(V) # correction by Cecile Ane (2010-11-04)
        n * log(2 * pi * sigma2) + 2 * sum(log(diag(R))) +
            (t(x - M) %*% chol2inv(R) %*% (x - M)) / sigma2
    }

    out <- if (is.null(alpha))
        nlm(function(p) dev(p),
            p = c(0.1, 1, rep(mean(x), ncol(Wstart))), hessian = TRUE)
    else nlm(function(p) dev(c(alpha, p)),
             p = c(1, rep(mean(x), ncol(Wstart))), hessian = TRUE)

    ## if alpha is estimated it may be that the Hessian matrix has the
    ## corresponding column and row filled with 0, making solve() fail
    se <- if (is.null(alpha) && all(out$hessian[1, ] == 0))
        c(NA, sqrt(diag(solve(out$hessian[-1, -1]))))
    else sqrt(diag(solve(out$hessian)))

    para <- cbind(out$estimate, se)
    nms <- c("sigma2", paste("theta", 1:ncol(Wstart), sep = ""))
    if (is.null(alpha)) nms <- c("alpha", nms)
    dimnames(para) <- list(nms, c("estimate", "stderr"))
    obj <- list(deviance = out$minimum, para = para, call = match.call())
    class(obj) <- "compar.ou"
    obj
}

## cophyloplot.R (2014-04-07)

##   Plots two phylogenetic trees face to
##   face with the links between the tips

## Copyright 2008-2010 Damien de Vienne

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

cophyloplot <-
    function(x, y, assoc = NULL, use.edge.length = FALSE, space = 0,
             length.line = 1, gap = 2, type = "phylogram", rotate = FALSE,
             col = par("fg"), lwd = par("lwd"), lty = par("lty"),
             show.tip.label = TRUE, font = 3, ...)
{
    if (is.null(assoc)) {
        assoc <- matrix(ncol = 2)
        print("No association matrix specified. Links will be omitted.")
    }
    if (rotate == TRUE) {
        cat("\n    Click on a node to rotate (right click to exit)\n\n")
        repeat {
            res <- plotCophylo2(x, y, assoc = assoc, use.edge.length = use.edge.length,
                space = space, length.line = length.line, gap = gap,
                type = type, return = TRUE, col = col, lwd=lwd, lty=lty, show.tip.label = show.tip.label,
                font = font)
            click <- identify(res$c[, 1], res$c[, 2], n = 1)
            if (click < length(res$a[, 1]) + 1) {
                if (click > res$N.tip.x)
                  x <- rotate(x, click)
            } else if (click < length(res$c[, 1]) + 1) {
                if (click > length(res$a[, 1]) + res$N.tip.y)
                  y <- rotate(y, click - length(res$a[, 1]))
            }
        }
        on.exit(cat("done\n"))
    }
    else plotCophylo2(x, y, assoc = assoc, use.edge.length = use.edge.length,
        space = space, length.line = length.line, gap = gap,
        type = type, return = FALSE, col = col, lwd=lwd, lty=lty, show.tip.label = show.tip.label, font = font)
}

plotCophylo2 <-
    function(x, y, assoc = assoc, use.edge.length = use.edge.length,
             space = space, length.line = length.line, gap = gap,
             type = type, return = return, col = col, lwd=lwd, lty=lty,
             show.tip.label = show.tip.label,
             font = font, ...)
{
    res <- list()
###choice of the minimum space between the trees
    left <- max(nchar(x$tip.label, type = "width")) + length.line
    right <- max(nchar(y$tip.label, type = "width")) + length.line
    space.min <- left + right + gap * 2
    if ((space <= 0) || (space < space.min)) space <- space.min
    N.tip.x <- Ntip(x)
    N.tip.y <- Ntip(y)
    res$N.tip.x <- N.tip.x
    res$N.tip.y <- N.tip.y
    a <- plotPhyloCoor(x, use.edge.length = use.edge.length, type = type)
    res$a <- a
    b <- plotPhyloCoor(y, use.edge.length = use.edge.length,
                       direction = "leftwards", type = type)
###for the two trees to have the extreme leaves at the same ordinate.
    a[, 2] <- a[, 2] - min(a[, 2])
    b[, 2] <- b[, 2] - min(b[, 2])
    res$b <- b
    b2 <- b
    b2[, 1] <- b[1:nrow(b), 1] * (max(a[, 1])/max(b[, 1])) +
        space + max(a[, 1])
    b2[, 2] <- b[1:nrow(b), 2] * (max(a[, 2])/max(b[, 2]))
    res$b2 <- b2
    c <- matrix(ncol = 2, nrow = nrow(a) + nrow(b))
    c[1:nrow(a), ] <- a[1:nrow(a), ]
    c[nrow(a) + 1:nrow(b), 1] <- b2[, 1]
    c[nrow(a) + 1:nrow(b), 2] <- b2[, 2]
    res$c <- c
    plot(c, type = "n", xlim = NULL, ylim = NULL, log = "", main = NULL,
        sub = NULL, xlab = NULL, ylab = NULL, ann = FALSE, axes = FALSE,
        frame.plot = FALSE)
 ###segments for cladograms
   if (type == "cladogram") {
        for (i in 1:(nrow(a) - 1)) segments(a[x$edge[i, 1], 1],
            a[x$edge[i, 1], 2], a[x$edge[i, 2], 1], a[x$edge[i,
                2], 2], col="red")
        for (i in 1:(nrow(b) - 1))
            segments(b2[y$edge[i, 1], 1], b2[y$edge[i, 1], 2],
                     b2[y$edge[i, 2], 1], b2[y$edge[i, 2], 2])
    }
###segments for phylograms
    if (type == "phylogram") {
        for (i in (N.tip.x + 1):nrow(a)) {
            l <- length(x$edge[x$edge[, 1] == i, ][, 1])
            for (j in 1:l) {
                segments(a[x$edge[x$edge[, 1] == i, ][1, 1],
                  1], a[x$edge[x$edge[, 1] == i, 2], 2][1], a[x$edge[x$edge[,
                  1] == i, ][1, 1], 1], a[x$edge[x$edge[, 1] ==
                  i, 2], 2][j])
                segments(a[x$edge[x$edge[, 1] == i, ][1, 1],
                  1], a[x$edge[x$edge[, 1] == i, 2], 2][j], a[x$edge[x$edge[,
                  1] == i, 2], 1][j], a[x$edge[x$edge[, 1] ==
                  i, 2], 2][j])
            }
        }
        for (i in (N.tip.y + 1):nrow(b)) {
            l <- length(y$edge[y$edge[, 1] == i, ][, 1])
            for (j in 1:l) {
                segments(b2[y$edge[y$edge[, 1] == i, ][1, 1],
                  1], b2[y$edge[y$edge[, 1] == i, 2], 2][1],
                  b2[y$edge[y$edge[, 1] == i, ][1, 1], 1], b2[y$edge[y$edge[,
                    1] == i, 2], 2][j])
                segments(b2[y$edge[y$edge[, 1] == i, ][1, 1],
                  1], b2[y$edge[y$edge[, 1] == i, 2], 2][j],
                  b2[y$edge[y$edge[, 1] == i, 2], 1][j], b2[y$edge[y$edge[,
                    1] == i, 2], 2][j])
            }
        }
    }
    if (show.tip.label) {
        text(a[1:N.tip.x, ], cex = 0, font = font, pos = 4,
             labels = x$tip.label)
        text(b2[1:N.tip.y, ], cex = 1, font = font, pos = 2,
             labels = y$tip.label)
    }
###links between associated taxa. Takes into account the size of the character strings of the taxa names.
    lsa <- 1:N.tip.x
    lsb <- 1:N.tip.y
    decx <- array(nrow(assoc))
    decy <- array(nrow(assoc))

    #colors
    if (length(col)==1) colors<-c(rep(col, nrow(assoc)))
    else if (length(col)>=nrow(assoc)) colors<-col
    else  colors<-c(rep(col, as.integer(nrow(assoc)/length(col))+1))

    #lwd
    if (length(lwd)==1) lwidths<-c(rep(lwd, nrow(assoc)))
    else if (length(lwd)>=nrow(assoc)) lwidths<-lwd
    else  lwidths<-c(rep(lwd, as.integer(nrow(assoc)/length(lwd))+1))

    #lty
    if (length(lty) == 1) ltype <- c(rep(lty, nrow(assoc)))
    else if (length(lty) >= nrow(assoc)) ltype <- lty
    else  ltype <- c(rep(lty, as.integer(nrow(assoc)/length(lty))+1))

    for (i in 1:nrow(assoc)) {
        if (show.tip.label) {
            decx[i] <- strwidth(x$tip.label[lsa[x$tip.label == assoc[i, 1]]])
            decy[i] <- strwidth(y$tip.label[lsb[y$tip.label == assoc[i, 2]]])
        } else {
            decx[i] <- decy[i] <- 0
        }

        if (length.line) { # added by EP (2014-04-07)
            segments(a[lsa[x$tip.label == assoc[i, 1]], 1] + decx[i] + gap,
                     a[lsa[x$tip.label == assoc[i, 1]], 2],
                     a[lsa[x$tip.label == assoc[i, 1]], 1] + gap + left,
                     a[lsa[x$tip.label ==  assoc[i, 1]], 2],
                     col = colors[i], lwd = lwidths[i], lty = ltype[i])

            segments(b2[lsb[y$tip.label == assoc[i, 2]], 1] - (decy[i] + gap),
                     b2[lsb[y$tip.label == assoc[i, 2]], 2],
                     b2[lsb[y$tip.label == assoc[i, 2]], 1] - (gap + right),
                     b2[lsb[y$tip.label ==  assoc[i, 2]], 2],
                     col = colors[i], lwd = lwidths[i], lty = ltype[i])
        }

        segments(a[lsa[x$tip.label == assoc[i, 1]], 1] + gap + left,
                 a[lsa[x$tip.label == assoc[i, 1]], 2],
                 b2[lsb[y$tip.label == assoc[i, 2]], 1] - (gap + right),
                 b2[lsb[y$tip.label == assoc[i, 2]], 2],
                 col = colors[i], lwd = lwidths[i], lty = ltype[i])
    }
    if (return == TRUE)  return(res)
}

## makeNodeLabel.R (2009-03-22)

##   Makes Node Labels

## Copyright 2009 Emmanuel Paradis

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

makeNodeLabel <- function(phy, method = "number", prefix = "Node",
                          nodeList = list(), ...)
{
    method <- sapply(method, match.arg, c("number", "md5sum", "user"),
                     USE.NAMES = FALSE)

    if ("number" %in% method)
        phy$node.label <- paste(prefix, 1:phy$Nnode, sep = "")

    if ("md5sum" %in% method) {
        nl <- character(phy$Nnode)
        pp <- prop.part(phy, check.labels = FALSE)
        labs <- attr(pp, "labels")
        fl <- tempfile()
        for (i in seq_len(phy$Nnode)) {
            cat(sort(labs[pp[[i]]]), sep = "\n", file = fl)
            nl[i] <- tools::md5sum(fl)
        }
        unlink(fl)
        phy$node.label <- nl
    }

    if ("user" %in% method) {
        if (is.null(phy$node.label))
            phy$node.label <- character(phy$Nnode)
        nl <- names(nodeList)
        if (is.null(nl)) stop("argument 'nodeList' has no names")
        Ntip <- length(phy$tip.label)
        seq.nod <- .Call(seq_root2tip, phy$edge, Ntip, phy$Nnode)
        ## a local version to avoid the above call many times:
        .getMRCA <- function(seq.nod, tip) {
            sn <- seq.nod[tip]
            MRCA <- Ntip + 1
            i <- 2
            repeat {
                x <- unique(unlist(lapply(sn, "[", i)))
                if (length(x) != 1) break
                MRCA <- x
                i <- i + 1
            }
            MRCA
        }
        for (i in seq_along(nodeList)) {
            tips <- sapply(nodeList[[i]], grep, phy$tip.label, ...,
                           USE.NAMES = FALSE)
            j <- .getMRCA(seq.nod, unique(unlist(tips)))
            phy$node.label[j - Ntip] <- nl[i]
        }
    }
    phy
}

## skyline.R (2002-09-12)

##   Methods to construct skyline objects (data underlying skyline plot)

## Copyright 2002 Korbinian Strimmer

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

skyline <- function(x, ...) UseMethod("skyline")

# input: phylogenetic tree
skyline.phylo <- function(x, ...)
{
  if (class(x) != "phylo")
    stop("object \"x\" is not of class \"phylo\"")

  skyline(coalescent.intervals(x), ...)
}

# input: coalescent intervals and epsilon
skyline.coalescentIntervals <- function(x, epsilon=0, ...)
{
  if (class(x) != "coalescentIntervals")
    stop("object \"x\" is not of class \"coalescentIntervals\"")

  if (epsilon < 0)
  {
    eps <- find.skyline.epsilon(x, ...)
  }
  else
    eps <- epsilon

  skyline(collapsed.intervals(x, epsilon=eps), ...)
}


# input: collapsed intervals
skyline.collapsedIntervals <- function(x, old.style=FALSE, ...)
{
  if (class(x) != "collapsedIntervals")
    stop("object \"x\" is not of class \"collapsedIntervals\"")

  link <- x$collapsed.interval
  params <- x$collapsed.interval.count
  l <- x$lineages
  w <- x$interval.length

  b <- choose(l,2) # binomial coefficients

  sg <- rep(0,params)   # sizes of collapsed intervals
  cg <- rep(0,params)   # coalescent events in interval

  if(old.style)
    ng <- rep(0,params) # lineages at beginning of an in interval
  else
  {
    ng <- rep(0,params) # sum of classic skp estimates in an interval
    m.classic <- w*b
  }

  for (i in 1:params)
  {
    group <- link==i
    sgr <- w[group]
    sg[[i]] <- sum(sgr)
    cg[[i]] <- length(sgr)

    if(old.style)
      ng[[i]] <- l[group][[1]]
    else
      ng[[i]] <- sum(m.classic[group])
  }

  # generalized skp estimate
  t <- cumsum(sg)
  if (old.style)
    m <- sg*(ng*(ng-cg)/(2.0*cg) )
  else
    m <- ng/cg

  # log-likelihood
  logL <- sum(log(b/m[link]) - b/m[link]*w)

  # AICc corrected log-likelihood
  K <- x$collapsed.interval.count
  S <- x$interval.count
  if (S-K > 1)
    logL.AICc <- logL - K- K*(K+1)/(S-K-1)
  else
    logL.AICc <- NA

  obj <- list(
    time=t,
    interval.length=sg,
    population.size=m,
    parameter.count=length(t),
    epsilon = x$epsilon,
    logL = logL,
    logL.AICc = logL.AICc
  )
  class(obj) <- "skyline"
  return(obj)
}

# grid search for finding optimal epsilon parameter
find.skyline.epsilon <- function(ci, GRID=1000, MINEPS=1e-6, ...)
{
  # Why MINEPS?
  # Because most "clock-like" trees are not properly
  # clock-like for a variety of reasons, i.e. the heights
  # of the tips are not exactly zero.

  cat("Searching for the optimal epsilon... ")

  # a grid search is a naive way but still effective of doing this ...

  size <- ci$interval.count
  besteps <- ci$total.depth
  eps <- besteps

  cli <- collapsed.intervals(ci,eps)
  skpk <- skyline(cli, ...)
  bestaicc <- skpk$ logL.AICc
  params <- skpk$parameter.count

  delta <- besteps/GRID

  eps <- eps-delta
  while(eps > MINEPS)
  {
    cli <- collapsed.intervals(ci,eps)
    skpk <- skyline(cli, ...)
    aicc <- skpk$ logL.AICc
    params <- skpk$parameter.count

    if (aicc > bestaicc && params < size-1)
    {
      besteps <- eps
      bestaicc <- aicc
    }
    eps <- eps-delta
  }

   cat("epsilon =", besteps, "\n")

  besteps
}

## ladderize.R (2017-04-25)

##   Ladderize a Tree

## Copyright 2007-2017 Emmanuel Paradis

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

ladderize <- function(phy, right = TRUE)
{
    foo <- function(node, END, where) {
        start <- which(phy$edge[, 1] == node)
        end <- c(start[-1] - 1, END)
        size <- end - start + 1
        desc <- phy$edge[start, 2]
        Nclade <- length(desc)
        n <- N[desc]
        o <- order(n, decreasing = right)
        newpos <- c(0, cumsum(size[o][-Nclade])) + where
        desc <- desc[o]
        end <- end[o]
        start <- start[o]
        neworder[newpos] <<- start
        for (i in 1:Nclade)
            if (desc[i] > nb.tip) foo(desc[i], end[i], newpos[i] + 1)
    }
    phy <- reorder(phy) # fix by Klaus (2015-10-04)
    nb.tip <- length(phy$tip.label)
    nb.node <- phy$Nnode
    nb.edge <- dim(phy$edge)[1]
    tmp <- reorder(phy, "postorder")
    N <- .C(node_depth, as.integer(nb.tip),
            as.integer(tmp$edge[, 1]), as.integer(tmp$edge[, 2]),
            as.integer(nb.edge), double(nb.tip + nb.node), 1L)[[5]]
    neworder <- integer(nb.edge)
    foo(nb.tip + 1, nb.edge, 1)
    phy$edge <- phy$edge[neworder, ]
    if (!is.null(phy$edge.length))
        phy$edge.length <- phy$edge.length[neworder]
    phy
}

## write.nexus.R (2017-09-08)

##   Write Tree File in Nexus Format

## Copyright 2003-2017 Emmanuel Paradis

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

write.nexus <- function(..., file = "", translate = TRUE)
{
    obj <- .getTreesFromDotdotdot(...)
    ntree <- length(obj)
    cat("#NEXUS\n", file = file)
    cat(paste("[R-package APE, ", date(), "]\n\n", sep = ""),
        file = file, append = TRUE)

    N <- length(obj[[1]]$tip.label)

    cat("BEGIN TAXA;\n", file = file, append = TRUE)
    cat(paste("\tDIMENSIONS NTAX = ", N, ";\n", sep = ""),
        file = file, append = TRUE)
    cat("\tTAXLABELS\n", file = file, append = TRUE)
    cat(paste("\t\t", obj[[1]]$tip.label, sep = ""),
        sep = "\n", file = file, append = TRUE)
    cat("\t;\n", file = file, append = TRUE)
    cat("END;\n", file = file, append = TRUE)

    cat("BEGIN TREES;\n", file = file, append = TRUE)
    if (translate) {
        cat("\tTRANSLATE\n", file = file, append = TRUE)
        obj <- .compressTipLabel(obj)
        X <- paste("\t\t", 1:N, "\t", attr(obj, "TipLabel"), ",", sep = "")
        ## We remove the last comma:
        X[length(X)] <- gsub(",", "", X[length(X)])
        cat(X, file = file, append = TRUE, sep = "\n")
        cat("\t;\n", file = file, append = TRUE)
        class(obj) <- NULL
        for (i in 1:ntree)
            obj[[i]]$tip.label <- as.character(1:N)
    } else {
        if (is.null(attr(obj, "TipLabel"))) {
            for (i in 1:ntree)
                obj[[i]]$tip.label <- checkLabel(obj[[i]]$tip.label)
        } else {
            attr(obj, "TipLabel") <- checkLabel(attr(obj, "TipLabel"))
            obj <- .uncompressTipLabel(obj)
        }
    }

    title <- names(obj)
    if (is.null(title))
        title <- rep("UNTITLED", ntree)
    else {
        if (any(s <- title == "")) title[s] <- "UNTITLED"
    }

    for (i in 1:ntree) {
        if (class(obj[[i]]) != "phylo") next
        root.tag <- if (is.rooted(obj[[i]])) "= [&R] " else "= [&U] "
        cat("\tTREE *", title[i], root.tag, file = file, append = TRUE)
        cat(write.tree(obj[[i]], file = ""),
            "\n", sep = "", file = file, append = TRUE)
    }
    cat("END;\n", file = file, append = TRUE)
}

## zzz.R (2009-01-12)

##   Library Loading

## Copyright 2003-2009 Emmanuel Paradis

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

.PlotPhyloEnv <- new.env()

## as.matching.R (2011-02-26)

##    Conversion Between Phylo and Matching Objects

## Copyright 2005-2011 Emmanuel Paradis

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

as.matching <- function(x, ...) UseMethod("as.matching")

as.matching.phylo <- function(x, labels = TRUE, ...)
{
    nb.tip <- length(x$tip.label)
    nb.node <- x$Nnode
    if (nb.tip != nb.node + 1)
        stop("the tree must be dichotomous AND rooted.")
    x <- reorder(x, "pruningwise") # cannot use "postorder" here!
    mat <- matrix(x$edge[, 2], ncol = 2, byrow = TRUE)
    nodes <- x$edge[seq(by = 2, length.out = nb.node), 1]
    ## we can use match() becoz each node appears once in `mat'
    O <- match(mat, nodes)
    new.nodes <- 1:nb.node + nb.tip
    sel <- !is.na(O)
    mat[sel] <- new.nodes[O[sel]]
    mat <- t(apply(mat, 1, sort))

    obj <- list(matching = mat)
    if (!is.null(x$edge.length))
        warning("branch lengths have been ignored")
    if (labels) {
        obj$tip.label <- x$tip.label
        if (!is.null(x$node.label))
            obj$node.label <- x$node.label[match(new.nodes, nodes)]
    }
    class(obj) <- "matching"
    obj
}

as.phylo.matching <- function(x, ...)
{
    nb.node <- dim(x$matching)[1]
    nb.tip <- nb.node + 1
    N <- 2 * nb.node
    edge <- matrix(NA, N, 2)
    new.nodes <- numeric(N + 1)
    new.nodes[N + 1] <- nb.tip + 1
    nextnode <- nb.tip + 2
    j <- 1
    for (i in nb.node:1) {
        edge[j:(j + 1), 1] <- new.nodes[i + nb.tip]
        for (k in 1:2) {
            if (x$matching[i, k] > nb.tip) {
                edge[j + k - 1, 2] <- new.nodes[x$matching[i, k]] <- nextnode
                nextnode <- nextnode + 1
            } else edge[j + k - 1, 2] <- x$matching[i, k]
        }
        j <- j + 2
    }
    obj <- list(edge = edge)
    if (!is.null(x$tip.label)) obj$tip.label <- x$tip.label
    else obj$tip.label <- as.character(1:nb.tip)
    obj$Nnode <- nb.node
    class(obj) <- "phylo"
    read.tree(text = write.tree(obj))
}

## njs.R (2013-10-04)

## Tree Reconstruction from Incomplete Distances With NJ* or bio-NJ*

## Copyright 2011-2013 Andrei-Alin Popescu

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

njs <- function(X, fs = 15)
{
    if (fs < 1)
        stop("argument 'fs' must be a non-zero positive integer")
    if (is.matrix(X)) X <- as.dist(X)
    X[is.na(X)] <- -1
    X[X < 0] <- -1
    X[is.nan(X)] <- -1
    N <- attr(X, "Size")
    labels <- attr(X, "Labels")
    if (is.null(labels)) labels <- as.character(1:N)
    ans <- .C(C_njs, as.double(X), as.integer(N), integer(2*N - 3),
              integer(2*N - 3), double(2*N - 3), as.integer(fs),
              NAOK = TRUE)
    obj <- list(edge = cbind(ans[[3]], ans[[4]]), edge.length = ans[[5]],
                tip.label = labels, Nnode = N - 2L)
    class(obj) <- "phylo"
    reorder(obj)
}

bionjs <- function(X, fs = 15)
{
    if (fs < 1)
        stop("argument 'fs' must be a non-zero positive integer")
    if (is.matrix(X)) X <- as.dist(X)
    X[is.na(X)] <- -1
    X[X < 0] <- -1
    X[is.nan(X)] <- -1
    N <- attr(X, "Size")
    labels <- attr(X, "Labels")
    if (is.null(labels)) labels <- as.character(1:N)
    ans <- .C(C_bionjs, as.double(X), as.integer(N), integer(2*N - 3),
              integer(2*N - 3), double(2*N - 3), as.integer(fs),
              NAOK = TRUE)
    obj <- list(edge = cbind(ans[[3]], ans[[4]]), edge.length = ans[[5]],
                tip.label = labels, Nnode = N - 2L)
    class(obj) <- "phylo"
    reorder(obj)
}

## plotPhyloCoor.R (2017-05-26)

##   Coordinates of a Tree Plot

## Copyright 2008 Damien de Vienne, 2013-2017 Klaus Schliep

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

plotPhyloCoor <-
    function (x, type = "phylogram", use.edge.length = TRUE, node.pos = NULL,
              direction = "rightwards", tip.height = NULL, ...)
{
    Ntip <- length(x$tip.label)
    if (Ntip == 1)
        stop("found only one tip in the tree!")
    Nedge <- dim(x$edge)[1]
    if (any(tabulate(x$edge[, 1]) == 1))
        stop("there are single (non-splitting) nodes in your tree; you may need to use collapse.singles().")
    Nnode <- x$Nnode
    if (is.null(x$edge.length)) use.edge.length <- FALSE
    phyloORclado <- type %in% c("phylogram", "cladogram")
    horizontal <- direction %in% c("rightwards", "leftwards")
    if (phyloORclado) {
        ## changed by KS:
        yy <- numeric(Ntip + Nnode)
        x <- reorder(x)
        TIPS <- x$edge[x$edge[, 2] <= Ntip, 2]
        if (!is.null(tip.height)) {
            if(!is.null(names(tip.height))) tip.height = tip.height[x$tip.label]
            yy[TIPS] <- tip.height
        } 
        else yy[TIPS] <- 1:Ntip
    }

    xe <- x$edge
    ## first reorder the tree in cladewise order to avoid cophyloplot() hanging:
    ## x <- reorder(reorder(x), order = "pruningwise") ... maybe not needed anymore (EP)
    x <- reorder(x, order = "postorder")
    ereorder <- match(x$edge[, 2], xe[, 2])

    if (phyloORclado) {
        if (is.null(node.pos)) {
            node.pos <- 1
            if (type == "cladogram" && !use.edge.length)
                node.pos <- 2
        }
        if (node.pos == 1)
            yy <- .C(node_height, as.integer(x$edge[, 1]),
                     as.integer(x$edge[, 2]), as.integer(Nedge),
                     as.double(yy))[[4]]
        else {
            ans <- .C(node_height_clado, as.integer(Ntip),
                      as.integer(x$edge[, 1]), as.integer(x$edge[, 2]),
                      as.integer(Nedge), double(Ntip + Nnode), as.double(yy))
            xx <- ans[[5]] - 1
            yy <- ans[[6]]
        }
        if (!use.edge.length) {
            if (node.pos != 2)
                xx <- .C(node_depth, as.integer(Ntip),
                         as.integer(x$edge[, 1]), as.integer(x$edge[, 2]),
                         as.integer(Nedge), double(Ntip + Nnode), 1L)[[5]] - 1
            xx <- max(xx) - xx
        } else {
            xx <- .C(node_depth_edgelength, as.integer(x$edge[, 1]),
                     as.integer(x$edge[, 2]), as.integer(Nedge),
                     as.double(x$edge.length), double(Ntip + Nnode))[[5]]
        }
    }

    if (phyloORclado && direction != "rightwards") {
        if (direction == "leftwards") {
            xx <- -xx
            xx <- xx - min(xx)
        }
        if (!horizontal) {
            tmp <- yy
            yy <- xx
            xx <- tmp - min(tmp) + 1
            if (direction == "downwards") {
                yy <- -yy
                yy <- yy - min(yy)
            }
        }
    }
    cbind(xx, yy)
}

## compar.gee.R (2015-05-01)

##   Comparative Analysis with GEEs

## Copyright 2002-2015 Emmanuel Paradis

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

compar.gee <-
    function(formula, data = NULL, family = gaussian, phy,
             corStruct, scale.fix = FALSE, scale.value = 1)
{
    if (requireNamespace("gee", quietly = TRUE)) gee <- gee::gee
    else stop("package 'gee' not available")

    if (!missing(corStruct)) {
        if (!missing(phy))
            warning("the phylogeny was ignored because you gave a 'corStruct' object")
        R <- vcv(corStruct, corr = TRUE)
    } else {
        R <- vcv(phy, corr = TRUE)
    }

    if (is.null(data)) data <- parent.frame()
    else {
        nmsR <- rownames(R)
        if (!identical(rownames(data), nmsR)) {
            if (!any(is.na(match(rownames(data), nmsR))))
                data <- data[nmsR, ]
            else {
                msg <- if (missing(corStruct))
                    "the tip labels of the tree" else "those of the correlation structure"
                msg <- paste("the rownames of the data.frame and", msg,
                             "do not match: the former were ignored in the analysis")
                warning(msg)
            }
        }
    }

    effect.assign <- attr(model.matrix(formula, data = data), "assign")

    for (i in all.vars(formula)) {
        if (any(is.na(eval(parse(text = i), envir = data))))
          stop("the present method cannot be used with missing data: you may consider removing the species with missing data from your tree with the function 'drop.tip'.")
    }

    id <- rep(1, dim(R)[1])
    geemod <- do.call("gee", list(formula, id, data = data, family = family, R = R,
                                  corstr = "fixed", scale.fix = scale.fix,
                                  scale.value = scale.value))
    W <- geemod$naive.variance
    fname <-
        if (is.function(family)) deparse(substitute(family)) else if (is.list(family)) family$family else family
    if (fname == "binomial")
        W <- summary(glm(formula, family = quasibinomial, data = data))$cov.scaled
    N <- geemod$nobs
    ## <FIXME>
    ## maybe need to refine below in case of non-Brownian corStruct
    if (!missing(corStruct)) phy <- attr(corStruct, "tree")
    dfP <- sum(phy$edge.length)*N / sum(diag(vcv(phy))) # need the variances
    ## </FIXME>

    ## compute QIC:
    Y <- geemod$y
    MU <- geemod$fitted.values
    Qlik <- switch(fname,
                   "gaussian" = -sum((Y - MU)^2)/2,
                   "binomial" = sum(Y*log(MU/(1 - MU)) + log(1 - MU)),
                   "poisson" = sum(Y*log(MU) - MU),
                   "Gamma" = sum(Y/MU + log(MU)),
                   "inverse.gaussian" = sum(-Y/(2*MU^2) + 1/MU))
    Ai <- do.call("gee", list(formula, id, data = data, family = family,
                              corstr = "independence", scale.fix = scale.fix,
                              scale.value = scale.value))$naive.variance
    QIC <- -2*Qlik + 2*sum(diag(solve(Ai) %*% W))

    obj <- list(call = match.call(),
                effect.assign = effect.assign,
                nobs = N,
                QIC = QIC,
                coefficients = geemod$coefficients,
                residuals = geemod$residuals,
                fitted.values = MU,
                family = geemod$family$family,
                link = geemod$family$link,
                scale = geemod$scale,
                W = W,
                dfP = dfP)
    class(obj) <- "compar.gee"
    obj
}

print.compar.gee <- function(x, ...)
{
    nas <- is.na(x$coef)
    coef <- x$coef[!nas]
    cnames <- names(coef)
    coef <- matrix(rep(coef, 4), ncol = 4)
    dimnames(coef) <- list(cnames,
                           c("Estimate", "S.E.", "t", "Pr(T > |t|)"))
    df <- x$dfP - dim(coef)[1]
    coef[, 2] <- sqrt(diag(x$W))
    coef[, 3] <- coef[, 1]/coef[, 2]
    if (df < 0) {
        warning("not enough degrees of freedom to compute P-values.")
        coef[, 4] <- NA
    } else coef[, 4] <- 2 * (1 -  pt(abs(coef[, 3]), df))
    residu <- quantile(as.vector(x$residuals))
    names(residu) <- c("Min", "1Q", "Median", "3Q", "Max")
    cat("Call: ")
    print(x$call)
    cat("Number of observations: ", x$nobs, "\n")
    cat("Model:\n")
    cat("                      Link:", x$link, "\n")
    cat(" Variance to Mean Relation:", x$family, "\n")
    cat("\nQIC:", x$QIC, "\n")
    cat("\nSummary of Residuals:\n")
    print(residu)
    if (any(nas))
        cat("\n\nCoefficients: (", sum(nas), " not defined because of singularities)\n",
            sep = "")
    else cat("\n\nCoefficients:\n")
    print(coef)
    cat("\nEstimated Scale Parameter: ", x$scale)
    cat("\n\"Phylogenetic\" df (dfP): ", x$dfP, "\n")
}

drop1.compar.gee <- function(object, scope, quiet = FALSE, ...)
{
    fm <- formula(object$call)
    trm <- terms(fm)
    z <- attr(trm, "term.labels")
    ind <- object$effect.assign
    n <- length(z)
    ans <- matrix(NA, n, 3)
    for (i in 1:n) {
        wh <- which(ind == i)
        ans[i, 1] <- length(wh)
        ans[i, 2] <- t(object$coefficients[wh]) %*%
          solve(object$W[wh, wh]) %*% object$coefficients[wh]
    }
    df <- object$dfP - length(object$coefficients)
    if (df < 0) warning("not enough degrees of freedom to compute P-values.")
    else ans[, 3] <- pf(ans[, 2], ans[, 1], df, lower.tail = FALSE)
    colnames(ans) <- c("df", "F", "Pr(>F)")
    rownames(ans) <- z
    if (any(attr(trm, "order") > 1) && !quiet)
      warning("there is at least one interaction term in your model:
you should be careful when interpreting the significance of the main effects.")
    class(ans) <- "anova"
    attr(ans, "heading") <- paste("Single term deletions\n\n  Model:",
                                  as.character(as.expression(fm)), "\n")
    ans
}

predict.compar.gee <-
    function(object, newdata = NULL, type = c("link", "response"), ...)
{
    type <- match.arg(type)
    pred <- if (is.null(newdata)) object$fitted.values else {
        frm <- formula(object$call$formula)[-2]
        X <-  model.matrix(frm, data = newdata)
        beta <- object$coefficients
        X[, names(beta), drop = FALSE] %*% beta
    }
    if (type == "link") return(pred)
    f <- match.fun(object$family)
    f(link = object$link)$linkinv(pred)
}

## subtreeplot.R (2017-05-26)

##  Zoom on a Portion of a Phylogeny by Successive Clicks

## Copyright 2008 Damien de Vienne

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

subtreeplot<-function(x, wait=FALSE, ...) {

    sub<-subtrees(x, wait=wait)
    y<-NULL
    plot.default(0, type="n",axes=FALSE, ann=FALSE)
    repeat {
	  split.screen(c(1,2))
        screen(2)
        if (is.null(y)) plot(x,...)
        else plot(y,sub=paste("Node :", click),...)
        screen(1)
        plot(x,sub="Complete tree",main="Type ESC or right click to exit", cex.main=0.9, ...)

        N.tip<-Ntip(x)
        N.node<-Nnode(x)

        # 5/24/17 changed by Klaus
        # coor<-plotPhyloCoor(x)
        lastPP <- get("last_plot.phylo", envir = .PlotPhyloEnv)
        tips<-x$tip.label
        nodes<-x$node.label
        if (is.null(x$node.label)) nodes<-(N.tip+1):(N.tip+N.node)
        labs<-c(rep("",N.tip), nodes)

        #click<-identify(coor[,1], coor[,2], labels=labs, n=1)
        click<-identify(lastPP$xx, lastPP$yy, labels=labs, n=1)
        if (length(click) == 0) {return(y)}
        if (click > N.tip) {
            close.screen(c(1,2),all.screens = TRUE)
            split.screen(c(1,2))
            screen(1) #selects the screen to plot in
            plot(x, sub="Complete tree", ...) # plots x in screen 1 (left)
            screen(2)
            for (i in 1:length(sub)) if (sub[[i]]$name==click) break
            y<-sub[[i]]
	  }
        else cat("this is a tip, you have to choose a node\n")

      }
    on.exit(return(y))
}

## SlowinskiGuyer.R (2016-10-23)

##   Tests of Diversification Shifts with Sister-Clades

## Copyright 2011-2016 Emmanuel Paradis

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

slowinskiguyer.test <- function(x, detail = FALSE)
{
    r <- x[, 1]
    n <- x[, 1] + x[, 2]
    pp <- (n - r)/(n - 1)
    chi <- -2 * sum(log(pp))
    df <- as.integer(2 * length(pp))
    pval <- pchisq(chi, df, lower.tail = FALSE)
    res <- data.frame("chisq" = chi, "df" = df, "P.val" = pval, row.names = "")
    if (detail)
        res <- list(res, individual_Pvalues = pp)
    res
}

mcconwaysims.test <- function(x)
{
    LRTp <- function(x) {
        f <- function(x) ifelse(x == 0, 0, x * log(x))
        n1 <- x[1]
        n2 <- x[2]
        1.629*(f(n1 - 1) - f(n1) + f(n2 - 1) - f(n2) - f(2) -
               f(n1 + n2 - 2) + f(n1 + n2))
    }
    chi <- sum(apply(x, 1, LRTp))
    pval <- pchisq(chi, df <- nrow(x), lower.tail = FALSE)
    data.frame("chisq" = chi, "df" = df, "P.val" = pval, row.names = "")
}

richness.yule.test <- function(x, t)
{
    n1 <- x[, 1]
    n2 <- x[, 2]
    n <- c(n1, n2)
    tb <- c(t, t)

    .PrNt.Yule <- function(N, age, birth) {
        tmp <- -birth * age
        tmp + (N - 1) * log(1 - exp(tmp)) # on a log-scale
    }

    ## the functions to minimize:
    minusloglik0 <- function(l) -sum(.PrNt.Yule(n, tb, l))
    minusloglika <- function(l) -sum(.PrNt.Yule(n1, t, l[1])) - sum(.PrNt.Yule(n2, t, l[2]))

    ## initial values (moment estimators):
    ipa <- c(mean(log(n1)/t), mean(log(n2)/t))
    ip0 <- mean(ipa)

    out0 <- nlminb(ip0, minusloglik0, lower = 0, upper = 1)
    outa <- nlminb(ipa, minusloglika, lower = c(0, 0), upper = c(1, 1))
    chi <- 2 * (out0$objective - outa$objective)
    pval <- pchisq(chi, 1, lower.tail = FALSE)
    data.frame(chisq = chi, df = 1, P.val = pval, row.names = "")
}

diversity.contrast.test <-
    function(x, method = "ratiolog", alternative = "two.sided", nrep = 0, ...)
{
    method <- match.arg(method, c("ratiolog", "proportion",
                                  "difference", "logratio"))
    alternative <- match.arg(alternative, c("two.sided", "less", "greater"))

    minmax <- t(apply(x, 1, sort)) # sort all rows
    DIFF <- x[, 1] - x[, 2]
    SIGN <- sign(DIFF)

    CONTRAST <- switch(method,
                       "ratiolog" = {
                           if (any(minmax == 1))
                               minmax <- minmax + 1 # prevent division by 0
                           ## Note: if min = max, no need to set the contrast
                           ## to zero since this is done with sign()
                           log(minmax[, 2]) / log(minmax[, 1])
                       },
                       "proportion" = minmax[, 2] / (minmax[, 2] + minmax[, 1]),
                       "difference" = abs(DIFF),
                       "logratio" = log(minmax[, 1] / minmax[, 2]))

    y <- SIGN * CONTRAST # the signed contrasts

    if (nrep) {
        n <- length(SIGN)
        RND <-
            replicate(nrep,
                      sum(sample(c(-1, 1), size = n, replace = TRUE) * CONTRAST))
        cases <- switch(alternative,
                        "two.sided" = sum(abs(RND) > sum(y)),
                        "less" = sum(RND < sum(y)),
                        "greater" = sum(RND > sum(y)))
        cases/nrep
    } else wilcox.test(x = y, alternative = alternative, ...)$p.value
}

## read.dna.R (2018-05-15)

##   Read DNA Sequences in a File

## Copyright 2003-2018 Emmanuel Paradis, 2017 RJ Ewing

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

read.FASTA <- function(file, type = "DNA")
{
    TYPES <- c("DNA", "AA")
    itype <- pmatch(toupper(type), TYPES)
    if (is.na(itype))
        stop(paste("'type' should be", paste(dQuote(TYPES), collapse = " or ")))
    if (length(grep("^(ht|f)tp(s|):", file))) {
        url <- file
        file <- tempfile()
        download.file(url, file)
    }
    if (inherits(file, "connection")) {
        if (!isOpen(file, "rt")) {
            open(file, "rt")
            on.exit(close(file))
        }
        x <- scan(file, what = character(), sep = "\n", quiet = TRUE)
        x <- charToRaw(paste(x, collapse = "\n"))
        sz <- length(x)
    } else {
        sz <- file.size(file)
        x <- readBin(file, "raw", sz)
    }
    ## if the file is larger than 1 Gb we assume that it is
    ## UNIX-encoded and skip the search-replace of carriage returns
    if (sz < 1e9) {
        icr <- which(x == as.raw(0x0d)) # CR
        if (length(icr)) x <- x[-icr]
    }
    res <- .Call(rawStreamToDNAorAAbin, x, itype - 2L)
    if (identical(res, 0L)) {
        warning("failed to read sequences, returns NULL")
        return(NULL)
    }
    names(res) <- sub("^ +", "", names(res)) # to permit phylosim
    class(res) <- c("DNAbin", "AAbin")[itype]
    res
}

read.dna <- function(file, format = "interleaved", skip = 0,
                     nlines = 0, comment.char = "#",
                     as.character = FALSE, as.matrix = NULL)
{
    findFirstNucleotide <- function(x) {
        ## actually find the 1st non-blank character
        ## just in case: pat.base <- "[-AaCcGgTtUuMmRrWwSsYyKkVvHhDdBbNn?]{10}"
        tmp <- regexpr("[[:blank:]]+", x[1]) # consider only a single string
        tmp[1] + attr(tmp, "match.length")
    }
    getTaxaNames <- function(x) {
        x <- sub("^['\" ]+", "", x) # remove the leading quotes and spaces
        x <- sub("['\" ]+$", "", x) #   "     "  trailing  "     "    "
        x
    }
    getNucleotide <- function(x) {
        x <- gsub(" ", "", x)
        x <- strsplit(x, NULL)
        tolower(unlist(x))
    }
    formats <- c("interleaved", "sequential", "fasta", "clustal")
    format <- match.arg(format, formats)
    if (format == "fasta") {
        obj <- read.FASTA(file)
    } else {
        X <- scan(file = file, what = "", sep = "\n", quiet = TRUE,
                  skip = skip, nlines = nlines, comment.char = comment.char)
        if (format %in% formats[1:2]) {
            ## need to remove the possible leading spaces and/or tabs in the first line
            fl <- gsub("^[[:blank:]]+", "", X[1])
            fl <- as.numeric(unlist(strsplit(fl, "[[:blank:]]+")))
            if (length(fl) != 2 || any(is.na(fl)))
                stop("the first line of the file must contain the dimensions of the data")
            n <- fl[1]
            s <- fl[2]
            obj <- matrix("", n, s)
            X <- X[-1]
        }
        switch(format,
               "interleaved" = {
                   start.seq <- findFirstNucleotide(X[1])
                   one2n <- 1:n
                   taxa <- getTaxaNames(substr(X[one2n], 1, start.seq - 1))
                   X[one2n] <- substr(X[one2n], start.seq, nchar(X[one2n]))
                   nl <- length(X)
                   for (i in one2n)
                       obj[i, ] <- getNucleotide(X[seq(i, nl, n)])
               },
               "sequential" = {
                   taxa <- character(n)
                   j <- 1L # line number
                   for (i in 1:n) {
                       start.seq <- findFirstNucleotide(X[j])
                       taxa[i] <- getTaxaNames(substr(X[j], 1, start.seq - 1))
                       sequ <- getNucleotide(substr(X[j], start.seq, nchar(X[j])))
                       j <- j + 1L
                       while (length(sequ) < s) {
                           sequ <- c(sequ, getNucleotide(X[j]))
                           j <- j + 1L
                       }
                       obj[i, ] <- sequ
                   }
                   taxa <- getTaxaNames(taxa)
               },
               "clustal" = {
                   X <- X[-1] # drop the line with "Clustal bla bla..."
                   ## find where the 1st sequence starts
                   start.seq <- findFirstNucleotide(X[1])
                   ## find the lines with *********....
                   nspaces <- paste("^ {", start.seq - 1, "}", sep = "", collapse = "")
                   stars <- grep(nspaces, X)
                   ## we now know how many sequences in the file:
                   n <- stars[1] - 1
                   taxa <- getTaxaNames(substr(X[1:n], 1, start.seq - 1))
                   ## need to remove the sequence names before getting the sequences:
                   X <- substr(X, start.seq, nchar(X))
                   nl <- length(X)
                   ## find the length of the 1st sequence:
                   tmp <- getNucleotide(X[seq(1, nl, n + 1)])
                   s <- length(tmp)
                   obj <- matrix("", n, s)
                   obj[1, ] <- tmp
                   for (i in 2:n)
                       obj[i, ] <- getNucleotide(X[seq(i, nl, n + 1)])
               })
    }
    if (format != "fasta") {
        rownames(obj) <- taxa
        if (!as.character) obj <- as.DNAbin(obj)
    } else {
        LENGTHS <- unique(lengths(obj, use.names = FALSE))
        allSameLength <- length(LENGTHS) == 1
        if (is.logical(as.matrix)) {
            if (as.matrix && !allSameLength)
                stop("sequences in FASTA file not of the same length")
        } else {
            as.matrix <- allSameLength
        }
        if (as.matrix) {
            taxa <- names(obj)
            n <- length(obj)
            y <- matrix(as.raw(0), n, LENGTHS)
            for (i in seq_len(n)) y[i, ] <- obj[[i]]
            obj <- y
            rownames(obj) <- taxa
            class(obj) <- "DNAbin"
        }
        if (as.character) obj <- as.character(obj)
    }
    obj
}

read.fastq <- function(file, offset = -33)
{
    Z <- scan(file, "", sep="\n", quiet = TRUE)
    tmp <- Z[c(TRUE, TRUE, FALSE, FALSE)]
    sel <- c(TRUE, FALSE)
    tmp[sel] <- gsub("^@", ">", tmp[sel])
    fl <- tempfile()
    cat(tmp, file = fl, sep = "\n")
    DNA <- read.FASTA(fl)

    ## get the qualities:
    tmp <- Z[c(FALSE, FALSE, FALSE, TRUE)]
    QUAL <- lapply(tmp, function(x) as.integer(charToRaw(x)))
    if (offset) QUAL <- lapply(QUAL, "+", offset)
    names(QUAL) <- names(DNA)
    attr(DNA, "QUAL") <- QUAL
    DNA
}

## chronos.R (2020-05-08)

##   Molecular Dating With Penalized and Maximum Likelihood

## Copyright 2013-2017 Emmanuel Paradis, 2018-2020 Santiago Claramunt, 2020 Guillaume Louvel

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

.chronos.ctrl <-
    list(tol = 1e-8, iter.max = 1e4, eval.max = 1e4, nb.rate.cat = 10,
         dual.iter.max = 20, epsilon = 1e-6)

makeChronosCalib <-
    function(phy, node = "root", age.min = 1, age.max = age.min,
             interactive = FALSE, soft.bounds = FALSE)
{
    n <- Ntip(phy)
    if (interactive) {
        plot(phy)
        cat("Click close to a node and enter the ages (right-click to exit)\n\n")
        node <- integer()
        age.min <- age.max <- numeric()
        repeat {
            ans <- identify(phy, quiet = TRUE)
            if (is.null(ans)) break
            NODE <- ans$nodes
            nodelabels(node = NODE, col = "white", bg = "blue")
            cat("constraints for node ", NODE, sep = "")
            cat("\n  youngest age: ")
            AGE.MIN <- as.numeric(readLines(n = 1))
            cat("  oldest age (ENTER if not applicable): ")
            AGE.MAX <- as.numeric(readLines(n = 1))
            node <- c(node, NODE)
            age.min <- c(age.min, AGE.MIN)
            age.max <- c(age.max, AGE.MAX)
        }
        s <- is.na(age.max)
        if (any(s)) age.max[s] <- age.min[s]
    } else {
        if (identical(node, "root")) node <- n + 1L
    }

    if (any(node <= n))
        stop("node numbers should be greater than the number of tips")

    diff.age <- which(age.max < age.min)
    if (length(diff.age)) {
        msg <- "'old age' less than 'young age' for node"
        if (length(diff.age) > 1) msg <- paste(msg, "s", sep = "")
        stop(paste(msg, paste(node[diff.age], collapse = ", ")))
    }

    data.frame(node, age.min, age.max, soft.bounds = soft.bounds)
}

next.calib <- function(y, ini.time) # added by GL (2020-01-29)
{
    times <- ini.time[y]
    runs.na <- rle(is.na(times))
    next.calib.i <- cumsum(runs.na$lengths)[runs.na$values] + 1
    ini.time[y[next.calib.i]]
    ##return(ncal)  #if(length(ncal)){ncal}else{-1})
}

chronos.control <- function(...)
{
    dots <- list(...)
    x <- .chronos.ctrl
    if (length(dots)) {
        chk.nms <- names(dots) %in% names(x)
        if (any(!chk.nms)) {
            warning("some control parameter names do not match: they were ignored")
            dots <- dots[chk.nms]
        }
        x[names(dots)] <- dots
    }
    x
}

chronos <-
    function(phy, lambda = 1, model = "correlated", quiet = FALSE,
             calibration = makeChronosCalib(phy),
             control = chronos.control())
{
    model <- match.arg(tolower(model), c("correlated", "relaxed", "discrete"))
    n <- Ntip(phy)
    ROOT <- n + 1L
    m <- phy$Nnode
    el <- phy$edge.length
    if (is.null(el)) stop("the tree has no branch lengths")
    if (any(el < 0)) stop("some branch lengths are negative")
    e1 <- phy$edge[, 1L]
    e2 <- phy$edge[, 2L]
    N <- length(e1)
    TIPS <- 1:n
    EDGES <- 1:N

    tol <- control$tol

    node <- calibration$node
    age.min <- calibration$age.min
    age.max <- calibration$age.max
    ## Starting points of node ages to *estimate*. Calibrated nodes can be NA.
    age.start <- # added by GL (2020-01-29)
        if (is.null(calibration$age.start)) rep(NA_real_, length(node)) else calibration$age.start

    if (model == "correlated") {
### `basal' contains the indices of the basal edges
### (ie, linked to the root):
        basal <- which(e1 == ROOT)
        Nbasal <- length(basal)

### 'ind1' contains the index of all nonbasal edges, and 'ind2' the
### index of the edges where these edges come from (ie, they contain
### pairs of contiguous edges), eg:

###         ___b___    ind1  ind2
###        |           |   ||   |
### ___a___|           | b || a |
###        |           | c || a |
###        |___c___    |   ||   |

        ind1 <- EDGES[-basal]
        ind2 <- match(e1[EDGES[-basal]], e2)
    }

    age <- numeric(n + m)

    lfactorial.el <- lfactorial(el) # Calculate the factorials here once (SC)

### This bit sets 'ini.time' and should result in no negative branch lengths

    if (!quiet) cat("\nSetting initial dates...\n")
    seq.nod <- .Call(seq_root2tip, phy$edge, n, phy$Nnode)

    ## 'fact.root' is used to approximate the age of the root if it is not given;
    ## it is multiplied by 1.5 every 100 tries of the initiation loop (see below)
    ## (added 2017-11-21)
    fact.root <- 3
    ii <- 1L
    repeat {
        ini.time <- age
        ini.time[ROOT:(n + m)] <- NA

        ##ini.time[node] <-
        ##    if (is.null(age.max)) age.min
        ##    else runif(length(node), age.min, age.max) # (age.min + age.max) / 2
        ## added by GL (2020-01-29):
        ini.time[node] <- ifelse(is.na(age.start),
                                 if (is.null(age.max)) age.min
                                 else runif(length(node), age.min, age.max),
                                 age.start)

        ## if no age given for the root, find one approximately:
        if (is.na(ini.time[ROOT]))
            ini.time[ROOT] <- fact.root * max(if (is.null(age.max)) age.min else age.max)

        ##ISnotNA.ALL <- unlist(lapply(seq.nod, function(x) sum(!is.na(ini.time[x]))))
        ##o <- order(ISnotNA.ALL, decreasing = TRUE)

        ## added by GL (2020-01-29):
        ## For each path to the leaves, return the calibrations following the last NA.
        calibs.after.NA <- lapply(seq.nod, next.calib, ini.time)

        ## This recycles shorter elements, but doesn't matter with the order() function
        L <- max(sapply(calibs.after.NA, length))
        calibs.df <-
            as.data.frame(do.call(rbind, lapply(calibs.after.NA,
                                                function(r) c(r, rep(-1, L - length(r))))))
        o <- do.call(order, c(calibs.df, decreasing = TRUE))

        for (y in seq.nod[o]) {
            ISNA <- is.na(ini.time[y])
            if (any(ISNA)) {
                i <- 2L # we know the 1st value is not NA, so we start at the 2nd one
                while (i <= length(y)) {
                    if (ISNA[i]) { # we stop at the next NA
                        j <- i + 1L
                        while (ISNA[j]) j <- j + 1L # look for the next non-NA
                        nb.val <- j - i
                        by <- (ini.time[y[i - 1L]] - ini.time[y[j]]) / (nb.val + 1)
                        ini.time[y[i:(j - 1L)]] <- ini.time[y[i - 1L]] - by * seq_len(nb.val)
                        i <- j + 1L
                    } else i <- i + 1L
                }
            }
        }
        if (all(ini.time[e1] - ini.time[e2] >= 0)) break
        ii <- ii + 1L
        if (ii > 1000)
            stop("cannot find reasonable starting dates after 1000 tries:
maybe you need to adjust the calibration dates")
        if (!(ii %% 100)) fact.root <- fact.root * 1.5
    }
### 'ini.time' set

    #ini.time[ROOT:(n+m)] <- branching.times(chr.dis)
    ## ini.time[ROOT:(n+m)] <- ini.time[ROOT:(n+m)] + rnorm(m, 0, 5)
    #print(ini.time)


### Setting 'ini.rate'
    ini.rate <- el/(ini.time[e1] - ini.time[e2])

    if (model == "discrete") {
        Nb.rates <- control$nb.rate.cat
        if (Nb.rates > N) {
            Nb.rates <- N
            warning("'nb.rate.cat' > number of branches: used nb.rate.cat = # of branches instead", call. = FALSE)
        }
        minmax <- range(ini.rate)
        if (Nb.rates == 1) {
            ini.rate <- sum(minmax)/2
        } else {
            inc <- diff(minmax)/Nb.rates
            ini.rate <- seq(minmax[1] + inc/2, minmax[2] - inc/2, inc)
            ini.freq <- rep(1/Nb.rates, Nb.rates - 1)
            lower.freq <- rep(0, Nb.rates - 1)
            upper.freq <- rep(1, Nb.rates - 1)
        }
    } else Nb.rates <- N
## 'ini.rate' set

### Setting bounds for the node ages

    ## `unknown.ages' will contain the index of the nodes of unknown age:
    unknown.ages <- 1:m + n

    ## initialize vectors for all nodes:
    lower.age <- rep(tol, m)
    upper.age <- rep(1/tol, m)

    lower.age[node - n] <- age.min
    upper.age[node - n] <- age.max

    ## find nodes known within an interval:
    ii <- which(is.na(age.min) | (age.min != age.max))
    ## drop them from 'node' since they will be estimated:
    if (length(ii)) {
        node <- node[-ii]
        if (length(node))
            age[node] <- age.min[-ii] # update 'age'
    } else age[node] <- age.min

    ## finally adjust the 3 vectors:
    if (length(node)) {
        unknown.ages <- unknown.ages[n - node] # 'n - node' is simplification for '-(node - n)'
        lower.age <- lower.age[n - node]
        upper.age <- upper.age[n - node]
    }
### Bounds for the node ages set

    ## 'known.ages' contains the index of all nodes
    ## (internal and terminal) of known age:
    known.ages <- c(TIPS, node)

    ## the bounds for the rates:
    lower.rate <- rep(tol, Nb.rates)
    upper.rate <- rep(1e5 - tol, Nb.rates)

### Gradient
    degree_node <- tabulate(phy$edge)
    eta_i <- degree_node[e1]
    eta_i[e2 <= n] <- 1L
    ## eta_i[i] is the number of contiguous branches for branch 'i'

    ## use of a list of indices is slightly faster than an incidence matrix
    ## and takes much less memory (60 Kb vs. 8 Mb for n = 500)
    X <- vector("list", N)
    for (i in EDGES) {
        j <- integer()
        if (e1[i] != ROOT) j <- c(j, which(e2 == e1[i]))
        if (e2[i] >= n) j <- c(j, which(e1 == e2[i]))
        X[[i]] <- j
    }
    ## X is a list whose i-th element gives the indices of the branches
    ## that are contiguous to branch 'i'

    ## D_ki and A_ki are defined in the SI of the paper
    D_ki <- match(unknown.ages, e2)
    A_ki <- lapply(unknown.ages, function(x) which(x == e1))

    gradient.poisson <- function(rate, node.time) {
        age[unknown.ages] <- node.time
        real.edge.length <- age[e1] - age[e2]

        ## gradient for the rates:
        gr <- el/rate - real.edge.length

        ## gradient for the dates:
        tmp <- el/real.edge.length - rate
        tmp2 <- tmp[D_ki]
        tmp2[is.na(tmp2)] <- 0
        gr.dates <- sapply(A_ki, function(x) sum(tmp[x])) - tmp2

        c(gr, gr.dates)
    }

    ## gradient of the penalized lik (must be multiplied by -1 before calling nlminb)
    gradient <-
        switch(model,
               "correlated" =
               function(rate, node.time) {
                   gr <- gradient.poisson(rate, node.time)
                   #if (all(gr == 0)) return(gr)

                   ## contribution of the penalty for the rates:
                   gr[RATE] <- gr[RATE] - lambda * 2 * (eta_i * rate - sapply(X, function(x) sum(rate[x])))
                   ## the contribution of the root variance term:
                   if (Nbasal == 2) { # the simpler formulae if there's a basal dichotomy
                       i <- basal[1]
                       j <- basal[2]
                       gr[i] <- gr[i] - lambda * (rate[i] - rate[j])
                       gr[j] <- gr[j] - lambda * (rate[j] - rate[i])
                   } else { # the general case
                       for (i in 1:Nbasal)
                           j <- basal[i]
                           gr[j] <- gr[j] -
                               lambda*2*(rate[j]*(1 - 1/Nbasal) - sum(rate[basal[-i]])/Nbasal)/(Nbasal - 1)
                   }
                   gr
               },
               "relaxed" =
               function(rate, node.time) {
                   gr <- gradient.poisson(rate, node.time)
                   #if (all(gr == 0)) return(gr)

                   ## contribution of the penalty for the rates:
                   mean.rate <- mean(rate)
                   ## rank(rate)/Nb.rates is the same than ecdf(rate)(rate) but faster
                   gr[RATE] <- gr[RATE] + lambda*2*dgamma(rate, mean.rate)*(rank(rate)/Nb.rates - pgamma(rate, mean.rate))
                   gr
               },
               "discrete" = NULL)

    log.lik.poisson <- function(rate, node.time) {
        age[unknown.ages] <- node.time
        real.edge.length <- age[e1] - age[e2]
        if (isTRUE(any(real.edge.length < 0))) return(-1e100)
        B <- rate * real.edge.length
        sum(el * log(B) - B - lfactorial.el)
    }

    ## New function for incorporating multiple rate categories (by SC).
    ## This one calculates the conditional probability for each branch
    ## and rate regime, and then computes a weighted average (using the
    ## frequencies as weights) before summing logs across branches.
    log.lik.poisson.discrete <- function(rate, node.time, freq) {
        Freqs <- c(freq, 1 - sum(freq))
        age[unknown.ages] <- node.time
        real.edge.length <- age[e1] - age[e2]
        if (any(real.edge.length < 0)) return(-1e+100)
        ## generate a matrix of branch length rates under each rate regime:
        B <- real.edge.length %*% t(rate)
        ## generate a matrix of likelihood values
        PPs <- exp(el * log(B) - B - lfactorial.el)
        ## matrix multiplication to obtain the weigthed sums for each
        ## branch (the average likelihoods), then sum the
        ## log-likelihoods to obtain the tree likelihood:
        sum(log(PPs %*% Freqs))
    }

### penalized log-likelihood
    penal.loglik <-
        switch(model,
               "correlated" =
               function(rate, node.time) {
                   loglik <- log.lik.poisson(rate, node.time)
                   if (!is.finite(loglik)) return(-1e100)
                   loglik - lambda * (sum((rate[ind1] - rate[ind2])^2)
                                      + var(rate[basal]))
               },
               "relaxed" =
               function(rate, node.time) {
                   loglik <- log.lik.poisson(rate, node.time)
                   if (!is.finite(loglik)) return(-1e100)
                   mu <- mean(rate)
                   ## loglik - lambda * sum((1:N/N - pbeta(sort(rate), mu/(1 + mu), 1))^2) # avec loi beta
                   ## loglik - lambda * sum((1:N/N - pcauchy(sort(rate)))^2) # avec loi Cauchy
                   loglik - lambda * sum((1:N/N - pgamma(sort(rate), mean(rate)))^2) # avec loi Gamma
               },
               "discrete" =
               if (Nb.rates == 1)
                   function(rate, node.time) log.lik.poisson(rate, node.time)
               else function(rate, node.time, freq) {
                   if (sum(freq) > 1) return(-1e100)
                   ## rate.freq <- sum(c(freq, 1 - sum(freq)) * rate)
                   ## log.lik.poisson(rate.freq, node.time)
                   log.lik.poisson.discrete(rate, node.time, freq) # by SC
               })

    opt.ctrl <- list(eval.max = control$eval.max, iter.max = control$iter.max)

    ## the following capitalized vectors give the indices of
    ## the parameters once they are concatenated in 'p'
    RATE <- 1:Nb.rates
    AGE <- Nb.rates + 1:length(unknown.ages)

    if (model == "discrete") {
        if (Nb.rates == 1) {
            start.para <- c(ini.rate, ini.time[unknown.ages])
            f <- function(p) -penal.loglik(p[RATE], p[AGE])
            g <- NULL
            LOW <- c(lower.rate, lower.age)
            UP <- c(upper.rate, upper.age)
        } else {
            FREQ <- length(RATE) + length(AGE) + 1:(Nb.rates - 1)
            start.para <- c(ini.rate, ini.time[unknown.ages], ini.freq)
            f <- function(p) -penal.loglik(p[RATE], p[AGE], p[FREQ])
            g <- NULL
            LOW <- c(lower.rate, lower.age, lower.freq)
            UP <- c(upper.rate, upper.age, upper.freq)
        }
    } else {
        start.para <- c(ini.rate, ini.time[unknown.ages])
        f <- function(p) -penal.loglik(p[RATE], p[AGE])
        g <- function(p) -gradient(p[RATE], p[AGE])
        LOW <- c(lower.rate, lower.age)
        UP <- c(upper.rate, upper.age)
    }

    k <- length(LOW) # number of free parameters

    if (!quiet) cat("Fitting in progress... get a first set of estimates\n")

    out <- nlminb(start.para, f, g,
                  control = opt.ctrl, lower = LOW, upper = UP)

    if (model == "discrete") {
        if (Nb.rates == 1) {
            f.rates <- function(p) -penal.loglik(p, current.ages)
            f.ages <- function(p) -penal.loglik(current.rates, p)
        } else {
            f.rates <- function(p) -penal.loglik(p, current.ages, current.freqs)
            f.ages <- function(p) -penal.loglik(current.rates, p, current.freqs)
            f.freqs <- function(p) -penal.loglik(current.rates, current.ages, p)
            g.freqs <- NULL
        }
        g.rates <- NULL
        g.ages <- NULL
    } else {
        f.rates <- function(p) -penal.loglik(p, current.ages)
        g.rates <- function(p) -gradient(p, current.ages)[RATE]
        f.ages <- function(p) -penal.loglik(current.rates, p)
        g.ages <- function(p) -gradient(current.rates, p)[AGE]
    }

    current.ploglik <- -out$objective
    current.rates <- out$par[RATE]
    current.ages <- out$par[AGE]
    if (model == "discrete" && Nb.rates > 1) current.freqs <- out$par[FREQ]

    dual.iter.max <- control$dual.iter.max
    epsilon <- control$epsilon
    i <- 1L # was 0L (2020-05-08)

    if (!quiet) cat("         (Penalised) log-lik =", current.ploglik, "\n")

    repeat {
        if (dual.iter.max < 1) break
        if (i > dual.iter.max) { # added this break here (with a warning) instead of after optimizations (SC)
            warning("Maximum number of dual iterations reached.", call. = FALSE)
            break
        }
        if (!quiet) cat("Optimising rates...")
        out.rates <- nlminb(current.rates, f.rates, g.rates,# h.rates,
                            control = list(eval.max = 1000, iter.max = 1000,
                                           step.min = 1e-8, step.max = .1),
                            lower = lower.rate, upper = upper.rate)
        new.rates <- out.rates$par
        if (-out.rates$objective > current.ploglik)
            current.rates <- new.rates

        if (model == "discrete" && Nb.rates > 1) {
            if (!quiet) cat(" frequencies...")
            out.freqs <- nlminb(current.freqs, f.freqs,
                                control = list(eval.max = 1000, iter.max = 1000,
                                               step.min = .001, step.max = .5),
                                lower = lower.freq, upper = upper.freq)
            new.freqs <- out.freqs$par
        }

        if (!quiet) cat(" dates...")
        out.ages <- nlminb(current.ages, f.ages, g.ages,# h.ages,
                           control = list(eval.max = 1000, iter.max = 1000,
                                          step.min = .001, step.max = 100),
                           lower = lower.age, upper = upper.age)
        new.ploglik <- -out.ages$objective

        if (!quiet) cat("", current.ploglik, "\n")

        delta.ploglik <- new.ploglik - current.ploglik
        if (is.na(delta.ploglik)) break # fix by Daniel Lang
        if (delta.ploglik > epsilon) {
            current.ploglik <- new.ploglik
            current.rates <- new.rates
            current.ages <- out.ages$par
            if (model == "discrete" && Nb.rates > 1) current.freqs <- new.freqs
            out <- out.ages
            i <- i + 1L
        } else break
    }

    ## if (!quiet) cat("\nDone.\n")

    if (model == "discrete") {
        ## rate.freq <-
        logLik <-
            if (Nb.rates == 1) log.lik.poisson(current.rates, current.ages)
            else log.lik.poisson.discrete(current.rates, current.ages, current.freqs)
##            else mean(c(current.freqs, 1 - sum(current.freqs)) * current.rates)
##        logLik <- log.lik.poisson(rate.freq, current.ages)
        PHIIC <- list(logLik = logLik, k = k, PHIIC = - 2 * logLik + 2 * k)
    } else {
        logLik <- log.lik.poisson(current.rates, current.ages)
        PHI <- switch(model,
                      "correlated" = (current.rates[ind1] - current.rates[ind2])^2 + var(current.rates[basal]),
                      "relaxed" = (1:N/N - pgamma(sort(current.rates), mean(current.rates)))^2) # avec loi Gamma
        PHIIC <- list(logLik = logLik, k = k, lambda = lambda,
                      PHIIC = - 2 * logLik + 2 * k + lambda * svd(PHI)$d)
    }

    attr(phy, "call") <- match.call()
    attr(phy, "ploglik") <- -out$objective
    attr(phy, "rates") <- current.rates #out$par[EDGES]
    if (model == "discrete" && Nb.rates > 1)
        attr(phy, "frequencies") <- c(current.freqs, 1 - sum(current.freqs))
    attr(phy, "convergence") <- if (out$convergence == 0) TRUE else FALSE
    attr(phy, "message") <- out$message
    attr(phy, "PHIIC") <- PHIIC
    attr(phy, "niter") <- i
    age[unknown.ages] <- current.ages #out$par[-EDGES]
    phy$edge.length <- age[e1] - age[e2]

    if(!attr(phy, "convergence"))
        warning(attr(phy, "message"), call. = FALSE)
    if (!quiet)
        cat("\nlog-Lik =", logLik, "\nPHIIC =", round(PHIIC$PHIIC, 2),"\n")

    class(phy) <- c("chronos", class(phy))
    phy
}

print.chronos <- function(x, ...)
{
    cat("\n    Chronogram\n\n")
    cat("Call: ")
    print(attr(x, "call"))
    cat("\n")
    NextMethod("print")
}

## cophenetic.phylo.R (2012-08-14)

##   Pairwise Distances from a Phylogenetic Tree

## Copyright 2006-2012 Emmanuel Paradis

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

dist.nodes <- function(x)
{
    x <- reorder(x) # required for the C code
    n <- Ntip(x)
    m <- x$Nnode
    nm <- n + m

    d <- .C(dist_nodes, as.integer(n), as.integer(m),
            as.integer(x$edge[, 1] - 1L), as.integer(x$edge[, 2] - 1L),
            as.double(x$edge.length), as.integer(Nedge(x)),
            double(nm * nm), NAOK = TRUE)[[7]]
    dim(d) <- c(nm, nm)
    dimnames(d) <- list(1:nm, 1:nm)
    d
}

cophenetic.phylo <- function(x)
{
    n <- length(x$tip.label)
    ans <- dist.nodes(x)[1:n, 1:n]
    dimnames(ans)[1:2] <- list(x$tip.label)
    ans
}

## scales.R (2014-08-21)

##   Add a Scale Bar or Axis to a Phylogeny Plot

## add.scale.bar: add a scale bar to a phylogeny plot
## axisPhylo: add a scale axis on the side of a phylogeny plot

## Copyright 2002-2014 Emmanuel Paradis

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

add.scale.bar <- function(x, y, length = NULL, ask = FALSE,
                          lwd = 1, lcol = "black", ...)
{
    lastPP <- get("last_plot.phylo", envir = .PlotPhyloEnv)
    direc <- lastPP$direction
    if (is.null(length)) {
        nb.digit <-
          if (direc %in% c("rightwards", "leftwards")) diff(range(lastPP$xx))
          else diff(range(lastPP$yy))
        length <- pretty(c(0, nb.digit) / 6, 1)[2] # by Klaus
    }

    if (ask) {
        cat("\nClick where you want to draw the bar\n")
        x <- unlist(locator(1))
        y <- x[2]
        x <- x[1]
    } else if (missing(x) || missing(y)) {
        if (lastPP$type %in% c("phylogram", "cladogram")) {
            switch(direc,
                   "rightwards" = {
                       x <- 0
                       y <- 1
                   },
                   "leftwards" = {
                       x <- max(lastPP$xx)
                       y <- 1
                   },
                   "upwards" = {
                       x <- max(lastPP$xx)
                       y <- 0
                   },
                   "downwards" = {
                       x <- 1
                       y <- max(lastPP$yy)
                   })
        } else {
            direc <- "rightwards" # just to be sure for below
            x <- lastPP$x.lim[1]
            y <- lastPP$y.lim[1]
        }
    }

    switch(direc,
           "rightwards" = {
               segments(x, y, x + length, y, col = lcol, lwd = lwd)
               text(x + length * 1.1, y, as.character(length), adj = c(0, 0.5), ...)
           },
           "leftwards" = {
               segments(x - length, y, x, y, col = lcol, lwd = lwd)
               text(x - length * 1.1, y, as.character(length), adj = c(1, 0.5), ...)
           },
           "upwards" = {
               segments(x, y, x, y + length, col = lcol, lwd = lwd)
               text(x, y + length * 1.1, as.character(length), adj = c(0, 0.5), srt = 90, ...)
           },
           "downwards" = {
               segments(x, y - length, x, y, col = lcol, lwd = lwd)
               text(x, y - length * 1.1, as.character(length), adj = c(0, 0.5), srt = 270, ...)
           })
}

axisPhylo <- function(side = 1, root.time = NULL, backward = TRUE, ...)
{
    lastPP <- get("last_plot.phylo", envir = .PlotPhyloEnv)
    type <- lastPP$type

    if (type == "unrooted")
        stop("axisPhylo() not available for unrooted plots; try add.scale.bar()")
    if (type == "radial")
        stop("axisPhylo() not meaningful for this type of plot")

    if (is.null(root.time)) root.time <- lastPP$root.time

    if (type %in% c("phylogram", "cladogram")) {
        xscale <-
            if (lastPP$direction %in% c("rightwards", "leftwards")) range(lastPP$xx)
            else range(lastPP$yy)

        tmp <- lastPP$direction %in% c("leftwards", "downwards")

        tscale <- c(0, xscale[2] - xscale[1])
        if (xor(backward, tmp)) tscale <- tscale[2:1]
        if (!is.null(root.time)) {
            tscale <- tscale + root.time
            if (backward) tscale <- tscale - xscale[2]
        }

        ## the linear transformation between the x-scale and the time-scale:
        beta <- diff(xscale) / diff(tscale)
        alpha <- xscale[1] - beta * tscale[1]

        lab <- pretty(tscale)
        x <- beta * lab + alpha
        axis(side = side, at = x, labels = lab, ...)
    } else { # type == "fan"
        n <- lastPP$Ntip
        xx <- lastPP$xx[1:n]; yy <- lastPP$yy[1:n]
        r0 <- max(sqrt(xx^2 + yy^2))
        firstandlast <- c(1, n)
        theta0 <- mean(atan2(yy[firstandlast], xx[firstandlast]))
        x0 <- r0 * cos(theta0); y0 <- r0 * sin(theta0)
        inc <- diff(pretty(c(0, r0))[1:2])
        srt <- 360*theta0/(2*pi)
        coef <- -1
        if (abs(srt) > 90) {
            srt <- srt + 180
            coef <- 1
        }
        len <- 0.025 * r0 # the length of tick marks
        r <- r0
        while (r > 1e-8) {
            x <- r * cos(theta0); y <- r * sin(theta0)
            if (len/r < 1) {
                ra <- sqrt(len^2 + r^2); thetaa <- theta0 + coef * asin(len/r)
                xa <- ra * cos(thetaa); ya <- ra * sin(thetaa)
                segments(xa, ya, x, y)
                text(xa, ya, r0 - r, srt = srt, adj = c(0.5, 1.1), ...)
            }
            r <- r - inc
        }
        segments(x, y, x0, y0)
    }
}

'lmorigin' <- 
function(formula, data=NULL, origin=TRUE, nperm=999, method=NULL, silent=FALSE)
#
# This program computes a multiple linear regression and performs tests 
# of significance of the equation parameters using permutations. 
# 
# origin=TRUE: the regression line can be forced through the origin. Testing 
# the significance in that case requires a special permutation procedure.
#
# Permutation methods: raw data or residuals of full model
#    Default method in regression through the origin: raw data
#    Default method in ordinary multiple regression: residuals of full model
#    - In ordinary multiple regression when m = 1: raw data
#
#         Pierre Legendre, March 2009
{
if(!is.null(method)) method <- match.arg(method, c("raw", "residuals"))
if(is.null(method) & origin==TRUE) method <- "raw"
if(is.null(method) & origin==FALSE) method <- "residuals"
if(nperm < 0) stop("Incorrect value for 'nperm'")
	
## From the formula, find the variables and the number of observations 'n'
toto <- lm(formula, data)
mf <- match.call(expand.dots = FALSE)
m <- match(c("formula", "data", "offset"), names(mf), 0)
mf <- mf[c(1, m)]
mf$drop.unused.levels <- TRUE
mf[[1]] <- as.name("model.frame")
mf <- eval(mf, parent.frame())
var.names = colnames(mf)   # Noms des variables
y <- as.matrix(mf[,1])
colnames(y) <- var.names[1]
X <- as.matrix(mf[,-1])
n <- nrow(mf)
m <- ncol(X)

a <- system.time({
mm<- m           # No. regression coefficients, possibly including the intercept
if(m == 1) method <- "raw"
if(nrow(X) != n) stop("Unequal number of rows in y and X")

if(origin) {
	if(!silent) cat("Regression through the origin",'\n')
	reg <- lm(y ~ 0 + X)
	} else {
	if(!silent) cat("Multiple regression with estimation of intercept",'\n')
	reg <- lm(y ~ X)	
	mm <- mm+1
	}

if(!silent) {
	if(nperm > 0) {
		if(method == "raw") {
			cat("Permutation method =",method,"data",'\n')
			} else {
			cat("Permutation method =",method,"of full model",'\n')
			}
		}
	}
t.vec      <- summary(reg)$coefficients[,3]
p.param.t  <- summary(reg)$coefficients[,4]
df1        <- summary(reg)$fstatistic[[2]]
df2        <- summary(reg)$fstatistic[[3]]
F          <- summary(reg)$fstatistic[[1]]
y.res      <- summary(reg)$residuals
# b.vec      <- summary(reg)$coefficients[,1]
# r.sq       <- summary(reg)$r.squared
# adj.r.sq   <- summary(reg)$adj.r.squared
# p.param.F  <- pf(F, df1, df2, lower.tail=FALSE)

if(df1 < m) stop("\nCollinearity among the X variables. Check using 'lm'")

# Permutation tests
if(nperm > 0) {

	nGT.F  <- 1
	nGT1.t <- rep(1,mm)
	nGT2.t <- rep(1,mm)
	sign.t <- sign(t.vec)

	for(i in 1:nperm)  # Permute raw data. Always use this method for F-test
		{
		if(origin) {   # Regression through the origin
			dia.bin <- diag((rbinom(n,1,0.5)*2)-1)
			y.perm <- dia.bin %*% sample(y)
			reg.perm <- lm(y.perm ~ 0 + X)
			} else {   # Multiple linear regression
			y.perm <- sample(y,n)
			reg.perm <- lm(y.perm ~ X)
			}
	
		# Permutation test of the F-statistic
		F.perm <- summary(reg.perm)$fstatistic[1]
		if(F.perm >= F) nGT.F <- nGT.F+1

		# Permutation tests of the t-statistics: permute raw data
		if(method == "raw") {
			t.perm <- summary(reg.perm)$coefficients[,3]
			if(nperm <= 5) cat(t.perm,'\n')
			for(j in 1:mm) {
				# One-tailed test in direction of sign
				if(t.perm[j]*sign.t[j] >= t.vec[j]*sign.t[j]) nGT1.t[j] <- nGT1.t[j]+1
				# Two-tailed test
				if( abs(t.perm[j]) >= abs(t.vec[j]) ) nGT2.t[j] <- nGT2.t[j]+1
				}
			}
		}
		
	if(method == "residuals") {
	# Permute residuals of full model
		for(i in 1:nperm) {
			if(origin) {   # Regression through the origin
				dia.bin <- diag((rbinom(n,1,0.5)*2)-1)
				y.perm <- dia.bin %*% sample(y.res)
				reg.perm <- lm(y.perm ~ 0 + X)
				} else {   # Multiple linear regression
				y.perm <- sample(y.res,n)
				reg.perm <- lm(y.perm ~ X)
				}
	
			# Permutation tests of the t-statistics: permute residuals
			t.perm <- summary(reg.perm)$coefficients[,3]
			if(nperm <= 5) cat(t.perm,'\n')
			for(j in 1:mm) {
				# One-tailed test in direction of sign
				if(t.perm[j]*sign.t[j] >= t.vec[j]*sign.t[j]) nGT1.t[j] <- nGT1.t[j]+1
				# Two-tailed test
				if( abs(t.perm[j]) >= abs(t.vec[j]) ) nGT2.t[j] <- nGT2.t[j]+1
				}
			}
		}
	# Compute the permutational probabilities
	p.perm.F <- nGT.F/(nperm+1)
	p.perm.t1 <- nGT1.t/(nperm+1)
	p.perm.t2 <- nGT2.t/(nperm+1)

	### Do not test intercept by permutation of residuals in multiple regression
	if(!origin & method=="residuals") {
		if(silent) {   # Note: silent==TRUE in simulation programs
			p.perm.t1[1] <- p.perm.t2[1] <- 1
			} else {
			p.perm.t1[1] <- p.perm.t2[1] <- NA
			}
		}
	}

})
a[3] <- sprintf("%2f",a[3])
if(!silent) cat("Computation time =",a[3]," sec",'\n')
#
if(nperm == 0) {

	out <- list(reg=reg, p.param.t.2tail=p.param.t, p.param.t.1tail=p.param.t/2, origin=origin, nperm=nperm, var.names=var.names, call=match.call())

	} else {

	out <- list(reg=reg, p.param.t.2tail=p.param.t, p.param.t.1tail=p.param.t/2, p.perm.t.2tail=p.perm.t2, p.perm.t.1tail=p.perm.t1, p.perm.F=p.perm.F, origin=origin, nperm=nperm, method=method, var.names=var.names, call=match.call())

	}
#
class(out) <- "lmorigin"
out
}

## read.caic.R (2005-09-21)

##   Read Tree File in CAIC Format

## Copyright 2005 Julien Dutheil

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

read.caic <- function(file, brlen=NULL, skip = 0, comment.char="#", ...)
{
  text <- scan(file = file, what = character(), sep="\n", skip = skip, comment.char = comment.char, ...)

	# Parse the whole file:
  n <- length(text) / 2
  nodes <- 1:n;
	leaf.names <- character(n)
	patterns   <- character(n)
	lengths    <- numeric(n)
	for(i in 1:n)
	{
		leaf.names[i] <- text[2*i]
		patterns[i]   <- text[2*i-1]
		lengths[i]    <- nchar(patterns[i])
	}
	# Sort all patterns if not done:
	i <- order(patterns);
	leaf.names <- leaf.names[i]
	patterns   <- patterns[i]
	lengths    <- lengths[i]

	# This inner function compares two patterns:
	test.patterns <- function(p1, p2)
	{
		t1 <- strsplit(p1, split="")[[1]]
		t2 <- strsplit(p2, split="")[[1]]
		if(length(t1) == length(t2))
		{
			l <- length(t1)
			if(l==1) return(TRUE)
			return(all(t1[1:(l-1)]==t2[1:(l-1)]) & t1[l] != t2[l])
		}
		return(FALSE)
	}

	# The main loop:
	while(length(nodes) > 1)
	{
		# Recompute indexes:
		index <- logical(length(nodes))
		maxi  <- max(lengths)
		for(i in 1:length(nodes))
		{
			index[i] <- lengths[i] == maxi
		}
		i <- 1
		while(i <= length(nodes))
		{
			if(index[i])
			{
				p <- paste("(",nodes[i],sep="")
				c <- i+1
				while(c <= length(nodes) && index[c] && test.patterns(patterns[i], patterns[c]))
				{
					p <- paste(p, nodes[c], sep=",")
					c <- c+1
				}
				if(c-i < 2) stop("Unvalid format.")
				p <- paste(p, ")", sep="")
				nodes[i]   <- p
				patterns[i]<- substr(patterns[i],1,nchar(patterns[i])-1)
				lengths[i] <- lengths[i]-1
				nodes      <- nodes   [-((i+1):(c-1))]
				lengths    <- lengths [-((i+1):(c-1))]
				patterns   <- patterns[-((i+1):(c-1))]
				index      <- index   [-((i+1):(c-1))]
			}
			i <- i+1
		}
	}

	# Create a 'phylo' object and return it:
	phy <- read.tree(text=paste(nodes[1],";", sep=""))
	phy$tip.label <- leaf.names;
	if(!is.null(brlen))
	{
		br <- read.table(file=brlen)
		phy$edge.length <- br[,1]
	}
	return(phy)
}

## read.nexus.R (2017-07-28)

##   Read Tree File in Nexus Format

## Copyright 2003-2017 Emmanuel Paradis and 2010-2017 Klaus Schliep

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

.treeBuildWithTokens <- function(x)
{
    phy <- .Call(treeBuildWithTokens, x)
    dim(phy[[1]]) <- c(length(phy[[1]])/2, 2)
    nms <- c("edge", "edge.length", "Nnode", "node.label", "root.edge")
    if (length(phy) == 4) nms <- nms[-5]
    names(phy) <- nms
    if (all(phy$node.label == "")) phy$node.label <- NULL
    class(phy) <- "phylo"
    attr(phy, "order") <- "cladewise"
    phy
}

## for read.nexus clado with TRANSLATION
.cladoBuildWithTokens <- function(x)
{
    phy <- .Call(cladoBuildWithTokens, x)
    dim(phy[[1]]) <- c(length(phy[[1]])/2, 2)
    nms <- c("edge", "Nnode", "node.label", "root.edge")
    if (length(phy) == 3) nms <- nms[-4]
    names(phy) <- nms
    if (all(phy$node.label == "")) phy$node.label <- NULL
    class(phy) <- "phylo"
    attr(phy, "order") <- "cladewise"
    phy
}

.treeBuild <- function(x)
{
    if (!length(grep(",", x))) {
        phy <- list(edge = matrix(c(2L, 1L), 1, 2), Nnode = 1L)
        x <- unlist(strsplit(x, "[\\(\\):;]"))
        phy$tip.label <- x[2]
        phy$edge.length <- as.numeric(x[3])
        phy$node.label <- x[4]
    } else {
        phy <- .Call(treeBuild, x)
        dim(phy[[1]]) <- c(length(phy[[1]])/2, 2)
        nms <- c("edge", "edge.length", "Nnode", "node.label", "tip.label", "root.edge")
        if (length(phy) == 5) nms <- nms[-6]
        names(phy) <- nms
    }
    if (all(phy$node.label == "")) phy$node.label <- NULL
    class(phy) <- "phylo"
    attr(phy, "order") <- "cladewise"
    phy
}

.cladoBuild <- function(x)
{
    if (!length(grep(",", x))) {
        phy <- list(edge = matrix(c(2L, 1L), 1, 2), Nnode = 1L)
        x <- unlist(strsplit(x, "[\\(\\);]"))
        phy$tip.label <- x[2]
        phy$node.label <- x[3]
    } else {
        phy <- .Call(cladoBuild, x)
        dim(phy[[1]]) <- c(length(phy[[1]])/2, 2)
        nms <- c("edge", "Nnode", "node.label", "tip.label", "root.edge")
        if (length(phy) == 4) nms <- nms[-5]
        names(phy) <- nms
    }
    if (all(phy$node.label == "")) phy$node.label <- NULL
    class(phy) <- "phylo"
    attr(phy, "order") <- "cladewise"
    phy
}

##clado.build <- function(tp)
##{
##    add.internal <- function() {
##        edge[j, 1L] <<- current.node
##        node <<- node + 1L
##        edge[j, 2L] <<- current.node <<- node
##        index[node] <<- j # set index
##        j <<- j + 1L
##    }
##    add.terminal <- function() {
##        edge[j, 1L] <<- current.node
##        edge[j, 2L] <<- tip
##        index[tip] <<- j # set index
##        tip.label[tip] <<- tpc[k]
##        k <<- k + 1L
##        tip <<- tip + 1L
##        j <<- j + 1L
##    }
##    go.down <- function() {
##        l <- index[current.node]
##        node.label[current.node - nb.tip] <<- tpc[k]
##        k <<- k + 1L
##        current.node <<- edge[l, 1L]
##    }
##    if (!length(grep(",", tp))) {
##        obj <- list(edge = matrix(c(2L, 1L), 1L, 2L), Nnode = 1L)
##        tp <- unlist(strsplit(tp, "[\\(\\);]"))
##        obj$tip.label <- tp[2]
##        if (tp[3] != "") obj$node.label <- tp[3]
##        class(obj) <- "phylo"
##        return(obj)
##    }
##    tsp <- unlist(strsplit(tp, NULL))
##    tp <- gsub(")", ")NA", tp)
##    tp <- gsub(" ", "", tp)
##    tpc <- unlist(strsplit(tp, "[\\(\\),;]"))
##    tpc <- tpc[tpc != ""]
##    skeleton <- tsp[tsp == "(" | tsp == ")" | tsp == "," | tsp == ";"]
##    nsk <- length(skeleton)
##    nb.node <- length(skeleton[skeleton == ")"])
##    nb.tip <- length(skeleton[skeleton == ","]) + 1L
##    ## We will assume there is an edge at the root;
##    ## if so, it will be removed and put in a vector
##    nb.edge <- nb.node + nb.tip
##    node.label <- character(nb.node)
##    tip.label <- character(nb.tip)
##
##    edge <- matrix(NA_integer_, nb.edge, 2L)
##    current.node <- node <- nb.tip + 1L # node number
##    edge[nb.edge, 1L] <- 0L   # see comment above
##    edge[nb.edge, 2L] <- node #
##
##    index <- numeric(nb.edge + 1L)
##    index[node] <- nb.edge
##    ## j: index of the line number of edge
##    ## k: index of the line number of tpc
##    ## tip: tip number
##    j <- k <- tip <- 1L
##    for (i in 2:nsk) {
##        if (skeleton[i] == "(") add.internal()      # add an internal branch (on top)
##        if (skeleton[i] == ",") {
##            if (skeleton[i - 1] != ")") add.terminal()   # add a terminal branch
##        }
##        if (skeleton[i] == ")") {
##            if (skeleton[i - 1] == ",") {   # add a terminal branch and go down one level
##                add.terminal()
##                go.down()
##            }
##            ## added by Klaus to allow singleton nodes (2017-05-26):
##            if (skeleton[i - 1] == "(") {
##                add.terminal()
##                go.down()
##            }
##            ## end
##            if (skeleton[i - 1] == ")") go.down()   # go down one level
##        }
##    }
##    edge <- edge[-nb.edge, ]
##    obj <- list(edge = edge, tip.label = tip.label,
##                Nnode = nb.node, node.label = node.label)
##    obj$node.label <-
##        if (all(obj$node.label == "NA", na.rm = TRUE)) NULL
##        else gsub("^NA", "", obj$node.label)
##    class(obj) <- "phylo"
##    attr(obj, "order") <- "cladewise"
##    obj
##}

read.nexus <- function(file, tree.names = NULL, force.multi = FALSE)
{
    X <- scan(file = file, what = "", sep = "\n", quiet = TRUE)
    ## remove all comments
    ## (this might not work if there are square brackets within the comments)
    LEFT <- grep("\\[", X)
    RIGHT <- grep("\\]", X)
    if (length(LEFT)) { # in case there are no comments at all
        w <- LEFT == RIGHT
        if (any(w)) { # in case all comments use at least 2 lines
            s <- LEFT[w]
            X[s] <- gsub("\\[[^]]*\\]", "", X[s])
            ## The above regexp was quite tough to find: it makes
            ## possible to delete series of comments on the same line:
            ##       ...[...]xxx[...]...
            ## without deleting the "xxx". This regexp is in three parts:
            ##       \\[      [^]]*       \\]
            ## where [^]]* means "any character, except "]", repeated zero
            ## or more times" (note that the ']' is not escaped here).
            ## The previous version was:
            ##       X[s] <- gsub("\\[.*\\]", "", X[s])
            ## which deleted the "xxx". (EP  2008-06-24)
        }
        w <- !w
        if (any(w)) {
            s <- LEFT[w]
            X[s] <- gsub("\\[.*", "", X[s])
            sb <- RIGHT[w]
            X[sb] <- gsub(".*\\]", "", X[sb])
            if (any(s < sb - 1))
                X <- X[-unlist(mapply(":", (s + 1), (sb - 1)))]
        }
    }
    endblock <- grep("END;|ENDBLOCK;", X, ignore.case = TRUE)
    semico <- grep(";", X)
    i1 <- grep("BEGIN TREES;", X, ignore.case = TRUE)
    i2 <- grep("TRANSLATE", X, ignore.case = TRUE)
    translation <- if (length(i2) == 1 && i2 > i1) TRUE else FALSE
    if (translation) {
        end <- semico[semico > i2][1]
        x <- X[(i2 + 1):end] # assumes there's a 'new line' after "TRANSLATE"
        x <- unlist(strsplit(x, "[,; \t]"))
        x <- x[nzchar(x)]
        TRANS <- matrix(x, ncol = 2, byrow = TRUE)
        TRANS[, 2] <- gsub("['\"]", "", TRANS[, 2])
        n <- dim(TRANS)[1]
    }
    start <-
        if (translation) semico[semico > i2][1] + 1
        else i1 + 1 # semico[semico > i1][1] ## fix done on 2014-08-25
    end <- endblock[endblock > i1][1] - 1
    tree <- X[start:end]
    rm(X)

    ## check whether there are empty lines from the above manips:
    tree <- tree[tree != ""]
    semico <- grep(";", tree)
    Ntree <- length(semico) # provisional -- some ";" may actually mark end of commands
    ## are some trees on several lines?
    ## -- this actually 'packs' all characters ending with a ";" in a single string --
    if (Ntree == 1 && length(tree) > 1) STRING <- paste(tree, collapse = "") else {
        if (any(diff(semico) != 1)) {
            STRING <- character(Ntree)
            s <- c(1, semico[-Ntree] + 1)
            j <- mapply(":", s, semico)
            if (is.list(j)) {
                for (i in 1:Ntree)
                    STRING[i] <- paste(tree[j[[i]]], collapse = "")
            } else {
                for (i in 1:Ntree)
                    STRING[i] <- paste(tree[j[, i]], collapse = "")
            }
        } else STRING <- tree
    }
    rm(tree)
    ## exclude the possible command lines ending with ";":
    STRING <- STRING[grep("^[[:blank:]]*tree.*= *", STRING, ignore.case = TRUE)]
    Ntree <- length(STRING) # update Ntree
    ## get the tree names:
    nms.trees <- sub(" *= *.*", "", STRING) # only the first occurence of "="
    nms.trees <- sub("^[[:blank:]]*tree[[:blank:]\\*]*", "", nms.trees, ignore.case = TRUE) # fix by Graham Gower (2014-10-20)
    STRING <- sub("^.*= *", "", STRING) # delete title and 'TREE' command with 'sub'
    STRING <- gsub(" ", "", STRING) # delete all white spaces
    colon <- grep(":", STRING)
    if (!length(colon)) {
        trees <- lapply(STRING, .cladoBuild)
    } else if (length(colon) == Ntree) {
        trees <-
            if (translation) lapply(STRING, .treeBuildWithTokens)
            else lapply(STRING, .treeBuild)
    } else {
        trees <- vector("list", Ntree)
        trees[colon] <- lapply(STRING[colon], .treeBuild)
        nocolon <- (1:Ntree)[!1:Ntree %in% colon]
        trees[nocolon] <- lapply(STRING[nocolon], .cladoBuild)
        if (translation) {
            for (i in 1:Ntree) {
                tr <- trees[[i]]
                for (j in 1:n) {
                    ind <- which(tr$tip.label[j] == TRANS[, 1])
                    tr$tip.label[j] <- TRANS[ind, 2]
                }
                if (!is.null(tr$node.label)) {
                    for (j in 1:length(tr$node.label)) {
                        ind <- which(tr$node.label[j] == TRANS[, 1])
                        tr$node.label[j] <- TRANS[ind, 2]
                    }
                }
                trees[[i]] <- tr
            }
            translation <- FALSE
        }
    }
    for (i in 1:Ntree) {
        tr <- trees[[i]]
        if (!translation) n <- length(tr$tip.label)
        ## I suppose the following is no more needed (EP 2017-07-28)
        ##ROOT <- n + 1L
        ##if (sum(tr$edge[, 1] == ROOT) == 1 && dim(tr$edge)[1] > 1) {
        ##    stop(paste("The tree has apparently singleton node(s): cannot read tree file.\n  Reading NEXUS file aborted at tree no.", i, sep = ""))
        ##}
    }
    if (Ntree == 1 && !force.multi) {
        trees <- trees[[1]]
        if (translation) {
            trees$tip.label <-
                if (length(colon)) TRANS[, 2] else
                TRANS[, 2][as.numeric(trees$tip.label)]
        }
    } else {
        if (!is.null(tree.names)) names(trees) <- tree.names
        if (translation) {
            if (length(colon) == Ntree) # .treeBuildWithTokens() was used
                attr(trees, "TipLabel") <- TRANS[, 2]
            else { # reassign the tip labels then compress
                for (i in 1:Ntree)
                    trees[[i]]$tip.label <-
                        TRANS[, 2][as.numeric(trees[[i]]$tip.label)]
                trees <- .compressTipLabel(trees)
            }
        }
        class(trees) <- "multiPhylo"
        if (!all(nms.trees == "")) names(trees) <- nms.trees
    }
    trees
}

## gammaStat.R (2009-05-10)

##   Gamma-Statistic of Pybus and Harvey

## Copyright 2002-2009 Emmanuel Paradis

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

gammaStat <- function(phy)
{
    if (!inherits(phy, "phylo")) stop('object "phy" is not of class "phylo"')
    N <- length(phy$tip.label)
    bt <- sort(branching.times(phy))
    g <- rev(c(bt[1], diff(bt))) # internode intervals are from past to present
    ST <- sum((2:N) * g)
    stat <- sum(cumsum((2:(N - 1)) * g[-(N - 1)]))/(N - 2)
    m <- ST/2
    s <- ST * sqrt(1/(12 * (N - 2)))
    (stat - m)/s
}

## summary.phylo.R (2020-07-28)

##   Print Summary of a Phylogeny and "multiPhylo" operators

## Copyright 2003-2020 Emmanuel Paradis, 2006 Ben Bolker, and Klaus Schliep 2016

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

Ntip <- function(phy) UseMethod("Ntip")

Ntip.phylo <- function(phy) length(phy$tip.label)

Ntip.multiPhylo <- function(phy)
{
    labs <- attr(phy, "TipLabel")
    if (is.null(labs)) sapply(unclass(phy), Ntip.phylo)
    else setNames(rep(length(labs), length(phy)), names(phy))
}

Nnode <- function(phy, ...) UseMethod("Nnode")

Nnode.phylo <- function(phy, internal.only = TRUE, ...)
{
    if (internal.only) return(phy$Nnode)
    phy$Nnode + length(phy$tip.label)
}

Nnode.multiPhylo <- function(phy, internal.only = TRUE, ...)
{
    res <- sapply(unclass(phy), "[[", "Nnode")
    if (internal.only) return(res)
    res + Ntip.multiPhylo(phy)
}

Nedge <- function(phy) UseMethod("Nedge")

Nedge.phylo <- function(phy) dim(phy$edge)[1]

Nedge.multiPhylo <- function(phy) sapply(unclass(phy), Nedge.phylo)

summary.phylo <- function(object, ...)
{
    cat("\nPhylogenetic tree:", deparse(substitute(object)), "\n\n")
    nb.tip <- length(object$tip.label)
    nb.node <- object$Nnode
    cat("  Number of tips:", nb.tip, "\n")
    cat("  Number of nodes:", nb.node, "\n")
    if (is.null(object$edge.length))
      cat("  No branch lengths.\n")
    else {
        cat("  Branch lengths:\n")
        cat("    mean:", mean(object$edge.length), "\n")
        cat("    variance:", var(object$edge.length), "\n")
        cat("    distribution summary:\n")
        print(summary(object$edge.length)[-4])
    }
    if (is.null(object$root.edge))
      cat("  No root edge.\n")
    else
      cat("  Root edge:", object$root.edge, "\n")
    if (nb.tip <= 10) {
        cat("  Tip labels:", object$tip.label[1], "\n")
        cat(paste("             ", object$tip.label[-1]), sep = "\n")
    }
    else {
        cat("  First ten tip labels:", object$tip.label[1], "\n")
        cat(paste("                       ", object$tip.label[2:10]), sep = "\n")
    }
    if (is.null(object$node.label))
      cat("  No node labels.\n")
    else {
        if (nb.node <= 10) {
            cat("  Node labels:", object$node.label[1], "\n")
            cat(paste("              ", object$node.label[-1]), sep = "\n")
        }
        else {
            cat("  First ten node labels:", object$node.label[1], "\n")
            cat(paste("                        ", object$node.label[2:10]), sep = "\n")

        }
    }
}

### by BB:
print.phylo <- function(x, printlen = 6,...)
{
    nb.tip <- length(x$tip.label)
    nb.node <- x$Nnode
    cat(paste("\nPhylogenetic tree with", nb.tip, "tips and", nb.node,
              "internal nodes.\n\n"))
    cat("Tip labels:\n")
    if (nb.tip > printlen) {
        cat("  ", paste(x$tip.label[1:printlen], collapse=", "), ", ...\n", sep = "")
    } else {
        cat("  ", paste(x$tip.label, collapse=", "), "\n", sep = "")
    }
    if (!is.null(x$node.label)) {
        cat("Node labels:\n")
        if (nb.node > printlen) {
            cat("  ", paste(x$node.label[1:printlen], collapse=", "), ", ...\n", sep = "")
        } else {
            cat("  ", paste(x$node.label, collapse=", "), "\n", sep = "")
        }
    }
    rlab <- if (is.rooted(x)) "Rooted" else "Unrooted"
    cat("\n", rlab, "; ", sep="")

    blen <- if (is.null(x$edge.length)) "no branch lengths." else
    "includes branch lengths."
    cat(blen, "\n", sep = "")
}

print.multiPhylo <- function(x, details = FALSE, ...)
{
    N <- length(x)
    cat(N, "phylogenetic", ifelse(N > 1, "trees\n", "tree\n"))
    if (details)
      for (i in 1:N)
        cat("tree", i, ":", length(x[[i]]$tip.label), "tips\n")
}

"[[.multiPhylo" <- function(x, i)
{
    class(x) <- NULL
    phy <- x[[i]]
    if (!is.null(attr(x, "TipLabel")))
        phy$tip.label <- attr(x, "TipLabel")
    phy
}

`$.multiPhylo` <- function(x, name) x[[name]]

"[.multiPhylo" <- function(x, i)
{
    oc <- oldClass(x)
    class(x) <- NULL
    structure(x[i], TipLabel = attr(x, "TipLabel"),
              class = oc)
}

str.multiPhylo <- function(object, ...)
{
    class(object) <- NULL
    cat('Class "multiPhylo"\n')
    str(object, ...)
}

.c_phylo_single <- function(phy) structure(list(phy), class = "multiPhylo")

c.phylo <- function(..., recursive = TRUE)
{
    obj <- list(...)
    classes <- lapply(obj, class)
    isphylo <- sapply(classes, function(x) "phylo" %in% x)
    if (all(isphylo)) {
        class(obj) <- "multiPhylo"
        return(obj)
    }
    if (!recursive) return(obj)
    ismulti <- sapply(classes, function(x) "multiPhylo" %in% x)
    if (all(isphylo | ismulti)) {
        for (i in which(isphylo)) obj[[i]] <- .c_phylo_single(obj[[i]])
        ## added by Klaus:
        for (i in which(ismulti)) obj[[i]] <- .uncompressTipLabel(obj[[i]])
        obj <- .makeMultiPhyloFromObj(obj)
    } else {
        warning('some objects not of class "phylo" or "multiPhylo": argument recursive=TRUE ignored')
    }
    obj
}

# this is an option to avoid growing the list, better check it also
# not really as important as long the list of trees is short (by Klaus)
.makeMultiPhyloFromObj <- function(obj)
{
    n <- length(obj)
    N <- lengths(obj, FALSE)
    cs <- c(0, cumsum(N))
    x <- vector("list", cs[length(cs)])
    for (i in 1:n) {
        a <- cs[i] + 1L
        b <- cs[i + 1L]
        x[a:b] <- obj[[i]]
    }
    class(x) <- "multiPhylo"
    x
}
## the original code:
##.makeMultiPhyloFromObj <- function(obj)
##{
##    n <- length(obj)
##    x <- obj[[1L]]
##    N <- length(x)
##    i <- 2L
##    while (i <= n) {
##        a <- N + 1L
##        N <- N + length(obj[[i]])
##        ## x is of class "multiPhylo", so this uses the operator below:
##        x[a:N] <- obj[[i]]
##        i <- i + 1L
##    }
##    x
##}

c.multiPhylo <- function(..., recursive = TRUE)
{
    obj <- list(...)
    if (!recursive) return(obj)
    classes <- lapply(obj, class)
    isphylo <- sapply(classes, function(x) "phylo" %in% x)
    ismulti <- sapply(classes, function(x) "multiPhylo" %in% x)
    if (!all(isphylo | ismulti)) {
        warning('some objects not of class "phylo" or "multiPhylo": argument recursive=TRUE ignored')
        return(obj)
    }
    for (i in which(isphylo)) obj[[i]] <- .c_phylo_single(obj[[i]])
    ## added by Klaus
    for (i in which(ismulti)) obj[[i]] <- .uncompressTipLabel(obj[[i]])
    .makeMultiPhyloFromObj(obj)
}

.uncompressTipLabel <- function(x)
{
    Lab <- attr(x, "TipLabel")
    if (is.null(Lab)) return(x)
    class(x) <- NULL
    for (i in 1:length(x)) x[[i]]$tip.label <- Lab
    class(x) <- "multiPhylo"
    attr(x, "TipLabel") <- NULL
    x
}

`[<-.multiPhylo` <- function(x, ..., value)
{
    ## recycling is allowed so no need to check: length(value) != length(..1)

    ## check that all elements in 'value' inherit class "phylo"
    test <- unlist(lapply(value, function(xx) !inherits(xx, "phylo")))
    if (any(test))
        stop("at least one element in 'value' is not of class \"phylo\".")

    oc <- oldClass(x)
    class(x) <- NULL

    if (is.null(attr(x, "TipLabel"))) {
        x[..1] <- value
        class(x) <- oc
        return(x)
    }

    x[..1] <- 0L # in case x needs to be elongated
    class(x) <- oc
    j <- 1L
    for (i in ..1) {
        ## x is of class "multiPhylo", so this uses the operator below:
        x[[i]] <- value[[j]]
        j <- j + 1L
    }
    x
}

`[[<-.multiPhylo` <- function(x, ..., value)
{
    if (!inherits(value, "phylo"))
        stop('trying to assign an object not of class "phylo" into an object of class "multiPhylo".')

    oc <- oldClass(x)
    class(x) <- NULL

    Lab <- attr(x, "TipLabel")

    if (!is.null(Lab)) {
        n <- length(Lab)
        if (n != length(value$tip.label))
            stop("tree with different number of tips than those in the list (which all have the same labels; maybe you want to uncompress them)")

        o <- match(value$tip.label, Lab)
        if (any(is.na(o)))
            stop("tree tip labels do not match with those in the list; maybe you want to uncompress them.")
        value$tip.label <- NULL
        ie <- match(o, value$edge[, 2])
        value$edge[ie, 2] <- 1:n
    }

    x[[..1]] <- value
    class(x) <- oc
    x
}

`$<-.multiPhylo` <- function(x, ..., value)
{
    x[[..1]] <- value
    x
}

## is.compatible.R (2017-06-03)

##   Check Compatibility of Splits

## Copyright 2011 Andrei-Alin Popescu

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

is.compatible <- function(obj) UseMethod("is.compatible")

is.compatible.bitsplits <- function(obj)
{
    m <- obj$matsplit
    n <- ncol(m)
    ntaxa <- length(obj$labels)
    for (i in 1:(n - 1))
        for (j in (i + 1):n)
            if (!arecompatible(m[, i], m[, j], ntaxa))
                return(FALSE)
    TRUE
}

arecompatible <-function(x, y, n)
{
    msk <- !as.raw(2^(8 - (n %% 8)) - 1)

    foo <- function(v) {
        lv <- length(v)
        v[lv] <- v[lv] & msk
        as.integer(all(v == as.raw(0)))
    }

    nE <- foo(x & y) + foo(x & !y) + foo(!x & y) + foo(!x & !y)
    if (nE >= 1) TRUE else FALSE
}

## is.binary.tree.R (2016-11-03)

##    Test for Binary Tree

## Copyright 2016 Emmanuel Paradis

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

is.binary <- function(phy) UseMethod("is.binary")

is.binary.phylo <- function(phy)
    length(phy$tip.label) - phy$Nnode + is.rooted.phylo(phy) == 2

is.binary.tree <- function(phy)
{
    ##warning("is.binary.tree() is deprecated; using is.binary() instead.\n\nis.binary.tree() will be removed soon: see ?is.binary and update your code.")
    is.binary(phy)
}

is.binary.multiPhylo <- function(phy)
{
    phy <- unclass(phy)
    n <- length(attr(phy, "TipLabel"))
    if (n)
        n - sapply(phy, "[[", "Nnode") + is.rooted.multiPhylo(phy) == 2
    else
        sapply(phy, is.binary.phylo)
}

## write.tree.R (2019-03-01)

##   Write Tree File in Parenthetic Format

## Copyright 2002-2019 Emmanuel Paradis, Daniel Lawson, and Klaus Schliep

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

checkLabel <- function(x)
{
    ## delete all leading and trailing spaces and tabs, and
    ## the leading left and trailing right parentheses:
    ## (the syntax will work with any mix of these characters,
    ##  e.g., "    ( ( ((  " will correctly be deleted)
    x <- gsub("^[[:space:]\\(]+", "", x)
    x <- gsub("[[:space:]\\)]+$", "", x)
    ## replace all spaces and tabs by underscores:
    x <- gsub("[[:space:]]", "_", x)
    ## replace commas, colons, and semicolons with dashes:
    x <- gsub("[,:;]", "-", x)
    ## replace left and right parentheses with dashes:
    x <- gsub("[\\(\\)]", "-", x)
    x
}

write.tree <-
    function(phy, file = "", append = FALSE, digits = 10, tree.names = FALSE)
{
    if (!(inherits(phy, c("phylo", "multiPhylo"))))
        stop("object \"phy\" has no trees")

    if (inherits(phy, "phylo")) phy <- c(phy)
    N <- length(phy)
    res <- character(N)

    if (is.logical(tree.names)) {
        if (tree.names) {
            tree.names <-
                if (is.null(names(phy))) character(N)
                else names(phy)
        } else tree.names <- character(N)
    }

    ## added by KS (2019-03-01):
    check_tips <- TRUE
    if (inherits(phy, "multiPhylo")) {
        if (!is.null(attr(phy, "TipLabel"))) {
            attr(phy, "TipLabel") <- checkLabel(attr(phy, "TipLabel"))
            check_tips <- FALSE
        }
    }

    ## added by EP (2019-01-23):
    phy <- .uncompressTipLabel(phy)
    class(phy) <- NULL

    for (i in 1:N)
        res[i] <- .write.tree2(phy[[i]], digits = digits,
                               tree.prefix = tree.names[i], check_tips)

    if (file == "") return(res)
    else cat(res, file = file, append = append, sep = "\n")
}

.write.tree2 <- function(phy, digits = 10, tree.prefix = "", check_tips)
{
    brl <- !is.null(phy$edge.length)
    nodelab <- !is.null(phy$node.label)
    if (check_tips) phy$tip.label <- checkLabel(phy$tip.label)
    if (nodelab) phy$node.label <- checkLabel(phy$node.label)
    f.d <- paste("%.", digits, "g", sep = "")
    cp <- function(x){
        STRING[k] <<- x
        k <<- k + 1
    }
    add.internal <- function(i) {
        cp("(")
        desc <- kids[[i]]
        for (j in desc) {
            if (j > n) add.internal(j)
            else add.terminal(ind[j])
            if (j != desc[length(desc)]) cp(",")
        }
        cp(")")
        if (nodelab && i > n) cp(phy$node.label[i - n]) # fixed by Naim Matasci (2010-12-07)
        if (brl) {
            cp(":")
            cp(sprintf(f.d, phy$edge.length[ind[i]]))
        }
    }
    add.terminal <- function(i) {
        cp(phy$tip.label[phy$edge[i, 2]])
        if (brl) {
            cp(":")
            cp(sprintf(f.d, phy$edge.length[i]))
        }
    }

    n <- length(phy$tip.label)

    ## borrowed from phangorn:
    parent <- phy$edge[, 1]
    children <- phy$edge[, 2]
    kids <- vector("list", n + phy$Nnode)
    for (i in 1:length(parent))
        kids[[parent[i]]] <- c(kids[[parent[i]]], children[i])

    ind <- match(1:max(phy$edge), phy$edge[, 2])

    LS <- 4*n + 5
    if (brl) LS <- LS + 4*n
    if (nodelab)  LS <- LS + n
    STRING <- character(LS)
    k <- 1
    cp(tree.prefix)
    cp("(")
    getRoot <- function(phy)
        phy$edge[, 1][!match(phy$edge[, 1], phy$edge[, 2], 0)][1]
    root <- getRoot(phy) # replaced n+1 with root - root has not be n+1
    desc <- kids[[root]]
    for (j in desc) {
        if (j > n) add.internal(j)
        else add.terminal(ind[j])
        if (j != desc[length(desc)]) cp(",")
    }

    if (is.null(phy$root.edge)) {
        cp(")")
        if (nodelab) cp(phy$node.label[1])
        cp(";")
    }
    else {
        cp(")")
        if (nodelab) cp(phy$node.label[1])
        cp(":")
        cp(sprintf(f.d, phy$root.edge))
        cp(";")
    }
    paste(STRING, collapse = "")
}

## mvr.R (2012-03-30)

##   Minimum Variance Reduction

## Copyright 2011 Andrei-Alin Popescu

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

mvr <- function(X, V)
{
    if (is.matrix(X)) X <- as.dist(X)
    if (is.matrix(V)) V <- as.dist(V)
    if (any(is.na(X)))
        stop("missing values are not allowed in the distance matrix")
    if (any(is.na(V)))
        stop("missing values are not allowed in the variance matrix")
    N <- attr(X, "Size")
    labels <- attr(X, "Labels")
    if (is.null(labels)) labels <- as.character(1:N)
    ans <- .C(C_mvr, as.double(X), as.double(V), as.integer(N),
              integer(2*N - 3), integer(2*N - 3), double(2*N - 3),
              NAOK = TRUE)
    obj <- list(edge = cbind(ans[[4]], ans[[5]]), edge.length = ans[[6]],
                tip.label = labels, Nnode = N - 2L)
    class(obj) <- "phylo"
    reorder(obj)
}

mvrs <- function(X, V, fs = 15)
{
    if (fs < 1)
        stop("argument 'fs' must be a non-zero positive integer")

    if (is.matrix(X)) X <- as.dist(X)
    if (is.matrix(V)) V <- as.dist(V)

    X[is.na(X)] <- -1
    X[X < 0] <- -1
    X[is.nan(X)] <- -1

    N <- attr(X, "Size")
    labels <- attr(X, "Labels")
    if (is.null(labels)) labels <- as.character(1:N)
    ans <- .C(C_mvrs, as.double(X), as.double(V), as.integer(N),
              integer(2*N - 3), integer(2*N - 3), double(2*N - 3),
              as.integer(fs), NAOK = TRUE)
    obj <- list(edge = cbind(ans[[4]], ans[[5]]), edge.length = ans[[6]],
                tip.label = labels, Nnode = N - 2L)
    class(obj) <- "phylo"
    reorder(obj)
}

## bind.tree.R (2018-01-26)

##    Bind Trees

## Copyright 2003-2018 Emmanuel Paradis

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

`+.phylo` <- function(x, y)
{
    p <- if (is.null(x$root.edge)) 0 else x$root.edge
    bind.tree(x, y, position = p)
}

bind.tree <- function(x, y, where = "root", position = 0, interactive = FALSE)
{
    nx <- length(x$tip.label)
    mx <- x$Nnode
    ROOTx <- nx + 1L
    ny <- length(y$tip.label)
    my <- y$Nnode

    if (interactive) {
        lastPP <- get("last_plot.phylo", envir = .PlotPhyloEnv)
        if (lastPP$type != "phylogram" || lastPP$direction != "rightwards")
            stop("you must plot tree 'x' as a 'rightward phylogram'")
        cat("Click where you want to graft tree 'y'...\n")
        xy <- locator(1)
        d <- abs(xy$y - lastPP$yy)
        d[lastPP$xx - xy$x < 0] <- Inf
        where <- which.min(d)
        position <- lastPP$xx[where] - xy$x
        if (position < 0) position <- 0
        cat("The following parameters are used:\n")
        cat("  where =", where, " position =", position, "\n")
    } else {
        if (where == 0 || where == "root") where <- ROOTx
        if (position < 0) position <- 0
        if (where > nx + mx)
            stop("argument 'where' out of range for tree 'x'")
    }

    ## check whether both trees have branch lengths:
    switch(is.null(x$edge.length) + is.null(y$edge.length) + 1L,
           wbl <- TRUE, {
               x$edge.length <- y$edge.length <- NULL
               wbl <- FALSE
               warning("one tree has no branch lengths, they have been ignored")
           },
           wbl <- FALSE)

    yHasNoRootEdge <- is.null(y$root.edge)
    xHasNoRootEdge <- is.null(x$root.edge)

    x <- reorder(x) # fix by Veronika Boskova
    y <- reorder(y)

    ## find the row of 'where' before renumbering
    if (where == ROOTx) case <- 1 else {
        i <- which(x$edge[, 2] == where)
        case <- if (where <= nx) 2 else 3
    }
    ## case = 1 -> y is bound on the root of x
    ## case = 2 -> y is bound on a tip of x
    ## case = 3 -> y is bound on a node of x

    ## check that 'position' is correct
    if (position && wbl) {
### New in ape 3.0-1: this makes possible binding 'y' below
### a node of 'x' thus creating a new node in 'x'
###        if (!wbl)
###            stop("'position' is non-null but trees have no branch lengths")
        if (case == 1) {
            if (xHasNoRootEdge)
                stop("tree 'x' has no root edge")
            if (position > x$root.edge)
                stop("'position' is larger than x's root edge")
        } else {
            if (x$edge.length[i] < position)
                stop("'position' is larger than the branch length")
        }
    }

    ## the special case of substituting two tips:
    if (case == 2 && ny == 1 && !position) {
        x$tip.label[x$edge[i, 2]] <- y$tip.label
        if (wbl)
            x$edge.length[i] <- x$edge.length[i] + y$edge.length
        return(x)
    }

### because in all situations internal nodes need to be
### renumbered, they are changed to negatives first, and
### nodes eventually added will be numbered sequentially

    nodes <- x$edge > nx
    x$edge[nodes] <- -(x$edge[nodes] - nx) # -1, ..., -mx
    nodes <- y$edge > ny
    y$edge[nodes] <- -(y$edge[nodes] - ny + mx) # -(mx+1), ..., -(mx+my)
    ROOT <- -1L # may change later
    next.node <- -(mx + my) - 1L

    ## renumber now the tips in y:
    new.nx <- if (where <= nx && !position) nx - 1L else nx
    y$edge[!nodes] <- y$edge[!nodes] + new.nx

    ## if 'y' as a root edge, use it:
    if (!yHasNoRootEdge) {
        y$edge <- rbind(c(0, y$edge[1]), y$edge)
        ##                ^ will be filled later
        next.node <- next.node - 1L
        if (wbl) y$edge.length <- c(y$root.edge, y$edge.length)
    }

    switch(case, { # case = 1
        if (position) {
            x$root.edge <- x$root.edge - position
            x$edge <- rbind(c(next.node, x$edge[1]), x$edge)
            ROOT <- next.node
            if (wbl) x$edge.length <- c(position, x$edge.length)
        }
        if (yHasNoRootEdge) {
            j <- which(y$edge[, 1] == y$edge[1])
            y$edge[j, 1] <- ROOT
        } else y$edge[1] <- ROOT
        x$edge <- rbind(x$edge, y$edge)
        if (wbl)
            x$edge.length <- c(x$edge.length, y$edge.length)
    }, { # case = 2
        if (position) {
            x$edge[i, 2] <- next.node
            x$edge <- rbind(x$edge[1:i, ], c(next.node, where), x$edge[-(1:i), ])
            if (wbl) {
                x$edge.length[i] <- x$edge.length[i] - position
                x$edge.length <- c(x$edge.length[1:i], position, x$edge.length[-(1:i)])
            }
            i <- i + 1L
            if (yHasNoRootEdge) {
                j <- which(y$edge[, 1] == y$edge[1])
                y$edge[j, 1] <- x$edge[i, 1]
            } else y$edge[1] <- x$edge[i, 1]
        } else {
            if (yHasNoRootEdge) x$edge[i, 2] <- y$edge[1]
            else {
                ## the root edge of y is fused with the terminal edge of x
                if (wbl) y$edge.length[1] <- y$edge.length[1] + x$edge.length[i]
                y$edge[1] <- x$edge[i, 1]
                ## delete i-th edge in x:
                x$edge <- x$edge[-i, ]
                if (wbl) x$edge.length <- x$edge.length[-i]
                i <- i - 1L
            }
            x$tip.label <- x$tip.label[-where]
            ## renumber the tips that need to:
            ii <- which(x$edge[, 2] > where & x$edge[, 2] <= nx)
            x$edge[ii, 2] <- x$edge[ii, 2] - 1L
        }
        x$edge <- rbind(x$edge[1:i, ], y$edge, x$edge[-(1:i), ])
        if (wbl)
            x$edge.length <- c(x$edge.length[1:i], y$edge.length, x$edge.length[-(1:i)])
    }, { # case = 3
        if (position) {
            if (yHasNoRootEdge) {
                j <- which(y$edge[, 1] == y$edge[1])
                y$edge[j, 1] <- next.node
            } else y$edge[1] <- next.node
            x$edge <- rbind(x$edge[1:i, ], c(next.node, x$edge[i, 2]), x$edge[-(1:i), ])
            x$edge[i, 2] <- next.node
            if (wbl) {
                x$edge.length[i] <- x$edge.length[i] - position
                x$edge.length <- c(x$edge.length[1:i], position, x$edge.length[-(1:i)])
            }
            i <- i + 1L
        } else {
            if (yHasNoRootEdge) {
                j <- which(y$edge[, 1] == y$edge[1])
                y$edge[j, 1] <- x$edge[i, 2]
            } else y$edge[1] <- x$edge[i, 2]
        }
        x$edge <- rbind(x$edge[1:i, ], y$edge, x$edge[-(1:i), ])
        if (wbl)
            x$edge.length <- c(x$edge.length[1:i], y$edge.length, x$edge.length[-(1:i)])
    })

    x$tip.label <- c(x$tip.label, y$tip.label)

    if (is.null(x$node.label)) {
        if (!is.null(y$node.label))
            x$node.label <- c(rep(NA, mx), y$node.label)
    } else {
        x$node.label <-
            if (is.null(y$node.label)) c(x$node.label, rep(NA, my))
            else c(x$node.label, y$node.label)
    }

    n <- length(x$tip.label)
    x$Nnode <- dim(x$edge)[1] + 1L - n

    ## update the node labels before renumbering (this adds NA for
    ## the added nodes, and drops the label for those deleted)
    if (!is.null(x$node.label))
        x$node.label <- x$node.label[sort(-unique(x$edge[, 1]))]

    ## renumber nodes:
    newNb <- integer(x$Nnode)
    newNb[-ROOT] <- n + 1L
    sndcol <- x$edge[, 2] < 0
    ## executed from right to left, so newNb is modified before x$edge:
    x$edge[sndcol, 2] <- newNb[-x$edge[sndcol, 2]] <- n + 2:x$Nnode
    x$edge[, 1] <- newNb[-x$edge[, 1]]

    if (!is.null(x$node.label))
        x$node.label <- x$node.label[order(newNb[newNb > 0])]

    x
}

## MoranI.R (2008-01-14)

##   Moran's I Autocorrelation Index

## Copyright 2004 Julien Dutheil, 2007-2008 Emmanuel Paradis

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

## code cleaned-up by EP (Dec. 2007)

Moran.I <- function(x, weight, scaled = FALSE, na.rm = FALSE,
                    alternative = "two.sided")
{
    if(dim(weight)[1] != dim(weight)[2])
        stop("'weight' must be a square matrix")
    n <- length(x)
    if(dim(weight)[1] != n)
        stop("'weight' must have as many rows as observations in 'x'")
    ## Expected mean:
    ei <- -1/(n - 1)

    nas <- is.na(x)
    if (any(nas)) {
        if (na.rm) {
            x <- x[!nas]
            n <- length(x)
            weight <- weight[!nas, !nas]
        } else {
            warning("'x' has missing values: maybe you wanted to set na.rm = TRUE?")
            return(list(observed = NA, expected = ei, sd = NA, p.value = NA))
        }
    }

    ## normalizing the weights:
    ## Note that we normalize after possibly removing the
    ## missing data.
    ROWSUM <- rowSums(weight)
    ## the following is useful if an observation has no "neighbour":
    ROWSUM[ROWSUM == 0] <- 1
    weight <- weight/ROWSUM # ROWSUM is properly recycled

    s <- sum(weight)
    m <- mean(x)
    y <- x - m # centre the x's
    cv <- sum(weight * y %o% y)
    v <- sum(y^2)
    obs <- (n/s) * (cv/v)
    ## Scaling:
    if (scaled) {
        i.max <- (n/s) * (sd(rowSums(weight) * y)/sqrt(v/(n - 1)))
        obs <- obs/i.max
    }
    ## Expected sd:
    S1 <- 0.5 * sum((weight + t(weight))^2)
    S2 <- sum((apply(weight, 1, sum) + apply(weight, 2, sum))^2)
    ## the above is the same than:
    ##S2 <- 0
    ##for (i in 1:n)
    ##    S2 <- S2 + (sum(weight[i, ]) + sum(weight[, i]))^2

    s.sq <- s^2
    k <- (sum(y^4)/n) / (v/n)^2
    sdi <- sqrt((n*((n^2 - 3*n + 3)*S1 - n*S2 + 3*s.sq) -
                 k*(n*(n - 1)*S1 - 2*n*S2 + 6*s.sq))/
                ((n - 1)*(n - 2)*(n - 3)*s.sq) - 1/((n - 1)^2))

    alternative <- match.arg(alternative, c("two.sided", "less", "greater"))
    pv <- pnorm(obs, mean = ei, sd = sdi)
    if (alternative == "two.sided")
        pv <- if (obs <= ei) 2*pv else 2*(1 - pv)
    if (alternative == "greater") pv <- 1 - pv
    list(observed = obs, expected = ei, sd = sdi, p.value = pv)
}

weight.taxo <- function(x)
{
    d <- outer(x, x, "==")
    diag(d) <- 0 # implicitly converts 'd' into numeric
    d
}

weight.taxo2 <- function(x, y)
{
    d <- outer(x, x, "==") & outer(y, y, "!=")
    diag(d) <- 0
    d
}

correlogram.formula <- function(formula, data = NULL, use = "all.obs")
{
    err <- 'formula must be of the form "y1+...+yn ~ x1/x2/../xn"'
    use <- match.arg(use, c("all.obs", "complete.obs", "pairwise.complete.obs"))
    if (formula[[1]] != "~") stop(err)

    lhs <- formula[[2]]
    y.nms <- if (length(lhs) > 1)
        unlist(strsplit(as.character(as.expression(lhs)), " \\+ "))
    else as.character(as.expression(lhs))

    rhs <- formula[[3]]
    gr.nms <- if (length(rhs) > 1)
        rev(unlist(strsplit(as.character(as.expression(rhs)), "/")))
    else as.character(as.expression(rhs))

    if (is.null(data)) {
        ## we 'get' the variables in the .GlobalEnv:
        y <- as.data.frame(sapply(y.nms, get))
        gr <- as.data.frame(sapply(gr.nms, get))
    } else {
        y <- data[y.nms]
        gr <- data[gr.nms]
    }
    if (use == "all.obs") {
        na.fail(y)
        na.fail(gr)
    }
    if (use == "complete.obs") {
        sel <- complete.cases(y, gr)
        y <- y[sel]
        gr <- gr[sel]
    }
    na.rm <- use == "pairwise.complete.obs"

    foo <- function(x, gr, na.rm) {
        res <- data.frame(obs = NA, p.values = NA, labels = colnames(gr))
        for (i in 1:length(gr)) {
            sel <- if (na.rm) !is.na(x) & !is.na(gr[, i]) else TRUE
            xx <- x[sel]
            g <- gr[sel, i]
            w <- if (i > 1) weight.taxo2(g, gr[sel, i - 1]) else weight.taxo(g)
            o <- Moran.I(xx, w, scaled = TRUE)
            res[i, 1] <- o$observed
            res[i, 2] <- o$p.value
        }
        ## We need to specify the two classes; if we specify
        ## only "correlogram", 'res' is coerced as a list
        ## (data frames are of class "data.frame" and mode "list")
        structure(res, class = c("correlogram", "data.frame"))
    }

    if (length(y) == 1) foo(y[[1]], gr, na.rm)
    else structure(lapply(y, foo, gr = gr, na.rm = na.rm),
                   names = y.nms, class = "correlogramList")
}

plot.correlogram <-
    function(x, legend = TRUE, test.level = 0.05,
             col = c("grey", "red"), type = "b", xlab = "",
             ylab = "Moran's I", pch = 21, cex = 2, ...)
{
    BG <- col[(x$p.values < test.level) + 1]
    if (pch > 20 && pch < 26) {
        bg <- col
        col <- CO <- "black"
    } else {
        CO <- BG
        BG <- bg <- NULL
    }
    plot(1:length(x$obs), x$obs, type = type, xaxt = "n", xlab = xlab,
         ylab = ylab, col = CO, bg = BG, pch = pch, cex = cex, ...)
    axis(1, at = 1:length(x$obs), labels = x$labels)
    if (legend)
        legend("top", legend = paste(c("P >=", "P <"), test.level),
               pch = pch, col = col, pt.bg = bg, pt.cex = cex, horiz = TRUE)
}

plot.correlogramList <-
    function(x, lattice = TRUE, legend = TRUE,
             test.level = 0.05, col = c("grey", "red"),
             xlab = "", ylab = "Moran's I",
             type = "b", pch = 21, cex = 2, ...)
{
    n <- length(x)
    obs <- unlist(lapply(x, "[[", "obs"))
    pval <- unlist(lapply(x, "[[", "p.values"))
    gr <- factor(unlist(lapply(x, "[[", "labels")),
                 ordered = TRUE, levels = x[[1]]$labels)
    vars <- gl(n, nlevels(gr), labels = names(x))
    BG <- col[(pval < test.level) + 1]
    if (lattice) {
        ## trellis.par.set(list(plot.symbol=list(pch=19)))
        xyplot(obs ~ gr | vars, xlab = xlab, ylab = ylab,
               panel = function(x, y) {
                   panel.lines(x, y, lty = 2)
                   panel.points(x, y, cex = cex, pch = 19, col = BG)
                   ##lattice::panel.abline(h = 0, lty = 3)
               })
    } else {
        if (pch > 20 && pch < 26) {
            bg <- col
            CO <- rep("black", length(obs))
            col <- "black"
        } else {
            CO <- BG
            BG <- bg <- NULL
        }
        plot(as.numeric(gr), obs, type = "n", xlab = xlab,
             ylab = ylab, xaxt = "n")
        for (i in 1:n) {
            sel <- as.numeric(vars) == i
            lines(as.numeric(gr[sel]), obs[sel], type = type, lty = i,
                  col = CO[sel], bg = BG[sel], pch = pch, cex = cex, ...)
        }
        axis(1, at = 1:length(x[[i]]$obs), labels = x[[i]]$labels)
        if (legend) {
            legend("topright", legend = names(x), lty = 1:n, bty = "n")
            legend("top", legend = paste(c("P >=", "P <"), test.level),
                   pch = pch, col = col, pt.bg = bg, pt.cex = cex, horiz = TRUE)
        }
    }
}

## chronopl.R (2012-02-09)

##   Molecular Dating With Penalized Likelihood

## Copyright 2005-2012 Emmanuel Paradis

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

chronopl <-
    function(phy, lambda, age.min = 1, age.max = NULL,
             node = "root", S = 1, tol = 1e-8,
             CV = FALSE, eval.max = 500, iter.max = 500, ...)
{
    n <- length(phy$tip.label)
    ROOT <- n + 1L
    if (identical(node, "root")) node <- ROOT
    if (any(node <= n))
        stop("node numbers should be greater than the number of tips")
    zerobl <- which(phy$edge.length <= 0)
    if (length(zerobl)) {
        if (any(phy$edge[zerobl, 2] <= n))
            stop("at least one terminal branch is of length zero:
  you should remove it to have a meaningful estimation.")
        else {
            warning("at least one internal branch is of length zero:
  it was collapsed and some nodes have been deleted.")
            if (length(node) == 1 && node == ROOT)
                phy <- di2multi(phy)
            else {
                tmp <- FALSE
                if (is.null(phy$node.label)) {
                    tmp <- !tmp
                    phy$node.label <- paste("node", 1:phy$Nnode)
                }
                node.lab <- phy$node.label[node - n]
                phy <- di2multi(phy)
                node <- match(node.lab, phy$node.label) + n
                if (tmp) phy$node.label <- NULL
            }
        }
    }
    m <- phy$Nnode
    el <- phy$edge.length
    e1 <- phy$edge[, 1L]
    e2 <- phy$edge[, 2L]
    N <- length(e1)
    TIPS <- 1:n
    EDGES <- 1:N

    ini.rate <- el
    el <- el/S

    ## `basal' contains the indices of the basal edges
    ## (ie, linked to the root):
    basal <- which(e1 == ROOT)
    Nbasal <- length(basal)

    ## `ind' contains in its 1st column the index of all nonbasal
    ## edges, and in its second column the index of the edges
    ## where these edges come from (ie, this matrix contains pairs
    ## of contiguous edges), eg:

    ##         ___b___    ind:
    ##        |           |   |   |
    ## ___a___|           | b | a |
    ##        |           | c | a |
    ##        |___c___    |   |   |

    ind <- matrix(0L, N - Nbasal, 2)
    ind[, 1] <- EDGES[-basal]
    ind[, 2] <- match(e1[EDGES[-basal]], e2)

    age <- numeric(n + m)

#############################################################################
### This bit sets 'ini.time' and should result in no negative branch lengths

    seq.nod <- .Call("seq_root2tip", phy$edge, n, phy$Nnode, PACKAGE = "ape")

    ini.time <- age
    ini.time[ROOT:(n + m)] <- NA
    ini.time[node] <- if (is.null(age.max)) age.min else (age.min + age.max) / 2

    ## if no age given for the root, find one approximately:
    if (is.na(ini.time[ROOT]))
        ini.time[ROOT] <- if (is.null(age.max)) 3 * max(age.min) else 3 * max(age.max)

    ISnotNA.ALL <- unlist(lapply(seq.nod, function(x) sum(!is.na(ini.time[x]))))
    o <- order(ISnotNA.ALL, decreasing = TRUE)

    for (y in seq.nod[o]) {
        ISNA <- is.na(ini.time[y])
        if (any(ISNA)) {
            i <- 2L # we know the 1st value is not NA, so we start at the 2nd one
            while (i <= length(y)) {
                if (ISNA[i]) { # we stop at the next NA
                    j <- i + 1L
                    while (ISNA[j]) j <- j + 1L # look for the next non-NA
                    nb.val <- j - i
                    by <- (ini.time[y[i - 1L]] - ini.time[y[j]]) / (nb.val + 1)
                    ini.time[y[i:(j - 1L)]] <- ini.time[y[i - 1L]] - by * seq_len(nb.val)
                    i <- j + 1L
                } else i <- i + 1L
            }
        }
    }

    real.edge.length <- ini.time[e1] - ini.time[e2]

    if (any(real.edge.length <= 0))
        stop("some initial branch lengths are zero or negative;
  maybe you need to adjust the given dates -- see '?chronopl' for details")
#############################################################################

    ## because if (!is.null(age.max)), 'node' is modified,
    ## so we copy it in case CV = TRUE:
    node.bak <- node

    ## `unknown.ages' will contain the index of the nodes of unknown age:
    unknown.ages <- n + 1:m

    ## define the bounds for the node ages:
    lower <- rep(tol, length(unknown.ages))
    upper <- rep(1/tol, length(unknown.ages))

    if (!is.null(age.max)) { # are some nodes known within some intervals?
        lower[node - n] <- age.min
        upper[node - n] <- age.max
        ## find nodes known within an interval:
        interv <- which(age.min != age.max)
        ## drop them from the 'node' since they will be estimated:
        node <- node[-interv]
        if (length(node)) age[node] <- age.min[-interv] # update 'age'
    } else age[node] <- age.min

    if (length(node)) {
        unknown.ages <- unknown.ages[n - node] # 'n - node' is simplification for '-(node - n)'
        lower <- lower[n - node]
        upper <- upper[n - node]
    }

    ## `known.ages' contains the index of all nodes (internal and
    ## terminal) of known age:
    known.ages <- c(TIPS, node)

    ## concatenate the bounds for the rates:
    lower <- c(rep(tol, N), lower)
    upper <- c(rep(1 - tol, N), upper)

    minusploglik.gr <- function(rate, node.time) {
        grad <- numeric(N + length(unknown.ages))
        age[unknown.ages] <- node.time
        real.edge.length <- age[e1] - age[e2]
        if (any(real.edge.length < 0)) {
            grad[] <- 0
            return(grad)
        }
        ## gradient for the rates:
        ## the parametric part can be calculated without a loop:
        grad[EDGES] <- real.edge.length - el/rate
        if (Nbasal == 2) { # the simpler formulae if there's a basal dichotomy
            grad[basal[1]] <-
                grad[basal[1]] + lambda*(rate[basal[1]] - rate[basal[2]])
            grad[basal[2]] <-
                grad[basal[2]] + lambda*(rate[basal[2]] - rate[basal[1]])
        } else { # the general case
            for (i in 1:Nbasal)
                grad[basal[i]] <- grad[basal[i]] +
                    lambda*(2*rate[basal[i]]*(1 - 1/Nbasal) -
                            2*sum(rate[basal[-i]])/Nbasal)/(Nbasal - 1)
        }

        for (i in EDGES) {
            ii <- c(which(e2 == e1[i]), which(e1 == e2[i]))
            if (!length(ii)) next
            grad[i] <- grad[i] + lambda*(2*length(ii)*rate[i] - 2*sum(rate[ii]))
        }

        ## gradient for the 'node times'
        for (i in 1:length(unknown.ages)) {
            nd <- unknown.ages[i]
            ii <- which(e1 == nd)
            grad[i + N] <-
                sum(rate[ii] - el[ii]/real.edge.length[ii])#, na.rm = TRUE)
            if (nd != ROOT) {
                ii <- which(e2 == nd)
                grad[i + N] <- grad[i + N] -
                    rate[ii] + el[ii]/real.edge.length[ii]
            }
        }
        grad
    }

    minusploglik <- function(rate, node.time) {
        age[unknown.ages] <- node.time
        real.edge.length <- age[e1] - age[e2]
        if (any(real.edge.length < 0)) return(1e50)
        B <- rate*real.edge.length
        loglik <- sum(-B + el*log(B) - lfactorial(el))
        -(loglik - lambda*(sum((rate[ind[, 1]] - rate[ind[, 2]])^2)
                           + var(rate[basal])))
    }

    out <- nlminb(c(ini.rate, ini.time[unknown.ages]),
                  function(p) minusploglik(p[EDGES], p[-EDGES]),
                  function(p) minusploglik.gr(p[EDGES], p[-EDGES]),
                  control = list(eval.max = eval.max, iter.max = iter.max, ...),
                  lower = lower, upper = upper)

    attr(phy, "ploglik") <- -out$objective
    attr(phy, "rates") <- out$par[EDGES]
    attr(phy, "message") <- out$message
    age[unknown.ages] <- out$par[-EDGES]
    if (CV) ophy <- phy
    phy$edge.length <- age[e1] - age[e2]
    if (CV) attr(phy, "D2") <-
        chronopl.cv(ophy, lambda, age.min, age.max, node.bak,
                    n, S, tol, eval.max, iter.max, ...)
    phy
}

chronopl.cv <- function(ophy, lambda, age.min, age.max, nodes,
                        n, S, tol, eval.max, iter.max, ...)
### ophy: the original phylogeny
### n: number of tips
### Note that we assume here that the order of the nodes
### in node.label are not modified by the drop.tip operation
{
    cat("Doing cross-validation\n")
    BT <- branching.times(ophy)
    D2 <- numeric(n)

    for (i in 1:n) {
        cat("\r  dropping tip ", i, " / ", n, sep = "")
        tr <- drop.tip(ophy, i)
        j <- which(ophy$edge[, 2] == i)
        if (ophy$edge[j, 1] %in% nodes) {
            k <- which(nodes == ophy$edge[j, 1])
            node <- nodes[-k]
            agemin <- age.min[-k]
            agemax <- age.max[-k]
        } else node <- nodes
        if (length(node)) {
            chr <- chronopl(tr, lambda, age.min, age.max, node,
                            S, tol, FALSE, eval.max, iter.max, ...)
            tmp <-
                if (Nnode(chr) == Nnode(ophy)) BT else BT[-(ophy$edge[j, 1] - n)]
            D2[i] <- sum((tmp - branching.times(chr))^2 / tmp)
        } else D2[i] <- 0
    }
    cat("\n")
    D2
}

'print.lmorigin' <-
    function(x, ...)
{
	if(x$origin) {
		cat("\nRegression through the origin",'\n')
		} else {
		cat("\nMultiple regression with estimation of intercept",'\n')
		}
	cat("\nCall:\n")
    cat(deparse(x$call),'\n')
	if(x$origin) { names <- x$var.names[-1] }
		else { names <- c("(Intercept)",x$var.names[-1]) }

	cat("\nCoefficients and parametric test results \n",'\n')
	res <- as.data.frame(cbind(summary(x$reg)$coefficients[,1], summary(x$reg)$coefficients[,2], summary(x$reg)$coefficients[,3], summary(x$reg)$coefficients[,4]))
	rownames(res) <- names
	colnames(res) <- c("Coefficient","Std_error","t-value","Pr(>|t|)")
	printCoefmat(res, P.values=TRUE, signif.stars=TRUE)
	
	if(x$nperm > 0) {
		cat("\nTwo-tailed tests of regression coefficients\n",'\n')
		res2 <- as.data.frame(cbind(summary(x$reg)$coefficients[,1], x$p.param.t.2tail, x$p.perm.t.2tail))
		rownames(res2) <- names
		colnames(res2) <- c("Coefficient","p-param","p-perm")
		nc <- 3
		printCoefmat(res2, P.values=TRUE, signif.stars=TRUE, has.Pvalue = 3 && substr(colnames(res2)[3],1,6) == "p-perm")

		cat("\nOne-tailed tests of regression coefficients:",'\n')
		cat("test in the direction of the sign of the coefficient\n",'\n')
		res1 <- as.data.frame(cbind(summary(x$reg)$coefficients[,1], x$p.param.t.1tail, x$p.perm.t.1tail))
		rownames(res1) <- names
		colnames(res1) <- c("Coefficient","p-param","p-perm")
		nc <- 3
		printCoefmat(res1, P.values=TRUE, signif.stars=TRUE, has.Pvalue = 3 && substr(colnames(res1)[3],1,6) == "p-perm")

		}
	cat("\nResidual standard error:", summary(x$reg)$sigma, "on", summary(x$reg)$df[2],"degrees of freedom",'\n')
	cat("Multiple R-square:", summary(x$reg)$r.squared,"  Adjusted R-square:", summary(x$reg)$adj.r.squared,'\n')

	F   <- summary(x$reg)$fstatistic[[1]]
	df1 <- summary(x$reg)$fstatistic[[2]]
	df2 <- summary(x$reg)$fstatistic[[3]]
	p.param.F <- pf(F, df1, df2, lower.tail=FALSE)
	cat("\nF-statistic:", F, "on", df1, "and", df2, "DF:\n")
	cat("   parametric p-value   :", p.param.F,'\n')
	if(x$nperm > 0) {
		cat("   permutational p-value:", x$p.perm.F,'\n')
		if(x$method == "raw") {
			cat("after",x$nperm,"permutations of",x$method,"data",'\n','\n')
			} else {
			cat("after",x$nperm,"permutations of",x$method,"of full model",'\n','\n')
			}			
		}
    invisible(x) 
}

## vcv2phylo.R (2014-11-27)

##   Variance-Covariance Matrix to Tree

## Copyright 2014 Simon Blomberg

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

vcv2phylo <- function (mat, tolerance = 1e-7)
{
  #########################################################
  ## Program to reconstruct a phylogenetic tree          ##
  ## from a phylogenetic variance-covariance matrix.     ##
  ## Input: mat (is tested for positive-definiteness)    ##
  ## Output: phylo (in phylo format as in package "ape") ##
  ## If numerical issues occur, adjust the tolerance.    ##
  ## Author: S. P. Blomberg                              ##
  ## Date: 12th November 2010                            ##
  #########################################################

  make.node <- function (left, right, value, lbrlen, rbrlen) {
    # function to make a node, using lists
    the.node <- list(left=left, right=right, value=value, lbrlen=lbrlen,
                     rbrlen=rbrlen)
    class(the.node) <- c("node", "list")
    return(the.node)
  }

  divide.matrix <- function (mat) {
    # function to decompose a block-diagonal matrix into
    # upper and lower blocks

    dims <- dim(mat)[1]
    end.of.block <- which(mat[1,] < tolerance)[1]-1
    if (is.na(end.of.block)) stop("Matrix is not block-diagonal")
    matlist <- list(upper=mat[1:end.of.block, 1:end.of.block],
                    lower=mat[(end.of.block+1):dims,(end.of.block+1):dims])
    if (length(matlist$upper)==1) names(matlist$upper) <- rownames(mat)[1]
    if (length(matlist$lower)==1) names(matlist$lower) <- rownames(mat)[dims]
    return(matlist)
  }

  make.tree.rec <- function (mat) {
    # Recursive function to create a tree made of nodes
    # from a phylogenetic matrix

    matlist <- divide.matrix(mat)
    if (is.vector(matlist$upper) && is.vector(matlist$lower)) {
      left <- as.numeric(names(matlist$upper))
      right <- as.numeric(names(matlist$lower))
      value <- i
      lbrlen <- matlist$upper
      rbrlen <- matlist$lower
    }
    if (is.vector(matlist$upper) && is.matrix(matlist$lower)) {
      min.lower <- min(matlist$lower)
      left <- as.numeric(names(matlist$upper))
      value <- i
      i <<- i+1
      right <- Recall(matlist$lower-min.lower)
      lbrlen <- matlist$upper
      rbrlen <- min.lower
    }
    if (is.matrix(matlist$upper) && is.vector(matlist$lower)) {
      min.upper <- min(matlist$upper)
      value <- i
      i <<- i+1
      left <- Recall(matlist$upper-min.upper)
      right <- as.numeric(names(matlist$lower))
      lbrlen <- min.upper
      rbrlen <- matlist$lower
    }
    if (is.matrix(matlist$upper) && is.matrix(matlist$lower)) {
      min.upper <- min(matlist$upper)
      min.lower <- min(matlist$lower)
      value <- i
      i <<- i+1
      left <- Recall(matlist$upper-min.upper)
      i <<- i+1
      right <- Recall(matlist$lower-min.lower)
      lbrlen <- min.upper
      rbrlen <- min.lower
    }
    return(make.node(left, right, value, lbrlen, rbrlen))
  }

  make.phylo.rec <- function (the.list) {
    # Recursive function to construct the edge matrix and collect the
    # branch length information from the tree
    brlens <<- c(brlens, the.list$lbrlen, the.list$rbrlen)
    if (is.numeric(the.list$left) && is.numeric(the.list$right)) {
      the.matrix <<- rbind(the.matrix, c(the.list$value, the.list$left),
                           c(the.list$value, the.list$right))
    }
    if (is.numeric(the.list$left) && inherits(the.list$right, "node")) {
      the.matrix <<- rbind(the.matrix, c(the.list$value, the.list$left),
                           c(the.list$value, the.list$right$value))
      Recall(the.list$right)
    }
    if (inherits(the.list$left, "node") && is.numeric(the.list$right)) {
        the.matrix <<- rbind(the.matrix, c(the.list$value, the.list$left$value),
                             c(the.list$value, the.list$right))
        Recall(the.list$left)
      }
    if (inherits(the.list$left, "node") && inherits(the.list$right, "node")) {
      the.matrix <<- rbind(the.matrix, c(the.list$value, the.list$left$value),
                           c(the.list$value, the.list$right$value))
      Recall(the.list$left)
      Recall(the.list$right)
    }
  }

  # main body
  #require(matrixcalc)
  #if (!is.positive.definite(mat)) stop("Matrix is not positive-definite")
  if (!isSymmetric(mat)) stop("Matrix is not symmetric")
  if (any(eigen(mat, only.values = TRUE)$values < -tolerance))
    stop("Matrix is not positive-definite")
  sp.names <- rownames(mat)
  dims <- dim(mat)[1]
  rownames(mat) <- colnames(mat) <- 1:dims
  i <- dims+1
  the.list <- make.tree.rec(mat) # side effect: calculate i
  the.matrix <- matrix(NA, 0, ncol=2) # initialise the edge matrix
  brlens <- vector(mode="numeric", length=0) #initialise branch length vector
  make.phylo.rec(the.list) # side effects: calculate the.matrix and brlens
  names(brlens) <- NULL
  phylo <- list(edge=the.matrix, tip.label=sp.names, edge.length=brlens, Nnode=i-dims)
  storage.mode(phylo$edge) <- "integer"
  storage.mode(phylo$Nnode) <- "integer"
  class(phylo) <- "phylo"
  return(phylo)
}

## howmanytrees.R (2004-12-23)

##   Calculate Numbers of Phylogenetic Trees

## Copyright 2004 Emmanuel Paradis

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

howmanytrees <- function(n, rooted = TRUE, binary = TRUE,
                         labeled = TRUE, detail = FALSE)
{
    if (!labeled && !(rooted & binary))
      stop("can compute number of unlabeled trees only for rooted binary cases.")
    if (n < 3) N <- 1 else {
        if (labeled) {
            if (!rooted) n <- n - 1
            if (binary) N <- prod(seq(1, (2*n - 3), by = 2))
            else {
                N <- matrix(0, n, n - 1)
                N[1:n, 1] <- 1
                for (i in 3:n)
                  for (j in 2:(i - 1))
                    N[i, j] <- (i + j - 2)*N[i - 1, j - 1] + j*N[i - 1, j]
                if (detail) {
                    rownames(N) <- 1:n
                    colnames(N) <- 1:(n - 1)
                } else N <- sum(N[n, ])
            }
        } else {
            N <- numeric(n)
            N[1] <- 1
            for (i in 2:n)
              if (i %% 2) N[i] <- sum(N[1:((i - 1)/2)]*N[(i - 1):((i + 1)/2)]) else {
                  x <- N[1:(i/2)]
                  y <- N[(i - 1):(i/2)]
                  y[length(y)] <- (y[length(y)] + 1)/2
                  N[i] <- sum(x*y)
              }
            if (detail) names(N) <- 1:n else N <- N[n]
        }
    }
    N
}

## by KS
replace.single.quotes <- function(x, start = 1L)
{
    z <- unlist(gregexpr("'", x))
    if (length(z) %% 2) {
        #warning("wrong number of single quotes around labels")
        warning(paste0("odd number of single quotes (", length(z), "): label(s) unchanged"))
        return(x)
    }
    i <- 1
    while (i < length(z)) {
        tmp <- substr(x, z[i], z[i + 1])
        substr(x, z[i], z[i + 1]) <- gsub("\\s+", "_", tmp)
        i <- i + 2
    }
    gsub("'", "", x)
}

"read.nexus.data" <- function (file)
{
    # Simplified NEXUS data parser.
    #
    # Version: 09/13/2006 01:01:59 PM CEST
    #          (modified by EP 2011-06-01 and by TG 2019-06-25)
    #
    # By:      Johan Nylander, nylander @ scs.fsu.edu
    #
    # WARNING: This is parser reads a restricted nexus format,
    #          see README for details.
    #
    # Argument (x) is a nexus formatted data file.
    #
    # Returns  (Value) a list of data sequences each made of a single
    #          vector of mode character where each element is a character.
    #
    # TODO:    Error checking, gap/missing, find.datatype, etc.
    #------------------------------------------------------------------

    "find.ntax" <- function (x)
    {
        for (i in 1:NROW(x)) {
            if(any(f <- grep("\\bntax", x[i], ignore.case = TRUE))) {
                ntax <- as.numeric(sub("(.+?)(ntax\\s*\\=\\s*)(\\d+)(.+)",
                                       "\\3", x[i], perl = TRUE, ignore.case = TRUE))
                break
            }
        }
        ntax
    }

    "find.nchar" <- function (x)
    {
        for (i in 1:NROW(x)) {
            if(any(f <- grep("\\bnchar", x[i], ignore.case = TRUE))) {
                nchar <- as.numeric(sub("(.+?)(nchar\\s*\\=\\s*)(\\d+)(.+)",
                                        "\\3", x[i], perl = TRUE, ignore.case = TRUE))
                break
            }
        }
        nchar
    }

    "find.matrix.line" <- function (x)
    {
        for (i in 1:NROW(x)) {
            if(any(f <- grep("\\bmatrix\\b", x[i], ignore.case = TRUE))) {
                matrix.line <- as.numeric(i)
                break
            }
        }
        matrix.line
    }

    "trim.whitespace" <- function (x)
    {
        gsub("\\s+", "", x)
    }

    "trim.semicolon" <- function (x)
    {
        gsub(";", "", x)
    }

    #TG: Added get polymorphism function
    "get.polymorphism" <- function (x)
    {
        ## Detect polymorphism function
        is.poly.start <- function(x) {return("(" == x || "{" == x)}
        is.poly.end   <- function(x) {return(")" == x || "}" == x)}
        ## Position increment
        position <- 1
        ## Check which position contains a polymorphism
        while(position <= length(x)) {
            ## Check whether the position is polymorphic
            if(is.poly.start(x[position])){
                ## Find the polymorphism end
                poly_end <- position + 1
                while(!is.poly.end(x[poly_end])) {
                    poly_end <- poly_end + 1
                    if(is.poly.start(x[poly_end]) || poly_end > length(x)) {
                        stop("missing closing bracket for a polymorphism at position ", position)
                    }
                }
                ## Replace the position by what's in the middle of the polymorphism
                x[position] <- paste0(x[(position+1):(poly_end-1)], collapse = "/")
                ## Remove the polymorphism
                x <- x[-c((position+1):poly_end)]
            }
            ## Increment the position
            position <- position + 1
        }
        return(x)
    }


    X <- scan(file = file, what = character(), sep = "\n",
              quiet = TRUE, comment.char = "[", strip.white = TRUE)
    ntax <- find.ntax(X)
    nchar <- find.nchar(X)
    matrix.line <- find.matrix.line(X)
    start.reading <- matrix.line + 1
    Obj <- list()
    length(Obj) <- ntax
    i <- 1
    pos <- 0
    tot.nchar <- 0
    tot.ntax <- 0

    ## by KS
    single.quotes <- grepl("'", X)
    if (any(single.quotes)) {
        to.replace <- which(single.quotes)
        for (j in to.replace) {
            X[[j]] <- replace.single.quotes(X[[j]])
        }
    }

    for (j in start.reading:NROW(X)) {
        Xj <- trim.semicolon(X[j])
        if(Xj == "") {
            break
        }
        if(any(jtmp <- grep("\\bend\\b", X[j], perl = TRUE, ignore.case = TRUE))) {
            break
        }
        ts <- unlist(strsplit(Xj, "(?<=\\S)(\\s+)(?=\\S)", perl = TRUE))
        if (length(ts) > 2) {
            stop("nexus parser does not handle spaces in sequences or taxon names (ts>2)")
        }
        if (length(ts) !=2) {
            stop("nexus parser failed to read the sequences (ts!=2)")
        }
        Seq <- trim.whitespace(ts[2])
        Name <- trim.whitespace(ts[1])
        nAME <- paste(c("\\b", Name, "\\b"), collapse = "")
        if (any(l <- grep(nAME, names(Obj)))) {
            tsp <- strsplit(Seq, NULL)[[1]]
            #TG: Convert polymorphisms
            if(any("(" %in% tsp || "{" %in% tsp)) {
                tsp <- get.polymorphism(tsp)
            }
            for (k in 1:length(tsp)) {
                p <- k + pos
                Obj[[l]][p] <- tsp[k]
                chars.done <- k
            }
        }
        else {
            names(Obj)[i] <- Name
            tsp <- strsplit(Seq, NULL)[[1]]
            #TG: Convert polymorphisms
            if(any("(" %in% tsp || "{" %in% tsp)) {
                tsp <- get.polymorphism(tsp)
            }
            for (k in 1:length(tsp)) {
                p <- k + pos
                Obj[[i]][p] <- tsp[k]
                chars.done <- k
            }
        }
        tot.ntax <- tot.ntax + 1
        if (tot.ntax == ntax) {
            i <- 1
            tot.ntax <- 0
            tot.nchar <- tot.nchar + chars.done
            if (tot.nchar == nchar*ntax) {
                print("ntot was more than nchar*ntax")
                break
            }
            pos <- tot.nchar
        }
        else {
            i <- i + 1
        }
    }
    if (tot.ntax != 0) {
        cat("ntax:",ntax,"differ from actual number of taxa in file?\n")
        stop("nexus parser did not read names correctly (tot.ntax!=0)")
    }
    for (i in 1:length(Obj)) {
        if (length(Obj[[i]]) != nchar) {
            cat(names(Obj[i]),"has",length(Obj[[i]]),"characters\n")
            stop("nchar differ from sequence length (length(Obj[[i]])!=nchar)")
        }
    }
    Obj <- lapply(Obj, tolower)
    Obj
}

## by KS:
nexus2DNAbin <- function(x)
{
    bs <- as.raw(._bs_)
    cs <- ._cs_
    fun <- function(x) {
        res <- as.raw(0)
        for (i in x) res <- res | bs[match(i, cs)]
        res <- res & bs[15] # bs[15] == n
        if (!(res %in% bs)) return(cs[17]) # return(?)
        cs[match(res, bs)]
    }
    y <- unique(unlist(x))
    y <- tolower(y)
    y <- y[is.na(match(y, cs))]
    if (length(y)) {
        tmp <- strsplit(y, "/")
        repl <- sapply(tmp, fun)
        for (i in seq_along(x)) {
            for (j in seq_along(y)) {
                x[[i]] <- gsub(y[j], repl[j], x[[i]])
            }
        }
    }
    as.DNAbin(x)
}

## phydataplot.R (2017-10-04)

##   Annotate Phylogenies

## Copyright 2014-2017 Emmanuel Paradis

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

polar2rect <- function(r, angle)
    list(x = r * cos(angle), y = r * sin(angle))

rect2polar <- function(x, y)
    list(r = sqrt(x^2 + y^2), angle = atan2(y, x))

.matchDataPhylo <- function(x, phy)
{
    msg <- "'x' has no (row)names: data are assumed to be in the same order than the tips of the tree"
    labs <- phy$tip.label
    if (is.vector(x)) { # also for lists
        if (is.null(names(x))) warning(msg) else x <- x[labs]
    } else {
        if (is.null(rownames(x))) warning(msg) else x <- x[labs, ]
    }
    x
}

ring <- function(x, phy, style = "ring", offset = 1, ...)
{
    style <- match.arg(style, c("ring", "segments", "arrows"))
    x <- .matchDataPhylo(x, phy)
    lastPP <- get("last_plot.phylo", envir = .PlotPhyloEnv)
    n <- lastPP$Ntip
    one2n <- seq_len(n)
    tmp <- rect2polar(lastPP$xx[one2n], lastPP$yy[one2n])
    theta <- tmp$angle
    r0 <- max(tmp$r) + offset
    r1 <- r0 + x
    s0 <- polar2rect(rep.int(r0, 100L), seq(0, 2*pi, length.out = 100L))
    s1 <- polar2rect(r1, theta)

    switch(style, ring = {
        if (length(x) < n) x <- rep_len(x, n)
        dx <- dim(x)
        if (is.null(dx)) dim(x) <- dx <- c(n, 1L)
        nc <- dx[2]
        col <- list(...)$col
        if (is.null(col)) col <- "grey"
        if (nc == 1) {
            col <- rep_len(col, n)
        } else {
            colvar <- col
            col <- rep(col[1], n)
        }
        iangle <- min(diff(sort(theta)))
        iangle2 <- iangle / 2
        for (i in one2n) {
            R <- rep(r0, 100)
            THETA <- seq(theta[i] - iangle2, theta[i] + iangle2, length.out = 100)
            xy1 <- polar2rect(R, THETA)
            xy2 <- polar2rect(R + x[i, 1], THETA)
            polygon(c(xy1$x, rev(xy2$x)), c(xy1$y, rev(xy2$y)), col = col[i], border = NA)
            if (nc > 1) {
                for (j in 2:nc) {
                    xy1 <- xy2
                    xy2 <- polar2rect(R + sum(x[i, 1:j]), THETA)
                    polygon(c(xy1$x, rev(xy2$x)), c(xy1$y, rev(xy2$y)), col = colvar[j], border = NA)
                }
            }
        }
        ##polypath(c(s0$x, NA, s0$x), c(s0$y, NA, s1$y), rule = "evenodd",
        ##         border = 1, col = "transparent")
    }, segments = {
        s0 <- polar2rect(rep.int(r0, n), theta)
        segments(s0$x, s0$y, s1$x, s1$y, ...)
    },  arrows = {
        s0 <- polar2rect(rep.int(r0, n), theta)
        fancyarrows(s0$x, s0$y, s1$x, s1$y, ...)
    })
}

phydataplot <- function(x, phy, style = "bars", offset = 1, scaling = 1,
                        continuous = FALSE, width = NULL, legend = "below",
                        funcol = rainbow, ...)
{
    style <- match.arg(style, c("bars", "segments", "image", "arrows", "boxplot", "dotchart", "mosaic"))
    lastPP <- get("last_plot.phylo", envir = .PlotPhyloEnv)
    circular <- if (lastPP$type %in% c("radial", "fan")) TRUE else FALSE

    n <- length(phy$tip.label)
    one2n <- seq_len(n)
    x <- .matchDataPhylo(x, phy)

    if (scaling != 1)
        x <- if (is.list(x)) lapply(x, "*", scaling) else scaling * x

    if (!circular) {
        if (lastPP$direction != "rightwards")
            stop("for the moment, only rightwards trees are supported")
        x0 <- max(lastPP$xx[one2n]) + offset
        if (style %in% c("bars", "segments", "arrows")) x1 <- x0 + x
        y1 <- lastPP$yy[one2n]
        if (style %in% c("bars", "image", "boxplot", "dotchart", "mosaic")) {
            o <- order(y1)
            x <- if (style == "image") x[o, o] else
            if (is.vector(x)) x[o] else x[o, ]
        }
    } else {
        if (style %in% c("image", "boxplot", "dotchart", "mosaic"))
            stop(paste(dQuote(style), "not implemented with circular trees"))
    }

    switch(style, bars = {
        if (circular)
            stop("style = \"bars\" not implemented with circular trees; see function 'ring'")
        if (!is.null(dim(x))) x <- t(x)
        barplot(x, width = 1, add = TRUE, horiz = TRUE, offset = x0,
                axes = FALSE, axisnames = FALSE, space = c(0.5, rep(0, n - 1)), ...)
        px <- pretty(c(0, x))
        axis(1, px + x0, labels = px / scaling, line = 1)
    }, segments = {
        if (circular) ring(x, phy, style, offset, ...)
        else segments(x0, y1, x1, y1, ...)
    }, image = {
        if (inherits(x, "DNAbin"))
            stop('object of class "DNAbin" not supported: use type="mosaic"')
        x1 <- seq(x0, lastPP$x.lim[2], length.out = n)
        image(x1, y1[o], x, add = TRUE, ...)
        mtext(phy$tip.label[o], 1, 1, at = x1, font = lastPP$font,
              cex = lastPP$cex, col = lastPP$tip.color)
    }, arrows = {
        if (circular) ring(x, phy, style, offset, ...)
        else fancyarrows(rep(x0, length(y1)), y1, x1, y1, ...)
    }, boxplot = {
        if (is.matrix(x)) x <- t(x)
        o <- boxplot(x, plot = FALSE)
        mini <- min(o$stats)
        maxi <- max(o$stats)
        if (length(o$out)) { # in case there is no outlier
            mini <- min(o$out, mini)
            maxi <- max(o$out, maxi)
        }
        px <- pretty(c(mini, maxi))
        x0 <- x0 - mini
        o$stats <- o$stats + x0
        o$out <- o$out + x0
        bxp(o, horizontal = TRUE, add = TRUE, axes = FALSE, ...)
        axis(1, px + x0, labels = px / scaling, line = 1)

    }, dotchart = {
        mini <- min(x)
        maxi <- max(x)
        x0 <- x0 - mini
        segments(mini + x0, one2n, maxi + x0, one2n, lty = 3, col = "gray")
        points(x + x0, 1:n, ...)
        px <- pretty(x)
        axis(1, px + x0, labels = px / scaling, line = 1)
    }, mosaic = {
        p <- ncol(x)
        if (is.null(p)) p <- 1L
        if (is.null(width)) {
            x1 <- lastPP$x.lim[2]
            width <- (x1 - x0)/p
        } else x1 <- x0 + width * p
        xx <- seq(x0, x1, width)
        xl <- rep(xx[-length(xx)], each = n)
        yb <- rep(one2n - 0.5, p)
        xr <- xl + width
        yt <- yb + 1

        if (!is.null(labx <- colnames(x)))
            text(xx[-length(xx)] + width/2, max(yt), labx, adj = c(0.5, -0.5), xpd = TRUE)

        if (continuous) {
            nux <- if (is.logical(continuous)) 10 else continuous
            sq <- seq(min(x), max(x), length.out = nux + 1)
            x <- .bincode(x, sq, FALSE, TRUE)
            lgd <- paste0("[", sq[-length(sq)], "-", sq[-1], ")")
        } else {
            if (is.raw(x)) x <- toupper(as.character(x)) # for DNAbin objects
            nux <- length(ux <- sort(unique.default(x)))
            x <- match(x, ux)
            lgd <- as.character(ux)
        }
        co <- funcol(nux)
        conames <- names(co)
        if (!is.null(conames)) co <- co[lgd]
        rect(xl, yb, xr, yt, col = co[x], xpd = TRUE, ...)
        legend <- match.arg(legend, c("below", "side", "none"))
        if (legend != "none") {
            if (legend == "below")
                legend((x0 + x1)/2, -yinch(0.1), lgd, pch = 22, pt.bg = co,
                       pt.cex = 2, bty = "n", xjust = 0.5, yjust = 0.5,
                       horiz = TRUE, xpd = TRUE)
            else legend(x1, n, lgd, pch = 22, pt.bg = co,
                        pt.cex = 2, bty = "n", yjust = 1, xpd = TRUE)
        }
    })
}

## rTrait.R (2014-03-06)

##   Trait Evolution

## Copyright 2010-2014 Emmanuel Paradis

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

rTraitDisc <-
    function(phy, model = "ER", k = if (is.matrix(model)) ncol(model) else 2,
             rate = 0.1, states = LETTERS[1:k], freq = rep(1/k, k),
             ancestor = FALSE, root.value = 1, ...)
{
    if (is.null(phy$edge.length))
        stop("tree has no branch length")
    if (any(phy$edge.length < 0))
        stop("at least one branch length negative")

    if (is.character(model)) {
        switch(toupper(model), "ER" = {
                   if (length(rate) != 1)
                       stop("`rate' must have one element")
                   Q <- matrix(rate, k, k)
               }, "ARD" = {
                   if (length(rate) != k*(k - 1))
                       stop("`rate' must have k(k - 1) elements")
                   Q <- matrix(0, k, k)
                   Q[col(Q) != row(Q)] <- rate
               }, "SYM" = {
                   if (length(rate) != k*(k - 1)/2)
                       stop("`rate' must have k(k - 1)/2 elements")
                   Q <- matrix(0, k, k)
                   sel <- col(Q) < row(Q)
                   Q[sel] <- rate
                   Q <- t(Q)
                   Q[sel] <- rate
               })
    }
    if (is.matrix(model)) {
        Q <- model
        if (ncol(Q) != nrow(Q))
            stop("the matrix given as `model' must be square")
    }

    phy <- reorder(phy, "postorder")
    n <- length(phy$tip.label)
    N <- dim(phy$edge)[1]
    ROOT <- n + 1L
    x <- integer(n + phy$Nnode)
    x[ROOT] <- as.integer(root.value)

    anc <- phy$edge[, 1]
    des <- phy$edge[, 2]
    el <- phy$edge.length

    if (is.function(model)) {
        environment(model) <- environment() # to find 'k'
        for (i in N:1) x[des[i]] <- model(x[anc[i]], el[i], ...)
    } else {
        freq <- rep(freq, each = k)
        Q <- Q * freq
        diag(Q) <- 0
        diag(Q) <- -rowSums(Q)
        for (i in N:1) {
            p <- matexpo(Q * el[i])[x[anc[i]], ]
            x[des[i]] <- sample.int(k, size = 1, FALSE, prob = p)
        }
    }

    if (ancestor) {
        if (is.null(phy$node.label)) phy <- makeNodeLabel(phy)
        names(x) <- c(phy$tip.label, phy$node.label)
    } else {
        x <- x[1:n]
        names(x) <- phy$tip.label
    }
    class(x) <- "factor"
    levels(x) <- states
    x
}

rTraitCont <-
    function(phy, model = "BM", sigma = 0.1, alpha = 1, theta = 0,
             ancestor = FALSE, root.value = 0, ...)
{
    if (is.null(phy$edge.length))
        stop("tree has no branch length")
    if (any(phy$edge.length < 0))
        stop("at least one branch length negative")

    phy <- reorder(phy, "postorder")
    n <- length(phy$tip.label)
    N <- dim(phy$edge)[1]
    ROOT <- n + 1L
    x <- numeric(n + phy$Nnode)
    x[ROOT] <- root.value

    anc <- phy$edge[, 1]
    des <- phy$edge[, 2]
    el <- phy$edge.length

    if (is.function(model)) {
        environment(model) <- environment()
        for (i in N:1) x[des[i]] <- model(x[anc[i]], el[i], ...)
    } else {
        model <- pmatch(toupper(model), c("BM", "OU"))
        if (length(sigma) == 1) sigma <- rep(sigma, N)
        else if (length(sigma) != N)
            stop("'sigma' must have one or Nedge(phy) elements")
        if (model == 2) { # "OU"
            if (length(alpha) == 1) alpha <- rep(alpha, N)
            else if (length(alpha) != N)
                stop("'alpha' must have one or Nedge(phy) elements")
            if (length(theta) == 1) theta <- rep(theta, N)
            else if (length(theta) != N)
                stop("'theta' must have one or Nedge(phy) elements")
        }
        x <- .C(C_rTraitCont, as.integer(model), as.integer(N),
                as.integer(anc - 1L), as.integer(des - 1L), el,
                as.double(sigma), as.double(alpha), as.double(theta),
                x = x, NAOK = TRUE)$x
    }

    if (ancestor) {
        if (is.null(phy$node.label)) phy <- makeNodeLabel(phy)
        names(x) <- c(phy$tip.label, phy$node.label)
    } else {
        x <- x[1:n]
        names(x) <- phy$tip.label
    }
    x
}

rTraitMult <-
    function(phy, model, p = 1, root.value = rep(0, p), ancestor = FALSE,
             asFactor = NULL, trait.labels = paste("x", 1:p, sep = ""), ...)
{
    phy <- reorder(phy, "postorder")
    n <- length(phy$tip.label)
    m <- phy$Nnode
    N <- dim(phy$edge)[1]
    ROOT <- n + 1L

    x <- matrix(0, n + m, p)
    x[ROOT, ] <- root.value

    anc <- phy$edge[, 1]
    des <- phy$edge[, 2]

    el <- phy$edge.length
    if (is.null(el)) el <- numeric(N)

    environment(model) <- environment() # to find 'p'

    for (i in N:1) x[des[i], ] <- model(x[anc[i], ], el[i], ...)

    if (ancestor) {
        if (is.null(phy$node.label)) phy <- makeNodeLabel(phy)
        rownames(x) <- c(phy$tip.label, phy$node.label)
    } else {
        x <- x[1:n, , drop = FALSE]
        rownames(x) <- phy$tip.label
    }
    x <- as.data.frame(x)
    names(x) <- trait.labels
    if (!is.null(asFactor)) {
        for (i in asFactor) {
            y <- x[, i]
            x[, i] <- factor(y, labels = LETTERS[1:length(unique(y))])
        }
    }
    x
}

## treePop.R (2011-10-11)

##   Tree Popping

## Copyright 2011 Andrei-Alin Popescu

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

treePop <- function(obj)
{
    mf <- obj$matsplit
    labels <- obj$labels
    n <- length(labels)
    imf <- as.integer(mf)
    freq <- obj$freq
    mimf <- matrix(imf, nrow(mf), ncol(mf))
    ans <- .C(C_treePop, mimf, as.double(freq), as.integer(ncol(mf)),
              as.integer(n), integer(2*n - 3), integer(2*n - 3),
              double(2*n - 3), NAOK = TRUE)
    obj <- list(edge = cbind(ans[[5]], ans[[6]]), edge.length = ans[[7]],
                tip.label = labels, Nnode = n - 2L)
    class(obj) <- "phylo"
    reorder(obj)
}

## alex.R (2017-04-18)

##   Alignment Explorer With Multiple Devices

## Copyright 2012-2017 Emmanuel Paradis

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

alex <- function(x, ...)
{
    n <- nrow(x)
    s <- ncol(x)
    devmain <- dev.cur()
    on.exit(dev.set(devmain))
    NEW <- TRUE
    cat("Click on two opposite corners of the zone you want to zoom-in.
Right-click to exit.\n")
    repeat {
        xy <- locator(2)
        if (is.null(xy)) break
        xy$y <- n - xy$y + 1
        xy <- lapply(xy, function(x) sort(round(x)))
        i1 <- xy$y[1L]; i2 <- xy$y[2L]
        j1 <- xy$x[1L]; j2 <- xy$x[2L]
        if (i1 > n || j1 > s) cat("Try again!\n") else {
            if (i1 <= 0) i1 <- 1L
            if (j1 <= 0) j1 <- 1L
            if (i2 > n) i2 <- n
            if (j2 > s) j2 <- s
            if (NEW) {
                dev.new()
                devsub <- dev.cur()
                NEW <- FALSE
            } else dev.set(devsub)
            image(x[i1:i2, j1:j2], xaxt = "n", ...)
            atx <- axTicks(1)
            axis(1, atx, labels = (j1:j2)[atx])
            title(sub = paste("From", sQuote(deparse(substitute(x)))))
            dev.set(devmain)
        }
    }
}

## corphylo.R (2015-05-01)

##   Ancestral Character Estimation

## Copyright 2015 Anthony R. Ives

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

corphylo <- function(X, U = list(), SeM = NULL, phy = NULL, REML = TRUE, method = c("Nelder-Mead", "SANN"), 
	constrain.d = FALSE, reltol = 10^-6, maxit.NM = 1000, maxit.SA = 1000, temp.SA = 1, tmax.SA = 1, verbose = FALSE) {

	# Begin corphylo.LL
	corphylo.LL <- function(par, XX, UU, MM, tau, Vphy, REML, constrain.d, verbose) {

		n <- nrow(X)
		p <- ncol(X)

		L.elements <- par[1:(p + p * (p - 1)/2)]
		L <- matrix(0, nrow = p, ncol = p)
		L[lower.tri(L, diag = T)] <- L.elements
		R <- t(L) %*% L

		if (constrain.d == TRUE) {
			logit.d <- par[(p + p * (p - 1)/2 + 1):length(par)]
			if (max(abs(logit.d)) > 10) 
				return(10^10)
			d <- 1/(1 + exp(-logit.d))
		} else {
			d <- par[(p + p * (p - 1)/2 + 1):length(par)]
			if (max(d) > 10) 
				return(10^10)
		}

		# OU transform
		C <- matrix(0, nrow = p * n, ncol = p * n)
		for (i in 1:p) for (j in 1:p) {
			Cd <- (d[i]^tau * (d[j]^t(tau)) * (1 - (d[i] * d[j])^Vphy))/(1 - d[i] * d[j])
			C[(n * (i - 1) + 1):(i * n), (n * (j - 1) + 1):(j * n)] <- R[i, j] * Cd
		}

		V <- C + diag(as.numeric(MM))
		if (is.nan(rcond(V)) || rcond(V) < 10^-10) 
			return(10^10)
		iV <- solve(V)
		denom <- t(UU) %*% iV %*% UU
		if (is.nan(rcond(denom)) || rcond(denom) < 10^-10) 
			return(10^10)
		num <- t(UU) %*% iV %*% XX
		B <- solve(denom, num)
		B <- as.matrix(B)
		H <- XX - UU %*% B

		logdetV <- -determinant(iV)$modulus[1]
		if (is.infinite(logdetV)) 
			return(10^10)

		if (REML == TRUE) {
			# REML likelihood function		
			LL <- 0.5 * (logdetV + determinant(t(UU) %*% iV %*% UU)$modulus[1] + t(H) %*% iV %*% H)
		} else {
			# ML likelihood function
			LL <- 0.5 * (logdetV + t(H) %*% iV %*% H)
		}

		if (verbose == T) 
			show(c(as.numeric(LL), par))
		return(as.numeric(LL))
	}
	# End corphylo.LL
	
	# Main program
	if (!inherits(phy, "phylo")) 
		stop("Object \"phy\" is not of class \"phylo\".")
	if (is.null(phy$edge.length)) 
		stop("The tree has no branch lengths.")
	if (is.null(phy$tip.label)) 
		stop("The tree has no tip labels.")
	phy <- reorder(phy, "postorder")
	n <- length(phy$tip.label)

	# Input X
	if (dim(X)[1] != n) 
		stop("Number of rows of the data matrix does not match the length of the tree.")
	if (is.null(rownames(X))) {
		warning("No tip labels on X; order assumed to be the same as in the tree.\n")
		data.names = phy$tip.label
	} else data.names = rownames(X)
	order <- match(data.names, phy$tip.label)
	if (sum(is.na(order)) > 0) {
		warning("Data names do not match with the tip labels.\n")
		rownames(X) <- data.names
	} else {
		temp <- X
		rownames(X) <- phy$tip.label
		X[order, ] <- temp[1:nrow(temp), ]
	}
	p <- dim(X)[2]

	# Input SeM
	if (!is.null(SeM)) {
		if (dim(SeM)[1] != n) 
			stop("Number of rows of the SeM matrix does not match the length of the tree.")
		if (is.null(rownames(SeM))) {
			warning("No tip labels on SeM; order assumed to be the same as in the tree.\n")
			data.names = phy$tip.label
		} else data.names = rownames(SeM)
		order <- match(data.names, phy$tip.label)
		if (sum(is.na(order)) > 0) {
			warning("SeM names do not match with the tip labels.\n")
			rownames(SeM) <- data.names
		} else {
			temp <- SeM
			rownames(SeM) <- phy$tip.label
			SeM[order, ] <- temp[1:nrow(temp), ]
		}
	} else {
		SeM <- matrix(0, nrow = n, ncol = p)
	}

	# Input U
	if (length(U) > 0) {
		if (length(U) != p) 
			stop("Number of elements of list U does not match the number of columns in X.")

		for (i in 1:p) {
			if (!is.null(U[[i]])){
				if (dim(U[[i]])[1] != n) 
					stop("Number of rows of an element of U does not match the tree.")
				if (is.null(rownames(U[[i]]))) {
					warning("No tip labels on U; order assumed to be the same as in the tree.\n")
					data.names = phy$tip.label
				} else data.names = rownames(U[[i]])
				order <- match(data.names, phy$tip.label)
				if (sum(is.na(order)) > 0) {
					warning("U names do not match with the tip labels.\n")
					rownames(U[[i]]) <- data.names
				} else {
					temp <- U[[i]]
					rownames(U[[i]]) <- phy$tip.label
					U[[i]][order, ] <- temp[1:nrow(temp), ]
				}
			} else {
				U[[i]] <- matrix(0, nrow=n, ncol=1)
				rownames(U[[i]]) <- phy$tip.label
			}
		}
	}

	# Standardize all variables
	Xs <- X
	for (i in 1:p) Xs[, i] <- (X[, i] - mean(X[, i]))/sd(X[, i])

	if (!is.null(SeM)) {
		SeMs <- SeM
		for (i in 1:p) SeMs[, i] <- SeM[, i]/sd(X[, i])
	}

	if (length(U) > 0) {
		Us <- U
		for (i in 1:p) for (j in 1:ncol(U[[i]])) {
			if (sd(U[[i]][, j]) > 0) {
				Us[[i]][, j] <- (U[[i]][, j] - mean(U[[i]][, j]))/sd(U[[i]][, j])
			} else {
				Us[[i]][, j] <- U[[i]][, j] - mean(U[[i]][, j])
			}
		}
	}

	# Set up matrices
	Vphy <- vcv(phy)
	Vphy <- Vphy/max(Vphy)
	Vphy <- Vphy/exp(determinant(Vphy)$modulus[1]/n)

	XX <- matrix(as.matrix(Xs), ncol = 1)
	MM <- matrix(as.matrix(SeMs^2), ncol = 1)

	UU <- kronecker(diag(p), matrix(1, nrow = n, ncol = 1))
	if (length(U) > 0) {
		zeros <- 0 * (1:p)
		for (i in 1:p) {
			dd <- zeros
			dd[i] <- 1
			u <- kronecker(dd, as.matrix(Us[[i]]))
			for (j in 1:dim(u)[2]) if (sd(u[, j]) > 0) 
				UU <- cbind(UU, u[, j])
		}
	}

	# Compute initial estimates assuming no phylogeny if not provided
	if (length(U) > 0) {
		eps <- matrix(nrow = n, ncol = p)
		for (i in 1:p) {
			if (ncol(U[[i]]) > 0) {
				u <- as.matrix(Us[[i]])
				z <- lm(Xs[, i] ~ u)
				eps[, i] <- resid(z)
			} else {
				eps[, i] <- Xs[, i] - mean(Xs[, i])
			}
		}
		L <- t(chol(cov(eps)))
	} else {
		L <- t(chol(cov(Xs)))
	}
	L.elements <- L[lower.tri(L, diag = T)]
	par <- c(L.elements, array(0.5, dim = c(1, p)))

	tau <- matrix(1, nrow = n, ncol = 1) %*% diag(Vphy) - Vphy

	if (method == "Nelder-Mead") 
		opt <- optim(fn = corphylo.LL, par = par, XX = XX, UU = UU, MM = MM, tau = tau, Vphy = Vphy, REML = REML, verbose = verbose, constrain.d = constrain.d, method = "Nelder-Mead", control = list(maxit = maxit.NM, reltol = reltol))

	if (method == "SANN") {
		opt <- optim(fn = corphylo.LL, par = par, XX = XX, UU = UU, MM = MM, tau = tau, Vphy = Vphy, REML = REML, 
			verbose = verbose, constrain.d = constrain.d, method = "SANN", control = list(maxit = maxit.SA, 
				temp = temp.SA, tmax = tmax.SA, reltol = reltol))
		par <- opt$par
		opt <- optim(fn = corphylo.LL, par = par, XX = XX, UU = UU, MM = MM, tau = tau, Vphy = Vphy, REML = REML, 
			verbose = verbose, constrain.d = constrain.d, method = "Nelder-Mead", control = list(maxit = maxit.NM, 
				reltol = reltol))
	}

	# Extract parameters
	par <- Re(opt$par)
	LL <- opt$value

	L.elements <- par[1:(p + p * (p - 1)/2)]
	L <- matrix(0, nrow = p, ncol = p)
	L[lower.tri(L, diag = T)] <- L.elements
	R <- t(L) %*% L
	Rd <- diag(diag(R)^-0.5)
	cor.matrix <- Rd %*% R %*% Rd

	if (constrain.d == TRUE) {
		logit.d <- par[(p + p * (p - 1)/2 + 1):length(par)]
		d <- 1/(1 + exp(-logit.d))
	} else {
		d <- par[(p + p * (p - 1)/2 + 1):length(par)]
	}

	# OU transform
	C <- matrix(0, nrow = p * n, ncol = p * n)
	for (i in 1:p) for (j in 1:p) {
		Cd <- (d[i]^tau * (d[j]^t(tau)) * (1 - (d[i] * d[j])^Vphy))/(1 - d[i] * d[j])
		C[(n * (i - 1) + 1):(i * n), (n * (j - 1) + 1):(j * n)] <- R[i, j] * Cd
	}

	V <- C + diag(MM)
	iV <- solve(V)
	denom <- t(UU) %*% iV %*% UU
	num <- t(UU) %*% iV %*% XX
	B <- solve(denom, num)
	B <- as.matrix(B)
	B.cov <- solve(t(UU) %*% iV %*% UU)
	H <- XX - UU %*% B

	# Back-transform B
	counter <- 0
	sd.list <- matrix(0, nrow = dim(UU)[2], ncol = 1)
	for (i in 1:p) {
		counter <- counter + 1
		B[counter] <- B[counter] + mean(X[, i])
		sd.list[counter] <- sd(X[, i])
		if (length(U) > 0) {
			for (j in 1:ncol(U[[i]])) {
				if (sd(U[[i]][, j]) > 0) {
					counter <- counter + 1
					B[counter] <- B[counter] * sd(X[, i])/sd(U[[i]][, j])
					sd.list[counter] <- sd(X[, i])/sd(U[[i]][, j])
				}
			}
		}
	}
	B.cov <- diag(as.numeric(sd.list)) %*% B.cov %*% diag(as.numeric(sd.list))
	B.se <- as.matrix(diag(B.cov))^0.5
	B.zscore <- B/B.se
	B.pvalue <- 2 * pnorm(abs(B/B.se), lower.tail = FALSE)

	# RowNames for B
	if (length(U) > 0) {
		B.rownames <- NULL
		for (i in 1:p) {
			B.rownames <- c(B.rownames, paste("B", i, ".0", sep = ""))
			if (ncol(U[[i]]) > 0) 
				for (j in 1:ncol(U[[i]])) if (sd(U[[i]][, j]) > 0) {
					if (is.null(colnames(U[[i]])[j])) 
						B.rownames <- c(B.rownames, paste("B", i, ".", j, sep = ""))
					if (!is.null(colnames(U[[i]])[j])) 
						B.rownames <- c(B.rownames, paste("B", i, ".", colnames(U[[i]])[j], sep = ""))
				}
		}
	} else {
		B.rownames <- NULL
		for (i in 1:p) {
			B.rownames <- c(B.rownames, paste("B", i, ".0", sep = ""))
		}
	}
	rownames(B) <- B.rownames
	rownames(B.cov) <- B.rownames
	colnames(B.cov) <- B.rownames
	rownames(B.se) <- B.rownames
	rownames(B.zscore) <- B.rownames
	rownames(B.pvalue) <- B.rownames

	if (REML == TRUE) {
		logLik <- -0.5 * ((n * p) - ncol(UU)) * log(2 * pi) + 0.5 * determinant(t(XX) %*% XX)$modulus[1] - LL
	} else {
		logLik <- -0.5 * (n * p) * log(2 * pi) - LL
	}
	k <- length(par) + ncol(UU)
	AIC <- -2 * logLik + 2 * k
	BIC <- -2 * logLik + k * (log(n) - log(pi))

	results <- list(cor.matrix = cor.matrix, d = d, B = B, B.se = B.se, B.cov = B.cov, B.zscore = B.zscore, 
		B.pvalue = B.pvalue, logLik = logLik, AIC = AIC, BIC = BIC, REML = REML, constrain.d = constrain.d, 
		XX = XX, UU = UU, MM = MM, Vphy = Vphy, R = R, V = V, C = C, convcode = opt$convergence, niter = opt$counts)
	class(results) <- "corphylo"
	return(results)
}

# Printing corphylo objects
print.corphylo <- function(x, digits = max(3, getOption("digits") - 3), ...) {

	cat("Call to corphylo\n\n")

	logLik = x$logLik
	AIC = x$AIC
	BIC = x$BIC

	names(logLik) = "logLik"
	names(AIC) = "AIC"
	names(BIC) = "BIC"
	print(c(logLik, AIC, BIC), digits = digits)

	cat("\ncorrelation matrix:\n")
	rownames(x$cor.matrix) <- 1:dim(x$cor.matrix)[1]
	colnames(x$cor.matrix) <- 1:dim(x$cor.matrix)[1]
	print(x$cor.matrix, digits = digits)

	cat("\nfrom OU process:\n")
	d <- data.frame(d = x$d)
	print(d, digits = digits)
	if (x$constrain.d == TRUE) 
		cat("\nvalues of d constrained to be in [0, 1]\n")

	cat("\ncoefficients:\n")
	coef <- data.frame(Value = x$B, Std.Error = x$B.se, Zscore = x$B.zscore, Pvalue = x$B.pvalue)
	rownames(coef) <- rownames(x$B)
	printCoefmat(coef, P.values = TRUE, has.Pvalue = TRUE)
	cat("\n")

	if (x$convcode != 0) 
		cat("\nWarning: convergence in optim() not reached\n")
}

## evonet.R (2017-07-28)

##   Evolutionary Networks

## Copyright 2011-2012 Emmanuel Paradis, 2017 Klaus Schliep

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

evonet <- function(phy, from, to = NULL)
{
    if (!inherits(phy, "phylo"))
        stop('object "phy" is not of class "phylo".')
    if (!is.rooted(phy))
        warning("the tree is unrooted")
    x <- phy

    if (is.null(to)) {
        if (is.data.frame(from))
            from <- as.matrix(from)
        if (!is.matrix(from))
            stop("'from' must be a matrix or a data frame if 'to' is not given")
        if (ncol(from) > 2) {
            warning("'from' has more than two columns: only the first two will be used.")
            ret <- from[, 1:2]
        } else if (ncol(from) < 2) {
            stop("'from' must have at least two columns")
        } else ret <- from
    } else {
        from <- as.vector(from)
        to <- as.vector(to)
        if (length(from) != length(to))
            stop("'from' and 'to' not of the same length after coercing as vectors")
        ret <- cbind(from, to)
    }

    ## check that values are not out of range:
    storage.mode(ret) <- "integer"
    if (any(is.na(ret)))
        stop("some values are NA's after coercing as integers")
    if (any(ret < 0) || any(ret > Ntip(phy) + phy$Nnode))
        stop("some values are out of range")

    x$reticulation <- ret
    class(x) <- c("evonet", "phylo")
    x
}

as.phylo.evonet <- function(x, ...)
{
    x$reticulation <- NULL
    class(x) <- "phylo"
    x
}

plot.evonet <- function(x, col = "blue", lty = 1, lwd = 1, alpha = 0.5,
                        arrows = 0, arrow.type = "classical", ...)
{
    ## changed 5/24/17 by Klaus
    plot.phylo(x, ...)
    edges(x$reticulation[, 1], x$reticulation[, 2],
          col = rgb(t(col2rgb(col)), alpha = 255 * alpha,
                    maxColorValue = 255),
          lty = lty, lwd = lwd, arrows = arrows, type = arrow.type)
}

as.networx.evonet <- function(x, weight = NA, ...)
{
    if (any(x$reticulation <= Ntip(x)))
        stop("some tips are involved in reticulations: cannot convert to \"networx\"")
    x <- reorder(x, "postorder")
    ned <- Nedge(x)
    nrt <- nrow(x$reticulation)
    x$edge <- rbind(x$edge, x$reticulation)
    colnames(x$edge) <- c("oldNodes", "newNodes")
    x$reticulation <- NULL
    x$edge.length <- c(x$edge.length, rep(weight, length.out = nrt))
    x$split <- c(1:ned, 1:nrt)
    class(x) <- c("networx", "phylo")
    x
}

as.network.evonet <- function(x, directed = TRUE, ...)
{
    class(x) <- NULL
    x$edge <- rbind(x$edge, x$reticulation)
    as.network.phylo(x, directed = directed, ...)
}

as.igraph.evonet <- function(x, directed = TRUE, use.labels = TRUE, ...)
{
    class(x) <- NULL
    x$edge <- rbind(x$edge, x$reticulation)
    ## added check by Klaus (2017-05-26)
    if (use.labels) {
        if (!is.null(x$node.label)){
            tmp <- nchar(x$node.label)
            if (any(tmp == 0)){
                newLabel <- paste0("number", 1:x$Nnode)
                x$node.label[tmp == 0] <- newLabel[tmp == 0]
            }
        }
        if (any(duplicated(c(x$tip.label, x$node.label))))
            stop("Duplicated labels!")
    }
    as.igraph.phylo(x, directed = directed, use.labels = use.labels, ...)
}

print.evonet <- function(x, ...)
{
    nr <- nrow(x$reticulation)
    cat("\n    Evolutionary network with", nr, "reticulation")
    if (nr > 1) cat("s")
    cat("\n\n               --- Base tree ---")
    print.phylo(as.phylo(x))
}

## new stuff by Klaus (2017-05-26)

reorder.evonet <- function(x, order = "cladewise", index.only = FALSE, ...)
{
    reticulation <- x$reticulation
    y <- reorder(as.phylo(x), order = order, index.only = index.only, ...)
    if (index.only) return(y)
    y$reticulation <- reticulation
    class(y) <- c("evonet", "phylo")
    y
}

## requires topo_sort from igraph, behaviour different from phylo
## (postorder seems to work fine)
## if no singletons are in edge reorder.phylo could be used
## if (getRversion() >= "2.15.1") utils::globalVariables(c("topo_sort", "graph"))
## reorder.evonet <- function(x, order = "cladewise", index.only = FALSE, ...)
## {
##     order <- match.arg(order, c("cladewise", "postorder"))
##     if (!is.null(attr(x, "order")))
##         if (attr(x, "order") == order) return(x)
##     g <- graph(t(x$edge))
##     neword <- if (order == "cladewise") topo_sort(g, "out") else topo_sort(g, "in")
##     neworder <- order(match(x$edge[, 1], neword))
##     if (index.only) return(neworder)
##     x$edge <- x$edge[neworder, ]
##     if (!is.null(x$edge.length)) x$edge.length <- x$edge.length[neworder]
##     attr(x, "order") <- order
##     x
## }

as.evonet <- function(x, ...)
{
    if (inherits(x, "evonet")) return(x)
    UseMethod("as.evonet")
}

as.evonet.phylo <- function(x, ...)
{
    pos <- grep("#", x$tip.label)
    ind <- match(pos, x$edge[, 2])
    reticulation <- x$edge[ind, , drop = FALSE]
    edge <- x$edge[-ind, , drop = FALSE]
    nTips <- as.integer(length(x$tip.label))
    reticulation[, 2] <- as.integer(match(x$tip.label[pos], x$node.label) + nTips)
    for (i in sort(pos, TRUE)) {
        edge[edge > i ] <- edge[edge > i] - 1L
        reticulation[reticulation > i] <- reticulation[reticulation > i] - 1L
    }
    x$edge <- edge
    x$reticulation <- reticulation
    if (!is.null(x$edge.length)) x$edge.length <- x$edge.length[-ind]
    x$tip.label <- x$tip.label[-pos]
    class(x) <- c("evonet", "phylo")
    x
}

## requires new version of clado.build and tree.build
read.evonet <- function(file = "", text = NULL, comment.char = "", ...)
{
    x <- read.tree(file = file, text = text, comment.char = comment.char, ...)
    as.evonet.phylo(x)
}

.evonet2phylo <-  function(x)
{
    nTips <- as.integer(length(x$tip.label))
    if (!is.null(x$edge.length)) {
        nd <- node.depth.edgelength(x)
        x$edge.length <- c(x$edge.length, nd[x$reticulation[, 2]] - nd[x$reticulation[, 1]])
    }
    if (!is.null(x$node.label))
        x$tip.label <- c(x$tip.label, x$node.label[x$reticulation[, 2] - nTips])
    else {
        newLabels <- paste0("#H", x$reticulation[, 2])
        x$tip.label <- c(x$tip.label, newLabels)
        x$node.label <- rep("", x$Nnode)
        ind <- which((x$reticulation[, 2] > nTips) & !duplicated(x$reticulation[, 2]))
        x$node.label[x$reticulation[ind, 2] - nTips] <- newLabels[ind]
    }
    nrets <- as.integer(nrow(x$reticulation))
    x$edge[x$edge > nTips] <-  x$edge[x$edge > nTips] + nrets
    x$reticulation[, 1] <- x$reticulation[, 1] + nrets
    x$reticulation[, 2] <- nTips + (1L:nrets)
    x$edge <- rbind(x$edge, x$reticulation)
    x$reticulation <- NULL
    attr(x, "order") <- NULL
    class(x) <- "phylo"
    x
}

write.evonet <- function(x, file = "", ...)
{
    x <- .evonet2phylo(x)
    write.tree(x, file = file, ...)
}

Nedge.evonet <- function(phy) dim(phy$edge)[1] + dim(phy$reticulation)[1]

## comparePhylo.R (2018-03-13)

##   Compare Two "phylo" Objects

## Copyright 2018 Emmanuel Paradis

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

comparePhylo <- function(x, y, plot = FALSE, force.rooted = FALSE,
                         use.edge.length = FALSE)
{
    tree1 <- deparse(substitute(x))
    tree2 <- deparse(substitute(y))
    res <- list()
    msg <- paste("=> Comparing", tree1, "with", tree2)
    res$messages <- msg
    n1 <- Ntip(x)
    n2 <- Ntip(y)
    tmp <-
        if (n1 == n2)
            paste("Both trees have the same number of tips:", n1)
        else
            paste("Trees have different numbers of tips:", n1, "and", n2)
    msg <- c(msg, tmp)
    tips1 <- x$tip.label
    tips2 <- y$tip.label
    tips12 <- match(tips1, tips2)
    tips21 <- match(tips2, tips1)
    tmp <- is.na(tips12)
    if (any(tmp))
        msg <- c(msg, paste("Tips in", tree1, "not in", tree2, ":",
                            paste(tips1[tmp], collapse = ", ")))
    tmp2 <- is.na(tips21)
    if (any(tmp2))
        msg <- c(msg, paste("Tips in", tree2, "not in", tree1, ":",
                            paste(tips2[tmp2], collapse = ", ")))
    sameTips <- FALSE
    if (!sum(tmp, tmp2)) {
        msg <- c(msg, "Both trees have the same tip labels")
        sameTips <- TRUE
    }
    m1 <- Nnode(x)
    m2 <- Nnode(y)
    tmp <-
        if (m1 == m2)
            paste("Both trees have the same number of nodes:", m1)
        else
            paste("Trees have different numbers of nodes:", m1, "and", m2)
    msg <- c(msg, tmp)
    rooted1 <- is.rooted(x)
    rooted2 <- is.rooted(y)
    tmp <- if (rooted1) {
               if (rooted2) "Both trees are rooted" else paste(tree1, "is rooted,", tree2, "is unrooted")
           } else {
               if (rooted2) paste(tree1, "is unrooted,", tree2, "is rooted") else "Both trees are unrooted"
           }
    msg <- c(msg, tmp)
    ultra1 <- ultra2 <- FALSE
    if (!is.null(x$edge.length)) ultra1 <- is.ultrametric(x)
    if (!is.null(y$edge.length)) ultra2 <- is.ultrametric(y)
    tmp <- if (ultra1) {
               if (ultra2) "Both trees are ultrametric" else paste(tree1, "is ultrametric,", tree2, "is not")
           } else {
               if (ultra2) paste(tree1, "is not ultrametric,", tree2, "is ultrametric") else "Both trees are not ultrametric"
           }
    msg <- c(msg, tmp)
    if (rooted1 && rooted2 || force.rooted) {
        key1 <- makeNodeLabel(x, "md5sum")$node.label
        key2 <- makeNodeLabel(y, "md5sum")$node.label
        mk12 <- match(key1, key2)
        mk21 <- match(key2, key1)
        if (any(tmp <- is.na(mk12))) {
            nk <- sum(tmp)
            msg <- c(msg, paste(nk, if (nk == 1) "clade" else "clades", "in", tree1, "not in", tree2))
        }
        if (plot) {
            layout(matrix(1:2, 1, 2))
            plot(x, use.edge.length = use.edge.length, main = tree1)
            nodelabels(node = which(tmp) + n1, pch = 19, col = "blue", cex = 2)
            legend("topleft", legend = paste("Clade absent in", tree2), pch = 19, col = "blue")
        }
        if (any(tmp <- is.na(mk21))) {
            nk <- sum(tmp)
            msg <- c(msg, paste(nk, if (nk == 1) "clade" else "clades", "in", tree2, "not in", tree1))
        }
        if (plot) {
            plot(y, use.edge.length = use.edge.length, main = tree2)
            nodelabels(node = which(tmp) + n2, pch = 19, col = "red", cex = 2)
            legend("topleft", legend = paste("Clade absent in", tree1), pch = 19, col = "red")
        }
        nodes1 <- which(!is.na(mk12))
        nodes2 <- mk12[!is.na(mk12)]
        if (ultra1 && ultra2) {
            bt1 <- branching.times(x)
            bt2 <- branching.times(y)
            BT <- data.frame(paste0(bt1[nodes1], " (", nodes1 + n1, ")"),
                             paste0(bt2[nodes2], " (", nodes2 + n2, ")"))
            names(BT) <- c(tree1, tree2)
            res$BT <- BT
            msg <- c(msg, "Branching times of clades in common between both trees: see ..$BT
(node number in parentheses)")
        }
        if (!is.null(nl1 <- x$node.label) && !is.null(nl2 <- y$node.label)) {
            NODES <- data.frame(paste0(nl1[nodes1], " (", nodes1 + n1, ")"),
                                paste0(nl2[nodes2], " (", nodes2 + n2, ")"))
            names(NODES) <- c(tree1, tree2)
            res$NODES <- NODES
            msg <- c(msg, "Node labels of clades in common between both trees: see ..$NODES
(node number in parentheses)")
        }
    }
    if (!force.rooted && !rooted1 && !rooted2 && sameTips && m1 == m2) {
        TR <- .compressTipLabel(c(x, y))
        bs <- bitsplits(TR)
        common.splits <- which(bs$freq == 2L)
        ncs <- length(common.splits)
        tmp <-
            if (ncs)
                paste(ncs, if (ncs == 1) "split" else "splits", "in common")
            else "No split in common"
        msg <- c(msg, tmp)
        if (plot) {
            co <- "black"#rgb(0, 0, 1, 0.7)
            layout(matrix(1:2, 1, 2))
            edgecol1 <- rep("black", Nedge(x))
            edgew1 <- rep(1, Nedge(x))
            edgecol2 <- rep("black", Nedge(y))
            edgew2 <- rep(1, Nedge(y))
            if (ncs) {
                f <- function(x)
                    unlist(lapply(ONEwise(x), paste, collapse = "\r"))
                ##pp <-  f(as.prop.part(bs, include.trivial = TRUE))
                pp <-  as.prop.part(bs)
                pp1 <- f(prop.part(TR[[1]]))
                pp2 <- f(prop.part(TR[[2]]))
                one2n <- 1:n1
                for (i in common.splits) {
                    p <- pp[[i]]
                    split <- paste(p, collapse = "\r")
                    k1 <- match(split, pp1)
                    k2 <- match(split, pp2)
                    if (!length(k1)) {
                        split <- paste(one2n[-p], collapse = "\r")
                        k1 <- match(split, pp1)
                        if (!length(k2)) k2 <- match(split, pp2)
                    }
                    e1 <- match(k1 + n1, TR[[1]]$edge[, 2])
                    e2 <- match(k2 + n2, TR[[2]]$edge[, 2])
                    edgecol1[e1] <- edgecol2[e2] <- co
                    edgew1[e1] <- edgew2[e2] <- 5
                }
            }
            plot(TR[[1]], "u", use.edge.length = use.edge.length,
                 edge.color = edgecol1, edge.width = edgew1, main = tree1, cex = 1.3, font =1)
            legend("bottomright", legend = "Split present in both trees",
                   lty = 1, col = "black", lwd = 5)
            plot(TR[[2]], "u", use.edge.length = use.edge.length,
                 edge.color = edgecol2, edge.width = edgew2, main = tree2, cex = 1.3, font =1)
        }
    }
    res$messages <- paste0(msg, ".")
    class(res) <- "comparePhylo"
    res
}

print.comparePhylo <- function(x, ...)
{
    cat(x$messages, sep = "\n")
    cat("\n")
    x$messages <- class(x) <- NULL
    if (length(x)) print.default(x)
}

## is.ultrametric.R (2016-10-04)

##   Test if a Tree is Ultrametric

## Copyright 2003-2016 Emmanuel Paradis

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

is.ultrametric <- function(phy, ...) UseMethod("is.ultrametric")

## the main driver code (n = number of tips):
.is.ultrametric_ape <- function(phy, tol, option, n)
{
    if (is.null(phy$edge.length))
        stop("the tree has no branch lengths")
    e1 <- phy$edge[, 1]
    e2 <- phy$edge[, 2]
    EL <- phy$edge.length

    ## xx: distance from a node or a tip to the root
    xx <- numeric(n + phy$Nnode)

    ## the following must start at the root and follow the
    ## edges contiguously; so the tree must be either in cladewise
    ## order (or in pruningwise but the for loop must start from
    ## the bottom of the edge matrix)

    for (i in seq_len(length(e1)))
        xx[e2[i]] <- xx[e1[i]] + EL[i]

    xx.tip <- xx[1:n]

    crit <- switch(option, {
        mn <- min(xx.tip)
        mx <- max(xx.tip)
        (mx - mn)/mx
    }, var(xx.tip))

    isTRUE(all.equal.numeric(crit, 0, tolerance = tol))
}

is.ultrametric.phylo <- function(phy, tol = .Machine$double.eps^0.5,
                                 option = 1, ...)
{
    phy <- reorder.phylo(phy)
    .is.ultrametric_ape(phy, tol, option, length(phy$tip.label))
}

is.ultrametric.multiPhylo <- function(phy, tol = .Machine$double.eps^0.5,
                                      option = 1, ...)
{
    phy <- reorder.multiPhylo(phy)
    labs <- attr(phy, "TipLabel")
    if (is.null(labs))
        sapply(phy, is.ultrametric.phylo, tol = tol, option = option)
    else
        sapply(phy, .is.ultrametric_ape, tol = tol, option = option, n = length(labs))
}

## yule.time.R (2009-02-20)

##    Fits the Time-Dependent Yule Model

## Copyright 2009 Emmanuel Paradis

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

yule.time <- function(phy, birth, BIRTH = NULL, root.time = 0,
                      opti = "nlm", start = 0.01)
{
    opti <- pmatch(opti, c("nlm", "nlminb", "optim"))
    if (is.na(opti)) stop("ambiguous argument 'opti'")
    LAMBDA <- function() x
    body(LAMBDA) <- body(birth)
    formals(LAMBDA) <- alist(t=)
    BT <- branching.times(phy)
    T <- BT[1]
    x <- BT[1] - BT + root.time
    m <- phy$Nnode

    paranam <- c(names(formals(birth)))
    np <- length(paranam)
    start <- rep(start, length.out = np)

    ## Foo is always vectorized
    if (is.null(BIRTH)) {
        Foo <- function(x) {
            n <- length(x)
            res <- numeric(n)
            for (i in 1:n)
                res[i] <- integrate(LAMBDA, x[i], T)$value
            res
        }
    } else {
        environment(BIRTH) <- environment()
        Foo <- function(x) BIRTH(T) - BIRTH(x)
    }

    half.dev <- function(p) {
        for (i in 1:np)
            assign(paranam[i], p[i], pos = sys.frame(1))
        root.term <-
            if (is.null(BIRTH)) integrate(LAMBDA, x[1], T)$value
            else BIRTH(T) - BIRTH(x[1])
        sum(Foo(x)) + root.term - sum(log(LAMBDA(x[2:m])))
    }

    switch(opti,
        {
            out <- nlm(half.dev, start, hessian = TRUE)
            est <- out$estimate
            se <- sqrt(diag(solve(out$hessian)))
            loglik <- lfactorial(m) - out$minimum
        },{
            out <- nlminb(start, half.dev)
            est <- out$par
            se <- NULL
            loglik <- lfactorial(m) - out$objective
        },{
            out <- optim(start, half.dev, hessian = TRUE,
                         control = list(maxit = 1000), method = "BFGS")
            est <- out$par
            se <- sqrt(diag(solve(out$hessian)))
            loglik <- lfactorial(m) - out$value
        })
    names(est) <- paranam
    if (!is.null(se)) names(se) <- paranam
    structure(list(estimate = est, se = se, loglik = loglik), class = "yule")
}

## root.R (2019-06-18)

##   Roots Phylogenetic Trees

## Copyright 2004-2019 Emmanuel Paradis

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

is.rooted <- function(phy) UseMethod("is.rooted")

.is.rooted_ape <- function(phy, ntips)
{
    if (!is.null(phy$root.edge)) return(TRUE)
    if (tabulate(phy$edge[, 1])[ntips + 1] > 2) FALSE else TRUE
}

is.rooted.phylo <- function (phy)
    .is.rooted_ape(phy, length(phy$tip.label))

is.rooted.multiPhylo <- function(phy)
{
    phy <- unclass(phy)
    labs <- attr(phy, "TipLabel")
    if (is.null(labs)) sapply(phy, is.rooted.phylo)
    else sapply(phy, .is.rooted_ape, ntips = length(labs))
}

unroot <- function(phy) UseMethod("unroot")

.unroot_ape <- function(phy, n)
{
    ## n: number of tips of phy
    N <- dim(phy$edge)[1]
    if (N < 3)
        stop("cannot unroot a tree with less than three edges.")

    ## delete FIRST the root.edge (in case this is sufficient to
    ## unroot the tree, i.e. there is a multichotomy at the root)
    if (!is.null(phy$root.edge)) phy$root.edge <- NULL
    if (!.is.rooted_ape(phy, n)) return(phy)

    ROOT <- n + 1L

### EDGEROOT[1]: the edge to be deleted
### EDGEROOT[2]: the target where to stick the edge to be deleted

### If the tree is in pruningwise (or postorder) order, then
### the last two edges are those connected to the root; the node
### situated in phy$edge[N - 2L, 1L] will be the new root...

    ophy <- attr(phy, "order")
    if (!is.null(ophy) && ophy != "cladewise") {
        NEWROOT <- phy$edge[N - 2L, 1L]
        EDGEROOT <- c(N, N - 1L)
        ## make sure EDGEROOT is ordered as described above:
        if (phy$edge[EDGEROOT[1L], 2L] != NEWROOT)
            EDGEROOT <- EDGEROOT[2:1]
    } else {

### ... otherwise, we remove one of the edges coming from
### the root, and eventually adding the branch length to
### the other one also coming from the root.
### In all cases, the node deleted is the 2nd one (numbered
### nb.tip+2 in 'edge'), so we simply need to renumber the
### nodes by adding 1, except the root (this remains the
### origin of the tree).

        EDGEROOT <- which(phy$edge[, 1L] == ROOT)
        ## make sure EDGEROOT is ordered as described above:
        if (phy$edge[EDGEROOT[1L], 2L] <= n)
            EDGEROOT <- EDGEROOT[2:1]
        NEWROOT <- phy$edge[EDGEROOT[1L], 2L]
    }

    phy$edge <- phy$edge[-EDGEROOT[1L], ]

    s <- phy$edge == NEWROOT # renumber the new root
    phy$edge[s] <- ROOT

    s <- phy$edge > NEWROOT # renumber all nodes greater than the new root
    phy$edge[s] <- phy$edge[s] - 1L

    if (!is.null(phy$edge.length)) {
        phy$edge.length[EDGEROOT[2L]] <-
            phy$edge.length[EDGEROOT[2L]] + phy$edge.length[EDGEROOT[1L]]
        phy$edge.length <- phy$edge.length[-EDGEROOT[1L]]
    }

    phy$Nnode <- phy$Nnode - 1L

    if (!is.null(phy$node.label)) {
        if (NEWROOT == n + 2L)
            phy$node.label <- phy$node.label[-1]
        else {
            lbs <- phy$node.label
            tmp <- lbs[NEWROOT - n]
            lbs <- lbs[-c(1, NEWROOT - n)] # fix by KS (2019-06-18)
            phy$node.label <- c(tmp, lbs)
        }
    }
    phy
}

unroot.phylo <- function(phy)
    .unroot_ape(phy, length(phy$tip.label))

unroot.multiPhylo <- function(phy)
{
    oc <- oldClass(phy)
    class(phy) <- NULL
    labs <- attr(phy, "TipLabel")
    if (is.null(labs)) phy <- lapply(phy, unroot.phylo)
    else {
        phy <- lapply(phy, .unroot_ape, n = length(labs))
        attr(phy, "TipLabel") <- labs
    }
    class(phy) <- oc
    phy
}

root <- function(phy, ...) UseMethod("root")

root.phylo <- function(phy, outgroup, node = NULL, resolve.root = FALSE,
                       interactive = FALSE, edgelabel = FALSE, ...)
{
    if (!inherits(phy, "phylo"))
        stop('object not of class "phylo"')
    phy <- reorder(phy)
    n <- length(phy$tip.label)
    ROOT <- n + 1L

    if (interactive) {
        node <- identify(phy)$nodes
        cat("You have set resolve.root =", resolve.root, "\n")
    }

    e1 <- phy$edge[, 1L]
    e2 <- phy$edge[, 2L]
    wbl <- !is.null(phy$edge.length)

    if (!is.null(node)) {
        if (node <= n)
            stop("incorrect node#: should be greater than the number of taxa")
        outgroup <- NULL
        newroot <- node
    } else {
        if (is.numeric(outgroup)) {
            if (any(outgroup > n))
                stop("incorrect taxa#: should not be greater than the number of taxa")
        }
        if (is.character(outgroup)) {
            outgroup <- match(outgroup, phy$tip.label)
            if (anyNA(outgroup))
                stop("specified outgroup not in labels of the tree")
        }
        if (length(outgroup) == n) return(phy)
        outgroup <- sort(outgroup) # used below

        ## First check that the outgroup is monophyletic, unless it has only one tip
        if (length(outgroup) > 1) {
            pp <- prop.part(phy)
            ingroup <- (1:n)[-outgroup]
            newroot <- 0L
            for (i in 2:phy$Nnode) {
                if (identical(pp[[i]], ingroup)) {
                    ## inverted with the next if (... (2013-06-16)
                    newroot <- e1[which(e2 == i + n)]
                    break
                }
                if (identical(pp[[i]], outgroup)) {
                    newroot <- i + n
                    break
                }
            }
            if (!newroot)
                stop("the specified outgroup is not monophyletic")
            MRCA.outgroup <- i + n
        } else newroot <- e1[which(e2 == outgroup)]
    }

    N <- Nedge(phy)
    oldNnode <- phy$Nnode

    Nclade <- tabulate(e1)[ROOT] # degree of the root node
    ## if only 2 edges connect to the root, we have to fuse them:
    fuseRoot <- Nclade == 2

    if (newroot == ROOT) {
        if (!resolve.root) return(phy) # else (resolve.root == TRUE)
        if (length(outgroup) > 1) outgroup <- MRCA.outgroup
        if (!is.null(node))
            stop("ambiguous resolution of the root node: please specify an explicit outgroup")

        k <- which(e1 == ROOT) # find the basal edges
        if (length(k) > 2) {
            i <- which(e2 == outgroup) # outgroup is always of length 1 here
            j <- k[k != i]
            newnod <- oldNnode + n + 1L
            phy$edge[j, 1] <- newnod

            phy$edge <- rbind(c(ROOT, newnod), phy$edge)
            if (wbl) phy$edge.length <- c(0, phy$edge.length)

            phy$Nnode <- phy$Nnode + 1L
        }
    } else {
        phy$root.edge <- NULL # just in case

        INV <- logical(N)
        w <- which(e2 == newroot)
        anc <- e1[w]
        i <- w

        nod <- anc

        if (nod != ROOT) {
            INV[w] <- TRUE
            i <- w - 1L
            repeat {
                if (e2[i] == nod) {
                    if (e1[i] == ROOT) break
                    INV[i] <- TRUE
                    nod <- e1[i]
                }
                i <- i - 1L
            }
        }

        ## we keep the edge leading to the old root if needed:
        if (!fuseRoot) INV[i] <- TRUE

        ## bind the other clades...

        if (fuseRoot) { # do we have to fuse the two basal edges?
            k <- which(e1 == ROOT)
            k <- if (k[2] > w) k[2] else k[1]
            phy$edge[k, 1] <- phy$edge[i, 2]
            if (wbl)
                phy$edge.length[k] <- phy$edge.length[k] + phy$edge.length[i]
        }

        if (fuseRoot) phy$Nnode <- oldNnode - 1L

        ## added after discussion with Jaime Huerta Cepas (2016-07-30):
        if (edgelabel) {
            phy$node.label[e1[INV] - n] <- phy$node.label[e2[INV] - n]
            phy$node.label[newroot - n] <- ""
        }

        phy$edge[INV, ] <- phy$edge[INV, 2:1]

        if (fuseRoot) {
            phy$edge <- phy$edge[-i, ]
            if (wbl) phy$edge.length <- phy$edge.length[-i]
            N <- N - 1L
        }

        if (resolve.root) {
            newnod <- oldNnode + n + 1L
            if (length(outgroup) == 1L) {
                wh <- which(phy$edge[, 2] == outgroup)
                                        #phy$edge[1] <- newnod
                k <- which(phy$edge[, 1] == newroot) # wh should be among k
                phy$edge[k[k != wh], 1] <- newnod
                o <- c((1:N)[-wh], wh)
                phy$edge <- rbind(c(newroot, newnod), phy$edge[o, ])
                if (wbl) phy$edge.length <- c(0, phy$edge.length[o])
            } else {
                wh <- which(phy$edge[, 1] == newroot)
                phy$edge[wh[-1], 1] <- newnod
                s1 <- 1:(wh[2] - 1)
                s2 <- wh[2]:N
                phy$edge <-
                    rbind(phy$edge[s1, ], c(newroot, newnod), phy$edge[s2, ])
                if (wbl)
                    phy$edge.length <- c(phy$edge.length[s1], 0, phy$edge.length[s2])
            }
            phy$Nnode <- phy$Nnode + 1L
        }
    }

    ## The block below renumbers the nodes so that they conform
    ## to the "phylo" format
    newNb <- integer(n + phy$Nnode)
    newNb[newroot] <- n + 1L
    sndcol <- phy$edge[, 2] > n
    newNb[sort(phy$edge[sndcol, 2])] <- n + 2:phy$Nnode
    phy$edge[sndcol, 2] <- newNb[phy$edge[sndcol, 2]]
    phy$edge[, 1] <- newNb[phy$edge[, 1]]

    if (!is.null(phy$node.label)) {
        newNb <- newNb[-(1:n)]
        if (fuseRoot) {
            newNb <- newNb[-1]
            phy$node.label <- phy$node.label[-1]
        }
        phy$node.label <- phy$node.label[order(newNb)]
        if (resolve.root) {
            phy$node.label[is.na(phy$node.label)] <- phy$node.label[1]
            phy$node.label[1] <- "Root"
        }
    }
    attr(phy, "order") <- NULL
    reorder.phylo(phy)
}

root.multiPhylo <- function(phy, outgroup, ...)
{
    oc <- oldClass(phy)
    class(phy) <- NULL
    labs <- attr(phy, "TipLabel")
    if (!is.null(labs))
        for (i in seq_along(phy)) phy[[i]]$tip.label <- labs
    phy <- lapply(phy, root.phylo, outgroup = outgroup, ...)
    if (!is.null(labs)) {
        for (i in seq_along(phy)) phy[[i]]$tip.label <- NULL
        attr(phy, "TipLabel") <- labs
    }
    class(phy) <- oc
    phy
}

## mst.R (2020-07-02)

##   Minimum Spanning Tree

## Copyright 2002-2006 Yvonnick Noel, Julien Claude, and Emmanuel Paradis

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

mst <- function(X)
{
    if (inherits(X, "dist")) X <- as.matrix(X)
    n <- dim(X)[1]
    N <- matrix(0, n, n)
    tree <- NULL
    large.value <- max(X) + 1
    diag(X) <- large.value
    index.i <- 1

    for (i in 1:(n - 1)) {
        tree <- c(tree, index.i)
        m <- apply(as.matrix(X[, tree]), 2, min)  #calcul les minimum par colonne
        a <- sortIndex(X[, tree])[1, ]
        b <- sortIndex(m)[1]
        index.j <- tree[b]
        index.i <- a[b]

        N[index.i, index.j] <- 1
        N[index.j, index.i] <- 1

        for (j in tree) {
            X[index.i, j] <- large.value
            X[j, index.i] <- large.value
        }
    }
    dimnames(N) <- dimnames(X)
    class(N) <- "mst"
    return(N)
}

### Function returning an index matrix for an increasing sort
sortIndex <- function(X)
{
    if(length(X) == 1) return(1)                  # sorting a scalar?
    if(!is.matrix(X)) X <- as.matrix(X)           # force vector into matrix
    ## n <- nrow(X)
    apply(X, 2, function(v) order(rank(v)))       # find the permutation
}

plot.mst <- function(x, graph = "circle", x1 = NULL, x2 = NULL, ...)
{
    n <- nrow(x)
    if (is.null(x1) || is.null(x2)) {
        if (graph == "circle") {
            ang <- seq(0, 2 * pi, length = n + 1)
            x1 <- cos(ang)
            x2 <- sin(ang)
            plot(x1, x2, type = "n", xlab = "", ylab = "",
                 xaxt = "n", yaxt = "n", bty = "n", ...)
        }
        if (graph == "nsca") {
            XY <- nsca(x)
            x1 <- XY[, 1]
            x2 <- XY[, 2]
            plot(XY, type = "n", xlab = "\"nsca\" -- axis 1",
                 ylab = "\"nsca\" -- axis 2", ...)
        }
    } else plot(x1, x2, type = "n", xlab = deparse(substitute(x1)),
                ylab = deparse(substitute(x2)), ...)
    for (i in 1:n) {
        w1 <- which(x[i, ] == 1)
        segments(x1[i], x2[i], x1[w1], x2[w1])
    }
    points(x1, x2, pch = 21, col = "black", bg = "white", cex = 3)
    text(x1, x2, 1:n, cex = 0.8)
}

nsca <- function(A)
{
    Dr <- apply(A, 1, sum)
    Dc <- apply(A, 2, sum)

    eig.res <- eigen(diag(1 / sqrt(Dr)) %*% A %*% diag(1 / sqrt(Dc)))
    r <- diag(1 / Dr) %*% (eig.res$vectors)[, 2:4]
    ## The next line has been changed by EP (20-02-2003), since
    ## it does not work if 'r' has no dimnames already defined
    ## dimnames(r)[[1]] <- dimnames(A)[[1]]
    rownames(r) <- rownames(A)
    r
}

`CADM.global` <-
	function(Dmat, nmat, n, nperm=99, make.sym=TRUE, weights=NULL, silent=FALSE)
{
### Function to test the overall significance of the congruence among 
### a group of distance matrices using Kendall's coefficient of concordance W.
###
### copyleft - Pierre Legendre, December 2008
###
### Reference -
### Legendre, P. and F.-J. Lapointe. 2004. Assessing congruence among distance 
### matrices: single malt Scotch whiskies revisited. Australian and New Zealand 
### Journal of Statistics 46: 615-629.
###
### Parameters of the function --
###
### Dmat = A text file listing the distance matrices one after the other, with
###        or without blank lines.
###        Each matrix is in the form of a square distance matrix with 0's 
###        on the diagonal.
###
### nmat = number of distance matrices in file Dmat.
###
### n = number of objects in each distance matrix. All matrices have same n.
###
### nperm = number of permutations for the tests.
###
### make.sym = TRUE: turn asymmetric matrices into symmetric matrices by 
###            averaging the two triangular portions.
###          = FALSE: analyse asymmetric matrices as they are.
###
### weights = a vector of positive weights for the distance matrices. 
###           Example: weights = c(1,2,3)
###         = NULL (default): all matrices have same weight in calculation of W.
###
### silent = TRUE: informative messages will not be printed, except stopping 
###          messages. Option useful for simulation work.
###        = FALSE: informative messages will be printed.
###
################################################################################
	
	if(nmat < 2) 
		stop("Analysis requested for a single D matrix: CADM is useless")
	
	a <- system.time({

    ## Check the input file
    if(ncol(Dmat) != n) 
    	stop("Error in the value of 'n' or in the D matrices themselves")
    nmat2 <- nrow(Dmat)/n
    if(nmat2 < nmat)  # OK if 'nmat' < number of matrices in the input file
    	stop("Number of input D matrices = ",nmat2,"; this value is < nmat")

    nd <- n*(n-1)/2
    if(is.null(weights)) {
    	w <- rep(1,nmat)
    	} else {
    	if(length(weights) != nmat) 
    		stop("Incorrect number of values in vector 'weights'")
    	if(length(which(weights < 0)) > 0) 
    		stop("Negative weights are not permitted")
    	w <- weights*nmat/sum(weights)
    	if(!silent) cat("Normalized weights =",w,'\n')
    	}
    
    ## Are asymmetric D matrices present?
    asy <- rep(FALSE, nmat)
	asymm <- FALSE
    end <- 0
    for(k in 1:nmat) {
        begin <- end+1
        end <- end+n
        D.temp <- Dmat[begin:end,]
        if(sum(abs(diag(as.matrix(D.temp)))) > 0) 
        	stop("Diagonal not 0: matrix #",k," is not a distance matrix")
        vec1 <- as.vector(as.dist(D.temp))
        vec2 <- as.vector(as.dist(t(D.temp)))
        if(sum(abs((vec1-vec2))) > 0) {
        	if(!silent) cat("Matrix #",k," is asymmetric",'\n')
        	asy[k] <- TRUE
        	asymm <- TRUE
        	}
        }
    D1 <- as.list(1:nmat)
    if(asymm) {
    	if(make.sym) {
    		if(!silent) cat("\nAsymmetric matrices were transformed to be symmetric",'\n')
    		} else {
    		nd <- nd*2
    		if(!silent) cat("\nAnalysis carried out on asymmetric matrices",'\n')
    		D2 <- as.list(1:nmat)
    		}
    	} else {
    	if(!silent) cat("Analysis of symmetric matrices",'\n')
    	}
    Y <- rep(NA,nd)
    
    ## String out the distance matrices (vec) and assemble them as columns into matrix 'Y'
    ## Construct also matrices of ranked distances D1[[k]] and D2[[k]] for permutation test
    end <- 0
    for(k in 1:nmat) {
        begin <- end+1
        end <- end+n
        D.temp <- as.matrix(Dmat[begin:end,])
        vec <- as.vector(as.dist(D.temp))
        if(asymm) {
        	if(!make.sym) {
        		## Analysis carried out on asymmetric matrices: 
        		## The ranks are computed on the whole matrix except the diagonal values.
        		## The two halves are stored as symmetric matrices in D1[[k]] and D2[[k]]
        		vec <- c(vec, as.vector(as.dist(t(D.temp))))
        		diag(D.temp) <- NA
        		D.temp2 <- rank(D.temp)
                        dim(D.temp2) <- dim(D.temp)   # Correction E. Paradis, 08may17
        		diag(D.temp2) <- 0
        		# cat("nrow =",nrow(D.temp2)," ncol =",ncol(D.temp2),'\n')
				# cat("Matrix ",k," min =",min(D.temp2)," max =",max(D.temp2),'\n')
				# cat("Matrix ",k," max values #",which(D.temp2 == max(D.temp2)),'\n')
        		D1[[k]] <- as.matrix(as.dist(D.temp2))
        		D2[[k]] <- as.matrix(as.dist(t(D.temp2)))
        		} else {
        		## Asymmetric matrices transformed to be symmetric, stored in D1[[k]]
        		vec <- (vec + as.vector(as.dist(t(D.temp)))) / 2
				D.temp2 <- (D.temp + t(D.temp)) / 2
				D.temp2 <- as.dist(D.temp2)
        		D.temp2[] <- rank(D.temp2)
				D.temp2 <- as.matrix(D.temp2)
        		D1[[k]] <- D.temp2
        		}
        	} else {
        	## Symmetric matrices are stored in D1[[k]]
        	D.temp2 <- as.dist(D.temp)
        	D.temp2[] <- rank(D.temp2)
        	D1[[k]] <- as.matrix(D.temp2)
        	}
        Y <- cbind(Y, vec)
        }
    Y <- as.matrix(Y[,-1])
    colnames(Y) <- colnames(Y,do.NULL = FALSE, prefix = "Dmat.")
    
    ## Begin calculations for global test
    
    ## Compute the reference values of the statistics: W and Chi2
	## Transform the distances to ranks, by column
	Rmat <- apply(Y,2,rank)

	## Correction factors for tied ranks (eq. 3.3)
	t.ranks <- apply(Rmat, 2, function(x) summary(as.factor(x), maxsum=nd))
	TT <- sum(unlist(lapply(t.ranks, function(x) sum((x^3)-x))))
	# if(!silent) cat("TT = ",TT,'\n')
	
	## Compute the S = Sum-of-Squares of the row-marginal sums of ranks (eq. 1a)
	## The ranks are weighted during the sum by the vector of matrix weights 'w'
	## Eq. 1b cannot be used with weights; see formula for W below
	sumRanks <- as.vector(Rmat%*%w)
	S <- (nd-1)*var(sumRanks)
	
	## Compute Kendall's W (eq. 2a)
	## Eq. 2b cannot be used with weights 
	## because the sum of all ranks is not equal to m*n*(n+1)/2 in that case
	W <- (12*S)/(((nmat^2)*((nd^3)-nd))-(nmat*TT))
		
	## Calculate Friedman's Chi-square (Kendall W paper, 2005, eq. 3.4)
	Chi2 <- nmat*(nd-1)*W

	## Test the Chi2 statistic by permutation
	counter <- 1
	for(j in 1:nperm) {   # Each matrix is permuted independently
	                      # There is no need to permute the last matrix
		Rmat.perm <- rep(NA,nd)
		##
		if(asymm & !make.sym) {
			## For asymmetric matrices: permute the values within each triangular 
			## portion, stored as square matrices in D1[[]] and D2[[]]
			for(k in 1:(nmat-1)) {
				order <- sample(n)
				vec <- as.vector(as.dist(D1[[k]][order,order]))
			    vec <- c(vec, as.vector(as.dist(D2[[k]][order,order])))
				Rmat.perm <- cbind(Rmat.perm, vec)
				}
				vec <- as.vector(as.dist(D1[[nmat]]))
			    vec <- c(vec, as.vector(as.dist(D2[[nmat]])))
				Rmat.perm <- cbind(Rmat.perm, vec)
			} else {
			for(k in 1:(nmat-1)) {
				order <- sample(n)
				vec <- as.vector(as.dist(D1[[k]][order,order]))
				Rmat.perm <- cbind(Rmat.perm, vec)
				}
				vec <- as.vector(as.dist(D1[[nmat]]))
				Rmat.perm <- cbind(Rmat.perm, vec)
			}
		# Remove the first column of Rmat.perm containing NA
		# The test is based on the comparison of S and S.perm instead of the comparison of 
		# Chi2 and Chi2.perm: it is faster that way. 
		# S, W, and Chi2 are equivalent statistics for permutation tests.
		Rmat.perm <- as.matrix(Rmat.perm[,-1])
		S.perm <- (nd-1)*var(as.vector(Rmat.perm%*%w))
		if(S.perm >= S) counter <- counter+1
	}
	prob.perm.gr <- counter/(nperm+1)

	table <- rbind(W, Chi2, prob.perm.gr)
	colnames(table) <- "Statistics"
	rownames(table) <- c("W", "Chi2", "Prob.perm")
	})
	a[3] <- sprintf("%2f",a[3])
	if(!silent) cat("\nTime to compute global test =",a[3]," sec",'\n')
#
	# if(asymm & !make.sym) { out <- list(congruence_analysis=table, D1=D1, D2=D2)
	# } else {
	   out <- list(congruence_analysis=table)
	#    }
#
	out$nperm <- nperm
	class(out) <- "CADM.global"
	out
}

## reconstruct.R (2016-07-15)

##   Ancestral Character Estimation

## Copyright 2014-2016 Manuela Royer-Carenzi, Didier Gilles

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

#renvoie la racine d'arbre
racine <- function(arbre) {
    Ntip(arbre) + 1
}



# renvoie une liste dont la premiere composante est l'arbre renumerote
# de telle sorte que l'index d'un enfant est superieur a celui de son pere,
# la seconde compopsante est la fonction de l'index initial vers le second,
# et la troisieme son inverse
# (attention probleme pour l'image de 0 mise a l'image du max)
#
renumeroteArbre <- function(arbre) {
  m <- Ntip(arbre) + Nnode(arbre)
  v<-numeric(m)
  t<-numeric(m)
  stack<-numeric(m)
  istack<-1
  stack[istack]<-racine(arbre)
  codeI<-1
  codeL<-Nnode(arbre)+1
  while(istack>0){
    cour<-stack[istack]
    istack<-istack-1
    l <- which(arbre$edge[, 1] == cour)
    if(length(l)>0){
      v[cour] <- codeI
      t[codeI] <- cour
      codeI <- codeI+1
      for(i in 1:length(l)) {
	istack<-istack+1
	stack[istack] <- arbre$edge[l[i], 2]
      }
    } else {
      v[cour] <- codeL
      t[codeL] <- cour
      codeL <- codeL+1
    }
  }
  arbrebis<-arbre
#renumeroter les noms
  for(i in 1:Nedge(arbre)) {
    arbrebis$edge[i,1] <- v[arbre$edge[i,1]]
    arbrebis$edge[i,2] <- v[arbre$edge[i,2]]
  }
  l <- list(arbre = arbrebis, cod = v, dec = t)
  l
}


#calcule la matrice C selon le modele BM ou ABM
#
calculeC_ABM <- function(arbre) {
  m <- max(arbre[["edge"]])
  C <- matrix(0,nrow=m,ncol=m)
  for(i in 1:(m)) {
    l <- which(arbre$edge[, 2] == i)
    if(length(l)>0){
      for(j in 1:(m)) {
	C[j,i] <- C[j, arbre$edge[l[1], 1]]
      }
    }
    C[i,i]<-1;
  }
  t(C)
}

#calcule la matrice C selon le modele OU ou OU*
#
calculeC_OU <- function(arbre, a) {
  m <- max(arbre[["edge"]])
  C <- matrix(0,nrow=m,ncol=m)
  for(i in 1:(m)) {
    l <- which(arbre$edge[, 2] == i)
    if(length(l)>0){
      for(j in 1:(m)) {
	  C[j,i] <- C[j, arbre$edge[l[1], 1]]*exp(-a*arbre$edge.length[l[1]])
      }
    }
    C[i,i]<-1;
  }
  t(C)
}

#calcule la matrice C selon le modele type qui vaut ABM ou OU
calculeC <- function(type, arbre, a) {
  switch(type, ABM = calculeC_ABM(arbre), OU = calculeC_OU(arbre, a))
}





#########################
#calcul Variance
#########################

getSumSquare <- function(value, arbre) {
 sum <- 0.
 for(eu in 1:Nedge(arbre))
   sum <- sum + (value[arbre$edge[eu,2]]-value[arbre$edge[eu,1]])^2/arbre$edge.length[eu]
 sum
}


getMLHessian <- function(value, arbre) {
   sumSqu <- getSumSquare(value, arbre)
   nI <- Nnode(arbre)
   nT <- length(arbre$tip.label)
   nE <- nI+nT-1
   sizeH<-nI+1
   hessian <- matrix(0., nrow=sizeH, ncol=sizeH)
   var <- sumSqu/nE
   sd <- sqrt(var)
   hessian[1,1] <- -nE/(2*var^2)+sumSqu/var^3
   for(i in 1:nI) {
     	child <- which(arbre$edge[, 1] == nT+i)
  	if(length(child)>0) {
      		for(j in 1:length(child)) {
     		hessian[1,i+1] <- hessian[1,i+1]-(value[arbre$edge[child[j],2]]-value[nT+i])/arbre$edge.length[child[j]]
      		hessian[i+1,i+1] <- hessian[i+1,i+1]+1./arbre$edge.length[child[j]]
       		if(arbre$edge[child[j],2]>nT)
		  hessian[i+1,arbre$edge[child[j],2]-nT+1] <- -1./(var*arbre$edge.length[child[j]])
      		}
     	}
      	anc <- which(arbre$edge[, 2] == nT+i)
     	if(length(anc)>0) {
     	 	for(j in 1:length(anc)) {
       		hessian[1,i+1] <- hessian[1,i+1]+(value[nT+i]-value[arbre$edge[anc[j],1]])/arbre$edge.length[anc[j]]
     		hessian[i+1,i+1] <- hessian[i+1,i+1]+1./arbre$edge.length[anc[j]]
       		hessian[i+1,arbre$edge[anc[j],1]-nT+1] <- -1./(var*arbre$edge.length[anc[j]])
      		}
     	}
   hessian[1,i+1] <- -hessian[1,i+1]/sd^2
   hessian[i+1,1] <- hessian[1,i+1]
   hessian[i+1,i+1] <- hessian[i+1,i+1]/var
   }
   hessian
}

getREMLHessian <- function(value, arbre, sigma2) {
   nI <- Nnode(arbre)
   nT <- length(arbre$tip.label)
   sizeH<-nI
   hessian <- matrix(0., nrow=sizeH, ncol=sizeH)
   for(i in 1:nI) {
     	child <- which(arbre$edge[, 1] == nT+i)
  	if(length(child)>0) {
      		for(j in 1:length(child)) {
      		hessian[i,i] <- hessian[i,i]+1./arbre$edge.length[child[j]]
       		if(arbre$edge[child[j],2]>nT)
		  hessian[i,arbre$edge[child[j],2]-nT] <- -1./(sigma2*arbre$edge.length[child[j]])
      		}
     	}
      	anc <- which(arbre$edge[, 2] == nT+i)
     	if(length(anc)>0) {
     	 	for(j in 1:length(anc)) {
      		hessian[i,i] <- hessian[i,i]+1./arbre$edge.length[anc[j]]
       		hessian[i,arbre$edge[anc[j],1]-nT] <- -1./(sigma2*arbre$edge.length[anc[j]])
      		}
     	}
      hessian[i,i] <- hessian[i,i]/sigma2
   }
   hessian
}



glsBM <- function (phy, x, CI=TRUE) 
{	
	obj <- list()
	nb.tip <- length(phy$tip.label)
	nb.node <- phy$Nnode
	nbTotN <- nb.tip+nb.node
	sigmaMF <- 1	
	TsTemps <- dist.nodes(phy)
	TempsRacine <- TsTemps[(nb.tip+1),]
	IndicesMRCA <- mrca(phy, full=T)
	M <- matrix(NA, ncol=nbTotN, nrow=nbTotN)
	for (i in 1:nbTotN)
	{
	for (j in 1:nbTotN)
	{
		M[i,j] <- sigmaMF^2 * TempsRacine[IndicesMRCA[i,j]]
	}
	}
# M = SigmaZ
	varAL <- M[-(1:nb.tip), 1:nb.tip]
	varAA <- M[-(1:nb.tip), -(1:nb.tip)]
        varLL <- M[(1:nb.tip), 1:nb.tip]
        invVarLL <- solve(varLL)
	UL <- rep(1, length=nb.tip)
	UA <- rep(1, length=nb.node)
	TL <- TempsRacine[1:nb.tip] 
	TA <- TempsRacine[(nb.tip+1):(nb.tip+nb.node)]
#
	IVL_Z <- invVarLL %*% x
	IVL_T <- invVarLL %*% TL
	IVL_U <- invVarLL %*% UL
	U_IVL_U <- t(UL) %*% IVL_U
	U_IVL_Z <- t(UL) %*% IVL_Z
	DeltaU <- UA - varAL %*% IVL_U
#
	Racine_chap <- solve(U_IVL_U) %*% U_IVL_Z 
	Racine_chap <- as.numeric(Racine_chap)
	Anc_chap <- Racine_chap * DeltaU + varAL %*% IVL_Z
	Anc_chap <- as.vector(Anc_chap)
	obj$ace <- Anc_chap
	names(obj$ace) <- (nb.tip + 1):(nb.tip + nb.node)
#
 	if (CI) {
		Vec <- x - Racine_chap
		Num <- t(Vec) %*% invVarLL %*% Vec
		Num <- as.numeric(Num)
		sigma2_chap <- Num / (nb.tip-1)
		obj$sigma2 <- sigma2_chap
                se <- sqrt((varAA - varAL %*% invVarLL %*% t(varAL))[cbind(1:nb.node,
                  1:nb.node)])
		se <- se * sqrt(sigma2_chap)
                tmp <- se * qt(0.025, df=nb.tip-1)
                 obj$CI95 <- cbind(lower=obj$ace + tmp, upper=obj$ace - tmp)
           }
	obj
}

glsABM <- function (phy, x, CI=TRUE)
{
	obj <- list()
	nb.tip <- length(phy$tip.label)
	nb.node <- phy$Nnode
	nbTotN <- nb.tip+nb.node
	sigmaMF <- 1
	TsTemps <- dist.nodes(phy)
	TempsRacine <- TsTemps[(nb.tip+1),]
	IndicesMRCA <- mrca(phy, full=T)
	M <- matrix(NA, ncol=nbTotN, nrow=nbTotN)
	for (i in 1:nbTotN)
	{
	for (j in 1:nbTotN)
	{
		M[i,j] <- sigmaMF^2 * TempsRacine[IndicesMRCA[i,j]]
	}
	}
# M = SigmaZ
	varAL <- M[-(1:nb.tip), 1:nb.tip]
	varAA <- M[-(1:nb.tip), -(1:nb.tip)]
        varLL <- M[(1:nb.tip), 1:nb.tip]
        invVarLL <- solve(varLL)
	UL <- rep(1, length=nb.tip)
	UA <- rep(1, length=nb.node)
	TL <- TempsRacine[1:nb.tip]
	TA <- TempsRacine[(nb.tip+1):(nb.tip+nb.node)]
#
	IVL_Z <- invVarLL %*% x
	IVL_T <- invVarLL %*% TL
	IVL_U <- invVarLL %*% UL
	U_IVL_U <- t(UL) %*% IVL_U
	T_IVL_T <- t(TL) %*% IVL_T
	U_IVL_T <- t(UL) %*% IVL_T
	U_IVL_Z <- t(UL) %*% IVL_Z
	T_IVL_Z <- t(TL) %*% IVL_Z
	DeltaT <- TA - varAL %*% IVL_T
	DeltaU <- UA - varAL %*% IVL_U
#
	Den <- U_IVL_U * T_IVL_T - U_IVL_T^2
	Den <- as.numeric(Den)
	Mu_chap <- (U_IVL_U * T_IVL_Z - U_IVL_T * U_IVL_Z) / Den
	Mu_chap <- as.numeric(Mu_chap)
	Racine_chap <- (T_IVL_T * U_IVL_Z - U_IVL_T * T_IVL_Z) / Den
	Racine_chap <- as.numeric(Racine_chap)
	Anc_chap <- Mu_chap * DeltaT + Racine_chap * DeltaU + varAL %*% IVL_Z
	Anc_chap <- as.vector(Anc_chap)
	obj$ace <- Anc_chap
	names(obj$ace) <- (nb.tip + 1):(nb.tip + nb.node)
	obj$mu <- Mu_chap
#
 	if (CI) {
		Vec <- x - Racine_chap - Mu_chap * TL
		Num <- t(Vec) %*% invVarLL %*% Vec
		Num <- as.numeric(Num)
		sigma2_chap <- Num / (nb.tip-2)
		obj$sigma2 <- sigma2_chap
                se <- sqrt((varAA - varAL %*% invVarLL %*% t(varAL))[cbind(1:nb.node, 
                  1:nb.node)])
		se <- se * sqrt(sigma2_chap)
                tmp <- se * qt(0.025, df=nb.tip-2)
                obj$CI95 <- cbind(lower=obj$ace + tmp, upper=obj$ace - tmp)
            }
	obj
}

# theta = z0
glsOUv1 <- function (phy, x, alpha, CI=TRUE)
{
	obj <- list()
	nb.tip <- length(phy$tip.label)
	nb.node <- phy$Nnode
	nbTotN <- nb.tip+nb.node
	sigmaMF <- 1
	alphaM <- alpha
	nbTotN <- nb.tip+nb.node
	TsTemps <- dist.nodes(phy)
	TempsRacine <- TsTemps[(nb.tip+1),]
	IndicesMRCA <- mrca(phy, full=T)
	M <- matrix(NA, ncol=nbTotN, nrow=nbTotN)
	for (i in 1:nbTotN)
		{
	for (j in 1:nbTotN)
		{
		Tempsm <- TempsRacine[IndicesMRCA[i,j]]
		Tempsi <- TempsRacine[i]
		Tempsj <- TempsRacine[j]
		M[i,j] <- sigmaMF^2 * exp(-alphaM * (Tempsi+Tempsj-2*Tempsm)) * (1-exp(-2*alphaM * Tempsm)) / (2 * alphaM)
		}
		}
# M = SigmaZ
	varAL <- M[-(1:nb.tip), 1:nb.tip]
	varAA <- M[-(1:nb.tip), -(1:nb.tip)]
        varLL <- M[(1:nb.tip), 1:nb.tip]
        invVarLL <- solve(varLL)
	UL <- rep(1, length=nb.tip)
	UA <- rep(1, length=nb.node)
	TL <- TempsRacine[1:nb.tip]
	TA <- TempsRacine[(nb.tip+1):(nb.tip+nb.node)]
#
	IVL_Z <- invVarLL %*% x
	IVL_T <- invVarLL %*% TL
	IVL_U <- invVarLL %*% UL
	U_IVL_U <- t(UL) %*% IVL_U
	U_IVL_Z <- t(UL) %*% IVL_Z
	DeltaU <- UA - varAL %*% IVL_U
#
	Racine_chap <- solve(U_IVL_U) %*% U_IVL_Z
	Racine_chap <- as.numeric(Racine_chap)
	Anc_chap <- Racine_chap * DeltaU + varAL %*% IVL_Z
	Anc_chap <- as.vector(Anc_chap)
	obj$ace <- Anc_chap
	names(obj$ace) <- (nb.tip + 1):(nb.tip + nb.node)
#
# vraisemblance
#
	mL <- Racine_chap
	Num <- t(x-mL) %*% invVarLL %*% (x-mL)
	Num <- as.numeric(Num)
	sigma2_chap <- Num / (nb.tip-1)
	obj$sigma <- sqrt(sigma2_chap)
	VL <- sigma2_chap * varLL
	invVL <- invVarLL / sigma2_chap
	LVrais <- - t(x-mL) %*% invVL %*% (x-mL) /2 - nb.tip * log(2*pi)/2 - log(det(VL))/2
	obj$LLik <- as.numeric(LVrais)
#
 	if (CI) {
                se <- sqrt((varAA - varAL %*% invVarLL %*% t(varAL))[cbind(1:nb.node,
                  1:nb.node)])
		se <- se * sqrt(sigma2_chap)
                tmp <- se * qt(0.025, df=nb.tip-1)
                 obj$CI95 <- cbind(lower=obj$ace + tmp, upper=obj$ace - tmp)
            }
	obj
}


# theta pas egal a z0
glsOUv2 <- function (phy, x, alpha, CI=TRUE)
{
	obj <- list()
	nb.tip <- length(phy$tip.label)
	nb.node <- phy$Nnode
	nbTotN <- nb.tip+nb.node
	sigmaMF <- 1
	nbTotN <- nb.tip+nb.node
	TsTemps <- dist.nodes(phy)
	TempsRacine <- TsTemps[(nb.tip+1),]
	IndicesMRCA <- mrca(phy, full=T)
	M <- matrix(NA, ncol=nbTotN, nrow=nbTotN)
	for (i in 1:nbTotN)
		{
	for (j in 1:nbTotN)
		{
		Tempsm <- TempsRacine[IndicesMRCA[i,j]]
		Tempsi <- TempsRacine[i]
		Tempsj <- TempsRacine[j]
		M[i,j] <- sigmaMF^2 * exp(-alpha * (Tempsi+Tempsj-2*Tempsm)) * (1-exp(-2*alpha * Tempsm)) / (2 * alpha)
		}
		}
# M = SigmaZ
	varAL <- M[-(1:nb.tip), 1:nb.tip]
	varAA <- M[-(1:nb.tip), -(1:nb.tip)]
        varLL <- M[(1:nb.tip), 1:nb.tip]
        invVarLL <- solve(varLL)
	vecW <- exp(-alpha * TempsRacine)
	UL <- vecW[1:nb.tip]
	UA <- vecW[(nb.tip+1):(nb.tip+nb.node)]
	TL <- 1-UL
	TA <- 1-UA
#
#
	IVL_Z <- invVarLL %*% x
	IVL_T <- invVarLL %*% TL
	IVL_U <- invVarLL %*% UL
	U_IVL_U <- t(UL) %*% IVL_U
	T_IVL_T <- t(TL) %*% IVL_T
	U_IVL_T <- t(UL) %*% IVL_T
	U_IVL_Z <- t(UL) %*% IVL_Z
	T_IVL_Z <- t(TL) %*% IVL_Z
	DeltaT <- TA - varAL %*% IVL_T
	DeltaU <- UA - varAL %*% IVL_U
#
	Den <- U_IVL_U * T_IVL_T - U_IVL_T^2
	Den <- as.numeric(Den)
	Theta_chap <- (U_IVL_U * T_IVL_Z - U_IVL_T * U_IVL_Z) / Den
	Theta_chap <- as.numeric(Theta_chap)
	Racine_chap <- (T_IVL_T * U_IVL_Z - U_IVL_T * T_IVL_Z) / Den
	Racine_chap <- as.numeric(Racine_chap)
	Anc_chap <- Theta_chap * DeltaT + Racine_chap * DeltaU + varAL %*% IVL_Z
	Anc_chap <- as.vector(Anc_chap)
	obj$ace <- Anc_chap
	names(obj$ace) <- (nb.tip + 1):(nb.tip + nb.node)
	obj$theta <- Theta_chap
#
# vraisemblance
#
	mL <- (Racine_chap * UL + Theta_chap * TL)
	Num <- t(x-mL) %*% invVarLL %*% (x-mL)
	Num <- as.numeric(Num)
	sigma2_chap <- Num / (nb.tip-2)
	obj$sigma <- sqrt(sigma2_chap)
	VL <- sigma2_chap * varLL
	invVL <- invVarLL / sigma2_chap
	LVrais <- - t(x-mL) %*% invVL %*% (x-mL) /2 - nb.tip * log(2*pi)/2 - log(det(VL))/2
	obj$LLik <- as.numeric(LVrais)
#
 	if (CI) {
                se <- sqrt((varAA - varAL %*% invVarLL %*% t(varAL))[cbind(1:nb.node,
                  1:nb.node)])
		se <- se * sqrt(sigma2_chap)
                tmp <- se * qt(0.025, df=nb.tip-2)
                obj$CI95 <- cbind(lower=obj$ace + tmp, upper=obj$ace - tmp)
            }
	obj
}


reconstruct <- function (x, phyInit, method = "ML", alpha = NULL, CI = TRUE) {
 if(!is.null(alpha)) {
  if(alpha<=0)
   stop("alpha has to be positive.")
 }
 if (!inherits(phyInit, "phylo"))
  stop("object \"phy\" is not of class \"phylo\"")
 if (is.null(phyInit$edge.length))
  stop("tree has no branch lengths")
 nN <- phyInit$Nnode
 nT <- length(x)
 switch(method,
  ML = {
   Intern <- glsBM(phy=phyInit, x=x, CI=F)$ace
   Value <- c(x, Intern)
   Hessian <- getMLHessian(Value, phyInit)
   se <- sqrt(diag(solve(Hessian)))
   se <- se[-1]
   tmp <- se*qt(0.025, nN)
   CI95 <- cbind(lower=Intern+tmp, upper=Intern-tmp)
  },
  REML={
   minusLogLik <- function(sig2) {
    if (sig2 < 0) return(1e+100)
    V <- sig2 * vcv(phyInit)
    distval <- stats::mahalanobis(x, center = mu, cov = V)
    logdet <- sum(log(eigen(V, symmetric = TRUE, only.values = TRUE)$values))
    (nT * log(2 * pi) + logdet + distval)/2
   }
   Intern <- glsBM(phy=phyInit, x=x, CI=F)$ace
   Value <- c(x, Intern)
   GM <- Intern[1]
   mu <- rep(GM, nT)
   out <- nlm(minusLogLik, 1, hessian = FALSE)
   sigma2 <- out$estimate
   Hessian <- getREMLHessian(Value, phyInit, sigma2)
   se <- sqrt(diag(solve(Hessian)))
   tmp <- se*qt(0.025, nN)
   CI95 <- cbind(lower=Intern+tmp, upper=Intern-tmp)
  },
  GLS = {
	result <- glsBM(phy=phyInit, x=x, CI=T)
    Intern <- result$ace
    CI95 <- result$CI95
  },
  GLS_ABM = {
	result <- glsABM(phy=phyInit, x=x, CI=T)
    Intern <- result$ace
    CI95 <- result$CI95
  },
  GLS_OUS = {
	if(is.null(alpha)) {
		funOpt1 <- function(alpha)
		{
			-glsOUv1(phy=phyInit, x=x, alpha, CI=F)$LLik
		}
		calOp <- optim(par=0.25, fn=funOpt1, method="Brent", lower=0.001, upper=1)
		if (calOp$convergence == 0)
		{
			alpha <- calOp$par
		} else {
			stop("Estimation error for alpha")
		}
	}
	result <- glsOUv1(phy=phyInit, x=x, alpha=alpha, CI=T)
    Intern <- result$ace
    CI95 <- result$CI95
  },
  GLS_OU = {
	if(is.null(alpha)) {
		funOpt2 <- function(alpha)
		{
			-glsOUv2(phy=phyInit, x=x, alpha, CI=F)$LLik
		}
		calOp <- optim(par=0.25, fn=funOpt2, method="Brent", lower=0.001, upper=1)
		if (calOp$convergence == 0)
		{
			alpha <- calOp$par
		} else {
			stop("Estimation error for alpha")
		}
	}
	result <- glsOUv2(phy=phyInit, x=x, alpha=alpha, CI=T)
    Intern <- result$ace
    CI95 <- result$CI95
  }
 )
if (CI==TRUE)
 list(ace=Intern, CI95=CI95)
else
  list(ace=Intern)
}

## write.dna.R (2018-03-26)

##   Write DNA Sequences in a File

## Copyright 2003-2018 Emmanuel Paradis

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

write.dna <- function(x, file, format = "interleaved", append = FALSE,
                      nbcol = 6, colsep = " ", colw = 10, indent = NULL,
                      blocksep = 1)
{
    format <- match.arg(format, c("interleaved", "sequential", "fasta"))
    phylip <- if (format %in% c("interleaved", "sequential")) TRUE else FALSE
    if (inherits(x, "DNAbin")) x <- as.character(x)
    aligned <- TRUE
    if (is.matrix(x)) {
        N <- dim(x)
        S <- N[2]
        N <- N[1]
        xx <- vector("list", N)
        for (i in 1:N) xx[[i]] <- x[i, ]
        names(xx) <- rownames(x)
        x <- xx
        rm(xx)
    } else {
        N <- length(x)
        S <- unique(lengths(x, use.names = FALSE))
        if (length(S) > 1) aligned <- FALSE
    }
    if (is.null(names(x))) names(x) <- as.character(1:N)
    if (is.null(indent))
      indent <- if (phylip) 10 else  0
    if (is.numeric(indent))
        indent <- paste(rep(" ", indent), collapse = "")
    if (format == "interleaved") {
        blocksep <- paste(rep("\n", blocksep), collapse = "")
        if (nbcol < 0) format <- "sequential"
    }
    zz <- if (append) file(file, "a") else file(file, "w")
    on.exit(close(zz))
    if (phylip) {
        if (!aligned)
            stop("sequences must have the same length for
 interleaved or sequential format.")
        cat(N, " ", S, "\n", sep = "", file = zz)
        if (nbcol < 0) {
            nb.block <- 1
            nbcol <- totalcol <- ceiling(S/colw)
        } else {
            nb.block <- ceiling(S/(colw * nbcol))
            totalcol <- ceiling(S/colw)
        }
        ## Prepare the sequences in a matrix whose elements are
        ## strings with `colw' characters.
        SEQ <- matrix("", N, totalcol)
        for (i in 1:N) {
            X <- paste(x[[i]], collapse = "")
            for (j in 1:totalcol)
                SEQ[i, j] <- substr(X, 1 + (j - 1)*colw, colw + (j - 1)*colw)
        }
        ## Prepare the names so that they all have the same nb of chars
        max.nc <- max(nchar(names(x)))
        ## always put a space between the sequences and the taxa names
        fmt <- paste("%-", max.nc + 1, "s", sep = "")
        names(x) <- sprintf(fmt, names(x))
    }
    switch(format, "interleaved" = {
        ## Write the first block with the taxon names
        colsel <- if (nb.block == 1) 1:totalcol else 1:nbcol
        for (i in 1:N) {
            cat(names(x)[i], file = zz)
            cat(SEQ[i, colsel], sep = colsep, file = zz)
            cat("\n", file = zz)
        }
        ## Write eventually the other blocks
        if (nb.block > 1) {
            for (k in 2:nb.block) {
                cat(blocksep, file = zz)
                endcolsel <- if (k == nb.block) totalcol else nbcol + (k - 1)*nbcol
                for (i in 1:N) {
                    cat(indent, file = zz)
                    cat(SEQ[i, (1 + (k - 1)*nbcol):endcolsel], sep = colsep, file = zz)
                    cat("\n", file = zz)
                }
            }
        }

    }, "sequential" = {
        if (nb.block == 1) {
            for (i in 1:N) {
                cat(names(x)[i], file = zz)
                cat(SEQ[i, ], sep = colsep, file = zz)
                cat("\n", file = zz)
            }
        } else {
            for (i in 1:N) {
                cat(names(x)[i], file = zz)
                cat(SEQ[i, 1:nbcol], sep = colsep, file = zz)
                cat("\n", file = zz)
                for (k in 2:nb.block) {
                    endcolsel <- if (k == nb.block) totalcol else nbcol + (k - 1)*nbcol
                    cat(indent, file = zz)
                    cat(SEQ[i, (1 + (k - 1)*nbcol):endcolsel], sep = colsep, file = zz)
                    cat("\n", file = zz)
                }
            }
        }
    }, "fasta" = {
        for (i in 1:N) {
            cat(">", names(x)[i], file = zz, sep = "")
            cat("\n", file = zz)
            X <- paste(x[[i]], collapse = "")
            S <- length(x[[i]])
            totalcol <- ceiling(S/colw)
            if (nbcol < 0) nbcol <- totalcol
            nb.lines <- ceiling(totalcol/nbcol)
            SEQ <- character(totalcol)
            for (j in 1:totalcol)
                SEQ[j] <- substr(X, 1 + (j - 1) * colw, colw + (j - 1) * colw)
            for (k in 1:nb.lines) {
                endsel <-
                    if (k == nb.lines) length(SEQ) else nbcol + (k - 1)*nbcol
                cat(indent, file = zz)
                cat(SEQ[(1 + (k - 1)*nbcol):endsel], sep = colsep, file = zz)
                cat("\n", file = zz)
            }
        }
    })
}

write.FASTA <- function(x, file, header = NULL, append = FALSE)
{
    dna <- inherits(x, "DNAbin")
    if (!dna && !inherits(x, "AAbin"))
        stop("data are apparently neither DNA nor AA sequences")
    if (!is.null(header)) {
        header <- as.character(header)
        if (!length(header) || !sum(nchar(header)) || is.na(header)) {
            warning("header cannot be coerced as character; was ignored")
            header <- NULL
        }
    }
    labs <- labels(x)
    if (is.matrix(x)) {
        s <- ncol(x) # always integer
        n <- nrow(x)
    } else {
        s <- -1L
        n <- length(x)
    }
    if (is.null(labs)) labs <- as.character(1:n)
    labs <- lapply(labs, charToRaw)
    if (!is.null(header)) {
        cat(header, sep = "\n", file = file, append = append)
    } else {
        if (!append) {
            if (file.exists(file)) file.remove(file)
            file.create(file)
        }
    }
    ## 'file' should always exist now
    file <- normalizePath(file)
    if (dna) .Call(writeDNAbinToFASTA, x, file, n, s, labs)
    else .Call(writeAAbinToFASTA, x, file, n, s, labs)
    invisible(NULL)
}

## balance.R (2015-07-08)

##   Balance of a Dichotomous Phylogenetic Tree

## Copyright 2002-2015 Emmanuel Paradis

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

balance <- function(phy)
{
    if (!inherits(phy, "phylo"))
      stop('object "phy" is not of class "phylo"')
    phy <- reorder(phy) # fix a bug reported by G. Valiente in January 2009 (2015-07-08)
    N <- length(phy$tip.label)
    nb.node <- phy$Nnode
    if (nb.node != N - 1)
      stop('"phy" is not rooted and fully dichotomous')
    ans <- matrix(NA, nb.node, 2)
    foo <- function(node, n) {
        s <- which(phy$edge[, 1] == node)
        desc <- phy$edge[s, 2]
        ans[node - N, 1] <<- n1 <- (s[2] - s[1] + 1)/2
        ans[node - N, 2] <<- n2 <- n - n1
        if (desc[1] > N) foo(desc[1], n1)
        if (desc[2] > N) foo(desc[2], n2)
    }
    foo(N + 1, N)
    rownames(ans) <-
      if (is.null(phy$node.label)) N + 1:nb.node else phy$node.label
    ans
}

## coalescent.intervals.R (2002-09-12)

##   Constructs objects with information on coalescent intervals

## Copyright 2002 Korbinian Strimmer

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

coalescent.intervals <- function(x) UseMethod("coalescent.intervals")

# set up coalescent interval object (from NH tree)
coalescent.intervals.phylo <- function(x)
{
    if (class(x) != "phylo") stop("object \"x\" is not of class \"phylo\"")

    # ensure we have a BINARY tree
    if (!is.binary.phylo(x)) stop("object \"x\" is not a binary tree")
    # ordered branching times
    t <- sort(branching.times(x))
    lt <- length(t)

    # interval widths
    w <- numeric(lt)
    w[1] <- t[1]
    for (i in 2:lt) w[i] <- t[i] - t[i - 1]

    l <- (lt+1):2       # number of lineages

    obj <- list(
     lineages=l,
     interval.length=w,
     interval.count=lt,
     total.depth =sum(w))
    class(obj) <- "coalescentIntervals"
    return(obj)
}


# set up coalescent interval object from vector of interval length
coalescent.intervals.default <- function(x)
{
  if (!is.vector(x)) stop("argument \"x\" is not a vector of interval lengths")

  # x = list of the widths of each interval
  lt <- length(x)
  l <- (lt+1):2           # number of lineages at the beginning of each interval

  obj <- list(
     lineages=l,
     interval.length=x,
     interval.count=lt,
     total.depth =sum(x))
    class(obj) <- "coalescentIntervals"
    return(obj)
}

## ltt.plot.R (2012-03-05)

##    Lineages Through Time Plot

## Copyright 2002-2012 Emmanuel Paradis

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

ltt.plot.coords <- function(phy, backward = TRUE, tol = 1e-6)
{
    if (is.ultrametric(phy, tol)) {
        if (is.binary.phylo(phy)) {
            N <- numeric(phy$Nnode + 1)
            N[] <- 1
        } else {
            node.order <- tabulate(phy$edge[, 1])
            N <- node.order[-(1:length(phy$tip.label))] - 1
        }
        bt <- branching.times(phy)
        names(bt) <- NULL
        o <- order(bt, decreasing = TRUE)
        time <- c(-bt[o], 0)
        if (!is.binary.phylo(phy)) N <- c(1, N[o])
    } else {
        if (!is.binary.phylo(phy)) phy <- multi2di(phy)
        n <- Ntip(phy)
        m <- phy$Nnode
        ROOT <- n + 1L
        event <- time.event <- numeric(n + m)

        time.event[ROOT] <- 0
        phy <- reorder(phy)

        for (i in 1:nrow(phy$edge))
            time.event[phy$edge[i, 2]] <- time.event[phy$edge[i, 1]] + phy$edge.length[i]

        present <- max(time.event)
        event[1:n] <- -1
        event[ROOT:(n + m)] <- 1

        ## delete the events that are too close to present:
        past.event <- present - time.event > tol
        event <- event[past.event]
        time.event <- time.event[past.event]

        ## reorder wrt time:
        o <- order(time.event)
        time.event <- time.event[o]
        event <- event[o]

        time <- c(time.event - present, 0)
        N <- c(1, event)
    }
    N <- cumsum(N)
    if (!is.null(phy$root.edge)) {
        time <- c(time[1] - phy$root.edge, time)
        N <- c(1, N)
    }
    if (!backward) time <- time - time[1]
    cbind(time, N)
}

ltt.plot <- function(phy, xlab = "Time", ylab = "N",
                     backward = TRUE, tol = 1e-6, ...)
{
    if (!inherits(phy, "phylo"))
        stop("object \"phy\" is not of class \"phylo\"")

    xy <- ltt.plot.coords(phy, backward, tol)

    plot.default(xy, xlab = xlab, ylab = ylab, xaxs = "r",
                 yaxs = "r", type = "S", ...)
}

ltt.lines <- function(phy, backward = TRUE, tol = 1e-6, ...)
{
    xy <- ltt.plot.coords(phy, backward, tol)
    lines(xy, type = "S", ...)
}

mltt.plot <-
    function(phy, ..., dcol = TRUE, dlty = FALSE, legend = TRUE,
             xlab = "Time", ylab = "N", log = "", backward = TRUE, tol = 1e-6)
{
    if (inherits(phy, "phylo")) { # if a tree of class "phylo"
        TREES <- list(ltt.plot.coords(phy, backward, tol))
        names(TREES) <- deparse(substitute(phy))
    } else { # a list of trees
        TREES <- lapply(phy, ltt.plot.coords, backward = backward, tol = tol)
        names(TREES) <- names(phy)
        if (is.null(names(TREES)))
            names(TREES) <-
                paste(deparse(substitute(phy)), "-", 1:length(TREES))
    }
    dts <- list(...)
    n <- length(dts)
    if (n) {
        mc <- as.character(match.call())[-(1:2)]
        nms <- mc[1:n]
        for (i in 1:n) {
            if (inherits(dts[[i]], "phylo")) {
                a <- list(ltt.plot.coords(dts[[i]], backward, tol))
                names(a) <- nms[i]
            } else { # a list of trees
                a <- lapply(dts[[i]], ltt.plot.coords, backward = backward, tol = tol)
                names(a) <- names(dts[[i]])
                if (is.null(names(a)))
                    names(a) <- paste(deparse(substitute(phy)), "-", seq_along(a))
            }
            TREES <- c(TREES, a)
        }
    }
    n <- length(TREES)
    range.each.tree <- sapply(TREES, function(x) range(x[, 1]))
    xl <- range(range.each.tree)
    yl <- c(1, max(sapply(TREES, function(x) max(x[, 2]))))

    ## if backward is FALSE, we have to rescale the time scales of each tree:
    if (!backward) {
        for (i in seq_along(TREES)) {
            tmp <- TREES[[i]]
            tmp[, 1] <- tmp[, 1] + xl[2] - range.each.tree[2, i]
            TREES[[i]] <- tmp
        }
    }

    plot.default(NA, type = "n", xlim = xl, ylim = yl, xaxs = "r",
                 yaxs = "r", xlab = xlab, ylab = ylab, log = log)

    lty <- if (!dlty) rep(1, n) else 1:n
    col <- if (!dcol) rep(1, n) else topo.colors(n)

    for (i in 1:n)
        lines(TREES[[i]], col = col[i], lty = lty[i], type = "S")

    if (legend)
        legend(xl[1], yl[2], legend = names(TREES),
               lty = lty, col = col, bty = "n")
}

ltt.coplot <- function(phy, backward = TRUE, ...)
{
    layout(matrix(1:2, 2))
    par(mar = c(0, 3, 0.5, 0.5))
    o <- plot(phy, root.edge = TRUE, ...)
    par(mar = c(3, 3, 0, 0.5))
    ltt.plot(phy, xlim = o$x.lim, backward = FALSE, xaxt = "n")
    if (backward) axisPhylo() else axis(1)
}

## vcv.phylo.R (2012-02-21)

##   Phylogenetic Variance-Covariance or Correlation Matrix

## Copyright 2002-2012 Emmanuel Paradis

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

vcv <- function(phy, ...) UseMethod("vcv")

vcv.phylo <- function(phy, model = "Brownian", corr = FALSE, ...)
{
    if (is.null(phy$edge.length))
        stop("the tree has no branch lengths")

    pp <- prop.part(phy)

    phy <- reorder(phy, "postorder")

    n <- length(phy$tip.label)
    e1 <- phy$edge[, 1]
    e2 <- phy$edge[, 2]
    EL <- phy$edge.length

    ## xx: vecteur donnant la distance d'un noeud
    ##     ou d'un tip a partir de la racine
    ## (same than in is.ultrametric)
    xx <- numeric(n + phy$Nnode)

    vcv <- matrix(0, n, n)

    ## the loop below starts from the bottom of the edge matrix, so
    ## from the root

    for (i in length(e1):1) {
        var.cur.node <- xx[e1[i]]
        xx[e2[i]] <- var.cur.node + EL[i] # sets the variance
        j <- i - 1L
        while (e1[j] == e1[i] && j > 0) {
            left <- if (e2[j] > n) pp[[e2[j] - n]] else e2[j]
            right <- if (e2[i] > n) pp[[e2[i] - n]] else e2[i]
            vcv[left, right] <- vcv[right, left] <- var.cur.node # sets the covariance
            j <- j - 1L
        }
    }

    diag.elts <- 1 + 0:(n - 1)*(n + 1)
    vcv[diag.elts] <- xx[1:n]

    if (corr) {
        ## This is inspired from the code of cov2cor (2005-09-08):
        Is <- sqrt(1 / vcv[diag.elts])
        ## below 'vcv[] <- ...' has been changed to 'vcv <- ...'
        ## which seems to be twice faster for n = 1000 and
        ## respects the additional attributes (2012-02-21):
        vcv <- Is * vcv * rep(Is, each = n)
        vcv[diag.elts] <- 1
    }

    dimnames(vcv)[1:2] <- list(phy$tip.label)
    vcv
}

vcv.corPhyl <- function(phy, corr = FALSE, ...)
{
    labels <- attr(phy, "tree")$tip.label
    dummy.df <- data.frame(seq_along(labels), row.names = labels)
    res <- corMatrix(Initialize.corPhyl(phy, dummy.df), corr = corr)
    dimnames(res) <- list(labels, labels)
    res
}

`CADM.post` <-
	function(Dmat, nmat, n, nperm=99, make.sym=TRUE, weights=NULL, mult="holm", mantel=FALSE, silent=FALSE)
{
### Function to carry out a posteriori tests of the contribution of individual 
### matrices to the congruence of a group of distance matrices.
###
### copyleft - Pierre Legendre, December 2008
###
### Reference -
### Legendre, P. and F.-J. Lapointe. 2004. Assessing congruence among distance 
### matrices: single malt Scotch whiskies revisited. Australian and New Zealand 
### Journal of Statistics 46: 615-629.
###
### Parameters of the function --
###
### Dmat = A text file listing the distance matrices one after the other, with
###        or without blank lines.
###        Each matrix is in the form of a square distance matrix with 0's 
###        on the diagonal.
###
### nmat = number of distance matrices in file Dmat.
###
### n = number of objects in each distance matrix. All matrices have same n.
###
### nperm = number of permutations for the tests.
###
### make.sym = TRUE: turn asymmetric matrices into symmetric matrices by 
###            averaging the two triangular portions.
###          = FALSE: analyse asymmetric matrices as they are.
###
### weights = a vector of positive weights for the distance matrices. 
###           Example: weights = c(1,2,3)
###         = NULL (default): all matrices have same weight in calculation of W.
###
### mult = method for correcting P-values due to multiple testing. The methods 
###        are "holm" (default), "sidak", and "bonferroni". The Bonferroni 
###        correction is overly conservative; it is not recommended. It is 
###        included to allow comparisons with the other methods.
###
### mantel = TRUE: Mantel statistics are computed from ranked distances,
###          as well as permutational P-values.
###        = FALSE (default): Mantel statistics and tests are not computed.
###
### silent = TRUE: informative messages will not be printed, except stopping 
###          messages. Option useful for simulation work.
###        = FALSE: informative messages will be printed.
###
################################################################################
	
	mult <- match.arg(mult, c("sidak", "holm", "bonferroni"))
	if(nmat < 2) 
		stop("Analysis requested for a single D matrix: CADM is useless")
	
	a <- system.time({

    ## Check the input file
    if(ncol(Dmat) != n) 
    	stop("Error in the value of 'n' or in the D matrices themselves")
    nmat2 <- nrow(Dmat)/n
    if(nmat2 < nmat)  # OK if 'nmat' < number of matrices in the input file
    	stop("Number of input D matrices = ",nmat2,"; this value is < nmat")

    nd <- n*(n-1)/2
    if(is.null(weights)) {
    	w <- rep(1,nmat)
    	} else {
    	if(length(weights) != nmat) 
    		stop("Incorrect number of values in vector 'weights'")
    	if(length(which(weights < 0)) > 0) 
    		stop("Negative weights are not permitted")
    	w <- weights*nmat/sum(weights)
    	if(!silent) cat("Normalized weights =",w,'\n')
    	}
    
    ## Are asymmetric D matrices present?
    asy <- rep(FALSE, nmat)
	asymm <- FALSE
    end <- 0
    for(k in 1:nmat) {
        begin <- end+1
        end <- end+n
        D.temp <- Dmat[begin:end,]
        if(sum(abs(diag(as.matrix(D.temp)))) > 0) 
        	stop("Diagonal not 0: matrix #",k," is not a distance matrix")
        vec1 <- as.vector(as.dist(D.temp))
        vec2 <- as.vector(as.dist(t(D.temp)))
        if(sum(abs((vec1-vec2))) > 0) {
        	if(!silent) cat("Matrix #",k," is asymmetric",'\n')
        	asy[k] <- TRUE
        	asymm <- TRUE
        	}
        }
    D1 <- as.list(1:nmat)
    if(asymm) {
    	if(make.sym) {
    		if(!silent) cat("\nAsymmetric matrices were transformed to be symmetric",'\n')
    		} else {
    		nd <- nd*2
    		if(!silent) cat("\nAnalysis carried out on asymmetric matrices",'\n')
    		D2 <- as.list(1:nmat)
    		}
    	} else {
    	if(!silent) cat("Analysis of symmetric matrices",'\n')
    	}
    Y <- rep(NA,nd)
    
    ## String out the distance matrices (vec) and assemble them as columns into matrix 'Y'
    ## Construct also matrices of ranked distances D1[[k]] and D2[[k]] for permutation test
    end <- 0
    for(k in 1:nmat) {
        begin <- end+1
        end <- end+n
        D.temp <- as.matrix(Dmat[begin:end,])
        vec <- as.vector(as.dist(D.temp))
        if(asymm) {
        	if(!make.sym) {
        		## Analysis carried out on asymmetric matrices: 
        		## The ranks are computed on the whole matrix except the diagonal values.
        		## The two halves are stored as symmetric matrices in D1[[k]] and D2[[k]]
        		vec <- c(vec, as.vector(as.dist(t(D.temp))))
        		diag(D.temp) <- NA
                        D.temp2 <- rank(D.temp)
                        dim(D.temp2) <- dim(D.temp)   # Correction E. Paradis, 08may17
        		diag(D.temp2) <- 0
        		# cat("nrow =",nrow(D.temp2)," ncol =",ncol(D.temp2),'\n')
				# cat("Matrix ",k," min =",min(D.temp2)," max =",max(D.temp2),'\n')
				# cat("Matrix ",k," max values #",which(D.temp2 == max(D.temp2)),'\n')
        		D1[[k]] <- as.matrix(as.dist(D.temp2))
        		D2[[k]] <- as.matrix(as.dist(t(D.temp2)))
        		} else {
        		## Asymmetric matrices transformed to be symmetric, stored in D1[[k]]
        		vec <- (vec + as.vector(as.dist(t(D.temp)))) / 2
				D.temp2 <- (D.temp + t(D.temp)) / 2
				D.temp2 <- as.dist(D.temp2)
        		D.temp2[] <- rank(D.temp2)
				D.temp2 <- as.matrix(D.temp2)
        		D1[[k]] <- D.temp2
        		}
        	} else {
        	## Symmetric matrices are stored in D1[[k]]
        	D.temp2 <- as.dist(D.temp)
        	D.temp2[] <- rank(D.temp2)
        	D1[[k]] <- as.matrix(D.temp2)
        	}
        Y <- cbind(Y, vec)
        }
    Y <- as.matrix(Y[,-1])
    colnames(Y) <- colnames(Y,do.NULL = FALSE, prefix = "Dmat.")
    
    ## Begin calculations: compute reference value of S

		## Transform the distances to ranks, by column
		Rmat <- apply(Y,2,rank)

		## Compute the S = Sum-of-Squares of the row-marginal sums of ranks (eq. 1a)
		## The ranks are weighted during the sum by the vector of matrix weights 'w'
		sumRanks <- as.vector(Rmat%*%w)
		S <- (nd-1)*var(sumRanks)

    ## Begin a posteriori tests of individual matrices

    ## Statistics displayed for each matrix: "Mantel.mean" and "W.per.matrix"
	## Calculate the mean of the Mantel correlations on ranks for each matrix
	Mantel.cor <- cor(Rmat)
	diag(Mantel.cor) <- 0
	spear.mean <- as.vector(Mantel.cor%*%w)/(nmat-1)
	## Calculate Kendall's W for each variable
	## W.var <- ((nmat-1)*spear.mean+1)/nmat

	## P-value for each matrix: test of S, permuting values in matrix[[k]] only
	## as in program CADM.f (2004)
	## Initialize the counters
	counter <- rep(1,nmat)

	## Test each matrix 'k' in turn
	for(k in 1:nmat) {
		## Create a new Rmat table where the permuted column has been removed
		Rmat.mod <- Rmat[,-k]
				
		## Permutation loop: string out permuted matrix 'k' only
		for(j in 1:nperm) {
			order <- sample(n)
			if(asymm & !make.sym) {
				## For asymmetric matrices: permute the values within each triangular 
				## portion, stored as square matrices in D1[[]] and D2[[]]
				vec <- as.vector(as.dist(D1[[k]][order,order]))
			    vec <- c(vec, as.vector(as.dist(D2[[k]][order,order])))
				} else {
				vec <- as.vector(as.dist(D1[[k]][order,order]))
				}
			Rmat.perm <- cbind(Rmat.mod, vec)
			S.perm <- (nd-1)*var(as.vector(Rmat.perm%*%w))
			if(S.perm >= S) counter[k] <- counter[k]+1
		}
	}

	## Calculate P-values
	counter <- counter/(nperm+1)
	
	## Correction to P-values for multiple testing
		if(mult == "sidak") {
			vec.corr = NA
			for(i in 1:nmat) vec.corr = c(vec.corr, (1-(1-counter[i])^nmat))
			vec.corr <- vec.corr[-1]
			}
		if(mult == "holm") vec.corr <- p.adjust(counter, method="holm")
		if(mult == "bonferroni") vec.corr <- p.adjust(counter, method="bonferroni")

	## Create a data frame containing the results
		# table <- rbind(spear.mean, W.var, counter, vec.corr)
		# rownames(table) <- c("Mantel.mean", "W.per.matrix", "Prob", "Corrected prob")
		table <- rbind(spear.mean, counter, vec.corr)
		rownames(table) <- c("Mantel.mean", "Prob", "Corrected.prob")
		colnames(table) <- colnames(table,do.NULL = FALSE, prefix = "Dmat.")
	
	## Mantel tests
	if(mantel) {
		diag(Mantel.cor) <- 1
		rownames(Mantel.cor) <- colnames(table)
		colnames(Mantel.cor) <- colnames(table)
		Mantel.prob <- matrix(1,nmat,nmat)
		rownames(Mantel.prob) <- colnames(table)
		colnames(Mantel.prob) <- colnames(table)
		
		for(j in 1:nperm) {   # Each matrix is permuted independently
	    	                  # There is no need to permute the last matrix
			Rmat.perm <- rep(NA,nd)
			##
			if(asymm & !make.sym) {
				## For asymmetric matrices: permute the values within each triangular 
				## portion, stored as square matrices in D1[[]] and D2[[]]
				for(k in 1:(nmat-1)) {
					order <- sample(n)
					vec <- as.vector(as.dist(D1[[k]][order,order]))
			    	vec <- c(vec, as.vector(as.dist(D2[[k]][order,order])))
					Rmat.perm <- cbind(Rmat.perm, vec)
					}
					vec <- as.vector(as.dist(D1[[nmat]]))
			    	vec <- c(vec, as.vector(as.dist(D2[[nmat]])))
					Rmat.perm <- cbind(Rmat.perm, vec)
				} else {
				for(k in 1:(nmat-1)) {
					order <- sample(n)
					vec <- as.vector(as.dist(D1[[k]][order,order]))
					Rmat.perm <- cbind(Rmat.perm, vec)
					}
					vec <- as.vector(as.dist(D1[[nmat]]))
					Rmat.perm <- cbind(Rmat.perm, vec)
				}
			# Remove the first column of Rmat.perm containing NA
			Rmat.perm <- as.matrix(Rmat.perm[,-1])
			# Compute Mantel correlations on ranks under permutation
			Mantel.cor.perm <- cor(Rmat.perm)
			for(j2 in 1:(nmat-1)) { # Compute prob in the upper tail
				for(j1 in (j2+1):nmat) {
					if(Mantel.cor.perm[j1,j2] >= Mantel.cor[j1,j2]) Mantel.prob[j1,j2] <- Mantel.prob[j1,j2]+1
					}
				}
			}
		Mantel.prob <- as.matrix(as.dist(Mantel.prob/(nperm+1)))
		diag(Mantel.prob) <- NA # Corrected 08feb13
		}
	
	})
	a[3] <- sprintf("%2f",a[3])
	if(!silent) cat("Time to compute a posteriori tests (per matrix) =",a[3]," sec",'\n')

	out <- list(A_posteriori_tests=table, Correction.type=mult)

	if(mantel) {
		out$Mantel.cor  <- Mantel.cor
		out$Mantel.prob <- Mantel.prob
		}
	out$nperm <- nperm
	class(out) <- "CADM.post"
	out
}

## diversi.time.R (2007-09-22)

##   Analysis of Diversification with Survival Models

## Copyright 2002-2007 Emmanuel Paradis

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

diversi.time <- function(x, census = NULL, censoring.codes = c(1, 0),
                         Tc = NULL)
{
    n <- length(x)
    if (is.null(census)) {
        k <- n
        census <- rep(censoring.codes[1], n)
    }
    else k <- sum(census == censoring.codes[1])
    u <- n - k
    S <- sum(x)
    delta <- k / S
    var.delta <- delta^2 / k
    loglik.A <- k * log(delta) - delta * S
    tk <- x[census == censoring.codes[1]]
    tu <- x[census == censoring.codes[2]]
    fb <- function(b)
      1/b - sum(x^b * log(x))/sum(x^b) + sum(log(tk))/k
    beta <- uniroot(fb, interval = c(1e-7, 10))$root
    Sp <- sum(x^beta)
    alpha <- (k / Sp)^(1/beta)
    var.alpha <- 1/ ((k * beta / alpha^2) + beta * (beta - 1) * alpha^(beta - 2) * Sp)
    ax <- alpha * x
    var.beta <- 1 / (k / beta^2 + sum(ax^beta * log(ax)))
    loglik.B <- k*(log(alpha) + log(beta)) +
      (beta - 1)*(k*log(alpha) + sum(log(tk)))- Sp * alpha^beta
    if (is.null(Tc)) Tc <- median(x)
    tk1 <- tk[tk < Tc]
    tk2 <- tk[tk >= Tc]
    tu1 <- tu[tu < Tc]
    tu2 <- tu[tu >= Tc]
    k1 <- length(tk1)
    k2 <- k - k1
    u1 <- length(tu1)
    u2 <- u - u1
    tmp <- (k2 + u2) * Tc
    delta1 <- k1 / (sum(tk1) + sum(tu1) + tmp)
    delta2 <- k2 / (sum(tk2) + sum(tu2) - tmp)
    var.delta1 <- delta1^2 / k1
    var.delta2 <- delta2^2 / k2
    tmp <- Tc * (delta2 - delta1)
    loglik.C <- k1 * log(delta1) - delta1 * sum(tk1) + k2 * log(delta2) +
                  k2 * tmp - delta2 * sum(tk2) - delta1 * sum(tu1) +
                    u2 * tmp - delta2 * sum(tu2)
    cat("\nAnalysis of Diversification with Survival Models\n\n")
    cat("Data:", deparse(substitute(x)), "\n")
    cat("Number of branching times:", n, "\n")
    cat("         accurately known:", k, "\n")
    cat("                 censored:", u, "\n\n")
    cat("Model A: constant diversification\n")
    cat("    log-likelihood =", round(loglik.A, 3),
        "   AIC =", round(-2 * loglik.A + 2, 3), "\n")
    cat("    delta =", round(delta, 6), "   StdErr =", round(sqrt(var.delta), 6), "\n\n")
    cat("Model B: diversification follows a Weibull law\n")
    cat("    log-likelihood =", round(loglik.B, 3),
        "   AIC =", round(-2 * loglik.B + 4, 3), "\n")
    cat("    alpha =", round(alpha, 6), "   StdErr =", round(sqrt(var.alpha), 6), "\n")
    cat("     beta =", round(beta, 6), "   StdErr =", round(sqrt(var.beta), 6), "\n\n")
    cat("Model C: diversification changes with a breakpoint at time =", Tc, "\n")
    cat("    log-likelihood =", round(loglik.C, 3),
        "   AIC =", round(-2 * loglik.C + 4, 3), "\n")
    cat("    delta1 =", round(delta1, 6), "   StdErr =", round(sqrt(var.delta1), 6), "\n")
    cat("    delta2 =", round(delta2, 6), "   StdErr =", round(sqrt(var.delta2), 6), "\n\n")
    cat("Likelihood ratio tests:\n")
    c1 <- 2 * (loglik.B - loglik.A)
    p1 <- round(1 - pchisq(c1, 1), 4)
    c2 <- 2 * (loglik.C - loglik.A)
    p2 <- round(1 - pchisq(c2, 1), 4)
    cat("    Model A vs. Model B: chi^2 =", round(c1, 3), "   df = 1,    P =", p1, "\n")
    cat("    Model A vs. Model C: chi^2 =", round(c2, 3), "   df = 1,    P =", p2, "\n")
}

## CDF.birth.death.R (2019-11-07)

## Functions to Simulate and Fit Time-Dependent Birth-Death Models

## Copyright 2010-2019 Emmanuel Paradis

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

integrateTrapeze <- function(FUN, from, to, nint = 10)
## compute an integral with a simple trapeze method
## (apparently, Vectorize doesn't give faster calculation)
{
    x <- seq(from = from, to = to, length.out = nint + 1)
    ## reorganized to minimize the calls to FUN:
    out <- FUN(x[1]) + FUN(x[length(x)])
    for (i in 2:nint) out <- out + 2 * FUN(x[i])
    (x[2] - x[1]) * out/2 # (x[2] - x[1]) is the width of the trapezes
}

## case:
## 1: birth and death rates constant
## 2: no primitive available
## 3: primitives are available
## 4: death rate constant, no primitive available
## 5: birth rate constant, no primitive available
## 6: death rate constant, primitive available for birth(t)
## 7: birth rate constant, primitive available for death(t)

.getCase <- function(birth, death, BIRTH = NULL, DEATH = NULL)
{
    if (is.numeric(birth)) {
        if (is.numeric(death)) 1 else {
            if (is.null(DEATH)) 5 else 7
        }
    } else {
        if (is.numeric(death)) {
            if (is.null(BIRTH)) 4 else 6
        } else if (is.null(BIRTH) || is.null(DEATH)) 2 else 3
    }
}

## if (getRversion() >= "2.15.1") -- R 3.2.0 is required for ape
utils::globalVariables("Tmax")

.getRHOetINT <- function(birth, death, BIRTH = NULL, DEATH = NULL, case, fast)
{
    ## build the RHO(), \rho(t), and INT(), I(t), functions
    switch (case,
        { # case 1:
            RHO <- function(t1, t2) (t2 - t1)*(death - birth)
            INT <- function(t) {
                rho <- death - birth
                death*(exp(rho*(Tmax - t)) - 1)/rho
            }
        },{ # case 2:
            if (fast) {
                RHO <- function(t1, t2)
                    integrateTrapeze(function(t) death(t) - birth(t), t1, t2)
                INT <- function(t) {
                    FOO <- function(u) exp(RHO(t, u)) * death(u)
                    integrateTrapeze(FOO, t, Tmax)
                }
            } else {
                RHO <- function(t1, t2)
                    integrate(function(t) death(t) - birth(t), t1, t2)$value
                INT <- function(t) {
                    FOO <- function(u) exp(RHO(t, u)) * death(u)
                    integrate(Vectorize(FOO), t, Tmax)$value # Vectorize required
                }
            }
        },{ # case 3:
            RHO <- function(t1, t2)
                DEATH(t2) - BIRTH(t2) - DEATH(t1) + BIRTH(t1)
            INT <- function(t) { # vectorized
                FOO <- function(u) exp(RHO(tt, u)) * death(u)
                out <- t
                for (i in 1:length(t)) {
                    tt <- t[i]
                    out[i] <- integrate(FOO, tt, Tmax)$value
                }
                out
            }
        },{ # case 4:
            if (fast) {
                RHO <- function(t1, t2)
                    death * (t2 - t1) - integrateTrapeze(birth, t1, t2)
                INT <- function(t) {
                    FOO <- function(u) exp(RHO(t, u)) * death
                    integrateTrapeze(Vectorize(FOO), t, Tmax)
                }
            } else {
                RHO <- function(t1, t2)
                    death * (t2 - t1) - integrate(birth, t1, t2)$value
                INT <- function(t) {
                    FOO <- function(u) exp(RHO(t, u)) * death
                    integrate(Vectorize(FOO), t, Tmax)$value
                }
            }
        },{ # case 5:
            RHO <- function(t1, t2)
                integrate(death, t1, t2)$value - birth * (t2 - t1)
            if (fast) {
                INT <- function(t) {
                    FOO <- function(u) exp(RHO(t, u)) * death(u)
                    integrateTrapeze(FOO, t, Tmax)
                }
            } else {
                INT <- function(t) {
                    FOO <- function(u) exp(RHO(t, u)) * death(u)
                    integrate(Vectorize(FOO), t, Tmax)$value
                }
            }
        },{ # case 6:
            RHO <- function(t1, t2) death * (t2 - t1) - BIRTH(t2) + BIRTH(t1)
            INT <- function(t) { # vectorized
                FOO <- function(u) exp(RHO(tt, u)) * death
                out <- t
                for (i in 1:length(t)) {
                    tt <- t[i]
                    out[i] <- integrate(FOO, tt, Tmax)$value
                }
                out
            }
        },{ # case 7:
            RHO <- function(t1, t2) DEATH(t2) - DEATH(t1) - birth * (t2 - t1)
            if (fast) {
                INT <- function(t) {
                    FOO <- function(u) exp(RHO(t, u)) * death(u)
                    integrateTrapeze(FOO, t, Tmax)
                }
            } else {
                INT <- function(t) {
                    FOO <- function(u) exp(RHO(t, u)) * death(u)
                    integrate(Vectorize(FOO), t, Tmax)$value
                }
            }
        })
    list(RHO, INT)
}

CDF.birth.death <-
    function(birth, death, BIRTH = NULL, DEATH = NULL, Tmax, x, case, fast = FALSE)
{
    ff <- .getRHOetINT(birth, death, BIRTH, DEATH, case, fast)
    RHO <- ff[[1]]
    INT <- ff[[2]]
    environment(INT) <- environment() # so that INT() can find Tmax
    .CDF.birth.death2(RHO, INT, birth, death, BIRTH, DEATH,
                      Tmax, x, case, fast)
}

.CDF.birth.death2 <-
    function(RHO, INT, birth, death, BIRTH, DEATH, Tmax, x, case, fast)
{
    Pi <- if (case %in% c(1, 5, 7))
        function(t) (1/(1 + INT(t)))^2 * 2 * exp(-RHO(0, t)) * birth
    else
        function(t) (1/(1 + INT(t)))^2 * 2 * exp(-RHO(0, t)) * birth(t)

    if (!case %in% c(1, 3, 6)) Pi <- Vectorize(Pi)

    denom <-
        if (fast) integrateTrapeze(Pi, 0, Tmax)
        else integrate(Pi, 0, Tmax)$value
    n <- length(x)
    p <- numeric(n)
    if (fast) {
        for (i in 1:n) p[i] <- integrateTrapeze(Pi, 0, x[i])
    } else {
        for (i in 1:n) p[i] <- integrate(Pi, 0, x[i])$value
    }
    p/denom
}

.makePhylo <- function(edge, edge.length, i)
{
    NODES <- edge > 0
    edge[NODES] <- edge[NODES] + i + 1L
    edge[!NODES] <- 1:(i + 1L)

    phy <- list(edge = edge, edge.length = edge.length,
                tip.label = paste("t", 1:(i + 1), sep = ""), Nnode = i)
    class(phy) <- "phylo"
    attr(phy, "order") <- "cladewise"
    phy
}

rlineage <-
    function(birth, death, Tmax = 50, BIRTH = NULL, DEATH = NULL, eps = 1e-6)
{
    case <- .getCase(birth, death, BIRTH, DEATH)

    rTimeToEvent <- function(t)
    {
        ## CDF of the times to event (speciation or extinction):
        switch (case,
            { # case 1:
                Foo <- function(t, x)
                    1 - exp(-(birth + death)*(x - t))
            },{ # case 2:
                Foo <- function(t, x) {
                    if (t == x) return(0)
                    1 - exp(-integrate(function(t) birth(t) + death(t),
                                       t, x)$value)
                }
            },{ # case 3:
                Foo <- function(t, x) {
                    if (t == x) return(0)
                    1 - exp(-(BIRTH(x) - BIRTH(t) + DEATH(x) - DEATH(t)))
                }
            },{ # case 4:
                Foo <- function(t, x) {
                    if (t == x) return(0)
                    1 - exp(-(integrate(function(t) birth(t), t, x)$value
                              + death*(x - t)))
                }

            },{ # case 5:
                Foo <- function(t, x) {
                    if (t == x) return(0)
                    1 - exp(-(birth*(x - t) +
                              integrate(function(t) death(t), t, x)$value))
                }

            },{ # case 6:
                Foo <- function(t, x) {
                    if (t == x) return(0)
                    1 - exp(-(BIRTH(x) - BIRTH(t) + death*(x - t)))
                }

            },{ # case 7:
                Foo <- function(t, x) {
                    if (t == x) return(0)
                    1 - exp(-(birth*(x - t) + DEATH(x) - DEATH(t)))
                }
            })

        ## generate a random time to event by the inverse method:
        P <- runif(1)
        ## in case speciation probability is so low
        ## that time to speciation is infinite:
        if (Foo(t, Tmax) < P) return(Tmax + 1)
        inc <- 10
        x <- t + inc
        while (inc > eps) { # la precision influe sur le temps de calcul
            if (Foo(t, x) > P) {
                x <- x - inc
                inc <- inc/10
            } else x <- x + inc
        }
        x - t
    }

    if (case == 1)
        speORext <- function(t) birth/(birth + death)
    if (case == 2 || case == 3)
        speORext <- function(t) birth(t)/(birth(t) + death(t))
    if (case == 4 || case == 6)
        speORext <- function(t) birth(t)/(birth(t) + death)
    if (case == 5 || case == 7)
        speORext <- function(t) birth/(birth + death(t))

    ## the recursive function implementing algorithm 1
    foo <- function(node) {
        for (k in 0:1) {
            X <- rTimeToEvent(t[node])
            tmp <- t[node] + X
            ## is the event a speciation or an extinction?
            if (tmp >= Tmax) {
                Y <- 0
                tmp <- Tmax
            } else Y <- rbinom(1, size = 1, prob = speORext(tmp))
            j <<- j + 1L
            edge.length[j] <<- tmp - t[node]
            if (Y) {
                i <<- i + 1L
                t[i] <<- tmp
                ## set internal edge:
                edge[j, ] <<- c(node, i)
                foo(i)
            } else
                ## set terminal edge:
                edge[j, ] <<- c(node, 0L)
        }
    }

    edge <- matrix(0L, 1e5, 2)
    edge.length <- numeric(1e5)
    j <- 0L; i <- 1; t <- 0
    foo(1L)
    .makePhylo(edge[1:j, ], edge.length[1:j], i)
}

drop.fossil <- function(phy, tol = 1e-8)
{
    n <- Ntip(phy)
    x <- dist.nodes(phy)[n + 1, ][1:n]
    drop.tip(phy, which(x < max(x) - tol))
}

rbdtree <-
    function(birth, death, Tmax = 50, BIRTH = NULL, DEATH = NULL, eps = 1e-6)
{
    case <- .getCase(birth, death, BIRTH, DEATH)
    ff <- .getRHOetINT(birth, death, BIRTH, DEATH, case, FALSE)
    RHO <- ff[[1]]
    INT <- ff[[2]]
    ## so that RHO() and INT() can find Tmax:
    environment(RHO) <- environment(INT) <- environment()

    rtimetospe <- function(t)
    {
        ## CDF of the times to speciation:
        Foo <- if (case %in% c(1, 5, 7))
            function(t, x) 1 - exp(-birth*(x - t))
        else {
            if (case %in% c(3, 6))
                function(t, x) 1 - exp(-(BIRTH(x) - BIRTH(t)))
            else {
                function(t, x) {
                    if (t == x) return(0)
                    1 - exp(-integrate(birth, t, x)$value)
                }
            }
        }
        ## generate a random time to speciation by the inverse method:
        P <- runif(1)
        ## in case speciation probability is so low
        ## that time to speciation is infinite:
        if (Foo(t, Tmax) < P) return(Tmax + 1)
        inc <- 10
        x <- t + inc
        while (inc > eps) { # la precision influe sur le temps de calcul
            if (Foo(t, x) > P) {
                x <- x - inc
                inc <- inc/10
            } else x <- x + inc
        }
        x - t
    }

    ## the recursive function implementing algorithm 2
    foo <- function(node, start) {
        node <- node # make a local copy
        for (k in 0:1) {
            tau <- start # because tau is changed below
            NoDesc <- TRUE
            X <- rtimetospe(tau)
            while (X < Tmax - tau) {
                tau <- tau + X
                ## does the new lineage survive until Tmax?
                Y <- rbinom(1, size = 1, prob = 1/(1 + INT(tau)))
                if (Y) {
                    i <<- i + 1L
                    t[i] <<- tau
                    ## set internal edge:
                    j <<- j + 1L
                    edge[j, ] <<- c(node, i)
                    edge.length[j] <<- tau - t[node]
                    foo(i, t[i])
                    NoDesc <- FALSE
                    break
                }
                X <- rtimetospe(tau)
            }
            ## set terminal edge:
            if (NoDesc) {
                j <<- j + 1L
                edge[j, 1] <<- node # the 2nd column is already set to 0
                edge.length[j] <<- Tmax - t[node]
            }
        }
    }

    edge <- matrix(0L, 1e5, 2)
    edge.length <- numeric(1e5)
    j <- 0L; i <- 1L; t <- 0
    foo(1L, 0)
    .makePhylo(edge[1:j, ], edge.length[1:j], i)
}

bd.time <- function(phy, birth, death, BIRTH = NULL, DEATH = NULL,
                    ip, lower, upper, fast = FALSE, boot = 0, trace = 0)
{
    guess.bounds <- if (missing(lower)) TRUE else FALSE
    BIG <- 1e10
    PrNt <- function(t, T, x)
    {
        tmp <- exp(-RHO(t, T))
        Wt <- tmp * (1 + INT(t))
        out <- numeric(length(x))
        zero <- x == 0
        if (length(zero)) {
            out[zero] <- 1 - tmp/Wt
            out[!zero] <- (tmp/Wt^2)*(1 - 1/Wt)^(x[!zero] - 1)
        } else out[] <- (tmp/Wt^2)*(1 - 1/Wt)^(x - 1)
        out
    }

    case <- .getCase(birth, death, BIRTH, DEATH)

    if (is.function(birth)) {
        paranam <- names(formals(birth))
        if (guess.bounds) {
            upper <- rep(BIG, length(paranam))
            lower <- -upper
        }
        formals(birth) <- alist(t=)
        environment(birth) <- environment()
        if (!is.null(BIRTH)) environment(BIRTH) <- environment()
    } else {
        paranam <- "birth"
        if (guess.bounds) {
            upper <- 1
            lower <- 0
        }
    }

    if (is.function(death)) {
        tmp <- names(formals(death))
        np2 <- length(tmp)
        if (guess.bounds) {
            upper <- c(upper, rep(BIG, np2))
            lower <- c(lower, rep(-BIG, np2))
        }
        paranam <- c(paranam, tmp)
        formals(death) <- alist(t=)
        environment(death) <- environment()
        if (!is.null(DEATH)) environment(DEATH) <- environment()
    } else {
        paranam <- c(paranam, "death")
        if (guess.bounds) {
            upper <- c(upper, .1)
            lower <- c(lower, 0)
        }
    }

    np <- length(paranam)

    ff <- .getRHOetINT(birth, death, BIRTH, DEATH, case = case, fast = fast)
    RHO <- ff[[1]]
    INT <- ff[[2]]
    environment(RHO) <- environment(INT) <- environment()

    x <- branching.times(phy)
    n <- length(x)
    Tmax <- x[1]
    x <- Tmax - x # change the time scale so the root is t=0
    x <- sort(x)

    foo <- function(para) {
        for (i in 1:np)
            assign(paranam[i], para[i], pos = sys.frame(1))
        p <- CDF.birth.death(birth, death, BIRTH, DEATH, Tmax = Tmax,
                             x = x, case = case, fast = fast)
        ## w is the probability of the observed tree size (= number of tips)
        w <- PrNt(0, Tmax, Ntip(phy))
        ## p is the expected CDF of branching times
        ## ecdf(x)(x) is the observed CDF
        sum((1:n/n - p)^2)/w # faster than sum((ecdf(x)(x) - p)^2)/w
    }

    if (missing(ip)) ip <- (upper - lower)/2

    out <- nlminb(ip, foo, control = list(trace = trace, eval.max = 500),
                  upper = upper, lower = lower)

    names(out$par) <- paranam
    names(out)[2] <- "SS"

    if (boot) { # nonparametric version
        PAR <- matrix(NA, boot, np)
        i <- 1L
        while (i <= boot) {
            cat("\rDoing bootstrap no.", i, "\n")
            x <- sort(sample(x, replace = TRUE))
            o <- try(nlminb(ip, foo, control = list(trace = 0, eval.max = 500),
                            upper = upper, lower = lower))
            if (class(o) == "list") {
                PAR[i, ] <- o$par
                i <- i + 1L
            }
        }
        out$boot <- PAR
    }
    out
}

LTT <- function(birth = 0.1, death = 0, N = 100, Tmax = 50, PI = 95,
                scaled = TRUE, eps = 0.1, add = FALSE, backward = TRUE,
                ltt.style = list("black", 1, 1),
                pi.style = list("blue", 1, 2), ...)
{
    case <- .getCase(birth, death, NULL, NULL)
    Time <- seq(0, Tmax, eps)
    F <- CDF.birth.death(birth, death, BIRTH = NULL, DEATH = NULL,
                         Tmax = Tmax, x = Time, case = case, fast = TRUE)
    if (PI) {
        i <- (1 - PI/100)/2
        Flow <- qbinom(i, N - 2, F)
        Fup <- qbinom(1 - i, N - 2, F)
        if (scaled) {
            Flow <- Flow/N
            Fup <- Fup/N
        }
    }
    if (!scaled) F <- F * N
    if (backward) Time <- Time - Tmax
    if (add)
        lines(Time, F, "l", col = ltt.style[[1]], lwd = ltt.style[[2]],
              lty = ltt.style[[3]])
    else
        plot(Time, F, "l", col = ltt.style[[1]], lwd = ltt.style[[2]],
             lty = ltt.style[[3]], ylab = "Number of lineages", ...)
    if (PI)
        lines(c(Time, NA, Time), c(Flow, NA, Fup),
              col = pi.style[[1]], lwd = pi.style[[2]], lty = pi.style[[3]])
}

rphylo <-
    function(n, birth, death, BIRTH = NULL, DEATH = NULL,
             T0 = 50, fossils = FALSE, eps = 1e-6)
{
    case <- .getCase(birth, death, BIRTH, DEATH)

    ## Foo(): CDF of the times to event (speciation or extinction)
    ## rTimeToEvent(): generate a random time to event by the inverse method

    switch(case, { # case 1:
        rTimeToEvent <- function(t) t - rexp(1, N * (birth + death)) # much faster than using Foo()
        speORext <- function(t) birth/(birth + death)
        ## Foo <- function(t, x)
        ##     1 - exp(-N*(birth + death)*(x - t))
    },{ # case 2:
        Foo <- function(t, x) {
            if (t == x) return(0)
            1 - exp(-integrate(function(t) birth(t) + death(t),
                               t, x)$value * N)
        }
        speORext <- function(t) birth(t)/(birth(t) + death(t))
    },{ # case 3:
        Foo <- function(t, x) {
            if (t == x) return(0)
            1 - exp(-N*(BIRTH(x) - BIRTH(t) + DEATH(x) - DEATH(t)))
        }
        speORext <- function(t) birth(t)/(birth(t) + death(t))
    },{ # case 4:
        Foo <- function(t, x) {
            if (t == x) return(0)
            1 - exp(-N*(integrate(function(t) birth(t), t, x)$value
                        + death*(x - t)))
        }
        speORext <- function(t) birth(t)/(birth(t) + death)
    },{ # case 5:
        Foo <- function(t, x) {
            if (t == x) return(0)
            1 - exp(-N*(birth*(x - t) +
                            integrate(function(t) death(t), t, x)$value))
        }
        speORext <- function(t) birth/(birth + death(t))
    },{ # case 6:
        Foo <- function(t, x) {
            if (t == x) return(0)
            1 - exp(-N*(BIRTH(x) - BIRTH(t) + death*(x - t)))
        }
        speORext <- function(t) birth(t)/(birth(t) + death)
    },{ # case 7:
        Foo <- function(t, x) {
            if (t == x) return(0)
            1 - exp(-N*(birth*(x - t) + DEATH(x) - DEATH(t)))
        }
        speORext <- function(t) birth/(birth + death(t))
    })

    if (case != 1) {
        rTimeToEvent <- function(t)
        {
            P <- runif(1)
            inc <- 10
            x <- t - inc
            while (inc > eps) {
                if (Foo(x, t) > P) { # fixed by Niko Yasui (2016-07-06) + fixed 2019-11-07
                    x <- x + inc
                    inc <- inc/10
                }
                x <- x - inc
            }
            x
        }
    }

    storage.mode(n) <- "integer"
    N <- n
    t <- T0
    j <- 0L # number of edges already created
    POOL <- seq_len(N) # initial pool (only tips at start)

if (!fossils) {
    Nedge <- 2L * N - 2L
    nextnode <- 2L * N - 1L
    e1 <- integer(Nedge)
    e2 <- integer(Nedge)
    TIME <- numeric(nextnode) # record the times
    TIME[POOL] <- T0 # the times of the n tips are the present time

    while (j < Nedge) {
        X <- rTimeToEvent(t)
        ## is the event a speciation or an extinction?
        Y <- rbinom(1, size = 1, prob = speORext(X))
        if (Y) { # speciation
            i <- sample.int(N, 2)
            fossil <- POOL[i] == 0
            if (any(fossil)) {
                ## we drop the fossil lineage, or the first one if both are fossils
                POOL <- POOL[-i[which(fossil)[1]]]
            } else { # create a node and an edge
                j <- j + 2L
                k <- c(j - 1, j)
                e1[k] <- nextnode
                e2[k] <- POOL[i]
                TIME[nextnode] <- X
                POOL <- c(POOL[-i], nextnode)
                nextnode <- nextnode - 1L
            }
            N <- N - 1L
        } else { # extinction => create a tip, store it in POOL but don't create an edge
            ## fossil lineages are numbered 0 to find them if Y = 1
            N <- N + 1L
            POOL <- c(POOL, 0L)
        }
        t <- X
    }

    Nnode <- n - 1L

} else { # fossils = TRUE
    nextnode <- -1L # nodes are numbered with negatives
    nexttip <- N + 1L # tips are numbered with positives
    e1 <- integer(1e5)
    e2 <- integer(1e5)
    time.tips <- numeric(1e5) # accessed with positive indices
    time.nodes <- numeric(1e5) # accessed with negative indices
    time.tips[POOL] <- T0 # the times of the n living tips are the present time

    while (N > 1) {
        X <- rTimeToEvent(t)
        ## is the event a speciation or an extinction?
        Y <- rbinom(1, size = 1, prob = speORext(X))
        if (Y) { # speciation => create a node
            i <- sample.int(N, 2)
            j <- j + 2L
            k <- c(j - 1, j)
            e1[k] <- nextnode
            e2[k] <- POOL[i]
            time.nodes[-nextnode] <- X
            POOL <- c(POOL[-i], nextnode)
            nextnode <- nextnode - 1L
            N <- N - 1L
        } else { # extinction => create a tip
            N <- N + 1L
            time.tips[nexttip] <- X
            POOL <- c(POOL, nexttip)
            nexttip <- nexttip + 1L
        }
        t <- X
    }

    n <- nexttip - 1L # update n
    Nnode <- n - 1L
    EDGE <- seq_len(j)
    e1 <- e1[EDGE]
    e2 <- e2[EDGE]
    e1 <- e1 + n + Nnode + 1L # e1 has only nodes...
    NODES <- e2 < 0 # ... so this is needed only on e2
    e2[NODES] <- e2[NODES] + n + Nnode + 1L
    ## concatenate the vectors of times after dropping the extra 0's:
    TIME <- c(time.tips[seq_len(n)], rev(time.nodes[seq_len(Nnode)]))
}
    obj <- list(edge = cbind(e1, e2, deparse.level = 0),
                edge.length = TIME[e2] - TIME[e1],
                tip.label = paste0("t", seq_len(n)), Nnode = Nnode)
    class(obj) <- "phylo"
    reorder(obj)
}

## read.gff.R (2018-05-22)

##   Read GFF Files

## Copyright 2016-2018 Emmanuel Paradis

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

read.gff <- function(file, na.strings = c(".", "?"), GFF3 = TRUE)
{
    w <- list("", "", "", 0L, 0L, 0, "", "", "")
    x <- scan(file, w, sep = "\t", quote = "", quiet = TRUE,
              na.strings = na.strings, comment.char = "#")
    for (i in c(1, 2, 3, 7, 8)) x[[i]] <- factor(x[[i]])
    names(x) <- c("seqid", "source", "type", "start", "end",
                  "score", "strand", "phase", "attributes")
    if (!GFF3) {
        names(x) <- c("seqname", "source", "feature", "start", "end",
                      "score", "strand", "frame", "attributes")
    }
    n <- length(x[[1]])
    attr(x, "row.names") <- as.character(seq_len(n))
    class(x) <- "data.frame"
    x
}

## speciesTree.R (2013-08-12)

##   Species Trees

## Copyright 2010-2013 Emmanuel Paradis

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

speciesTree <- function(x, FUN = min)
### FUN = min => MAXTREE (Liu et al. 2010)
### FUN = sum => shallowest divergence (Maddison & Knowles 2006)
{
    test.ultra <- which(!unlist(lapply(x, is.ultrametric)))
    if (length(test.ultra))
        stop(paste("the following trees were not ultrametric:\n",
                   paste(test.ultra, collapse = " ")))

    Ntree <- length(x)
    D <- lapply(x, cophenetic.phylo)
    nms <- rownames(D[[1]])
    n <- length(nms)
    M <- matrix(0, n*(n - 1)/2, Ntree)
    for (i in 1:Ntree) M[, i] <- as.dist(D[[i]][nms, nms])
    Y <- apply(M, 1, FUN)
    attributes(Y) <- list(Size = n, Labels = nms, Diag = FALSE,
                          Upper = FALSE, class = "dist")
    as.phylo(hclust(Y, "single"))
}

## all.equal.phylo.R (2009-07-05)
##
##     Global Comparison of two Phylogenies

## Copyright 2006 Benoit Durand
##    modified by EP for the new coding of "phylo" (2006-10-04)

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

## Recherche de la correspondance entre deux arbres
## Parcours en profondeur et en parallele des deux arbres (current et target)
## current, target: les deux arbres a comparer
## use.edge.length: faut-il comparer les longueurs de branches ?
## use.tip.label: faut-il comparer les etiquettes de feuilles ou seulement la
##	topologie des deux arbres ?
## index.return: si TRUE, retourner la matrice de correspondance entre noeuds
##	et feuilles, une matrice a deux colonnes (current et target) avec pour
##	chaque ligne des paires d'identifiants de noeuds/feuilles, tels qu'ils
##	apparaissent dans l'attribut 'edge' des objets phylo
## tolerance, scale: parametres de comparaison des longueurs de branches
##	(voir 'all.equal')
all.equal.phylo <- function(target, current,
                        use.edge.length = TRUE,
                        use.tip.label = TRUE,
                        index.return = FALSE,
                        tolerance = .Machine$double.eps ^ 0.5,
                        scale = NULL, ...) {

	same.node <- function(i, j) {
		# Comparaison de un noeud et une feuille
		if (xor(i > Ntip1, j > Ntip2)) return(NULL)
		# Comparaison de deux feuilles
		if (i <= Ntip1) {
			if (!use.tip.label) return(c(i, j))
			if (current$tip.label[i] == target$tip.label[j])
				return(c(i, j))
			return(NULL)
  		}
  		# Comparaison de deux noeuds
		i.children <- which(current$edge[, 1] == i)
		j.children <- which(target$edge[, 1] == j)
		if (length(i.children) != length(j.children)) return(NULL)
		correspondance <- NULL
		for (i.child in i.children) {
			corresp <- NULL
			for (j.child in j.children) {
				if (!use.edge.length ||
                                    isTRUE(all.equal(current$edge.length[i.child],
                                                     target$edge.length[j.child],
                                                     tolerance = tolerance,
                                                     scale = scale)))
                                    corresp <- same.node(current$edge[i.child, 2],
                                                         target$edge[j.child, 2])
				if (!is.null(corresp)) break
			}
			if (is.null(corresp)) return(NULL)
			correspondance <- c(correspondance, i, j, corresp)
			j.children <- j.children[j.children != j.child]
		}
		return(correspondance)
	}

        Ntip1 <- length(target$tip.label)
        Ntip2 <- length(current$tip.label)
        root1 <- Ntip1 + 1
        root2 <- Ntip2 + 1
        if (root1 != root2) return(FALSE)
        ## Fix by EP so that unrooted trees are correctly compared:
        if (!is.rooted(target) && !is.rooted(current)) {
            outg <- target$tip.label[1]
            if (! outg %in% current$tip.label) return(FALSE)
            target <- root(target, outg)
            current <- root(current, outg)
        }
        ## End
	result <- same.node(root1, root2)
	if (!isTRUE(index.return)) return(!is.null(result))
	if (is.null(result)) return(result)
	result <- t(matrix(result, nrow = 2))
      colnames(result) = c('current', 'target')
      return(result)
}

'parafit' <-
	function(host.D, para.D, HP, nperm=999, test.links=FALSE, seed=NULL, correction="none", silent=FALSE)
#
# Test of host-parasite coevolution
# host.D = host distance or patristic matrix (class dist or matrix)
# para.D = parasite distance or patristic matrix (class dist or matrix)
# HP = host-parasite link matrix (n.host, n.para)
#
#      Pierre Legendre, May 2009
{
epsilon <- sqrt(.Machine$double.eps)
if(is.null(seed)) {
	runif(1)
	seed <- .Random.seed[trunc(runif(1,1,626))]
	}
HP <- as.matrix(HP)

host.D <- as.matrix(host.D)
host.pc <- pcoa(host.D, correction=correction)
if(host.pc$correction[2] == 1) {
	if(min(host.pc$values[,2]) < -epsilon) stop('Host D matrix has negative eigenvalues. Rerun with correction="lingoes" or correction="cailliez"')
	sum.host.values.sq <- sum(host.pc$values[,1]^2)
	host.vectors <- host.pc$vectors
	} else {
	sum.host.values.sq <- sum(host.pc$values[,2]^2)
	host.vectors <- host.pc$vectors.cor
	}
n.host <- nrow(host.D)

para.D <- as.matrix(para.D)
para.pc <- pcoa(para.D, correction=correction)
if(para.pc$correction[2] == 1) {
	if(min(para.pc$values[,2]) < -epsilon) stop('Parasite D matrix has negative eigenvalues. Rerun with correction="lingoes" or correction="cailliez"')
	sum.para.values.sq <- sum(para.pc$values[,1]^2)
	para.vectors <- para.pc$vectors
	} else {
	sum.para.values.sq <- sum(para.pc$values[,2]^2)
	para.vectors <- para.pc$vectors.cor
	}
n.para <- nrow(para.D)

if(!silent) cat("n.hosts =", n.host, ", n.parasites =", n.para,'\n')

a <- system.time({
tracemax <- max(sum.host.values.sq, sum.para.values.sq)

if(n.host == n.para) {
	if(!silent) cat("The function cannot check if matrix HP has been entered in the right way.",'\n')
	if(!silent) cat("It will assume that the rows of HP are the hosts.",'\n')
	} else {
	temp <- dim(HP)
	if(temp[1] == n.host) {
		if(temp[2] != n.para) stop("Matrices host.D, para.D and HP not comformable")
		} else if(temp[2] == n.host) {
			if(temp[1] != n.para) stop("Matrices host.D, para.D and HP not comformable")
			HP <- t(HP)
			if(!silent) cat("Matrix HP has been transposed for comformity with host.D and para.D.",'\n')
		} else {
		stop("Matrices host.D, para.D and HP not comformable")
		}
	}
p.per.h <- apply(HP, 1, sum)
h.per.p <- apply(HP, 2, sum)
#
# Compute and test the global statistics
mat.4 <- t(host.vectors) %*% HP %*% para.vectors
global <- sum(mat.4^2)
if(nperm > 0) {
	set.seed(seed)
	nGT <- 1
	global.perm <- NA
	for(i in 1:nperm) {
		HP.perm <- apply(HP, 2, sample)
		mat.4.perm <- t(host.vectors) %*% HP.perm %*% para.vectors
		global.perm <- c(global.perm, sum(mat.4.perm^2))
		if(global.perm[i+1] >= global) nGT <- nGT+1
		}
	global.perm <- global.perm[-1]
	p.global <- nGT/(nperm+1)
	} else { p.global <- NA }

#
# Test individual H-P links
if(test.links) {
	# 1. Create the list of H-P pairs
	list.hp <- which( t(cbind(HP,rep(0,n.host))) > 0)
	HP.list <- cbind((list.hp %/% (n.para+1))+1, list.hp %% (n.para+1))
	colnames(HP.list) <- c("Host","Parasite")
	n.links <- length(list.hp)

	stat1 <- NA
	stat2 <- NA
	p.stat1 <- NA
	p.stat2 <- NA
	for(k in 1:n.links) {
		#
		# 2. Compute reference values of link statistics
		HP.k <- HP
		HP.k[HP.list[k,1], HP.list[k,2]] <- 0
		mat.4.k <- t(host.vectors) %*% HP.k %*% para.vectors
		trace.k <- sum(mat.4.k^2)
		stat1 <- c(stat1, (global-trace.k))
		den <- tracemax-global
		if(den > epsilon) { 
			stat2 <- c(stat2, stat1[k+1]/den) 
			} else { 
			stat2 <- c(stat2, NA) 
			}
		#
		# 3. Test link statistics by permutations
		if(nperm > 0) {
			set.seed(seed)
			nGT1 <- 1
			nGT2 <- 1
			nperm2 <- nperm
			#
			for(i in 1:nperm) {
				HP.k.perm <- apply(HP.k, 2, sample)
				mat.4.k.perm <- t(host.vectors) %*% HP.k.perm %*% para.vectors
				trace.k.perm <- sum(mat.4.k.perm^2)
				stat1.perm <- global.perm[i]-trace.k.perm
				if(stat1.perm >= stat1[k+1]) nGT1 <- nGT1+1
				#
				if(!is.na(stat2[k+1])) {
					den <- tracemax-global.perm[i]
					if(den > epsilon) {
						stat2.perm <- stat1.perm/den 
						if(stat2.perm >= stat2[k+1]) nGT2 <- nGT2+1
						} else {
						nperm2 <- nperm2-1
						# if(!silent) cat("In permutation #",i,"den < epsilon",'\n')
						}
					}
				}
			p.stat1 <- c(p.stat1, nGT1/(nperm+1))
			if(!is.na(stat2[k+1])) {
				p.stat2 <- c(p.stat2, nGT2/(nperm2+1))
				} else {
				p.stat2 <- c(p.stat2, NA) ### Error in previous version, corrected here
				}
			} else { 
			p.stat1 <- c(p.stat1, NA)     ### Error in previous version, corrected here
			p.stat2 <- c(p.stat2, NA)     ### Error in previous version, corrected here
			}
		}
	#
	link.table <- cbind(HP.list, stat1[-1], p.stat1[-1], stat2[-1], p.stat2[-1])
	colnames(link.table) = c("Host","Parasite","F1.stat","p.F1","F2.stat","p.F2")
	out <-list(ParaFitGlobal=global, p.global=p.global, link.table=link.table, para.per.host=p.per.h, host.per.para=h.per.p, nperm=nperm)
	} else {
	if(!silent) cat("Rerun the program with option 'test.links=TRUE' to test the individual H-P links",'\n')
	out <-list(ParaFitGlobal=global, p.global=p.global, para.per.host=p.per.h, host.per.para=h.per.p, nperm=nperm)
	}
#
})
a[3] <- sprintf("%2f",a[3])
if(!silent) cat("Computation time =",a[3]," sec",'\n')
#
class(out) <- "parafit"
out
}

## as.phylo.formula.R (2018-09-17)

##   Conversion from Taxonomy Variables to Phylogenetic Trees

## Copyright 2005-2018 Julien Dutheil, 2018 Eric Marcon

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

as.phylo.formula <- function(x, data = parent.frame(), collapse = TRUE, ...)
{
    ## Testing formula syntax:
    err <- "Formula must be of the kind ~A1/A2/.../An."
    if (length(x) != 2) stop(err)
    if (x[[1]] != "~") stop(err)
    f <- x[[2]]
    taxo <- list()
    while (length(f) == 3) {
        if (f[[1]] != "/") stop(err)
        f3.txt <- deparse(f[[3]])
        if (!is.factor(data[[f3.txt]]))
            stop(paste("Variable", f3.txt, "must be a factor"))
        taxo[[f3.txt]] <- data[[f3.txt]]
        if (length(f) > 1) f <- f[[2]]
    }
    f.txt <- deparse(f)
    if (!is.factor(data[[f.txt]]))
        stop(paste("Variable", f.txt, "must be a factor."))
    taxo[[f.txt]] <- data[[f.txt]]
    taxo.data <- as.data.frame(taxo)
    leaves.names <- as.character(taxo.data[, 1])
    taxo.data[, 1] <- 1:nrow(taxo.data)
    ## Now builds the phylogeny:
    f.rec <- function(subtaxo) { # Recurrent utility function
        u <- ncol(subtaxo)
        levels <- unique(subtaxo[,u])
        if (u == 1) {
            if (length(levels) != nrow(subtaxo))
                warning("leaves names are not unique.")
            return(as.character(subtaxo[, 1]))
        }
        t <- character(length(levels))
        for (l in 1:length(levels)) {
            x <- f.rec(subtaxo[subtaxo[,u] == levels[l], ][1:(u - 1)])
            t[l] <- paste0("(", paste(x, collapse=","), ")")
        }
        t
    }
    string <- paste0("(", paste(f.rec(taxo.data), collapse = ","), ");")
    phy <- read.tree(text = string)
    if (collapse) phy <- collapse.singles(phy)
    phy$tip.label <- leaves.names[as.numeric(phy$tip.label)]
    phy
}

## me.R (2019-03-26)

##   Tree Estimation Based on Minimum Evolution Algorithm

## Copyright 2007 Vincent Lefort with modifications by
##                Emmanuel Paradis (2008-2019)

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

fastme.bal <- function(X, nni = TRUE, spr = TRUE, tbr = FALSE)
{
    if (tbr) {
        warning("option 'tbr = TRUE' was ignored: see ?fastme.bal")
        tbr <- FALSE
    }
    if (is.matrix(X)) X <- as.dist(X)
    N <- as.integer(attr(X, "Size"))
    nedge <- 2L * N - 3L
    ans <- .C(me_b, as.double(X), N, 1:N, as.integer(nni),
              as.integer(spr), as.integer(tbr), integer(nedge),
              integer(nedge), double(nedge), NAOK = TRUE)
    labels <- attr(X, "Labels")
    if (is.null(labels)) labels <- as.character(1:N)
    labels <- labels[ans[[3]]]
    obj <- list(edge =  cbind(ans[[7]], ans[[8]]),
                edge.length = ans[[9]],
                tip.label = labels, Nnode = N - 2L)
    class(obj) <- "phylo"
    attr(obj, "order") <- "cladewise"
    obj
}

fastme.ols <- function(X, nni = TRUE)
{
    if (is.matrix(X)) X <- as.dist(X)
    N <- as.integer(attr(X, "Size"))
    nedge <- 2L * N - 3L
    ans <- .C(me_o, as.double(X), N, 1:N, as.integer(nni),
              integer(nedge), integer(nedge), double(nedge),
              NAOK = TRUE)
    labels <- attr(X, "Labels")
    if (is.null(labels)) labels <- as.character(1:N)
    labels <- labels[ans[[3]]]
    obj <- list(edge =  cbind(ans[[5]], ans[[6]]),
                edge.length = ans[[7]],
                tip.label = labels, Nnode = N - 2L)
    class(obj) <- "phylo"
    attr(obj, "order") <- "cladewise"
    obj
}

bionj <- function(X)
{
    if (is.matrix(X)) X <- as.dist(X)
    if (any(is.na(X)))
        stop("missing values are not allowed in the distance matrix.\nConsider using bionjs()")
    if (any(X > 100))
        stop("at least one distance was greater than 100")
    N <- as.integer(attr(X, "Size"))

    ans <- .C(C_bionj, as.double(X), N, integer(2 * N - 3),
              integer(2 * N - 3), double(2*N - 3), NAOK = TRUE)
    labels <- attr(X, "Labels")
    if (is.null(labels)) labels <- as.character(1:N)
    obj <- list(edge =  cbind(ans[[3]], ans[[4]]), edge.length = ans[[5]],
                tip.label = labels, Nnode = N - 2L)
    class(obj) <- "phylo"
    reorder(obj)
}

## drop.tip.R (2019-11-07)

##   Remove Tips in a Phylogenetic Tree

## Copyright 2003-2019 Emmanuel Paradis, 2017-2018 Klaus Schliep, 2018 Joseph Brown

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

keep.tip <- function(phy, tip)
{
    if (!inherits(phy, "phylo"))
        stop("object \"phy\" is not of class \"phylo\"")
    Ntip <- length(phy$tip.label)
    ## convert to indices if strings passed in
    if (is.character(tip)) {
        idx <- match(tip, phy$tip.label)
        ## stop on bad tip names
        ## alternative is to warn but proceed. not sure what stance is
        if (anyNA(idx)) {
            um <- c("umatched tip labels:\n", paste(tip[is.na(idx)], collapse = " "))
            stop(um)
        }
        tip <- idx
    } else {
        # check that passed in indices are all valid
        out.of.range <- tip > Ntip
        if (any(out.of.range)) {
            warning("some tip numbers were larger than the number of tips: they were ignored")
            tip <- tip[!out.of.range]
        }
    }
    ## get complement tip indices to drop
    toDrop <- setdiff(1:Ntip, tip)
    drop.tip(phy, toDrop)
}

extract.clade <- function(phy, node, root.edge = 0, collapse.singles = TRUE, interactive = FALSE)
{
    n <- length(phy$tip.label)
    if (interactive) {
        cat("Click close to the node...\n")
        node <- identify(phy)$nodes
    } else {
        if (length(node) > 1) {
            node <- node[1]
            warning("only the first value of 'node' has been considered")
        }
        if (is.character(node)) {
            if (is.null(phy$node.label))
                stop("the tree has no node labels")
            node <- match(node, phy$node.label) + n
            if (is.na(node)) stop("'node' not among the node labels.")
        }
        if (node <= n)
            stop("node number must be greater than the number of tips")
    }
    if (node == n + 1L) return(phy)
    keep <- prop.part(phy)[[node - n]]
    drop.tip(phy, (1:n)[-keep], root.edge = root.edge, rooted = TRUE,
             collapse.singles = collapse.singles)
}

drop.tip <-
    function(phy, tip, trim.internal = TRUE, subtree = FALSE,
             root.edge = 0, rooted = is.rooted(phy), collapse.singles = TRUE,
             interactive = FALSE)
{
    if (!inherits(phy, "phylo"))
        stop('object "phy" is not of class "phylo"')

    Ntip <- length(phy$tip.label)
    ## find the tips to drop:
    if (interactive) {
        cat("Left-click close to the tips you want to drop; right-click when finished...\n")
        xy <- locator()
        nToDrop <- length(xy$x)
        tip <- integer(nToDrop)
        lastPP <- get("last_plot.phylo", envir = .PlotPhyloEnv)
        for (i in 1:nToDrop) {
            d <- sqrt((xy$x[i] - lastPP$xx)^2 + (xy$y[i] - lastPP$yy)^2)
            tip[i] <- which.min(d)
        }
    } else {
        if (is.character(tip))
            tip <- which(phy$tip.label %in% tip)
    }

    out.of.range <- tip > Ntip
    if (any(out.of.range)) {
        warning("some tip numbers were larger than the number of tips: they were ignored")
        tip <- tip[!out.of.range]
    }

    if (!length(tip)) return(phy)

    if (length(tip) == Ntip) {
        if (Nnode(phy) < 3 || trim.internal) { # by Klaus (2018-06-21)
            warning("drop all tips of the tree: returning NULL")
            return(NULL)
        }
    }

    wbl <- !is.null(phy$edge.length)

    if (length(tip) == Ntip - 1 && trim.internal) {
        i <- which(phy$edge[, 2] == (1:Ntip)[-tip])
        res <- list(edge = matrix(2:1, 1, 2),
                    tip.label = phy$tip.label[phy$edge[i, 2]],
                    Nnode = 1L)
        class(res) <- "phylo"
        if (wbl) res$edge.length <- phy$edge.length[i]
        if (!is.null(phy$node.label))
            res$node.label <- phy$node.label[phy$edge[i, 1] - Ntip]
        return(res)
    }

    if (!rooted && subtree) {
        phy <- root(phy, (1:Ntip)[-tip][1])
        root.edge <- 0
    }

    phy <- reorder(phy)
    NEWROOT <- ROOT <- Ntip + 1
    Nnode <- phy$Nnode
    Nedge <- dim(phy$edge)[1]
    if (subtree) {
        trim.internal <- TRUE
        tr <- reorder(phy, "postorder")
        N <- .C(node_depth, as.integer(Ntip),
                as.integer(tr$edge[, 1]), as.integer(tr$edge[, 2]),
                as.integer(Nedge), double(Ntip + Nnode), 1L)[[5]]
    }

    edge1 <- phy$edge[, 1] # local copies
    edge2 <- phy$edge[, 2] #
    keep <- !logical(Nedge)

    ## delete the terminal edges given by `tip':
    keep[match(tip, edge2)] <- FALSE

    if (trim.internal) {
        ints <- edge2 > Ntip
        ## delete the internal edges that do not have anymore
        ## descendants (ie, they are in the 2nd col of `edge' but
        ## not in the 1st one)
        repeat {
            sel <- !(edge2 %in% edge1[keep]) & ints & keep
            if (!sum(sel)) break
            keep[sel] <- FALSE
        }
        if (subtree) {
            ## keep the subtending edge(s):
            subt <- edge1 %in% edge1[keep] & edge1 %in% edge1[!keep]
            keep[subt] <- TRUE
        }
        if (root.edge && wbl) {
            degree <- tabulate(edge1[keep])
            if (degree[ROOT] == 1) {
                j <- integer(0) # will store the indices of the edges below the new root
                repeat {
                    i <- which(edge1 == NEWROOT & keep)
                    j <- c(i, j)
                    NEWROOT <- edge2[i]
                    ## degree <- tabulate(edge1[keep]) # utile ?
                    if (degree[NEWROOT] > 1) break
                }
                keep[j] <- FALSE
                ## if (length(j) > root.edge) j <- 1:root.edge
                j <- j[1:root.edge]
                NewRootEdge <- sum(phy$edge.length[j])
                if (length(j) < root.edge && !is.null(phy$root.edge))
                    NewRootEdge <- NewRootEdge + phy$root.edge
                phy$root.edge <- NewRootEdge
            }
        }
    }

    if (!root.edge) phy$root.edge <- NULL

    ## drop the edges
    phy$edge <- phy$edge[keep, ]
    if (wbl) phy$edge.length <- phy$edge.length[keep]

    ## find the new terminal edges (works whatever 'subtree' and 'trim.internal'):
    TERMS <- !(phy$edge[, 2] %in% phy$edge[, 1])

    ## get the old No. of the nodes and tips that become tips:
    oldNo.ofNewTips <- phy$edge[TERMS, 2]

    ## in case some tips are dropped but kept because of 'subtree = TRUE':
    if (subtree) {
        i <- which(tip %in% oldNo.ofNewTips)
        if (length(i)) {
            phy$tip.label[tip[i]] <- "[1_tip]"
            tip <- tip[-i]
        }
    }

    n <- length(oldNo.ofNewTips) # the new number of tips in the tree

    ## the tips may not be sorted in increasing order in the
    ## 2nd col of edge, so no need to reorder $tip.label
    phy$edge[TERMS, 2] <- rank(phy$edge[TERMS, 2])
    ## fix by Thomas Sibley (2017-10-28):
    if (length(tip)) phy$tip.label <- phy$tip.label[-tip]

    ## make new tip labels if necessary:
    if (subtree || !trim.internal) {
        ## get the numbers of the nodes that become tips:
        node2tip <- oldNo.ofNewTips[oldNo.ofNewTips > Ntip]
        ## fix by Thomas Sibley (2017-10-28):
        new.tip.label <-
            if (!length(node2tip)) {
                character(0)
            } else if (subtree) {
                paste("[", N[node2tip], "_tips]", sep = "")
            } else {
                if (is.null(phy$node.label)) rep("NA", length(node2tip))
                else phy$node.label[node2tip - Ntip]
            }
#        if (!is.null(phy$node.label))
#            phy$node.label <- phy$node.label[-(node2tip - Ntip)]
        phy$tip.label <- c(phy$tip.label, new.tip.label)
    }

    phy$Nnode <- dim(phy$edge)[1] - n + 1L # update phy$Nnode

    ## The block below renumbers the nodes so that they conform
    ## to the "phylo" format
    newNb <- integer(Ntip + Nnode)
    newNb[NEWROOT] <- n + 1L
    sndcol <- phy$edge[, 2] > n
    newNb[sort(phy$edge[sndcol, 2])] <- (n + 2):(n + phy$Nnode)
    phy$edge[sndcol, 2] <- newNb[phy$edge[sndcol, 2]]
    phy$edge[, 1] <- newNb[phy$edge[, 1]]
    storage.mode(phy$edge) <- "integer"
    if (!is.null(phy$node.label)) # update node.label if needed
        phy$node.label <- phy$node.label[which(newNb > 0) - Ntip]
    if (collapse.singles) phy <- collapse.singles(phy)
    phy
}

## apetools.R (2018-06-13)

##   APE Tools

## Copyright 2017-2018 Emmanuel Paradis

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

.file.extensions <-
    list(clustal = "aln", fasta = c("fas", "fasta", "fa"),
         fastq = c("fq", "fastq"), newick = c("nwk", "newick", "tre", "tree"),
         nexus = c("nex", "nexus"), phylip = "phy")

Xplorefiles <- function(from = "HOME", recursive = TRUE, ignore.case = TRUE)
{
    if (from == "HOME") from <- Sys.getenv("HOME")
    FILES <- list.files(path = from, recursive = recursive, full.names = TRUE)
    ext <- if (exists(".file.extensions", envir = .PlotPhyloEnv))
               get(".file.extensions", envir = .PlotPhyloEnv)
           else .file.extensions
    res <- vector("list", length(ext))
    names(res) <- names(ext)
    for (i in seq_along(res)) {
        e <- paste0("\\.", ext[[i]], "$")
        if (length(e) > 1) e <- paste(e, collapse = "|")
        x <- grep(e, FILES, ignore.case = ignore.case, value = TRUE)
        res[[i]] <- data.frame(File = x, Size = file.size(x),
                               stringsAsFactors = FALSE)
    }
    res
}

editFileExtensions <- function()
{
    foo <- function(x) {
        n <- length(x)
        if (n < m) x[(n + 1):m] <- NA
        x
    }
    res <- if (exists(".file.extensions", envir = .PlotPhyloEnv))
               get(".file.extensions", envir = .PlotPhyloEnv)
           else .file.extensions
    m <- max(lengths(res, FALSE))
    res <- lapply(res, foo)
    res <- as.data.frame(res, stringsAsFactors = FALSE)
    res <- edit(res)
    res <- lapply(res, function(x) x[!is.na(x)])
    assign(".file.extensions", res, envir = .PlotPhyloEnv)
}

bydir <- function(x)
{
    nofile <- which(sapply(x, nrow) == 0)
    if (length(nofile)) x <- x[-nofile]
    if (!length(x)) {
        cat("No file\n")
        return(invisible(NULL))
    }
    for (i in seq_along(x)) x[[i]]$Type <- names(x)[i]
    x <- do.call(rbind, x)
    x <- x[order(x$File), ]
    SPLIT <- strsplit(x$File, "/")
    LL <- lengths(SPLIT)
    foo <- function(i, PATH) {
        K <- grep(paste0("^", PATH, "/"), x$File)
        sel <- intersect(K, which(LL == i + 1L))
        if (length(sel)) {
            y <- x[sel, ]
            y$File <- gsub(".*/", "", y$File)
            cat("\n", PATH, "/\n", sep = "")
            print(y, row.names = FALSE)
        }
        if (length(sel) < length(K)) {
            d <- setdiff(K, sel)
            subdir <- unlist(lapply(SPLIT[d], "[", i + 1L))
            for (z in unique(subdir))
                foo(i + 1L, paste(PATH, z, sep = "/"))
        }
    }
    top <- unlist(lapply(SPLIT, "[", 1L))
    for (z in unique(top)) foo(1L, z)
}

Xplor <- function(from = "HOME")
{
    ext <- if (exists(".file.extensions", envir = .PlotPhyloEnv))
               get(".file.extensions", envir = .PlotPhyloEnv)
           else .file.extensions

    OUT <- paste0(tempfile(), ".html")
    mycat <- function(...) cat(..., sep = "", file = OUT, append = TRUE)

    FILES <- Xplorefiles(from = from)
    filetypes <- names(FILES)
    ## nb of files of each type:
    NR <- sapply(FILES, nrow)

    ## HTML header
    mycat('<html><title>Files Sorted by Type</title></head>')

    ## build the TOC
    mycat('<h2>File types searched:</h2>')
    mycat('<TABLE border=0>')
    mycat('<tr><th align="center"> Type </th><th align="center"> Number of files </th><th align="center"> Extensions* </th></tr>')
    for (type in filetypes) {
        mycat('<tr><td><a href=#', type, '>', type, '</a></td><td align="center">', NR[type],
                              '</td><td align="center">', paste(paste0(".", ext[[type]]), collapse = " "), '</td></tr>')
    }
    mycat('</TABLE>')

    mycat('<br>*Case-independent<br>To change the files extensions, type in R: <font face = "courier">editFileExtensions()</font><br>')

    if (all(NR == 0)) {
        browseURL(OUT)
        return(invisible(NULL))
    }

    OUTBYDIR <- paste0(tempfile(), ".html")
    sink(OUTBYDIR)
    cat('<html><title>Files Sorted by Directory</title></head>')
    .bydir.html(FILES)
    cat('</html>')
    sink(NULL)
    mycat('<br><a target="blank" href=', OUTBYDIR, '><h2>Files sorted by directory (in new tab)</h2></a><br>')

    for (type in filetypes) {
        nr <- NR[type]
        mycat('<a name=', type, '></a><h1>', toupper(type), '</h1>')
        if (nr == 0) {
            mycat('no file of this type')
            next
        }
        DF <- FILES[[type]]
        mycat('<TABLE border=1>')
        mycat('<tr><th> File name </th><th align="center"> Size (KB) </th></tr>')
        for (i in 1:nr)
            mycat('<tr><td><a href="file://', DF[i, 1], '">', DF[i, 1],
                  '</a></td><td align="right">', round(DF[i, 2]/1000, 1), '</td></tr>')
        mycat('</TABLE>')
    }
    mycat('</html>')
    browseURL(OUT)
}

.bydir.html <- function(x)
{
    nofile <- which(sapply(x, nrow) == 0)
    if (length(nofile)) x <- x[-nofile]
    if (!length(x)) return(NULL)
    for (i in seq_along(x)) x[[i]]$Type <- names(x)[i]
    x <- do.call(rbind, x)
    x <- x[order(x$File), ]
    SPLIT <- strsplit(x$File, "/")
    LL <- lengths(SPLIT)
    foo <- function(i, PATH) {
        K <- grep(paste0("^", PATH, "/"), x$File)
        sel <- intersect(K, which(LL == i + 1L))
        if (length(sel)) {
            y <- x[sel, ]
            y$File <- gsub(".*/", "", y$File)
            cat('<h2><a href="file://', PATH, '">', PATH, '/</a></h2>', sep = "")
            cat('<TABLE border=1>')
            cat('<tr><th> File </th><th align="center"> Size (KB) </th><th align="center"> Type </th></tr>')
            for (i in 1:nrow(y))
                cat('<tr><td><a href="file://', PATH, '/', y[i, 1], '">', y[i, 1],
                    '</a></td><td align="right">', round(y[i, 2]/1000, 1),
                    '</td><td align="right">', y[i, 3], '</td></tr>', sep = "")
            cat('</TABLE><br>')
        }
        if (length(sel) < length(K)) {
            d <- setdiff(K, sel)
            subdir <- unlist(lapply(SPLIT[d], "[", i + 1L))
            for (z in unique(subdir))
                foo(i + 1L, paste(PATH, z, sep = "/"))
        }
    }
    top <- unlist(lapply(SPLIT, "[", 1L))
    for (z in unique(top)) foo(1L, z)
}

## binaryPGLMM.R (2015-03-04)

##   Phylogenetic Generalized Linear Mixed Model for Binary Data

## Copyright 2015 Anthony R. Ives

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

binaryPGLMM <- function(formula, data = list(), phy, s2.init = 0.1, B.init = NULL, 
	tol.pql = 10^-6, maxit.pql = 200, maxit.reml = 100) {

	# Begin pglmm.reml
	pglmm.reml <- function(par, tinvW, tH, tVphy, tX) {
		n <- dim(tX)[1]
		p <- dim(tX)[2]

		ss2 <- abs(Re(par))
		Cd <- ss2 * tVphy
		V <- tinvW + Cd

		LL <- 10^10
		if (sum(is.infinite(V)) == 0) { # & rcond(V) < 10^10) {
			if (all(eigen(V)$values > 0)) { #if(rcond(V) > 10^-10 & all(eigen(V)$values > 0)) {
				invV <- solve(V)
				logdetV <- determinant(V)$modulus[1]
				if (is.infinite(logdetV)) {
					cholV <- chol(V)
					logdetV <- 2 * sum(log(diag(chol(V))))
				}
				LL <- logdetV + t(tH) %*% invV %*% tH + determinant(t(tX) %*% 
					invV %*% tX)$modulus[1]
			}
		}
		return(LL)
	}
	# End pglmm.reml
	
	if (!inherits(phy, "phylo")) 
		stop("Object \"phy\" is not of class \"phylo\".")
	if (is.null(phy$edge.length)) 
		stop("The tree has no branch lengths.")
	if (is.null(phy$tip.label)) 
		stop("The tree has no tip labels.")
	phy <- reorder(phy, "postorder")
	n <- length(phy$tip.label)

	mf <- model.frame(formula = formula, data = data)
	if (nrow(mf) != length(phy$tip.label)) 
		stop("Number of rows of the design matrix does not match with length of the tree.")
	if (is.null(rownames(mf))) {
		warning("No tip labels, order assumed to be the same as in the tree.\n")
		data.names = phy$tip.label
	} else data.names = rownames(mf)
	order <- match(data.names, phy$tip.label)
	if (sum(is.na(order)) > 0) {
		warning("Data names do not match with the tip labels.\n")
		rownames(mf) <- data.names
	} else {
		tmp <- mf
		rownames(mf) <- phy$tip.label
		mf[order, ] <- tmp[1:nrow(tmp), ]
	}

	X <- model.matrix(attr(mf, "terms"), data = mf)
	y <- model.response(mf)
	if (sum(!(y %in% c(0, 1)))) {
		stop("PGLMM.binary requires a binary response (dependent variable).")
	}
	if (var(y) == 0) {
		stop("The response (dependent variable) is always 0 or always 1.")
	}

	p <- ncol(X)
	Vphy <- vcv(phy)
	Vphy <- Vphy/max(Vphy)
	Vphy/exp(determinant(Vphy)$modulus[1]/n)

	# Compute initial estimates if not provided assuming no phylogeny
	if (!is.null(B.init) & length(B.init) != p) {
		warning("B.init not correct length, so computed B.init using glm()")
	}
	if (is.null(B.init) | (!is.null(B.init) & length(B.init) != p)) {
		B.init <- t(matrix(glm(formula = formula, data = data, family = "binomial")$coefficients, ncol = p))
	}
	B <- B.init
	s2 <- s2.init
	b <- matrix(0, nrow = n)
	beta <- rbind(B, b)
	mu <- exp(X %*% B)/(1 + exp(X %*% B))

	XX <- cbind(X, diag(1, nrow = n, ncol = n))
	C <- s2 * Vphy

	est.s2 <- s2
	est.B <- B
	oldest.s2 <- 10^6
	oldest.B <- matrix(10^6, nrow = length(est.B))

	iteration <- 0
	exitflag <- 0
	rcondflag <- 0
	while (((t(est.s2 - oldest.s2) %*% (est.s2 - oldest.s2) > tol.pql^2) | 
		(t(est.B - oldest.B) %*% (est.B - oldest.B)/length(B) > tol.pql^2)) & 
		(iteration <= maxit.pql)) {

		iteration <- iteration + 1
		oldest.s2 <- est.s2
		oldest.B <- est.B

		est.B.m <- B
		oldest.B.m <- matrix(10^6, nrow = length(est.B))
		iteration.m <- 0

		# mean component
		while ((t(est.B.m - oldest.B.m) %*% (est.B.m - oldest.B.m)/length(B) > 
			tol.pql^2) & (iteration.m <= maxit.pql)) {

			iteration.m <- iteration.m + 1
			oldest.B.m <- est.B.m
			invW <- diag(as.vector((mu * (1 - mu))^-1))
			V <- invW + C

			# This flags cases in which V has a very high condition number, which will cause solve() to fail.
			if (sum(is.infinite(V)) > 0 | rcond(V) < 10^-10) {
				rcondflag <- rcondflag + 1
				B <- 0 * B.init + 0.001
				b <- matrix(0, nrow = n)
				beta <- rbind(B, b)
				mu <- exp(X %*% B)/(1 + exp(X %*% B))
				oldest.B.m <- matrix(10^6, nrow = length(est.B))
				invW <- diag(as.vector((mu * (1 - mu))^-1))
				V <- invW + C
			}

			invV <- solve(V)
			Z <- X %*% B + b + (y - mu)/(mu * (1 - mu))
			denom <- t(X) %*% invV %*% X
			num <- t(X) %*% invV %*% Z
			B <- as.matrix(solve(denom, num))

			b <- C %*% invV %*% (Z - X %*% B)
			beta <- rbind(B, b)
			mu <- exp(XX %*% beta)/(1 + exp(XX %*% beta))

			est.B.m <- B
		}

		# variance component
		H <- Z - X %*% B
		opt <- optim(fn = pglmm.reml, par = s2, tinvW = invW, tH = H, tVphy = Vphy, 
			tX = X, method = "BFGS", control = list(factr = 1e+12, maxit = maxit.reml))
		s2 <- abs(opt$par)
		C <- s2 * Vphy

		est.s2 <- s2
		est.B <- B
	}
	convergeflag <- "converged"
	if (iteration >= maxit.pql | rcondflag >= 3) {
		convergeflag <- "Did not converge; try increasing maxit.pql or starting with B.init values of .001"
	}

	converge.test.s2 <- (t(est.s2 - oldest.s2) %*% (est.s2 - oldest.s2))^0.5
	converge.test.B <- (t(est.B - oldest.B) %*% (est.B - oldest.B))^0.5/length(est.B)

	# Extract parameters
	invW <- diag(as.vector((mu * (1 - mu))^-1))
	V <- invW + C
	invV <- solve(V)
	Z <- X %*% B + b + (y - mu)/(mu * (1 - mu))
	denom <- t(X) %*% invV %*% X
	num <- t(X) %*% invV %*% Z
	B <- solve(denom, num)
	b <- C %*% invV %*% (Z - X %*% B)
	beta <- rbind(B, b)
	mu <- exp(XX %*% beta)/(1 + exp(XX %*% beta))
	H <- Z - X %*% B

	B.cov <- solve(t(X) %*% invV %*% X)
	B.se <- as.matrix(diag(B.cov))^0.5
	B.zscore <- B/B.se
	B.pvalue <- 2 * pnorm(abs(B/B.se), lower.tail = FALSE)

	LL <- opt$value
	lnlike.cond.reml <- -0.5 * (n - p) * log(2 * pi) + 0.5 * determinant(t(X) %*% 
		X)$modulus[1] - 0.5 * LL

	LL0 <- pglmm.reml(par = 0, tinvW = invW, tH = H, tVphy = Vphy, tX = X)
	lnlike.cond.reml0 <- -0.5 * (n - p) * log(2 * pi) + 0.5 * determinant(t(X) %*% 
		X)$modulus[1] - 0.5 * LL0

	P.H0.s2 <- pchisq(2 * (lnlike.cond.reml - lnlike.cond.reml0), df = 1, 
		lower.tail = F)/2

	results <- list(formula = formula, B = B, B.se = B.se, B.cov = B.cov, 
		B.zscore = B.zscore, B.pvalue = B.pvalue, s2 = s2, P.H0.s2 = P.H0.s2, 
		mu = mu, b = b, B.init = B.init, X = X, H = H, VCV = Vphy, V = V, 
		convergeflag = convergeflag, iteration = iteration, converge.test.s2 = converge.test.s2, 
		converge.test.B = converge.test.B, rcondflag = rcondflag)
	class(results) <- "binaryPGLMM"
	results
}

######################################################
######################################################
# binaryPGLMM.sim
######################################################
######################################################

binaryPGLMM.sim <- function(formula, data = list(), phy, s2 = NULL, B = NULL, 
	nrep = 1) {

	if (!inherits(phy, "phylo")) 
		stop("Object \"phy\" is not of class \"phylo\".")
	if (is.null(phy$edge.length)) 
		stop("The tree has no branch lengths.")
	if (is.null(phy$tip.label)) 
		stop("The tree has no tip labels.")
	phy <- reorder(phy, "postorder")
	n <- length(phy$tip.label)

	mf <- model.frame(formula = formula, data = data)
	if (nrow(mf) != length(phy$tip.label)) 
		stop("Number of rows of the design matrix does not match with length of the tree.")
	if (is.null(rownames(mf))) {
		warning("No tip labels, order assumed to be the same as in the tree.\n")
		data.names = phy$tip.label
	} else data.names = rownames(mf)
	order <- match(data.names, phy$tip.label)
	if (sum(is.na(order)) > 0) {
		warning("Data names do not match with the tip labels.\n")
		rownames(mf) <- data.names
	} else {
		tmp <- mf
		rownames(mf) <- phy$tip.label
		mf[order, ] <- tmp[1:nrow(tmp), ]
	}

	if (is.null(s2)) 
		stop("You must specify s2")
	if (is.null(B)) 
		stop("You must specify B")
	X <- model.matrix(attr(mf, "terms"), data = mf)

	n <- nrow(X)
	p <- ncol(X)
	V <- vcv(phy)
	V <- V/max(V)
	V <- vcv(phy)
	V <- V/max(V)
	V/exp(determinant(V)$modulus[1]/n)
	V <- s2 * V

	if (s2 > 10^-8) {
		iD <- t(chol(V))
	} else {
		iD <- matrix(0, nrow = n, ncol = n)
	}
	Y <- matrix(0, nrow = n, ncol = nrep)
	y <- matrix(0, nrow = n, ncol = nrep)
	for (i in 1:nrep) {
		y[, i] <- X %*% B + iD %*% rnorm(n = n)
		p <- 1/(1 + exp(-y[, i]))
		Y[, i] <- as.numeric(runif(n = n) < p)
	}
	results <- list(Y = Y, y = y, X = X, s2 = s2, B = B, V = V)
	return(results)
}

######################################################
######################################################
# print.binaryPGLMM
######################################################
######################################################

print.binaryPGLMM <- function(x, digits = max(3, getOption("digits") - 3), 
	...) {

	cat("\n\nCall:")
	print(x$formula)
	cat("\n")

	cat("Random effect (phylogenetic signal s2):\n")
	w <- data.frame(s2 = x$s2, Pr = x$P.H0.s2)
	print(w, digits = digits)

	cat("\nFixed effects:\n")
	coef <- data.frame(Value = x$B, Std.Error = x$B.se, Zscore = x$B.zscore, 
		Pvalue = x$B.pvalue)
	printCoefmat(coef, P.values = TRUE, has.Pvalue = TRUE)
	cat("\n")
}

## read.tree.R (2018-07-23)

##   Read Tree Files in Parenthetic Format

## Copyright 2002-2018 Emmanuel Paradis, Daniel Lawson and Klaus Schliep

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

read.tree <- function(file = "", text = NULL, tree.names = NULL, skip = 0,
    comment.char = "", keep.multi = FALSE, ...)
{
    if (!is.null(text)) {
        if (!is.character(text))
            stop("argument `text' must be of mode character")
        tree <- text
    } else {
        tree <- scan(file = file, what = "", sep = "\n", quiet = TRUE,
                     skip = skip, comment.char = comment.char, ...)
    }

    ## Suggestion from Eric Durand and Nicolas Bortolussi (added 2005-08-17):
    if (identical(tree, character(0))) {
        warning("empty character string.")
        return(NULL)
    }

    tree <- gsub("[ \t]", "", tree)
    tree <- gsub("''", "", tree)

    single_quotes <- function(x, start = 1L) {
        z <- unlist(gregexpr("'", x))
        if (length(z) %% 2)
            stop("wrong number of single quotes around labels")
        l <- length(z) / 2
        tmp <- strsplit(x, "'")[[1]]
        ind_orig <- 2L * (1L:l)
        tmp_label <- paste0("@_", start:(start + l - 1), "_@")
        orig_label <- tmp[ind_orig]  #paste0("'", tmp[ind_orig], "'")
        names(orig_label) <- tmp_label
        for (i in 1:l) tmp[2 * i] <- tmp_label[i]
        tmp <- paste0(tmp, collapse = "")
        list(tmp, orig_label)
    }

    ## replace labels with single quotes
    z <- grepl("'", tree)
    if (any(z)) {
        Ntree <- length(tree)
        tmp_label <- vector("list", Ntree)
        for (i in 1:Ntree) {
            if (z[i]) {
                TMP <- single_quotes(tree[i])
                tree[i] <- TMP[[1]]
                tmp_label[[i]] <- TMP[[2]]
            }
        }
    }

    y <- unlist(gregexpr(";", tree))

### replace comments may handle them different later on

    ## if one tree per line much faster
    if (identical(y, nchar(tree))) { # check if always one tree per line
        Ntree <- length(y)
        STRING <- character(Ntree)
        for (i in 1:Ntree) {
            STRING[i] <- gsub("\\[[^]]*\\]", "", tree[i]) # delete comments (fix 2015-01-12)
        }
    } else {
        ## tree <- paste0(tree)
        ## tree <- unlist(strsplit(tree, ";"))
        ## tree <- paste0(tree, ";")
        tree <- unlist(strsplit(tree, NULL))
        y <- which(tree == ";")
        Ntree <- length(y)
        x <- c(1, y[-Ntree] + 1)
        ## Suggestion from Olivier Francois (added 2006-07-15):
        if (is.na(y[1])) return(NULL)
        STRING <- character(Ntree)
        for (i in 1:Ntree) {
            tmp <- paste0(tree[x[i]:y[i]], collapse = "")
            STRING[i] <- gsub("\\[[^]]*\\]", "", tmp) # delete comments (fix 2015-01-12)
        }
    }

    ## remove possible leading and trailing underscores
    STRING <- gsub("^_+", "", STRING)
    STRING <- gsub("_+$", "", STRING)

    getTreeName <- function(x) {
        res <- rep("", length(x))
        i <- regexpr("\\(", x)
        s <- i > 1
        if (any(s)) res[s] <- substr(x[s], 1, i[s] - 1)
        res
    }

    tmpnames <- getTreeName(STRING)
    if (is.null(tree.names) && any(nzchar(tmpnames))) tree.names <- tmpnames

    colon <- grep(":", STRING)
    if (!length(colon)) {
        obj <- lapply(STRING, .cladoBuild)
    } else if (length(colon) == Ntree) {
        obj <- lapply(STRING, .treeBuild)
    } else {
        obj <- vector("list", Ntree)
        obj[colon] <- lapply(STRING[colon], .treeBuild)
        nocolon <- (1:Ntree)[!1:Ntree %in% colon]
        obj[nocolon] <- lapply(STRING[nocolon], .cladoBuild)
    }

    for (i in 1:Ntree) {
        if (z[i]) {
            tmp_lab <- tmp_label[[i]]
            tip.label <- obj[[i]]$tip.label
            node.label <- obj[[i]]$node.label
            ind <- match(tip.label, names(tmp_lab))
            ind2 <- which(!is.na(ind))
            if (length(ind2)) {
                tip.label[ind2] <- tmp_lab[ind[ind2]]
                tmp_lab <- tmp_lab[-ind[ind2]]
            }

            ind <- match(node.label, names(tmp_lab))
            ind2 <- which(!is.na(ind))
            if (length(ind2)) {
                node.label[ind2] <- tmp_lab[ind[ind2]]
                tmp_lab <- tmp_lab[-ind[ind2]]
            }
            if (length(tmp_lab)) {
                for (j in 1:length(tmp_lab)) {
                    node.label <- gsub(names(tmp_lab)[j], tmp_lab[j], node.label)
                    tip.label <- gsub(names(tmp_lab)[j], tmp_lab[j], tip.label)
                }
            }
            obj[[i]]$tip.label <- tip.label
            obj[[i]]$node.label <- node.label
        }
    }
    if (Ntree == 1 && !keep.multi) obj <- obj[[1]] else {
        if (!is.null(tree.names)) names(obj) <- tree.names
        class(obj) <- "multiPhylo"
    }
    obj
}

## node.dating.R (2018-02-07)
## This file is part of the R-package `ape'.
## See the file COPYING in the package ape available at cran.r-project.org for licensing issues.

# Copyright (c) 2016, Bradley R. Jones, BC Centre for Excellence in HIV/AIDS
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in the
#       documentation and/or other materials provided with the distribution.
#     * Neither the name of the BC Centre for Excellence in HIV/AIDS nor the
#       names of its contributors may be used to endorse or promote products
#       derived from this software without specific prior written permission.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL The BC Centre for Excellence in HIV/AIDS BE LIABLE FOR ANY
# DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

# Estimate the mutation rate and node dates based on tip dates.
#
# Felsenstein, Joseph. "Evolutionary trees from DNA sequences: A maximum
# likelihood approach." Journal of Molecular Evolution 17 (1981):368-376.
#
# Rambaut, Andrew. "Estimating the rate of molecular evolution: incorporating 
# non-contemporaneous sequences into maximum likelihood phylogenies." 
# Bioinformatics 16.4 (2000): 395-399.

# Estimate the mutation rate of a phylogenetic tree from the tip dates using 
# linear regression. This model assumes that the tree follows a molecular 
# clock.
#
# t: rooted tree with edge lengths equal to genetic distance
#
# tip.dates: vector of dates for the tips, in the same order as t$tip.label.
#            Tip dates can be censored with NA values
#
# p: p-value cutoff for failed regression (default=0.05)
#
# returns the mutation rate as a double
estimate.mu <- function(t, node.dates, p.tol=0.05) {
	# fit linear model
	g <- glm(node.depth.edgelength(t)[1:length(node.dates)] ~ node.dates, na.action=na.omit)
	p <- anova(g, test="Chisq")[2,5]
	
	# test fit
	if (p > p.tol) {
		warning(paste("Cannot reject null hypothesis (p=", p, ")"))
	}
	
	coef(g)[[2]]
}

# Estimate the dates of the internal nodes of a phylogenetic tree.
#
# t: rooted tree with edge lengths equal to genetic distance
#
# node.dates: either a vector of dates for the tips, in the same order as 
#             t$tip.label; or a vector of dates to initalize each node
#
# mu: mutation rate, either a vector of size one for a strict molecular clock
#     or a vector with a local molecular clock along each edge
#
# min.date: the minimum date that a node can have (needed for optimize()). The 
#           default is -.Machine$double.xmax
#
# show.steps: set to print the log likelihood every show.steps. Set to 0 to 
#             supress output
#
# opt.tol: tolerance for optimization precision. By default, the optimize()
#          function uses a tolerance of .Machine$double.eps^0.25 (see ?optimize)
#
# lik.tol: tolerance for likelihood comparison. estimate.dates will stop when
#          the log likelihood between successive trees is less than like.tol. If
#          0 will stop after nsteps steps.
#
# nsteps: the maximum number of steps to run. If 0 will run until the log 
#         likelihood between successive runs is less than lik.tol. The default 
#         is 1000.
#
# is.binary: if the phylogentic tree is binary, setting is.binary to TRUE, will 
#            run a optimization method
#
# If lik.tol and nsteps are both 0 then estimate.dates will only run the inital 
# step.
#
# returns a vector of the estimated dates of the tips and internal nodes
estimate.dates <- function(t, node.dates, mu = estimate.mu(t, node.dates), min.date = -.Machine$double.xmax, show.steps = 0, opt.tol = 1e-8, nsteps = 1000, lik.tol = 0, is.binary = is.binary.phylo(t)) {
	
	# check parameters
	if (any(mu < 0))
		stop(paste("mu (", mu, ") less than 0", sep=""))
		
	# init vars	
	mu <- if (length(mu) == 1) rep(mu, length(t$edge.length)) else mu
	n.tips <- length(t$tip.label)
	dates <- if (length(node.dates) == n.tips) {
			c(node.dates, rep(NA, t$Nnode))
		} else if (length(node.dates) == n.tips + t$Nnode) {
			node.dates
		} else {
			stop(paste0("node.dates must be a vector with length equal to the number of tips or equal to the number of nodes plus the number of tips"))
		}
		
	lik.sens <- if (lik.tol == 0) opt.tol else lik.tol
	
	# Don't count initial step if all values are seeded
	iter.step <-  if (any(is.na(dates))) 0 else 1
	
	children <- lapply(1:t$Nnode,
		function(x) {
			which(t$edge[,1] == x + n.tips)
		})
	parent <- lapply(1:t$Nnode,
		function(x) {
			which(t$edge[,2] == x + n.tips)
		})
		
	# to process children before parents
	nodes <- c(1)
	for (i in 1:t$Nnode) {
		to.add <- t$edge[children[[nodes[i]]], 2] - n.tips
	
		nodes <- c(nodes, to.add[to.add > 0])
		
		i <- i + 1
	}
	nodes <- rev(nodes)
		
	# calculate likelihood functions
	scale.lik <- sum(-lgamma(t$edge.length+1)+(t$edge.length+1)*log(mu))
	
	calc.Like <- function(ch.node, ch.edge, x) {
		tim <- ch.node - x
						
		t$edge.length[ch.edge]*log(tim)-mu[ch.edge]*tim
	}
	
	opt.fun <- function(x, ch, p, ch.edge, p.edge, use.parent=T) {
		sum(if (!use.parent || length(dates[p]) == 0 || is.na(dates[p])) {		
				calc.Like(dates[ch], t$edge.length[ch.edge], x)
			} else {
				calc.Like(c(dates[ch], x), c(t$edge.length[ch.edge], t$edge.length[p.edge]), c(rep(x, length(dates[ch])), dates[p]))
			})
	}
	
	solve.lin <- function(bounds, ch.times, ch.edge) {	
		y <- (mu[ch.edge] * ch.times - t$edge.length[ch.edge]) / mu[ch.edge]
		x <- c(bounds[1] + opt.tol, bounds[2] - opt.tol)
		if (bounds[1] < y && y < bounds[2])
			x <- c(x, y)
				
		x[which.max(unlist(lapply(x, function(y) sum(calc.Like(ch.times, ch.edge, y)))))]
	}
	
	solve.poly2 <- function(bounds, a, b, c.0) {
		x <- c(bounds[1] + opt.tol, bounds[2] - opt.tol)
	
		if (b ^ 2 - 4 * a * c.0 >= 0) {
			if (a == 0) {
				y <- -c.0 / b
				
				if (bounds[1] < y && y < bounds[2])
					x <- c(x, y)
			} else {
				x.1 <- (-b + sqrt(b ^ 2 - 4 * a * c.0)) / (2 * a)
				x.2 <- (-b - sqrt(b ^ 2 - 4 * a * c.0)) / (2 * a)
					
				if (bounds[1] < x.1 && x.1 < bounds[2])
					x <- c(x, x.1)
				if (bounds[1] < x.2 && x.2 < bounds[2])
					x <- c(x, x.2)
			}
		}
		
		x
	}
	
	solve.bin <- function(bounds, ch.times, ch.edge) {
		ch.edge.length <- t$edge.length[ch.edge]
		a <- sum(mu[ch.edge])
		b <- ch.edge.length[1] + ch.edge.length[2] - a * (ch.times[1] + ch.times[2])
		c.0 <- a*ch.times[1] * ch.times[2] - ch.times[1] * ch.edge.length[2] - ch.times[2] * ch.edge.length[1]
						
		x <- solve.poly2(bounds, a, b, c.0)					
			
		x[which.max(unlist(lapply(x, function(y) sum(calc.Like(ch.times, ch.edge, y)))))]
	}
	
	
	solve.bin2 <- function(bounds, ch.times, ch.edge, par.time, par.edge) {
		ch.edge.length <- t$edge.length[ch.edge]
		par.edge.length <- t$edge.length[par.edge]
		a <- mu[ch.edge] - mu[par.edge]
		b <- ch.edge.length + par.edge.length - a * (ch.times + par.time)
		c.0 <- a*ch.times * par.time - ch.times * par.edge.length - par.time * ch.edge.length
		
		cat(sprintf("a: %f, b: %f, c: %f\n", a, b, c.0))
		
		x <- solve.poly2(bounds, a, b, c.0)					
			
		x[which.max(unlist(lapply(x, function(y) sum(calc.Like(c(ch.times, y), c(ch.edge, par.edge), c(y, par.time))))))]
	}
	
	solve.poly3 <- function(bounds, a, b, c.0, d) {
		x <- c(bounds[1] + opt.tol, bounds[2] - opt.tol)
	
		if (a == 0)
			x <- c(x, solve.poly2(bounds, b, c.0, d))
		else {
			delta.0 <- complex(real=b^2 - 3 * a * c.0)
			delta.1 <- complex(real=2 * b^3 - 9 * a * b * c.0 + 27 * a^2 * d)
			C <- ((delta.1 + sqrt(delta.1^2 - 4 * delta.0^3)) / 2)^(1/3)
		
			x.1 <- Re(-1 / (3 * a) * (b + complex(real=1) * C + delta.0 / (complex(real=1) * C)))
			x.2 <- Re(-1 / (3 * a) * (b + complex(real=-1/2, imaginary=sqrt(3)/2) * C + delta.0 / (complex(real=-1/2, imaginary=sqrt(3)/2) * C)))
			x.3 <- Re(-1 / (3 * a) * (b + complex(real=-1/2, imaginary=-sqrt(3)/2) * C + delta.0 / (complex(real=-1/2, imaginary=-sqrt(3)/2) * C)))
		
			if (bounds[1] < x.1 && x.1 < bounds[2])
				x <- c(x, x.1)
			if (bounds[1] < x.2 && x.2 < bounds[2])
				x <- c(x, x.2)
			if (bounds[1] < x.3 && x.3 < bounds[2])
				x <- c(x, x.3)
		}
		
		x
	}
	
	solve.cube <- function(bounds, ch.times, ch.edge, par.time, par.edge) {
		ch.edge.length <- t$edge.length[ch.edge]
		par.edge.length <- t$edge.length[par.edge]
	
		a <- sum(mu[ch.edge]) - mu[par.edge]
		b <- sum(ch.edge.length) + par.edge.length - a * (sum(ch.times) + par.time)
		c.0 <- a * (ch.times[1] * ch.times[2] + ch.times[1] * par.time + ch.times[2] * par.time) - (ch.times[1] + ch.times[2]) * par.edge.length - (ch.times[1] + par.time) * ch.edge.length[2] - (ch.times[2] + par.time) * ch.edge.length[1]
		d <- ch.edge.length[1] * ch.times[2] * par.time + ch.edge.length[2] * ch.times[1] * par.time + par.edge.length * ch.times[1] * ch.times[2] - a * prod(ch.times) * par.time
		
		x <- solve.poly3(bounds, a, b, c.0, d)
		
		x[which.max(unlist(lapply(x, function(y) sum(calc.Like(c(ch.times, y), c(ch.edge, par.edge), c(y, y, par.time))))))]
	}
	
	estimate <- function(node) {
		ch.edge <- children[[node]]
		ch <- t$edge[ch.edge, 2]
		
		p.edge <- parent[[node]]
		p <- t$edge[p.edge, 1]
		
		m <- if (length(p) == 0 || is.na(dates[p])) {
				min.date
			} else {
				dates[p]
			}
			
		if (is.binary) {
			if (length(dates[p]) == 0 || is.na(dates[p])) {
				if (length(ch.edge) == 2)
					solve.bin(c(m, min(dates[ch])), dates[ch], ch.edge)
				else
					solve.lin(c(m, min(dates[ch])), dates[ch], ch.edge)
			} else {
				if (length(ch.edge) == 2)
					solve.cube(c(m, min(dates[ch])), dates[ch], ch.edge, dates[p], p.edge)
				else
					solve.bin2(c(m, min(dates[ch])), dates[ch], ch.edge, dates[p], p.edge)
			}
		} else {				
			res <- optimize(opt.fun, c(m, min(dates[ch])), ch, p, ch.edge, p.edge, maximum=T)
		
			res$maximum
		}
	}
	
	# iterate to estimate dates
	lik <- NA
	
	repeat
	{
		for (n in nodes) {		
			dates[n + n.tips] <- estimate(n)
		}
		
		all.lik <- 	calc.Like(dates[t$edge[,2]], 1:length(t$edge.length), dates[t$edge[,1]]) + scale.lik
		new.lik <- sum(all.lik)
		
		if (show.steps > 0 && ((iter.step %% show.steps) == 0)) {
			cat(paste("Step: ", iter.step, ", Likelihood: ", new.lik, "\n", sep=""))
		}
		
		if ((lik.tol > 0 && (!is.na(lik) && (is.infinite(lik) || is.infinite(new.lik) || new.lik - lik < lik.tol))) || (nsteps > 0 && iter.step >= nsteps) || (lik.tol <= 0 && nsteps <= 0)) {
			if (is.infinite(lik) || is.infinite(new.lik)) {
				warning("Likelihood infinite")
			}
			else if (!is.na(lik) && new.lik + lik.sens < lik) {			
				warning("Likelihood less than previous estimate")
			}
					
			break
		} else {
			lik <- new.lik
		}
		
		iter.step <- iter.step + 1
	}
	
	if (show.steps > 0) {
		cat(paste("Step: ", iter.step, ", Likelihood: ", new.lik, "\n", sep=""))
	}
	
	dates
}

pcoa <- function(D, correction="none", rn=NULL)
#
# Principal coordinate analysis (PCoA) of a square distance matrix D
# with correction for negative eigenvalues.
#
# References:
# Gower, J. C. 1966. Some distance properties of latent root and vector methods
#    used in multivariate analysis. Biometrika. 53: 325-338.
# Gower, J. C. and P. Legendre. 1986. Metric and Euclidean properties of
#    dissimilarity coefficients. J. Classif. 3: 5-48.
# Legendre, P. and L. Legendre. 1998. Numerical ecology, 2nd English edition.
#    Elsevier Science BV, Amsterdam. [PCoA: Section 9.2]
#
#      Pierre Legendre, October 2007
{
centre <- function(D,n)
# Centre a square matrix D by matrix algebra
# mat.cen = (I - 11'/n) D (I - 11'/n)
{	One <- matrix(1,n,n)
	mat <- diag(n) - One/n
	mat.cen <- mat %*% D %*% mat
}

bstick.def <- function (n, tot.var = 1, ...)   # 'bstick.default' from vegan
{
    res <- rev(cumsum(tot.var/n:1)/n)
    names(res) <- paste("Stick", seq(len = n), sep = "")
    return(res)
}

# ===== The PCoA function begins here =====

# Preliminary actions
	D <- as.matrix(D)
	n <- nrow(D)
	epsilon <- sqrt(.Machine$double.eps)
	if(length(rn)!=0) {
		names <- rn
		} else {
		names <- rownames(D)
		}
	CORRECTIONS <- c("none","lingoes","cailliez")
	correct <- pmatch(correction, CORRECTIONS)
	if(is.na(correct)) stop("Invalid correction method")
	# cat("Correction method =",correct,'\n')

# Gower centring of matrix D
# delta1 = (I - 11'/n) [-0.5 d^2] (I - 11'/n)
	delta1 <- centre((-0.5*D^2),n)
	trace <- sum(diag(delta1))

# Eigenvalue decomposition
	D.eig <- eigen(delta1)

# Negative eigenvalues?
	min.eig <- min(D.eig$values)
	zero.eig <- which(abs(D.eig$values) < epsilon)
	D.eig$values[zero.eig] <- 0

# No negative eigenvalue
	if(min.eig > -epsilon) {   # Curly 1
		correct <- 1
		eig <- D.eig$values
		k <- length(which(eig > epsilon))
		rel.eig <- eig[1:k]/trace
		cum.eig <- cumsum(rel.eig)
		vectors <- sweep(D.eig$vectors[,1:k], 2, sqrt(eig[1:k]), FUN="*")
		bs <- bstick.def(k)
		cum.bs <- cumsum(bs)

		res <- data.frame(eig[1:k], rel.eig, bs, cum.eig, cum.bs)
		colnames(res) <- c("Eigenvalues","Relative_eig","Broken_stick","Cumul_eig","Cumul_br_stick")
		rownames(res) <- 1:nrow(res)

		rownames(vectors) <- names
		colnames(vectors) <- colnames(vectors, do.NULL = FALSE, prefix = "Axis.")
		note <- paste("There were no negative eigenvalues. No correction was applied")
		out <- (list(correction=c(correction,correct), note=note, values=res, vectors=vectors, trace=trace))

# Negative eigenvalues present
	} else {   # Curly 1
		k <- n
		eig <- D.eig$values
		rel.eig <- eig/trace
		rel.eig.cor <- (eig - min.eig)/(trace - (n-1)*min.eig) # Eq. 9.27 for a single dimension
                if (length(zero.eig)) # by Jesse Connell
                    rel.eig.cor <- c(rel.eig.cor[-zero.eig[1]], 0)
                ## the previous line replaces:
		## rel.eig.cor = c(rel.eig.cor[1:(zero.eig[1]-1)], rel.eig.cor[(zero.eig[1]+1):n], 0)
		cum.eig.cor <- cumsum(rel.eig.cor)
		k2 <- length(which(eig > epsilon))
		k3 <- length(which(rel.eig.cor > epsilon))
		vectors <- sweep(D.eig$vectors[,1:k2], 2, sqrt(eig[1:k2]), FUN="*")
		# Only the eigenvectors with positive eigenvalues are shown

# Negative eigenvalues: three ways of handling the situation
	if((correct==2) | (correct==3)) {   # Curly 2

		if(correct == 2) {   # Curly 3
			# Lingoes correction: compute c1, then the corrected D
			c1 <- -min.eig
			note <- paste("Lingoes correction applied to negative eigenvalues: D' = -0.5*D^2 -",c1,", except diagonal elements")
			D <- -0.5*(D^2 + 2*c1)

			# Cailliez correction: compute c2, then the corrected D
			} else if(correct == 3) {
				delta2 <- centre((-0.5*D),n)
				upper <- cbind(matrix(0,n,n), 2*delta1)
				lower <- cbind(-diag(n), -4*delta2)
				sp.matrix <- rbind(upper, lower)
				c2 <- max(Re(eigen(sp.matrix, symmetric=FALSE, only.values=TRUE)$values))
				note <- paste("Cailliez correction applied to negative eigenvalues: D' = -0.5*(D +",c2,")^2, except diagonal elements")
				D <- -0.5*(D + c2)^2
			}   # End curly 3

	diag(D) <- 0
	mat.cor <- centre(D,n)
	toto.cor <- eigen(mat.cor)
	trace.cor <- sum(diag(mat.cor))

	# Negative eigenvalues present?
	min.eig.cor <- min(toto.cor$values)
	zero.eig.cor <- which((toto.cor$values < epsilon) & (toto.cor$values > -epsilon))
	toto.cor$values[zero.eig.cor] <- 0

	# No negative eigenvalue after correction: result OK
	if(min.eig.cor > -epsilon) {   # Curly 4
		eig.cor <- toto.cor$values
		rel.eig.cor <- eig.cor[1:k]/trace.cor
		cum.eig.cor <- cumsum(rel.eig.cor)
		k2 <- length(which(eig.cor > epsilon))
		vectors.cor <- sweep(toto.cor$vectors[,1:k2], 2, sqrt(eig.cor[1:k2]), FUN="*")
		rownames(vectors.cor) <- names
		colnames(vectors.cor) <- colnames(vectors.cor, do.NULL = FALSE, prefix = "Axis.")
		# bs <- broken.stick(k2)[,2]
		bs <- bstick.def(k2)
		bs <- c(bs, rep(0,(k-k2)))
		cum.bs <- cumsum(bs)

		# Negative eigenvalues still present after correction: incorrect result
		} else {
		if(correct == 2) cat("Problem! Negative eigenvalues are still present after Lingoes",'\n')
		if(correct == 3) cat("Problem! Negative eigenvalues are still present after Cailliez",'\n')
		rel.eig.cor <- cum.eig.cor <- bs <- cum.bs <- rep(NA,n)
		vectors.cor <- matrix(NA,n,2)
		rownames(vectors.cor) <- names
		colnames(vectors.cor) <- colnames(vectors.cor, do.NULL = FALSE, prefix = "Axis.")
		}   # End curly 4

	res <- data.frame(eig[1:k], eig.cor[1:k], rel.eig.cor, bs, cum.eig.cor, cum.bs)
	colnames(res) <- c("Eigenvalues", "Corr_eig", "Rel_corr_eig", "Broken_stick", "Cum_corr_eig", "Cum_br_stick")
	rownames(res) <- 1:nrow(res)

	rownames(vectors) <- names
	colnames(vectors) <- colnames(vectors, do.NULL = FALSE, prefix = "Axis.")
	out <- (list(correction=c(correction,correct), note=note, values=res, vectors=vectors, trace=trace, vectors.cor=vectors.cor, trace.cor=trace.cor))

	} else {   # Curly 2

	note <- "No correction was applied to the negative eigenvalues"
	bs <- bstick.def(k3)
	bs <- c(bs, rep(0,(k-k3)))
	cum.bs <- cumsum(bs)

	res <- data.frame(eig[1:k], rel.eig, rel.eig.cor, bs, cum.eig.cor, cum.bs)
	colnames(res) <- c("Eigenvalues","Relative_eig","Rel_corr_eig","Broken_stick","Cum_corr_eig","Cumul_br_stick")
	rownames(res) <- 1:nrow(res)

	rownames(vectors) <- names
	colnames(vectors) <- colnames(vectors, do.NULL = FALSE, prefix = "Axis.")
	out <- (list(correction=c(correction,correct), note=note, values=res, vectors=vectors, trace=trace))

			}   # End curly 2: three ways of handling the situation
		}	# End curly 1
	class(out) <- "pcoa"
	out
}	# End of PCoA

## checkValidPhylo.R (2016-07-26)

##   Check the Structure of a "phylo" Object

## Copyright 2015-2016 Emmanuel Paradis

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

checkValidPhylo <- function(phy)
{
    cat("Starting checking the validity of ", deparse(substitute(phy)), "...\n", sep = "")
    n <- m <- NULL
    if (is.null(phy$tip.label)) {
        cat("  FATAL: no element named 'tip.label' in the tree -- did you extract this tree from a \"multiPhylo\" object?\n")
    } else {
        if (!is.vector(phy$tip.label)) {
            cat("  FATAL: 'tip.label' is not a vector\n")
        } else {
            if (!is.character(phy$tip.label))
                cat("  MODERATE: 'tip.label' is not of mode \"character\"\n")
            n <- length(phy$tip.label)
            cat("Found number of tips: n =", n, "\n")
        }
    }

    if (is.null(n))
        cat("  FATAL: cannot determine the number of tips\n")

    if (is.null(phy$Nnode)) {
        cat("  FATAL: no element named 'Nnode' in the tree\n")
    } else {
        if (!is.vector(phy$Nnode)) cat("  MODERATE: 'Nnode' is not a vector\n")
        if (length(phy$Nnode) != 1) cat("  FATAL: 'Nnode' is not of length 1\n")
        if (!is.numeric(phy$Nnode)) {
            cat("  FATAL: 'Nnode' is not numeric\n")
        } else {
            if (storage.mode(phy$Nnode) != "integer")
                cat("  MODERATE: 'Nnode' is not stored as an integer\n")
        }
        if (length(phy$Nnode) == 1 && is.numeric(phy$Nnode)) {
            m <- phy$Nnode
            cat("Found number of nodes: m =", m, "\n")
        }
    }

    if (is.null(m))
        cat("  FATAL: cannot determine the number of nodes\n")

    if (is.null(phy$edge)) {
        cat("  FATAL: no element named 'edge' in the tree\n")
    } else {
        if (!is.matrix(phy$edge)) {
            cat("  FATAL: 'edge' is not a matrix\n")
        } else {
            nc <- ncol(phy$edge)
            if (nc != 2)
                cat("  FATAL: 'edge' has", nc, "columns: it MUST have 2\n")
            if (!is.numeric(phy$edge)) {
                cat("  FATAL: 'edge' is not a numeric matrix\n")
            } else {
                if (storage.mode(phy$edge) != "integer")
                    cat("  MODERATE: the matrix 'edge' is not stored as integers\n")
                if (nc == 2) {
                    if (any(phy$edge <= 0))
                        cat("  FATAL: some elements in 'edge' are negative or zero\n")
                    if (is.null(n) || is.null(m)) {
                        cat("The number of tips and/or nodes was not found: cannot check completely the 'edge' matrix\n")
                    } else {
                        tab <- tabulate(phy$edge)
                        if (length(tab) > n + m)
                            cat("  FATAL: some numbers in 'edge' are larger than 'n + m'\n")
                        if (length(tab) < n + m)
                            cat("  MODERATE: some nodes are missing in 'edge'\n")
                        if (any(tab[1:n] != 1))
                            cat("  FATAL: each tip must appear once in 'edge'\n")
                        if (any(tab[n + 1:m] < 2))
                            cat("  FATAL: all nodes should appear at least twice in 'edge'\n")
                        if (m > 1)
                            if (any(tab[n + 2:m] < 2))
                                cat("  MODERATE: some nodes are of degree 1 or less\n")
                        if (any(phy$edge[, 1] <= n & phy$edge[, 1] > 0))
                            cat("  FATAL: tips should not appear in the 1st column of 'edge'\n")
                        if (any(table(phy$edge[, 2]) > 1))
                            cat("  FATAL: nodes and tips should appear only once in the 2nd column of 'edge'\n")
                        if (any(phy$edge[, 2] == n + 1L))
                            cat("  FATAL: the root node should not appear in the 2nd column of 'edge'\n")
                    }
                }
            }
        }
    }
    cat("Done.\n")
}

## collapsed.intervals.R (2002-09-12)

##   Collapsed coalescent intervals (e.g. for the skyline plot)

## Copyright 2002 Korbinian Strimmer

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

# construct collapsed intervals from coalescent intervals
collapsed.intervals <- function(ci, epsilon=0.0)
{
  if (class(ci) != "coalescentIntervals")
    stop("object \"ci\" is not of class \"coalescentIntervals\"")

  sz <- ci$interval.length
  lsz <- length(sz)
  idx <- c <- 1:lsz

  p <- 1
  w <- 0

  # starting from tips collapes intervals
  # until total size is >= epsilon
  for (i in 1:lsz)
  {
    idx[[i]] <- p
    w <- w + sz[[i]]
    if (w >= epsilon)
    {
      p <- p+1
      w <- 0
    }
  }

  # if last interval is smaller than epsilon merge
  # with second last interval
  lastInterval <- idx==p
  if ( sum(sz[lastInterval]) < epsilon )
  {
    p <- p-1
    idx[lastInterval] <- p
  }

  obj <- list(
     lineages=ci$lineages,
     interval.length=ci$interval.length,
     collapsed.interval=idx, # collapsed intervals (via reference)
     interval.count=ci$interval.count,
     collapsed.interval.count = idx[[ci$interval.count]],
     total.depth =ci$total.depth,
     epsilon = epsilon
    )
  class(obj) <- "collapsedIntervals"

  return(obj)
}

## zoom.R (2009-07-27)

##   Zoom on a Portion of a Phylogeny

## Copyright 2003-2009 Emmanuel Paradis

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

zoom <- function(phy, focus, subtree = FALSE, col = rainbow, ...)
{
    if (!is.list(focus)) focus <- list(focus)
    n <- length(focus)
    for (i in 1:n)
      if (is.character(focus[[i]]))
        focus[[i]] <- which(phy$tip.label %in% focus[[i]]) # fix by Yan Wong
    if (is.function(col)) {
        col <- if (deparse(substitute(col)) == "grey") grey(1:n/n) else col(n)
    }
    ext <- vector("list", n)
    for (i in 1:n)
      ext[[i]] <- drop.tip(phy, phy$tip.label[-focus[[i]]],
                           subtree = subtree, rooted = TRUE)
    nc <- round(sqrt(n)) + 1
    nr <- ceiling(sqrt(n))
    M <- matrix(0, nr, nc)
    x <- c(rep(1, nr), 2:(n + 1))
    M[1:length(x)] <- x
    layout(M, c(1, rep(3/(nc - 1), nc - 1)))
    phy$tip.label <- rep("", length(phy$tip.label))
    colo <- rep("black", dim(phy$edge)[1])
    for (i in 1:n)
      colo[which.edge(phy, focus[[i]])] <- col[i]
    plot.phylo(phy, edge.color = colo, ...)
    for (i in 1:n)
      plot.phylo(ext[[i]], edge.color = col[i], ...)
}

## delta.plot.R (2010-01-12)

##   Delta Plots

## Copyright 2010 Emmanuel Paradis

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

delta.plot <- function(X, k = 20, plot = TRUE, which = 1:2)
{
    if (is.matrix(X)) X <- as.dist(X)
    n <- attr(X, "Size")
    if (n < 4) stop("need at least 4 observations")

    ## add a category for the cases delta = 1
    ans <- .C(delta_plot, as.double(X), as.integer(n),
              as.integer(k), integer(k + 1), double(n),
              NAOK = TRUE)
    counts <- ans[[4]]
    ## add the counts of delta=1 to the last category:
    counts[k] <- counts[k] + counts[k + 1]
    counts <- counts[-(k + 1)]

    delta.bar <- ans[[5]]/choose(n - 1, 3)

    if (plot) {
        if (length(which) == 2) layout(matrix(1:2, 1, 2))
        if (1 %in% which) {
            barplot(counts, space = 0, xlab = expression(delta[q]))
            a <- axTicks(1)
            axis(1, at = a, labels = a/k)
        }
        if (2 %in% which)
            plot(delta.bar, type = "h", ylab = expression(bar(delta)))
    }

    invisible(list(counts = counts, delta.bar = delta.bar))
}

## Cheverud.R (2004-10-29)

##    Cheverud's 1985 Autoregression Model

## Copyright 2004 Julien Dutheil

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

# This function is adapted from a MatLab code from
# Rholf, F. J. (2001) Comparative Methods for the Analysis of Continuous Variables: Geometric Interpretations.
# Evolution 55(11): 2143-2160
compar.cheverud <- function(y, W, tolerance=1e-6, gold.tol=1e-4)
{
  ## fix by Michael Phelan
  diag(W) <- 0 # ensure diagonal is zero
  ## end of fix
  y <- as.matrix(y)
  if(dim(y)[2] != 1) stop("Error: y must be a single column vector.")
  D <- solve(diag(apply(t(W),2,sum)))
  Wnorm <- D %*% W #Row normalize W matrix
  n <- dim(y)[1]
  m <- dim(y)[2]
  y <- y-matrix(rep(1, n)) %*% apply(y,2,mean) # Deviations from mean
  Wy <- Wnorm %*% y

  Wlam <- eigen(Wnorm)$values # eigenvalues of W

  # Find distinct eigenvalues
  sorted <- sort(Wlam)
  # Check real:
  for (ii in 1:n) {
    if(abs(Im(sorted[ii])) > 1e-12) {
      warning(paste("Complex eigenvalue coerced to real:", Im(sorted[ii])))
	  }
    sorted[ii] <- Re(sorted[ii]) # Remove imaginary part
  }
  sorted <- as.double(sorted)

	Distinct <- numeric(0)
  Distinct[1] <- -Inf
  Distinct[2] <- sorted[1]
  nDistinct <- 2
  for(ii in 2:n) {
    if(sorted[ii] - Distinct[nDistinct] > tolerance) {
      nDistinct <- nDistinct + 1
      Distinct[nDistinct] <- sorted[ii]
    }
  }

  # Search for minimum of LL

  likelihood <- function(rhohat) {
    DetProd <- 1
    for(j in 1:n) {
      prod <- 1 - rhohat * Wlam[j]
      DetProd <- DetProd * prod
    }
    absValDet <- abs(DetProd) #[abs to allow rho > 1]
    logDet <- log(absValDet)
    LL <- log(t(y) %*% y - 2 * rhohat * t(y) %*% Wy + rhohat * rhohat * t(Wy) %*% Wy) - logDet*2/n
    return(LL)
  }

  GoldenSearch <- function(ax, cx) {
    # Golden section search over the interval ax to cx
    # Return rhohat and likelihood value.
    r <- 0.61803399
    x0 <- ax
    x3 <- cx
    bx <- (ax + cx)/2
    if(abs(cx - bx) > abs(bx - ax)) {
      x1 <- bx
      x2 <- bx + (1-r)*(cx - bx)
    } else {
      x2 <- bx
      x1 <- bx - (1-r)*(bx - ax)
    }
    f1 <- likelihood(x1)
    f2 <- likelihood(x2)
    while(abs(x3 - x0) > gold.tol*(abs(x1) + abs(x2))) {
      if(f2 < f1) {
        x0 <- x1
        x1 <- x2
        x2 <- r * x1 + (1 - r) * x3
        f1 <- f2
        f2 <- likelihood(x2)
      } else {
        x3 <- x2
        x2 <- x1
        x1 <- r * x2 + (1 - r) * x0
        f2 <- f1
        f1 <- likelihood(x1)
      }
    }
    if(f1 < f2) {
      likelihood <- f1
      xmin <- x1
    } else {
      likelihood <- f2
      xmin <- x2
    }
    return(list(rho=xmin, LL=likelihood))
  }

  LL <- Inf
  for(ii in 2:(nDistinct -1)) {# Search between pairs of roots
    # [ constrain do not use positive roots < 1]
    ax <- 1/Distinct[ii]
    cx <- 1/Distinct[ii+1]
    GS <- GoldenSearch(ax, cx)
    if(GS$LL < LL) {
      LL <- GS$LL
      rho <- GS$rho
    }
  }
  # Compute residuals:
  res <- y - rho * Wy
  return(list(rhohat=rho, Wnorm=Wnorm, residuals=res))
}

#For debugging:
#W<- matrix(c(
#  0,1,1,2,0,0,0,0,
#  1,0,1,2,0,0,0,0,
#  1,1,0,2,0,0,0,0,
#  2,2,2,0,0,0,0,0,
#  0,0,0,0,0,1,1,2,
#  0,0,0,0,1,0,1,2,
#  0,0,0,0,1,1,0,2,
#  0,0,0,0,2,2,2,0
#),8)
#W <- 1/W
#W[W == Inf] <- 0
#y<-c(-0.12,0.36,-0.1,0.04,-0.15,0.29,-0.11,-0.06)
#compar.cheverud(y,W)
#
#y<-c(10,8,3,4)
#W <- matrix(c(1,1/6,1/6,1/6,1/6,1,1/2,1/2,1/6,1/2,1,1,1/6,1/2,1,1), 4)
#compar.cheverud(y,W)

## makeLabel.R (2019-10-14)

##   Label Management

## Copyright 2010-2019 Emmanuel Paradis

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

makeLabel <- function(x, ...) UseMethod("makeLabel")

makeLabel.character <- function(x, len = 99, space = "_",
          make.unique = TRUE, illegal = "():;,[]", quote = FALSE, ...)
{
    x <- gsub("[[:space:]]", space, x)
    if (illegal != "") {
        illegal <- unlist(strsplit(illegal, NULL))
        for (i in illegal) x <- gsub(i, "", x, fixed = TRUE)
    }
    if (quote) len <- len - 2
    nc <- nchar(x) > len
    if (any(nc)) x[nc] <- substr(x[nc], 1, len)
    tab <- table(x)
    if (all(tab == 1)) make.unique <- FALSE
    if (make.unique) {
        dup <- tab[which(tab > 1)]
        nms <- names(dup)
        for (i in 1:length(dup)) {
            j <- which(x == nms[i])
            end <- nchar(x[j][1])
            ## w: number of characters to be added as suffix
            w <- floor(log10(dup[i])) + 1
            suffix <- formatC(1:dup[i], width = w, flag = "0")
            if (end + w > len) {
                start <- end - w + 1
                substr(x[j], start, end) <- suffix
            } else x[j] <- paste(x[j], suffix, sep = "")
        }
    }
    if (quote) x <- paste('"', x, '"', sep = "")
    x
}

makeLabel.phylo <- function(x, tips = TRUE, nodes = TRUE, ...)
{
    if (tips)
        x$tip.label <- makeLabel.character(x$tip.label, ...)
    if (!is.null(x$node.label) && nodes)
        x$node.label <- makeLabel.character(x$node.label, ...)
    x
}

makeLabel.multiPhylo <- function(x, tips = TRUE, nodes = TRUE, ...)
{
    y <- attr(x, "TipLabel")
    if (is.null(y)) {
        for (i in 1:length(x))
            x[[i]] <- makeLabel.phylo(x[[i]], tips = tips, nodes = nodes, ...)
    } else {
        attr(x, "TipLabel") <- makeLabel.character(y, ...)
    }
    x
}

makeLabel.DNAbin <- function(x, ...)
{
    if (is.list(x))
        names(x) <- makeLabel.character(names(x), ...)
    else rownames(x) <- makeLabel.character(rownames(x), ...)
    x
}

mixedFontLabel <-
    function(..., sep = " ", italic = NULL, bold = NULL, parenthesis = NULL,
             always.upright = c("sp.", "spp.", "ssp."))
{
    x <- list(...)
    n <- length(x)

    if (!is.null(italic)) {
        for (i in italic) {
            y <- x[[i]]
            s <- ! y %in% always.upright
            y[s] <- paste("italic(\"", y[s], "\")", sep = "")
            if (any(!s)) y[!s] <- paste("plain(\"", y[!s], "\")", sep = "")
            x[[i]] <- y
        }
    }

    if (!is.null(bold)) {
        for (i in bold) {
            y <- x[[i]]
            s <- logical(length(y))
            s[grep("^italic", y)] <- TRUE
            y[s] <- sub("^italic", "bolditalic", y[s])
            y[!s] <- paste("bold(\"", y[!s], "\")", sep = "")
            x[[i]] <- y
        }
    }

    k <- which(! 1:n %in% c(italic, bold)) # those in upright
    if (length(k))
        for (i in k)
            x[[i]] <- paste("plain(\"", x[[i]], "\")", sep = "")

    if (!is.null(parenthesis))
        for (i in parenthesis)
            x[[i]] <- paste("(", x[[i]], ")", sep = "")

    res <- x[[1L]]
    if (n > 1) {
        sep <- rep(sep, length.out = n - 1L)
        for (i in 2:n)
            res <- paste(res, "*\"", sep[i - 1L], "\"*", x[[i]], sep = "")
    }
    parse(text = res)
}

.getSeparatorTaxaLabels <- function(x)
{
    if (length(grep("_", x))) "_" else " "
}

label2table <- function(x, sep = NULL, as.is = FALSE)
{
    n <- length(x)
    if (is.null(sep)) sep <- .getSeparatorTaxaLabels(x)
    x <- strsplit(x, sep)
    maxlen <- max(lengths(x))
    x <- unlist(lapply(x, "[", 1:maxlen))
    x <- matrix(x, n, maxlen, byrow = TRUE)
    x <- as.data.frame(x, as.is = as.is)
    baselevels <- c("genus", "species", "subspecies")
    nmx <- if (maxlen <= 3) baselevels[1:maxlen]
           else c(baselevels, paste0("type", 1:(maxlen - 3)))
    names(x) <- nmx
    x
}

stripLabel <- function(x, species = FALSE, subsp = TRUE, sep = NULL)
{
    if (is.null(sep)) sep <- .getSeparatorTaxaLabels(x)
    n <- 0
    if (species) n <- 1 else if (subsp) n <- 2
    if (!n) return(x)
    x <- strsplit(x, sep)
    x <- lapply(x, "[", 1:n)
    sapply(x, paste, collapse = sep)
}

abbreviateGenus <- function(x, genus = TRUE, species = FALSE, sep = NULL)
{
    if (is.null(sep)) sep <- .getSeparatorTaxaLabels(x)
    if (genus) x <- sub(paste0("[[:lower:]]{1,}", sep), paste0(".", sep), x)
    if (!species) return(x)
    x <- strsplit(x, sep)
    k <- which(lengths(x, use.names = FALSE) > 1)
    for (i in k)
        x[[i]][2] <- paste0(substr(x[[i]][2], 1, 1), ".")
    sapply(x, paste, collapse = sep)
}

updateLabel <- function(x, old, new, ...) UseMethod("updateLabel")

updateLabel.character <- function(x, old, new, exact = TRUE, ...)
{
    if (length(old) != length(new))
        stop("'old' and 'new' not of the same length")
    if (exact) {
        for (i in seq_along(old))
            x[x == old[i]] <- new[i]
    } else {
        for (i in seq_along(old))
            x[grep(old[i], x)] <- new[i]
    }
    x
}

updateLabel.DNAbin <- function(x, old, new, exact = TRUE, ...)
{
    labs <- labels(x)
    labs <- updateLabel.character(labs, old, new, exact, ...)
    if (is.list(x)) names(x) <- labs else rownames(x) <- labs
    x
}

updateLabel.AAbin <- function(x, old, new, exact = TRUE, ...)
    updateLabel.DNAbin(x, old, new, exact, ...)

updateLabel.phylo <- function(x, old, new, exact = TRUE, nodes = FALSE, ...)
{
    x$tip.label <- updateLabel.character(x$tip.label, old, new, exact, ...)
    if (nodes)
        x$node.label <- updateLabel.character(x$node.label, old, new, exact, ...)
    x
}

updateLabel.evonet <- function(x, old, new, exact = TRUE, nodes = FALSE, ...)
    updateLabel.phylo(x, old, new, exact, nodes, ...)


updateLabel.data.frame <- function(x, old, new, exact = TRUE, ...)
{
    row.names(x) <- updateLabel.character(row.names(x), old, new, exact, ...)
    x
}

updateLabel.matrix <- function(x, old, new, exact = TRUE, ...)
{
    rownames(x) <- updateLabel.character(rownames(x), old, new, exact, ...)
    x
}

## mrca.R (2017-07-28)

##   Find Most Recent Common Ancestors Between Pairs

## Copyright 2005-2017 Emmanuel Paradis

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

mrca <- function(phy, full = FALSE)
{
    if (!inherits(phy, "phylo")) stop('object "phy" is not of class "phylo"')
    ## Get all clades:
    n <- length(phy$tip.label)
    m <- phy$Nnode
    phy <- reorder.phylo(phy, "postorder")
    BP <- bipartition2(phy$edge, n)
    N <- n + m
    ROOT <- n + 1L
    ## In the following matrix, numeric indexing will be used:
    M <- numeric(N * N)
    dim(M) <- c(N, N)

    e1 <- phy$edge[, 1]
    e2 <- phy$edge[, 2]

    ## We start at the root:
    next.node <- ROOT
    while (length(next.node)) {
        tmp <- numeric(0)
        for (anc in next.node) {
            ## Find the branches which `anc' is the ancestor...:
            id <- which(e1 == anc)
            ## ... and get their descendants:
            desc <- e2[id]
            ## `anc' is itself the MRCA of its direct descendants:
            M[anc, desc] <- M[desc, anc] <- anc
            ## Find all 2-by-2 combinations of `desc': `anc'
            ## is their MRCA:
            for (i in 1:length(desc))
                M[cbind(desc[i], desc[-i])] <- anc
            ## If one element of `desc' is a node, then the tips it
            ## leads to and the other elements of `desc' have also
            ## `anc' as MRCA!
            for (i in 1:length(desc)) {
                if (desc[i] < ROOT) next
                ## (get the tips:)
                tips <- BP[[desc[i] - n]]
                ## Same thing for the nodes...
                node.desc <- numeric(0)
                for (k in 1:m) {
                    if (k == desc[i] - n) next
                    ## If the clade of the current node is a
                    ## subset of desc[i], then it is one of its
                    ## descendants:
                    if (all(BP[[k]] %in% tips))
                      node.desc <- c(node.desc, k)
                }
                ## all nodes and tips which are descendants of
                ## `desc[i]':
                ALLDESC <- c(tips, node.desc + n)
                M[ALLDESC, desc[-i]] <- M[desc[-i], ALLDESC] <- anc
                for (j in 1:length(desc)) {
                    if (j == i || desc[j] < ROOT) next
                    tips2 <- BP[[desc[j] - n]]
                    node.desc <- numeric(0)
                    for (k in 1:m) {
                        if (k == desc[j] - n) next
                        if (all(BP[[k]] %in% tips2))
                          node.desc <- c(node.desc, k)
                    }
                    ALLDESC2 <- c(tips2, node.desc + n)
                    M[ALLDESC, ALLDESC2] <- M[ALLDESC2, ALLDESC] <- anc
                }
                ## `anc' is also the MRCA of itself and its descendants:
                M[ALLDESC, anc] <- M[anc, ALLDESC] <- anc
            }
            ## When it is done, `desc' i stored to become
            ## the new `next.node', if they are nodes:
            tmp <- c(tmp, desc[desc > n])
        }
        next.node <- tmp
    }
    M[cbind(1:N, 1:N)] <- 1:N
    if (full)
        dimnames(M)[1:2] <- list(as.character(1:N))
    else {
        M <- M[1:n, 1:n]
        dimnames(M)[1:2] <- list(phy$tip.label)
    }
    M
}

## rotate.R (2014-06-05)

##   Ancestral Character Estimation

## Copyright 2007 Christoph Heibl

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

rotate <- function(phy, node, polytom = c(1,2)){
	# load DESCENDANTS function
	DESCENDANTS <- function(tree, node){
		tips <- length(tree$tip.label)
		x <- tree$edge[,2][tree$edge[,1] == node]
		while(max(x) > tips){
			x <- x[x > tips]
			for(h in 1:length(x)) tree$edge <- tree$edge[!tree$edge[,2] == x[h],]
			for(i in 1:length(x)) tree$edge[,1][tree$edge[,1] == x[i]] <- node
			x <- tree$edge[,2][tree$edge[,1] == node]
			}
		x
		}

	if (!inherits(phy, "phylo")) # is phy of class phylo?
        stop("object \"phy\" is not of class \"phylo\"")
        phy <- reorder(phy) # added by EP 2014-06-05
    nb.tips <- length(phy$tip.label) # number of tiplabels
	max.int.node <- phy$Nnode+nb.tips # number of last internal node
	nb.edges <- dim(phy$edge)[1] # number of branches
	if (length(node) == 2){ # get MRCA if tips are given for node
    	if (mode(node) == "character"){
    		if (any(!node %in% phy$tip.label)) # do tiplabels correspond
        		stop("object \"node\" contains tiplabels not present in object \"phy\"")
    		tips <- cbind(phy$tip.label, 1:nb.tips)
    		node[1] <- tips[,2][tips[,1] == node[1]]
			node[2] <- tips[,2][tips[,1] == node[2]]
			node <- as.numeric(node)
    		}
    	if (any(!node %in% 1:nb.tips))
        	stop("object \"node\" does not contain terminal nodes")
    	node <- getMRCA(phy, node)
    	}
	if (node  <= nb.tips || node > max.int.node) # is node really internal?
        stop("object \"node\" is not an internal node of object \"phy\"")
	with.br.length <- !is.null(phy$edge.length) # does phy contain brlength?
	G <- cbind(phy$edge, 1:(length(phy$edge)/2))
	N <- phy$edge[phy$edge[,1] == node]
	N <- N[N != node]
	if (length(N) > 2) N <- N[polytom]
	CLADE1 <- N[1]
	CLADE2 <- N[2]
# do clades comprise interior nodes?
	if (CLADE1 > nb.tips) CLADE11 <- DESCENDANTS(phy, CLADE1)
	if (CLADE2 > nb.tips) CLADE22 <- DESCENDANTS(phy, CLADE2)
# calculate inidices of clades in phy.edge
		if (CLADE1 > nb.tips){
			c1 <- G[,3][G[,2] == CLADE1]
			c2 <- G[,3][G[,2] == max(CLADE11)]
			} else {
			c1 <- G[,3][G[,2] == CLADE1]
			c2 <- G[,3][G[,2] == CLADE1]
			}
		if (CLADE2 > nb.tips){
			c3 <- G[,3][G[,2] == CLADE2]
			c4 <- G[,3][G[,2] == max(CLADE22)]
			} else {
			c3 <- G[,3][G[,2] == CLADE2]
			c4 <- G[,3][G[,2] == CLADE2]
			}

# create new phy$edge and  phy$edge.length
if (c2+1 == c3){
	if (c1 == 1 && c4 != nb.edges){
		phy$edge <- rbind(phy$edge[c3:c4,], phy$edge[c1:c2,], phy$edge[(c4+1):nb.edges,])
			if (with.br.length)
			phy$edge.length <- c(phy$edge.length[c3:c4], phy$edge.length[c1:c2], phy$edge.length[(c4+1):nb.edges])
		}
	if (c1 !=1 && c4 == nb.edges){
		phy$edge <- rbind(phy$edge[1:(c1-1),], phy$edge[c3:c4,], phy$edge[c1:c2,])
			if (with.br.length)
			phy$edge.length <- c(phy$edge.length[1:(c1-1)], phy$edge.length[c3:c4], phy$edge.length[c1:c2])
		}
	if (c1 !=1 && c4 != nb.edges){
		phy$edge <- rbind(phy$edge[1:(c1-1),], phy$edge[c3:c4,], phy$edge[c1:c2,], phy$edge[(c4+1):nb.edges,])
			if (with.br.length)
			phy$edge.length <- c(phy$edge.length[1:(c1-1)], phy$edge.length[c3:c4], phy$edge.length[c1:c2], phy$edge.length[(c4+1):nb.edges])
		}
	if (c1 ==1 && c4 == nb.edges){
		phy$edge <- rbind(phy$edge[c3:c4,], phy$edge[c1:c2,])
			if (with.br.length)
			phy$edge.length <- c(phy$edge.length[c3:c4], phy$edge.length[c1:c2])
		}
	}
else {
	if (c1 == 1 && c4 != nb.edges){
		phy$edge <- rbind(phy$edge[c3:c4,], phy$edge[(c2+1):(c3-1),], phy$edge[c1:c2,], phy$edge[(c4+1):nb.edges,])
			if (with.br.length)
			phy$edge.length <- c(phy$edge.length[c3:c4], phy$edge.length[(c2+1):(c3-1)], phy$edge.length[c1:c2], phy$edge.length[(c4+1):nb.edges])
		}
	if (c1 !=1 && c4 == nb.edges){
		phy$edge <- rbind(phy$edge[1:(c1-1),], phy$edge[c3:c4,], phy$edge[(c2+1):(c3-1),], phy$edge[c1:c2,])
			if (with.br.length)
			phy$edge.length <- c(phy$edge.length[1:(c1-1)], phy$edge.length[c3:c4], phy$edge.length[(c2+1):(c3-1)], phy$edge.length[c1:c2])
		}
	if (c1 !=1 && c4 != nb.edges){
		phy$edge <- rbind(phy$edge[1:(c1-1),], phy$edge[c3:c4,], phy$edge[(c2+1):(c3-1),], phy$edge[c1:c2,], phy$edge[(c4+1):nb.edges,])
			if (with.br.length)
			phy$edge.length <- c(phy$edge.length[1:(c1-1)], phy$edge.length[c3:c4], phy$edge.length[(c2+1):(c3-1)], phy$edge.length[c1:c2], phy$edge.length[(c4+1):nb.edges])
			}
	if (c1 ==1 && c4 == nb.edges){
		phy$edge <- rbind(phy$edge[c3:c4,], phy$edge[(c2+1):(c3-1),], phy$edge[c1:c2,])
			if (with.br.length)
			phy$edge.length <- c(phy$edge.length[c3:c4], phy$edge.length[(c2+1):(c3-1)], phy$edge.length[c1:c2])
		}
	}
	phy
	}

## which.edge.R (2017-10-04)

##   Identifies Edges of a Tree

## Copyright 2004-2017 Emmanuel Paradis, 2017 Joseph W. Brown, 2017 Klaus Schliep

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

getMRCA <- function(phy, tip) {
    if (!inherits(phy, "phylo"))
        stop('object "phy" is not of class "phylo"')
    if (length(tip) < 2) return(NULL)
    Ntip <- length(phy$tip.label)
    ## <FIXME> do we need to check the value(s) in 'tip'?
    ##if (any(tip > Ntip + phy$Nnode) || any(tip < 1))
    ##    stop("value(s) out of range in 'tip'")
    ## </FIXME>
    rootnd <- Ntip + 1L

    pars <- integer(phy$Nnode) # worst case assignment, usually far too long
    tnd <- if (is.character(tip)) match(tip, phy$tip.label) else tip

    done_v <- logical(Ntip + phy$Nnode)

    ## build a lookup table to get parents faster
    pvec <- integer(Ntip + phy$Nnode)
    pvec[phy$edge[, 2]] <- phy$edge[, 1]

    ## get entire lineage for first tip
    nd <- tnd[1]
    for (k in 1:phy$Nnode) {
        nd <- pvec[nd]
        pars[k] <- nd
        if (nd == rootnd) break
    }
    pars <- pars[1:k] # delete the rest
    mrcind <- integer(max(pars))
    mrcind[pars] <- 1:k

    mrcand <- pars[1]

    ## traverse lineages for remaining tips, stop if hit common ancestor
    for (i in 2:length(tnd)) {
        cnd <- tnd[i]
        done <- done_v[cnd]
        while(!done){
            done_v[cnd] <- TRUE
            cpar <- pvec[cnd] # get immediate parent
            done <- done_v[cpar] # early exit if TRUE
            if (cpar %in% pars) {
                if (cpar == rootnd) return(rootnd) # early exit
                if(mrcind[cpar] > mrcind[mrcand]) mrcand <- cpar
                done_v[cpar] <- TRUE
                done <- TRUE
            }
            cnd <- cpar # keep going!
        }
    }
    mrcand
}

which.edge <- function(phy, group)
{
    if (!inherits(phy, "phylo"))
        stop('object "phy" is not of class "phylo"')
    if (is.character(group))
        group <- which(phy$tip.label %in% group)
    if (length(group) == 1)
        return(match(group, phy$edge[, 2]))

    n <- length(phy$tip.label)
    sn <- .Call(seq_root2tip, phy$edge, n, phy$Nnode)[group]
    i <- 2L
    repeat {
        x <- unique(unlist(lapply(sn, "[", i)))
        if (length(x) != 1) break
        i <- i + 1L
    }
    d <- -(1:(i - 1L))
    x <- unique(unlist(lapply(sn, function(x) x[d])))
    match(x, phy$edge[, 2L])
}

## as.bitsplits.R (2020-07-20)

##   Conversion Among Split Classes

## Copyright 2011-2020 Emmanuel Paradis, 2019 Klaus Schliep

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

as.bitsplits <- function(x) UseMethod("as.bitsplits")

as.bitsplits.prop.part <- function(x)
{
    foo <- function(vect, RAWVECT) {
        res <- RAWVECT
        for (y in vect) {
            i <- ceiling(y/8)
            res[i] <- res[i] | as.raw(2^(8 - ((y - 1) %% 8) - 1))
        }
        res
    }

    N <- length(x) # number of splits
    n <- length(x[[1]]) # number of tips

    nr <- ceiling(n/8)
    mat <- raw(N * nr)
    dim(mat) <- c(nr, N)

    RAWVECT <- raw(nr)

    for (i in 1:N) mat[, i] <- foo(x[[i]], RAWVECT)

    ## add the n trivial splits of size 1... :
    mat.bis <- raw(n * nr)
    dim(mat.bis) <- c(nr, n)
    for (i in 1:n) mat.bis[, i] <- foo(i, RAWVECT)

    ## ... drop the trivial split of size n... :
    mat <- cbind(mat.bis, mat[, -1, drop = FALSE])

    ## ... update the split frequencies... :
    freq <- attr(x, "number")
    freq <- c(rep(freq[1L], n), freq[-1L])

    ## ... and numbers:
    N <- N + n - 1L

    structure(list(matsplit = mat, labels = attr(x, "labels"),
                   freq =  freq), class = "bitsplits")
}

print.bitsplits <- function(x, ...)
{
    cat('Object of class "bitsplits"\n')
    cat('   ', length(x$labels), 'tips\n')
    cat('   ', length(x$freq), 'partitions\n')
}

sort.bitsplits <- function(x, decreasing = FALSE, ...)
{
    o <- order(x$freq, decreasing = decreasing)
    x$matsplit <- x$matsplit[, o]
    x$freq <- x$freq[o]
    x
}

as.prop.part <- function(x, ...) UseMethod("as.prop.part")

as.prop.part.bitsplits <- function(x, include.trivial = FALSE, ...)
{
    decodeBitsplits <- function(x) {
        f <- function(y) rev(rawToBits(y)) == as.raw(1)
        which(unlist(lapply(x, f)))
    }
    N <- ncol(x$matsplit) # nb of splits
    n <- length(x$labels) # nb of tips
    Nres <- if (include.trivial) N + 1L else N
    res <- vector("list", Nres)
    if (include.trivial) res[[1]] <- 1:n
    j <- if (include.trivial) 2L else 1L
    for (i in 1:N) {
        res[[j]] <- decodeBitsplits(x$matsplit[, i])
        j <- j + 1L
    }
    attr(res, "number") <- if (include.trivial) c(N, x$freq) else x$freq
    attr(res, "labels") <- x$labels
    class(res) <- "prop.part"
    res
}

bitsplits <- function(x)
{
    if (inherits(x, "phylo")) {
        x <- list(x)
        class(x) <- "multiPhylo"
    } else {
        if (!inherits(x, "multiPhylo"))
            stop('x is not of class "phylo" or "multiPhylo"')
    }
    x <- .compressTipLabel(x)
    labs <- attr(x, "TipLabel")
    n <- length(labs)
    nr <- ceiling(n/8)
    ans <- .Call(bitsplits_multiPhylo, x, n, nr)
    nc <- ans[[3]]
    o <- ans[[1]][1:(nr * nc)]
    freq <- ans[[2]][1:nc]
    dim(o) <- c(nr, nc)
    structure(list(matsplit = o, labels = labs, freq = freq),
              class = "bitsplits")
}

countBipartitions <- function(phy, X)
{
    split <- bitsplits(phy)
    SPLIT <- bitsplits(X)
    .Call("CountBipartitionsFromSplits", split, SPLIT)
}

## mcmc.popsize.R (2013-07-19)

##   Run reversible jump MCMC to sample demographic histories

## Copyright 2004-2013 Rainer Opgen-Rhein and Korbinian Strimmer

## Portions of this function are adapted from rjMCMC code by
## Karl W Broman (see http://www.biostat.wisc.edu/~kbroman/)

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

# public function

# run rjMCMC chain
if (getRversion() >= "2.15.1")
    utils::globalVariables(c("loglik", "b.lin", "popsize"))

mcmc.popsize <-
    function(tree, nstep, thinning = 1, burn.in = 0, progress.bar = TRUE,
             method.prior.changepoints = c("hierarchical", "fixed.lambda"),
             max.nodes = 30,
             lambda = 0.5, # "fixed.lambda" method.prior.changepoints
             gamma.shape = 0.5,
             gamma.scale = 2, # gamma distribution from which lambda is drawn (for "hierarchical" method)
             method.prior.heights = c("skyline", "constant", "custom"),
             prior.height.mean, prior.height.var)
{
    method.prior.changepoints <- match.arg(method.prior.changepoints)
    method.prior.heights <- match.arg(method.prior.heights)

    ## Calculate skylineplot, coalescent intervals
    ## and estimated population sizes

    if (inherits(tree, "phylo")) {
        ci <- coalescent.intervals(tree)
        sk1 <- skyline(ci)
    } else if (class(tree) == "coalescentIntervals") {
        ci <- tree
        sk1 <- skyline(ci)
    } else
        stop("tree must be an object of class phylo or coalescentIntervals")

    ## consider possibility of more than one lineage
    ci$lineages <- ci$lineages[sk1$interval.length > 0]
    ci$interval.length <- ci$interval.length[sk1$interval.length > 0]
    data <- sk1$time <- sk1$time[sk1$interval.length > 0]
    sk1$population.size <- sk1$population.size[sk1$interval.length > 0]
    sk1$interval.length <- sk1$interval.length[sk1$interval.length > 0]

    ## constant prior for heights

    if (method.prior.heights == "constant") {
        prior.height.mean <- function(position)
            mean(sk1$population.size)
        prior.height.var <- function(position)
            (mean(sk1$population.size))^2
    }

    ## skyline plot prior for heights

    if (method.prior.heights == "skyline") {
        TIME <- sk1$time
        numb.interv <- 10
        prior.change.times <- abs((0:numb.interv) * max(TIME)/numb.interv)
        prior.height.mean.all <- prior.height.var.all <- vector(length = numb.interv)
        for (p.int in 1:(numb.interv)) {
            left <- p.int
            right <- p.int + 1
            sample.pop <- sk1$population.size[sk1$time >= prior.change.times[left] & sk1$time <= prior.change.times[right]]
            while (length(sample.pop) < 10) {
                if (left > 1) left <- left - 1
                if (right < length(prior.change.times)) right <- right + 1
                sample.pop <- sk1$population.size[sk1$time >= prior.change.times[left] & sk1$time <= prior.change.times[right]]
            }
            prior.height.mean.all[p.int] <- sum(sample.pop)/length(sample.pop)
            prior.height.var.all[p.int] <- sum((sample.pop-prior.height.mean.all[p.int])^2)/(length(sample.pop) - 1)
        }

        prior.height.mean <- function(position) {
            j <- sum(prior.change.times <= position)
            if (j >= length(prior.height.mean.all)) j <- length(prior.height.mean.all)
            prior.mean <- prior.height.mean.all[j]
            prior.mean
        }

        prior.height.var <- function(position) {
            j <- sum(prior.change.times <= position)
            if (j >= length(prior.height.var.all)) j <- length(prior.height.var.all)
            prior.var <- prior.height.var.all[j]
            prior.var
        }
    }

    if (method.prior.heights == "custom") {
        if (missing(prior.height.mean) || missing(prior.height.var))
            stop("custom priors not specified")
    }

    ## set prior
    prior <- vector(length = 4)
    prior[4] <- max.nodes

    ## set initial position of markov chain and likelihood
    pos <- c(0, max(data))
    h <- c(rep(mean(sk1$population.size), 2))

    b.lin <- choose(ci$lineages, 2)
    ## loglik <<- loglik.pop # modified by EP

    ## set lists for data
    count.it <- floor((nstep - burn.in)/thinning)
    save.pos <- save.h <- vector("list", count.it)
    save.loglik <- 1:count.it
    save.steptype <- 1:count.it
    save.accept <- 1:count.it

    ## calculate jump probabilities for given lambda of the prior
    if (method.prior.changepoints == "fixed.lambda") {
        prior[1] <- lambda
        jump.prob <- matrix(ncol = 4, nrow = prior[4] + 1)
        p <- dpois(0:prior[4], prior[1])/ppois(prior[4] + 1, prior[1])
        bk <- c(p[-1]/p[-length(p)], 0)
        bk[bk > 1] <- 1
        dk <- c(0, p[-length(p)]/p[-1])
        dk[dk > 1] <- 1
        mx <- max(bk + dk)
        bk <- bk/mx*0.9
        dk <- dk/mx*0.9
        bk[is.na(bk)] <- 0     # added
        dk[is.na(dk)] <- 0     # added
        jump.prob[, 3] <- bk
        jump.prob[, 4] <- dk
        jump.prob[1, 2] <- 0
        jump.prob[1, 1] <- 1 - bk[1] - dk[1]
        jump.prob[-1, 1] <- jump.prob[-1, 2] <-
            (1 - jump.prob[-1, 3] - jump.prob[-1, 4])/2
    }


    ## calculate starting loglik
    curloglik <- loglik.pop(data, pos, h, b.lin, sk1, ci)

    count.i <- 1

    ## set progress bar
    if (progress.bar == TRUE) {
        dev.new(width = 3, height = 0.7)
        par(mar = c(0.5, 0.5, 2, 0.5))
        plot(x = c(0, 0), y = c(0, 1), type = "l", xlim = c(0, 1), ylim = c(0, 1),
             main = "rjMCMC in progress", ylab = "", xlab = "", xaxs = "i",
             yaxs = "i", xaxt = "n", yaxt = "n")
    }

    ## BEGIN CALCULATION

    for (i in (1:nstep + 1)) {
        if (progress.bar == TRUE) {
            if (i %% 100 == 0) {
                z <- i/nstep
                zt <- (i - 100)/(nstep)
                polygon(c(zt, zt, z, z), c(1, 0, 0, 1), col = "black")
            }
        }

        ## calculate jump probabilities without given lamda
        if (method.prior.changepoints == "hierarchical") {
            prior[1] <- rgamma(1, shape = gamma.shape, scale = gamma.scale)
            jump.prob <- matrix(ncol = 4, nrow = prior[4] + 1)
            p <- dpois(0:prior[4], prior[1]) / ppois(prior[4] + 1, prior[1])
            bk <- c(p[-1]/p[-length(p)], 0)
            bk[bk > 1] <- 1
            dk <- c(0, p[-length(p)]/p[-1])
            dk[dk > 1] <- 1
            mx <- max(bk + dk)
            bk <- bk/mx*0.9
            dk <- dk/mx*0.9
            bk[is.na(bk)] <- 0   # added
            dk[is.na(dk)] <- 0   # added
            jump.prob[, 3] <- bk
            jump.prob[, 4] <- dk
            jump.prob[1, 2] <- 0
            jump.prob[1, 1] <- 1 - bk[1] - dk[1]
            jump.prob[-1, 1] <- jump.prob[-1, 2] <-
                (1 - jump.prob[-1, 3] - jump.prob[-1, 4])/2
        }

        ## determine what type of jump to make
        wh <- sample(1:4, 1, prob = jump.prob[length(h)-1, ])

        if (i %% thinning == 0 & i > burn.in) save.steptype[[count.i]] <- wh

        if (wh == 1) {
            step <- ht.move(data, pos, h, curloglik, prior, b.lin, sk1, ci, prior.height.mean, prior.height.var)
            h <- step[[1]]
            curloglik <- step[[2]]
            if (i %% thinning == 0 & i > burn.in) {
                save.pos[[count.i]] <- pos
                save.h[[count.i]] <- h
                save.loglik[[count.i]] <- step[[2]]
                save.accept[[count.i]] <- step[[3]]
            }
        } else if (wh == 2) {
            step <- pos.move(data, pos, h, curloglik, b.lin, sk1, ci)
            pos <- step[[1]]
            curloglik <- step[[2]]
            if (i %% thinning == 0 & i > burn.in) {
                save.pos[[count.i]] <- pos
                save.h[[count.i]] <- h
                save.loglik[[count.i]] <- step[[2]]
                save.accept[[count.i]] <- step[[3]]
            }
        } else if (wh == 3) {
            step <- birth.step(data, pos, h, curloglik, prior, jump.prob, b.lin, sk1, ci, prior.height.mean, prior.height.var)
            pos <- step[[1]]
            h <- step[[2]]
            curloglik <- step[[3]]
            if (i %% thinning == 0 & i > burn.in) {
                save.pos[[count.i]] <- pos
                save.h[[count.i]] <- h
                save.loglik[[count.i]] <- step[[3]]
                save.accept[[count.i]] <- step[[4]]
            }
        } else {
            step <- death.step(data, pos, h, curloglik, prior, jump.prob, b.lin, sk1, ci, prior.height.mean, prior.height.var)
            pos <- step[[1]]
            h <- step[[2]]
            curloglik <- step[[3]]
            if (i %% thinning == 0 & i > burn.in) {
                save.pos[[count.i]] <- pos
                save.h[[count.i]] <- h
                save.loglik[[count.i]] <- step[[3]]
                save.accept[[count.i]] <- step[[4]]
            }
        }
        if (i %% thinning == 0 & i > burn.in) count.i <- count.i + 1
    }

    if (progress.bar == TRUE) dev.off()

    list(pos = save.pos, h = save.h, loglik = save.loglik,
         steptype = save.steptype, accept = save.accept)
}

## private functions

ht.move <-
    function(data, pos, h, curloglik, prior, b.lin, sk1, ci, prior.height.mean, prior.height.var)
{
    j <- sample(1:length(h), 1)

    prior.mean <- prior.height.mean(pos[j])
    prior.var <- prior.height.var(pos[j])

    prior[3] <- prior.mean/prior.var
    prior[2] <- (prior.mean^2)/prior.var

    newh <- h
    newh[j] <- h[j] * exp(runif(1, -0.5, 0.5))

    newloglik <- loglik.pop(data, pos, newh, b.lin, sk1, ci)
    lr <- newloglik - curloglik

  ratio <- exp(lr + prior[2] * (log(newh[j]) - log(h[j])) - prior[3] * (newh[j] - h[j]))

    if (runif(1, 0, 1) < ratio)
        return(list(newh, newloglik, 1))
    else
        return(list(h, curloglik, 0))
}

pos.move <- function(data, pos, h, curloglik, b.lin, sk1, ci)
{
    j <- if (length(pos) == 3) 2 else sample(2:(length(pos)-1), 1)
    newpos <- pos
    left <- pos[j - 1]
    right <- pos[j + 1]
    newpos[j] <- runif(1, left, right)

    newloglik <- loglik.pop(data, newpos, h, b.lin, sk1, ci)
    lr <- newloglik - curloglik

    ratio <- exp(lr) * (right - newpos[j])*(newpos[j]- left)/
        (right - pos[j])/(pos[j] - left)

    if (runif(1, 0, 1) < ratio)
        return(list(newpos, newloglik, 1))
    else
        return(list(pos, curloglik, 0))
}

birth.step <-
    function(data, pos, h, curloglik, prior, jump.prob, b.lin, sk1, ci, prior.height.mean, prior.height.var)
{
    newpos <- runif(1, 0, pos[length(pos)])
    j <- sum(pos < newpos)

    left <- pos[j]
    right <- pos[j + 1]

    prior.mean <- prior.height.mean(pos[j])
    prior.var <- prior.height.var(pos[j])
    prior[3] <- prior.mean/prior.var
    prior[2] <- (prior.mean^2)/prior.var

    u <- runif(1, -0.5, 0.5)
    oldh <- (((newpos - left)/(right - left))*(h[j + 1] - h[j]) + h[j])
    newheight <- oldh*(1 + u)

    ## ratio
    ## recall that prior = (lambda, alpha, beta, maxk)
    k <- length(pos) - 2
    L <- max(pos)

    prior.logratio <- log(prior[1]) - log(k+1) +  log((2*k + 3)*(2*k + 2)) - 2*log(L) +
        log(newpos - left) + log(right - newpos) - log(right - left) +
            prior[2]*log(prior[3]) - lgamma(prior[2]) +
                (prior[2] - 1) * log(newheight) + prior[3]*(newheight)

    proposal.ratio <- jump.prob[k + 2, 4]*L/jump.prob[k + 1, 3]/(k + 1)
    jacobian <- (((newpos - left)/(right - left))*(h[j + 1] - h[j])) + h[j]

    ## form new parameters
    newpos <- sort(c(pos, newpos))
    newh <- c(h[1:j], newheight, h[(j + 1):length(h)])

    newloglik <- loglik.pop(data, newpos, newh, b.lin, sk1, ci)
    lr <- newloglik - curloglik
    ratio <- exp(lr + prior.logratio) * proposal.ratio * jacobian

    if (runif(1, 0, 1) < ratio)
        return(list(newpos, newh, newloglik, 1))
    else
        return(list(pos, h, curloglik, 0))
}

death.step <-
    function(data, pos, h, curloglik, prior, jump.prob, b.lin, sk1, ci, prior.height.mean, prior.height.var)
{
    ## position to drop
    if (length(pos) == 3) j <- 2
    else j <- sample(2:(length(pos) - 1), 1)

    left <- pos[j - 1]
    right <- pos[j + 1]

    prior.mean <- prior.height.mean(pos[j])
    prior.var <- prior.height.var(pos[j])
    prior[3] <- prior.mean/prior.var
    prior[2] <- (prior.mean^2)/prior.var

    ## get new height
    h.left <- h[j - 1]
    h.right <- h[j + 1]
    newheight <- (((pos[j] - left)/(right - left))*(h.right - h.left) + h.left)

    ## ratio
    ## recall that prior = (lambda, alpha, beta, maxk)
    k <- length(pos) - 3
    L <- max(pos)

    prior.logratio <- log(k+1) - log(prior[1]) -  log(2*(k + 1)*(2*k + 3)) + 2*log(L) -
        log(pos[j] - left) - log(right - pos[j]) + log(right - left) -
            prior[2]*log(prior[3]) + lgamma(prior[2]) -
                (prior[2]-1) * log(newheight) - prior[3]*(newheight)
    proposal.ratio <- (k + 1)*jump.prob[k + 1, 3]/jump.prob[k + 2, 4]/L
    jacobian <- ((pos[j] - left)/(right - left))*(h[j + 1] - h[j - 1]) + h[j - 1]

    ## form new parameters
    newpos <- pos[-j]
    newh <- h[-j]

    newloglik <- loglik.pop(data, newpos, newh, b.lin, sk1, ci)
    lr <- newloglik - curloglik
    ratio <- exp(lr + prior.logratio) * proposal.ratio * (jacobian^(-1))

    if (runif(1, 0, 1) < ratio)
        return(list(newpos, newh, newloglik, 1))
    else
        return(list(pos, h, curloglik, 0))


}

# calculate the log likelihood for a set of data
loglik.pop <-
    function(time = sk1$time, pos = c(0, max(sk1$time)), h = mean(sk1$population.size), b = b.lin, sk1, ci)
{
    data.time <- c(0, time)

    leftside <- 0
    i <- 1
    h1 <- c(h, h[length(h)])
    pos1 <- c(pos, pos[length(pos)])
    while (i < length(time)) {
        left.pos <- sum(data.time[i + 1] >= pos)
        right.pos <- left.pos + 1
        h.mix <- (((data.time[i + 1] - pos[left.pos])/(pos[right.pos] - pos[left.pos]))*(h[right.pos] - h[left.pos])) + h[left.pos]
        leftside <- leftside + log(b[i]/h.mix)
        i <- i + 1
    }

    rightside <- 0
    time1 <- c(0, time)
    time.count <- 1

    ## heigths of jumps
    jumps <- sort(c(time1, pos))
    h.jumps <- jumps
    while (time.count <= length(jumps)) {
        left.pos <- sum(jumps[time.count] >= pos)
        right.pos <- left.pos + 1
        h.jumps[time.count] <- (((jumps[time.count] - pos[left.pos])/(pos[right.pos] - pos[left.pos]))*(h[right.pos] - h[left.pos])) + h[left.pos]
        if (is.na(h.jumps[time.count])) h.jumps[time.count] <- h[left.pos]
        time.count <- time.count + 1
    }

    ## Vector for lineages
    i <- 1
    lineages.jumps <- jumps
    while (i <= length(jumps)) {
        lineages.jumps[i] <- sum(jumps[i] >= time)
        if (lineages.jumps[i] == 0) lineages.jumps[i] <- 1
        i <- i + 1
    }
    lineage <- ci$lineages[lineages.jumps]
    b1 <- choose(lineage, 2)

    ## Integral
    a <- (h.jumps[-1] - h.jumps[-length(h.jumps)])/(jumps[-1] - jumps[-length(jumps)])
    c <- h.jumps[-1] - jumps[-1] * a
    area <- (1/a) * log(a*jumps[-1] + c) - (1/a)*log(a * jumps[-length(jumps)] + c)
    stepfunction <- (jumps[-1] - jumps[-length(jumps)])/h.jumps[-1]
    area[is.na(area)] <- stepfunction[is.na(area)]

    rightside <- sum(area * b1[-1])

    loglik <- leftside - rightside
    loglik
}

## ewLasso.R (2013-04-02)

##   Lasso Tree

## Copyright 2013 Andrei-Alin Popescu

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

ewLasso <- function(X, phy)
{
    if (is.matrix(X)) X <- as.dist(X)
    X[is.na(X)] <- -1
    X[X < 0] <- -1
    X[is.nan(X)] <- -1

    if (is.rooted(phy)) {
        phy <- unroot(phy)
        warning("'phy' is rooted: it was unrooted for this operation")
    }

    N <- attr(X, "Size")
    labels <- attr(X, "Labels")
    if (is.null(labels)) labels <- as.character(1:N)
    ans <- .C(C_ewLasso, as.double(X), as.integer(N),
              as.integer(phy$edge[, 1]), as.integer(phy$edge[, 2]),
              NAOK = TRUE)
}

## plot.popsize.R (2004-07-4) modified by EP (2019-01-29)

##   Plot population size in dependence of time

## Copyright 2004 Rainer Opgen-Rhein and Korbinian Strimmer

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

plot.popsize <-
    function(x, show.median = TRUE, show.years = FALSE,
             subst.rate, present.year, xlab = NULL,
             ylab = "Effective population size",
             log = "y", ...)
{
    ylim <- range(x[, 2:5], na.rm = TRUE)
    x1 <- x[, 1]
    if (show.years) {
        x1 <- -x1/subst.rate + present.year
        if (is.null(xlab)) xlab <- "Time (years)"
    } else {
        if (is.null(xlab))
            xlab <- "Time (past to present in units of substitutions)"
    }
    xlim <- range(x1, na.rm = TRUE)

    j <- if (show.median) 3 else 2

    plot(x1, x[, j], type = "s", xlim = xlim, ylim = ylim,
         xlab = xlab, ylab = ylab, log = log, lwd = 2.5, ...)

    lines(x1, x[, 4], ...)
    lines(x1, x[, 5], ...)
}

lines.popsize <- function(x, show.median = TRUE, show.years = FALSE,
                          subst.rate, present.year, ...)
{
    x1 <- x[, 1]
    if (show.years) x1 <- -x1/subst.rate + present.year
    j <- if (show.median) 3 else 2
    lines(x1, x[, j], lwd = 2.5, ...)
    lines(x1, x[, 4], ...)
    lines(x1, x[, 5], ...)
}

## ace.R (2018-06-25)

##   Ancestral Character Estimation

## Copyright 2005-2018 Emmanuel Paradis and Ben Bolker

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

.getSEs <- function(out)
{
    h <- out$hessian
    if (any(diag(h) == 0)) {
        warning("The likelihood gradient seems flat in at least one dimension (gradient null):\ncannot compute the standard-errors of the transition rates.\n")
        se <- rep(NaN, nrow(h))
    } else {
        se <- sqrt(diag(solve(h)))
    }
    se
}

ace <-
  function(x, phy, type = "continuous",
           method = if (type == "continuous") "REML" else "ML",
           CI = TRUE, model = if (type == "continuous") "BM" else "ER",
           scaled = TRUE, kappa = 1, corStruct = NULL, ip = 0.1,
           use.expm = FALSE, use.eigen = TRUE, marginal = FALSE)
{
    if (!inherits(phy, "phylo"))
        stop('object "phy" is not of class "phylo"')
    if (is.null(phy$edge.length))
        stop("tree has no branch lengths")
    type <- match.arg(type, c("continuous", "discrete"))
    nb.tip <- length(phy$tip.label)
    nb.node <- phy$Nnode
    if (nb.node != nb.tip - 1)
        stop('"phy" is not rooted AND fully dichotomous.')
    if (length(x) != nb.tip)
        stop("length of phenotypic and of phylogenetic data do not match.")
    if (!is.null(names(x))) {
        if(all(names(x) %in% phy$tip.label))
          x <- x[phy$tip.label]
        else warning("the names of 'x' and the tip labels of the tree do not match: the former were ignored in the analysis.")
    }
    obj <- list()
    if (kappa != 1) phy$edge.length <- phy$edge.length^kappa
    if (type == "continuous") {
        switch(method, "REML" = {
            minusLogLik <- function(sig2) {
                if (sig2 < 0) return(1e100)
                V <- sig2 * vcv(phy)
                ## next three lines borrowed from dmvnorm() in 'mvtnorm'
                distval <- mahalanobis(x, center = mu, cov = V)
                logdet <- sum(log(eigen(V, symmetric = TRUE, only.values = TRUE)$values))
                (nb.tip * log(2 * pi) + logdet + distval)/2
            }
            mu <- rep(ace(x, phy, method="pic")$ace[1], nb.tip)
            out <- nlm(minusLogLik, 1, hessian = TRUE)
            sigma2 <- out$estimate
            se_sgi2 <- sqrt(1/out$hessian)
            tip <- phy$edge[, 2] <= nb.tip
            minus.REML.BM <- function(p) {
                x1 <- p[phy$edge[, 1] - nb.tip]
                x2 <- numeric(length(x1))
                x2[tip] <- x[phy$edge[tip, 2]]
                x2[!tip] <- p[phy$edge[!tip, 2] - nb.tip]
                -(-sum((x1 - x2)^2/phy$edge.length)/(2 * sigma2) -
                  nb.node * log(sigma2))
            }
            out <- nlm(function(p) minus.REML.BM(p),
                       p = rep(mu[1], nb.node), hessian = TRUE)
            obj$resloglik <- -out$minimum
            obj$ace <- out$estimate
            names(obj$ace) <- nb.tip + 1:nb.node
            obj$sigma2 <- c(sigma2, se_sgi2)
            if (CI) {
                se <- .getSEs(out)
                tmp <- se * qt(0.025, nb.node)
                obj$CI95 <- cbind(obj$ace + tmp, obj$ace - tmp)
            }
        }, "pic" = {
            if (model != "BM")
                stop('the "pic" method can be used only with model = "BM".')
            ## See pic.R for some annotations.
            phy <- reorder(phy, "postorder")
            phenotype <- numeric(nb.tip + nb.node)
            phenotype[1:nb.tip] <- if (is.null(names(x))) x else x[phy$tip.label]
            contr <- var.con <- numeric(nb.node)
            ans <- .C(C_pic, as.integer(nb.tip),
                      as.integer(phy$edge[, 1]), as.integer(phy$edge[, 2]),
                      as.double(phy$edge.length), as.double(phenotype),
                      as.double(contr), as.double(var.con),
                      as.integer(CI), as.integer(scaled))
            obj$ace <- ans[[5]][-(1:nb.tip)]
            names(obj$ace) <- nb.tip + 1:nb.node
            if (CI) {
                se <- sqrt(ans[[7]])
                tmp <- se * qnorm(0.025)
                obj$CI95 <- cbind(obj$ace + tmp, obj$ace - tmp)
            }
        }, "ML" = {
            if (model == "BM") {
                tip <- phy$edge[, 2] <= nb.tip
                dev.BM <- function(p) {
                    if (p[1] < 0) return(1e100) # in case sigma^2 is negative
                    x1 <- p[-1][phy$edge[, 1] - nb.tip]
                    x2 <- numeric(length(x1))
                    x2[tip] <- x[phy$edge[tip, 2]]
                    x2[!tip] <- p[-1][phy$edge[!tip, 2] - nb.tip]
                    -2 * (-sum((x1 - x2)^2/phy$edge.length)/(2*p[1]) -
                          nb.node * log(p[1]))
                }
                out <- nlm(function(p) dev.BM(p),
                           p = c(1, rep(mean(x), nb.node)), hessian = TRUE)
                obj$loglik <- -out$minimum / 2
                obj$ace <- out$estimate[-1]
                names(obj$ace) <- (nb.tip + 1):(nb.tip + nb.node)
                se <- .getSEs(out)
                obj$sigma2 <- c(out$estimate[1], se[1])
                if (CI) {
                    tmp <- se[-1] * qt(0.025, nb.node)
                    obj$CI95 <- cbind(obj$ace + tmp, obj$ace - tmp)
                }
            }
        }, "GLS" = {
            if (is.null(corStruct))
                stop('you must give a correlation structure if method = "GLS".')
            if (class(corStruct)[1] == "corMartins")
                M <- corStruct[1] * dist.nodes(phy)
            if (class(corStruct)[1] == "corGrafen")
                phy <- compute.brlen(attr(corStruct, "tree"),
                                     method = "Grafen",
                                     power = exp(corStruct[1]))
            if (class(corStruct)[1] %in% c("corBrownian", "corGrafen")) {
                dis <- dist.nodes(attr(corStruct, "tree"))
                MRCA <- mrca(attr(corStruct, "tree"), full = TRUE)
                M <- dis[as.character(nb.tip + 1), MRCA]
                dim(M) <- rep(sqrt(length(M)), 2)
            }
            varAY <- M[-(1:nb.tip), 1:nb.tip]
            varA <- M[-(1:nb.tip), -(1:nb.tip)]
            V <- corMatrix(Initialize(corStruct, data.frame(x)),
                           corr = FALSE)
            invV <- solve(V)
            o <- gls(x ~ 1, data.frame(x), correlation = corStruct)
            GM <- o$coefficients
            obj$ace <- drop(varAY %*% invV %*% (x - GM) + GM)
            names(obj$ace) <- (nb.tip + 1):(nb.tip + nb.node)
            if (CI) {
                se <- sqrt((varA - varAY %*% invV %*% t(varAY))[cbind(1:nb.node, 1:nb.node)])
                tmp <- se * qnorm(0.025)
                obj$CI95 <- cbind(obj$ace + tmp, obj$ace - tmp)
            }
        })
    } else { # type == "discrete"
        if (method != "ML")
            stop("only ML estimation is possible for discrete characters.")
        if (any(phy$edge.length <= 0))
            stop("some branches have length zero or negative")
        if (!is.factor(x)) x <- factor(x)
        nl <- nlevels(x)
        lvls <- levels(x)
        x <- as.integer(x)
        if (is.character(model)) {
            rate <- matrix(NA, nl, nl)
            switch(model,
                   "ER" = np <- rate[] <- 1,
                   "ARD" = {
                       np <- nl*(nl - 1)
                       rate[col(rate) != row(rate)] <- 1:np
                   },
                   "SYM" = {
                       np <- nl * (nl - 1)/2
                       sel <- col(rate) < row(rate)
                       rate[sel] <- 1:np
                       rate <- t(rate)
                       rate[sel] <- 1:np
                   })
        } else {
            if (ncol(model) != nrow(model))
                stop("the matrix given as 'model' is not square")
            if (ncol(model) != nl)
                stop("the matrix 'model' must have as many rows as the number of categories in 'x'")
            rate <- model
            np <- max(rate)
        }
        index.matrix <- rate
        tmp <- cbind(1:nl, 1:nl)
        index.matrix[tmp] <- NA
        rate[tmp] <- 0
        rate[rate == 0] <- np + 1 # to avoid 0's since we will use this as numeric indexing

        liks <- matrix(0, nb.tip + nb.node, nl)
        TIPS <- 1:nb.tip
        liks[cbind(TIPS, x)] <- 1
        if (anyNA(x)) liks[which(is.na(x)), ] <- 1
        phy <- reorder(phy, "postorder")

        Q <- matrix(0, nl, nl)

        e1 <- phy$edge[, 1]
        e2 <- phy$edge[, 2]
        EL <- phy$edge.length

        if (use.eigen) {
            dev <- function(p, output.liks = FALSE) {
                if (any(is.nan(p)) || any(is.infinite(p))) return(1e+50)
                comp <- numeric(nb.tip + nb.node)
                Q[] <- c(p, 0)[rate]
                diag(Q) <- -rowSums(Q)
                decompo <- eigen(Q)
                lambda <- decompo$values
                GAMMA <- decompo$vectors
                invGAMMA <- solve(GAMMA)
                for (i in seq(from = 1, by = 2, length.out = nb.node)) {
                    j <- i + 1L
                    anc <- e1[i]
                    des1 <- e2[i]
                    des2 <- e2[j]
                    v.l <- GAMMA %*% diag(exp(lambda * EL[i])) %*% invGAMMA %*% liks[des1, ]
                    v.r <- GAMMA %*% diag(exp(lambda * EL[j])) %*% invGAMMA %*% liks[des2, ]
                    v <- v.l * v.r
                    comp[anc] <- sum(v)
                    liks[anc, ] <- v/comp[anc]
                }
                if (output.liks) return(liks[-TIPS, ])
                dev <- -2 * sum(log(comp[-TIPS]))
                if (is.na(dev)) Inf else dev
            }
        } else {
            if (!requireNamespace("expm", quietly = TRUE) && use.expm) {
                warning("package 'expm' not available; using function 'matexpo' from 'ape'")
                use.expm <- FALSE
            }
            E <- if (use.expm) expm::expm # to avoid Matrix::expm
                 else matexpo
            dev <- function(p, output.liks = FALSE) {
                if (any(is.nan(p)) || any(is.infinite(p))) return(1e50)
                comp <- numeric(nb.tip + nb.node) # from Rich FitzJohn
                Q[] <- c(p, 0)[rate]
                diag(Q) <- -rowSums(Q)
                for (i in seq(from = 1, by = 2, length.out = nb.node)) {
                    j <- i + 1L
                    anc <- e1[i]
                    des1 <- e2[i]
                    des2 <- e2[j]
                    v.l <- E(Q * EL[i]) %*% liks[des1, ]
                    v.r <- E(Q * EL[j]) %*% liks[des2, ]
                    v <- v.l * v.r
                    comp[anc] <- sum(v)
                    liks[anc, ] <- v/comp[anc]
                }
                if (output.liks) return(liks[-TIPS, ])
                dev <- -2 * sum(log(comp[-TIPS]))
                if (is.na(dev)) Inf else dev
            }
        }

        out <- nlminb(rep(ip, length.out = np), function(p) dev(p),
                      lower = rep(0, np), upper = rep(1e50, np))
        obj$loglik <- -out$objective/2
        obj$rates <- out$par
        oldwarn <- options("warn")
        options(warn = -1)
        out.nlm <- try(nlm(function(p) dev(p), p = obj$rates, iterlim = 1,
                           stepmax = 0, hessian = TRUE), silent = TRUE)
        options(oldwarn)
        obj$se <- if (class(out.nlm) == "try-error") {
            warning("model fit suspicious: gradients apparently non-finite")
            rep(NaN, np)
        } else .getSEs(out.nlm)
        obj$index.matrix <- index.matrix
        if (CI) {
            lik.anc <- dev(obj$rates, TRUE)
            if (!marginal) {
                Q[] <- c(obj$rates, 0)[rate]
                diag(Q) <- -rowSums(Q)
                for (i in seq(to = 1, by = -2, length.out = nb.node)) {
                    anc <- e1[i] - nb.tip
                    des1 <- e2[i] - nb.tip
                    if (des1 > 0) {
                        P <- matexpo(Q * EL[i])
                        tmp <- lik.anc[anc, ] / (lik.anc[des1, ] %*% P)
                        lik.anc[des1, ] <- (tmp %*% P) * lik.anc[des1, ]
                    }
                    j <- i + 1L
                    des2 <- e2[j] - nb.tip
                    if (des2 > 0) {
                        P <- matexpo(Q * EL[j])
                        tmp <- lik.anc[anc, ] / (lik.anc[des2, ] %*% P)
                        lik.anc[des2, ] <- (tmp %*% P) * lik.anc[des2, ]
                    }
                    lik.anc <- lik.anc / rowSums(lik.anc)
                }
            }
            colnames(lik.anc) <- lvls
            obj$lik.anc <- lik.anc
        }
    }
    obj$call <- match.call()
    class(obj) <- "ace"
    obj
}


logLik.ace <- function(object, ...) object$loglik

deviance.ace <- function(object, ...) -2*object$loglik

AIC.ace <- function(object, ..., k = 2)
{
    if (is.null(object$loglik)) return(NULL)
    ## Trivial test of "type"; may need to be improved
    ## if other models are included in ace(type = "c")
    np <- if (!is.null(object$sigma2)) 1 else length(object$rates)
    -2*object$loglik + np*k
}

### by BB:
anova.ace <- function(object, ...)
{
    X <- c(list(object), list(...))
    df <- lengths(lapply(X, "[[", "rates"))
    ll <- sapply(X, "[[", "loglik")
    ## check if models are in correct order
    dev <- c(NA, 2*diff(ll))
    ddf <- c(NA, diff(df))
    table <- data.frame(ll, df, ddf, dev,
                        pchisq(dev, ddf, lower.tail = FALSE))
    dimnames(table) <- list(1:length(X), c("Log lik.", "Df",
                                           "Df change", "Resid. Dev",
                                           "Pr(>|Chi|)"))
    structure(table, heading = "Likelihood Ratio Test Table",
              class = c("anova", "data.frame"))
}

print.ace <- function(x, digits = 4, ...)
{
    cat("\n    Ancestral Character Estimation\n\n")
    cat("Call: ")
    print(x$call)
    cat("\n")
    if (!is.null(x$loglik))
        cat("    Log-likelihood:", x$loglik, "\n\n")
    if (!is.null(x$resloglik))
        cat("    Residual log-likelihood:", x$resloglik, "\n\n")
    ratemat <- x$index.matrix
    if (is.null(ratemat)) { # to be improved
        class(x) <- NULL
        x$resloglik <- x$loglik <- x$call <- NULL
        print(x)
    } else {
        dimnames(ratemat)[1:2] <- dimnames(x$lik.anc)[2]
        cat("Rate index matrix:\n")
        print(ratemat, na.print = ".")
        cat("\n")
        npar <- length(x$rates)
        estim <- data.frame(1:npar, round(x$rates, digits), round(x$se, digits))
        cat("Parameter estimates:\n")
        names(estim) <- c("rate index", "estimate", "std-err")
        print(estim, row.names = FALSE)
        if (!is.null(x$lik.anc)) {
            cat("\nScaled likelihoods at the root (type '...$lik.anc' to get them for all nodes):\n")
            print(x$lik.anc[1, ])
        }
    }
}

## clustal.R (2018-03-28)

##   Multiple Sequence Alignment with External Applications

## Copyright 2011-2018 Emmanuel Paradis, 2018 Franz Krah

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

.errorAlignment <- function(exec, prog)
{
    dirs <- strsplit(Sys.getenv("PATH"), .Platform$path.sep)[[1]]
    paste0("\n   cannot find executable ", sQuote(exec), " on your computer.\n",
           "  It is recommended that you place the executable of ", prog, "\n",
           "  in a directory on the PATH of your computer which is:\n",
           paste(sort(dirs), collapse = "\n"))
}

clustalomega <- function (x, y, guide.tree, exec = NULL, MoreArgs = "",
                           quiet = TRUE, original.ordering = TRUE, file)
{
    os <- Sys.info()[1]
    if (is.null(exec)) {
        exec <- switch(os, Linux = "clustalo", Darwin = "clustalo",
                       Windows = "clustalo.exe")
    }
    if (missing(x)) {
        out <- system(paste(exec, "-h"))
        if (out == 127)
            stop(.errorAlignment(exec, "Clustal-Omega"))
        return(invisible(NULL))
    }
    type <- if (inherits(x, "DNAbin")) "DNA" else "AA"
    if (type == "AA" && !inherits(x, "AAbin"))
        stop("'x' should be of class \"DNAbin\" or \"AAbin\"")
    noy <- missing(y)

    fns <- character(4)
    for (i in 1:3)
        fns[i] <- tempfile(pattern = "clustal", tmpdir = tempdir(), fileext = ".fas")
    fns[4] <-  tempfile(pattern = "guidetree", tmpdir = tempdir(), fileext = ".nwk")
    unlink(fns[file.exists(fns)])

    x <- as.list(x)
    labels.bak <- names(x)
    names(x) <- paste0("Id", 1:length(x))
    write.FASTA(x, fns[1])

    if (noy) {
        opts <- paste("-i", fns[1], "-o", fns[3], "--force")

        ## add input guide tree
        if (!missing(guide.tree)) {
            if (!inherits(guide.tree, "phylo"))
                stop("object 'guide.tree' is not of class \"phylo\"")
            if (length(setdiff(labels.bak, guide.tree$tip.label)))
                stop("guide tree does not match sequence names")
            guide.tree$tip.label[match(guide.tree$tip.label, labels.bak)] <- names(x)
            if (!is.binary(guide.tree)) guide.tree <- multi2di(guide.tree)
            if (is.null(guide.tree$edge.length))
                guide.tree$edge.length <- rep(1, Nedge(guide.tree))
            write.tree(guide.tree, fns[4])
            opts <- paste(opts, paste("--guidetree-in", fns[4]))
        }
    } else {
        y <- as.list(y)
        labels.baky <- names(y)
        names(y) <- paste0("Id", length(x) + 1:length(y))
        write.FASTA(y, fns[2])
        if (length(y) == 1) {
            opts <- paste("-i", fns[1],"--profile1",
                          fns[2], "-o", fns[3], "--force")
        } else {
            opts <- paste("--profile1", fns[1],"--profile2",
                          fns[2], "-o", fns[3], "--force")
        }
    }

    opts <- paste(opts, MoreArgs)
    if (!quiet) opts <- paste(opts, "-v")
    out <- system(paste(exec, opts), ignore.stdout = quiet)
    if (out == 127)
        stop(.errorAlignment(exec, "Clustal-Omega"))
    res <- as.matrix(read.FASTA(fns[3], type))

    if (noy) {
        if (original.ordering)
            res <- res[labels(x), ]
        rownames(res) <- labels.bak
    } else {
        if (original.ordering)
            res <- res[c(labels(x), labels(y)), ]
        rownames(res) <- c(labels.bak, labels.baky)
    }

    unlink(fns[file.exists(fns)])
    if (missing(file)) return(res) else write.FASTA(res, file)
}

clustal <-
    function(x, y, guide.tree, pw.gapopen = 10, pw.gapext = 0.1, gapopen = 10,
             gapext = 0.2, exec = NULL, MoreArgs = "", quiet = TRUE,
             original.ordering = TRUE, file)
{
    os <- Sys.info()[1]
    if (is.null(exec)) {
        exec <- switch(os, Linux = "clustalw", Darwin = "clustalw2",
                       Windows = "clustalw2.exe")
    }
    if (missing(x)) {
        out <- system(paste(exec, "-help"))
        if (out == 127)
            stop(.errorAlignment(exec, "Clustal"))
        return(invisible(NULL))
    }
    type <- if (inherits(x, "DNAbin")) "DNA" else "AA"
    if (type == "AA" && !inherits(x, "AAbin"))
        stop("'x' should be of class \"DNAbin\" or \"AAbin\"")
    noy <- missing(y)

    fns <- character(4)
    for (i in 1:3)
        fns[i] <- tempfile(pattern = "clustal", tmpdir = tempdir(), fileext = ".fas")
    fns[4] <-  tempfile(pattern = "guidetree", tmpdir = tempdir(), fileext = ".nwk")
    unlink(fns[file.exists(fns)])

    x <- as.list(x)
    labels.bak <- names(x)
    names(x) <- paste0("Id", 1:length(x))
    write.FASTA(x, fns[1])

    if (noy) {
        prefix <- c("-INFILE", "-PWGAPOPEN", "-PWGAPEXT", "-GAPOPEN","-GAPEXT", "-OUTFILE","-OUTPUT")
        suffix <- c(fns[1], pw.gapopen, pw.gapext, gapopen, gapext, fns[3], "FASTA")

        ## add input guide tree
        if (!missing(guide.tree)) {
            if (!inherits(guide.tree, "phylo"))
                stop("object 'guide.tree' is not of class \"phylo\"")
            if (length(setdiff(labels.bak, guide.tree$tip.label)))
                stop("guide tree does not match sequence names")
            guide.tree$tip.label[match(guide.tree$tip.label, labels.bak)] <- names(x)
            if (!is.binary(guide.tree)) guide.tree <- multi2di(guide.tree)
            if (is.null(guide.tree$edge.length))
                guide.tree$edge.length <- rep(1, Nedge(guide.tree))
            write.tree(guide.tree, fns[4])
            prefix <- c(prefix, "-USETREE")
            suffix <- c(suffix, fns[4])
        }
    } else {
        y <- as.list(y)
        labels.baky <- names(y)
        names(y) <- paste0("Id", length(x) + 1:length(y))
        write.FASTA(y, fns[2])
        prefix <- c("-PROFILE1", "-PROFILE2", "-PWGAPOPEN", "-PWGAPEXT",
                    "-GAPOPEN","-GAPEXT", "-OUTFILE","-OUTPUT")
        suffix <- c(fns[1], fns[2], pw.gapopen, pw.gapext,
                    gapopen, gapext, fns[3], "FASTA")

    }

    opts <- paste(prefix, suffix, sep = "=", collapse = " ")
    opts <- paste(opts, MoreArgs)
    out <- system(paste(exec, opts), ignore.stdout = quiet)
    if (out == 127)
        stop(.errorAlignment(exec, "Clustal"))
    res <- as.matrix(read.FASTA(fns[3], type))

    if (noy) {
        if (original.ordering)
            res <- res[labels(x), ]
        rownames(res) <- labels.bak
    } else {
        if (original.ordering)
            res <- res[c(labels(x), labels(y)), ]
        rownames(res) <- c(labels.bak, labels.baky)
    }

    unlink(fns[file.exists(fns)])
    if (missing(file)) return(res) else write.FASTA(res, file)
}

muscle <- function (x, y, guide.tree, exec = "muscle", MoreArgs = "",
                     quiet = TRUE, original.ordering = TRUE, file)
{
    if (missing(x)) {
        out <- system(exec)
        if (out == 127) stop(.errorAlignment(exec, "MUSCLE"))
        return(invisible(NULL))
    }
    type <- if (inherits(x, "DNAbin")) "DNA" else "AA"
    if (type == "AA" && !inherits(x, "AAbin"))
        stop("'x' should be of class \"DNAbin\" or \"AAbin\"")
    noy <- missing(y)

    ## Produce TEMP files
    fns <- character(4)
    for (i in 1:3)
        fns[i] <- tempfile(pattern = "muscle", tmpdir = tempdir(), fileext = ".fas")
    fns[4] <- tempfile(pattern = "guidetree", tmpdir = tempdir(), fileext = ".nwk")
    unlink(fns[file.exists(fns)])

    ## Write input sequences x to file
    x <- as.list(x)
    labels.bak <- names(x)
    names(x) <- paste0("Id", 1:length(x))
    write.FASTA(x, fns[1])

    ## Run muscle for X
    if (noy) {
        opts <- paste("-in", fns[1], "-out", fns[3])
        ## add input guide tree
        if (!missing(guide.tree)) {
            if (!inherits(guide.tree, "phylo"))
                stop("object 'guide.tree' is not of class \"phylo\"")
            if (length(setdiff(labels.bak, guide.tree$tip.label)))
                stop("guide tree does not match sequence names")
            guide.tree$tip.label[match(guide.tree$tip.label, labels.bak)] <- names(x)
            if (!is.binary(guide.tree)) guide.tree <- multi2di(guide.tree)
            if (is.null(guide.tree$edge.length))
                guide.tree$edge.length <- rep(1, Nedge(guide.tree))
            write.tree(guide.tree, fns[4])
            opts <- paste(opts, paste("-usetree_nowarn", fns[4]))
        }
    } else {
        y <- as.list(y)
        labels.baky <- names(y)
        names(y) <- paste0("Id", length(x) + 1:length(y))
        write.FASTA(y, fns[2])
        opts <- paste("-profile", "-in1", fns[1],"-in2", fns[2], "-out", fns[3])
    }

    if (quiet) opts <- paste(opts, "-quiet")
    opts <- paste(opts, MoreArgs)
    out <- system(paste(exec, opts))
    if (out == 127)
        stop(.errorAlignment(exec, "MUSCLE"))
    res <- as.matrix(read.FASTA(fns[3], type))

    if (noy) {
        if (original.ordering)
            res <- res[labels(x), ]
        rownames(res) <- labels.bak
    } else {
        if (original.ordering)
            res <- res[c(labels(x), labels(y)), ]
        rownames(res) <- c(labels.bak, labels.baky)
    }

    unlink(fns[file.exists(fns)])
    if (missing(file)) return(res) else write.FASTA(res, file)
}

tcoffee <- function(x, exec = "t_coffee", MoreArgs = "", quiet = TRUE, original.ordering = TRUE)
{
    if (missing(x)) {
        out <- system(exec)
        if (out == 127) stop(.errorAlignment(exec, "T-Coffee"))
        return(invisible(NULL))
    }

    x <- as.list(x)
    labels.bak <- names(x)
    names(x) <- paste0("Id", 1:length(x))

    d <- tempdir()
    od <- setwd(d)
    on.exit(setwd(od))
    inf <- "input_tcoffee.fas"
    write.dna(x, inf, "fasta")
    opts <- paste(inf, MoreArgs)
    if (quiet) opts <- paste(opts, "-quiet=nothing")
    out <- system(paste(exec, opts))
    if (out == 127) stop(.errorAlignment(exec, "T-Coffee"))
    res <- read.dna("input_tcoffee.aln", "clustal")
    if (original.ordering) res <- res[labels(x), ]
    rownames(res) <- labels.bak
    res
}

## plot.phylo.R (2019-07-30)

##   Plot Phylogenies

## Copyright 2002-2019 Emmanuel Paradis

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

plot.phylo <-
    function(x, type = "phylogram", use.edge.length = TRUE,
             node.pos = NULL, show.tip.label = TRUE,
             show.node.label = FALSE, edge.color = "black",
             edge.width = 1, edge.lty = 1, font = 3, cex = par("cex"),
             adj = NULL, srt = 0, no.margin = FALSE, root.edge = FALSE,
             label.offset = 0, underscore = FALSE, x.lim = NULL,
             y.lim = NULL, direction = "rightwards", lab4ut = NULL,
             tip.color = "black", plot = TRUE, rotate.tree = 0,
             open.angle = 0, node.depth = 1, align.tip.label = FALSE, ...)
{
    Ntip <- length(x$tip.label)
    if (Ntip < 2) {
        warning("found less than 2 tips in the tree")
        return(NULL)
    }
#    if (any(tabulate(x$edge[, 1]) == 1))
#      stop("there are single (non-splitting) nodes in your tree; you may need to use collapse.singles()")

    .nodeHeight <- function(edge, Nedge, yy)
        .C(node_height, as.integer(edge[, 1]), as.integer(edge[, 2]),
           as.integer(Nedge), as.double(yy))[[4]]

    .nodeDepth <- function(Ntip, Nnode, edge, Nedge, node.depth)
        .C(node_depth, as.integer(Ntip),
           as.integer(edge[, 1]), as.integer(edge[, 2]),
           as.integer(Nedge), double(Ntip + Nnode), as.integer(node.depth))[[5]]

    .nodeDepthEdgelength <- function(Ntip, Nnode, edge, Nedge, edge.length)
        .C(node_depth_edgelength, as.integer(edge[, 1]),
           as.integer(edge[, 2]), as.integer(Nedge),
           as.double(edge.length), double(Ntip + Nnode))[[5]]

    Nedge <- dim(x$edge)[1]
    Nnode <- x$Nnode
    if (any(x$edge < 1) || any(x$edge > Ntip + Nnode))
        stop("tree badly conformed; cannot plot. Check the edge matrix.")
    ROOT <- Ntip + 1
    type <- match.arg(type, c("phylogram", "cladogram", "fan",
                              "unrooted", "radial"))
    direction <- match.arg(direction, c("rightwards", "leftwards",
                                        "upwards", "downwards"))
    if (is.null(x$edge.length)) {
        use.edge.length <- FALSE
    } else {
        if (use.edge.length && type != "radial") {
            tmp <- sum(is.na(x$edge.length))
            if (tmp) {
                warning(paste(tmp, "branch length(s) NA(s): branch lengths ignored in the plot"))
                use.edge.length <- FALSE
            }
        }
    }

    if (is.numeric(align.tip.label)) {
        align.tip.label.lty <- align.tip.label
        align.tip.label <- TRUE
    } else { # assumes is.logical(align.tip.labels) == TRUE
        if (align.tip.label) align.tip.label.lty <- 3
    }

    if (align.tip.label) {
        if (type %in% c("unrooted", "radial") || !use.edge.length || is.ultrametric(x))
            align.tip.label <- FALSE
    }

    ## the order of the last two conditions is important:
    if (type %in% c("unrooted", "radial") || !use.edge.length ||
        is.null(x$root.edge) || !x$root.edge) root.edge <- FALSE

    phyloORclado <- type %in% c("phylogram", "cladogram")
    horizontal <- direction %in% c("rightwards", "leftwards")
    xe <- x$edge # to save
    if (phyloORclado) {
        ## we first compute the y-coordinates of the tips.
        phyOrder <- attr(x, "order")
        ## make sure the tree is in cladewise order:
        if (is.null(phyOrder) || phyOrder != "cladewise") {
            x <- reorder(x) # fix from Klaus Schliep (2007-06-16)
            if (!identical(x$edge, xe)) {
                ## modified from Li-San Wang's fix (2007-01-23):
                ereorder <- match(x$edge[, 2], xe[, 2])
                if (length(edge.color) > 1) {
                    edge.color <- rep(edge.color, length.out = Nedge)
                    edge.color <- edge.color[ereorder]
                }
                if (length(edge.width) > 1) {
                    edge.width <- rep(edge.width, length.out = Nedge)
                    edge.width <- edge.width[ereorder]
                }
                if (length(edge.lty) > 1) {
                    edge.lty <- rep(edge.lty, length.out = Nedge)
                    edge.lty <- edge.lty[ereorder]
                }
            }
        }
### By contrats to ape (< 2.4), the arguments edge.color, etc., are
### not elongated before being passed to segments(), except if needed
### to be reordered
        yy <- numeric(Ntip + Nnode)
        TIPS <- x$edge[x$edge[, 2] <= Ntip, 2]
        yy[TIPS] <- 1:Ntip
    }
    ## 'z' is the tree in postorder order used in calls to .C
    z <- reorder(x, order = "postorder")

if (phyloORclado) {
        if (is.null(node.pos))
            node.pos <-
                if (type == "cladogram" && !use.edge.length) 2 else 1

        if (node.pos == 1)
            yy <- .nodeHeight(z$edge, Nedge, yy)
        else {
          ## node_height_clado requires the number of descendants
          ## for each node, so we compute `xx' at the same time
          ans <- .C(node_height_clado, as.integer(Ntip),
                    as.integer(z$edge[, 1]), as.integer(z$edge[, 2]),
                    as.integer(Nedge), double(Ntip + Nnode), as.double(yy))
          xx <- ans[[5]] - 1
          yy <- ans[[6]]
        }
        if (!use.edge.length) {
            if (node.pos != 2) xx <- .nodeDepth(Ntip, Nnode, z$edge, Nedge, node.depth) - 1
            xx <- max(xx) - xx
        } else  {
            xx <- .nodeDepthEdgelength(Ntip, Nnode, z$edge, Nedge, z$edge.length)
        }
} else {
    twopi <- 2 * pi
    rotate.tree <- twopi * rotate.tree/360

    if (type != "unrooted") { # for "fan" and "radial" trees (open.angle)
        ## if the tips are not in the same order in tip.label
        ## and in edge[, 2], we must reorder the angles: we
        ## use `xx' to store temporarily the angles
        TIPS <- x$edge[which(x$edge[, 2] <= Ntip), 2]
        xx <- seq(0, twopi * (1 - 1/Ntip) - twopi * open.angle/360,
                  length.out = Ntip)
        theta <- double(Ntip)
        theta[TIPS] <- xx
        theta <- c(theta, numeric(Nnode))
    }

    switch(type, "fan" = {
        theta <- .nodeHeight(z$edge, Nedge, theta)
        if (use.edge.length) {
            r <- .nodeDepthEdgelength(Ntip, Nnode, z$edge, Nedge, z$edge.length)
        } else {
            r <- .nodeDepth(Ntip, Nnode, z$edge, Nedge, node.depth)
            r <- 1/r
        }
        theta <- theta + rotate.tree
        if (root.edge) r <- r + x$root.edge
        xx <- r * cos(theta)
        yy <- r * sin(theta)
    }, "unrooted" = {
        nb.sp <- .nodeDepth(Ntip, Nnode, z$edge, Nedge, node.depth)
        XY <- if (use.edge.length)
            unrooted.xy(Ntip, Nnode, z$edge, z$edge.length, nb.sp, rotate.tree)
        else
            unrooted.xy(Ntip, Nnode, z$edge, rep(1, Nedge), nb.sp, rotate.tree)
        ## rescale so that we have only positive values
        xx <- XY$M[, 1] - min(XY$M[, 1])
        yy <- XY$M[, 2] - min(XY$M[, 2])
    }, "radial" = {
        r <- .nodeDepth(Ntip, Nnode, z$edge, Nedge, node.depth)
        r[r == 1] <- 0
        r <- 1 - r/Ntip
        theta <- .nodeHeight(z$edge, Nedge, theta) + rotate.tree
        xx <- r * cos(theta)
        yy <- r * sin(theta)
    })
}

    if (phyloORclado) {
        if (!horizontal) {
            tmp <- yy
            yy <- xx
            xx <- tmp - min(tmp) + 1
        }
        if (root.edge) {
            if (direction == "rightwards") xx <- xx + x$root.edge
            if (direction == "upwards") yy <- yy + x$root.edge
        }
    }

    if (no.margin) par(mai = rep(0, 4))

    if (show.tip.label) nchar.tip.label <- nchar(x$tip.label)
    max.yy <- max(yy)

    ## Function to compute the axis limit
    ## x: vector of coordinates, must be positive (or at least the largest value)
    ## lab: vector of labels, length(x) == length(lab)
    ## sin: size of the device in inches
    getLimit <- function(x, lab, sin, cex) {
        s <- strwidth(lab, "inches", cex = cex) # width of the tip labels
        ## if at least one string is larger than the device,
        ## give 1/3 of the plot for the tip labels:
        if (any(s > sin)) return(1.5 * max(x))
        Limit <- 0
        while (any(x > Limit)) {
            i <- which.max(x)
            ## 'alp' is the conversion coeff from inches to user coordinates:
            alp <- x[i]/(sin - s[i])
            Limit <- x[i] + alp*s[i]
            x <- x + alp*s
        }
        Limit
    }

    if (is.null(x.lim)) {
        if (phyloORclado) {
            if (horizontal) {
                ## 1.04 comes from that we are using a regular axis system
                ## with 4% on both sides of the range of x:
                ## REMOVED (2017-06-14)
                xx.tips <- xx[1:Ntip]# * 1.04
                if (show.tip.label) {
                    pin1 <- par("pin")[1] # width of the device in inches
                    tmp <- getLimit(xx.tips, x$tip.label, pin1, cex)
                    tmp <- tmp + label.offset
                } else tmp <- max(xx.tips)
                x.lim <- c(0, tmp)
            } else x.lim <- c(1, Ntip)
        } else switch(type, "fan" = {
            if (show.tip.label) {
                offset <- max(nchar.tip.label * 0.018 * max.yy * cex)
                x.lim <- range(xx) + c(-offset, offset)
            } else x.lim <- range(xx)
        }, "unrooted" = {
            if (show.tip.label) {
                offset <- max(nchar.tip.label * 0.018 * max.yy * cex)
                x.lim <- c(0 - offset, max(xx) + offset)
            } else x.lim <- c(0, max(xx))
        }, "radial" = {
            if (show.tip.label) {
                offset <- max(nchar.tip.label * 0.03 * cex)
                x.lim <- c(-1 - offset, 1 + offset)
            } else x.lim <- c(-1, 1)
        })
    } else if (length(x.lim) == 1) {
        x.lim <- c(0, x.lim)
        if (phyloORclado && !horizontal) x.lim[1] <- 1
        if (type %in% c("fan", "unrooted") && show.tip.label)
            x.lim[1] <- -max(nchar.tip.label * 0.018 * max.yy * cex)
        if (type == "radial")
            x.lim[1] <-
                if (show.tip.label) -1 - max(nchar.tip.label * 0.03 * cex)
                else -1
    }
    ## mirror the xx:
    if (phyloORclado && direction == "leftwards") xx <- x.lim[2] - xx
    if (is.null(y.lim)) {
        if (phyloORclado) {
            if (horizontal) y.lim <- c(1, Ntip) else {
                pin2 <- par("pin")[2] # height of the device in inches
                ## 1.04 comes from that we are using a regular axis system
                ## with 4% on both sides of the range of x:
                ## REMOVED (2017-06-14)
                yy.tips <- yy[1:Ntip]# * 1.04
                if (show.tip.label) {
                    tmp <- getLimit(yy.tips, x$tip.label, pin2, cex)
                    tmp <- tmp + label.offset
                } else tmp <- max(yy.tips)
                y.lim <- c(0, tmp)
            }
        } else switch(type, "fan" = {
            if (show.tip.label) {
                offset <- max(nchar.tip.label * 0.018 * max.yy * cex)
                y.lim <- c(min(yy) - offset, max.yy + offset)
            } else y.lim <- c(min(yy), max.yy)
        }, "unrooted" = {
            if (show.tip.label) {
                offset <- max(nchar.tip.label * 0.018 * max.yy * cex)
                y.lim <- c(0 - offset, max.yy + offset)
            } else y.lim <- c(0, max.yy)
        }, "radial" = {
            if (show.tip.label) {
                offset <- max(nchar.tip.label * 0.03 * cex)
                y.lim <- c(-1 - offset, 1 + offset)
            } else y.lim <- c(-1, 1)
        })
    } else if (length(y.lim) == 1) {
        y.lim <- c(0, y.lim)
        if (phyloORclado && horizontal) y.lim[1] <- 1
        if (type %in% c("fan", "unrooted") && show.tip.label)
            y.lim[1] <- -max(nchar.tip.label * 0.018 * max.yy * cex)
        if (type == "radial")
            y.lim[1] <- if (show.tip.label) -1 - max(nchar.tip.label * 0.018 * max.yy * cex) else -1
    }
    ## mirror the yy:
    if (phyloORclado && direction == "downwards") yy <- y.lim[2] - yy # fix by Klaus
    if (phyloORclado && root.edge) {
        if (direction == "leftwards") x.lim[2] <- x.lim[2] + x$root.edge
        if (direction == "downwards") y.lim[2] <- y.lim[2] + x$root.edge
    }
    asp <- if (type %in% c("fan", "radial", "unrooted")) 1 else NA # fixes by Klaus Schliep (2008-03-28 and 2010-08-12)
    plot.default(0, type = "n", xlim = x.lim, ylim = y.lim, xlab = "",
                 ylab = "", axes = FALSE, asp = asp, ...)

if (plot) {
    if (is.null(adj))
        adj <- if (phyloORclado && direction == "leftwards") 1 else 0
    if (phyloORclado && show.tip.label) {
        MAXSTRING <- max(strwidth(x$tip.label, cex = cex))
        loy <- 0
        if (direction == "rightwards") {
            lox <- label.offset + MAXSTRING * 1.05 * adj
        }
        if (direction == "leftwards") {
            lox <- -label.offset - MAXSTRING * 1.05 * (1 - adj)
            ##xx <- xx + MAXSTRING
        }
        if (!horizontal) {
            psr <- par("usr")
            MAXSTRING <- MAXSTRING * 1.09 * (psr[4] - psr[3])/(psr[2] - psr[1])
            loy <- label.offset + MAXSTRING * 1.05 * adj
            lox <- 0
            srt <- 90 + srt
            if (direction == "downwards") {
                loy <- -loy
                ##yy <- yy + MAXSTRING
                srt <- 180 + srt
            }
        }
    }
    if (type == "phylogram") {
        phylogram.plot(x$edge, Ntip, Nnode, xx, yy,
                       horizontal, edge.color, edge.width, edge.lty)
    } else {
        if (type == "fan") {
            ereorder <- match(z$edge[, 2], x$edge[, 2])
            if (length(edge.color) > 1) {
                edge.color <- rep(edge.color, length.out = Nedge)
                edge.color <- edge.color[ereorder]
            }
            if (length(edge.width) > 1) {
                edge.width <- rep(edge.width, length.out = Nedge)
                edge.width <- edge.width[ereorder]
            }
            if (length(edge.lty) > 1) {
                edge.lty <- rep(edge.lty, length.out = Nedge)
                edge.lty <- edge.lty[ereorder]
            }
            circular.plot(z$edge, Ntip, Nnode, xx, yy, theta,
                          r, edge.color, edge.width, edge.lty)
        } else
        cladogram.plot(x$edge, xx, yy, edge.color, edge.width, edge.lty)
    }
    if (root.edge) {
        rootcol <- if (length(edge.color) == 1) edge.color else "black"
        rootw <- if (length(edge.width) == 1) edge.width else 1
        rootlty <- if (length(edge.lty) == 1) edge.lty else 1
        if (type == "fan") {
            tmp <- polar2rect(x$root.edge, theta[ROOT])
            segments(0, 0, tmp$x, tmp$y, col = rootcol, lwd = rootw, lty = rootlty)
        } else {
            switch(direction,
                   "rightwards" = segments(0, yy[ROOT], x$root.edge, yy[ROOT],
                                           col = rootcol, lwd = rootw, lty = rootlty),
                   "leftwards" = segments(xx[ROOT], yy[ROOT], xx[ROOT] + x$root.edge, yy[ROOT],
                                          col = rootcol, lwd = rootw, lty = rootlty),
                   "upwards" = segments(xx[ROOT], 0, xx[ROOT], x$root.edge,
                                        col = rootcol, lwd = rootw, lty = rootlty),
                   "downwards" = segments(xx[ROOT], yy[ROOT], xx[ROOT], yy[ROOT] + x$root.edge,
                                          col = rootcol, lwd = rootw, lty = rootlty))
        }
    }
    if (show.tip.label) {
        if (is.expression(x$tip.label)) underscore <- TRUE
        if (!underscore) x$tip.label <- gsub("_", " ", x$tip.label)

        if (phyloORclado) {
            if (align.tip.label) {
                xx.tmp <- switch(direction,
                                 "rightwards" = max(xx[1:Ntip]),
                                 "leftwards" = min(xx[1:Ntip]),
                                 "upwards" = xx[1:Ntip],
                                 "downwards" = xx[1:Ntip])
                yy.tmp <- switch(direction,
                                 "rightwards" = yy[1:Ntip],
                                 "leftwards" = yy[1:Ntip],
                                 "upwards" = max(yy[1:Ntip]),
                                 "downwards" = min(yy[1:Ntip]))
                segments(xx[1:Ntip], yy[1:Ntip], xx.tmp, yy.tmp, lty = align.tip.label.lty)
            } else {
                xx.tmp <- xx[1:Ntip]
                yy.tmp <- yy[1:Ntip]
            }
            text(xx.tmp + lox, yy.tmp + loy, x$tip.label, adj = adj,
                 font = font, srt = srt, cex = cex, col = tip.color)
        } else {
            angle <- if (type == "unrooted") XY$axe else atan2(yy[1:Ntip], xx[1:Ntip]) # in radians

            lab4ut <-
                if (is.null(lab4ut)) {
                    if (type == "unrooted") "horizontal" else "axial"
                } else match.arg(lab4ut, c("horizontal", "axial"))

            xx.tips <- xx[1:Ntip]
            yy.tips <- yy[1:Ntip]
            if (label.offset) {
                xx.tips <- xx.tips + label.offset * cos(angle)
                yy.tips <- yy.tips + label.offset * sin(angle)
            }

            if (lab4ut == "horizontal") {
                y.adj <- x.adj <- numeric(Ntip)
                sel <- abs(angle) > 0.75 * pi
                x.adj[sel] <- -strwidth(x$tip.label)[sel] * 1.05
                sel <- abs(angle) > pi/4 & abs(angle) < 0.75 * pi
                x.adj[sel] <- -strwidth(x$tip.label)[sel] * (2 * abs(angle)[sel] / pi - 0.5)
                sel <- angle > pi / 4 & angle < 0.75 * pi
                y.adj[sel] <- strheight(x$tip.label)[sel] / 2
                sel <- angle < -pi / 4 & angle > -0.75 * pi
                y.adj[sel] <- -strheight(x$tip.label)[sel] * 0.75
                text(xx.tips + x.adj * cex, yy.tips + y.adj * cex,
                     x$tip.label, adj = c(adj, 0), font = font,
                     srt = srt, cex = cex, col = tip.color)
            } else { # if lab4ut == "axial"
                if (align.tip.label) {
                    POL <- rect2polar(xx.tips, yy.tips)
                    POL$r[] <- max(POL$r)
                    REC <- polar2rect(POL$r, POL$angle)
                    xx.tips <- REC$x
                    yy.tips <- REC$y
                    segments(xx[1:Ntip], yy[1:Ntip], xx.tips, yy.tips, lty = align.tip.label.lty)
                }
                if (type == "unrooted") {
                    adj <- abs(angle) > pi/2
                    angle <- angle * 180/pi # switch to degrees
                    angle[adj] <- angle[adj] - 180
                    adj <- as.numeric(adj)
                } else {
                    s <- xx.tips < 0
                    angle <- angle * 180/pi
                    angle[s] <- angle[s] + 180
                    adj <- as.numeric(s)
                }
                ## `srt' takes only a single value, so can't vectorize this:
                ## (and need to 'elongate' these vectors:)
                font <- rep(font, length.out = Ntip)
                tip.color <- rep(tip.color, length.out = Ntip)
                cex <- rep(cex, length.out = Ntip)
                for (i in 1:Ntip)
                    text(xx.tips[i], yy.tips[i], x$tip.label[i], font = font[i],
                         cex = cex[i], srt = angle[i], adj = adj[i],
                         col = tip.color[i])
            }
        }
    }
    if (show.node.label)
        text(xx[ROOT:length(xx)] + label.offset, yy[ROOT:length(yy)],
             x$node.label, adj = adj, font = font, srt = srt, cex = cex)
}
    L <- list(type = type, use.edge.length = use.edge.length,
              node.pos = node.pos, node.depth = node.depth,
              show.tip.label = show.tip.label,
              show.node.label = show.node.label, font = font,
              cex = cex, adj = adj, srt = srt, no.margin = no.margin,
              label.offset = label.offset, x.lim = x.lim, y.lim = y.lim,
              direction = direction, tip.color = tip.color,
              Ntip = Ntip, Nnode = Nnode, root.time = x$root.time,
              align.tip.label = align.tip.label)
    assign("last_plot.phylo", c(L, list(edge = xe, xx = xx, yy = yy)),
           envir = .PlotPhyloEnv)
    invisible(L)
}

phylogram.plot <- function(edge, Ntip, Nnode, xx, yy, horizontal,
                           edge.color, edge.width, edge.lty)
{
    nodes <- (Ntip + 1):(Ntip + Nnode)
    if (!horizontal) {
        tmp <- yy
        yy <- xx
        xx <- tmp
    }
    ## un trait vertical a chaque noeud...
    x0v <- xx[nodes]
    y0v <- y1v <- numeric(Nnode)

    ## store the index of each node in the 1st column of edge:
    NodeInEdge1 <- vector("list", Nnode)
    e1 <- edge[, 1]
    for (i in seq_along(e1)) {
        j <- e1[i] - Ntip
        NodeInEdge1[[j]] <- c(NodeInEdge1[[j]], i)
    }

    for (i in 1:Nnode) {
        j <- NodeInEdge1[[i]]
        tmp <- range(yy[edge[j, 2]])
        y0v[i] <- tmp[1]
        y1v[i] <- tmp[2]
    }
    ## ... et un trait horizontal partant de chaque tip et chaque noeud
    ##  vers la racine
    x0h <- xx[edge[, 1]]
    x1h <- xx[edge[, 2]]
    y0h <- yy[edge[, 2]]

    nc <- length(edge.color)
    nw <- length(edge.width)
    nl <- length(edge.lty)

    if (nc + nw + nl == 3) {
        color.v <- edge.color
        width.v <- edge.width
        lty.v <- edge.lty
    } else {
        Nedge <- dim(edge)[1]
        edge.color <- rep(edge.color, length.out = Nedge)
        edge.width <- rep(edge.width, length.out = Nedge)
        edge.lty <- rep(edge.lty, length.out = Nedge)
        DF <- data.frame(edge.color, edge.width, edge.lty, stringsAsFactors = FALSE)
        color.v <- rep("black", Nnode)
        width.v <- rep(1, Nnode)
        lty.v <- rep(1, Nnode)
        for (i in 1:Nnode) {
            br <- NodeInEdge1[[i]]
            if (length(br) == 1) {
                A <- br[1]
                color.v[i] <- edge.color[A]
                width.v[i] <- edge.width[A]
                lty.v[i] <- edge.lty[A]
            } else if (length(br) > 2) {
                x <- unique(DF[br, 1])
                if (length(x) == 1) color.v[i] <- x
                x <- unique(DF[br, 2])
                if (length(x) == 1) width.v[i] <- x
                x <- unique(DF[br, 3])
                if (length(x) == 1) lty.v[i] <- x
            } else { # length(br) == 2
                A <- br[1]
                B <- br[2]
                if (any(DF[A, ] != DF[B, ])) {
                    color.v[i] <- edge.color[B]
                    width.v[i] <- edge.width[B]
                    lty.v[i] <- edge.lty[B]
                    ## add a new line:
                    y0v <- c(y0v, y0v[i])
                    y1v <- c(y1v, yy[i + Ntip])
                    x0v <- c(x0v, x0v[i])
                    color.v <- c(color.v, edge.color[A])
                    width.v <- c(width.v, edge.width[A])
                    lty.v <- c(lty.v, edge.lty[A])
                    ## shorten the line:
                    y0v[i] <- yy[i + Ntip]
                } else {
                    color.v[i] <- edge.color[A]
                    width.v[i] <- edge.width[A]
                    lty.v[i] <- edge.lty[A]
                }
            }
        }
    }

    if (horizontal) {
        segments(x0h, y0h, x1h, y0h, col = edge.color, lwd = edge.width, lty = edge.lty) # draws horizontal lines
        segments(x0v, y0v, x0v, y1v, col = color.v, lwd = width.v, lty = lty.v) # draws vertical lines
    } else {
        segments(y0h, x0h, y0h, x1h, col = edge.color, lwd = edge.width, lty = edge.lty) # draws vertical lines
        segments(y0v, x0v, y1v, x0v, col = color.v, lwd = width.v, lty = lty.v) # draws horizontal lines
    }
}

cladogram.plot <- function(edge, xx, yy, edge.color, edge.width, edge.lty)
    segments(xx[edge[, 1]], yy[edge[, 1]], xx[edge[, 2]], yy[edge[, 2]],
             col = edge.color, lwd = edge.width, lty = edge.lty)

circular.plot <- function(edge, Ntip, Nnode, xx, yy, theta,
                          r, edge.color, edge.width, edge.lty)
### 'edge' must be in postorder order
{
    r0 <- r[edge[, 1]]
    r1 <- r[edge[, 2]]
    theta0 <- theta[edge[, 2]]
    costheta0 <- cos(theta0)
    sintheta0 <- sin(theta0)

    x0 <- r0 * costheta0
    y0 <- r0 * sintheta0
    x1 <- r1 * costheta0
    y1 <- r1 * sintheta0

    segments(x0, y0, x1, y1, col = edge.color, lwd = edge.width, lty = edge.lty)

    tmp <- which(diff(edge[, 1]) != 0)
    start <- c(1, tmp + 1)
    Nedge <- dim(edge)[1]
    end <- c(tmp, Nedge)

    ## function dispatching the features to the arcs
    foo <- function(edge.feat, default) {
        if (length(edge.feat) == 1) return(as.list(rep(edge.feat, Nnode)))
        edge.feat <- rep(edge.feat, length.out = Nedge)
        feat.arc <- as.list(rep(default, Nnode))
        for (k in 1:Nnode) {
            tmp <- edge.feat[start[k]]
            if (tmp == edge.feat[end[k]]) { # fix by Francois Michonneau (2015-07-24)
                feat.arc[[k]] <- tmp
            } else {
                if (nodedegree[k] == 2)
                    feat.arc[[k]] <- rep(c(tmp, edge.feat[end[k]]), each = 50)
            }
        }
        feat.arc
    }
    nodedegree <- tabulate(edge[, 1L])[-seq_len(Ntip)]
    co <- foo(edge.color, "black")
    lw <- foo(edge.width, 1)
    ly <- foo(edge.lty, 1)

    for (k in 1:Nnode) {
        i <- start[k]
        j <- end[k]
        X <- rep(r[edge[i, 1]], 100)
        Y <- seq(theta[edge[i, 2]], theta[edge[j, 2]], length.out = 100)
        x <- X * cos(Y); y <- X * sin(Y)
        x0 <- x[-100]; y0 <- y[-100]; x1 <- x[-1]; y1 <- y[-1]
        segments(x0, y0, x1, y1, col = co[[k]], lwd = lw[[k]], lty = ly[[k]])
    }
}

unrooted.xy <- function(Ntip, Nnode, edge, edge.length, nb.sp, rotate.tree)
{
    foo <- function(node, ANGLE, AXIS) {
        ind <- which(edge[, 1] == node)
        sons <- edge[ind, 2]
        start <- AXIS - ANGLE/2
        for (i in 1:length(sons)) {
            h <- edge.length[ind[i]]
            angle[sons[i]] <<- alpha <- ANGLE*nb.sp[sons[i]]/nb.sp[node]
            axis[sons[i]] <<- beta <- start + alpha/2
            start <- start + alpha
            xx[sons[i]] <<- h*cos(beta) + xx[node]
            yy[sons[i]] <<- h*sin(beta) + yy[node]
        }
        for (i in sons)
            if (i > Ntip) foo(i, angle[i], axis[i])
    }
    Nedge <- dim(edge)[1]
    yy <- xx <- numeric(Ntip + Nnode)
    ## `angle': the angle allocated to each node wrt their nb of tips
    ## `axis': the axis of each branch
    axis <- angle <- numeric(Ntip + Nnode)
    ## start with the root...
    foo(Ntip + 1L, 2*pi, 0 + rotate.tree)

    M <- cbind(xx, yy)
    axe <- axis[1:Ntip] # the axis of the terminal branches (for export)
    axeGTpi <- axe > pi
    ## make sure that the returned angles are in [-PI, +PI]:
    axe[axeGTpi] <- axe[axeGTpi] - 2*pi
    list(M = M, axe = axe)
}

node.depth <- function(phy, method = 1)
{
    n <- length(phy$tip.label)
    m <- phy$Nnode
    N <- dim(phy$edge)[1]
    phy <- reorder(phy, order = "postorder")
    .C(node_depth, as.integer(n),
       as.integer(phy$edge[, 1]), as.integer(phy$edge[, 2]),
       as.integer(N), double(n + m), as.integer(method))[[5]]
}

node.depth.edgelength <- function(phy)
{
    n <- length(phy$tip.label)
    m <- phy$Nnode
    N <- dim(phy$edge)[1]
    phy <- reorder(phy, order = "postorder")
    .C(node_depth_edgelength, as.integer(phy$edge[, 1]),
       as.integer(phy$edge[, 2]), as.integer(N),
       as.double(phy$edge.length), double(n + m))[[5]]
}

node.height <- function(phy, clado.style = FALSE)
{
    n <- length(phy$tip.label)
    m <- phy$Nnode
    N <- dim(phy$edge)[1]

    phy <- reorder(phy)
    yy <- numeric(n + m)
    e2 <- phy$edge[, 2]
    yy[e2[e2 <= n]] <- 1:n

    phy <- reorder(phy, order = "postorder")
    e1 <- phy$edge[, 1]
    e2 <- phy$edge[, 2]

    if (clado.style)
        .C(node_height_clado, as.integer(n), as.integer(e1),
           as.integer(e2), as.integer(N), double(n + m), as.double(yy))[[6]]
    else
        .C(node_height, as.integer(e1), as.integer(e2), as.integer(N),
           as.double(yy))[[4]]
}

plot.multiPhylo <- function(x, layout = 1, ...)
{
    layout(matrix(1:layout, ceiling(sqrt(layout)), byrow = TRUE))
    if (!devAskNewPage() && names(dev.cur()) %in% deviceIsInteractive()) {
        devAskNewPage(TRUE)
        on.exit(devAskNewPage(FALSE))
    }
    for (i in seq_along(x)) plot(x[[i]], ...)
}

trex <- function(phy, title = TRUE, subbg = "lightyellow3",
                 return.tree = FALSE, ...)
{
    lastPP <- get("last_plot.phylo", envir = .PlotPhyloEnv)
    devmain <- dev.cur() # where the main tree is plotted

    restore <- function() {
        dev.set(devmain)
        assign("last_plot.phylo", lastPP, envir = .PlotPhyloEnv)
    }

    on.exit(restore())
    NEW <- TRUE
    cat("Click close to a node. Right-click to exit.\n")
    repeat {
        x <- identify.phylo(phy, quiet = TRUE)
        if (is.null(x)) return(invisible(NULL)) else {
            x <- x$nodes
            if (is.null(x)) cat("Try again!\n") else {
                if (NEW) {
                    dev.new()
                    par(bg = subbg)
                    devsub <- dev.cur()
                    NEW <- FALSE
                } else dev.set(devsub)

                tr <- extract.clade(phy, x)
                plot(tr, ...)
                if (is.character(title)) title(title)
                else if (title) {
                     tl <-
                         if (is.null(phy$node.label))
                         paste("From node #", x, sep = "")
                         else paste("From", phy$node.label[x - Ntip(phy)])
                     title(tl)
                }
                if (return.tree) return(tr)
                restore()
            }
        }
    }
}

kronoviz <- function(x, layout = length(x), horiz = TRUE, ...)
{
    par(mar = rep(0.5, 4), oma = rep(2, 4))
    rts <- sapply(x, function(x) branching.times(x)[1])
    maxrts <- max(rts)
    lim <- cbind(rts - maxrts, rts)
    Ntree <- length(x)
    Ntips <- sapply(x, Ntip)
    if (horiz) {
        nrow <- layout
        w <- 1
        h <- Ntips
    } else {
        nrow <- 1
        w <- Ntips
        h <- 1
    }
    layout(matrix(1:layout, nrow), widths = w, heights = h)
    if (layout < Ntree && !devAskNewPage() && interactive()) {
        devAskNewPage(TRUE)
        on.exit(devAskNewPage(FALSE))
    }
    if (horiz) {
        for (i in 1:Ntree)
            plot(x[[i]], x.lim = lim[i, ], ...)
    } else {
        for (i in 1:Ntree)
            plot(x[[i]], y.lim = lim[i, ], direction = "u", ...)
    }
    axisPhylo(if (horiz) 1 else 4) # better if the deepest tree is last ;)
}

## dist.gene.R (2012-04-02)

##   Pairwise Distances from Genetic Data

## Copyright 2002-2012 Emmanuel Paradis

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

dist.gene <-
    function(x, method = "pairwise", pairwise.deletion = FALSE,
             variance = FALSE)
{
    if (is.data.frame(x)) x <- as.matrix(x) else { # suggestion by Markus Schlegel
        if (!is.matrix(x))
            stop("'x' should be a matrix or a data.frame")
    }
    method <- match.arg(method, c("pairwise", "percentage"))

    if (!pairwise.deletion) {
        ## delete the columns with at least one NA:
        del <- apply(x, 2, function(xx) any(is.na(xx)))
        x <- x[, !del]
    }
    n <- dim(x)
    L <- n[2]
    n <- n[1]
    D <- double(n * (n - 1)/2)
    if (pairwise.deletion) L <- D
    k <- 1L
    for (i in 1:(n - 1)) {
        for (j in (i + 1):n) {
            y <- x[i, ] != x[j, ]
            if (pairwise.deletion) L[k] <- sum(!is.na(y))
            D[k] <-  sum(y, na.rm = TRUE)
            k <- k + 1L
        }
    }
    ## L is either a single integer value if pairwise.deletion = FALSE,
    ## or a vector of integers if pairwise.deletion = TRUE

    if (method == "percentage") D <- D/L

    attr(D, "Size") <- n
    attr(D, "Labels") <-  dimnames(x)[[1]]
    attr(D, "Diag") <- attr(D, "Upper") <- FALSE
    attr(D, "call") <- match.call()
    attr(D, "method") <- method
    class(D) <- "dist"

    if (variance) {
        y <- if (method == "pairwise") L else 1
        attr(D, "variance") <- D * (y - D)/L
    }
    D
}

## nodepath.R (2014-11-06)

##   Find Paths of Nodes

## Copyright 2014 Emmanuel Paradis

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

nodepath <- function(phy, from = NULL, to = NULL)
{
    if (!inherits(phy, "phylo"))
        stop("object \"phy\" is not of class \"phylo\"")
    n <- length(phy$tip.label)
    m <- phy$Nnode
    root2tip <- .Call(seq_root2tip, phy$edge, n, m)
    if (is.null(from) || is.null(to)) return(root2tip)
    if (from < 1 || from > n + m) stop("'from' out of range")
    if (to < 1 || to > n + m) stop("'to' out of range")
    if (from == to) return(to)

    ## find the first occurrence of 'x' in the list root2tip
    foo <- function(x) {
        if (x <= n) return(x) # if x is a tip
        if (x == n + 1L) return(1L) # if x is the root
        i <- 1L
        repeat {
            if (any(root2tip[[i]] == x)) break
            i <- i + 1L
        }
        i
    }

    i <- foo(from)
    j <- foo(to)

    ## find path of nodes in a single vector 'seq' from root2tip
    findPath <- function(from, to, seq) {
        i <- which(seq == from)
        j <- which(seq == to)
        seq[i:j]
    }

    if (i == j) return(findPath(from, to, root2tip[[i]]))

    ## find the MRCA of 'from' and 'to'
    A <- root2tip[[i]]
    B <- root2tip[[j]]
    MRCA <- n + 1L # start from the root
    k <- 2L
    repeat {
        if (A[k] != B[k]) break
        MRCA <- A[k]
        k <- k + 1L
    }

    x <- findPath(MRCA, from, A)
    y <- findPath(MRCA, to, B)
    c(rev(x), y[-1])
}

## yule.R (2011-11-03)

##     Fits Yule Model to a Phylogenetic Tree

## yule: standard Yule model (constant birth rate)
## yule.cov: Yule model with covariates

## Copyright 2003-2011 Emmanuel Paradis

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

yule <- function(phy, use.root.edge = FALSE)
{
    if (!is.binary.phylo(phy))
        stop("tree must be dichotomous to fit the Yule model.")

    X <- sum(phy$edge.length)
    nb.node <- phy$Nnode

    if (!is.null(phy$root.edge) && use.root.edge) X <- X + phy$root.edge
    else nb.node <- nb.node - 1

    lambda <- nb.node/X
    se <- lambda/sqrt(nb.node)
    loglik <- -lambda * X + lfactorial(phy$Nnode) + nb.node * log(lambda)
    obj <- list(lambda = lambda, se = se, loglik = loglik)
    class(obj) <- "yule"
    obj
}

yule.cov <- function(phy, formula, data = NULL)
{
    if (is.null(data)) data <- parent.frame()
    n <- length(phy$tip.label)
    nb.node <- phy$Nnode
    if (!is.null(phy$node.label)) phy$node.label <- NULL
    bt <- sort(branching.times(phy)) # branching times (from present to past)
    bt <- rev(bt) # branching times from past to present
    ni <- cumsum(rev(table(bt))) + 1
    X <- model.matrix(formula, data)
    Xi <- X[phy$edge[, 1], , drop = FALSE]
    Xj <- X[phy$edge[, 2], , drop = FALSE]
    dev <- function(b) {
        2 * sum(((1/(1 + exp(-(Xi %*% b)))) +
                 (1/(1 + exp(-(Xj %*% b)))))
                * phy$edge.length/2) -
         2 * (sum(log(ni[-length(ni)])) +
              sum(log((1/(1 + exp(-(X[-(1:(n + 1)), , drop = FALSE] %*% b)))))))
    }
    out <- nlm(function(p) dev(p), p = c(rep(0, ncol(X) - 1), -1),
               hessian = TRUE)
    Dev <- out$minimum
    para <- matrix(NA, ncol(X), 2)
    para[, 1] <- out$estimate
    if (any(out$gradient == 0))
      warning("The likelihood gradient seems flat in at least one dimension (null gradient):\ncannot compute the standard-errors of the parameters.\n")
    else para[, 2] <- sqrt(diag(solve(out$hessian)))
    rownames(para) <- colnames(X)
    colnames(para) <- c("Estimate", "StdErr")
    ## fit the intercept-only model:
    X <- model.matrix(~ 1, data = data.frame(X))
    Xi <- X[phy$edge[, 1], , drop = FALSE]
    Xj <- X[phy$edge[, 2], , drop = FALSE]
    Dev.null <- nlm(function(p) dev(p), p = -1)$minimum
    cat("\n---- Yule Model with Covariates ----\n\n")
    cat("    Phylogenetic tree:", deparse(substitute(phy)), "\n")
    cat("       Number of tips:", n, "\n")
    cat("      Number of nodes:", nb.node, "\n")
    cat("             Deviance:", Dev, "\n")
    cat("       Log-likelihood:", -Dev/2, "\n\n")
    cat("  Parameter estimates:\n")
    print(para)
    cat("\n")
    cat("Null Deviance:", Dev.null, "\n")
    cat("  Test of the fitted model: ")
    chi <- Dev.null - Dev
    df <- nrow(para) - 1
    cat("chi^2 =", round(chi, 3), "  df =", df,
        "  P =", round(1 - pchisq(chi, df), 3), "\n")
}

## identify.phylo.R (2011-03-23)

##   Graphical Identification of Nodes and Tips

## Copyright 2008-2011 Emmanuel Paradis

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

identify.phylo <- function(x, nodes = TRUE, tips = FALSE,
                           labels = FALSE, quiet = FALSE, ...)
{
    if (!quiet)
        cat("Click close to a node of the tree...\n")
    xy <- locator(1)
    if (is.null(xy)) return(NULL)
    lastPP <- get("last_plot.phylo", envir = .PlotPhyloEnv)
    ## rescale the coordinates (especially if the x- and
    ## y-scales are very different):
    pin <- par("pin")
    rescaleX <- pin[1]/max(lastPP$xx)
    xx <- rescaleX * lastPP$xx
    rescaleY <- pin[2]/max(lastPP$yy)
    yy <- rescaleY * lastPP$yy
    xy$x <- rescaleX * xy$x
    xy$y <- rescaleY * xy$y
    ## end of rescaling
    d <- (xy$x - xx)^2 + (xy$y - yy)^2 # no need to sqrt()
    NODE <- which.min(d)
    res <- list()
    if (NODE <= lastPP$Ntip) {
        res$tips <- if (labels) x$tip.label[NODE] else NODE
        return(res)
    }
    if (tips) {
        TIPS <- prop.part(x)[[NODE - lastPP$Ntip]]
        res$tips <- if (labels) x$tip.label[TIPS] else TIPS
    }
    if (nodes) {
        if (is.null(x$node.label)) labels <- FALSE
        res$nodes <- if (labels) x$node.label[NODE - lastPP$Ntip] else NODE
    }
    res
}

# Generated by using Rcpp::compileAttributes() -> do not edit by hand
# Generator token: 10BE3573-1514-4C36-9D1C-5A225CD40393

bipartition2 <- function(orig, nTips) {
    .Call(`_ape_bipartition2`, orig, nTips)
}

prop_part2 <- function(trees, nTips) {
    .Call(`_ape_prop_part2`, trees, nTips)
}

reorderRcpp <- function(orig, nTips, root, order) {
    .Call(`_ape_reorderRcpp`, orig, nTips, root, order)
}

## DNA.R (2020-04-27)

##   Manipulations and Comparisons of DNA and AA Sequences

## Copyright 2002-2020 Emmanuel Paradis, 2015 Klaus Schliep, 2017 Franz Krah

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

DNAbin2indel <- function(x)
{
    if (is.list(x)) x <- as.matrix(x)
    d <- dim(x)
    s <- as.integer(d[2])
    n <- as.integer(d[1])
    if (s * n > 2^31 - 1)
        stop("DNAbin2indel() cannot handle more than 2^31 - 1 bases")
    res <- .C(DNAbin2indelblock, x, n, s, integer(n*s), NAOK = TRUE)[[4]]
    dim(res) <- d
    rownames(res) <- rownames(x)
    res
}

labels.DNAbin <- function(object, ...)
{
    if (is.list(object)) return(names(object))
    if (is.matrix(object)) return(rownames(object))
    NULL
}

del.gaps <- function(x)
{
    deleteGaps <- function(x) {
        i <- which(x == 4)
        if (length(i)) x[-i] else x
    }

    if (!inherits(x, "DNAbin")) x <- as.DNAbin(x)
    if (is.matrix(x)) {
        n <- dim(x)[1]
        y <- vector("list", n)
        for (i in 1:n) y[[i]] <- x[i, ]
        names(y) <- rownames(x)
        x <- y
        rm(y)
    }
    if (!is.list(x)) return(deleteGaps(x))
    x <- lapply(x, deleteGaps)
    class(x) <- "DNAbin"
    x
}

del.rowgapsonly <- function(x, threshold = 1, freq.only = FALSE)
{
    if (!inherits(x, "DNAbin")) x <- as.DNAbin(x)
    if (!is.matrix(x)) stop("DNA sequences not in a matrix")
    foo <- function(x) sum(x == 4)
    g <- apply(x, 1, foo)
    if (freq.only) return(g)
    i <- which(g / ncol(x) >= threshold)
    if (length(i)) x <- x[-i, ]
    x
}

del.colgapsonly <- function(x, threshold = 1, freq.only = FALSE)
{
    if (!inherits(x, "DNAbin")) x <- as.DNAbin(x)
    if (!is.matrix(x)) stop("DNA sequences not in a matrix")
    foo <- function(x) sum(x == 4)
    g <- apply(x, 2, foo)
    if (freq.only) return(g)
    i <- which(g / nrow(x) >= threshold)
    if (length(i)) x <- x[, -i]
    x
}

as.alignment <- function(x)
{
    if (is.list(x)) n <- length(x)
    if (is.matrix(x)) n <- dim(x)[1]
    seq <- character(n)
    if (is.list(x)) {
        nam <- names(x)
        for (i in 1:n)
          seq[i] <- paste(x[[i]], collapse = "")
    }
    if (is.matrix(x)) {
        nam <- dimnames(x)[[1]]
        for (i in 1:n)
          seq[i] <- paste(x[i, ], collapse = "")
    }
    obj <- list(nb = n, seq = seq, nam = nam, com = NA)
    class(obj) <- "alignment"
    obj
}

"[.DNAbin" <- function(x, i, j, drop = FALSE)
{
    ans <- NextMethod("[", drop = drop)
    class(ans) <- "DNAbin"
    ans
}

as.matrix.DNAbin <- function(x, ...)
{
    if (is.matrix(x)) return(x)
    if (!is.list(x)) { # vector
        dim(x) <- c(1, length(x))
        return(x)
    }
    s <- unique(lengths(x, use.names = FALSE))
    if (length(s) != 1)
        stop("DNA sequences in list not of the same length.")
    n <- length(x)
    y <- matrix(raw(), n, s)
    for (i in seq_len(n)) y[i, ] <- x[[i]]
    rownames(y) <- names(x)
    class(y) <- "DNAbin"
    y
}

as.list.DNAbin <- function(x, ...)
{
    if (is.list(x)) return(x)
    if (is.null(dim(x))) obj <- list(x) # cause is.vector() doesn't work
    else { # matrix
        class(x) <- NULL
        n <- nrow(x)
        obj <- vector("list", n)
        for (i in seq_len(n)) obj[[i]] <- x[i, , drop = TRUE]
        names(obj) <- rownames(x)
    }
    class(obj) <- "DNAbin"
    obj
}

rbind.DNAbin <- function(...)
{
    obj <- list(...)
    n <- length(obj)
    if (n == 1) return(obj[[1]])
    for (i in 1:n)
        if (!is.matrix(obj[[1]]))
            stop("the 'rbind' method for \"DNAbin\" accepts only matrices")
    NC <- unlist(lapply(obj, ncol))
    if (length(unique(NC)) > 1)
        stop("matrices do not have the same number of columns.")
    for (i in 1:n) class(obj[[i]]) <- NULL # safe but maybe not really needed
    structure(do.call(rbind, obj), class = "DNAbin")
}

cbind.DNAbin <-
    function(..., check.names = TRUE, fill.with.gaps = FALSE,
             quiet = FALSE)
{
    obj <- list(...)
    n <- length(obj)
    if (n == 1) return(obj[[1]])
    for (i in 1:n)
        if (!is.matrix(obj[[1]]))
            stop("the 'cbind' method for \"DNAbin\" accepts only matrices")
    NR <- unlist(lapply(obj, nrow))
    for (i in 1:n) class(obj[[i]]) <- NULL
    if (check.names) {
        NMS <- lapply(obj, rownames)
        for (i in 1:n)
            if (anyDuplicated(NMS[[i]]))
                stop("Duplicated rownames in matrix ", i, ": see ?cbind.DNAbin")
        nms <- unlist(NMS)
        if (fill.with.gaps) {
            NC <- unlist(lapply(obj, ncol))
            nms <- unique(nms)
            ans <- matrix(as.raw(4), length(nms), sum(NC))
            rownames(ans) <- nms
            from <- 1
            for (i in 1:n) {
                to <- from + NC[i] - 1
                k <- match(NMS[[i]], nms)
                ans[k, from:to] <- obj[[i]]
                from <- to + 1
            }
        } else {
            tab <- table(nms)
            ubi <- tab == n
            nms <- names(tab)[which(ubi)]
            ans <- obj[[1]][nms, , drop = FALSE]
            for (i in 2:n)
                ans <- cbind(ans, obj[[i]][nms, , drop = FALSE])
            if (!quiet && !all(ubi))
                warning("some rows were dropped.")
        }
    } else {
        if (length(unique(NR)) > 1)
            stop("matrices do not have the same number of rows.")
        ans <- matrix(unlist(obj), NR)
        rownames(ans) <- rownames(obj[[1]])
    }
    class(ans) <- "DNAbin"
    ans
}

c.DNAbin <- function(..., recursive = FALSE)
{
    if (!all(unlist(lapply(list(...), is.list))))
        stop("the 'c' method for \"DNAbin\" accepts only lists")
    structure(NextMethod("c"), class = "DNAbin")
}

print.DNAbin <- function(x, printlen = 6, digits = 3, ...)
{
    if (is.list(x)) {
        n <- length(x)
        nms <- names(x)
        if (n == 1) {
            cat("1 DNA sequence in binary format stored in a list.\n\n")
            nTot <- length(x[[1]])
            cat("Sequence length:", nTot, "\n")
        } else {
            cat(n, "DNA sequences in binary format stored in a list.\n\n")
            tmp <- lengths(x, use.names = FALSE)
            nTot <- sum(as.numeric(tmp))
            mini <- min(tmp)
            maxi <- max(tmp)
            if (mini == maxi)
                cat("All sequences of same length:", maxi, "\n")
            else {
                cat("Mean sequence length:", round(mean(tmp), 3), "\n")
                cat("   Shortest sequence:", mini, "\n")
                cat("    Longest sequence:", maxi, "\n")
            }
        }
    } else {
        nTot <- length(x)
        if (is.matrix(x)) {
            nd <- dim(x)
            n <- nd[1]
            nms <- rownames(x)
            if (n == 1) {
                cat("1 DNA sequence in binary format stored in a matrix.\n\n")
                cat("Sequence length:", nd[2], "\n")
            } else {
                cat(n, "DNA sequences in binary format stored in a matrix.\n\n")
                cat("All sequences of same length:", nd[2], "\n")
            }
        } else {
            cat("1 DNA sequence in binary format stored in a vector.\n\n")
            cat("Sequence length:", nTot, "\n\n")
        }
    }
    if (exists("nms")) {
        HEAD <- if (n == 1) "\nLabel:" else "\nLabels:"
        TAIL <- ""
        if (printlen < n) {
            nms <- nms[1:printlen]
            TAIL <- "...\n"
        }
        if (any(longs <- nchar(nms) > 60))
            nms[longs] <- paste0(substr(nms[longs], 1, 60), "...")
        cat(HEAD, nms, TAIL, sep = "\n")
    }
    if (nTot <= 1e7) {
        cat("Base composition:\n")
        print(round(base.freq(x), digits))
    } else {
        cat("More than 10 million bases: not printing base composition.\n")
    }
    if (nTot > 1) {
        k <- floor(log(nTot, 1000))
        units <- c("bases", "kb", "Mb", "Gb", "Tb", "Pb", "Eb")
        cat("(Total: ", round(nTot/1000^k, 2), " ", units[k + 1], ")\n", sep = "")
    }
}

as.DNAbin <- function(x, ...) UseMethod("as.DNAbin")

._cs_ <- c("a", "g", "c", "t", "r", "m", "w", "s", "k",
           "y", "v", "h", "d", "b", "n", "-", "?")

._bs_ <- c(136, 72, 40, 24, 192, 160, 144, 96, 80,
           48, 224, 176, 208, 112, 240, 4, 2)

## by Klaus:
as.DNAbin.character <- function(x, ...)
{
    ans <- as.raw(._bs_)[match(tolower(x), ._cs_)]
    if (is.matrix(x)) {
        dim(ans) <- dim(x)
        dimnames(ans) <- dimnames(x)
    }
    class(ans) <- "DNAbin"
    ans
}

as.DNAbin.alignment <- function(x, ...)
{
    n <- x$nb
    x$seq <- tolower(x$seq)
    ans <- matrix("", n, nchar(x$seq[1]))
    for (i in 1:n)
        ans[i, ] <- strsplit(x$seq[i], "")[[1]]
    rownames(ans) <- gsub(" +$", "", gsub("^ +", "", x$nam))
    as.DNAbin.character(ans)
}

as.DNAbin.list <- function(x, ...)
{
    obj <- lapply(x, as.DNAbin)
    class(obj) <- "DNAbin"
    obj
}

as.character.DNAbin <- function(x, ...)
{
    f <- function(xx) {
        ans <- ._cs_[match(as.numeric(xx), ._bs_)]
        if (is.matrix(xx)) {
            dim(ans) <- dim(xx)
            dimnames(ans) <- dimnames(xx)
        }
        ans
    }
    if (is.list(x)) lapply(x, f) else f(x)
}

base.freq <- function(x, freq = FALSE, all = FALSE)
{
    if (!inherits(x, "DNAbin"))
        stop('base.freq requires an object of class "DNAbin"')

    f <- function(x) .Call(BaseProportion, x)

    if (is.list(x)) {
        BF <- rowSums(sapply(x, f))
        n <- sum(as.double(lengths(x, use.names = FALSE)))
    } else {
        n <- length(x)
        BF <- f(x)
    }

    names(BF) <- c("a", "c", "g", "t", "r", "m", "w", "s",
                   "k", "y", "v", "h", "d", "b", "n", "-", "?")
    if (all) {
        if (!freq) BF <- BF / n
    } else {
        BF <- BF[1:4]
        if (!freq) BF <- BF / sum(BF)
    }
    BF
}

Ftab <- function(x, y = NULL)
{
    if (is.null(y)) {
        if (is.list(x)) {
            y <- x[[2]]
            x <- x[[1]]
            if (length(x) != length(y))
                stop("'x' and 'y' not of the same length")
        } else { # 'x' is a matrix
            y <- x[2, , drop = TRUE]
            x <- x[1, , drop = TRUE]
        }
    } else {
        x <- as.vector(x)
        y <- as.vector(y)
        if (length(x) != length(y))
            stop("'x' and 'y' not of the same length")
    }
    out <- matrix(0, 4, 4)
    k <- c(136, 40, 72, 24)
    for (i in 1:4) {
        a <- x == k[i]
        for (j in 1:4) {
            b <- y == k[j]
            out[i, j] <- sum(a & b)
        }
    }
    dimnames(out)[1:2] <- list(c("a", "c", "g", "t"))
    out
}

GC.content <- function(x) sum(base.freq(x)[2:3])

seg.sites <- function(x, strict = FALSE, trailingGapsAsN = TRUE)
{
    if (is.list(x)) x <- as.matrix(x)
    ## is.vector() returns FALSE because of the class,
    ## so we use a different test
    dx <- dim(x)
    if (is.null(dx)) return(integer())
    if (dx[1] == 1) return(integer())
    if (trailingGapsAsN) x <- latag2n(x)
    ans <- .Call(SegSites, x, strict)
    which(as.logical(ans))
}

dist.dna <- function(x, model = "K80", variance = FALSE, gamma = FALSE,
                     pairwise.deletion = FALSE, base.freq = NULL,
                     as.matrix = FALSE)
{
    MODELS <- c("RAW", "JC69", "K80", "F81", "K81", "F84", "T92", "TN93",
                "GG95", "LOGDET", "BH87", "PARALIN", "N", "TS", "TV",
                "INDEL", "INDELBLOCK")
    imod <- pmatch(toupper(model), MODELS)
    if (is.na(imod))
        stop(paste("'model' must be one of:",
                   paste("\"", MODELS, "\"", sep = "", collapse = " ")))
    if (imod == 11 && variance) {
        warning("computing variance not available for model BH87")
        variance <- FALSE
    }
    if (gamma && imod %in% c(1, 5:7, 9:17)) {
        warning(paste("gamma-correction not available for model", model))
        gamma <- FALSE
    }
    if (is.list(x)) x <- as.matrix(x)
    nms <- dimnames(x)[[1]]
    n <- dim(x)
    s <- n[2]
    n <- n[1]

    if (s * n > 2^31 - 1)
        stop("dist.dna() cannot handle more than 2^31 - 1 bases")

    if (imod %in% c(4, 6:8)) {
        BF <- if (is.null(base.freq)) base.freq(x) else base.freq
    } else BF <- 0

    if (imod %in% 16:17) pairwise.deletion <- TRUE

    if (!pairwise.deletion) {
        keep <- .C(GlobalDeletionDNA, x, n, s, rep(1L, s))[[4]]
        x <- x[, as.logical(keep)]
        s <- dim(x)[2]
    }
    Ndist <- if (imod == 11) n*n else n*(n - 1)/2
    var <- if (variance) double(Ndist) else 0
    if (!gamma) gamma <- alpha <- 0
    else {
        alpha <- gamma
        gamma <- 1
    }
    d <- .C(dist_dna, x, as.integer(n), as.integer(s), imod,
            double(Ndist), BF, as.integer(pairwise.deletion),
            as.integer(variance), var, as.integer(gamma),
            as.double(alpha), NAOK = TRUE)
    if (variance) var <- d[[9]]
    d <- d[[5]]
    if (imod == 11) {
        dim(d) <- c(n, n)
        dimnames(d) <- list(nms, nms)
    } else {
        attr(d, "Size") <- n
        attr(d, "Labels") <- nms
        attr(d, "Diag") <- attr(d, "Upper") <- FALSE
        attr(d, "call") <- match.call()
        attr(d, "method") <- model
        class(d) <- "dist"
        if (as.matrix) d <- as.matrix(d)
    }
    if (variance) attr(d, "variance") <- var
    d
}

image.DNAbin <-
    function(x, what, col, bg = "white", xlab = "", ylab = "",
             show.labels = TRUE, cex.lab = 1, legend = TRUE,
             grid = FALSE, show.bases = FALSE, base.cex = 1,
             base.font = 1, base.col = "black", ...)
{
    what <-
        if (missing(what)) c("a", "g", "c", "t", "n", "-") else tolower(what)
    if (missing(col))
        col <- c("red", "yellow", "green", "blue", "grey", "black")
    x <- as.matrix(x) # tests if all sequences have the same length
    n <- (dx <- dim(x))[1] # number of sequences
    s <- dx[2] # number of sites
    y <- integer(N <- length(x))
    ncl <- length(what)
    col <- rep(col, length.out = ncl)
    brks <- 0.5:(ncl + 0.5)
    sm <- 0L
    for (i in ncl:1) {
        k <- ._bs_[._cs_ == what[i]]
        sel <- which(x == k)
        if (L <- length(sel)) {
            y[sel] <- i
            sm <- sm + L
        } else {
            what <- what[-i]
            col <- col[-i]
            brks <- brks[-i]
        }
    }
    dim(y) <- dx
    ## if there's no 0 in y, must drop 'bg' from the cols passed to image:
    if (sm == N) {
        leg.co <- co <- col
        leg.txt <- toupper(what)
    } else {
        co <- c(bg, col)
        leg.txt <- c(toupper(what), "others")
        leg.co <- c(col, bg)
        brks <- c(-0.5, brks)
    }
    yaxt <- if (show.labels) "n" else "s"
    image.default(1:s, 1:n, t(y[n:1, , drop = FALSE]), col = co, xlab = xlab,
                  ylab = ylab, yaxt = yaxt, breaks = brks, ...)
    if (show.labels)
        mtext(rownames(x), side = 2, line = 0.1, at = n:1,
              cex = cex.lab, adj = 1, las = 1)
    if (legend) {
        psr <- par("usr")
        xx <- psr[2]/2
        yy <- psr[4] * (0.5 + 0.5/par("plt")[4])
        legend(xx, yy, legend = leg.txt, pch = 22, pt.bg = leg.co,
               pt.cex = 2, bty = "n", xjust = 0.5, yjust = 0.5,
               horiz = TRUE, xpd = TRUE)
    }
    if (grid) {
        if (is.logical(grid)) grid <- 3L
        if (grid %in% 2:3) abline(v = seq(1.5, s - 0.5, 1), lwd = 0.33, xpd = FALSE)
        if (grid %in% c(1, 3)) abline(h = seq(1.5, n - 0.5, 1), lwd = 0.33, xpd = FALSE)
    }
    if (show.bases) {
        x <- toupper(as.character(x))
        xx <- rep(1:s, each = n)
        yy <- rep(n:1, s)
        text(xx, yy, x, cex = base.cex, font = base.font, col = base.col)
    }
}

alview <- function(x, file = "", uppercase = TRUE, showpos = TRUE)
{
    if (is.list(x)) x <- as.matrix(x)
    taxa <- formatC(labels(x), width = -1)
    x <- as.character(x)
    s <- ncol(x)
    if (nrow(x) > 1) {
        for (j in seq_len(s)) {
            q <- which(x[-1L, j] == x[1L, j]) + 1L
            x[q, j] <- "."
        }
    }
    x <- apply(x, 1L, paste, collapse = "")
    if (uppercase) x <- toupper(x)
    res <- paste(taxa, x)
    if ((is.logical(showpos) && showpos) || is.numeric(showpos)) {
        if (is.logical(showpos)) {
            pos <- 1:s
            digits <- floor(log10(s)) + 1
        } else {
            pos <- showpos
            digits <- floor(log10(max(pos))) + 1
        }
        hdr <- sprintf(paste0("%0", digits, "d"), pos)
        hdr <- unlist(strsplit(hdr, ""))
        dim(hdr) <- c(digits, length(pos))
        hdr <- apply(hdr, 1, paste, collapse = "")
        hdr <- formatC(hdr, width = nchar(res[1]))
        cat(hdr, file = file, sep = "\n")
    }
    cat(res, file = file, sep = "\n", append = TRUE)
}

where <- function(x, pattern)
{
    pat <- as.DNAbin(strsplit(pattern, NULL)[[1]])
    p <- length(pat)

    f <- function(x, pat, p) {
        s <- length(x)
        if (s < p) stop("sequence shorter than the pattern")
        .Call(C_where, x, pat)
    }

    if (is.list(x)) return(lapply(x, f, pat = pat, p = p))
    if (is.matrix(x)) {
        n <- nrow(x)
        res <- vector("list", n)
        for (i in seq_len(n))
            res[[i]] <- f(x[i, , drop = TRUE], pat, p)
        names(res) <- rownames(x)
        return(res)
    }
    f(x, pat, p) # if x is a vector
}

## conversions from BioConductor:

## DNA:
.DNAString2DNAbin <- function(from)
    .Call("charVectorToDNAbinVector", as.character(from))

as.DNAbin.DNAString <- function(x, ...)
{
    res <- list(.DNAString2DNAbin(x))
    class(res) <- "DNAbin"
    res
}

as.DNAbin.DNAStringSet <- function(x, ...)
{
    res <- lapply(x, .DNAString2DNAbin)
    class(res) <- "DNAbin"
    res
}

as.DNAbin.DNAMultipleAlignment <- function(x, ...)
    as.matrix(as.DNAbin.DNAStringSet(as(x, "DNAStringSet")))

as.DNAbin.PairwiseAlignmentsSingleSubject <- function(x, ...)
    as.DNAbin.DNAMultipleAlignment(x)

## AA:
.AAString2AAbin <- function(from)
    charToRaw(as.character(from))

as.AAbin.AAString <- function(x, ...)
{
    res <- list(.AAString2AAbin(x))
    class(res) <- "AAbin"
    res
}

as.AAbin.AAStringSet <- function(x, ...)
{
    res <- lapply(x, .AAString2AAbin)
    class(res) <- "AAbin"
    res
}

as.AAbin.AAMultipleAlignment <- function(x, ...)
    as.matrix(as.AAbin.AAStringSet(as(x, "AAStringSet")))

complement <- function(x)
{
    f <- function(x) {
        ## reorder the vector of raws to match the complement:
        comp <- as.raw(._bs_[c(4:1, 10:9, 7:8, 6:5, 14:11, 15:17)])
        ans <- comp[match(as.integer(x), ._bs_)]
        rev(ans) # reverse before returning
    }
    if (is.matrix(x)) {
        for (i in 1:nrow(x)) x[i, ] <- f(x[i, ])
        return(x)
    } else if (is.list(x)) {
        x <- lapply(x, f)
    } else x <- f(x)
    class(x) <- "DNAbin"
    x
}

trans <- function(x, code = 1, codonstart = 1)
{
    f <- function(x, s, code)
        .C(trans_DNA2AA, x, as.integer(s), raw(s/3), as.integer(code),
           NAOK = TRUE)[[3]]
    if (code > 6)
        stop("only the genetic codes 1--6 are available for now")

    if (codonstart > 1) {
        del <- -(1:(codonstart - 1))
        if (is.list(x)) {
            for (i in seq_along(x)) x[[i]] <- x[[i]][del]
        } else {
            x <- if (is.matrix(x)) x[, del] else x[del]
        }
    }

    if (is.list(x)) {
        res <- lapply(x, trans, code = code)
    } else {
        s <- if (is.matrix(x)) ncol(x) else length(x)
        rest <- s %% 3
        if (rest != 0) {
            s <- s - rest
            x <- if (is.matrix(x)) x[, 1:s] else x[1:s]
            msg <- paste("sequence length not a multiple of 3:", rest, "nucleotide")
            if (rest == 2) msg <- paste0(msg, "s")
            warning(paste(msg, "dropped"))
        }
        res <- if (is.matrix(x)) t(apply(x, 1, f, s = s, code = code)) else f(x, s, code)
    }
    class(res) <- "AAbin"
    res
}

print.AAbin <- function(x, ...)
{
    if (is.list(x)) {
        n <- length(x)
        cat(n, "amino acid sequence")
        if (n > 1) cat("s")
        cat(" in a list\n\n")
        tmp <- lengths(x, use.names = FALSE)
        maxi <- max(tmp)
        mini <- min(tmp)
        if (mini == maxi)
            cat("All sequences of the same length:", maxi, "\n")
        else {
            cat("Mean sequence length:", round(mean(tmp), 3),
                "\n   Shortest sequence:", mini,
                "\n    Longest sequence:", maxi, "\n")
        }
    } else if (is.matrix(x)) {
        n <- nrow(x)
        cat(n, "amino acid sequence")
        if (n > 1) cat("s")
        cat(" in a matrix\n")
        if (n == 1) cat("Sequence length: ")
        else cat("All sequences of the same length: ")
        cat(ncol(x), "\n")
    } else {
        cat("1 amino acid sequence in a vector:\n\n",
            rawToChar(x))
    }
    cat("\n")
}

"[.AAbin" <- function (x, i, j, drop = FALSE)
{
    ans <- NextMethod("[", drop = drop)
    class(ans) <- "AAbin"
    ans
}

as.character.AAbin <- function(x, ...)
{
    f <- function(x) strsplit(rawToChar(x), "")[[1]]
    if (is.list(x)) return(lapply(x, f))
    if (is.matrix(x)) return(t(apply(x, 1, f)))
    f(x)
}

as.AAbin <- function(x, ...) UseMethod("as.AAbin")

as.AAbin.character <- function(x, ...)
{
    f <- function(x) charToRaw(paste(x, collapse = ""))
    res <- if (is.vector(x)) f(x) else t(apply(x, 1, f))
    class(res) <- "AAbin"
    res
}

labels.AAbin <- function(object, ...) labels.DNAbin(object, ...)

## TO BE MOVED TO phangorn LATER
if (getRversion() >= "2.15.1") utils::globalVariables("phyDat")
as.phyDat.AAbin <- function(x, ...) phyDat(as.character(x), type = "AA")
## \alias{as.phyDat.AAbin}
## \method{as.phyDat}{AAbin}(x, \dots)

dist.aa <- function(x, pairwise.deletion = FALSE, scaled = FALSE)
{
    n <- nrow(x)
    d <- numeric(n*(n - 1)/2)
    X <- charToRaw("X")
    k <- 0L
    if (!pairwise.deletion) {
        del <- apply(x, 2, function(y) any(y == X))
        if (any(del)) x <- x[, !del]
        for (i in 1:(n - 1)) {
            for (j in (i + 1):n) {
                k <- k + 1L
                d[k] <- sum(x[i, ] != x[j, ])
            }
        }
        if (scaled) d <- d/ncol(x)
    } else {
        for (i in 1:(n - 1)) {
            a <- x[i, ]
            for (j in (i + 1):n) {
                b <- x[j, ]
                del <- a == X | b == X
                p <- length(b <- b[!del])
                tmp <- sum(a[!del] != b)
                k <- k + 1L
                d[k] <- if (scaled) tmp/p else tmp
            }
        }
    }
    attr(d, "Size") <- n
    attr(d, "Labels") <- rownames(x)
    attr(d, "Diag") <- attr(d, "Upper") <- FALSE
    attr(d, "call") <- match.call()
    class(d) <- "dist"
    d
}

AAsubst <- function(x)
{
    X <- charToRaw("X")
    f <- function(y) length(unique.default(y[y != X]))
    which(apply(x, 2, f) > 1)
}

.AA_3letter <- c("Ala", "Cys", "Asp", "Glu", "Phe", "Gly", "His", "Ile",  "Lys", "Leu",
                 "Met", "Asn", "Pro", "Gln", "Arg", "Ser", "Thr",  "Val", "Trp", "Tyr",
                 "Xaa", "Stp")

.AA_1letter <- c("A", "C", "D", "E", "F", "G", "H", "I", "K", "L",
                 "M", "N", "P", "Q", "R", "S", "T", "V", "W", "Y", "X", "*")

.AA_raw <- sapply(.AA_1letter, charToRaw)

.AA_3cat <- list(Hydrophobic = .AA_raw[c("V", "I", "L", "F", "W", "Y", "M")],
                 Small = .AA_raw[c("P", "G", "A", "C")],
                 Hydrophilic = .AA_raw[c("S", "T", "H", "N", "Q", "D", "E", "K", "R")])

image.AAbin <-
    function(x, what, col, bg = "white", xlab = "", ylab = "",
             show.labels = TRUE, cex.lab = 1, legend = TRUE,
             grid = FALSE, show.aa = FALSE, aa.cex = 1,
             aa.font = 1, aa.col = "black", ...)
{
    if (missing(what))
        what <- c("Hydrophobic", "Small", "Hydrophilic")
    if (missing(col)) col <- c("red", "yellow", "blue")
    n <- (dx <- dim(x))[1]
    s <- dx[2]
    y <- integer(N <- length(x))
    ncl <- length(what)
    col <- rep(col, length.out = ncl)
    brks <- 0.5:(ncl + 0.5)
    sm <- 0L
    for (i in ncl:1) {
        k <- .AA_3cat[[i]]
        sel <- which(x %in% k)
        if (L <- length(sel)) {
            y[sel] <- i
            sm <- sm + L
        }
        else {
            what <- what[-i]
            col <- col[-i]
            brks <- brks[-i]
        }
    }
    dim(y) <- dx
    if (sm == N) {
        leg.co <- co <- col
        leg.txt <- what
    } else {
        co <- c(bg, col)
        leg.txt <- c(what, "Unknown")
        leg.co <- c(col, bg)
        brks <- c(-0.5, brks)
    }
    yaxt <- if (show.labels) "n" else "s"
    image.default(1:s, 1:n, t(y[n:1, ]), col = co, xlab = xlab, ylab = ylab,
                  yaxt = yaxt, breaks = brks, ...)
    if (length(poly <- AAsubst(x))) {
        rect(poly - 0.5, n + 0.5, poly + 0.5, n + 0.5 + yinch(0.2),
             col = "slategrey", border = NA, xpd = TRUE)
        ##rect(0.5, n + 0.5, s + 0.5, n + 0.5 + yinch(0.2), lwd = 0.5)
    }
    if (show.labels)
        mtext(rownames(x), side = 2, line = 0.1, at = n:1, cex = cex.lab,
              adj = 1, las = 1)
    if (legend) {
        psr <- par("usr")
        xx <- psr[2]/2
        yy <- psr[4] * (0.5 + 0.5/par("plt")[4])
        legend(xx, yy, legend = leg.txt, pch = 22, pt.bg = leg.co,
               pt.cex = 2, bty = "n", xjust = 0.5, yjust = 0.5,
               horiz = TRUE, xpd = TRUE)
    }
    if (grid) {
        if (is.logical(grid)) grid <- 3L
        if (grid %in% 2:3) abline(v = seq(1.5, s - 0.5, 1), lwd = 0.33, xpd = FALSE)
        if (grid %in% c(1, 3)) abline(h = seq(1.5, n - 0.5, 1), lwd = 0.33, xpd = FALSE)
    }
    if (show.aa) {
        x <- toupper(as.character(x))
        xx <- rep(1:s, each = n)
        yy <- rep(n:1, s)
        text(xx, yy, x, cex = aa.cex, font = aa.font, col = aa.col)
    }
}

checkAlignment <- function(x, check.gaps = TRUE, plot = TRUE, what = 1:4)
{
    cat("\nNumber of sequences:", n <- nrow(x),
        "\nNumber of sites:", s <- ncol(x), "\n")
if (check.gaps) {
    cat("\n")
    y <- DNAbin2indel(x)
    gap.length <- sort(unique.default(y))[-1]
    if (!length(gap.length)) cat("No gap in alignment.\n")
    else {
        rest <- gap.length %% 3
        if (any(cond <- rest > 0)) {
            cat("Some gap lengths are not multiple of 3:", gap.length[cond])
        } else cat("All gap lengths are multiple of 3.")

        tab <- tabulate(y, gap.length[length(gap.length)])
        tab <- tab[gap.length]
        cat("\n\nFrequencies of gap lengths:\n")
        names(tab) <- gap.length
        print(tab)

        ## find gaps on the borders:
        col1 <- unique(y[, 1])
        if (!col1[1]) col1 <- col1[-1]
        if (length(col1))
            cat("   => length of gaps on the left border of the alignment:", unique(col1), "\n")
        else cat("   => no gap on the left border of the alignment\n")
        i <- which(y != 0, useNames = FALSE)
        jcol <- i %/% nrow(y) + 1
        yi <- y[i]
        j <- yi == s - jcol + 1
        if (any(j))
            cat("   => length of gaps on the right border of the alignment:", yi[j], "\n")
        else cat("   => no gap on the right border of the alignment\n")

        ## find base segments:
        A <- B <- numeric()
        for (i in seq_len(n)) {
            j <- which(y[i, ] != 0) # j: start of each gap in the i-th sequence
            if (!length(j)) next
            k <- j + y[i, j] # k: start of each base segment in the i-th sequence
            if (j[1] != 1) k <- c(1, k) else j <- j[-1]
            if (k[length(k)] > s) k <- k[-length(k)] else j <- c(j, s + 1)
            A <- c(A, j)
            B <- c(B, k)
        }
        AB <- unique(cbind(A, B))
        not.multiple.of.3 <- (AB[, 1] - AB[, 2]) %% 3 != 0
        left.border <- AB[, 2] == 1
        right.border <- AB[, 1] == s + 1
        Nnot.mult3 <- sum(not.multiple.of.3)
        cat("\nNumber of unique contiguous base segments defined by gaps:", nrow(AB), "\n")
        if (!Nnot.mult3) cat("All segment lengths multiple of 3.\n")
        else {
            Nleft <- sum(not.multiple.of.3 & left.border)
            Nright <- sum(not.multiple.of.3 & right.border)
            cat("Number of segment lengths not multiple of 3:", Nnot.mult3, "\n",
                "   => on the left border of the alignement:", Nleft, "\n",
                "   => on the right border                 :", Nright, "\n")
            if (Nright + Nleft < Nnot.mult3) {
                cat("    => positions of these segments inside the alignment: ")
                sel <- not.multiple.of.3 & !left.border & !right.border
                cat(paste(AB[sel, 2], AB[sel, 1] - 1, sep = ".."), "\n")
            }
        }
    }
} else gap.length <- numeric()
    ss <- seg.sites(x)
    cat("\nNumber of segregating sites (including gaps):", length(ss))
    BF.col <- matrix(NA_real_, length(ss), 4)
    for (i in seq_along(ss))
        BF.col[i, ] <- base.freq(x[, ss[i]])#, freq = TRUE)
    tmp <- apply(BF.col, 1, function(x) sum(x > 0))
    cat("\nNumber of sites with at least one substitution:", sum(tmp > 1))
    cat("\nNumber of sites with 1, 2, 3 or 4 observed bases:\n")
    tab2 <- tabulate(tmp, 4L)
    tab2[1] <- s - sum(tab2)
    names(tab2) <- 1:4
    print(tab2)
    cat("\n")
    H <- numeric(s)
    H[ss] <- apply(BF.col, 1, function(x) {x <- x[x > 0]; -sum(x * log(x))})

    G <- rep(1, s)
    G[ss] <- tmp
    if (plot) {
        if (length(what) == 4) {
            mat <- if (length(gap.length)) 1:4 else c(1, 0, 2, 3)
            layout(matrix(mat, 2, 2))
        } else {
            if (length(what) != 1) {
                what <- what[1]
                warning("argument 'what' has length > 1: the first value is taken")
            }
        }
        if (1 %in% what) image(x)
        if (2 %in% what && length(gap.length)) barplot(tab, xlab = "Gap length")
        if (3 %in% what)
            plot(1:s, H, "h", xlab = "Sequence position", ylab = "Shannon index (H)")
        if (4 %in% what)
            plot(1:s, G, "h", xlab = "Sequence position", ylab = "Number of observed bases")
    }
}

all.equal.DNAbin <- function(target, current, plot = FALSE, ...)
{
    if (identical(target, current)) return(TRUE)
    name.target <- deparse(substitute(target))
    name.current <- deparse(substitute(current))
    st1 <- "convert list as matrix for further comparison."
#    st2 <- ""
    st3 <- "Subset your data for further comparison."
    isali1 <- is.matrix(target)
    isali2 <- is.matrix(current)
    if (isali1 && !isali2)
        return(c("1st object is a matrix, 2nd object is a list:", st1))
    if (!isali1 && isali2)
        return(c("1st object is a list, 2nd object is a matrix:", st1))
    if (!isali1 && !isali2)
        return(c("Both objects are lists:",
                 "convert them as matrices for further comparison."))
#    n1 <- if (isali1) nrow(target) else length(target)
#    n2 <- if (isali2) nrow(current) else length(current)
    if (ncol(target) != ncol(current))
        return("Numbers of columns different: comparison stopped here.")

    foo <- function(n) ifelse(n == 1, "sequence", "sequences")
    doComparison <- function(target, current)
        which(target != current, arr.ind = TRUE, useNames = FALSE)

    n1 <- nrow(target)
    n2 <- nrow(current)
    labs1 <- labels(target)
    labs2 <- labels(current)
    if (identical(labs1, labs2)) {
        res <- "Labels in both objects identical."
        res <- list(messages = res,
                    different.sites = doComparison(target, current))
    } else {
        in12 <- labs1 %in% labs2
        in21 <- labs2 %in% labs1
        if (n1 != n2) {
            res <- c("Number of sequences different:",
                     paste(n1, foo(n1), "in 1st object;", n2,
                           foo(n2), "in 2nd object."),
                     st3)
            plot <- FALSE
        } else { # n1 == n2
            if (any(!in12)) {
                res <- c("X: 1st object (target), Y: 2nd object (current).",
                         paste("labels in X not in Y:",
                               paste(labs1[!in12], collapse = ", ")),
                         paste("labels in X not in Y:",
                               paste(labs2[!in21], collapse = ", ")),
                         st3)
                plot <- FALSE
            } else {
                res <- c("Labels in both objects identical but not in the same order.",
                         "Comparing sequences after reordering rows of the second matrix.")
                current <- current[labs1, ]
                if (identical(target, current)) {
                    res <- c(res, "Sequences are identical.")
                    plot <- FALSE
                } else {
                    res <- list(messages = res,
                                different.sites = doComparison(target, current))
                }
            }
	}
    }
    if (plot) {
        cols <- unique(res$different.sites[, 2])
        diff.cols <- diff(cols)
        j <- which(diff.cols != 1)
        end <- c(cols[j], cols[length(cols)])
        start <- c(cols[1], cols[j + 1])
        v <- cumsum(end - start + 1) + 0.5
        f <- function(lab) {
            axis(2, at = seq_len(n1), labels = FALSE)
            axis(1, at = seq_along(cols), labels = cols)
            mtext(lab, line = 1, adj = 0, font = 2)
        }
        layout(matrix(1:2, 2))
        par(xpd = TRUE)
        image(target[, cols], show.labels = FALSE, axes = FALSE, ...)
        f(name.target)
        xx <- c(0.5, v)
        segments(xx, 0.5, xx, n1, lty = 2, col = "white", lwd = 2)
        segments(xx, 0.5, xx, -1e5, lty = 2, lwd = 2)
        image(current[, cols], show.labels = FALSE, axes = FALSE, ...)
        f(name.current)
        segments(xx, 0.5, xx, n2, lty = 2, col = "white", lwd = 2)
        segments(xx, 1e5, xx, n2, lty = 2, lwd = 2)
        #segments(0.5, -5, length(cols) + 0.5, -5, lwd = 5, col = "grey")
        #rect(0.5, -4, length(cols) + 0.5, -3, col = "grey")
        #segments(0.5, 0.5, 10, -3)
    }
    res
}

## From Franz Krah <f.krah@mailbox.org>:

## estensions of the AAbin class to complement the DNAbin class funcitons

c.AAbin <- function(..., recursive = FALSE)
{
  if (!all(unlist(lapply(list(...), is.list))))
    stop("the 'c' method for \"AAbin\" accepts only lists")
  structure(NextMethod("c"), class = "AAbin")
}

rbind.AAbin <- function(...)
{
    obj <- list(...)
    n <- length(obj)
    if (n == 1) return(obj[[1]])
    for (i in 1:n)
        if (!is.matrix(obj[[1]]))
            stop("the 'rbind' method for \"AAbin\" accepts only matrices")
    NC <- unlist(lapply(obj, ncol))
    if (length(unique(NC)) > 1)
        stop("matrices do not have the same number of columns.")
    for (i in 1:n) class(obj[[i]]) <- NULL # safe but maybe not really needed
    structure(do.call(rbind, obj), class = "AAbin")
}

cbind.AAbin <-
    function(..., check.names = TRUE, fill.with.Xs = FALSE,
             quiet = FALSE)
{
    obj <- list(...)
    n <- length(obj)
    if (n == 1) return(obj[[1]])
    for (i in 1:n)
        if (!is.matrix(obj[[1]]))
            stop("the 'cbind' method for \"AAbin\" accepts only matrices")
    NR <- unlist(lapply(obj, nrow))
    for (i in 1:n) class(obj[[i]]) <- NULL
    if (check.names) {
        NMS <- lapply(obj, rownames)
        for (i in 1:n)
            if (anyDuplicated(NMS[[i]]))
                stop("Duplicated rownames in matrix ", i, ": see ?cbind.AAbin")
        nms <- unlist(NMS)
        if (fill.with.Xs) {
            NC <- unlist(lapply(obj, ncol))
            nms <- unique(nms)
            ans <- matrix(charToRaw("X"), length(nms), sum(NC))
            rownames(ans) <- nms
            from <- 1
            for (i in 1:n) {
                to <- from + NC[i] - 1
                k <- match(NMS[[i]], nms)
                ans[k, from:to] <- obj[[i]]
                from <- to + 1
            }
        } else {
            tab <- table(nms)
            ubi <- tab == n
            nms <- names(tab)[which(ubi)]
            ans <- obj[[1]][nms, , drop = FALSE]
            for (i in 2:n)
                ans <- cbind(ans, obj[[i]][nms, , drop = FALSE])
            if (!quiet && !all(ubi))
                warning("some rows were dropped.")
        }
    } else {
        if (length(unique(NR)) > 1)
            stop("matrices do not have the same number of rows.")
        ans <- matrix(unlist(obj), NR)
        rownames(ans) <- rownames(obj[[1]])
    }
    class(ans) <- "AAbin"
    ans
}

as.AAbin.list <- function(x, ...)
{
  obj <- lapply(x, as.AAbin)
  class(obj) <- "AAbin"
  obj
}

as.list.AAbin <- function(x, ...)
{
  if (is.list(x)) return(x)
  if (is.null(dim(x))) obj <- list(x) # cause is.vector() doesn't work
  else { # matrix
    n <- nrow(x)
    obj <- vector("list", n)
    for (i in seq_len(n)) obj[[i]] <- x[i, , drop = TRUE]
    names(obj) <- rownames(x)
  }
  class(obj) <- "AAbin"
  obj
}

as.matrix.AAbin <- function(x, ...)
{
  if (is.matrix(x)) return(x)
  if (!is.list(x)) { # vector
    dim(x) <- c(1, length(x))
    return(x)
  }
  s <- unique(lengths(x, use.names = FALSE))
  if (length(s) != 1)
    stop("AA sequences in list not of the same length.")
  n <- length(x)
  y <- matrix(raw(), n, s)
  for (i in seq_len(n)) y[i, ] <- x[[i]]
  rownames(y) <- names(x)
  class(y) <- "AAbin"
  y
}

rDNAbin <- function(n, nrow, ncol, base.freq = rep(0.25, 4), prefix = "Ind_")
{
    foo <- function(n, prob) {
        vec <- as.raw(._bs_[1:4])
        vec[sample.int(4L, n, TRUE, prob, FALSE)]
    }
    base.freq <- if (all(base.freq == 0.25)) NULL else base.freq[c(1, 3, 2, 4)]
    if (missing(n)) {
        if (missing(nrow) && missing(ncol))
            stop("nrow and ncol should be given if n is missing")
        res <- foo(nrow * ncol, base.freq)
        dim(res) <- c(nrow, ncol)
        rownames(res) <- paste0(prefix, 1:nrow)
    } else {
        res <- lapply(n, foo, prob = base.freq)
        names(res) <- paste0(prefix, seq_along(n))
    }
    class(res) <- "DNAbin"
    res
}

dnds <- function(x, code = 1, codonstart = 1, quiet = FALSE)
{
    if (code > 2)
        stop("only the standard (code=1) and the vertebrate mitochondrial (code=2) codes are available for now")
    if (is.list(x)) x <- as.matrix(x)
    n <- nrow(x)
    if (nrow(unique.matrix(x)) != n) stop("sequences are not unique")
    if (codonstart > 1) {
        del <- -(1:(codonstart - 1))
        x <- x[, del]
    }
    p <- ncol(x)
    rest <- p %% 3
    if (rest != 0) {
        p <- p - rest
        x <- x[, 1:p]
        msg <- paste("sequence length not a multiple of 3:",
                     rest, ifelse(rest == 1,  "nucleotide", "nucleotides"),
                     "dropped")
        warning(msg)
    }

    class(x) <- NULL

    abin <- as.raw(0x88)
    gbin <- as.raw(0x48)
    cbin <- as.raw(0x28)
    tbin <- as.raw(0x18)

    pos1 <- seq(1, by = 3, length.out = p/3)
    POS1 <- POS2 <- POS3 <- logical(p)
    POS1[pos1] <- POS2[pos1 + 1L] <- POS3[pos1 + 2L] <- TRUE

    Lcat <- matrix(0L, n, p)
    Lcat[, POS3] <- 4L # most sites at 3rd positions are fourfold degenerate

    m12 <- -c(1, 2)

    if (code == 1) {
        for (i in 1:n) {
            z <- x[i, , drop = TRUE]
            isA <- z == abin
            isG <- z == gbin
            isC <- z == cbin
            isT <- z == tbin
            ## 1/ are some bases at 1st positions twofold degenerate?
            s2 <- isT & POS2
            if (any(s2)) {
                s3 <- c(FALSE, s2[-p]) & ((isA | isG) & POS3)
                if (any(s3)) {
                    s1 <- ((isT | isC) & POS1) & c(s3[m12], FALSE, FALSE)
                    if (any(s1)) Lcat[i, which(s1)] <- 2L
                }
            }
            s2 <- isG & POS2
            if (any(s2)) {
                s3 <- c(FALSE, s2[-p]) & ((isA | isG) & POS3)
                if (any(s3)) {
                    s1 <- ((isA | isC) & POS1) & c(s3[m12], FALSE, FALSE)
                    if (any(s1)) Lcat[i, which(s1)] <- 2L
                }
            }
            ## 2/ all bases at 2nd positions are nondegenerate: no need to do anything
            ## 3/ find the bases at 3rd positions that are twofold degenerate
            s2 <- isA & POS2
            if (any(s2)) Lcat[i, which(s2) + 1L] <- 2L
            s2 <- isG & POS2
            if (any(s2)) {
                s1 <- ((isT | isA) & POS1) & c(s2[-p], FALSE)
                if (any(s1)) Lcat[i, which(s1) + 2L] <- 2L
            }
        }
    } else { # if (code == 2)
        for (i in 1:n) {
            z <- x[i, , drop = TRUE]
            isA <- z == abin
            isG <- z == gbin
            isC <- z == cbin
            isT <- z == tbin
            ## 1/ are some bases at 1st positions twofold degenerate?
            s2 <- isT & POS2
            if (any(s2)) {
                s3 <- c(FALSE, s2[-p]) & ((isA | isG) & POS3)
                if (any(s3)) {
                    s1 <- ((isT | isC) & POS1) & c(s3[m12], FALSE, FALSE)
                    if (any(s1)) Lcat[i, which(s1)] <- 2L
                }
            }
            ## 2/ all bases at 2nd positions are nondegenerate: no need to do anything
            ## 3/ find the bases at 3rd positions that twofold/fourfold degenerate
            s1 <- (isA | isT) & POS1
            if (any(s1)) {
                s2 <- c(FALSE, s1[-p]) & ((isT | isA | isG) & POS2)
                if (any(s2)) Lcat[i, which(s2) + 1L] <- 2L
            }
            s1 <- (isC | isG) & POS1
            if (any(s1)) {
                s2 <- c(FALSE, s1[-p]) & (isA & POS2)
                if (any(s2)) Lcat[i, which(s2) + 1L] <- 2L
            }
        }
    }

    deg <- c(0, 2, 4) # the 3 levels of degeneracy
    nout <- n*(n - 1)/2
    res <- numeric(nout)
    k <- 1L
    for (i in 1:(n - 1)) {
        for (j in (i + 1):n) {
            if (!quiet) cat("\r", round(100*k/nout), "%")
            z <- x[c(i, j), ]
            Lavg <- (Lcat[i, ] + Lcat[j, ])/2
            ii <- lapply(deg, function(x) which(x == Lavg))
            L <- lengths(ii)
            S <- lapply(ii, function(id) dist.dna(z[, id], "TS"))
            V <- lapply(ii, function(id) dist.dna(z[, id], "TV"))
            P <- unlist(S, use.names = FALSE)/L
            Q <- unlist(V, use.names = FALSE)/L
            a <- 1/(1 - 2*P - Q)
            b <- 1/(1 - 2*Q)
            c <- (a - b)/2
            A <- log(a)/2 - log(b)/4
            B <- log(b)/2
            dS <- (L[2]*A[2] + L[3]*A[3])/sum(L[2:3]) + B[3]
            dN <- A[1] + (L[1]*B[1] + L[2]*B[2])/sum(L[1:2])
            res[k] <- dN/dS
            k <- k + 1L
        }
    }
    if (!quiet) cat("... done\n")
    attr(res, "Size") <- n
    attr(res, "Labels") <- rownames(x)
    attr(res, "Diag") <- attr(res, "Upper") <- FALSE
    attr(res, "call") <- match.call()
    attr(res, "method") <- "dNdS (Li 1993)"
    class(res) <- "dist"
    res
}

latag2n <- function(x) {
    if (is.list(x)) x <- as.matrix(x)
    dx <- dim(x)
    clx <- class(x)
    res <- .Call(leading_trailing_gaps_to_N, x)
    class(res) <- clx
    dim(res) <- dx
    res
}

## rtt.R (2015-07-16)

##   Root a tree by root-to-tip regression

## Copyright (c) 2014-2015, Rosemary McCloskey, BC Centre for Excellence in HIV/AIDS

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

rtt <- function (t, tip.dates, ncpu = 1, objective = "correlation",
    opt.tol = .Machine$double.eps^0.25)  {
    if (objective == "correlation")
        objective <- function(x, y) cor.test(y, x)$estimate
    else if (objective == "rsquared")
        objective <- function(x, y) summary(lm(y ~ x))$r.squared
    else if (objective == "rms")
        objective <- function(x, y) -summary(lm(y ~ x))$sigma^2
    else stop("objective must be one of \"correlation\", \"rsquared\", or \"rms\"")

    ut <- unroot(t)
    dist <- dist.nodes(ut)[, 1:(ut$Nnode + 2)]

    f <- function (x, parent, child) {
        edge.dist <- x * dist[parent, ] + (1 - x) * dist[child,]
        objective(tip.dates, edge.dist)
    }

    obj.edge <- if (ncpu > 1)
        unlist(mclapply(1:nrow(ut$edge), function (e) {
            opt.fun <- function (x) f(x, ut$edge[e,1], ut$edge[e,2])
            optimize(opt.fun, c(0, 1), maximum = TRUE, tol = opt.tol)$objective
        }, mc.cores=ncpu))
    else apply(ut$edge, 1, function (e) {
        opt.fun <- function (x) f(x, e[1], e[2])
        optimize(opt.fun, c(0, 1), maximum = TRUE, tol = opt.tol)$objective
    })

    best.edge <- which.max(obj.edge)

    best.edge.parent <- ut$edge[best.edge, 1]
    best.edge.child <- ut$edge[best.edge, 2]
    best.edge.length <- ut$edge.length[best.edge]

    opt.fun <- function (x) f(x, best.edge.parent, best.edge.child)
    best.pos <- optimize(opt.fun, c(0, 1), maximum = TRUE, tol = opt.tol)$maximum

    new.root <- list(edge = matrix(c(2L, 1L), 1, 2), tip.label = "new.root",
        edge.length = 1, Nnode = 1L, root.edge = 1)
    class(new.root) <- "phylo"
    ut <- bind.tree(ut, new.root, where = best.edge.child, position = best.pos *
        best.edge.length)
    ut <- collapse.singles(ut)
    ut <- root(ut, "new.root")
    drop.tip(ut, "new.root")
}

## plot.phyloExtra.R (2018-07-28)

##   Extra Functions for Plotting and Annotating

## Copyright 2016-2018 Emmanuel Paradis

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

plotBreakLongEdges <- function(phy, n = 1, ...) {
    o <- order(phy$edge.length, decreasing = TRUE)
    i <- o[seq_len(n)]
    phy$edge.length[i] <- max(phy$edge.length[-i])
    plot.phylo(phy, ...)
    edgelabels(edge = i, pch = 19, col = "white")
    edgelabels("//", i, frame = "n")
}

drawSupportOnEdges <- function(value, ...)
{
    lastPP <- get("last_plot.phylo", envir = .PlotPhyloEnv)
    n <- lastPP$Ntip
    m <- lastPP$Nnode
    if (length(value) == m) value <- value[-1]
    else if (length(value) != m - 1)
        stop("incorrect number of support values")
    nodes <- 2:m + n
    i <- match(nodes, lastPP$edge[, 2])
    edgelabels(value, i, ...)
}

plotTreeTime <- function(phy, tip.dates, show.tip.label = FALSE, y.lim = NULL,
                         color = TRUE, ...)
{
    n <- Ntip(phy)
    if (length(tip.dates) != n)
        stop("number of dates does not match number of tips of the tree")
    if (is.null(y.lim)) y.lim <- c(-n/4, n)
    plot(phy, show.tip.label = show.tip.label, y.lim = y.lim, ...)
    psr <- par("usr")

    if (anyNA(tip.dates)) {
        s <- which(!is.na(tip.dates))
        tip.dates <- tip.dates[s]
    } else s <- 1:n
    range.dates <- range(as.numeric(tip.dates))

    diff.range <- range.dates[2] - range.dates[1]
    footrans <- function(x)
        psr[2] * (as.numeric(x) - range.dates[1]) / diff.range

    x1 <- footrans(tip.dates)
    y1 <- psr[3]
    lastPP <- get("last_plot.phylo", envir = .PlotPhyloEnv)
    x2 <- lastPP$xx[s]
    y2 <- lastPP$yy[s]
    x1.scaled <- x1 / max(x1)
    col <-
        if (color) rgb(x1.scaled, 0, 1 - x1.scaled, alpha = .5)
        else grey(x1.scaled, alpha = 0.5)
    segments(x1, y1, x2, y2, col = col)
    at <- pretty(tip.dates)
    axis(1, at = footrans(at), labels = at)
}

'print.parafit' <-
    function(x, ...)
{
	cat("\nTest of host-parasite coevolution",'\n','\n')

	cat("Global test:  ParaFitGlobal =",x$ParaFitGlobal,", p-value =", x$p.global, "(", x$nperm,"permutations)",'\n','\n')

	n.links <- nrow(x$link.table)
	cat("There are",n.links,"host-parasite links in matrix HP",'\n','\n')
	cat("Test of individual host-parasite links", "(", x$nperm, "permutations)",'\n','\n')
	print(x$link.table)

	cat('\n',"Number of parasites per host",'\n')
	print(x$para.per.host)
	cat('\n',"Number of hosts per parasite",'\n')
	print(x$host.per.para)
    invisible(x)
}

'biplot.pcoa' <- 
    function(x, Y=NULL, plot.axes=c(1,2), dir.axis1=1, dir.axis2=1,rn=NULL,main=NULL, ...)
# x = output object from function pcoa.R
# Y = optional sites-by-variables data table
# plot.axes = the two axes to be plotted
# dir.axis.1 = -1 to revert axis 1 for the projection of points and variables
# dir.axis.2 = -1 to revert axis 2 for the projection of points and variables
# rn = an optional vector, length n, of object name labels
# Customize the title of the biplot with argument 'main'. Ex.: main="My own PCoA title".
#
# Corrected version, March 2017 - This version draws biplots from the principal coordinates (x$vectors.cor) with Lingoes or Cailliez correction, when applicable.
#
# Author: Pierre Legendre, January 2009, March 2017
	{
	if (!inherits(x, "pcoa")) stop("Object of class 'pcoa' expected")
	pr.coo <- x$vectors
	if(x$correction[2] > 1) pr.coo <- x$vectors.cor
	k <- ncol(pr.coo)
	if(k < 2) stop("There is a single eigenvalue. No plot can be produced.")
	if(k < plot.axes[1]) stop("Axis",plot.axes[1],"does not exist.")
	if(k < plot.axes[2]) stop("Axis",plot.axes[2],"does not exist.")

	if(!is.null(rn)) rownames(pr.coo) <- rn
	labels = colnames(pr.coo[,plot.axes])
	diag.dir <- diag(c(dir.axis1,dir.axis2))
	pr.coo[,plot.axes] <- pr.coo[,plot.axes] %*% diag.dir

	if(is.null(Y)) {
		limits <- apply(pr.coo[,plot.axes], 2, range) 
		ran.x <- limits[2,1] - limits[1,1]
		ran.y <- limits[2,2] - limits[1,2]
		xlim <- c((limits[1,1]-ran.x/10), (limits[2,1]+ran.x/5)) 
		ylim <- c((limits[1,2]-ran.y/10), (limits[2,2]+ran.y/10))

		par(mai = c(1.0, 1.0, 1.0, 0.5))
		plot(pr.coo[,plot.axes],xlab=labels[1],ylab=labels[2],xlim=xlim,ylim=ylim,asp=1)
		text(pr.coo[,plot.axes], labels=rownames(pr.coo), pos=4, cex=1, offset=0.5)
		if(is.null(main)) {
			title(main = "PCoA ordination", line=2)
   			} else {
   			title(main = main, family="serif", line=2)
   			}
	
		} else {
		# Find positions of variables in biplot:
		# construct U from covariance matrix between Y and standardized point vectors
		# (equivalent to PCA scaling 1, since PCoA preserves distances among objects)
		n <- nrow(Y)
		points.stand <- scale(pr.coo[,plot.axes])
		S <- cov(Y, points.stand)
		U <- S %*% diag((x$values$Eigenvalues[plot.axes]/(n-1))^(-0.5))
		colnames(U) <- colnames(pr.coo[,plot.axes])

		par(mai = c(1, 0.5, 1.4, 0))
		biplot(pr.coo[,plot.axes], U, xlab=labels[1], ylab=labels[2])
		if(is.null(main)) {
			title(main = c("PCoA biplot","Response variables projected","as in PCA with scaling 1"), line=4)
   			} else {
   			title(main = main, family="serif")
   			}
	}
    invisible()
}

## phymltest.R (2014-11-07)

##   Fits a Bunch of Models with PhyML

## Copyright 2004-2014 Emmanuel Paradis

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

.phymltest.model <-
    c("JC69", "JC69+I", "JC69+G", "JC69+I+G",
      "K80", "K80+I", "K80+G", "K80+I+G",
      "F81", "F81+I", "F81+G", "F81+I+G",
      "F84", "F84+I", "F84+G", "F84+I+G",
      "HKY85", "HKY85+I", "HKY85+G", "HKY85+I+G",
      "TN93", "TN93+I", "TN93+G", "TN93+I+G",
      "GTR", "GTR+I", "GTR+G", "GTR+I+G")

.phymltest.nfp <-
    c(1, 2, 2, 3, 2, 3, 3, 4, 4, 5, 5, 6, 5, 6, 6, 7,
      5, 6, 6, 7, 6, 7, 7, 8, 9, 10, 10, 11)

phymltest <- function(seqfile, format = "interleaved", itree = NULL,
                      exclude = NULL, execname = NULL, append = TRUE)
{
    os <- Sys.info()[1]
    ## default names of PhyML:
    if (is.null(execname)) {
        execname <- switch(os, "Linux" = {
            ## PhyML location for Debian and Fedora packages and maybe for other distributions (fix by Dylan A\"issi)
            if (file.exists("/usr/bin/phyml")) "/usr/bin/phyml" else "phyml_3.0.1_linux32"
	}, "Darwin" = "phyml_3.0.1_macintel", "Windows" = "phyml_3.0.1_win32")
    }
    if (is.null(execname))
        stop("you must give an executable file name for PHYML")
    N <- length(.phymltest.model)
    format <- match.arg(format, c("interleaved", "sequential"))
    fmt <- rep("", N)
    if (format != "interleaved") fmt[] <- "-q"
    boot <- rep("-b 0", N) # to avoid any testing
    mdl <- paste("-m", rep(c("JC69", "K80", "F81", "F84", "HKY85", "TN93", "GTR"), each = 4)) # fix by Luiz Max Fagundes de Carvalho
    tstv <- rep("-t e", N) # ignored by PhyML with JC69 or F81
    inv <- rep(c("", "-v e"), length.out = N)
    ## no need to use the -c option of PhyML (4 categories by default if '-a e' is set):
    alpha <- rep(rep(c("-c 1", "-a e"), each = 2), length.out = N)
    tree <- rep("", N)
    if (!is.null(itree)) tree[] <- paste("-u ", itree)

    cmd <- paste(execname, "-i", seqfile, fmt, boot, mdl, tstv, inv, alpha, tree, "--append ")
    outfile <- paste(seqfile, "_phyml_stats.txt", sep = "")
    if (!append) {
        unlink(outfile)
        unlink(paste(seqfile, "_phyml_tree.txt", sep = ""))
    }
    imod <- 1:N
    if (!is.null(exclude)) imod <- imod[!.phymltest.model %in% exclude]

    for (i in imod) system(cmd[i])

    l <- readLines(outfile)
    l <- grep("Log-likelihood:", l, value = TRUE)
    ## in case there were already some results in the output file:
    if (dd <- length(l) - length(imod)) l <- l[-(1:dd)]
    loglik <- as.numeric(sub(". Log-likelihood:", "", l))
    names(loglik) <- .phymltest.model[imod]
    class(loglik) <- "phymltest"
    loglik
}

print.phymltest <- function(x, ...)
{
    nfp <- .phymltest.nfp[.phymltest.model %in% names(x)]
    X <- cbind(nfp, x, 2 * (nfp - x))
    rownames(X) <- names(x)
    colnames(X) <- c("nb.free.para", "loglik", "AIC")
    print(X)
}

summary.phymltest <- function(object, ...)
{
    nfp <- .phymltest.nfp[.phymltest.model %in% names(object)]
    N <- length(object)
    model1 <- model2 <- character(0)
    chi2 <- df <- P.val <- numeric(0)
    for (i in 1:(N - 1)) {
        for (j in (i + 1):N) {
            if (nfp[i] >= nfp[j]) next
            m1 <- unlist(strsplit(names(object)[i], "\\+"))
            m2 <- unlist(strsplit(names(object)[j], "\\+"))
            if (m1[1] == "K80" && m2[1] == "F81") next
            ## a verifier que ds les 2 lignes suivantes les conversions
            ## se font bien correctement!!!!
            if (length(grep("\\+I", names(object)[i])) > 0 && length(grep("\\+I", names(object)[j])) == 0) next
            if (length(grep("\\+G", names(object)[i])) > 0 && length(grep("\\+G", names(object)[j])) == 0) next
            ## Now we should be sure that m1 is nested in m2.
            chi2 <- c(chi2, 2 * (object[j] - object[i]))
            df <- c(df, nfp[j] - nfp[i])
            P.val <- c(P.val, 1 - pchisq(2 * (object[j] - object[i]), nfp[j] - nfp[i]))
            model1 <- c(model1, names(object)[i])
            model2 <- c(model2, names(object)[j])
        }
    }
    data.frame(model1, model2, chi2, df, P.val = round(P.val, 4))
}

plot.phymltest <- function(x, main = NULL, col = "blue", ...)
{
    nfp <- .phymltest.nfp[.phymltest.model %in% names(x)]
    N <- length(x)
    aic <- 2 * (nfp - x)
    if (is.null(main))
      main <- paste("Akaike information criterion for",
                    deparse(substitute(x)))
    plot(rep(1, N), aic, bty = "n", xaxt = "n", yaxt = "n",
         type = "n", xlab = "", ylab = "", main = main, ...)
    axis(side = 2, pos = 0.85, las = 2)
    abline(v = 0.85)
    y.lab <- seq(min(aic), max(aic), length = N)
    segments(0.85, sort(aic), 1.1, y.lab, col = col)
    text(1.1, y.lab,
         parse(text = sub("\\+G", "\\+Gamma", names(sort(aic)))),
         adj = 0)
}

## branching.times.R (2018-01-16)

##    Branching Times of a Phylogenetic Tree

## Copyright 2002-2018 Emmanuel Paradis

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

branching.times <- function(phy)
{
    if (!inherits(phy, "phylo"))
        stop('object "phy" is not of class "phylo"')
    phy <- reorder(phy)
    n <- length(phy$tip.label)
    e1 <- phy$edge[, 1]
    e2 <- phy$edge[, 2]
    EL <- phy$edge.length
    if (is.null(EL)) {
        warning("no branch length in tree")
        return(numeric())
    }
    N <- length(e1)
    xx <- numeric(phy$Nnode)
    interns <- which(e2 > n)
    ## we loop only on the internal edges, this assumes
    ## that `xx' is already set with 0
    for (i in interns) xx[e2[i] - n] <- xx[e1[i] - n] + EL[i]
    depth <- xx[e1[N] - n] + EL[N]
    xx <- depth - xx
    names(xx) <-
        if (is.null(phy$node.label)) (n + 1):(n + phy$Nnode)
        else phy$node.label
    xx
}

## chronoMPL.R (2017-04-25)

##   Molecular Dating with Mean Path Lengths

## Copyright 2007-2017 Emmanuel Paradis

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

chronoMPL <- function(phy, se = TRUE, test = TRUE)
{
    if (!is.binary.phylo(phy)) stop("the tree is not dichotomous.")
    n <- length(phy$tip.label)
    m <- phy$Nnode
    N <- dim(phy$edge)[1]
    obj <- reorder(phy, "postorder")
    ndesc <- .C(node_depth, as.integer(n),
                as.integer(obj$edge[, 1]), as.integer(obj$edge[, 2]),
                as.integer(N), double(n + m), 1L)[[5]]
    s <- numeric(n + m) # sum of path lengths
    if (se) ss <- s
    if (test) Pval <- numeric(m)
    for (i in seq(1, N - 1, 2)) {
        j <- i + 1
        a <- obj$edge[i, 2]
        b <- obj$edge[j, 2]
        o <- obj$edge[i, 1]
        A <- s[a] + ndesc[a]*obj$edge.length[i]
        B <- s[b] + ndesc[b]*obj$edge.length[j]
        s[o] <- A + B
        if (se)
          ss[o] <- ss[a] + ndesc[a]^2 * obj$edge.length[i] + ss[b] +
            ndesc[b]^2 * obj$edge.length[j]
        if (test) {
            z <- abs(A/ndesc[a] - B/ndesc[b])
            tmp <- (ss[a] + ndesc[a]^2 * obj$edge.length[i])/ndesc[a]^2
            tmp <- tmp + (ss[b] + ndesc[b]^2 * obj$edge.length[j])/ndesc[b]^2
            z <- z/sqrt(tmp)
            Pval[o - n] <- 2*pnorm(z, lower.tail = FALSE)
        }
    }
    node.age <- s/ndesc
    phy$edge.length <- node.age[phy$edge[, 1]] - node.age[phy$edge[, 2]]
    if (se) attr(phy, "stderr") <- sqrt(ss[-(1:n)]/ndesc[-(1:n)]^2)
    if (test) attr(phy, "Pval") <- Pval
    phy
}

## extract.popsize.R (2004-07-4)

##  Extract table with population size in dependence of time
##      from mcmc output generated by mcmc.popsize

## Copyright 2004 Rainer Opgen-Rhein and Korbinian Strimmer

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

extract.popsize<-function(mcmc.out, credible.interval=0.95, time.points=200, thinning=1, burn.in=0)
{

  # construct a matrix with the positions of the jumps
    b<-burn.in+1
    i<-1
    k<-array(dim=ceiling((length(mcmc.out$pos)-burn.in)/thinning))
    while(i<=length(k)) {
       k[i]<-length(mcmc.out$pos[[b]]);
       (i<-i+1);
       b<-b+thinning
    }
    o<-max(k)

    b<-burn.in+1
    i<-1
    pos.m<-matrix(nrow=length(k), ncol=o)
    while(i<=length(k)) {
        pos.m[i,]<-c(mcmc.out$pos[[b]], array(dim=o-length(mcmc.out$pos[[b]])));
        i<-i+1;
        b<-b+thinning
    }

  # construct a matrix with the heights of the jumps
    b<-burn.in+1
    i<-1
    h.m<-matrix(nrow=length(k), ncol=o)
    while(i<=length(k)) {
        h.m[i,]<-c(mcmc.out$h[[b]], array(dim=o-length(mcmc.out$h[[b]])));
        i<-i+1;
        b<-b+thinning
     }
  prep<-list("pos"=pos.m, "h"=h.m)

####################

  step <- (max(prep$pos, na.rm=TRUE)-min(prep$pos, na.rm=TRUE))/(time.points-1)
  nr <- time.points

  p<-min(prep$pos, na.rm=TRUE)
  i<-1
  me<-matrix(nrow=nr, ncol=5)

  prep.l<-prep
  prep.l$pos<-cbind(prep$pos,prep$pos[,length(prep$pos[1,])])
  prep.l$h<-cbind(prep$h,prep$h[,length(prep$h[1,])])

  while (p<=max(prep$pos, na.rm=TRUE))
  {
    #Vector with position of heights
    l.prep<-prep$pos<=p
    l.prep[is.na(l.prep)]<-FALSE
    pos.of.h<-l.prep%*% array(data=1, dim=dim(prep$pos)[2])

    #Vector with heights
    z<-array(data=(1:dim(prep$pos)[1]), dim=dim(prep$pos)[1])
    index.left<-cbind(z,pos.of.h)
    index.right<-cbind(z, pos.of.h+1)

   mixed.heights<-((((p-prep$pos[index.left])/(prep$pos[index.right]-prep$pos[index.left]))*
                     (prep$h[index.right]-prep$h[index.left]))+prep$h[index.left])

    me[i,2]<-mean(mixed.heights)

    #library(MASS)
    #me[i,2]<-huber(mixed.heights)$mu

    me[i,3]<-median(mixed.heights)
    me[i,4]<-quantile(mixed.heights, probs=(1-credible.interval)/2, na.rm=TRUE)
    me[i,5]<-quantile(mixed.heights, probs=(1+credible.interval)/2, na.rm=TRUE)
    me[i,1]<-p
    p<-p+step
    i<-i+1
  }

  #av.jumps<-round((length(prep$pos)-sum(is.na(prep$pos)))/length(prep$pos[,1])-2,2)
  #print("average jumps")

  #print((length(prep$pos)-sum(is.na(prep$pos)))/length(prep$pos[,1])-2)

  colnames(me) <- c("time", "mean", "median", "lower CI", "upper CI")
  class(me) <- "popsize"

  return(me)
}

## reorder.phylo.R (2017-07-28)

##   Internal Reordering of Trees

## Copyright 2006-2017 Emmanuel Paradis, 2017 Klaus Schliep

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

.reorder_ape <- function(x, order, index.only, nb.tip, io)
{
    nb.edge <- dim(x$edge)[1]
    if (!is.null(attr(x, "order")))
        if (attr(x, "order") == order)
            if (index.only) return(1:nb.edge) else return(x)
    nb.node <- x$Nnode
    if (nb.node == 1)
        if (index.only) return(1:nb.edge) else return(x)

    if (io == 3) {
        x <- reorder(x)
        neworder <-
            .C(neworder_pruningwise, as.integer(nb.tip),
               as.integer(nb.node), as.integer(x$edge[, 1]),
               as.integer(x$edge[, 2]), as.integer(nb.edge),
               integer(nb.edge))[[6]]
    } else {
        neworder <- reorderRcpp(x$edge, as.integer(nb.tip),
                                as.integer(nb.tip + 1L), io)
    }
    if (index.only) return(neworder)
    x$edge <- x$edge[neworder, ]
    if (!is.null(x$edge.length))
        x$edge.length <- x$edge.length[neworder]
    attr(x, "order") <- order
    x
}

reorder.phylo <- function(x, order = "cladewise", index.only = FALSE, ...)
{
    ORDER <- c("cladewise", "postorder", "pruningwise")
    io <- pmatch(order, ORDER)
    if (is.na(io)) stop("ambiguous order")
    order <- ORDER[io]
    .reorder_ape(x, order, index.only, length(x$tip.label), io)
}

reorder.multiPhylo <- function(x, order = "cladewise", ...)
{
    ORDER <- c("cladewise", "postorder", "pruningwise")
    io <- pmatch(order, ORDER)
    if (is.na(io)) stop("ambiguous order")
    order <- ORDER[io]
    oc <- oldClass(x)
    class(x) <- NULL
    labs <- attr(x, "TipLabel")
    x <-
        if (is.null(labs)) lapply(x, reorder.phylo, order = order)
        else lapply(x, .reorder_ape, order = order, index.only = FALSE,
                    nb.tip = length(labs), io = io)
    if (!is.null(labs)) attr(x, "TipLabel") <- labs
    class(x) <- oc
    x
}

cladewise <- function(x) reorder(x, "cladewise", index.only = TRUE)

postorder <- function(x) reorder(x, "postorder", index.only = TRUE)

rotateConstr <- function(phy, constraint)
{
    D <- match(phy$tip.label, constraint)
    n <- Ntip(phy)

    P <- c(as.list(1:n), prop.part(phy))
    e1 <- phy$edge[, 1L]
    e2 <- phy$edge[, 2L]

    foo <- function(node) {
        i <- which(e1 == node) # the edges where 'node' is ancestral
        desc <- e2[i] # the descendants of 'node'
        ## below, min() seems to work better than median() which
        ## seems to work better than mean() which seems to work
        ## better than sum()
        o <- order(sapply(desc, function(x) min(D[P[[x]]])))
        for (k in o) {
            j <<- j + 1L
            neworder[j] <<- i[k]
            if ((dk <- desc[k]) > n) foo(dk)
        }
    }

    neworder <- integer(Nedge(phy))
    j <- 0L
    foo(n + 1L)
    phy$edge <- phy$edge[neworder, ]
    if (!is.null(phy$edge.length))
        phy$edge.length <- phy$edge.length[neworder]
    attr(phy, "order") <- "cladewise"
    phy
}

## cherry.R (2009-05-10)

##     Number of Cherries and Null Models of Trees

## Copyright 2002-2009 Emmanuel Paradis

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

cherry <- function(phy)
{
    if (!inherits(phy, "phylo")) stop('object "phy" is not of class "phylo"')
    n <- length(phy$tip.label)
    nb.node <- phy$Nnode
    if (nb.node != n - 1) stop('"phy" is not fully dichotomous')
    if (n < 4) stop("not enough tips in your phylogeny for this analysis")
    cherry <- sum(tabulate(phy$edge[, 1][phy$edge[, 2] <= n]) == 2)
    small.n <- n < 20
    if (small.n) {
        P.yule <- f.cherry.yule(n, cherry)
        P.uniform <- f.cherry.uniform(n, cherry)
    }
    else {
        P.yule <- 2*(1 - pnorm(abs(cherry - n/3)/sqrt(2*n/45)))
        mu.unif <- n*(n - 1)/(2*(2*n - 5))
        sigma2.unif <- n*(n - 1)*(n - 4)*(n - 5)/(2*(2*n - 5)^2 * (2*n -7))
        P.uniform <- 2*(1 - pnorm(abs(cherry - mu.unif)/sqrt(sigma2.unif)))
    }
    cat("\nAnalysis of the Number of Cherries in a Tree\n\n")
    cat("Phylogenetic tree:", deparse(substitute(phy)), "\n")
    cat("Number of tips:", n, "\n")
    cat("Number of cherries:", cherry, "\n\n")
    cat("Null hypothesis: Yule model\n")
    cat("    P-value =", round(P.yule, 4), "\n\n")
    cat("Null hypothesis: uniform model\n")
    cat("    P-value =", round(P.uniform, 4), "\n\n")
    if (!small.n) cat("(P-values were computed using normal approximations)\n")
}

f.cherry.yule <- function(n, k)
{
    if (k == 0 || k > floor(n/2)) 0 else if (n == 4) if (k == 1) 2/3 else if (k == 2) 1/3 else 0
    else (1 - 2*(k - 1)/(n - 1))*f.cherry.yule(n - 1, k - 1) +
        2*k/(n - 1)*f.cherry.yule(n - 1, k)
}

f.cherry.uniform <- function(n, k)
{
    if (k == 0 || k > floor(n/2)) 0 else if (n == 4) if (k == 1) 4/5 else if (k == 2) 1/5 else 0
    else if (k == 1) 0 else (gamma(n + 1)*gamma(n - 2 + 1)*gamma(n - 4 + 1) * 2^(n-2*k)) /
        (gamma(n - 2*k + 1)*gamma(2*n - 4 + 1)*gamma(k + 1)*gamma(k - 2 + 1))
}

## rtree.R (2020-08-12)

##   Generates Trees

## Copyright 2004-2020 Emmanuel Paradis

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

rtree <- function(n, rooted = TRUE, tip.label = NULL, br = runif,
                  equiprob = FALSE, ...)
{
    bar <- # more efficient than sample.int()
        if (equiprob) function(n) as.integer(runif(1, 0, floor(n/2))) + 1L
        else function(n)  sample.int(n - 1L, 1, FALSE, NULL) #as.integer(runif(1, 0, n - 1L)) + 1L

    foo <- function(n, pos) {
        n1 <- bar(n)
        n2 <- n - n1
        po2 <- pos + 2L * n1 - 1L
        edge[c(pos, po2), 1L] <<- nod
        nod <<- nod + 1L
        if (n1 > 2L) {
            edge[pos, 2L] <<- nod
            foo(n1, pos + 1L)
        } else if (n1 == 2L) {
            edge[pos + 1:2, 1L] <<- edge[pos, 2L] <<- nod
            nod <<- nod + 1L
        }
        if (n2 > 2L) {
            edge[po2, 2L] <<- nod
            foo(n2, po2 + 1L)
        } else if (n2 == 2L) {
            edge[po2 + 1:2, 1L] <<- edge[po2, 2L] <<- nod
            nod <<- nod + 1L
        }
    }

    if (n < 1) stop("a tree must have at least 1 tip")
    if (n < 3 && !rooted) stop("an unrooted tree must have at least 3 tips")
    n <- as.integer(n)

    ## make the tip labels:
    if (is.null(tip.label)) {
        tip.label <- paste0("t", 1:n)
    } else {
        tip.label <- as.character(tip.label)
        Nlabs <- length(tip.label)
        if (!Nlabs) {
            warning("vector 'tip.label' of length zero: generating tip labels")
            tip.label <- paste0("t", seq_len(n))
        } else if (Nlabs > n) {
            warning("vector 'tip.label' longer than 'n': was shorten")
            tip.label <- tip.label[1:n]
        } else if (Nlabs < n) {
            warning("vector 'tip.label' shorter than 'n': was recycled")
            tip.label <- rep(tip.label, length.out = n)
        }
    }

    if (n == 1L) { # rooted case with n = 1
        nbr <- 1L
        edge <- matrix(2:1, 1L, 2L)
    } else { # all other cases
        nbr <- 2L * n - 3L + rooted
        edge <- matrix(NA_integer_, nbr, 2L)
    }

    if (rooted) {
        if (n == 2L) {
            edge[] <- c(3L, 3L, 1L, 2L)
        } else if (n == 3L) {
            edge[] <- c(4L, 5L, 5L, 4L, 5L, 1:3)
        } else if (n > 3L) {
            nod <- n + 1L
            foo(n, 1L)
            ## slightly more efficient than affecting the tip numbers in foo():
            i <- which(is.na(edge[, 2L]))
            edge[i, 2L] <- 1:n
        }
    } else { # unrooted case
        if (n == 3L) {
            edge[] <- c(4L, 4L, 4L, 1:3)
        } else if (n == 4L) {
            edge[] <- c(5L, 6L, 6L, 5L, 5L, 6L, 1:4)
        } else if (n == 5L) {
            edge[] <- c(6L, 6L, 6L, 7L, 7L, 8L, 8L, 1L, 2L, 7L, 3L, 8L, 4L, 5L)
        } else { # n > 5
            ## generate a rooted tree without branch lengths and unroot it
            phy <- rtree(n, tip.label = tip.label, br = NULL, equiprob = equiprob, ...)
            phy <- .unroot_ape(phy, n)
        }
    }
    if (!exists("phy", inherits = FALSE)) {
        phy <- list(edge = edge, tip.label = sample(tip.label))
        phy$Nnode <- if (n == 1L) 1L else n - 2L + as.integer(rooted)
        class(phy) <- "phylo"
        attr(phy, "order") <- "cladewise"
    }
    if (!is.null(br)) {
        phy$edge.length <-
            if (is.function(br)) br(nbr, ...) else rep(br, length.out = nbr)
    }
    phy
}

rcoal <- function(n, tip.label = NULL, br = "coalescent", ...)
{
    n <- as.integer(n)
    nbr <- 2*n - 2
    edge <- matrix(NA, nbr, 2)
    ## coalescence times by default:
    x <- if (is.character(br)) 2*rexp(n - 1)/(as.double(n:2) * as.double((n - 1):1))
    else if (is.numeric(br)) rep(br, length.out = n - 1) else br(n - 1, ...)
    if (n == 2) {
        edge[] <- c(3L, 3L, 1:2)
        edge.length <- rep(x, 2)
    } else if (n == 3) {
        edge[] <- c(4L, 5L, 5L, 4L, 5L, 1:3)
        edge.length <- c(x[c(2, 1, 1)], sum(x))
    } else {
        edge.length <- numeric(nbr)
        h <- numeric(2*n - 1)
        node.height <- cumsum(x)
        pool <- 1:n
        nextnode <- 2L*n - 1L
        for (i in 1:(n - 1)) {
            y <- sample(pool, size = 2)
            ind <- (i - 1)*2 + 1:2
            edge[ind, 2] <- y
            edge[ind, 1] <- nextnode
            edge.length[ind] <- node.height[i] - h[y]
            h[nextnode] <- node.height[i]
            pool <- c(pool[! pool %in% y], nextnode)
            nextnode <- nextnode - 1L
        }
    }
    phy <- list(edge = edge, edge.length = edge.length)
    if (is.null(tip.label))
        tip.label <- paste("t", 1:n, sep = "")
    phy$tip.label <- sample(tip.label)
    phy$Nnode <- n - 1L
    class(phy) <- "phylo"
    phy <- reorder(phy)
    ## to avoid crossings when converting with as.hclust:
    phy$edge[phy$edge[, 2] <= n, 2] <- 1:n
    phy
}

rmtree <- function(N, n, rooted = TRUE, tip.label = NULL, br = runif, equiprob = FALSE, ...)
{
    a <- replicate(N, rtree(n, rooted = rooted, tip.label =  tip.label,
                            br = br, equiprob = equiprob, ...),
                   simplify = FALSE)
    class(a) <- "multiPhylo"
    a
}

stree <- function(n, type = "star", tip.label = NULL)
{
    type <- match.arg(type, c("star", "balanced", "left", "right"))
    n <- as.integer(n)
    if (type == "star") {
        N <- n
        m <- 1L
    } else {
        m <- n - 1L
        N <- n + m - 1L
    }
    edge <- matrix(0L, N, 2)

    switch(type, "star" = {
        edge[, 1] <- n + 1L
        edge[, 2] <- 1:n
    }, "balanced" = {
        if (log2(n) %% 1)
            stop("'n' is not a power of 2: cannot make a balanced tree")
        foo <- function(node, size) {
            if (size == 2) {
                edge[c(i, i + 1L), 1L] <<- node
                edge[c(i, i + 1L), 2L] <<- c(nexttip, nexttip + 1L)
                nexttip <<- nexttip + 2L
                i <<- i + 2L
            } else {
                for (k in 1:2) { # do the 2 subclades
                    edge[i, ] <<- c(node, nextnode)
                    nextnode <<- nextnode + 1L
                    i <<- i + 1L
                    foo(nextnode - 1L, size/2)
                }
            }
        }
        i <- 1L
        nexttip <- 1L
        nextnode <- n + 2L
        foo(n + 1L, n)
    }, "left" = {
        edge[c(seq.int(from = 1, to = N - 1, by = 2), N), 2L] <- 1:n
        nodes <- (n + 1L):(n + m)
        edge[seq.int(from = 2, to = N - 1, by = 2), 2L] <- nodes[-1]
        edge[, 1L] <- rep(nodes, each = 2)
    }, "right" = {
        nodes <- (n + 1L):(n + m)
        edge[, 1L] <- c(nodes, rev(nodes))
        edge[, 2L] <- c(nodes[-1], 1:n)
    })

    if (is.null(tip.label))
        tip.label <- paste("t", 1:n, sep = "")
    phy <- list(edge = edge, tip.label = tip.label, Nnode = m)
    class(phy) <- "phylo"
    attr(phy, "order") <- "cladewise"
    phy
}

## dist.topo.R (2020-07-20)

##      Topological Distances, Tree Bipartitions,
##   Consensus Trees, and Bootstrapping Phylogenies

## Copyright 2005-2020 Emmanuel Paradis, 2016-2017 Klaus Schliep

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

.getTreesFromDotdotdot <- function(...)
{
    obj <- list(...)
    if (length(obj) == 1 && !inherits(obj[[1]], "phylo")) obj <- obj[[1]]
    obj
}

dist.topo <- function(x, y = NULL, method = "PH85")
{
    method <- match.arg(method, c("PH85", "score"))
    if (!is.null(y)) x <- c(x, y)
    testroot <- any(is.rooted(x))
    n <- length(x) # number of trees
    res <- numeric(n * (n - 1) /2)
    nms <- names(x)
    if (is.null(nms)) nms <- paste0("tree", 1:n)

    if (method == "PH85") {
        if (testroot)
            warning("Some trees were rooted: topological distances may be spurious.")

        x <- .compressTipLabel(x)
        ntip <- length(attr(x, "TipLabel"))
        nnode <- sapply(x, Nnode)

        foo <- function(phy, ntip) {
            phy <- reorder(phy, "postorder")
            ans <- ONEwise(bipartition2(phy$edge, ntip))
            sapply(ans, paste, collapse = "\r")
        }

        x <- lapply(x, foo, ntip = ntip)

        k <- 0L
        for (i in 1:(n - 1)) {
            y <- x[[i]]
            m1 <- nnode[i]
            for (j in (i + 1):n) {
                z <- x[[j]]
                k <- k + 1L
                res[k] <- m1 + nnode[j] - 2 * sum(z %in% y)
            }
        }
    } else { # method == "score"
        k <- 0L
        for (i in 1:(n - 1)) {
            for (j in (i + 1):n) {
                k <- k + 1L
                ## still very slow......
                res[k] <- .dist.topo.score(x[[i]], x[[j]])
            }
        }
    }

    attr(res, "Size") <- n
    attr(res, "Labels") <- nms
    attr(res, "Diag") <- attr(res, "Upper") <- FALSE
    attr(res, "method") <- method
    class(res) <- "dist"
    res
}

.dist.topo.score <- function(x, y)
{
    if (is.null(x$edge.length) || is.null(y$edge.length))
        stop("trees must have branch lengths for branch score distance.")
    nx <- length(x$tip.label)
    x <- reorder.phylo(unroot(x), "postorder")
    y <- reorder.phylo(unroot(y), "postorder")
    ##bp1 <- .Call(bipartition, x$edge, nx, x$Nnode)
    bp1 <- bipartition2(x$edge, nx)
    bp1 <- lapply(bp1, function(xx) sort(x$tip.label[xx]))
    ny <- length(y$tip.label) # fix by Otto Cordero
    ## fix by Tim Wallstrom:
    bp2.tmp <- bipartition2(y$edge, ny)
    ##bp2.tmp <- .Call(bipartition, y$edge, ny, y$Nnode)
    bp2 <- lapply(bp2.tmp, function(xx) sort(y$tip.label[xx]))
    bp2.comp <- lapply(bp2.tmp, function(xx) setdiff(1:ny, xx))
    bp2.comp <- lapply(bp2.comp, function(xx) sort(y$tip.label[xx]))
    ## End
    q1 <- length(bp1)
    q2 <- length(bp2)

    dT <- 0
    found1 <- FALSE
    found2 <- logical(q2)
    found2[1] <- TRUE
    for (i in 2:q1) {
        for (j in 2:q2) {
            if (identical(bp1[[i]], bp2[[j]]) | identical(bp1[[i]], bp2.comp[[j]])) {
                dT <- dT + (x$edge.length[which(x$edge[, 2] == nx + i)] -
                            y$edge.length[which(y$edge[, 2] == ny + j)])^2
                found1 <- found2[j] <- TRUE
                break
            }
        }
        if (found1) found1 <- FALSE
        else dT <- dT + (x$edge.length[which(x$edge[, 2] == nx + i)])^2
    }
    if (!all(found2))
        dT <- dT + sum((y$edge.length[y$edge[, 2] %in% (ny + which(!found2))])^2)
    sqrt(dT)
}

.compressTipLabel <- function(x, ref = NULL)
{
    ## 'x' is a list of objects of class "phylo" possibly with no class
    if (!is.null(attr(x, "TipLabel"))) return(x)
    if (is.null(ref)) ref <- x[[1]]$tip.label
    n <- length(ref)
    if (length(unique(ref)) != n)
        stop("some tip labels are duplicated in tree no. 1")

    ## serious improvement by Joseph W. Brown!
    relabel <- function (y) {
        label <- y$tip.label
        if (!identical(label, ref)) {
            if (length(label) != length(ref))
                stop("one tree has a different number of tips")
            ilab <- match(label, ref)
            if (any(is.na(ilab)))
                stop("one tree has different tip labels")
            ie <- match(1:n, y$edge[, 2])
            y$edge[ie, 2] <- ilab
        }
        y$tip.label <- NULL
        y
    }
    x <- unclass(x) # another killer improvement by Tucson's hackathon (1/2/2013)
    x <- lapply(x, relabel)
    attr(x, "TipLabel") <- ref
    class(x) <- "multiPhylo"
    x
}

prop.part <- function(..., check.labels = TRUE)
{
    obj <- .getTreesFromDotdotdot(...)
    ntree <- length(obj)
    if (ntree == 1) check.labels <- FALSE
    if (check.labels) obj <- .compressTipLabel(obj) # fix by Klaus Schliep (2011-02-21)
    class(obj) <- NULL # fix by Klaus Schliep (2014-03-06)
    for (i in 1:ntree) storage.mode(obj[[i]]$Nnode) <- "integer"
    class(obj) <- "multiPhylo"
    obj <- reorder(obj, "postorder")
# the following line should not be necessary any more
#    obj <- .uncompressTipLabel(obj) # fix a bug (2010-11-18)
    nTips <- length(obj[[1]]$tip.label)
    clades <- prop_part2(obj, nTips)
    attr(clades, "labels") <- obj[[1]]$tip.label
    clades
}

print.prop.part <- function(x, ...)
{
    if (is.null(attr(x, "labels"))) {
        for (i in 1:length(x)) {
            cat("==>", attr(x, "number")[i], "time(s):")
            print(x[[i]], quote = FALSE)
        }
    } else {
        for (i in 1:length(attr(x, "labels")))
          cat(i, ": ", attr(x, "labels")[i], "\n", sep = "")
        cat("\n")
        for (i in 1:length(x)) {
            cat("==>", attr(x, "number")[i], "time(s):")
            print(x[[i]], quote = FALSE)
        }
    }
}

summary.prop.part <- function(object, ...) attr(object, "number")

plot.prop.part <- function(x, barcol = "blue", leftmar = 4, col = "red", ...)
{
    if (is.null(attr(x, "labels")))
      stop("cannot plot this partition object; see ?prop.part for details.")
    L <- length(x)
    n <- length(attr(x, "labels"))
    layout(matrix(1:2, 2, 1), heights = c(1, 3))
    par(mar = c(0.1, leftmar, 0.1, 0.1))
    one2L <- seq_len(L)
    plot(one2L - 0.5, attr(x, "number"), type = "h", col = barcol, xlim = c(0, L),
         xaxs = "i", xlab = "", ylab = "Frequency", xaxt = "n", bty = "n", ...)
    M <- matrix(0L, L, n)
    for (i in one2L) M[i, x[[i]]] <- 1L
    image.default(one2L, 1:n, M, col = c("white", col), xlab = "", ylab = "", yaxt = "n")
    mtext(attr(x, "labels"), side = 2, at = 1:n, las = 1)
}

### by Klaus (2016-03-23):
prop.clades <- function(phy, ..., part = NULL, rooted = FALSE)
{
    if (is.null(part)) {
        obj <- .getTreesFromDotdotdot(...)
        ## avoid double counting of edges if trees are rooted
        if (!rooted) obj <- lapply(obj, unroot)
        part <- prop.part(obj, check.labels = TRUE)
    }
    LABS <- attr(part, "labels")
    if (!identical(phy$tip.label, LABS)) {
        i <- match(phy$tip.label, LABS)
        j <- match(seq_len(Ntip(phy)), phy$edge[, 2])
        phy$edge[j, 2] <- i
        phy$tip.label <- LABS
    }
    bp <- prop.part(phy)
    if (!rooted) {
        ## avoid messing up the order and length if phy is rooted in some cases
        bp <- ONEwise(bp)
        part <- postprocess.prop.part(part)
    }
    pos <- match(bp, part)
    tmp <- which(!is.na(pos))
    n <- rep(NA_real_, phy$Nnode)
    n[tmp] <- attr(part, "number")[pos[tmp]]
    n
}

boot.phylo <-
    function(phy, x, FUN, B = 100, block = 1,
             trees = FALSE, quiet = FALSE,
             rooted = is.rooted(phy), jumble = TRUE,
             mc.cores = 1)
{
    if (is.null(dim(x)) || length(dim(x)) != 2)
        stop("the data 'x' must have two dimensions (e.g., a matrix or a data frame)")

    if (anyDuplicated(rownames(x)))
        stop("some labels are duplicated in the data: you won't be able to analyse tree bipartitions")

    boot.tree <- vector("list", B)
    y <- nc <- ncol(x)
    nr <- nrow(x)

    if (block > 1) {
        a <- seq(1, nc - 1, block)
        b <- seq(block, nc, block)
        y <- mapply(":", a, b, SIMPLIFY = FALSE)
        getBootstrapIndices <- function() unlist(sample(y, replace = TRUE))
    } else getBootstrapIndices <- function() sample.int(y, replace = TRUE)

    if (!quiet) {
        prefix <- "\rRunning bootstraps:      "
        suffix <- paste("/", B)
        updateProgress <- function(i) cat(prefix, i, suffix)
    }

    if (mc.cores == 1) {
        for (i in 1:B) {
            boot.samp <- x[, getBootstrapIndices()]
            if (jumble) boot.samp <- boot.samp[sample.int(nr), ]
            boot.tree[[i]] <- FUN(boot.samp)
            if (!quiet && !(i %% 100)) updateProgress(i)
        }
    } else {
        if (!quiet) cat("Running parallel bootstraps...")
        foo <- function(i) {
            boot.samp <- x[, getBootstrapIndices()]
            if (jumble) boot.samp <- boot.samp[sample.int(nr), ]
            FUN(boot.samp)
        }
        boot.tree <- mclapply(1:B, foo, mc.cores = mc.cores)
        if (!quiet) cat(" done.")
    }

    if (!quiet) cat("\nCalculating bootstrap values...")

    ## sort labels after mixed them up
    if (jumble) {
        boot.tree <- .compressTipLabel(boot.tree, ref = phy$tip.label)
        boot.tree <- .uncompressTipLabel(boot.tree)
        boot.tree <- unclass(boot.tree) # otherwise countBipartitions crashes
    }
    class(boot.tree) <- "multiPhylo"
    if (rooted) {
        pp <- prop.part(boot.tree)
        ans <- prop.clades(phy, part = pp, rooted = rooted)
    } else {
        phy <- reorder(phy, "postorder")
        ints <- phy$edge[, 2] > Ntip(phy)
        ans <- countBipartitions(phy, boot.tree)
        ans <- c(B, ans[order(phy$edge[ints, 2])])
    }

    if (!quiet) cat(" done.\n")

    if (trees) ans <- list(BP = ans, trees = boot.tree)
    ans
}

### The next function transforms an object of class "prop.part" so
### that the vectors which are identical in terms of split are aggregated.
### For instance if n = 5 tips, 1:2 and 3:5 actually represent the same
### split though they are different clades. The aggregation is done
### arbitrarily. The call to ONEwise() insures that all splits include
### the first tip.
### (rewritten by Klaus)
postprocess.prop.part <- function(x)
{
    w <- attr(x, "number")
    labels <- attr(x, "labels")

    x <- ONEwise(x)
    drop <- duplicated(x)

    if (any(drop)) {
        ind1 <- match(x[drop], x)
        ind2 <- which(drop)
        for (i in seq_along(ind2))
            w[ind1[i]] <- w[ind1[i]] + w[ind2[i]]
        x <- x[!drop]
        w <- w[!drop]
    }
    attr(x, "number") <- w
    attr(x, "labels") <- labels
    class(x) <- "prop.part"
    x
}

### This function changes an object of class "prop.part" so that they
### all include the first tip. For instance if n = 5 tips, 3:5 is
### changed to 1:2.
ONEwise <- function(x)
{
    v <- seq_along(x[[1L]])
    for (i in 2:length(x)) {
        y <- x[[i]]
        if (y[1] != 1) x[[i]] <- v[-y]
    }
    x
}

consensus <- function(..., p = 1, check.labels = TRUE)
{
    foo <- function(ic, node) {
        ## ic: index of 'pp'
        ## node: node number in the final tree
        pool <- pp[[ic]]
        if (ic < m) {
            for (j in (ic + 1):m) {
                wh <- match(pp[[j]], pool)
                if (!any(is.na(wh))) {
                    edge[pos, 1] <<- node
                    pool <- pool[-wh]
                    edge[pos, 2] <<- nextnode <<- nextnode + 1L
                    pos <<- pos + 1L
                    foo(j, nextnode)
                }
            }
        }
        size <- length(pool)
        if (size) {
            ind <- pos:(pos + size - 1)
            edge[ind, 1] <<- node
            edge[ind, 2] <<- pool
            pos <<- pos + size
        }
    }

    obj <- .getTreesFromDotdotdot(...)

    if (!is.null(attr(obj, "TipLabel")))
        labels <- attr(obj, "TipLabel")
    else {
        labels <- obj[[1]]$tip.label
        if (check.labels) obj <- .compressTipLabel(obj)
    }
    ntree <- length(obj)
    ## Get all observed partitions and their frequencies:
    pp <- prop.part(obj, check.labels = FALSE)
    ## Drop the partitions whose frequency is less than 'p':
    if (p == 0.5) p <- 0.5000001 # avoid incompatible splits
    pp <- pp[attr(pp, "number") >= p * ntree]
    ## Get the order of the remaining partitions by decreasing size:
    ind <- order(lengths(pp), decreasing = TRUE)
    pp <- pp[ind]
    n <- length(labels)
    m <- length(pp)
    edge <- matrix(0L, n + m - 1, 2)
    if (m == 1) {
        edge[, 1] <- n + 1L
        edge[, 2] <- 1:n
    } else {
        nextnode <- n + 1L
        pos <- 1L
        foo(1, nextnode)
    }
    structure(list(edge = edge, tip.label = labels,
              Nnode = m), class = "phylo")
}

## birthdeath.R (2012-04-20)

##   Estimation of Speciation and Extinction Rates
##             with Birth-Death Models

## birthdeath: standard model
## bd.ext: extended version

## Copyright 2002-2012 Emmanuel Paradis

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

birthdeath <- function(phy)
{
    if (!inherits(phy, "phylo")) stop('object "phy" is not of class "phylo"')
    N <- length(phy$tip.label)
    x <- c(NA, branching.times(phy))
    dev <- function(a, r) {
        if (r < 0 || a > 1) return(1e100)
        -2 * (lfactorial(N - 1)
              + (N - 2) * log(r)
              + r * sum(x[3:N])
              + N * log(1 - a)
              - 2 * sum(log(exp(r * x[2:N]) - a)))
    }
    out <- nlm(function(p) dev(p[1], p[2]), c(0.1, 0.2), hessian = TRUE)
    if (out$estimate[1] < 0) {
        out <- nlm(function(p) dev(0, p), 0.2, hessian = TRUE)
        para <- c(0, out$estimate)
        inv.hessian <- try(solve(out$hessian))
        se <-
            if (class(inv.hessian) == "try-error") NA
            else sqrt(diag(inv.hessian))
        se <- c(0, se)
    }
    else {
        para <- out$estimate
        inv.hessian <- try(solve(out$hessian))
        se <-
            if (class(inv.hessian) == "try-error") c(NA, NA)
            else sqrt(diag(inv.hessian))
    }
    Dev <- out$minimum

    ## 95% profile likelihood CIs

    ## which: index of the parameter (1 or 2)
    ## s: sign of the increment (-1 or +1)
    foo <- function(which, s) {
        i <- 0.1

        if (which == 1) {
            p <- para[1] + s * i
            bar <- function() dev(p, para[2])
        } else { # which == 2
            p <- para[2] + s * i
            bar <- function() dev(para[1], p)
        }

        while (i > 1e-9) {
            while (bar() < Dev + 3.84) p <- p + s * i
            p <- p - s * i
            i <- i / 10
        }
        p
    }

    CI <- mapply(foo, c(1, 2, 1, 2), c(-1, -1, 1, 1))
    dim(CI) <- c(2, 2)

    names(para) <- names(se) <- rownames(CI) <- c("d/b", "b-d")
    colnames(CI) <- c("lo", "up")
    obj <- list(tree = deparse(substitute(phy)), N = N,
                dev = Dev, para = para, se = se, CI = CI)
    class(obj) <- "birthdeath"
    obj
}

print.birthdeath <- function(x, ...)
{
    cat("\nEstimation of Speciation and Extinction Rates\n")
    cat("            with Birth-Death Models\n\n")
    cat("     Phylogenetic tree:", x$tree, "\n")
    cat("        Number of tips:", x$N, "\n")
    cat("              Deviance:", x$dev, "\n")
    cat("        Log-likelihood:", -(x$dev)/2, "\n")
    cat("   Parameter estimates:\n")
    cat("      d / b =", x$para[1], "  StdErr =", x$se[1], "\n")
    cat("      b - d =", x$para[2], "  StdErr =", x$se[2], "\n")
    cat("   (b: speciation rate, d: extinction rate)\n")
    cat("   Profile likelihood 95% confidence intervals:\n")
    cat("      d / b: [", x$CI[1, 1], ", ", x$CI[1, 2], "]", "\n", sep = "")
    cat("      b - d: [", x$CI[2, 1], ", ", x$CI[2, 2], "]", "\n\n", sep = "")
}

bd.ext <- function(phy, S, conditional = TRUE)
{
    if (!inherits(phy, "phylo"))
        stop('object "phy" is not of class "phylo"')
    if (!is.null(names(S))) {
        if (all(names(S) %in% phy$tip.label)) S <- S[phy$tip.label]
        else warning('the names of argument "S" and the tip labels
did not match: the former were ignored.')
    }
    N <- length(S)
    x <- branching.times(phy)
    x <- c(x[1], x)
    trm.br <- phy$edge.length[phy$edge[, 2] <= N]
    if (conditional) {
        dev <- function(a, r) {
            if (a >= 1 || a < 0 || r <= 0) return(1e50)
            ert <- exp(r * trm.br)
            zeta <- (ert - 1)/(ert - a)
            -2 * (lfactorial(N - 1)
                  + (N - 2) * log(r)
                  + N * log(1 - a)
                  + 2 * r * sum(x[2:N])
                  - 2 * sum(log(exp(r * x[2:N]) - a))
                  + sum(log(1 - zeta) + (S - 1)*log(zeta)))
        }
    } else {
        dev <- function(a, r) {
            if (a >= 1 || a < 0 || r <= 0) return(1e50)
            -2 * (lfactorial(N - 1)
                  + (N - 2) * log(r)
                  + (3 * N) * log(1 - a)
                  + 2 * r * sum(x[2:N])
                  - 2 * sum(log(exp(r * x[2:N]) - a))
                  + r * sum(trm.br)
                  + sum((S - 1) * log(exp(r * trm.br) - 1))
                  - sum((S + 1) * log(exp(r * trm.br) - a)))
        }
    }
    out <- nlm(function(p) dev(p[1], p[2]), c(0.1, 0.2), hessian = TRUE)
    para <- out$estimate
    se <- sqrt(diag(solve(out$hessian)))
    Dev <- out$minimum
    cat("\nExtended Version of the Birth-Death Models to\n")
    cat("    Estimate Speciation and Extinction Rates\n\n")
    cat("    Data: phylogenetic:", deparse(substitute(phy)), "\n")
    cat("             taxonomic:", deparse(substitute(S)), "\n")
    cat("        Number of tips:", N, "\n")
    cat("              Deviance:", Dev, "\n")
    cat("        Log-likelihood:", -Dev/2, "\n")
    cat("   Parameter estimates:\n")
    cat("      d / b =", para[1], "  StdErr =", se[1], "\n")
    cat("      b - d =", para[2], "  StdErr =", se[2], "\n")
    cat("   (b: speciation rate, d: extinction rate)\n")
}

## skylineplot.R (2004-07-4)

##   Various methods to plot skyline objects (= skyline plots)

## Copyright 2002-2004 Korbinian Strimmer

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

# plot skyline
plot.skyline <- function(x, show.years=FALSE, subst.rate, present.year, ...)
{
  if (class(x) != "skyline")
    stop("object \"x\" is not of class \"skyline\"")
  t <- x$time
  m <- x$population.size
  lm <- length(m)

  if (show.years)
  {
    plot((-c(0,t))/subst.rate+present.year,c(m,m[lm]),type="s",
     xlab="time (years)",ylab="effective population size",log="y", ...)

  }
  else
  {
    plot(c(0,t),c(m,m[lm]),type="s", xlim=c(t[lm],0),
     xlab="time (past to present in units of substitutions)",ylab="effective population size",log="y", ...)
  }

}

# plot another skyline plot on top
lines.skyline <- function(x, show.years=FALSE, subst.rate, present.year, ...)
{
  if (class(x) != "skyline")
    stop("object \"x\" is not of class \"skyline\"")
  t <- x$time
  m <- x$population.size
  lm <- length(m)


  if (show.years)
  {
    lines((-c(0,t))/subst.rate+present.year,c(m,m[lm]),type="s", ...)
  }
  else
  {
    lines(c(0,t),c(m,m[lm]),type="s", ...)
  }
}


# convenience short cut (almost compatible with APE 0.1)
skylineplot <- function(z, ...) plot(skyline(z, ...))


#input: phylogenetic tree
skylineplot.deluxe <- function(tree, ...)
{
  if (class(tree) != "phylo")
    stop("object \"tree\" is not of class \"phylo\"")

  ci <- coalescent.intervals(tree)
  classic <- skyline(ci)
  generalized <- skyline(ci, -1)
  plot(classic,col=grey(.8), ...)
  lines(generalized, ...)
  return(generalized)
}

## write.nexus.data.R (2018-06-23)

##   Write Character Data in NEXUS Format

## Copyright 2006-2015 Johan Nylander, Emmanuel Paradis, 2018 Thomas Guillerme

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

write.nexus.data <-
    function(x, file, format = "dna", datablock = TRUE,
             interleaved = TRUE, charsperline = NULL,
             gap = NULL, missing = NULL)
{
### TODO: Standard data, mixed data, nice indent

    format <- match.arg(toupper(format), c("DNA", "PROTEIN", "STANDARD", "CONTINUOUS"))

    if (inherits(x, "DNAbin") && format != "DNA") {
        format <- "DNA"
        warning("object 'x' is of class DNAbin: format forced to DNA")
    }
    if (inherits(x, "AAbin") && format != "PROTEIN") {
        format <- "PROTEIN"
        warning("object 'x' is of class AAbin: format forced to PROTEIN")
    }

    indent          <- "  "  # Two blanks
    maxtax          <- 5     # Max nr of taxon names to be printed on a line
    defcharsperline <- 80    # Default nr of characters per line if interleaved
    defgap          <- "-"   # Default gap character
    defmissing      <- "?"   # Default missing data character

    if (is.matrix(x)) {
        if (inherits(x, "DNAbin")) x <- as.list(x) else {
            xbak <- x
            x <- vector("list", nrow(xbak))
            for (i in seq_along(x)) x[[i]] <- xbak[i, ]
            names(x) <- rownames(xbak)
            rm(xbak)
        }
    }

    ntax <- length(x)
    nchars <- length(x[[1]])

    zz <- file(file, "w")

    if (is.null(names(x))) names(x) <- as.character(1:ntax)

    fcat <- function(..., file = zz)
        cat(..., file = file, sep = "", append = TRUE)

    find.max.length <- function(x) max(nchar(x))

    print.matrix <- function(x, dindent = "    ", collapse = "") {
        Names <- names(x)
        printlength <- find.max.length(Names) + 2
        if (!interleaved) {
            for (i in seq_along(x)) {
                sequence <- paste(x[[i]], collapse = collapse)
                taxon <- Names[i]
                thestring <- sprintf("%-*s%s%s", printlength, taxon, dindent, sequence)
                fcat(indent, indent, thestring, "\n")
            }
        } else {
            ntimes <- ceiling(nchars/charsperline)
            start <- 1
            end <- charsperline
            for (j in seq_len(ntimes)) {
                for (i in seq_along(x)) {
                    sequence <- paste(x[[i]][start:end], collapse = collapse)
                    taxon <- Names[i]
                    thestring <- sprintf("%-*s%s%s", printlength, taxon, dindent, sequence)
                    fcat(indent, indent, thestring, "\n")
                }
                if (j < ntimes) fcat("\n")
                start <- start + charsperline
                end <- end + charsperline
                if (end > nchars) end <- nchars
            }
        }
    }

    if (inherits(x, "DNAbin") || inherits(x, "AAbin")) x <- as.character(x)

    fcat("#NEXUS\n[Data written by write.nexus.data.R, ", date(), "]\n")

    NCHAR <- paste("NCHAR=", nchars, sep = "")
    NTAX <- paste0("NTAX=", ntax)
    DATATYPE <- paste0("DATATYPE=", format) # fix by Robin Cristofari (2015-02-04)

    if (is.null(charsperline)) {
        if (nchars <= defcharsperline) {
            charsperline <- nchars
            interleaved <- FALSE
        } else charsperline <- defcharsperline
    }

    if (is.null(missing)) missing <- defmissing
    MISSING <- paste0("MISSING=", missing)

    if (is.null(gap)) gap <- defgap
    GAP <- paste0("GAP=", gap)

    INTERLEAVE <- if (interleaved) "INTERLEAVE=YES" else "INTERLEAVE=NO"

    if (datablock) {
        fcat("BEGIN DATA;\n")
        fcat(indent, "DIMENSIONS ", NTAX, " ", NCHAR, ";\n")

        ## <FIXME> only DNA and PROTEIN is supported for the moment, so the
        ## following 'if' is not needed
        ## if (format %in% c("DNA", "PROTEIN")) # from Francois Michonneau (2009-10-02)
        if(format != "STANDARD") {
            fcat(indent, "FORMAT", " ", DATATYPE, " ", MISSING, " ", GAP, " ", INTERLEAVE, ";\n")
        } else {
            fcat(indent, "FORMAT", " ", DATATYPE, " ", MISSING, " ", GAP, " ", INTERLEAVE, " symbols=\"0123456789\";\n")
        }
        ## </FIXME>

        fcat(indent, "MATRIX\n")
        if(format != "CONTINUOUS") {
            print.matrix(x)
        } else {
            print.matrix(x, collapse = "\t")
        }
        fcat(indent, ";\nEND;\n\n")
    } else {
        fcat("BEGIN TAXA;\n")
        fcat(indent, "DIMENSIONS", " ", NTAX, ";\n")
        fcat(indent, "TAXLABELS\n")
        fcat(indent, indent)
        j <- 0
        for (i in seq_len(ntax)) {
            fcat(names(x[i]), " ")
            j <- j + 1
            if (j == maxtax) {
                fcat("\n", indent, indent)
                j <- 0
            }
        }
        fcat("\n", indent, ";\n")
        fcat("END;\n\nBEGIN CHARACTERS;\n")
        fcat(indent, "DIMENSIONS", " ", NCHAR, ";\n")

        ## <FIXME> only DNA and PROTEIN is supported for the moment, so the
        ## following 'if' is not needed
        ## if (format %in% c("DNA", "PROTEIN"))
        if(format != "STANDARD") {
            fcat(indent, "FORMAT", " ", MISSING, " ", GAP, " ", DATATYPE, " ", INTERLEAVE, ";\n")
        } else {
            fcat(indent, "FORMAT", " ", MISSING, " ", GAP, " ", DATATYPE, " ", INTERLEAVE, " symbols=\"0123456789\";\n")
        }
        ## </FIXME>

        fcat(indent,"MATRIX\n")
        if(format != "CONTINUOUS") {
            print.matrix(x)
        } else {
            print.matrix(x, collapse = "\t")
        }
        fcat(indent, ";\nEND;\n\n")
    }
    close(zz)
}

## is.monophyletic.R (2020-07-10)

##   Test Monophyly

## Copyright 2009-2020 Johan Nylander and Emmanuel Paradis

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

is.monophyletic <-
    function(phy, tips, reroot = !is.rooted(phy), plot = FALSE, ...)
{
    if (!inherits(phy, "phylo"))
        stop("object 'phy' is not of class 'phylo'")
    n <- length(phy$tip.label)
    ROOT <- n + 1L
    if (is.numeric(tips)) {
        if (any(tips > n))
            stop("incorrect tip#: should not be greater than the number of tips")
        tips <- as.integer(tips)
    }
    if (is.character(tips)) {
        tips <- match(tips, phy$tip.label)
        if (anyNA(tips)) stop("some tip label(s) not found in the tree")
    }
    tips <- sort(tips) # fix (2020-07-10)
    if (length(tips) == 1L || length(tips) ==  n) return(TRUE)

    if (reroot) {
        outgrp <- phy$tip.label[-tips][1]
        phy <- root(phy, outgroup = outgrp, resolve.root = TRUE)
        rerooted <- TRUE
    } else rerooted <- FALSE

    phy <- reorder(phy)

    seq.nod <- .Call(seq_root2tip, phy$edge, n, phy$Nnode)
    sn <- seq.nod[tips]
    newroot <- ROOT
    i <- 2
    repeat {
        x <- unique(unlist(lapply(sn, "[", i)))
        if (length(x) != 1) break
        newroot <- x
        i <- i + 1
    }
    desc <- which(unlist(lapply(seq.nod, function(x) any(x %in% newroot))))
    if (plot) {
        zoom(phy, tips, subtree = FALSE, ...)
        if (rerooted)
            mtext("Input tree arbitrarily rerooted", side = 1, cex = 0.9)
    }
    ## assuming that both vectors are sorted:
    identical(tips, desc)
}

## subtrees.R (2008-04-14)

##  All subtrees of a Phylogenetic Tree

## Copyright 2008 Damien de Vienne

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

subtrees<-function(tree, wait = FALSE)
{
N.tip<-Ntip (tree)
N.node<-Nnode(tree)
limit<-N.tip+N.node
sub<-list(N.node)
u<-0

  for (k in (N.tip+1):limit)
  {
 u<-u+1
	if (wait==TRUE) cat("wait... Node",u,"out of", N.node, "treated\n")
  fils<-NULL
  pere<-res <- k
	repeat
	{
	for (i in 1: length(pere)) fils<-c(fils, tree$edge[,2][tree$edge[,1]==pere[i]])
	res<-c(res, fils)
      pere<-fils
	fils<-NULL
	if (length(pere)==0) break
	}

  len<-res[res>N.tip]
   if (u==1) {
	tree2<-tree
	len<-(N.tip+1):limit
	}
   else {
  len.tip<-res[res<N.tip+1]
  vec<-1:length(tree$tip.label)
  len.tip.stay<-setdiff(vec, len.tip)
  tree2<-drop.tip(tree, len.tip.stay)
	  }
  sub[[u]]<-tree2
  sub[[u]]$name<-k
  #sub[[u]]$name<-tree2$node.label[1]
  sub[[u]]$Ntip<-Ntip(tree2)
  sub[[u]]$Nnode<-Nnode(tree2)
  if (is.null(tree$node.label))
  	sub[[u]]$node.label<-len

  }
return(sub)
cat("\n")
}

## mantel.test.R (2019-02-25)

##   Mantel Test for Similarity of Two Matrices

## Copyright 2002-2011 Ben Bolker and Julien Claude, 2019 Emmanuel Paradis

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

perm.rowscols <- function(m1, n)
{
    s <- sample(1:n)
    m1[s, s]
}

## calculate the Mantel z-statistic for two square matrices m1 and m2
## old code:
## mant.zstat <- function(m1, m2) sum(lower.triang(m1 * m2))
## modified by EP following suggestion by Andrzej Galecki (2018-02-07)
mant.zstat <- function(m1, m2) {
    diag(m1) <- diag(m2) <- 0 # in case the diagonals are not 0
    sum(m1 * m2)/2
}

mantel.test <- function(m1, m2, nperm = 999, graph = FALSE,
                        alternative = "two.sided", ...)
{
    alternative <- match.arg(alternative, c("two.sided", "less", "greater"))
    n <- nrow(m1)
    realz <- mant.zstat(m1, m2)
    nullstats <- replicate(nperm, mant.zstat(m1, perm.rowscols(m2, n)))
    pval <- switch(alternative,
                   "two.sided" = 2 * min(sum(nullstats >= realz), sum(nullstats <= realz)),
                   "less" = sum(nullstats <= realz),
                   "greater" = sum(nullstats >= realz))
    pval <- (pval + 1) / (nperm + 1) # 'realz' is included in 'nullstats'
    if (alternative == "two.sided" && pval > 1) pval <- 1
    if (graph) {
        plot(density(nullstats), type = "l", ...)
        abline(v = realz)
    }
    list(z.stat = realz, p = pval, alternative = alternative)
}

## nodelabels.R (2018-08-25)

##   Labelling Trees

## Copyright 2004-2018 Emmanuel Paradis, 2006 Ben Bolker, and 2006 Jim Lemon

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

## from JL:
## floating.pie() from plotrix with two changes:
## (1) aspect ratio fixed, so pies will appear circular
##     (`radius' is the radius in user coordinates along the x axis);
## (2) zero values allowed (but not negative).

floating.pie.asp <- function(xpos, ypos, x, edges = 200, radius = 1,
                             col = NULL, startpos = 0, ...)
{
    u <- par("usr")
    user.asp <- diff(u[3:4])/diff(u[1:2])
    p <- par("pin")
    inches.asp <- p[2]/p[1]
    asp <- user.asp/inches.asp
    if (!is.numeric(x) || any(is.na(x) | x < 0))
        stop("floating.pie: x values must be non-negative")
    x <- c(0, cumsum(x)/sum(x))
    dx <- diff(x)
    nx <- length(dx)
    col <- if (is.null(col)) rainbow(nx) else rep_len(col, nx)
    ## next a fix from Klaus to avoid a "3-o'clock" segment on pies with
    ## only one proportion equal to 1:
    if (length(i <- which(dx == 1))) {
        symbols(xpos, ypos, circles = radius, inches = FALSE, add = TRUE,
                fg = par("fg"), bg = col[i]) # suggested by Liam
    } else {
        bc <- 2 * pi * (x[1:nx] + dx/2) + startpos
        for (i in seq_len(nx)) {
            n <- max(2, floor(edges * dx[i]))
            t2p <- 2 * pi * seq(x[i], x[i + 1], length = n) + startpos
            xc <- c(cos(t2p) * radius + xpos, xpos)
            yc <- c(sin(t2p) * radius*asp + ypos, ypos)
            polygon(xc, yc, col = col[i], ...)
        }
    }
}

BOTHlabels <- function(text, sel, XX, YY, adj, frame, pch, thermo,
                       pie, piecol, col, bg, horiz, width, height, ...)
{
    if (missing(text)) text <- NULL
    if (length(adj) == 1) adj <- c(adj, 0.5)
    if (is.null(text) && is.null(pch) && is.null(thermo) && is.null(pie))
        text <- as.character(sel)
    frame <- match.arg(frame, c("rect", "circle", "none"))
    args <- list(...)
    CEX <- if ("cex" %in% names(args)) args$cex else par("cex")
    if (frame != "none" && !is.null(text)) {
        if (frame == "rect") {
            width <- strwidth(text, units = "inches", cex = CEX)
            height <- strheight(text, units = "inches", cex = CEX)
            if ("srt" %in% names(args)) {
                args$srt <- args$srt %% 360 # just in case srt >= 360
                if (args$srt == 90 || args$srt == 270) {
                    tmp <- width
                    width <- height
                    height <- tmp
                } else if (args$srt != 0)
                  warning("only right angle rotation of frame is supported;\n         try  `frame = \"n\"' instead.\n")
            }
            width <- xinch(width)
            height <- yinch(height)
            xl <- XX - width*adj[1] - xinch(0.03)
            xr <- xl + width + xinch(0.03)
            yb <- YY - height*adj[2] - yinch(0.02)
            yt <- yb + height + yinch(0.05)
            rect(xl, yb, xr, yt, col = bg)
        }
        if (frame == "circle") {
            radii <- 0.8*apply(cbind(strheight(text, units = "inches", cex = CEX),
                                     strwidth(text, units = "inches", cex = CEX)), 1, max)
            symbols(XX, YY, circles = radii, inches = max(radii), add = TRUE, bg = bg)
        }
    }
    if (!is.null(thermo)) {
        parusr <- par("usr")

        if (is.null(width)) {
            width <- CEX * (parusr[2] - parusr[1])
            width <- if (horiz) width/15 else width/40
        }

        if (is.null(height)) {
            height <- CEX * (parusr[4] - parusr[3])
            height <- if (horiz) height/40 else height/15
        }

        if (is.vector(thermo)) thermo <- cbind(thermo, 1 - thermo)
        thermo <- if (horiz) width * thermo else height * thermo
        if (is.null(piecol)) piecol <- rainbow(ncol(thermo))

        xl <- XX - width/2 + adj[1] - 0.5 # added 'adj' from Janet Young (2009-09-30)
        xr <- xl + width
        yb <- YY - height/2 + adj[2] - 0.5
        yt <- yb + height

        if (horiz) {
            ## draw the first rectangle:
            rect(xl, yb, xl + thermo[, 1], yt, border = NA, col = piecol[1])
            for (i in 2:ncol(thermo))
                rect(xl + rowSums(thermo[, 1:(i - 1), drop = FALSE]), yb,
                     xl + rowSums(thermo[, 1:i]), yt, border = NA, col = piecol[i])
        } else {
            ## draw the first rectangle:
            rect(xl, yb, xr, yb + thermo[, 1], border = NA, col = piecol[1])
            for (i in 2:ncol(thermo))
                rect(xl, yb + rowSums(thermo[, 1:(i - 1), drop = FALSE]),
                     xr, yb + rowSums(thermo[, 1:i]),
                     border = NA, col = piecol[i])
        }

        ## check for NA's before drawing the borders
        s <- apply(thermo, 1, function(xx) any(is.na(xx)))
        xl[s] <-  xr[s] <- NA
        rect(xl, yb, xr, yt, border = "black")

        if (!horiz) {
            segments(xl, YY, xl - width/5, YY)
            segments(xr, YY, xr + width/5, YY)
        }
    }
    ## from BB:
    if (!is.null(pie)) {
        if (is.vector(pie)) pie <- cbind(pie, 1 - pie)
        xrad <- CEX * diff(par("usr")[1:2]) / 50
        xrad <- rep(xrad, length(sel))
        XX <- XX + adj[1] - 0.5
        YY <- YY + adj[2] - 0.5
        for (i in seq_along(sel)) {
            if (any(is.na(pie[i, ]))) next
            floating.pie.asp(XX[i], YY[i], pie[i, ], radius = xrad[i], col = piecol)
        }
    }
    if (!is.null(text)) text(XX, YY, text, adj = adj, col = col, ...)
    if (!is.null(pch)) points(XX + adj[1] - 0.5, YY + adj[2] - 0.5,
                              pch = pch, col = col, bg = bg, ...)
}

nodelabels <-
    function(text, node, adj = c(0.5, 0.5), frame = "rect",
             pch = NULL, thermo = NULL, pie = NULL, piecol = NULL,
             col = "black", bg = "lightblue", horiz = FALSE,
             width = NULL, height = NULL, ...)
{
    lastPP <- get("last_plot.phylo", envir = .PlotPhyloEnv)
    if (missing(node)) node <- (lastPP$Ntip + 1):length(lastPP$xx)
    XX <- lastPP$xx[node]
    YY <- lastPP$yy[node]
    BOTHlabels(text, node, XX, YY, adj, frame, pch, thermo,
               pie, piecol, col, bg, horiz, width, height, ...)
}

tiplabels <-
    function(text, tip, adj = c(0.5, 0.5), frame = "rect",
             pch = NULL, thermo = NULL, pie = NULL, piecol = NULL,
             col = "black", bg = "yellow", horiz = FALSE,
             width = NULL, height = NULL, offset = 0, ...)
{
    lastPP <- get("last_plot.phylo", envir = .PlotPhyloEnv)
    if (missing(tip)) tip <- 1:lastPP$Ntip
    XX <- lastPP$xx[tip]
    YY <- lastPP$yy[tip]
    if (offset != 0) {
        if (lastPP$type %in% c("phylogram", "cladogram")) {
            switch(lastPP$direction,
                   "rightwards" = {XX <- XX + offset},
                   "leftwards" = {XX <- XX - offset},
                   "upwards" = {YY <- YY + offset},
                   "downwards" = {YY <- YY - offset})
        } else {
            if (lastPP$type %in% c("fan", "radial")) {
                tmp <- rect2polar(XX, YY)
                if (lastPP$align.tip.label) tmp$r[] <- max(tmp$r)
                tmp <- polar2rect(tmp$r + offset, tmp$angle)
                XX <- tmp$x
                YY <- tmp$y
            } else {
                if (lastPP$type == "unrooted")
                    warning("argument 'offset' ignored with unrooted trees")
            }
        }
    }
    BOTHlabels(text, tip, XX, YY, adj, frame, pch, thermo,
               pie, piecol, col, bg, horiz, width, height, ...)
}

edgelabels <-
    function(text, edge, adj = c(0.5, 0.5), frame = "rect",
             pch = NULL, thermo = NULL, pie = NULL, piecol = NULL,
             col = "black", bg = "lightgreen", horiz = FALSE,
             width = NULL, height = NULL, date = NULL, ...)
{
    lastPP <- get("last_plot.phylo", envir = .PlotPhyloEnv)
    if (missing(edge)) {
        sel <- 1:dim(lastPP$edge)[1]
        subedge <- lastPP$edge
    } else {
        sel <- edge
        subedge <- lastPP$edge[sel, , drop = FALSE]
    }

    xx <- lastPP$xx
    yy <- lastPP$yy

    if (lastPP$type == "phylogram") {
        if (lastPP$direction %in% c("rightwards", "leftwards")) {
            XX <- (xx[subedge[, 1]] + xx[subedge[, 2]]) / 2
            YY <- yy[subedge[, 2]]
        } else {
            XX <- xx[subedge[, 2]]
            YY <- (yy[subedge[, 1]] + yy[subedge[, 2]]) / 2
        }
    } else {
        if (lastPP$type == "fan") { # fix by Klaus Schliep (2015-07-31)
            r <- sqrt(xx^2 + yy^2)
            tmp <- (r[subedge[, 2]] + r[subedge[, 1]]) / (r[subedge[, 2]] * 2)
            XX <- xx[subedge[, 2]] * tmp
            YY <- yy[subedge[, 2]] * tmp
        } else {
            XX <- (xx[subedge[, 1]] + xx[subedge[, 2]]) / 2
            YY <- (yy[subedge[, 1]] + yy[subedge[, 2]]) / 2
        }
    }

    ## suggestion by Rob Lanfear:
    if (!is.null(date)) XX[] <- max(lastPP$xx) - date

    BOTHlabels(text, sel, XX, YY, adj, frame, pch, thermo,
               pie, piecol, col, bg, horiz, width, height, ...)
}

edges <- function(nodes0, nodes1, arrows = 0, type = "classical", ...)
{
    type <- match.arg(type, c("classical", "triangle", "harpoon"))
    lastPP <- get("last_plot.phylo", envir = .PlotPhyloEnv)
    ## we do the recycling if necessary:
    if (length(nodes0) != length(nodes1)) {
        tmp <- cbind(nodes0, nodes1)
        nodes0 <- tmp[, 1]
        nodes1 <- tmp[, 2]
    }
    x0 <- lastPP$xx[nodes0]
    y0 <- lastPP$yy[nodes0]
    x1 <- lastPP$xx[nodes1]
    y1 <- lastPP$yy[nodes1]
    if (arrows)
        if (type == "classical")
            arrows(x0, y0, x1, y1, code = arrows, ...)
        else
            fancyarrows(x0, y0, x1, y1, code = arrows, type = type, ...)
    else
        segments(x0, y0, x1, y1, ...)
}

fancyarrows <-
    function(x0, y0, x1, y1, length = 0.25, angle = 30, code = 2,
             col = par("fg"), lty = par("lty"), lwd = par("lwd"),
             type = "triangle", ...)
{
    foo <- function(x0, y0, x1, y1) {
        ## important to correct with these parameters cause
        ## the coordinate system will likely not be Cartesian
        pin <- par("pin")
        usr <- par("usr")
        A1 <- pin[1]/diff(usr[1:2])
        A2 <- pin[2]/diff(usr[3:4])
        x0 <- x0 * A1
        y0 <- y0 * A2
        x1 <- x1 * A1
        y1 <- y1 * A2
        atan2(y1 - y0, x1 - x0)
    }
    arrow.triangle <- function(x, y) {
        beta <- alpha - angle/2
        xa <- xinch(length * cos(beta)) + x
        ya <- yinch(length * sin(beta)) + y
        beta <- beta + angle
        xb <- xinch(length * cos(beta)) + x
        yb <- yinch(length * sin(beta)) + y
        n <- length(x)
        col <- rep(col, length.out = n)
        for (i in 1:n)
            polygon(c(x[i], xa[i], xb[i]), c(y[i], ya[i], yb[i]),
                    col = col[i], border = col[i])
        list((xa + xb)/2, (ya + yb)/2)
    }
    arrow.harpoon <- function(x, y) {
        beta <- alpha - angle/2
        xa <- xinch(length * cos(beta)) + x
        ya <- yinch(length * sin(beta)) + y
        beta <- alpha + angle/2
        xb <- xinch(length * cos(beta)) + x
        yb <- yinch(length * sin(beta)) + y
        xc <- x/2 + (xa + xb)/4
        yc <- y/2 + (ya + yb)/4
        n <- length(x)
        col <- rep(col, length.out = n)
        for (i in 1:n)
            polygon(c(x[i], xa[i], xc[i], xb[i]),
                    c(y[i], ya[i], yc[i], yb[i]),
                    col = col[i], border = col[i])
        list(xc, yc)
    }

    type <- match.arg(type, c("triangle", "harpoon"))
    angle <- pi*angle/180 # degree -> radian
    alpha <- foo(x0, y0, x1, y1) # angle of segment with x-axis
    ## alpha is in [-pi, pi]

    FUN <- if (type == "triangle") arrow.triangle else arrow.harpoon
    XY0 <- if (code == 1 || code == 3) FUN(x0, y0) else list(x0, y0)
    if (code >= 2) {
        alpha <- (alpha + pi) %% (2 * pi)
        XY1 <- FUN(x1, y1)
    } else XY1 <- list(x1, y1)
    segments(XY0[[1]], XY0[[2]], XY1[[1]], XY1[[2]], col = col, lty = lty, lwd = lwd, ...)
}

## additive.R (2013-10-04)

##   Incomplete Distance Matrix Filling

## Copyright 2011-2013 Andrei-Alin Popescu

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

additive <- function(X)
{
    if (is.matrix(X)) X <- as.dist(X)
    X[is.na(X)] <- -1
    X[X < 0] <- -1
    X[is.nan(X)] <- -1
    N <- attr(X, "Size")
    labels <- attr(X, "Labels")
    if (is.null(labels)) labels <- as.character(1:N)
    m <- sum(X == -1)
    ans <- .C(C_additive, as.double(X), as.integer(N),
              as.integer(m), double(N*N))
    matrix(ans[[4]], N, N)
}

ultrametric <- function(X)
{
    if (is.matrix(X)) X <- as.dist(X)
    X[is.na(X)] <- -1
    X[X < 0] <- -1
    X[is.nan(X)] <- -1
    N <- attr(X, "Size")
    labels <- attr(X, "Labels")
    if (is.null(labels)) labels <- as.character(1:N)
    m <- sum(X == -1)
    ans <- .C(C_ultrametric, as.double(X), as.integer(N),
              as.integer(m), double(N*N))
    matrix(ans[[4]], N, N)
}

## compar.lynch.R (2002-08-28)

##   Lynch's Comparative Method

## Copyright 2002 Julien Claude

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

compar.lynch <- function(x, G, eps = 1e-4)
{
    if (is.vector(x) || is.data.frame(x)) x <- as.matrix(x)
    alea <- runif(1, 0, 1)
    z <- as.vector(x)
    uz <- apply(x, 2, mean)
    vcvz <- var(x)
    vz <- diag(vcvz)
    nsp <- nrow(x)
    k <- ncol(x)
    X1 <- matrix(0, k, k)
    diag(X1) <- 1
    I <- matrix(0, nsp, nsp)
    diag(I) <- 1
    vara <- trvare <- matrix(NA, k, k)
    nsp1 <- rep(1, nsp)
    X <- X1 %x% nsp1
    compteur <- 0
    vara <- A0 <- alea * vcvz
    vare <- E0 <- (1 - alea) * vcvz
    newu <- u0 <- uz
    Ginv <- solve(G)
    V0 <- vcvz %x% G
    a0 <- e0 <- matrix(0, nsp, k)
    a1 <- e1 <- matrix(1, nsp, k)
    while (any(abs((rbind(a1, e1) - rbind(a0, e0))) > eps)) {
        a1 <- a0
        e1 <- e0
	compteur <- compteur + 1
        Rinv <- solve(E0 %x% I)
        Dinv <- solve(A0 %x% G)
        info <- solve(Rinv + Dinv)
        newa <- solve(Rinv + Dinv) %*% Rinv %*% (z - X %*% u0)
        newe <- z - X %*% u0 - newa
        e0 <- mnewe <- matrix(newe, nsp, k)
        a0 <- mnewa <- matrix(newa, nsp, k)

        for (i in 1:k) {
            for (j in 1:k) {
                trvare[i, j] <- sum(diag(info[(((i - 1) * nsp) + 1):(i * nsp),
                                              (((j - 1) * nsp) + 1):(j * nsp)]))}
        }
        vare <- ((nsp - 1) * var(mnewe) + trvare) / nsp

        for (i in 1:k) {
            for (j in 1:k) {
                vara[i, j] <- (t(mnewa[, i]) %*% Ginv %*% mnewa[, j] +
                              sum(diag(Ginv %*%
                                       info[(((i - 1) * nsp) + 1):(i * nsp),
                                            (((j - 1) * nsp) + 1):(j * nsp)]))) / nsp
            }
        }

        newu <- apply(x - mnewa, 2, mean)
	V  <-  vara %x% G + vare %x% I

	p <- (2 * pi)^(-nsp) * det(V)^(-0.5) *
          exp(-0.5 * t(z - (X %*% newu)) %*% solve(V) %*% (z - (X %*% newu)))
        E0 <- vare
        A0 <- vara
        u0 <- newu
    }
    dimnames(vare) <- dimnames(vara)
    list(vare = vare, vara = vara, A = mnewa, E = mnewe, u = newu, lik = log(p))
}

## compute.brtime.R (2012-03-02)

##   Compute and Set Branching Times

## Copyright 2011-2012 Emmanuel Paradis

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

compute.brtime <-
    function(phy, method = "coalescent", force.positive = NULL)
{
    if (!inherits(phy, "phylo"))
        stop('object "phy" is not of class "phylo"')
    n <- length(phy$tip.label)
    m <- phy$Nnode
    N <- Nedge(phy)

    ## x: branching times (aka, node ages, depths, or heights)

    if (identical(method, "coalescent")) { # the default
        x <- 2 * rexp(m)/(as.double((m + 1):2) * as.double(m:1))
        ## x <- 2 * rexp(n - 1)/(as.double(n:2) * as.double((n - 1):1))
        if (is.null(force.positive)) force.positive <- TRUE
    } else if (is.numeric(method)) {
        x <- as.vector(method)
        if (length(x) != m)
            stop("number of branching times given is not equal to the number of nodes")
        if (is.null(force.positive))
            force.positive <- FALSE
    }

    y <- c(rep(0, n), x) # for all nodes (terminal and internal)

    e1 <- phy$edge[, 1L] # local copies of the pointers
    e2 <- phy$edge[, 2L] #

    if (force.positive) {
        o <- .Call(seq_root2tip, phy$edge, n, m)
        list.nodes <- list(n + 1L)
        i <- 2L
        repeat {
            z <- sapply(o, "[", i)
            z <- unique(z[!(z <= n | is.na(z))])
            if (!length(z)) break
            list.nodes[[i]] <- z
            i <- i + 1L
        }
        nodes <- unlist(lapply(list.nodes, function(x) x[sample(length(x))]))
        y[nodes] <- sort(x, decreasing = TRUE)
    }

    phy$edge.length <- y[e1] - y[e2]
    phy
}

## def.R (2014-10-24)

##   Definition of Vectors for Plotting or Annotating

## Copyright 2014 Emmanuel Paradis

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

def <- function(x, ..., default = NULL, regexp = FALSE)
{
    dots <- list(...)
    if (is.null(default)) {
        if (is.numeric(dots[[1L]])) default <- 1
        if (is.character(dots[[1L]])) default <- "black"
    }
    foo <- if (regexp) function(vec, y) grep(y, vec) else function(vec, y) which(vec == y)
    res <- rep(default, length(x))
    nms <- names(dots)
    for (i in seq_along(nms))
        res[foo(x, nms[i])] <- dots[[i]]
    res
}

## MPR.R (2010-08-10)

##   Most Parsimonious Reconstruction

## Copyright 2010 Emmanuel Paradis

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

MPR <- function(x, phy, outgroup)
{
    if (is.rooted(phy))
        stop("the tree must be unrooted")
    if (!is.binary.phylo(phy))
        stop("the tree must be fully dichotomous")
    if (length(outgroup) > 1L)
        stop("outgroup must be a single tip")
    if (is.character(outgroup))
        outgroup <- which(phy$tip.label == outgroup)

    if (!is.null(names(x))) {
        if (all(names(x) %in% phy$tip.label))
            x <- x[phy$tip.label]
        else warning("the names of 'x' and the tip labels of the tree do not match: the former were ignored in the analysis.")
    }

    n <- length(phy$tip.label)
    if (is.null(phy$node.label))
        phy$node.label <- n + 1:(phy$Nnode)

    phy <- drop.tip(root(phy, outgroup), outgroup)
    n <- n - 1L
    m <- phy$Nnode
    phy <- reorder(phy, "postorder")

    root.state <- x[outgroup]
    I <- as.integer(x[-outgroup])
    I[n + 1:m] <- NA
    I <- cbind(I, I) # interval map

    med <- function(x) {
        i <- length(x)/2
        sort(x)[c(i, i + 1L)]
    }

    ## 1st pass
    s <- seq(from = 1, by = 2, length.out = m)
    anc <- phy$edge[s, 1]
    des <- matrix(phy$edge[, 2], ncol = 2, byrow = TRUE)
    for (i in 1:m) I[anc[i], ] <- med(I[des[i, ], ])

    ## 2nd pass
    out <- matrix(NA, m, 2)
    colnames(out) <- c("lower", "upper")
    ## do the most basal node before looping
    Iw <- as.vector(I[des[m, ], ]) # interval maps of the descendants
    out[anc[m] - n, ] <- range(med(c(root.state, root.state, Iw)))
    for (i in (m - 1):1) {
        j <- anc[i]
        Iw <- as.vector(I[des[i, ], ]) # interval maps of the descendants
        k <- which(phy$edge[, 2] == j) # find the ancestor
        tmp <- out[phy$edge[k, 1] - n, ]
        out[j - n, 1] <- min(med(c(tmp[1], tmp[1], Iw)))
        out[j - n, 2] <- max(med(c(tmp[2], tmp[2], Iw)))
    }
    rownames(out) <- phy$node.label
    out
}

## nj.R (2017-11-15)

##   Neighbor-Joining Tree Estimation

## Copyright 2004-2017 Emmanuel Paradis

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

nj <- function(X)
{
    if (is.matrix(X)) X <- as.dist(X)
    if (any(is.na(X)))
        stop("missing values are not allowed in the distance matrix\nConsider using njs()")
    if (any(is.infinite(X)))
        stop("infinite values are not allowed in the distance matrix")
    N <- attr(X, "Size")
    if (N < 3) stop("cannot build an unrooted tree with less than 3 observations")
    labels <- attr(X, "Labels")
    if (is.null(labels)) labels <- as.character(1:N)
    ans <- .C(C_nj, as.double(X), as.integer(N), integer(2*N - 3),
              integer(2*N - 3), double(2*N - 3), NAOK = TRUE)
    obj <- list(edge = cbind(ans[[3]], ans[[4]]), edge.length = ans[[5]],
                tip.label = labels, Nnode = N - 2L)
    class(obj) <- "phylo"
    reorder(obj)
}

## varcomp.R (2004-10-29)

##   Variance Component of Mixed-Effect Linear Model

## Copyright 2004 Julien Dutheil

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

varcomp <- function(x, scale = FALSE, cum = FALSE)
{
  if (!("lme" %in% class(x))) stop("Object \"x\" is not of class \"lme\"")
  res <- seq(along = x$modelStruct$reStruct)
  var <- vector(length = length(res) + 1)
  for(i in res) {
    var[length(var) - i] <- attr(summary(x$modelStruct$reStruct[[i]]),"stdDev")[1]*x$sigma
  }
  var[length(var)] <- x$sigma
  var <- var^2
  if(scale) var <- var/sum(var)
  if(cum) var <- cumsum(var)
  names(var) <- c(rev(names(x$modelStruct$reStruct)), "Within")
  class(var) <- "varcomp"
  return(var)
}

plot.varcomp <- function(x, xlab = "Levels", ylab = "Variance", type = "b", ...) {
  if (!("varcomp" %in% class(x))) stop("Object \"x\" is not of class \"varcomp\"")
  return(xyplot(x ~ ordered(names(x), levels=rev(names(x))), xlab=xlab, ylab=ylab, type=type, ...))
}

# For debuging:
#data(carnivora)
#m <- lme(log10(SW) ~ 1, random = ~ 1|Order/SuperFamily/Family/Genus, data=carnivora)
#v <- varcomp(m,T,T)
#plot(v)

## collapse.singles.R (2017-07-27)

## Collapse "Single" Nodes

## Copyright 2015 Emmanuel Paradis, 2017 Klaus Schliep

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

has.singles <- function(tree)
{
    fun <- function(x) {
        tab <- tabulate(x$edge[, 1])
        if (any(tab == 1L)) return(TRUE)
        FALSE
    }
    if (inherits(tree, "phylo")) return(fun(tree))
    if (inherits(tree, "multiPhylo")) return(sapply(tree, fun))
}

collapse.singles <- function(tree, root.edge = FALSE)
{
    n <- length(tree$tip.label)
    tree <- reorder(tree) # this works now
    e1 <- tree$edge[, 1]
    e2 <- tree$edge[, 2]

    tab <- tabulate(e1)
    if (all(tab[-c(1:n)] > 1)) return(tree) # tips are zero

    if (is.null(tree$edge.length)) {
        root.edge <- FALSE
        wbl <- FALSE
    } else {
        wbl <- TRUE
        el <- tree$edge.length
    }

    if (root.edge) ROOTEDGE <- 0

    ## start with the root node:
    ROOT <- n + 1L
    while (tab[ROOT] == 1) {
        i <- which(e1 == ROOT)
        ROOT <- e2[i]
        if (wbl) {
            if (root.edge) ROOTEDGE <- ROOTEDGE + el[i]
            el <- el[-i]
        }
        e1 <- e1[-i]
        e2 <- e2[-i]
    }

    singles <- which(tabulate(e1) == 1)
    if (length(singles) > 0) {
        ii <- sort(match(singles, e1), decreasing = TRUE)
        jj <- match(e1[ii], e2)
        for (i in 1:length(singles)) {
            e2[jj[i]] <- e2[ii[i]]
            if (wbl) el[jj[i]] <- el[jj[i]] + el[ii[i]]
        }
        e1 <- e1[-ii]
        e2 <- e2[-ii]
        if (wbl) el <- el[-ii]
    }
    Nnode <- length(e1) - n + 1L

    oldnodes <- unique(e1)
    if (!is.null(tree$node.label))
        tree$node.label <- tree$node.label[oldnodes - n]
    newNb <- integer(max(oldnodes))
    newNb[ROOT] <- n + 1L
    sndcol <- e2 > n
    e2[sndcol] <- newNb[e2[sndcol]] <- n + 2:Nnode
    e1 <- newNb[e1]
    tree$edge <- cbind(e1, e2, deparse.level = 0)
    tree$Nnode <- Nnode
    if (wbl) {
        if (root.edge) tree$root.edge <- ROOTEDGE
        tree$edge.length <- el
    }
    tree
}

## dbd.R (2015-02-06)

##   Probability Density Under Birth--Death Models

## Copyright 2012-2015 Emmanuel Paradis

## This file is part of the R-package `ape'.
## See the file ../COPYING for licensing issues.

dyule <- function(x, lambda = 0.1, t = 1, log = FALSE)
{
    tmp <- exp(-lambda * t)
    res <- if (log) log(tmp) + (x - 1) * log(1 - tmp) else tmp * (1 - tmp)^(x - 1)
    out.of.range <- x <= 0
    if (any(out.of.range))
        res[out.of.range] <- if (log) -Inf else 0
    res
}

dbd <- function(x, lambda, mu, t, conditional = FALSE, log = FALSE)
{
    if (length(lambda) > 1) {
        lambda <- lambda[1]
        warning("only the first value of 'lambda' was considered")
    }
    if (length(mu) > 1) {
        mu <- mu[1]
        warning("only the first value of 'mu' was considered")
    }

    if (mu == 0) return(dyule(x, lambda, t, log))

    ## for the unconditional case, we have to consider x=0 separately:
    if (!conditional) {
        zero <- x == 0
        out.of.range <- x < 0
    } else {
        out.of.range <- x <= 0
    }

    res <- numeric(length(x))

    ## the situation were speciation and extinction probabilities are equal:
    if (lambda == mu) {
        tmp <- lambda * t
        eta <- tmp/(1 + tmp)
        if (conditional) {
            res[] <- if (log) log(1 - eta) + (x - 1) * log(eta) else (1 - eta) * eta^(x - 1)
        } else { # the unconditional case:
            if (length(zero)) {
                res[zero] <- eta
                res[!zero] <- (1 - eta)^2 * eta^(x[!zero] - 1)
            } else res[] <- (1 - eta)^2 * eta^(x - 1)
        }
    } else { # the general case with lambda != mu

        ## this expression is common to the conditional and unconditional cases:
        Ent <- exp((lambda - mu) * t)

        if (conditional) {
            if (log) {
                res[] <- log(lambda - mu) - log(lambda * Ent - mu) +
                    (x - 1) * (log(lambda) + log(Ent - 1) - log(lambda * Ent - mu))
            } else {
                eta <- lambda * (Ent - 1)/(lambda * Ent - mu)
                res[] <- (1 - eta) * eta^(x - 1)
            }
        } else { # finally, the unconditional case:
            eta <- lambda * (Ent - 1)/(lambda * Ent - mu)
            if (length(zero)) {
                res[zero] <- eta * mu / lambda
                res[!zero] <- (1 - mu * eta / lambda) * (1 - eta) * eta^(x[!zero] - 1)
            } else res[] <- (1 - mu * eta / lambda) * (1 - eta) * eta^(x - 1)
        }
    }

    if (any(out.of.range))
        res[out.of.range] <- if (log) -Inf else 0
    res
}

dbdTime <- function(x, birth, death, t, conditional = FALSE,
                    BIRTH = NULL, DEATH = NULL, fast = FALSE)
{
    if (length(t) > 1) {
        t <- t[1]
        warning("only the first value of 't' was considered")
    }

    if (conditional) {
        PrNt <- function(t, T, x) {
            tmp <- exp(-RHO(t, T))
            Wt <- tmp * (1 + INT(t))
            out <- (1/Wt)*(1 - 1/Wt)^(x - 1)
            zero <- x == 0
            if (length(zero)) out[zero] <- 0
            out
        }
    } else { # the unconditional case:
        PrNt <- function(t, T, x)
        {
            tmp <- exp(-RHO(t, T))
            Wt <- tmp * (1 + INT(t))
            out <- numeric(length(x))
            zero <- x == 0
            if (length(zero)) {
                out[zero] <- 1 - tmp/Wt
                out[!zero] <- (tmp/Wt^2)*(1 - 1/Wt)^(x[!zero] - 1)
            } else out[] <- (tmp/Wt^2)*(1 - 1/Wt)^(x - 1)
            out
        }
    }
    case <- .getCase(birth, death, BIRTH, DEATH)
    ff <- .getRHOetINT(birth, death, BIRTH, DEATH, case = case, fast = fast)
    RHO <- ff[[1]]
    INT <- ff[[2]]
    environment(RHO) <- environment(INT) <- environment()
    Tmax <- t
    PrNt(0, t, x)
}

\documentclass[a4paper]{article}
%\VignetteIndexEntry{Random Topology}
%\VignettePackage{ape}
\usepackage{ape}
\author{Emmanuel Paradis}
\title{Enumeration and Simulation of Random Tree Topologies}

\begin{document}
\DefineVerbatimEnvironment{Sinput}{Verbatim}{formatcom=\color{darkblue}}
\DefineVerbatimEnvironment{Soutput}{Verbatim}{formatcom=\color{black}\vspace{-1.5em}}

\maketitle
\tableofcontents\vspace*{1pc}\hrule

<<echo=false,quiet=true>>=
options(width = 80, prompt = "> ")
@

\vspace{1cm}

This document describes how phylogenetic trees are simulated in \ape\
and discusses some issues related to solving multichotomies.

\section{Theoretical Background}

We use here the term \emph{topology} to mean the shape of a tree
without consideration of its branch lengths. The number of possible
topologies for $n$ tips (or leaves), denoted as $N_n$, is notoriously
large. This has been studied by Felsenstein \cite{Felsenstein1978} and
later reviewed in his book \cite{Felsenstein2004}. A particularly
relevant case is that of rooted, binary, labeled trees where the
number of possible topologies is given by the double factorial:

\begin{equation}
N_n=(2n-3)!!=1\times 3\times 5\times\cdots\times 2n-3.\label{eq:dblfact}
\end{equation}

The function \code{howmanytrees} in \ape\ calculates the
number of possible topologies with respect to three criteria: rooted
\textit{vs.}\ unrooted, binary \textit{vs.}\ multichotomous, and
labeled \textit{vs.}\ unlabeled. These three options should make eight
possible cases, but the number of unlabeled topologies can be computed
only for rooted, binary trees, so only five cases are effectively
considered. The returned number is obviously an integer which grows
dramatically with $n$:\footnote{This function is not vectorized, so we
  use here \code{sapply}. We could also use
  \code{Vectorize(howmanytrees)(n)}.}

<<>>=
library(ape)
n <- 1:10
data.frame(N.topo = sapply(n, howmanytrees))
@

\noindent With ten labeled tips, a rooted, binary phylogenetic tree
has more than 34 million possible topologies. Suppose we analyze a
sample of $n=25$ sequences (a very modest sample size in today's
standards), this number would be:

<<>>=
howmanytrees(25)
@

\noindent Imagine we want to print each of these topologies on an A4
paper sheet and arrange them side by side to make a (huge)
poster. This would require (in meters):

<<>>=
howmanytrees(25) * 0.21
@

\noindent The diameter of the observable
Universe\footnote{\texttt{https://en.wikipedia.org/wiki/Observable\_universe}}
is estimated to be $\approx 8.8\times 10^{26}$~m, so it would not be
wide enough to display our trees.

The number of topologies grows much more gently if they are unlabeled,
but still reaching huge values if $n$ is moderately large:

<<>>=
data.frame(N.topo = sapply(n, howmanytrees, labeled = FALSE))
@
<<>>=
n2 <- c(50, 100, 200)
data.frame(N.topo = sapply(n2, howmanytrees, labeled = FALSE),
           row.names = n2)
@

\noindent The formula is more complicated than for the labeled cases
and is computed by recursion setting $N_1=1$:

\begin{displaymath}
N_n =\left\{
\begin{array}{ll}
N_1N_{n-1}+N_2N_{n-2}+\dots +\displaystyle\frac{N_{n/2}^2+1}{2}&\quad n\ \mathrm{even}\\[1em]
N_1N_{n-1}+N_2N_{n-2}+\dots +N_{(n-1)/2}N_{(n+1)/2}&\quad n\ \mathrm{odd}\\
\end{array}\right.
\end{displaymath}

These numbers are so large that the probability to randomly
draw twice the same topology when drawing randomly (and independently)
two trees is very close to zero:

<<>>=
1 / howmanytrees(50)
@

\noindent However, for small values of $n$, this is clearly not negligible:

<<>>=
1 / sapply(n, howmanytrees)
@

\noindent These probabilities are of course larger if the topologies are unlabeled:

<<>>=
1 / sapply(n, howmanytrees, labeled = FALSE)
@

\noindent The potential problem is when sampling a large number of
trees, their topologies might not be represented adequately if the
algorithm does not draw them with equal probability.

\phangorn\ has the function \code{allTrees}, but, very wisely, it
accepts only values of $n\le 9$ (or 10 if the trees are unrooted,
which is the default for this function). We consider here $n=4$, so
there are 15 possible labeled topologies and 2 possible unlabeled topologies:

<<>>=
library(phangorn)
TR <- allTrees(4, rooted = TRUE)
TR
@
\setkeys{Gin}{width=\textwidth}
<<fig=true,height=4>>=
layout(matrix(1:15, 3, 5))
par(mar = rep(1.5, 4), xpd = TRUE)
for (i in 1:15) plot(TR[[i]], "c", cex = 1.2, font = 1)
@

\noindent This shows that the two unlabeled topologies do not have the
same number of labeled cases: there are 12 for the unbalanced
topologies, and 3 for the balanced one. Thus, if we
sample the unlabeled topologies with equal probabilities, the labeled
ones will not be represented in equal frequencies. However, we have
seen above that the probability to draw twice the same topology is very
small if $n$ is sufficiently large, but this will also depend on the
number of trees sampled, denoted here as $K$.

What is the probability $P$ to have at least twice the same unlabeled
topology when drawing $K$ trees assuming equal probability of
sampling?  We have seen above that the probability to draw a specific
topology is the inverse of the possible number of topologies, so the
number of times any topology is drawn out of $K$ draws follows a
binomial distribution with parameters $K$ and $1/N_n$.  The
probability to have at least twice this topology is one minus the
probability to have it zero time and minus the probability to have it
once. Let's calculate this for $n=50$ and $K=100$:

<<>>=
K <- 100
n <- 50
N <- howmanytrees(n, labeled = FALSE)
p <- 1/N
1 - (dbinom(0, K, p) + dbinom(1, K, p))
@

\noindent These calculations are very close to the numerical precision
of most computers, which may result in (very small) negative
probabilities, for instance, if we omit the parentheses in the last expression:

<<>>=
1 - dbinom(0, K, p) - dbinom(1, K, p)
@

\noindent We now assess these probabilities for a range of values of
$n$ and $K$:

<<fig=true,height=5>>=
f <- function(n, K) {
    N <- howmanytrees(n, labeled = FALSE)
    p <- 1/N
    1 - (dbinom(0, K, p) + dbinom(1, K, p))
}
DF <- expand.grid(n = 4:20, K = c(2, 5, 10, 100, 1e3, 1e4))
DF$P <- mapply(f, n = DF$n, K = DF$K)
library(lattice)
xyplot(P ~ n, DF, groups = K, panel = panel.superpose,
     type = "b", auto.key = list(x = .8, y = .9, title = "K"))
@

\noindent We can print the probabilities for a specific value $n$, or
calculate them for other values of $n$ and $K$:

<<>>=
subset(DF, n == 20)
@
<<>>=
f(20, 1e5)
@
<<>>=
f(30, 1e6)
@

If the number of tips is small ($n<20$), we cannot ignore the
probability to draw more than once the same topology unless a small
number of trees are sampled (e.g., $K<10$ for $n=10$). On the other
hand, if $n\ge 20$ it is unlikely to draw twice the same topology even
when sampling 10,000 trees. We have to keep in mind that these results
were obtained assuming that each unlabeled topology has the same
probability to be sampled.

\section{Simulating Trees with \ape}

There are five functions to simulate trees in \ape~5.4:

\begin{center}
  \begin{tabular}{ll}
    \code{rtree}&random topology with fixed $n$ and
                  random branch lengths\\
    \code{rcoal}&random coalescent tree with fixed $n$\\
    \code{rphylo}&random birth--death tree with fixed $n$\\
    \code{rbdtree}&random birth--death tree with fixed
                    time and only the surviving lineages\\
    \code{rlineage}&random birth--death tree with fixed
                     time and all lineages\\
  \end{tabular}
\end{center}

\noindent \code{rcoal}, \code{rphylo}, and \code{rbdtree} always
generate ultrametric trees (also \code{rlineage} if the death
rate is equal to zero). All functions generate fully binary trees.\footnote{The
function \code{stree} generates trees with specific shapes, including
multichotomies.}

\subsection{The function \code{rtree}}\label{sec:rtree}

We focus on the function \code{rtree} since it is the most general one
(the other functions have an underlying evolutionary model). Its
algorithm is \cite{Paradis2012}:

\begin{enumerate}\setlength{\itemsep}{0pt}
\item Draw randomly an integer $a$ on the interval $[1, n - 1]$. Set
  $b = n - a$.
\item If $a > 1$, apply (recursively) step 1 after substituting $n$ by
  $a$.
\item Repeat step 2 with $b$ in place of $a$.
\item Assign randomly the $n$ tip labels to the tips.
\end{enumerate}
These recursions are used to build the successive splits generating
sister-clades. This algorithm is thus well-suited to simulate rooted
trees. One of its side-effects is to produce topologies in unequal
frequencies. The reason for this is how the integer $a$ is
drawn. Suppose that $n=4$ (we detailed both the labeled and the
unlabeled cases above), then during the first iteration $a$ takes the
value 1, 2, or 3 with equal probabilities ($\frac{1}{3}$). Obviously,
if $a=2$ a balanced topology will be generated, otherwise the topology
will be unbalanced. Consequently, the expected frequencies of these
two are $\frac{1}{3}$ and $\frac{2}{3}$ instead of $\frac{1}{2}$ and
$\frac{1}{2}$. This also does not agree with the proportions of
labeled topologies which should be $\frac{1}{5}$ and $\frac{4}{5}$ of
the unlabeled ones.

For larger values of $n$, these expected frequencies can be calculated
in a straightforward way thanks to the recursive nature of the
algorithm. If $n=5$, there are three possible unlabeled topologies:

<<fig=true,height=3>>=
txt <- c("((,),((,),));", "(((,),(,)),);", "((((,),),),);")
TR5 <- read.tree(text = txt)
layout(matrix(1:3, 1))
for (i in 1:3) plot(TR5[[i]], "c", cex = 1.2, main = LETTERS[i])
@

\noindent During the first iteration, $a$ takes the value 1, 2, 3, or
4 with equal probabilities ($\frac{1}{4}$): $a=2$ or 3 leads to
topology A, so that it will occur in proportion $\frac{1}{2}$. On the
other hand, if $a=1$ or 4, the above reasoning for $n=4$ can be
applied so that topology B will appear in expected proportion
$\frac{1}{2}\times\frac{2}{3}=\frac{1}{3}$, and topology C in proportion
$\frac{1}{2}\times\frac{1}{3}=\frac{1}{6}$. Since there are 105
labeled topologies with $n=5$, we skip their detailed analysis.

In \ape~5.4-1, the option \code{equiprob} was introduced to
\code{rtree} to generate topologies in equal proportions.\footnote{The
  default of this option is \code{FALSE} because several packages use
  \code{rtree()} with \code{set.seed()} in their examples.} The
modification was simple: in step~1 $a$ is drawn uniformly on
the interval $[1, \lfloor n/2 \rfloor]$. If $n=4$, $a$ now takes the
value 1 or 2 with equal probabilities ($\frac{1}{2}$), so the two
unlabeled topologies are generated in equal proportions. However, if
$n=5$, $a$ takes the same values in the same probabilities leading to
incorrect proportions: the draw $a=1$ should happen twice more
frequently than $a=2$ because the former leads to two different
topologies in the following iteration (because $b=4$) of the algorithm
whereas the latter always result in topology A. The
solution is to weigh the probabilities by the
number of possible topologies for associated to each $(a,b)$ so that those
resulting in higher number of topologies will be more likely to be
drawn. For $n=5$, the two possible pairs are $(1,4)$ and $(2,3)$;
the product of the number of unlabeled topologies gives the correct
weights:

<<>>=
howmanytrees(1, labeled = FALSE) * howmanytrees(4, labeled = FALSE)
@
<<>>=
howmanytrees(2, labeled = FALSE) * howmanytrees(3, labeled = FALSE)
@

\noindent For instance, if $n=803$ it will be necessary to calculate the
following quantity during the first iteration:

<<>>=
howmanytrees(400, labeled = FALSE) * howmanytrees(403, labeled = FALSE)
@

\noindent Section~\ref{sec:beyond} explains how these large numbers
can be handled. This scheme has been incorporated into \ape~5.5. These
probabilities are passed to the function \code{sample} and its option
\code{prob} to generate the values of $a$.

\subsection{The new function \code{rtopology}}

\ape~5.5 introduces \code{rtopology} in order to provide an
alternative to the above functions. The implemented algorithm is as follows:

\begin{enumerate}\setlength{\itemsep}{0pt}
\item Initialize an unrooted tree with $k=3$ tips. Set the number of
  branches to 3.
\item Select randomly one branch of the tree and graft onto it one
  terminal branch. Increment $k$ by 1 tip and the number of branches
  by 2.
\item Repeat step 2 until $k=n$.
\end{enumerate}
This algorithm is particularly efficient to generate unrooted trees
(this is the default of the function). A rooted tree is generated with one additional step:

\begin{enumerate}\setlength{\itemsep}{0pt}
\item[4.] Select randomly one branch of the tree and add an internal
  node on it.
\end{enumerate}

Some calculations are simplified compared to \code{rtree}: it is
possible to generate all needed random numbers at once since it is
known in advance that we will need to select among 3, 5, 7, \dots\
branches in step 2. Additionally, the tip labels are permuted at the
start of the simulation so they are added in random order during step
2. However, \code{rtree} is faster than \code{rtopology} because the
latter requires to reorder the tree edges after the simulation
algorithm is performed.

What are the expected frequencies of the different topologies under
this algorithm? Let's consider $n=4$. Step 1 generates a tree
with three terminal branches, then step 2 adds the last
terminal branch on any of these three, so that the three possible
unrooted, labeled topologies are produced with equal probabilities. The final
unrooted tree has five branches: one internal and four terminal. If
it is rooted (step 4), then the root node is added randomly on any of
these branches, therefore resulting in the balanced topology in 20\% of
the cases, and one of the unbalanced topologies in the remaining 80\%. This conforms
to the numbers of labelled topologies found above.

\subsection{Tests}

The code below is a simple example of testing the frequencies of
topologies generated by the above question considering rooted
trees with $n=4$. We first simulate 1000 trees without branch lengths
using the three algorithms detailed above:

<<>>=
TR <- list(rmtopology(1000, 4, TRUE, br = NULL),
           rmtree(1000, 4, TRUE, br = NULL),
           rmtree(1000, 4, TRUE, br = NULL, equiprob = TRUE))
@

\noindent We then build a function to extract the unique topologies
and compute their frequencies. The returned value is the $\chi^2$-test
for equal frequencies. An option controls whether to consider the
toplogies as labeled (the default) or not:

<<>>=
foo.test <- function(x, labeled = TRUE) {
    uTR <- unique(x, use.tip.label = labeled)
    f <- integer(length(uTR))
    for (j in seq_along(uTR)) {
        for (i in seq_along(x)) {
            if (all.equal(x[[i]], uTR[[j]], use.tip.label = labeled))
                f[j] <- f[j] + 1L
        }
    }
    print(f)
    chisq.test(f)
}
@

\noindent We now apply the function to the list of simulated trees.

<<>>=
lapply(TR, foo.test)
@
<<>>=
lapply(TR, foo.test, labeled = FALSE)
@

\noindent The results agree with the above analysis. The same
simulation study with $n=5$ would require larger sample sizes because
of the much larger numbers of possible topologies.

\subsection{Summary}

\begin{enumerate}
  \item \code{rtree} simulates topologies in unequal frequencies. The
    differences in expected frequencies are important for small values
    of $n$ (see above for $n=4$ and $n=5$). For larger values of $n$,
    it is practically impossible to determine these frequencies because
    of the large number of possible topologies. However, it seems
    these frequencies are sufficiently low that the above analysis
    assuming equal probabilities might be a good approximation. For
    instance, \code{rmtree(1000, 20)} returns 1000 unique unlabeled
    topologies (not shown here to avoid long computations in this vignette).
  \item \code{rtree(, equiprob = TRUE)} simulates unlabeled topologies
    in equal frequencies (from \ape\ 5.5).
  \item \code{rtopology} simulates labeled topologies with equal
    probabilities. This is the function now called by \code{multi2di(,
      equiprob = TRUE)}.
\end{enumerate}

\section{Enumerating Topologies Beyond Large Values}\label{sec:beyond}

The function \code{howmanytrees}, like most functions in \R, works
with double precision floating point numbers, so the largest value
which can be returned is:

<<>>=
.Machine$double.xmax
@

\noindent This value is reached with $n=151$ or 792 for labeled or unlabeled topologies, respectively:

<<>>=
howmanytrees(151)
@
<<>>=
howmanytrees(792, labeled = FALSE)
@

\noindent This section shows how larger values are handled in \ape~5.5.

\subsection{Labeled Topologies}

It is possible to write equation~\ref{eq:dblfact} using standard factorial
(this uses the fact that $2n-3$ is always an odd integer):

\begin{displaymath}
(2n-3)!!=\frac{(2n-3)!}{2^{n-2}(n-2)!}\qquad n\ge 2.
\end{displaymath}
A log-transformation of both sides leads to:

\begin{equation}
\ln[(2n-3)!!]=\ln[(2n-3)!]-(n-2)\ln 2-\ln[(n-2)!].\label{eq:dbfact}
\end{equation}
\R\ has the function \code{lfactorial} making possible to calculate
this expression with large values of $n$.\footnote{\phangorn\ has
  the function \code{ldfactorial} doing the same calculation based on
  \code{lgamma}.} Obviously, if we try to compute the exponential of
the result, we will again obtain \code{Inf}. Instead, we
can use the fact that an expression such as $a^b$ can be expressed with a power
of ten:

\begin{displaymath}
a^b=x\times 10^n,
\end{displaymath}
with $x$ a real number and $n$ an integer. We do a
log$_{10}$-transformation of both sides:

\begin{displaymath}
b\times\log_{10}a=\log_{10}x+n.
\end{displaymath}
This is solved with $n=\lfloor b\times\log_{10}a\rfloor$ and
$x=10^c$, $c=b\times\log_{10}a-n$. This can be used with
$a=\mathrm{e}$ ($\approx 2.718$) and $b=\ln[(2n-3)!!]$ calculated with
equation~\ref{eq:dbfact}.

Let's find how many possible trees there are for the number of
living species on Earth using an estimate of two million species:\footnote{This returned \code{Inf} prior to \ape~5.5.}

<<>>=
(N <- howmanytrees(2e6))
@

\noindent How many digits are needed to print this number?

<<>>=
N[2] + 1
@

\noindent How many pages to print it (assuming 3000 characters per page)?

<<>>=
ceiling((N[2] + 1) / 3000)
@

\subsection{Unlabeled Topologies}

In the unlabeled case, the formulas to calculate the number of
topologies are more complicated and do not allow the previous
approach. However, there is an almost linear relationship between $n$
and $N_n$ after log-transformation of the latter:

<<>>=
n <- 1:792
N <- howmanytrees(792, labeled = FALSE, detail = TRUE)
lN <- log10(N)
summary(lm(lN ~ n))
@

\noindent The linear approximation is good but it is still better for $n>700$:

<<>>=
s <- n > 700
summary(lm(lN[s] ~ n[s]))
@

\noindent The residuals are now almost equal to zero. We may thus write:

\begin{displaymath}
\log_{10}N_n\approx 0.3941\times n-4.153 \qquad n>792.
\end{displaymath}
Let's evaluate the quality of this approximation for a few values:

<<>>=
n <- 788:792
log10(sapply(n, howmanytrees, labeled = FALSE))
0.3941 * n - 4.153
@

\noindent The approximation is not so good for smaller values of $n$
and we use it only for $n>792$. This can be used to handle some of the
calculations detailed in Section~\ref{sec:rtree}. The coefficient
(0.3941) is actually the difference between successive values of $N_n$
on the logarithmic scale:

\begin{displaymath}
\log_{10}N_{n+1}-\log_{10}N_n=0.3941.
\end{displaymath}
This is equivalent to a ratio of these successive values equal to
$N_{n+1}/N_n=10^{0.3941}=2.477993$. We denote this last
number as $\xi$. This can help to find
an approximation of the sum of the $N_i$'s for $i=1, \dots, n$, when
$n$ is large:

\begin{align*}
\sum_{i=1}^nN_i&=N_1+N_2+N_3+\dots+N_n\\
  &\approx N_1+\xi N_1+\xi^2 N_1+\dots+\xi^{n-1} N_1\\
  &=N_1\sum_{i=1}^n\xi^{i-1}.
\end{align*}

\noindent This is a divergent geometric series ($\xi>1$). Since
$N_1=1$, this first term can be ignored. The logarithm of this sum may
be approximated using the fact that $\log(x+\delta)\approx\log(x)$ if
$x>>>\delta$. More generally, if we have a series of numbers $A$, $B$,
$C$, \dots, such that:

\begin{displaymath}
A>B>C>\dots
\end{displaymath}
then the logarithm of their sum can be approximated with successive
calculations (the base of the logarithm is unimportant):

\begin{align*}
\log(A+B+C+\dots) &\approx\log(A)\\
  &\approx\log(A+B)\\
  &\approx\log(A+B+C)\\
  &\approx\dots
\end{align*}
In other words, when calculating the logarithm of a sum, the largest
terms will contribute the most. It is possible to assess the
convergence of the successive approximations.

\begin{align*}
\log_{10}\left(\sum_{i=1}^nN_n\right)&\approx\log_{10}(\xi^{n-1})=(n-1)\log_{10}\xi\\
  &\approx\log_{10}(\xi^{n-2}+\xi^{n-1})=(n-2)\log_{10}\xi+\log_{10}(1+\xi)\\
  &\approx\log_{10}(\xi^{n-3}+\xi^{n-2}+\xi^{n-1})=(n-3)\log_{10}\xi+\log_{10}(1+\xi+\xi^2)\\
  &\approx\dots
\end{align*}
The $k$th approximation can be calculated directly with:

\begin{displaymath}
(n-k)\log_{10}\xi+\log_{10}\left(\sum_{i=0}^{k-1}\xi^i\right)\qquad k>1
\end{displaymath}
This converges after a few iterations:

<<>>=
xi <- 2.477993
lxi <- log10(xi)
n <- 1000
(n - 1) * lxi # k = 1
for (k in 2:11)
    print((n - k) * lxi + log10(sum(xi^(0:(k - 1)))))
@

\bibliographystyle{plain}
\bibliography{ape}
%\setlength{\bibsep}{0pt}
\addcontentsline{toc}{section}{References}

\end{document}

\documentclass[a4paper]{article}
%\VignetteIndexEntry{Moran's I}
%\VignettePackage{ape}
\usepackage{fancyvrb}
\usepackage{color}

\newcommand{\code}{\texttt}
\newcommand{\pkg}{\textsf}
\newcommand{\ape}{\pkg{ape}}
\newcommand{\ade}{\pkg{ade4}}
\newcommand{\spatial}{\pkg{spatial}}
\renewcommand{\sp}{\pkg{sp}}

\author{Emmanuel Paradis}
\title{Moran's Autocorrelation Coefficient in Comparative Methods}

\begin{document}

\maketitle

<<echo=false,quiet=true>>=
options(width=60)
@

This document clarifies the use of Moran's autocorrelation coefficient
to quantify whether the distribution of a trait among a set of species
is affected or not by their phylogenetic relationships.

\section{Theoretical Background}

Moran's autocorrelation coefficient (often denoted as $I$) is an
extension of Pearson product-moment correlation coefficient to a univariate
series \cite{Cliff1973, Moran1950}. Recall that Pearson's correlation
(denoted as $\rho$) between two variables $x$ and $y$ both of length $n$ is:

\begin{displaymath}
\rho = \frac{\displaystyle\sum_{i=1}^n(x_i - \bar{x})(y_i -
  \bar{y})}{\displaystyle\left[{\sum_{i=1}^n(x_i - \bar{x})^2\sum_{i=1}^n(y_i - \bar{y})^2}\right]^{1/2}},
\end{displaymath}
where $\bar{x}$ and $\bar{y}$ are the sample means of both
variables. $\rho$ measures whether, on average, $x_i$ and $y_i$ are
associated. For a single variable, say $x$, $I$ will
measure whether $x_i$ and $x_j$, with $i\ne j$, are associated. Note
that with $\rho$, $x_i$ and $x_j$ are {\em not} associated since the
pairs $(x_i,y_i)$ are assumed to be independent of each other.

In the study of spatial patterns and processes, we may logically
expect that close observations are more likely to be similar than
those far apart. It is usual to associate a {\em weight} to each
pair $(x_i,x_j)$ which quantifies this \cite{Cliff1981}. In its simplest
form, these weights will take values 1 for close neighbours, and 0
otherwise. We also set $w_{ii}=0$. These weights are sometimes
referred to as a {\em neighbouring function}.

$I$'s formula is:

\begin{equation}
I = \frac{n}{S_0}
\frac{\displaystyle\sum_{i=1}^n \sum_{j=1}^n w_{ij}(x_i - \bar{x})(x_j -
  \bar{x})}{\displaystyle\sum_{i=1}^n (x_i - \bar{x})^2},\label{eq:morani}
\end{equation}
where $w_{ij}$ is the weight between observation $i$ and $j$, and
$S_0$ is the sum of all $w_{ij}$'s:

\begin{displaymath}
S_0 = \sum_{i=1}^n \sum_{j=1}^n w_{ij}.
\end{displaymath}

Quite not so intuitively, the expected value of $I$ under the null
hypothesis of no autocorrelation is not equal to zero but given by
$I_0 = -1/(n-1)$. The expected variance of  $I_0$ is also known, and
so we can make a test of the null hypothesis. If the observed value
of $I$ (denoted $\hat{I}$) is significantly greater than $I_0$, then
values of $x$ are positively autocorrelated, whereas if $\hat{I}<I_0$,
this will indicate negative autocorrelation. This allows us to design
one- or two-tailed tests in the standard way.

Gittleman \& Kot \cite{Gittleman1990} proposed to use Moran's $I$ to
test for ``phylogenetic effects''. They considered two ways to
calculate the weights $w$:

\begin{itemize}
\item With phylogenetic distances among species, e.g., $w_{ij} =
  1/d_{ij}$, where $d_{ij}$ are distances measured on a tree.
\item With taxonomic levels where $w_{ij} = 1$ if species $i$ and $j$
  belong to the same group, 0 otherwise.
\end{itemize}

Note that in the first situation, there are quite a lot of
possibilities to set the weights. For instance, Gittleman \& Kot also proposed:

\[\begin{array}{ll}
w_{ij} = 1/d_{ij}^\alpha & \mathrm{if}\ d_{ij} \le c\\
w_{ij} = 0 & \mathrm{if}\ d_{ij} > c,\\
\end{array}\]
where $c$ is a cut-off phylogenetic distance above which the species
are considered to have evolved completely independently, and $\alpha$
is a coefficient (see \cite{Gittleman1990} for details).
By analogy to the use of a spatial correlogram where coefficients are
calculated assuming different sizes of the ``neighbourhood'' and then
plotted to visualize the spatial extent of autocorrelation, they
proposed to calculate $I$ at different taxonomic levels.

\section{Implementation in \ape}

From version 1.2-6, \ape\ has functions \code{Moran.I} and
\code{correlogram.formula} implementing the approach developed by Gittleman \&
Kot. There was an error in the help pages of \code{?Moran.I}
(corrected in ver.\ 2.1) where the weights were referred to as
``distance weights''. This has been wrongly interpreted in my book
\cite[pp.~139--142]{Paradis2006}. The analyses below aim to correct
this.

\subsection{Phylogenetic Distances}

The data, taken from \cite{Cheverud1985}, are the log-transformed
body mass and longevity of five species of primates:

<<>>=
body <- c(4.09434, 3.61092, 2.37024, 2.02815, -1.46968)
longevity <- c(4.74493, 3.3322, 3.3673, 2.89037, 2.30259)
names(body) <- names(longevity) <- c("Homo", "Pongo", "Macaca", "Ateles", "Galago")
@

The tree has branch lengths scaled so that the root age is one. We
read the tree with \ape, and plot it:

<<fig=true>>=
library(ape)
trnwk <- "((((Homo:0.21,Pongo:0.21):0.28,Macaca:0.49):0.13,Ateles:0.62)"
trnwk[2] <- ":0.38,Galago:1.00);"
tr <- read.tree(text = trnwk)
plot(tr)
axisPhylo()
@

We choose the weights as $w_{ij}=1/d_{ij}$, where the $d$'s is the
distances measured on the tree:

<<>>=
w <- 1/cophenetic(tr)
w
@ 
Of course, we must set the diagonal to zero:

<<>>=
diag(w) <- 0
@ 
We can now perform the analysis with Moran's $I$:

<<>>=
Moran.I(body, w)
@

Not surprisingly, the results are opposite to those in
\cite{Paradis2006} since, there, the distances (given by
\code{cophenetic(tr)}) were used as weights. (Note that the argument
\code{dist} has been since renamed \code{weight}.\footnote{The older
  code was actually correct; nevertheless, it has been rewritten, and
  is now much faster. The documentation has been clarified.
  The function \code{correlogram.phylo}, which computed
  Moran's $I$ for a tree given as argument using the distances among
  taxa, has been removed.}) We can now conclude for a slighly
significant positive phylogenetic correlation among body mass values
for these five species.

The new version of \code{Moran.I} gains the option \code{alternative}
which specifies the alternative hypothesis (\code{"two-sided"} by
default, i.e., H$_1$: $I \ne I_0$). As expected from the above result, we divide the $P$-value
be two if we define H$_1$ as $I > I_0$:

<<>>=
Moran.I(body, w, alt = "greater")
@

The same analysis with \code{longevity} gives:

<<>>=
Moran.I(longevity, w)
@

As for \code{body}, the results are nearly mirrored compared to
\cite{Paradis2006} where a non-significant negative phylogenetic
correlation was found: it is now positive but still largely not
significant.

\subsection{Taxonomic Levels}

The function \code{correlogram.formula} provides an interface to
calculate Moran's $I$ for one or several variables giving a series of
taxonomic levels. An example of its use was provided in
\cite[pp.~141--142]{Paradis2006}. The code of this function has been
simplified, and the graphical presentation of the results have been improved.

\code{correlogram.formula}'s main argument is a formula which is ``sliced'',
and \code{Moran.I} is called for each of these elements. Two things
have been changed for the end-user at this level:

\begin{enumerate}
\item In the old version, the rhs of the formula was given in the
  order of the taxonomic hierarchy: e.g.,
  \code{Order/SuperFamily/Family/Genus}. Not respecting this order
  resulted in an error. In the new version, any order is accepted, but
  the order given is then respected when plotted the correlogram.
\item Variable transformations (e.g., log) were allowed on the lhs of
  the formula. Because of the simplification of the code, this is no
  more possible. So it is the responsibility of the user to apply any
  tranformation before the analysis.
\end{enumerate}

Following Gittleman \& Kot \cite{Gittleman1990}, the autocorrelation at a higher level
(e.g., family) is calculated among species belonging to the same
category and to different categories at the level below (genus).
To formalize this, let us write the different levels as
$X^1/X^2/X^3/\dots/X^n$ with $X^n$ being the lowest one (\code{Genus} in the
above formula):

\begin{displaymath}
\begin{array}{l}
\left.\begin{array}{ll}
w_{ij}=1 & \mathrm{if}\ X_i^k = X_j^k\ \mathrm{and}\ X_i^{k+1} \ne X_j^{k+1}\\
w_{ij}=0 & \mathrm{otherwise}\\
\end{array} \right\} k < n
\\\\
\left.\begin{array}{ll}
w_{ij}=1 & \mathrm{if}\ X_i^k = X_j^k\\
w_{ij}=0 & \mathrm{otherwise}\\
\end{array} \right\} k = n
\end{array}
\end{displaymath}
This is thus different from the idea of a ``neighbourhood'' of
different sizes, but rather similar to the idea of partial correlation
where the influence of the lowest level is removed when considering
the highest ones \cite{Gittleman1990}.

To repeat the analyses on the \code{carnivora} data set, we first
log$_{10}$-transform the variables mean body mass (\code{SW}) and the
mean female body mass (\code{FW}):

<<>>=
data(carnivora)
carnivora$log10SW <- log10(carnivora$SW)
carnivora$log10FW <- log10(carnivora$FW)
@ 
We first consider a single variable analysis (as in \cite{Paradis2006}):

<<fig=true>>=
fm1.carn <- log10SW ~ Order/SuperFamily/Family/Genus
co1 <- correlogram.formula(fm1.carn, data = carnivora)
plot(co1)
@

A legend now appears by default, but can be removed with \code{legend
= FALSE}. Most of the appearance of the graph can be customized via
the option of the plot method (see \code{?plot.correlogram} for
details). This is the same analysis than the one displayed on Fig.~6.3
of \cite{Paradis2006}.

When a single variable is given in the lhs in
\code{correlogram.formula}, an object of class \code{"correlogram"} is
returned as above. If several variables are analysed simultaneously,
the object returned is of class \code{"correlogramList"}, and the
correlograms can be plotted together with the appropriate plot method:

<<fig=true>>=
fm2.carn <- log10SW + log10FW ~ Order/SuperFamily/Family/Genus
co2 <- correlogram.formula(fm2.carn, data = carnivora)
print(plot(co2))
@

By default, lattice is used to plot the correlograms on separate
panels; using \code{lattice = FALSE} (actually the second argument,
see \code{?plot.correlogramList}) makes a standard graph superimposing
the different correlograms:

<<fig=true>>=
plot(co2, FALSE)
@

The options are roughly the same than above, but do not have always
the same effect since lattice and base graphics do not have the same
graphical parameters. For instance, \code{legend = FALSE} has no
effect if \code{lattice = TRUE}.

\section{Implementation in \ade}

The analysis done with \ade\ in \cite{Paradis2006} suffers from the
same error than the one done with \code{Moran.I} since it was also
done with a distance matrix. So I correct this below:

\begin{Schunk}
\begin{Sinput}
> library(ade4)
> gearymoran(w, data.frame(body, longevity))
\end{Sinput}
\begin{Soutput}
class: krandtest
Monte-Carlo tests
Call: as.krandtest(sim = matrix(res$result, ncol = nvar, byr = TRUE),
    obs = res$obs, alter = alter, names = test.names)

Test number:   2
Permutation number:   999
Alternative hypothesis: greater

       Test         Obs   Std.Obs Pvalue
1      body -0.06256789 2.1523342  0.001
2 longevity -0.22990437 0.3461414  0.414

other elements: NULL
\end{Soutput}
\end{Schunk}

The results are wholly consistent with those from \ape, but the
estimated coefficients are substantially different. This is because
the computational methods are not the same in both packages. In \ade,
the weight matrix is first transformed as a relative frequency matrix with
$\tilde{w}_{ij} = w_{ij}/S_0$. The weights are further transformed with:

\begin{displaymath}
p_{ij} = \tilde{w}_{ij} - \sum_{i=1}^n\tilde{w}_{ij}\sum_{j=1}^n\tilde{w}_{ij},
\end{displaymath}
with $p_{ij}$ being the elements of the matrix denoted as $P$. Moran's
$I$ is finally computed with $x^\mathrm{T}Px$. In \ape, the weights
are first row-normalized:

\begin{displaymath}
w_{ij} \Big/ \sum_{i=1}^n w_{ij},
\end{displaymath}
then eq.~\ref{eq:morani} is applied.

Another difference between both packages, though less
important, is that in \ade\ the weight matrix is forced to be
symmetric with $(W+W^\mathrm{T})/2$. In \ape, this matrix is assumed
to be symmetric, which is likely to be the case like in the examples above.

\section{Other Implementations}

Package \sp\ has several functions, including
\code{moran.test}, that are more specifically targeted to the analysis
of spatial data. Package \spatial\ has the function \code{correlogram}
that computes and plots spatial correlograms.

\section*{Acknowledgements}

I am thankful to Thibaut Jombart for clarifications on Moran's $I$.

\bibliographystyle{plain}
\bibliography{ape}

\end{document}

\name{makeNodeLabel}
\alias{makeNodeLabel}
\title{Makes Node Labels}
\description{
  This function makes node labels in a tree in a flexible way.
}

\usage{
makeNodeLabel(phy, method = "number", prefix = "Node", nodeList = list(), ...)
}
\arguments{
  \item{phy}{an object of class \code{"phylo"}.}
  \item{method}{a character string giving the method used to create the
    labels. Three choices are possible: \code{"number"} (the default),
    \code{"md5sum"}, and \code{"user"}, or any unambiguous abbreviation
    of these.}
  \item{prefix}{the prefix used if \code{method = "number"}.}
  \item{nodeList}{a named list specifying how nodes are names if
    \code{method = "user"} (see details and examples).}
   \item{\dots}{further arguments passed to \code{grep}.}
}
\details{
  The three methods are described below:

  \itemize{
    \item{``number''}{The labels are created with 1, 2, \dots prefixed
      with the argument \code{prefix}; thus the default is to have
      Node1, Node2, \dots Set \code{prefix = ""} to have only numbers.}
    \item{``md5sum''}{For each node, the labels of the tips descendant
      from this node are extracted, sorted alphabetically, and written
      into a temporary file, then the md5sum of this file is extracted
      and used as label. This results in a 32-character string which is
      unique (even accross trees) for a given set of tip labels.}
    \item{``user''}{the argument \code{nodeList} must be a list with
      names, the latter will be used as node labels. For each element of
      \code{nodeList}, the tip labels of the tree are searched for
      patterns present in this element: this is done using
      \code{\link[base]{grep}}. Then the most recent common ancestor of
      the matching tips is given the corresponding names as labels. This
      is repeated for each element of \code{nodeList}.}
  }

  The method \code{"user"} can be used in combination with either of the
  two others (see examples). Note that this method only modifies the
  specified node labels (so that if the other nodes have already labels
  they are not modified) while the two others change all labels.
}
\value{
  an object of class \code{"phylo"}.
}
\author{Emmanuel Paradis}
\seealso{
  \code{\link{makeLabel}}, \code{\link[base]{grep}},
  \code{\link{mixedFontLabel}}, \code{\link{label2table}},
  \code{\link{checkLabel}}
}
\examples{
tr <-
"((Pan_paniscus,Pan_troglodytes),((Homo_sapiens,Homo_erectus),Homo_abilis));"
tr <- read.tree(text = tr)
tr <- makeNodeLabel(tr, "u", nodeList = list(Pan = "Pan", Homo = "Homo"))
plot(tr, show.node.label = TRUE)
### does not erase the previous node labels:
tr <- makeNodeLabel(tr, "u", nodeList = list(Hominid = c("Pan","Homo")))
plot(tr, show.node.label = TRUE)
### the two previous commands could be combined:
L <- list(Pan = "Pan", Homo = "Homo", Hominid = c("Pan","Homo"))
tr <- makeNodeLabel(tr, "u", nodeList = L)
### combining different methods:
tr <- makeNodeLabel(tr, c("n", "u"), prefix = "#", nodeList = list(Hominid = c("Pan","Homo")))
plot(tr, show.node.label = TRUE)
}
\keyword{manip}

\name{LTT}
\alias{LTT}
\title{Theoretical Lineage-Through Time Plots}
\description{
  This function draws the lineage-through time (LTT) plots predicted
  under a speciation-extinction model (aka birth-death model) with
  specified values of speciation and extinction rates (which may vary
  with time).

  A prediction interval is plotted by default which requires to define a
  sample size (100 by default), and different curves can be combined.
}
\usage{
LTT(birth = 0.1, death = 0, N = 100, Tmax = 50, PI = 95,
    scaled = TRUE, eps = 0.1, add = FALSE, backward = TRUE,
    ltt.style = list("black", 1, 1), pi.style = list("blue", 1, 2), ...)
}
\arguments{
  \item{birth}{the speciation rate, this may be either a numeric value
    or a funtion of time (named \code{t} in the code of the function).}
  \item{death}{id. for the extinction rate.}
  \item{N}{the size of the tree.}
  \item{Tmax}{the age of the root of the tree.}
  \item{PI}{the percentage value of the prediction interval; set this
    value to 0 to not draw this interval.}
  \item{scaled}{a logical values specifying whether to scale the
    \eqn{y}-axis between 0 and 1.}
  \item{eps}{a numerical value giving the resolution of the time axis.}
  \item{add}{a logical values specifying whether to make a new plot (the
    default).}
  \item{backward}{a logical value: should the time axis be traced from
    the present (the default), or from the root of the tree?}
  \item{ltt.style}{a list with three elements giving the style of the
    LTT curve with, respectively, the colour (\code{"col"}), the line
    thickness (\code{"lwd"}), and the line type (\code{"lty"}).}
  \item{pi.style}{id. for the prediction interval.}
  \item{\dots}{arguments passed to \code{plot} (e.g., \code{log="y"}).}
}
\details{
  For the moment, this works well when \code{birth} and \code{death} are
  constant. Some improvements are under progress for time-dependent
  rates (but see below for an example).
}
\references{
  Hallinan, N. (2012) The generalized time variable reconstructed
  birth--death process. \emph{Journal of Theoretical Biology},
  \bold{300}, 265--276.

  Paradis, E. (2011) Time-dependent speciation and extinction from
  phylogenies: a least squares approach. \emph{Evolution}, \bold{65},
  661--672.

  Paradis, E. (2015) Random phylogenies and the distribution of
  branching times. \emph{Journal of Theoretical Biology}, \bold{387},
  39--45.
}
\author{Emmanuel Paradis}
\seealso{
  \code{\link{ltt.plot}}
}
\examples{
### predicted LTT plot under a Yule model with lambda = 0.1
### and 50 species after 50 units of time...
LTT(N = 50)
### ... and with a birth-death model with the same rate of
### diversification (try with N = 500):
LTT(0.2, 0.1, N = 50, PI = 0, add = TRUE, ltt.style = list("red", 2, 1))
### predictions under different tree sizes:
layout(matrix(1:4, 2, 2, byrow = TRUE))
for (N in c(50, 100, 500, 1000)) {
    LTT(0.2, 0.1, N = N)
    title(paste("N =", N))
}
layout(1)
\dontrun{
### speciation rate decreasing with time
birth.logis <- function(t) 1/(1 + exp(0.02 * t + 4))
LTT(birth.logis)
LTT(birth.logis, 0.05)
LTT(birth.logis, 0.1)
}
}
\keyword{hplot}

\name{read.dna}
\alias{read.dna}
\alias{read.FASTA}
\alias{read.fastq}
\title{Read DNA Sequences in a File}
\description{
  These functions read DNA sequences in a file, and returns a matrix or a
  list of DNA sequences with the names of the taxa read in the file as
  rownames or names, respectively. By default, the sequences are stored
  in binary format, otherwise (if \code{as.character = TRUE}) in
  lowercase.
}
\usage{
read.dna(file, format = "interleaved", skip = 0,
         nlines = 0, comment.char = "#",
         as.character = FALSE, as.matrix = NULL)
read.FASTA(file, type = "DNA")
read.fastq(file, offset = -33)
}
\arguments{
  \item{file}{a file name specified by either a variable of mode character,
    or a double-quoted string. Can also be a \link{connection} (which
    will be opened for reading if necessary, and if so
    \code{\link{close}}d (and hence destroyed) at the end of the
    function call).}
  \item{format}{a character string specifying the format of the DNA
    sequences. Four choices are possible: \code{"interleaved"},
    \code{"sequential"}, \code{"clustal"}, or \code{"fasta"}, or any
    unambiguous abbreviation of these.}
  \item{skip}{the number of lines of the input file to skip before
    beginning to read data (ignored for FASTA files; see below).}
  \item{nlines}{the number of lines to be read (by default the file is
    read untill its end; ignored for FASTA files)).}
  \item{comment.char}{a single character, the remaining of the line
    after this character is ignored (ignored for FASTA files).}
  \item{as.character}{a logical controlling whether to return the
    sequences as an object of class \code{"DNAbin"} (the default).}
  \item{as.matrix}{(used if \code{format = "fasta"}) one of the three
    followings: (i) \code{NULL}: returns the sequences in a matrix if
    they are of the same length, otherwise in a list; (ii) \code{TRUE}:
    returns the sequences in a matrix, or stops with an error if they
    are of different lengths; (iii) \code{FALSE}: always returns the
    sequences in a list.}
  \item{type}{a character string giving the type of the sequences: one of
    \code{"DNA"} or \code{"AA"} (case-independent, can be abbreviated).}
  \item{offset}{the value to be added to the quality scores (the default
    applies to the Sanger format and should work for most recent FASTQ
    files).}
}
\details{
  \code{read.dna} follows the interleaved and sequential formats defined
  in PHYLIP (Felsenstein, 1993) but with the original feature than there
  is no restriction on the lengths of the taxa names. For these two
  formats, the first line of the file must contain the dimensions of the
  data (the numbers of taxa and the numbers of nucleotides); the
  sequences are considered as aligned and thus must be of the same
  lengths for all taxa. For the FASTA and FASTQ formats, the conventions
  defined in the references are followed; the sequences are taken as
  non-aligned. For all formats, the nucleotides can be arranged in any
  way with blanks and line-breaks inside (with the restriction that the
  first ten nucleotides must be contiguous for the interleaved and
  sequential formats, see below). The names of the sequences are read in
  the file. Particularities for each format are detailed below.

\itemize{
  \item{Interleaved:}{the function starts to read the sequences after it
    finds one or more spaces (or tabulations). All characters before the
    sequences are taken as the taxa names after removing the leading and
    trailing spaces (so spaces in taxa names are not allowed). It is
    assumed that the taxa names are not repeated in the subsequent
    blocks of nucleotides.}

  \item{Sequential:}{the same criterion than for the interleaved format
    is used to start reading the sequences and the taxa names; the
    sequences are then read until the number of nucleotides specified in
    the first line of the file is reached. This is repeated for each taxa.}

  \item{Clustal:}{this is the format output by the Clustal programs
    (.aln). It is close to the interleaved format: the differences are
    that the dimensions of the data are not indicated in the file, and
    the names of the sequences are repeated in each block.}

  \item{FASTA:}{This looks like the sequential format but the taxa names
    (or a description of the sequence) are on separate lines beginning
    with a `greater than' character `>' (there may be leading spaces
    before this character). These lines are taken as taxa names after
    removing the `>' and the possible leading and trailing spaces. All
    the data in the file before the first sequence are ignored.}
}

The FASTQ format is explained in the references.

Compressed files must be read through connections (see examples).
\code{read.fastq} can read compressed files directly (see
examples).
}
\value{
  a matrix or a list (if \code{format = "fasta"}) of DNA sequences
  stored in binary format, or of mode character (if \code{as.character =
    "TRUE"}).

  \code{read.FASTA} always returns a list of class \code{"DNAbin"} or
  \code{"AAbin"}.

  \code{read.fastq} returns a list of class \code{"DNAbin"} with an
  atrribute \code{"QUAL"} (see examples).
}
\references{
  Anonymous. FASTA format. \url{https://en.wikipedia.org/wiki/FASTA_format}

  Anonymous. FASTQ format. \url{https://en.wikipedia.org/wiki/FASTQ_format}

  Felsenstein, J. (1993) Phylip (Phylogeny Inference Package) version
  3.5c. Department of Genetics, University of Washington.
  \url{http://evolution.genetics.washington.edu/phylip/phylip.html}
}
\seealso{
  \code{\link{read.GenBank}}, \code{\link{write.dna}},
  \code{\link{DNAbin}}, \code{\link{dist.dna}}, \code{\link{woodmouse}}
}
\author{Emmanuel Paradis and RJ Ewing}
\examples{
## a small extract from data(woddmouse) in sequential format:
cat("3 40",
"No305     NTTCGAAAAACACACCCACTACTAAAANTTATCAGTCACT",
"No304     ATTCGAAAAACACACCCACTACTAAAAATTATCAACCACT",
"No306     ATTCGAAAAACACACCCACTACTAAAAATTATCAATCACT",
file = "exdna.txt", sep = "\n")
ex.dna <- read.dna("exdna.txt", format = "sequential")
str(ex.dna)
ex.dna
## the same data in interleaved format...
cat("3 40",
"No305     NTTCGAAAAA CACACCCACT",
"No304     ATTCGAAAAA CACACCCACT",
"No306     ATTCGAAAAA CACACCCACT",
"          ACTAAAANTT ATCAGTCACT",
"          ACTAAAAATT ATCAACCACT",
"          ACTAAAAATT ATCAATCACT",
file = "exdna.txt", sep = "\n")
ex.dna2 <- read.dna("exdna.txt")
## ... in clustal format...
cat("CLUSTAL (ape) multiple sequence alignment", "",
"No305     NTTCGAAAAACACACCCACTACTAAAANTTATCAGTCACT",
"No304     ATTCGAAAAACACACCCACTACTAAAAATTATCAACCACT",
"No306     ATTCGAAAAACACACCCACTACTAAAAATTATCAATCACT",
"           ************************** ******  ****",
file = "exdna.txt", sep = "\n")
ex.dna3 <- read.dna("exdna.txt", format = "clustal")
## ... and in FASTA format
cat(">No305",
"NTTCGAAAAACACACCCACTACTAAAANTTATCAGTCACT",
">No304",
"ATTCGAAAAACACACCCACTACTAAAAATTATCAACCACT",
">No306",
"ATTCGAAAAACACACCCACTACTAAAAATTATCAATCACT",
file = "exdna.fas", sep = "\n")
ex.dna4 <- read.dna("exdna.fas", format = "fasta")
## They are the same:
identical(ex.dna, ex.dna2)
identical(ex.dna, ex.dna3)
identical(ex.dna, ex.dna4)

## How to read compressed files:

## create the ZIP file:
zip("exdna.fas.zip", "exdna.fas")
## create the GZ file with a connection:
con <- gzfile("exdna.fas.gz", "wt")
cat(">No305", "NTTCGAAAAACACACCCACTACTAAAANTTATCAGTCACT",
    ">No304", "ATTCGAAAAACACACCCACTACTAAAAATTATCAACCACT",
    ">No306", "ATTCGAAAAACACACCCACTACTAAAAATTATCAATCACT",
    file = con, sep = "\n")
close(con)

ex.dna5 <- read.dna(unz("exdna.fas.zip", "exdna.fas"), "fasta")
ex.dna6 <- read.dna(gzfile("exdna.fas.gz"), "fasta")
identical(ex.dna5, ex.dna4)
identical(ex.dna6, ex.dna4)

unlink("exdna.txt")
unlink("exdna.fas")
unlink("exdna.fas.zip")
unlink("exdna.fas.gz")

## read a FASTQ file from 1000 Genomes:
\dontrun{
a <- "ftp://ftp.1000genomes.ebi.ac.uk/vol1/ftp/phase3/data/HG00096/sequence_read/"
b <- "SRR062641.filt.fastq.gz"
URL <- paste0(a, b)
download.file(URL, b)
X <- read.fastq(b)
X # 109,811 sequences
## get the qualities of the first sequence:
(qual1 <- attr(X, "QUAL")[[1]])
## the corresponding probabilities:
10^(-qual1/10)
## get the mean quality for each sequence:
mean.qual <- sapply(attr(X, "Q"), mean)
## can do the same for var, sd, ...
}}
\keyword{IO}

\name{vcv2phylo}
\alias{vcv2phylo}
\title{Variance-Covariance Matrix to Tree}
\description{
  This function transforms a variance-covariance matrix into a
  phylogenetic tree.
}
\usage{
vcv2phylo(mat, tolerance = 1e-7)
}
\arguments{
  \item{mat}{a square symmetric (positive-definite) matrix.}
  \item{tolerance}{the numeric tolerance used to compare the branch
    lengths.}
}
\details{
  The function tests if the matrix is symmetric and positive-definite
  (i.e., all its eigenvalues positive within the specified tolerance).
}
\value{
  an object of class \code{"phylo"}.
}
\author{Simon Blomberg}
\seealso{
  \code{\link{vcv}}, \code{\link{corPhyl}}
}
\examples{
tr <- rtree(10)
V <- vcv(tr) # VCV matrix assuming Brownian motion
z <- vcv2phylo(V)
identical(tr, z) # FALSE
all.equal(tr, z) # TRUE
}
\keyword{manip}
\keyword{multivariate}

\name{varcomp}
\alias{varcomp}
\title{Compute Variance Component Estimates}
\description{
  Get variance component estimates from a fitted \code{lme} object.
}
\usage{
varcomp(x, scale = FALSE, cum = FALSE)
}
\arguments{
  \item{x}{A fitted \code{lme} object}
  \item{scale}{Scale all variance so that they sum to 1}
  \item{cum}{Send cumulative variance components.}
}
\details{
  Variance computations is done as in Venables and Ripley (2002).
}
\value{
  A named vector of class \code{varcomp} with estimated variance components.
}
\references{
  Venables, W. N. and Ripley, B. D. (2002) \emph{Modern Applied Statistics
  with S (Fourth Edition)}. New York: Springer-Verlag.
}
\author{Julien Dutheil \email{dutheil@evolbio.mpg.de}}
\seealso{\code{\link[nlme]{lme}}}
\examples{
data(carnivora)
library(nlme)
m <- lme(log10(SW) ~ 1, random = ~ 1|Order/SuperFamily/Family/Genus, data=carnivora)
v <- varcomp(m, TRUE, TRUE)
plot(v)
}
\keyword{regression}
\keyword{dplot}

\name{hivtree}
\alias{hivtree}
\alias{hivtree.newick}
\alias{hivtree.table}

\title{Phylogenetic Tree of 193 HIV-1 Sequences}

\description{
  This data set describes an estimated clock-like phylogeny of 193 HIV-1
  group M sequences sampled in the Democratic Republic of Congo. 
}

\usage{
data(hivtree.newick)
data(hivtree.table)
}

\format{
  \code{hivtree.newick} is a string with the tree in Newick format.
  The data frame \code{hivtree.table} contains the corresponding internode
  distances.
}

\source{
  This is a data example from Strimmer and Pybus (2001).
}

\references{
  Strimmer, K. and Pybus, O. G. (2001) Exploring the demographic history
  of DNA sequences using the generalized skyline plot. \emph{Molecular
    Biology and Evolution}, \bold{18}, 2298--2305.
}

\examples{
# example tree in NH format (a string)
data("hivtree.newick") 
hivtree.newick

# generate file "hivtree.phy" in working directory
cat(hivtree.newick, file = "hivtree.phy", sep = "\n")
tree.hiv <- read.tree("hivtree.phy") # load tree
unlink("hivtree.phy") # delete the file "hivtree.phy"

plot(tree.hiv)

# table with list of internode distances
data("hivtree.table") 
hivtree.table


# construct coalescence intervals
ci <- coalescent.intervals(tree.hiv) # from tree
ci <- coalescent.intervals(hivtree.table$size) #from intervals
ci
}
\keyword{datasets}

\name{ladderize}
\alias{ladderize}
\title{Ladderize a Tree}
\usage{
ladderize(phy, right = TRUE)
}
\arguments{
  \item{phy}{an object of class \code{"phylo"}.}
  \item{right}{a logical specifying whether the smallest clade is on the
    right-hand side (when the tree is plotted upwards), or the opposite
    (if \code{FALSE}).}
}
\description{
  This function reorganizes the internal structure of the tree to get
  the ladderized effect when plotted.
}
\author{Emmanuel Paradis}
\seealso{
  \code{\link{plot.phylo}}, \code{\link{reorder.phylo}}
}
\examples{
tr <- rcoal(50)
layout(matrix(1:4, 2, 2))
plot(tr, main = "normal")
plot(ladderize(tr), main = "right-ladderized")
plot(ladderize(tr, FALSE), main = "left-ladderized")
layout(matrix(1, 1))
}
\keyword{manip}

\name{varCompPhylip}
\alias{varCompPhylip}
\title{Variance Components with Orthonormal Contrasts}
\description{
  This function calls Phylip's contrast program and returns the
  phylogenetic and phenotypic variance-covariance components for one or
  several traits. There can be several observations per species.
}
\usage{
varCompPhylip(x, phy, exec = NULL)
}
\arguments{
  \item{x}{a numeric vector, a matrix (or data frame), or a list.}
  \item{phy}{an object of class \code{"phylo"}.}
  \item{exec}{a character string giving the name of the executable
    contrast program (see details).}
}
\details{
  The data \code{x} can be in several forms: (i) a numeric vector if
  there is single trait and one observation per species; (ii) a
  matrix or data frame if there are several traits (as columns) and a
  single observation of each trait for each species; (iii) a list of
  vectors if there is a single trait and several observations per
  species; (iv) a list of matrices or data frames: same than (ii) but
  with several traits and the rows are individuals.

  If \code{x} has names, its values are matched to the tip labels of
  \code{phy}, otherwise its values are taken to be in the same order
  than the tip labels of \code{phy}.

  Phylip (version 3.68 or higher) must be accessible on your computer. If
  you have a Unix-like operating system, the executable name is assumed
  to be \code{"phylip contrast"} (as in Debian); otherwise it is set
  to \code{"contrast"}. If this doesn't suit your system, use the
  option \code{exec} accordingly. If the executable is not in the path, you
  may need to specify it, e.g., \code{exec = "C:/Program Files/Phylip/contrast"}.
}
\value{
  a list with elements \code{varA} and \code{varE} with the phylogenetic
  (additive) and phenotypic (environmental) variance-covariance
  matrices. If a single trait is analyzed, these contains its variances.
}
\references{
  Felsenstein, J. (2004) Phylip (Phylogeny Inference Package) version
  3.68. Department of Genetics, University of Washington, Seattle, USA.
  \url{http://evolution.genetics.washington.edu/phylip/phylip.html}.

  Felsenstein, J. (2008) Comparative methods with sampling error and
  within-species variation: Contrasts revisited and revised.
  \emph{American Naturalist}, \bold{171}, 713--725.
}
\author{Emmanuel Paradis}
\seealso{
  \code{\link{pic}}, \code{\link{pic.ortho}}, \code{\link{compar.lynch}}
}
\examples{
\dontrun{
tr <- rcoal(30)
### Five traits, one observation per species:
x <- replicate(5, rTraitCont(tr, sigma = 1))
varCompPhylip(x, tr) # varE is small
x <- replicate(5, rnorm(30))
varCompPhylip(x, tr) # varE is large
### Five traits, ten observations per species:
x <- replicate(30, replicate(5, rnorm(10)), simplify = FALSE)
varCompPhylip(x, tr)
}}
\keyword{regression}

\name{which.edge}
\alias{which.edge}
\title{Identifies Edges of a Tree}
\description{
  This function identifies the edges that belong to a group (possibly
  non-monophyletic) specified as a set of tips.
}
\usage{
which.edge(phy, group)
}
\arguments{
  \item{phy}{an object of class \code{"phylo"}.}
  \item{group}{a vector of mode numeric or character specifying the tips
    for which the edges are to be identified.}
}
\details{
  The group of tips specified in `group' may be non-monophyletic
  (paraphyletic or polyphyletic), in which case all edges from the tips
  to their most recent common ancestor are identified.

  The identification is made with the indices of the rows of the matrix
  `edge' of the tree.
}
\value{
  a numeric vector.
}
\author{Emmanuel Paradis}
\seealso{
  \code{\link{bind.tree}}, \code{\link{drop.tip}}, \code{\link{root}}
}
\keyword{manip}

\name{woodmouse}
\alias{woodmouse}
\title{Cytochrome b Gene Sequences of Woodmice}
\description{
  This is a set of 15 sequences of the mitochondrial gene cytochrome
  \emph{b} of the woodmouse (\emph{Apodemus sylvaticus}) which is a
  subset of the data analysed by Michaux et al. (2003). The full data
  set is available through GenBank (accession numbers AJ511877 to
  AJ511987).
}
\usage{
data(woodmouse)
}
\format{
  An object of class \code{"DNAbin"}.
}
\source{
  Michaux, J. R., Magnanou, E., Paradis, E., Nieberding, C. and Libois,
  R. (2003) Mitochondrial phylogeography of the Woodmouse
  (\emph{Apodemus sylvaticus}) in the Western Palearctic region.
  \emph{Molecular Ecology}, \bold{12}, 685--697.
}
\seealso{
  \code{\link{read.dna}}, \code{\link{DNAbin}}, \code{\link{dist.dna}}
}
\examples{
data(woodmouse)
str(woodmouse)
}
\keyword{datasets}

\name{howmanytrees}
\alias{howmanytrees}
\title{Calculate Numbers of Phylogenetic Trees}
\usage{
howmanytrees(n, rooted = TRUE, binary = TRUE,
             labeled = TRUE, detail = FALSE)
}
\arguments{
  \item{n}{a positive numeric integer giving the number of tips.}
  \item{rooted}{a logical indicating whether the trees are rooted
    (default is \code{TRUE}).}
  \item{binary}{a logical indicating whether the trees are bifurcating
    (default is \code{TRUE}).}
  \item{labeled}{a logical indicating whether the trees have tips
    labeled (default is \code{TRUE}).}
  \item{detail}{a logical indicating whether the eventual intermediate
    calculations should be returned (default is \code{FALSE}). This
    applies only for the multifurcating trees, and the bifurcating,
    rooted, unlabeled trees (aka tree shapes).}
}
\description{
  This function calculates the number of possible phylogenetic trees for
  a given number of tips.
}
\details{
  In the cases of labeled binary trees, the calculation is done directly
  and a single numeric value is returned.

  For multifurcating trees, and bifurcating, rooted, unlabeled trees,
  the calculation is done iteratively for 1 to \code{n} tips. Thus the
  user can print all the intermediate values if \code{detail = TRUE}, or
  only a single value if \code{detail = FALSE} (the default).

  For multifurcating trees, if \code{detail = TRUE}, a matrix is
  returned with the number of tips as rows (named from \code{1} to
  \code{n}), and the number of nodes as columns (named from \code{1} to
  \code{n - 1}). For bifurcating, rooted, unlabeled trees, a vector is
  returned with names equal to the number of tips (from \code{1} to
  \code{n}).

  The number of unlabeled trees (aka tree shapes) can be computed only
  for the rooted binary cases.

  Note that if an infinite value (\code{Inf}) is returned this does not
  mean that there is an infinite number of trees (this cannot be if the
  number of tips is finite), but that the calculation is beyond the
  limits of the computer.
}
\value{
  a single numeric value, or in the case where \code{detail = TRUE} is
  used, a named vector or matrix.
}
\references{
  Felsenstein, J. (2004) \emph{Inferring Phylogenies}. Sunderland:
  Sinauer Associates.
}
\author{Emmanuel Paradis}
\examples{
### Table 3.1 in Felsenstein 2004:
for (i in c(1:20, 30, 40, 50))
  cat(paste(i, howmanytrees(i), sep = "\t"), sep ="\n")
### Table 3.6:
howmanytrees(8, binary = FALSE, detail = TRUE)
}
\keyword{arith}
\keyword{math}

\name{read.nexus}
\alias{read.nexus}
\title{Read Tree File in Nexus Format}
\usage{
read.nexus(file, tree.names = NULL, force.multi = FALSE)
}
\arguments{
  \item{file}{a file name specified by either a variable of mode character,
    or a double-quoted string.}
  \item{tree.names}{if there are several trees to be read, a vector of
    mode character giving names to the individual trees (by default,
    this uses the labels in the NEXUS file if these are present).}
  \item{force.multi}{a logical value; if \code{TRUE}, an object of class
    \code{"multiPhylo"} is always returned even if the file contains a
    single tree (see details).}
}
\description{
  This function reads one or several trees in a NEXUS file.
}
\details{
  The present implementation tries to follow as much as possible the
  NEXUS standard (but see the restriction below on TRANSLATION
  tables). Only the block ``TREES'' is read; the other data can be read
  with other functions (e.g., \code{\link{read.dna}},
  \code{\link[utils]{read.table}}, \dots).

  If a TRANSLATION table is present it is assumed that only the tip
  labels are translated and they are all translated with integers
  without gap. Consequently, if nodes have labels in the tree(s) they
  are read as they are and not looked for in the translation table. The
  logic behind this is that in the vast majority of cases, node labels
  will be support values rather than proper taxa names. This is
  consistent with \code{\link{write.nexus}} which translates only the
  tip labels.

  Using \code{force.multi = TRUE} when the file contains a single tree
  makes possible to keep the tree name (as names of the list).

  `read.nexus' tries to represent correctly trees with a badly
  represented root edge (i.e. with an extra pair of parentheses). For
  instance, the tree "((A:1,B:1):10);" will be read like "(A:1,B:1):10;"
  but a warning message will be issued in the former case as this is
  apparently not a valid Newick format. If there are two root edges
  (e.g., "(((A:1,B:1):10):10);"), then the tree is not read and an error
  message is issued.
}
\value{
  an object of class \code{"phylo"} or \code{"multiPhylo"}.
}
\references{
  Maddison, D. R., Swofford, D. L. and Maddison, W. P. (1997) NEXUS: an
  extensible file format for systematic information. \emph{Systematic
    Biology}, \bold{46}, 590--621.
}
\author{Emmanuel Paradis}
\seealso{
  \code{\link{read.tree}}, \code{\link{write.nexus}},
  \code{\link{write.tree}}, \code{\link{read.nexus.data}},
  \code{\link{write.nexus.data}}
}
\keyword{manip}
\keyword{IO}

\name{triangMtd}
\alias{triangMtd}
\alias{triangMtds}
\title{Tree Reconstruction Based on the Triangles Method}
\usage{
triangMtd(X)
triangMtds(X)
}
\arguments{
  \item{X}{a distance matrix}.
}
\description{
  Fast distance-based construction method. Should only be used when
  distance measures are fairly reliable.
}
\value{
  an object of class \code{"phylo"}.
}
\references{
  \url{http://archive.numdam.org/ARCHIVE/RO/RO_2001__35_2/RO_2001__35_2_283_0/RO_2001__35_2_283_0.pdf}
}
\author{Andrei Popescu}
\seealso{
  \code{\link{nj}}, \code{\link{bionj}}, \code{\link{fastme}},
  \code{\link{njs}}, \code{\link{mvrs}}, \code{\link{SDM}}
}
\examples{
data(woodmouse)
tr <- triangMtd(dist.dna(woodmouse))
plot(tr)
}
\keyword{models}

\name{dist.gene}
\alias{dist.gene}
\title{Pairwise Distances from Genetic Data}
\usage{
dist.gene(x, method = "pairwise", pairwise.deletion = FALSE,
          variance = FALSE)
}
\arguments{
  \item{x}{a matrix or a data frame (will be coerced as a matrix).}
  \item{method}{a character string specifying the method used to compute
    the distances; two choices are available: \code{"pairwise"} and
    \code{"percentage"}, or any unambiguous abbreviation of these.}
  \item{pairwise.deletion}{a logical indicating whether to delete the
    columns with missing data on a pairwise basis. The default is to
    delete the columns with at least one missing observation.}
  \item{variance}{a logical, indicates whether the variance of the
    distances should be returned (default to \code{FALSE}).}
}
\description{
  This function computes a matrix of distances between pairs of
  individuals from a matrix or a data frame of genetic data.
}
\details{
  This function is meant to be very general and accepts different kinds
  of data (alleles, haplotypes, SNP, DNA sequences, \dots). The rows of
  the data matrix represent the individuals, and the columns the loci.

  In the case of the pairwise method, the distance \eqn{d} between two
  individuals is the number of loci for which they differ, and the
  associated variance is \eqn{d(L - d)/L}, where \eqn{L} is the number
  of loci.

  In the case of the percentage method, this distance is divided by \eqn{L},
  and the associated variance is \eqn{d(1 - d)/L}.

  For more elaborate distances with DNA sequences, see the function
  \code{dist.dna}.
}
\note{
  Missing data (\code{NA}) are coded and treated in R's usual way.
}
\value{
  an object of class \code{dist}. If \code{variance = TRUE} an
  attribute called \code{"variance"} is given to the returned object.
}
\author{Emmanuel Paradis}
\seealso{
  \code{\link{dist.dna}}, \code{\link{cophenetic.phylo}},
  \code{\link[stats]{dist}}
}
\keyword{manip}

\name{subtreeplot}
\alias{subtreeplot}
\title{Zoom on a Portion of a Phylogeny by Successive Clicks}
\description{
  This function plots simultaneously a whole phylogenetic tree
  (supposedly large) and a portion of it determined by clicking on the nodes of the phylogeny. On exit, returns the last subtree visualized.
}
\usage{
subtreeplot(x, wait=FALSE, ...)
}

\arguments{
  \item{x}{an object of class \code{"phylo"}.}
  \item{wait}{a logical indicating whether the node beeing processed should be printed (useful for big phylogenies).}
  \item{\dots}{further arguments passed to \code{plot.phylo}.}
}
\details{
  This function aims at easily exploring very large trees. The main argument is
  a phylogenetic tree, and the second one is a logical indicating whether a waiting message should be printed while the calculation is being processed. 

  The whole tree is plotted on the left-hand side in half of the device. The
  subtree is plotted on the right-hand side in the other half. The user clicks on the nodes in the complete tree and the subtree corresponding to this node is ploted in the right-hand side. There is no limit for the number of clicks that can be done. On exit, the subtree on the right hand side is returned. 

  To use a subtree as the new tree in which to zoom, the user has to use the function many times. This can however be done in a single command line (see example 2).
}
\author{Damien de Vienne \email{damien.de-vienne@u-psud.fr}}
\seealso{
  \code{\link{plot.phylo}}, \code{\link{drop.tip}}, \code{\link{subtrees}}
}
\examples{
\dontrun{
#example 1: simple
tree1 <- rtree(50)
tree2 <- subtreeplot(tree1, wait = TRUE) # on exit, tree2 will be a subtree of tree1

#example 2: more than one zoom
tree1 <- rtree(60)
tree2 <- subtreeplot(subtreeplot(subtreeplot(tree1))) # allow three succssive zooms
}
}
\keyword{hplot}

\name{axisPhylo}
\alias{axisPhylo}
\title{Axis on Side of Phylogeny}
\usage{
axisPhylo(side = 1, root.time = NULL, backward = TRUE, ...)
}
\arguments{
  \item{side}{a numeric value specifying the side where the axis is
    plotted: 1: below, 2: left, 3: above, 4: right.}
  \item{root.time}{the time assigned to the root node of the tree. By
    default, this is taken from the \code{root.time} element of the
    tree. If it is absent, this is determined from the next option.}
  \item{backward}{a logical value; if TRUE, the most distant tip from
    the root is considered as the origin of the time scale; if FALSE,
    this is the root node.}
  \item{\dots}{further arguments to be passed to \code{axis}.}
}
\description{
  This function adds a scaled axis on the side of a phylogeny plot.
}
\details{
  The further arguments (\code{...}) are used to format the axis. They
  may be \code{font}, \code{cex}, \code{col}, \code{las}, and so on (see
  the help pages on \code{\link[graphics]{axis}} and
  \code{\link[graphics]{par}}).
}
\author{Emmanuel Paradis}
\seealso{
  \code{\link{plot.phylo}}, \code{\link{add.scale.bar}},
  \code{\link[graphics]{axis}}, \code{\link[graphics]{par}}
}
\examples{
tr <- rtree(30)
ch <- rcoal(30)
plot(ch)
axisPhylo()
plot(tr, "c", FALSE, direction = "u")
axisPhylo(2, las = 1)
}
\keyword{aplot}

\name{trans}
\alias{trans}
\alias{complement}
\title{Translation from DNA to Amino Acid Sequences}
\description{
  \code{trans} translates DNA sequences into amino acids.
  \code{complement} returns the (reverse) complement sequences.
}
\usage{
trans(x, code = 1, codonstart = 1)
complement(x)
}
\arguments{
\item{x}{an object of class \code{"DNAbin"} (vector, matrix or list).}
\item{code}{an integer value giving the genetic code to be
  used. Currently only the genetic codes  1 to 6 are supported.}
\item{codonstart}{an integer giving where to start the translation. This
  should be 1, 2, or 3, but larger values are accepted and have for
  effect to start the translation further towards the 3'-end of the sequence.}
}
\details{
  With \code{trans}, if the sequence length is not a multiple of three,
  a warning message is printed. Alignment gaps are simply ignored (i.e.,
  \code{AG-} returns \code{X} with no special warning or message). Base
  ambiguities are taken into account where relevant: for instance,
  \code{GGN}, \code{GGA}, \code{GGR}, etc, all return \code{G}.

  See the link given in the References for details about the taxonomic
  coverage and alternative codons of each code.
}
\value{
  an object of class \code{"AAbin"} or \code{"DNAbin"}, respectively.
}
\note{
  These functions are equivalent to \code{translate} and \code{comp} in
  the package \pkg{seqinr} with the difference that there is no need to
  convert the sequences into character strings.
}
\references{
\url{https://www.ncbi.nlm.nih.gov/Taxonomy/taxonomyhome.html/index.cgi?chapter=cgencodes}
}
\author{Emmanuel Paradis}
\seealso{
\code{\link{AAbin}}, \code{\link{checkAlignment}}, \code{\link{alview}}
}
\examples{
data(woodmouse)
X <- trans(woodmouse) # not correct
X2 <- trans(woodmouse, 2) # using the correct code
identical(X, X2)
alview(X[1:2, 1:60]) # some 'Stop' codons (*)
alview(X2[, 1:60])
X2
}

\name{zoom}
\alias{zoom}
\title{Zoom on a Portion of a Phylogeny}
\description{
  This function plots simultaneously a whole phylogenetic tree
  (supposedly large) and a portion of it.
}
\usage{
zoom(phy, focus, subtree = FALSE, col = rainbow, ...)
}
\arguments{
  \item{phy}{an object of class \code{"phylo"}.}
  \item{focus}{a vector, either numeric or character, or a list of
    vectors specifying the tips to be focused on.}
  \item{subtree}{a logical indicating whether to show the context of the
    extracted subtrees.}
  \item{col}{a vector of colours used to show where the subtrees are in
    the main tree, or a function .}
  \item{\dots}{further arguments passed to \code{plot.phylo}.}
}
\details{
  This function aims at exploring very large trees. The main argument is
  a phylogenetic tree, and the second one is a vector or a list of
  vectors specifying the tips to be focused on. The vector(s) can be
  either numeric and thus taken as the indices of the tip labels, or
  character in which case it is taken as the corresponding tip labels.

  The whole tree is plotted on the left-hand side in a narrower
  sub-window (about a quarter of the device) without tip labels. The
  subtrees consisting of the tips in `focus' are extracted and plotted
  on the right-hand side starting from the top left corner and
  successively column-wise.

  If the argument `col' is a vector of colours, as many colours as the
  number of subtrees must be given. The alternative is to give a
  function that will create colours or grey levels from the number of
  subtrees: see \code{\link[grDevices]{rainbow}} for some possibilities
  with colours.
}
\author{Emmanuel Paradis}
\seealso{
  \code{\link{plot.phylo}}, \code{\link{drop.tip}},
  \code{\link[graphics]{layout}}, \code{\link[grDevices]{rainbow}},
  \code{\link[grDevices]{grey}}
}
\examples{
\dontrun{
data(chiroptera)
zoom(chiroptera, 1:20, subtree = TRUE)
zoom(chiroptera, grep("Plecotus", chiroptera$tip.label))
zoom(chiroptera, list(grep("Plecotus", chiroptera$tip.label),
                      grep("Pteropus", chiroptera$tip.label)))
}
}
\keyword{hplot}

\name{is.ultrametric}
\alias{is.ultrametric}
\alias{is.ultrametric.phylo}
\alias{is.ultrametric.multiPhylo}
\title{Test if a Tree is Ultrametric}
\description{
  This function tests whether a tree is ultrametric using the distances
  from each tip to the root.
}
\usage{
is.ultrametric(phy, ...)
\method{is.ultrametric}{phylo}(phy, tol = .Machine$double.eps^0.5, option = 1, ...)
\method{is.ultrametric}{multiPhylo}(phy, tol = .Machine$double.eps^0.5, option = 1, ...)
}
\arguments{
  \item{phy}{an object of class \code{"phylo"} or \code{"multiPhylo"}.}
  \item{tol}{a numeric >= 0, variation below this value are considered
    non-significant.}
  \item{option}{an integer (1 or 2; see details).}
  \item{\dots}{arguments passed among methods.}
}
\details{
  The test is based on the distances from each tip to the root and a
  criterion: if \code{option = 1}, the criterion is the scaled range
  ((max - min/max)), if \code{option = 2}, the variance is used (this
  was the method used until ape 3.5). The default criterion is invariant
  to linear changes of the branch lengths.
}
\value{
  a logical vector.
}
\author{Emmanuel Paradis}
\seealso{
  \code{\link{is.binary}}, \code{\link[base]{.Machine}}
}
\examples{
is.ultrametric(rtree(10))
is.ultrametric(rcoal(10))
}
\keyword{utilities}

\name{stree}
\alias{stree}
\title{Generates Systematic Regular Trees}
\usage{
stree(n, type = "star", tip.label = NULL)
}
\arguments{
  \item{n}{an integer giving the number of tips in the tree.}
  \item{type}{a character string specifying the type of tree to
    generate; four choices are possible: \code{"star"},
    \code{"balanced"}, \code{"left"}, \code{"right"}, or any unambiguous
    abbreviation of these.}
  \item{tip.label}{a character vector giving the tip labels; if not
    specified, the tips "t1", "t2", ..., are given.}
}
\description{
  This function generates trees with regular shapes.
}
\details{
  The types of trees generated are:

  \itemize{
    \item{``star''}{a star (or comb) tree with a single internal node.}
    \item{``balanced''}{a fully balanced dichotomous rooted tree;
      \code{n} must be a power of 2 (2, 4, 8, \dots).}
    \item{``left''}{a fully unbalanced rooted tree where the largest
      clade is on the left-hand side when the tree is plotted upwards.}
    \item{``right''}{same than above but in the other direction.}
  }
}
\value{
  An object of class \code{"phylo"}.
}
\author{Emmanuel Paradis}
\seealso{
  \code{\link{compute.brlen}}, \code{\link{rtree}}
}
\examples{
layout(matrix(1:4, 2, 2))
plot(stree(100))
plot(stree(128, "balanced"))
plot(stree(100, "left"))
plot(stree(100, "right"))
}
\keyword{datagen}

\name{label2table}
\alias{label2table}
\alias{stripLabel}
\alias{abbreviateGenus}
\title{Label Management}
\description{
  These functions work on a vector of character strings storing bi- or trinomial species names, typically ``Genus_species_subspecies''.
}
\usage{
label2table(x, sep = NULL, as.is = FALSE)
stripLabel(x, species = FALSE, subsp = TRUE, sep = NULL)
abbreviateGenus(x, genus = TRUE, species = FALSE, sep = NULL)
}
\arguments{
  \item{x}{a vector of mode character.}
  \item{sep}{the separator (a single character) between the taxonomic levels (see details).}
  \item{as.is}{a logical specifying whether to convert characters into factors (like in \code{\link[utils]{read.table}}).}
  \item{species, subsp, genus}{a logical specifying whether the taxonomic level is concerned by the operation.}
}
\details{
\code{label2table} returns a data frame with three columns named ``genus'', ``species'', and ``subspecies'' (with \code{NA} if the level is missing).

\code{stripLabel} deletes the subspecies names from the input. If \code{species = TRUE}, the species names are also removed, thus returning only the genus names.

\code{abbreviateGenus} abbreviates the genus names keeping only the first letter. If \code{species = TRUE}, the species names are abbreviated.

By default, these functions try to guess what is the separator between the genus, species and/or subspecies names. If an underscore is present in the input, then this character is assumed to be the separator; otherwise, a space. If this does not work, you can specify \code{sep} to its appropriate value.
}
\value{
  A vector of mode character or a data frame.
}
\author{Emmanuel Paradis}
\seealso{
  \code{\link{makeLabel}}, \code{\link{makeNodeLabel}},
  \code{\link{mixedFontLabel}}, \code{\link{updateLabel}},
  \code{\link{checkLabel}}
}
\examples{
x <- c("Panthera_leo", "Panthera_pardus", "Panthera_onca", "Panthera_uncia",
       "Panthera_tigris_altaica", "Panthera_tigris_amoyensis")
label2table(x)
stripLabel(x)
stripLabel(x, TRUE)
abbreviateGenus(x)
abbreviateGenus(x, species = TRUE)
abbreviateGenus(x, genus = FALSE, species = TRUE)
}
\keyword{manip}

\name{cherry}
\alias{cherry}
\title{Number of Cherries and Null Models of Trees}
\usage{
cherry(phy)
}
\arguments{
  \item{phy}{an object of class \code{"phylo"}.}
}
\description{
  This function calculates the number of cherries (see definition below)
  on a phylogenetic tree, and tests the null hypotheses whether this
  number agrees with those predicted from two null models of trees (the
  Yule model, and the uniform model).
}
\value{
  A NULL value is returned, the results are simply printed.
}
\details{
  A cherry is a pair of adjacent tips on a tree. The tree can be either
  rooted or unrooted, but the present function considers only rooted
  trees. The probability distribution function of the number of cherries
  on a tree depends on the speciation/extinction model that generated
  the tree.

  McKenzie and Steel (2000) derived the probability
  distribution function of the number of cherries for two models: the
  Yule model and the uniform model. Broadly, in the Yule model, each extant
  species is equally likely to split into two daughter-species; in the
  uniform model, a branch is added to tree on any of the already
  existing branches with a uniform probability.

  The probabilities are computed using recursive formulae; however, for
  both models, the probability density function converges to a normal
  law with increasing number of tips in the tree. The function uses
  these normal approximations for a number of tips greater than or equal
  to 20.
}
\references{
  McKenzie, A. and Steel, M. (2000) Distributions of cherries for two
  models of trees. \emph{Mathematical Biosciences}, \bold{164}, 81--92.
}
\author{Emmanuel Paradis}
\seealso{
  \code{\link{gammaStat}}
}
\keyword{univar}

\name{checkValidPhylo}
\alias{checkValidPhylo}
\title{Check the Structure of a "phylo" Object}
\description{
  This function takes as single argument an object (phy), checks its
  elements, and prints a diagnostic. All problems are printed with a
  label: FATAL (will likely cause an error or a crash) or MODERATE (may
  cause some problems).

  This function is mainly intended for developers creating
  \code{"phylo"} objects from scratch.
}
\usage{
checkValidPhylo(phy)
}
\arguments{
  \item{phy}{an object of class \code{"phylo"}.}
}
\value{
  NULL.
}
\author{Emmanuel Paradis}
\examples{
tr <- rtree(3)
checkValidPhylo(tr)
tr$edge[1] <- 0
checkValidPhylo(tr)
}
\keyword{manip}

\name{seg.sites}
\alias{seg.sites}
\title{
  Find Segregating Sites in DNA Sequences
}
\usage{
seg.sites(x, strict = FALSE, trailingGapsAsN = TRUE)
}
\arguments{
  \item{x}{a matrix or a list which contains the DNA sequences.}
  \item{strict}{a logical value; if \code{TRUE}, ambiguities and gaps in
    the sequences are not interpreted in the usual way.}
  \item{trailingGapsAsN}{a logical value; if \code{TRUE} (the default),
    the leading and trailing alignment gaps are considered as unknown
    bases (i.e., N).}
}
\description{
  This function gives the indices of segregating (polymorphic) sites in
  a sample of DNA sequences.
}
\details{
  If the sequences are in a list, they must all be of the same length.

  If \code{strict = FALSE} (the default), the following rule is used to
  determine if a site is polymorphic or not in the presence of ambiguous
  bases: `A' and `R' are not interpreted as different, `A' and `Y' are
  interpreted as different, and `N' and any other base (ambiguous or
  not) are interpreted as not different. If \code{strict = TRUE}, all
  letters are considered different.

  Alignment gaps are considered different from all letters except for
  the leading and trailing gaps if \code{trailingGapsAsN = TRUE} (which
  is the default).
}
\value{
  A numeric (integer) vector giving the indices of the segregating
  sites.
}
\author{Emmanuel Paradis}
\seealso{
  \code{\link{base.freq}}, \code{\link[pegas]{theta.s}},
  \code{\link[pegas]{nuc.div}}
}
\examples{
data(woodmouse)
y <- seg.sites(woodmouse)
y
length(y)
}
\keyword{univar}

\name{mvr}
\alias{mvr}
\alias{mvrs}
\title{Minimum Variance Reduction}
\description{
  Phylogenetic tree construction based on the minimum variance reduction.
}
\usage{
mvr(X, V)
mvrs(X, V, fs = 15)
}
\arguments{
  \item{X}{a distance matrix.}
  \item{V}{a variance matrix.}
  \item{fs}{agglomeration criterion parameter: it is coerced as an
    integer and must at least equal to one.}
}
\details{
  The MVR method can be seen as a version of BIONJ which is not
  restricted to the Poison model of variance (Gascuel 2000).
}
\value{
  an object of class \code{"phylo"}.
}
\references{
  Criscuolo, A. and Gascuel, O. (2008). Fast NJ-like algorithms to deal
  with incomplete distance matrices. \emph{BMC Bioinformatics}, 9.

  Gascuel, O. (2000). Data model and classification by trees: the
  minimum variance reduction (MVR) method. \emph{Journal of
    Classification}, \bold{17}, 67--99.
}
\author{Andrei Popescu}
\seealso{
  \code{\link{bionj}}, \code{\link{fastme}}, \code{\link{njs}},
  \code{\link{SDM}}
}
\examples{
data(woodmouse)
rt <- dist.dna(woodmouse, variance = TRUE)
v <- attr(rt, "variance")
tr <- mvr(rt, v)
plot(tr, "u")
}
\keyword{models}

\name{compar.ou}
\alias{compar.ou}
\title{Ornstein--Uhlenbeck Model for Continuous Characters}
\usage{
compar.ou(x, phy, node = NULL, alpha = NULL)
}
\arguments{
  \item{x}{a numeric vector giving the values of a continuous
    character.}
  \item{phy}{an object of class \code{"phylo"}.}
  \item{node}{a vector giving the number(s) of the node(s) where the
    parameter `theta' (the trait optimum) is assumed to change. The
    node(s) can be specified with their labels if \code{phy} has node
    labels. By default there is no change (same optimum thoughout lineages).}
  \item{alpha}{the value of \eqn{\alpha}{alpha} to be used when fitting
    the model. By default, this parameter is estimated (see details).}
}
\description{
  This function fits an Ornstein--Uhlenbeck model giving a phylogenetic
  tree, and a continuous character. The user specifies the node(s) where
  the optimum changes. The parameters are estimated by maximum
  likelihood; their standard-errors are computed assuming normality of
  these estimates.
}
\details{
  The Ornstein--Uhlenbeck (OU) process can be seen as a generalization
  of the Brownian motion process. In the latter, characters are assumed
  to evolve randomly under a random walk, that is change is equally
  likely in any direction. In the OU model, change is more likely
  towards the direction of an optimum (denoted \eqn{\theta}{theta}) with
  a strength controlled by a parameter denoted \eqn{\alpha}{alpha}.

  The present function fits a model where the optimum parameter
  \eqn{\theta}{theta}, is allowed to vary throughout the tree. This is
  specified with the argument \code{node}: \eqn{\theta}{theta} changes
  after each node whose number is given there. Note that the optimum
  changes \emph{only} for the lineages which are descendants of this
  node.

  Hansen (1997) recommends to not estimate \eqn{\alpha}{alpha} together
  with the other parameters. The present function allows this by giving
  a numeric value to the argument \code{alpha}. By default, this
  parameter is estimated, but this seems to yield very large
  standard-errors, thus validating Hansen's recommendation. In practice,
  a ``poor man estimation'' of \eqn{\alpha}{alpha} can be done by
  repeating the function call with different values of \code{alpha}, and
  selecting the one that minimizes the deviance (see Hansen 1997 for an
  example).

  If \code{x} has names, its values are matched to the tip labels of
  \code{phy}, otherwise its values are taken to be in the same order
  than the tip labels of \code{phy}.

  The user must be careful here since the function requires that both
  series of names perfectly match, so this operation may fail if there
  is a typing or syntax error. If both series of names do not match, the
  values in the \code{x} are taken to be in the same order than the tip
  labels of \code{phy}, and a warning message is issued.
}
\note{
  The inversion of the variance-covariance matrix in the likelihood
  function appeared as somehow problematic. The present implementation
  uses a Cholevski decomposition with the function
  \code{\link[base]{chol2inv}} instead of the usual function
  \code{\link[base]{solve}}.
}
\value{
  an object of class \code{"compar.ou"} which is list with the following
  components:

  \item{deviance}{the deviance (= -2 * loglik).}
  \item{para}{a data frame with the maximum likelihood estimates and
    their standard-errors.}
  \item{call}{the function call.}
}
\references{
  Hansen, T. F. (1997) Stabilizing selection and the comparative
  analysis of adaptation. \emph{Evolution}, \bold{51}, 1341--1351.
}
\author{Emmanuel Paradis}
\seealso{
  \code{\link{ace}}, \code{\link{compar.lynch}},
  \code{\link{corBrownian}}, \code{\link{corMartins}}, \code{\link{pic}}
}
\examples{
data(bird.orders)
### This is likely to give you estimates close to 0, 1, and 0
### for alpha, sigma^2, and theta, respectively:
compar.ou(x <- rnorm(23), bird.orders)
### Much better with a fixed alpha:
compar.ou(x, bird.orders, alpha = 0.1)
### Let us 'mimick' the effect of different optima
### for the two clades of birds...
x <- c(rnorm(5, 0), rnorm(18, 5))
### ... the model with two optima:
compar.ou(x, bird.orders, node = 25, alpha = .1)
### ... and the model with a single optimum:
compar.ou(x, bird.orders, node = NULL, alpha = .1)
### => Compare both models with the difference in deviances
##     which follows a chi^2 with df = 1.
}
\keyword{models}

\name{compute.brlen}
\alias{compute.brlen}
\title{Branch Lengths Computation}
\usage{
compute.brlen(phy, method = "Grafen", power = 1, ...)
}
\arguments{
  \item{phy}{an object of class \code{phylo} representing the tree.}
  \item{method}{the method to be used to compute the branch lengths;
    this must be one of the followings: (i) \code{"Grafen"} (the
    default), (ii) a numeric vector, or (iii) a function.}
  \item{power}{The power at which heights must be raised (see below).}
  \item{\dots}{further argument(s) to be passed to \code{method} if it is
    a function.}
}
\description{
  This function computes branch lengths of a tree using different
  methods.
}
\details{
  Grafen's (1989) computation of branch lengths: each node is given a
  `height', namely the number of leaves of the subtree minus one, 0 for
  leaves. Each height is scaled so that root height is 1, and then
  raised at power 'rho' (> 0). Branch lengths are then computed as the
  difference between height of lower node and height of upper node.

  If one or several numeric values are provided as \code{method}, they
  are recycled if necessary. If a function is given instead, further
  arguments are given in place of \code{...} (they must be named, see
  examples).

  Zero-length branches are not treated as multichotomies, and thus may
  need to be collapsed (see \code{\link{di2multi}}).
}
\value{
  An object of class \code{phylo} with branch lengths.
}
\author{Julien Dutheil \email{dutheil@evolbio.mpg.de} and
  Emmanuel Paradis}
\references{
  Grafen, A. (1989) The phylogenetic regression. \emph{Philosophical
    Transactions of the Royal society of London. Series B. Biological
    Sciences}, \bold{326}, 119--157.
}
\seealso{
  \code{\link{read.tree}} for a description of \code{phylo} objects,
  \code{\link{di2multi}}, \code{\link{multi2di}}
}
\examples{
data(bird.orders)
plot(compute.brlen(bird.orders, 1))
plot(compute.brlen(bird.orders, runif, min = 0, max = 5))
layout(matrix(1:4, 2, 2))
plot(compute.brlen(bird.orders, power=1), main=expression(rho==1))
plot(compute.brlen(bird.orders, power=3), main=expression(rho==3))
plot(compute.brlen(bird.orders, power=0.5), main=expression(rho==0.5))
plot(compute.brlen(bird.orders, power=0.1), main=expression(rho==0.1))
layout(1)
}
\keyword{manip}

\name{node.depth}
\alias{node.depth}
\alias{node.depth.edgelength}
\alias{node.height}
\title{Depth and Heights of Nodes and Tips}
\description{
  These functions return the depths or heights of nodes and tips.
}
\usage{
node.depth(phy, method = 1)
node.depth.edgelength(phy)
node.height(phy, clado.style = FALSE)
}
\arguments{
  \item{phy}{an object of class "phylo".}
  \item{method}{an integer value (1 or 2); 1: the node depths are
    proportional to the number of tips descending from each node, 2:
    they are evenly spaced.}
  \item{clado.style}{a logical value; if \code{TRUE}, the node heights
    are calculated for a cladogram.}
}
\details{
  \code{node.depth} computes the depth of a node depending on the value
  of \code{method} (see the option \code{node.depth} in
  \code{\link{plot.phylo}}). The value of 1 is given to the tips.

  \code{node.depth.edgelength} does the same but using branch lengths.

  \code{node.height} computes the heights of nodes and tips as plotted
  by a phylogram or a cladogram.
}
\value{
  A numeric vector indexed with the node numbers of the matrix `edge' of
  \code{phy}.
}
\author{Emmanuel Paradis}
\seealso{\code{\link{plot.phylo}}}
\keyword{manip}

\name{comparePhylo}
\alias{comparePhylo}
\alias{print.comparePhylo}
\title{Compare Two "phylo" Objects}
\description{
  This function compares two phylogenetic trees, rooted or unrooted, and
  returns a detailed report of this comparison.
}
\usage{
comparePhylo(x, y, plot = FALSE, force.rooted = FALSE,
             use.edge.length = FALSE)
\method{print}{comparePhylo}(x, ...)
}
\arguments{
  \item{x, y}{two objects of class \code{"phylo"}.}
  \item{plot}{a logical value. If \code{TRUE}, the two trees are plotted
    on the same device and their similarities are shown.}
  \item{force.rooted}{a logical value. If \code{TRUE}, the trees are
    considered rooted even if \code{is.rooted} returns \code{FALSE}.}
  \item{use.edge.length}{a logical value passed to
    \code{\link{plot.phylo}} (see below).}
  \item{\dots}{unused.}
}
\details{
  In all cases, the numbers of tips and of nodes and the tip labels are
  compared.

  If both trees are rooted, or if \code{force.rooted = TRUE}, the clade
  compositions of each tree are compared. If both trees are also
  ultrametric, their branching times are compared.

  If both trees are unrooted and have the same number of nodes, the
  bipartitions (aka splits) are compared.

  If \code{plot = TRUE}, the edge lengths are not used by default
  because in some situations with unrooted trees, some splits might not
  be visible if the corresponding internal edge length is very short. To
  use edge lengths, set \code{use.edge.length = TRUE}.
}
\value{
  an object of class \code{"comparePhylo"} which is a list with messages
  from the comparison and, optionally, tables comparing branching times.
}
\author{Emmanuel Paradis}
\seealso{\code{\link{all.equal.phylo}}}
\examples{
## two unrooted trees but force comparison as rooted:
a <- read.tree(text = "(a,b,(c,d));")
b <- read.tree(text = "(a,c,(b,d));")
comparePhylo(a, b, plot = TRUE, force.rooted = TRUE)
## two random unrooted trees:
c <- rtree(5, rooted = FALSE)
d <- rtree(5, rooted = FALSE)
comparePhylo(c, d, plot = TRUE)
}
\keyword{manip}

\name{DNAbin}
\alias{DNAbin}
\alias{print.DNAbin}
\alias{[.DNAbin}
\alias{rbind.DNAbin}
\alias{cbind.DNAbin}
\alias{as.matrix.DNAbin}
\alias{c.DNAbin}
\alias{as.list.DNAbin}
\alias{labels.DNAbin}
\title{Manipulate DNA Sequences in Bit-Level Format}
\description{
  These functions help to manipulate DNA sequences coded in the
  bit-level coding scheme.
}
\usage{
\method{print}{DNAbin}(x, printlen = 6, digits = 3, \dots)
\method{rbind}{DNAbin}(\dots)
\method{cbind}{DNAbin}(\dots, check.names = TRUE, fill.with.gaps = FALSE,
             quiet = FALSE)
\method{[}{DNAbin}(x, i, j, drop = FALSE)
\method{as.matrix}{DNAbin}(x, \dots)
\method{c}{DNAbin}(\dots, recursive = FALSE)
\method{as.list}{DNAbin}(x, \dots)
\method{labels}{DNAbin}(object, \dots)
}
\arguments{
  \item{x, object}{an object of class \code{"DNAbin"}.}
  \item{\dots}{either further arguments to be passed to or from other
    methods in the case of \code{print}, \code{as.matrix}, and
    \code{labels}, or a series of objects of class \code{"DNAbin"} in the
    case of \code{rbind}, \code{cbind}, and \code{c}.}
  \item{printlen}{the number of labels to print (6 by default).}
  \item{digits}{the number of digits to print (3 by default).}
  \item{check.names}{a logical specifying whether to check the rownames
    before binding the columns (see details).}
  \item{fill.with.gaps}{a logical indicating whether to keep all
    possible individuals as indicating by the rownames, and eventually
    filling the missing data with insertion gaps (ignored if
    \code{check.names = FALSE}).}
  \item{quiet}{a logical to switch off warning messages when some rows
    are dropped.}
  \item{i, j}{indices of the rows and/or columns to select or to drop.
    They may be numeric, logical, or character (in the same way than for
    standard \R objects).}
  \item{drop}{logical; if \code{TRUE}, the returned object is of the
    lowest possible dimension.}
  \item{recursive}{for compatibility with the generic (unused).}
}
\details{
  These are all `methods' of generic functions which are here applied to
  DNA sequences stored as objects of class \code{"DNAbin"}. They are
  used in the same way than the standard \R functions to manipulate
  vectors, matrices, and lists. Additionally, the operators \code{[[}
  and \code{$} may be used to extract a vector from a list. Note that
  the default of \code{drop} is not the same than the generic operator:
  this is to avoid dropping rownames when selecting a single sequence.

  These functions are provided to manipulate easily DNA sequences coded
  with the bit-level coding scheme. The latter allows much faster
  comparisons of sequences, as well as storing them in less memory
  compared to the format used before \pkg{ape} 1.10.

  For \code{cbind}, the default behaviour is to keep only individuals
  (as indicated by the rownames) for which there are no missing data. If
  \code{fill.with.gaps = TRUE}, a `complete' matrix is returned,
  enventually with insertion gaps as missing data. If \code{check.names
  = TRUE} (the default), the rownames of each matrix are checked, and
  the rows are reordered if necessary (if some rownames are duplicated,
  an error is returned). If \code{check.names = FALSE}, the matrices
  must all have the same number of rows, and are simply binded; the
  rownames of the first matrix are used. See the examples.

  \code{as.matrix} may be used to convert DNA sequences (of the same
  length) stored in a list into a matrix while keeping the names and the
  class. \code{as.list} does the reverse operation.
}
\value{
  an object of class \code{"DNAbin"} in the case of \code{rbind},
  \code{cbind}, and \code{[}.
}
\references{
  Paradis, E. (2007) A Bit-Level Coding Scheme for Nucleotides.
  \url{http://ape-package.ird.fr/misc/BitLevelCodingScheme_20April2007.pdf}

  Paradis, E. (2012) \emph{Analysis of Phylogenetics and Evolution with
  R (Second Edition).} New York: Springer.
}
\author{Emmanuel Paradis}
\seealso{
  \code{\link{as.DNAbin}}, \code{\link{read.dna}},
  \code{\link{read.GenBank}}, \code{\link{write.dna}},
  \code{\link{image.DNAbin}},\code{\link{AAbin}}

  The corresponding generic functions are documented in the package
  \pkg{base}.
}
\examples{
data(woodmouse)
woodmouse
print(woodmouse, 15, 6)
print(woodmouse[1:5, 1:300], 15, 6)
### Just to show how distances could be influenced by sampling:
dist.dna(woodmouse[1:2, ])
dist.dna(woodmouse[1:3, ])
### cbind and its options:
x <- woodmouse[1:2, 1:5]
y <- woodmouse[2:4, 6:10]
as.character(cbind(x, y)) # gives warning
as.character(cbind(x, y, fill.with.gaps = TRUE))
\dontrun{
as.character(cbind(x, y, check.names = FALSE)) # gives an error
}
}
\keyword{manip}

\name{chronoMPL}
\alias{chronoMPL}
\title{Molecular Dating With Mean Path Lengths}
\usage{
chronoMPL(phy, se = TRUE, test = TRUE)
}
\arguments{
  \item{phy}{an object of class \code{"phylo"}.}
  \item{se}{a logical specifying whether to compute the standard-errors
    of the node ages (\code{TRUE} by default).}
  \item{test}{a logical specifying whether to test the molecular clock
    at each node (\code{TRUE} by default).}
}
\description{
  This function estimates the node ages of a tree using the mean path
  lengths method of Britton et al. (2002). The branch lengths of the
  input tree are interpreted as (mean) numbers of substitutions.
}
\details{
  The mean path lengths (MPL) method estimates the age of a node with
  the mean of the distances from this node to all tips descending from
  it. Under the assumption of a molecular clock, standard-errors of the
  estimates node ages can be computed (Britton et al. 2002).

  The tests performed if \code{test = TRUE} is a comparison of the MPL
  of the two subtrees originating from a node; the null hypothesis is
  that the rate of substitution was the same in both subtrees (Britton
  et al. 2002). The test statistic follows, under the null hypothesis, a
  standard normal distribution. The returned \emph{P}-value is the
  probability of observing a greater absolute value (i.e., a two-sided
  test). No correction for multiple testing is applied: this is left to
  the user.

  Absolute dating can be done by multiplying the edge lengths found by
  calibrating one node age.
}
\note{
  The present version requires a dichotomous tree.
}
\value{
  an object of class \code{"phylo"} with branch lengths as estimated by
  the function. There are, by default, two attributes:

  \item{stderr}{the standard-errors of the node ages.}
  \item{Pval}{the \emph{P}-value of the test of the molecular clock for
    each node.}
}
\references{
  Britton, T., Oxelman, B., Vinnersten, A. and Bremer, K. (2002)
  Phylogenetic dating with confidence intervals using mean path
  lengths. \emph{Molecular Phylogenetics and Evolution}, \bold{24},
  58--65.
}
\author{Emmanuel Paradis}
\seealso{
  \code{\link{chronopl}}
}
\examples{
tr <- rtree(10)
tr$edge.length <- 5*tr$edge.length
chr <- chronoMPL(tr)
layout(matrix(1:4, 2, 2, byrow = TRUE))
plot(tr)
title("The original tree")
plot(chr)
axisPhylo()
title("The dated MPL tree")
plot(chr)
nodelabels(round(attr(chr, "stderr"), 3))
title("The standard-errors")
plot(tr)
nodelabels(round(attr(chr, "Pval"), 3))
title("The tests")
layout(1)
}
\keyword{models}

\name{corMartins}
\alias{corMartins}
\alias{coef.corMartins}
\alias{corMatrix.corMartins}
\title{Martins's (1997) Correlation Structure}
\usage{
corMartins(value, phy, form = ~1, fixed = FALSE)
\method{coef}{corMartins}(object, unconstrained = TRUE, ...)
\method{corMatrix}{corMartins}(object,
		covariate = getCovariate(object), corr = TRUE, ...)
}
\arguments{
  \item{value}{The \eqn{\alpha}{alpha} parameter}
  \item{phy}{An object of class \code{phylo} representing the phylogeny
    (with branch lengths) to consider}
  \item{object}{An (initialized) object of class \code{corMartins}}
  \item{corr}{a logical value. If 'TRUE' the function returns the
    correlation matrix, otherwise it returns  the variance/covariance
    matrix.}
  \item{fixed}{an optional logical value indicating whether the
    coefficients should be allowed to vary in the optimization, ok kept
    fixed at their initial value. Defaults to 'FALSE', in which case the
    coefficients are allowed to vary.}
  \item{form}{a one sided formula of the form ~ t, or ~ t | g, specifying the taxa covariate t and, optionally, a grouping factor g. A covariate for this correlation structure must be character valued, with entries matching the tip labels in the phylogenetic tree. When a grouping factor is present in form, the correlation structure is assumed to apply only to observations within the same grouping level; observations with different grouping levels are assumed to be uncorrelated. Defaults to ~ 1, which corresponds to using the order of the observations in the data as a covariate, and no groups.}
  \item{covariate}{an optional covariate vector (matrix), or list of covariate vectors (matrices), at which values the correlation matrix, or list of correlation matrices, are to be evaluated. Defaults to getCovariate(object).}
  \item{unconstrained}{a logical value. If 'TRUE' the coefficients are returned
    in unconstrained form (the same used in the optimization
    algorithm). If 'FALSE' the coefficients are returned in
    "natural", possibly constrained, form. Defaults to 'TRUE'}
	\item{\dots}{some methods for these generics require additional arguments.
		None are used in these methods.}
}
\description{
	Martins and Hansen's (1997) covariance structure:
		\deqn{V_{ij} = \gamma \times e^{-\alpha t_{ij}}}{%
					Vij = gamma . exp(-alpha . tij)}
	where \eqn{t_{ij}}{tij} is the phylogenetic distance between taxa \eqn{i}{i} and \eqn{j}{j} and \eqn{\gamma}{gamma} is a constant.
}
\value{
	An object of class \code{corMartins} or the alpha coefficient from an object of this class
	or the correlation matrix of an initialized object of this class.
}
\author{Julien Dutheil \email{dutheil@evolbio.mpg.de}}
\seealso{
  \code{\link{corClasses}}.
}
\references{
  Martins, E. P. and Hansen, T. F. (1997) Phylogenies and the comparative
  method: a general approach to incorporating phylogenetic information
  into the analysis of interspecific data. \emph{American Naturalist},
  \bold{149}, 646--667.
}
\keyword{models}

\name{phymltest}
\alias{phymltest}
\alias{print.phymltest}
\alias{summary.phymltest}
\alias{plot.phymltest}
\title{Fits a Bunch of Models with PhyML}
\usage{
phymltest(seqfile, format = "interleaved", itree = NULL,
          exclude = NULL, execname = NULL, append = TRUE)
\method{print}{phymltest}(x, ...)
\method{summary}{phymltest}(object, ...)
\method{plot}{phymltest}(x, main = NULL, col = "blue", ...)
}
\arguments{
  \item{seqfile}{a character string giving the name of the file that
    contains the DNA sequences to be analysed by PhyML.}
  \item{format}{a character string specifying the format of the DNA
    sequences: either \code{"interleaved"} (the default), or
    \code{"sequential"}.}
  \item{itree}{a character string giving the name of a file with a tree
    in Newick format to be used as an initial tree by PhyML. If
    \code{NULL} (the default), PhyML uses a ``BIONJ'' tree.}
  \item{exclude}{a vector of mode character giving the models to be
    excluded from the analysis. These must be among those below, and
    follow the same syntax.}
  \item{execname}{a character string specifying the name of the PhyML
    executable. This argument can be left as \code{NULL} if PhyML's
    default names are used: \code{"phyml_3.0_linux32"},
    \code{"phyml_3.0_macintel"}, or \code{"phyml_3.0_win32.exe"}, under
    Linux, MacOS, or Windows respectively.}
  \item{append}{a logical indicating whether to erase previous PhyML
    output files if present; the default is to not erase.}
  \item{x}{an object of class \code{"phymltest"}.}
  \item{object}{an object of class \code{"phymltest"}.}
  \item{main}{a title for the plot; if left \code{NULL}, a title is made
    with the name of the object (use \code{main = ""} to have no
    title).}
  \item{col}{a colour used for the segments showing the AIC values (blue
    by default).}
  \item{\dots}{further arguments passed to or from other methods.}
}
\description{
  This function calls PhyML and fits successively 28 models of DNA
  evolution. The results are saved on disk, as PhyML usually does, and
  returned in \R as a vector with the log-likelihood value of each model.
}
\details{
  The present function requires version 3.0.1 of PhyML; it won't work with
  older versions.

  The user must take care to set correctly the three different paths
  involved here: the path to PhyML's binary, the path to the sequence
  file, and the path to R's working directory. The function should work
  if all three paths are different. Obviously, there should be no problem
  if they are all the same.

  The following syntax is used for the models:

  "X[Y][Z]00[+I][+G]"

  where "X" is the first letter of the author of the model, "Y" and "Z"
  are possibly other co-authors of the model, "00" is the year of the
  publication of the model, and "+I" and "+G" indicates whether the
  presence of invariant sites and/or a gamma distribution of
  substitution rates have been specified. Thus, Kimura's model is
  denoted "K80" and not "K2P". The exception to this rule is the general
  time-reversible model which is simple denoted "GTR" model.

  The seven substitution models used are: "JC69", "K80", "F81", "F84",
  "HKY85", "TN93", and "GTR". These models are then altered by adding
  the "+I" and/or "+G", resulting thus in four variants for each of them
  (e.g., "JC69", "JC69+I", "JC69+G", "JC69+I+G"). Some of these models
  are described in the help page of \code{\link{dist.dna}}.

  When a gamma distribution of substitution rates is specified, four
  categories are used (which is PhyML's default behaviour), and the
  ``alpha'' parameter is estimated from the data.

  For the models with a different substition rate for transitions and
  transversions, these rates are left free and estimated from the data
  (and not constrained with a ratio of 4 as in PhyML's default).

  The option \code{path2exec} has been removed in the present version:
  the path to PhyML's executable can be specified with the option
  \code{execname}.
}
\note{
  It is important to note that the models fitted by this function is
  only a small fraction of the models possible with PhyML. For instance,
  it is possible to vary the number of categories in the (discretized)
  gamma distribution of substitution rates, and many parameters can be
  fixed by the user. The results from the present function should rather
  be taken as indicative of a best model.
}
\value{
  \code{phymltest} returns an object of class \code{"phymltest"}: a
  numeric vector with the models as names.

  The \code{print} method prints an object of class \code{"phymltest"}
  as matrix with the name of the models, the number of free parameters,
  the log-likelihood value, and the value of the Akaike information
  criterion (AIC = -2 * loglik + 2 * number of free parameters)

  The \code{summary} method prints all the possible likelihood ratio
  tests for an object of class \code{"phymltest"}.

  The \code{plot} method plots the values of AIC of an object of class
  \code{"phymltest"} on a vertical scale.
}
\references{
  Posada, D. and Crandall, K. A. (2001) Selecting the best-fit model of
  nucleotide substitution. \emph{Systematic Biology}, \bold{50},
  580--601.

  Guindon, S. and Gascuel, O. (2003) A simple, fast, and accurate
  algorithm to estimate large phylogenies by maximum likelihood.
  \emph{Systematic Biology}, \bold{52}, 696--704.
  \url{http://www.atgc-montpellier.fr/phyml/}
}
\author{Emmanuel Paradis}
\seealso{
  \code{\link{read.tree}}, \code{\link{write.tree}},
  \code{\link{dist.dna}}
}
\examples{
### A `fake' example with random likelihood values: it does not
### make sense, but does not need PhyML and gives you a flavour
### of what the output looks like:
x <- runif(28, -100, -50)
names(x) <- ape:::.phymltest.model
class(x) <- "phymltest"
x
summary(x)
plot(x)
plot(x, main = "", col = "red")
### This example needs PhyML, copy/paste or type the
### following commands if you want to try them, eventually
### changing setwd() and the options of phymltest()
\dontrun{
setwd("D:/phyml_v2.4/exe") # under Windows
data(woodmouse)
write.dna(woodmouse, "woodmouse.txt")
X <- phymltest("woodmouse.txt")
X
summary(X)
plot(X)
}
}
\keyword{models}

\name{subtrees}
\alias{subtrees}
\title{All subtrees of a Phylogenetic Tree}
\usage{
subtrees(tree, wait=FALSE)
}
\arguments{
  \item{tree}{an object of class \code{"phylo"}.}
  \item{wait}{a logical indicating whether the node beeing processed should be printed (useful for big phylogenies).}
}
\description{
  This function returns a list of all the subtrees of a phylogenetic tree.
}
\author{Damien de Vienne \email{damien.de-vienne@u-psud.fr}}
\seealso{
  \code{\link{zoom}}, \code{\link{subtreeplot}} for functions extracting particular subtrees.
}
\value{
  \code{subtrees} returns a list of trees of class \code{"phylo"} and
  returns invisibly for each subtree a list with the following
  components:

  \item{tip.label}{}
  \item{node.label}{}
  \item{Ntip}{}
  \item{Nnode}{}
}
\examples{
### Random tree with 12 leaves
phy<-rtree(12)
par(mfrow=c(4,3))
plot(phy, sub="Complete tree")

### Extract the subtrees
l<-subtrees(phy)

### plot all the subtrees
for (i in 1:11) plot(l[[i]], sub=paste("Node", l[[i]]$node.label[1]))
par(mfrow=c(1,1))
}
\keyword{manip}

\name{diversi.time}
\alias{diversi.time}
\title{Analysis of Diversification with Survival Models}
\usage{
diversi.time(x, census = NULL, censoring.codes = c(1, 0), Tc = NULL)
}
\arguments{
  \item{x}{a numeric vector with the branching times.}
  \item{census}{a vector of the same length than `x' used as an
    indicator variable; thus, it must have only two values, one coding
    for accurately known branching times, and the other for censored
    branching times. This argument can be of any mode (numeric, character,
    logical), or can even be a factor.}
  \item{censoring.codes}{a vector of length two giving the codes used
    for \code{census}: by default 1 (accurately known times) and 0 (censored
    times). The mode must be the same than the one of \code{census}.}
  \item{Tc}{a single numeric value specifying the break-point time to
    fit Model C. If none is provided, then it is set arbitrarily to the
    mean of the analysed branching times.}
}
\description{
  This functions fits survival models to a set of branching times, some
  of them may be known approximately (censored). Three models are
  fitted, Model A assuming constant diversification, Model B assuming
  that diversification follows a Weibull law, and Model C assuming that
  diversification changes with a breakpoint at time `Tc'. The models are
  fitted by maximum likelihood.
}
\details{
  The principle of the method is to consider each branching time as an
  event: if the branching time is accurately known, then it is a failure
  event; if it is approximately knwon then it is a censoring event. An
  analogy is thus made between the failure (or hazard) rate estimated by
  the survival models and the diversification rate of the lineage. Time
  is here considered from present to past.

  Model B assumes a monotonically changing diversification rate. The
  parameter that controls the change of this rate is called beta. If
  beta is greater than one, then the diversification rate decreases
  through time; if it is lesser than one, the the rate increases through
  time. If beta is equal to one, then Model B reduces to Model A.
}
\value{
  A NULL value is returned, the results are simply printed.
}
\references{
  Paradis, E. (1997) Assessing temporal variations in diversification
  rates from phylogenies: estimation and hypothesis
  testing. \emph{Proceedings of the Royal Society of London. Series
    B. Biological Sciences}, \bold{264}, 1141--1147.
}
\author{Emmanuel Paradis}
\seealso{
  \code{\link{branching.times}}, \code{\link{diversi.gof}}
  \code{\link{ltt.plot}}, \code{\link{birthdeath}},
  \code{\link{bd.ext}}, \code{\link{yule}}, \code{\link{yule.cov}}
}
\keyword{models}

\name{cophenetic.phylo}
\alias{cophenetic.phylo}
\alias{dist.nodes}
\title{Pairwise Distances from a Phylogenetic Tree}
\usage{
\method{cophenetic}{phylo}(x)
dist.nodes(x)
}
\arguments{
  \item{x}{an object of class \code{"phylo"}.}
}
\description{
  \code{cophenetic.phylo} computes the pairwise distances between the
  pairs of tips from a phylogenetic tree using its branch lengths.

  \code{dist.nodes} does the same but between all nodes, internal and
  terminal, of the tree.
}
\value{
  a numeric matrix with colnames and rownames set to the names of the
  tips (as given by the element \code{tip.label} of the argument
  \code{phy}), or, in the case of \code{dist.nodes}, the numbers of the
  tips and the nodes (as given by the element \code{edge}).
}
\author{Emmanuel Paradis}
\seealso{
  \code{\link{read.tree}} to read tree files in Newick format,
  \code{\link[stats]{cophenetic}} for the generic function
}
\keyword{manip}

\name{chronopl}
\alias{chronopl}
\title{Molecular Dating With Penalized Likelihood}
\description{
  This function estimates the node ages of a tree using a
  semi-parametric method based on penalized likelihood (Sanderson
  2002). The branch lengths of the input tree are interpreted as mean
  numbers of substitutions (i.e., per site).
}
\usage{
chronopl(phy, lambda, age.min = 1, age.max = NULL,
         node = "root", S = 1, tol = 1e-8,
         CV = FALSE, eval.max = 500, iter.max = 500, ...)
}
\arguments{
  \item{phy}{an object of class \code{"phylo"}.}
  \item{lambda}{value of the smoothing parameter.}
  \item{age.min}{numeric values specifying the fixed node ages (if
    \code{age.max = NULL}) or the youngest bound of the nodes known to
    be within an interval.}
  \item{age.max}{numeric values specifying the oldest bound of the nodes
    known to be within an interval.}
  \item{node}{the numbers of the nodes whose ages are given by
    \code{age.min}; \code{"root"} is a short-cut for the root.}
  \item{S}{the number of sites in the sequences; leave the default if
    branch lengths are in mean number of substitutions.}
  \item{tol}{the value below which branch lengths are considered
    effectively zero.}
  \item{CV}{whether to perform cross-validation.}
  \item{eval.max}{the maximal number of evaluations of the penalized
    likelihood function.}
  \item{iter.max}{the maximal number of iterations of the optimization
    algorithm.}
  \item{\dots}{further arguments passed to control \code{nlminb}.}
}
\details{
  The idea of this method is to use a trade-off between a parametric
  formulation where each branch has its own rate, and a nonparametric
  term where changes in rates are minimized between contiguous
  branches. A smoothing parameter (lambda) controls this trade-off. If
  lambda = 0, then the parametric component dominates and rates vary as
  much as possible among branches, whereas for increasing values of
  lambda, the variation are smoother to tend to a clock-like model (same
  rate for all branches).

  \code{lambda} must be given. The known ages are given in
  \code{age.min}, and the correponding node numbers in \code{node}.
  These two arguments must obviously be of the same length. By default,
  an age of 1 is assumed for the root, and the ages of the other nodes
  are estimated.

  If \code{age.max = NULL} (the default), it is assumed that
  \code{age.min} gives exactly known ages. Otherwise, \code{age.max} and
  \code{age.min} must be of the same length and give the intervals for
  each node. Some node may be known exactly while the others are
  known within some bounds: the values will be identical in both
  arguments for the former (e.g., \code{age.min = c(10, 5), age.max =
    c(10, 6), node = c(15, 18)} means that the age of node 15 is 10
  units of time, and the age of node 18 is between 5 and 6).

  If two nodes are linked (i.e., one is the ancestor of the other) and
  have the same values of \code{age.min} and \code{age.max} (say, 10 and
  15) this will result in an error because the medians of these values
  are used as initial times (here 12.5) giving initial branch length(s)
  equal to zero. The easiest way to solve this is to change slightly the
  given values, for instance use \code{age.max = 14.9} for the youngest
  node, or \code{age.max = 15.1} for the oldest one (or similarly for
  \code{age.min}).

  The input tree may have multichotomies. If some internal branches are
  of zero-length, they are collapsed (with a warning), and the returned
  tree will have less nodes than the input one. The presence of
  zero-lengthed terminal branches of results in an error since it makes
  little sense to have zero-rate branches.

  The cross-validation used here is different from the one proposed by
  Sanderson (2002). Here, each tip is dropped successively and the
  analysis is repeated with the reduced tree: the estimated dates for
  the remaining nodes are compared with the estimates from the full
  data. For the \eqn{i}{i}th tip the following is calculated:

  \deqn{\sum_{j=1}^{n-2}{\frac{(t_j - t_j^{-i})^2}{t_j}}}{SUM[j = 1, ..., n-2] (tj - tj[-i])^2/tj},

  where \eqn{t_j}{tj} is the estimated date for the \eqn{j}{j}th node
  with the full phylogeny, \eqn{t_j^{-i}}{tj[-i]} is the estimated date
  for the \eqn{j}{j}th node after removing tip \eqn{i}{i} from the tree,
  and \eqn{n}{n} is the number of tips.

  The present version uses the \code{\link[stats]{nlminb}} to optimise
  the penalized likelihood function: see its help page for details on
  parameters controlling the optimisation procedure.
}
\value{
  an object of class \code{"phylo"} with branch lengths as estimated by
  the function. There are three or four further attributes:

  \item{ploglik}{the maximum penalized log-likelihood.}
  \item{rates}{the estimated rates for each branch.}
  \item{message}{the message returned by \code{nlminb} indicating
    whether the optimisation converged.}
  \item{D2}{the influence of each observation on overall date
    estimates (if \code{CV = TRUE}).}
}
\note{
  The new function \code{\link{chronos}} replaces the present one which
  is no more maintained.
}
\references{
  Sanderson, M. J. (2002) Estimating absolute rates of molecular
  evolution and divergence times: a penalized likelihood
  approach. \emph{Molecular Biology and Evolution}, \bold{19},
  101--109.
}
\author{Emmanuel Paradis}
\seealso{
  \code{\link{chronos}}, \code{\link{chronoMPL}}
}
\keyword{models}

\name{is.compatible}
\alias{is.compatible}
\alias{is.compatible.bitsplits}
\alias{arecompatible}
\title{Check Compatibility of Splits}
\description{
  \code{is.compatible} is a generic function with a method for the class
  \code{"bitsplits"}. It checks whether a set of splits is compatible
  using the \code{arecompatible} function.
}
\usage{
is.compatible(obj)
\method{is.compatible}{bitsplits}(obj)
arecompatible(x, y, n)
}
\arguments{
  \item{obj}{an object of class \code{"bitsplits"}.}
  \item{x, y}{a vector of mode raw\code{}.}
  \item{n}{the number of taxa in the splits.}
}
\value{
  \code{TRUE} if the splits are compatible, \code{FALSE} otherwise.
}
\author{Andrei Popescu}
\seealso{\code{\link{as.bitsplits}}}
\keyword{manip}

\name{dist.topo}
\alias{dist.topo}
\title{Topological Distances Between Two Trees}
\description{
  This function computes the topological distance between two
  phylogenetic trees or among trees in a list (if \code{y = NULL} using
  different methods.
}
\usage{
dist.topo(x, y = NULL, method = "PH85")
}
\arguments{
  \item{x}{an object of class \code{"phylo"} or of class
    \code{"multiPhylo"}.}
  \item{y}{an (optional) object of class \code{"phylo"}.}
  \item{method}{a character string giving the method to be used: either
    \code{"PH85"}, or \code{"score"}.}
}
\value{
  a single numeric value if both \code{x} and \code{y} are used, an
  object of class \code{"dist"} otherwise.
}
\details{
  Two methods are available: the one by Penny and Hendy (1985,
  originally from Robinson and Foulds 1981), and the branch length score
  by Kuhner and Felsenstein (1994). The trees are always considered as
  unrooted.

  The topological distance is defined as twice the number of internal
  branches defining different bipartitions of the tips (Robinson and
  Foulds 1981; Penny and Hendy 1985). Rzhetsky and Nei (1992) proposed a
  modification of the original formula to take multifurcations into
  account.

  The branch length score may be seen as similar to the previous
  distance but taking branch lengths into account. Kuhner and
  Felsenstein (1994) proposed to calculate the square root of the sum of
  the squared differences of the (internal) branch lengths defining
  similar bipartitions (or splits) in both trees.
}
\note{
  The geodesic distance of Billera et al. (2001) has been disabled: see
  the package \pkg{distory} on CRAN.
}
\references{
  Billera, L. J., Holmes, S. P. and Vogtmann, K. (2001) Geometry of the
  space of phylogenetic trees. \emph{Advances in Applied Mathematics},
  \bold{27}, 733--767.

  Kuhner, M. K. and Felsenstein, J. (1994) Simulation comparison of
  phylogeny algorithms under equal and unequal evolutionary rates.
  \emph{Molecular Biology and Evolution}, \bold{11}, 459--468.

  Nei, M. and Kumar, S. (2000) \emph{Molecular Evolution and
  Phylogenetics}. Oxford: Oxford University Press.

  Penny, D. and Hendy, M. D. (1985) The use of tree comparison
  metrics. \emph{Systemetic Zoology}, \bold{34}, 75--82.

  Robinson, D. F. and Foulds, L. R. (1981) Comparison of phylogenetic
  trees. \emph{Mathematical Biosciences}, \bold{53}, 131--147.

  Rzhetsky, A. and Nei, M. (1992) A simple method for estimating and
  testing minimum-evolution trees. \emph{Molecular Biology and
    Evolution}, \bold{9}, 945--967.
}
\author{Emmanuel Paradis}
\seealso{
  \code{\link{cophenetic.phylo}}, \code{\link{prop.part}}
}
\examples{
ta <- rtree(30)
tb <- rtree(30)
dist.topo(ta, ta) # 0
dist.topo(ta, tb) # unlikely to be 0
}
\keyword{manip}

\name{read.nexus.data}
\alias{read.nexus.data}
\alias{nexus2DNAbin}
\title{
  Read Character Data In NEXUS Format
}
\description{
  \code{read.nexus.data} reads a file with sequences in the NEXUS
  format. \code{nexus2DNAbin} is a helper function to convert the output
  from the previous function into the class \code{"DNAbin"}.
}
\usage{
read.nexus.data(file)
nexus2DNAbin(x)
}
\arguments{
  \item{file}{a file name specified by either a variable of mode
    character, or a double-quoted string.}
  \item{x}{an object output by \code{read.nexus.data}.}
}
\details{
  This parser tries to read data from a file written in a
  \emph{restricted} NEXUS format (see examples below).

  Please see files \file{data.nex} and \file{taxacharacters.nex} for
  examples of formats that will work.

  Some noticeable exceptions from the NEXUS standard (non-exhaustive
  list):

  \itemize{
    \item{\bold{I}}{Comments must be either on separate lines or at the
      end of lines. Examples:\cr
      \code{[Comment]} \bold{--- OK}\cr
      \code{Taxon ACGTACG [Comment]} \bold{--- OK}\cr
      \code{[Comment line 1}

      \code{Comment line 2]} \bold{--- NOT OK!}\cr
      \code{Tax[Comment]on ACG[Comment]T} \bold{--- NOT OK!}}
    \item{\bold{II}}{No spaces (or comments) are allowed in the
      sequences. Examples:\cr
      \code{name ACGT} \bold{--- OK}\cr
      \code{name AC GT} \bold{--- NOT OK!}}
    \item{\bold{III}}{No spaces are allowed in taxon names, not even if
      names are in single quotes. That is, single-quoted names are not
      treated as such by the parser. Examples:\cr
      \code{Genus_species} \bold{--- OK}\cr
      \code{'Genus_species'} \bold{--- OK}\cr
      \code{'Genus species'} \bold{--- NOT OK!}}
    \item{\bold{IV}}{The trailing \code{end} that closes the
      \code{matrix} must be on a separate line. Examples:\cr
      \code{taxon AACCGGT}

      \code{end;} \bold{--- OK}\cr
      \code{taxon AACCGGT;}

      \code{end;} \bold{--- OK}\cr
      \code{taxon AACCCGT; end;} \bold{--- NOT OK!}}
    \item{\bold{V}}{Multistate characters are not allowed. That is,
      NEXUS allows you to specify multiple character states at a
      character position either as an uncertainty, \code{(XY)}, or as an
      actual appearance of multiple states, \code{\{XY\}}. This is
      information is not handled by the parser. Examples:\cr
      \code{taxon 0011?110} \bold{--- OK}\cr
      \code{taxon 0011{01}110} \bold{--- NOT OK!}\cr
      \code{taxon 0011(01)110} \bold{--- NOT OK!}}
    \item{\bold{VI}}{The number of taxa must be on the same line as
      \code{ntax}. The same applies to \code{nchar}. Examples:\cr
      \code{ntax = 12} \bold{--- OK}\cr
      \code{ntax =}

      \code{12} \bold{--- NOT OK!}}
    \item{\bold{VII}}{The word \dQuote{matrix} can not occur anywhere in
      the file before the actual \code{matrix} command, unless it is in
      a comment. Examples:\cr
      \code{BEGIN CHARACTERS;}

      \code{TITLE 'Data in file "03a-cytochromeB.nex"';}

      \code{DIMENSIONS  NCHAR=382;}

      \code{FORMAT DATATYPE=Protein GAP=- MISSING=?;}

      \code{["This is The Matrix"]} \bold{--- OK}

      \code{MATRIX}\cr

      \code{BEGIN CHARACTERS;}

      \code{TITLE 'Matrix in file "03a-cytochromeB.nex"';} \bold{--- NOT OK!}

      \code{DIMENSIONS  NCHAR=382;}

      \code{FORMAT DATATYPE=Protein GAP=- MISSING=?;}

      \code{MATRIX}}
  }
}
\value{
  A list of sequences each made of a single vector of mode character
  where each element is a (phylogenetic) character state.
}
\references{
  Maddison, D. R., Swofford, D. L. and Maddison, W. P. (1997) NEXUS: an
  extensible file format for systematic information. \emph{Systematic
    Biology}, \bold{46}, 590--621.
}
\author{Johan Nylander, Thomas Guillerme, and Klaus Schliep}
\seealso{
  \code{\link{read.nexus}}, \code{\link{write.nexus}},
  \code{\link{write.nexus.data}}
}
\examples{
## Use read.nexus.data to read a file in NEXUS format into object x
\dontrun{x <- read.nexus.data("file.nex")}
}
\keyword{file}

\name{nodepath}
\alias{nodepath}
\title{Find Paths of Nodes}
\description{
  This function finds paths of nodes in a tree. The nodes can be
  internal and/or terminal (i.e., tips).
}
\usage{
nodepath(phy, from = NULL, to = NULL)
}
\arguments{
  \item{phy}{an object of class \code{"phylo"}.}
  \item{from, to}{integers giving node or tip numbers.}
}
\details{
  By default, this function returns all the paths from the root to each
  tip of the tree. If both arguments \code{from} and \code{to} are
  specified, the shortest path of nodes linking them is returned.
}
\value{
  a list of vectors of integers (by default), or a single vector of
  integers.
}
\author{Emmanuel Paradis}
\seealso{\code{\link{getMRCA}}}
\examples{
tr <- rtree(2)
nodepath(tr)
nodepath(tr, 1, 2)
}
\keyword{manip}

\name{as.phylo.formula}
\alias{as.phylo.formula}
\title{Conversion from Taxonomy Variables to Phylogenetic Trees}
\description{
  The function \code{as.phylo.formula} (short form \code{as.phylo})
  builds a phylogenetic tree (an object of class \code{phylo}) from
  a set of nested taxonomic variables.
}
\usage{
\method{as.phylo}{formula}(x, data = parent.frame(), collapse = TRUE, ...)
}
\arguments{
  \item{x}{a right-side formula describing the taxonomic relationship:
    \code{~C1/C2/.../Cn}.}
  \item{data}{the data.frame where to look for the variables (default
    to user's workspace).}
  \item{collapse}{a logical value specifying whether to collapse single
    nodes in the returned tree (see details).}
  \item{\dots}{further arguments to be passed from other methods.}
}
\details{
  Taxonomic variables must be nested and passed in the correct order:
  the higher clade must be on the left of the formula, for instance
  \code{~Order/Family/Genus/Species}. In most cases, the resulting tree
  will be unresolved and will contain polytomies.

  The option \code{collapse = FALSE} has for effect to add single nodes
  in the tree when a given higher level has only one element in the
  level below (e.g., a monospecific genus); see the example below.
}
\value{
  an object of class \code{"phylo"}.
}
\author{Julien Dutheil \email{dutheil@evolbio.mpg.de} and Eric
  Marcon}
\seealso{
  \code{\link{as.phylo}}, \code{\link{read.tree}} for a
  description of \code{"phylo"} objects, \code{\link{multi2di}}
}
\examples{
data(carnivora)
frm <- ~SuperFamily/Family/Genus/Species
tr <- as.phylo(frm, data = carnivora)
plot(tr)
Nnode(tr)
## compare with:
Nnode(as.phylo(frm, data = carnivora, collapse = FALSE))
}
\keyword{manip}

\name{correlogram.formula}
\alias{correlogram.formula}
\title{Phylogenetic Correlogram}
\usage{
  correlogram.formula(formula, data = NULL, use = "all.obs")
}
\arguments{
  \item{formula}{a formula of the type \code{y1+..+yn ~ g1/../gn}, where
    the \code{y}'s are the data to analyse and the \code{g}'s are the
    taxonomic levels.}
  \item{data}{a data frame containing the variables specified in the
    formula. If \code{NULL}, the variables are sought in the user's
    workspace.}
  \item{use}{a character string specifying how to handle missing
    values (i.e., \code{NA}). This must be one of  "all.obs",
    "complete.obs", or "pairwise.complete.obs", or any unambiguous
    abbrevation of these. In the first case, the presence of missing
    values produces an error. In the second case, all rows with missing
    values will be removed before computation. In the last case, missing
    values are removed on a case-by-case basis.}
}
\description{
  This function computes a correlogram from taxonomic levels.
}
\details{
  See the vignette in R: \code{vignette("MoranI")}.
}
\value{
  An object of class \code{correlogram} which is a data frame with three
  columns:

  \item{obs}{the computed Moran's I}
  \item{p.values}{the corresponding P-values}
  \item{labels}{the names of each level}

  or an object of class \code{correlogramList} containing a list of
  objects of class \code{correlogram} if several variables are given as
  response in \code{formula}.
}
\author{Julien Dutheil \email{dutheil@evolbio.mpg.de} and
  Emmanuel Paradis}
\seealso{
  \code{\link{plot.correlogram}, \link{Moran.I}}
}
\examples{
data(carnivora)
### Using the formula interface:
co <- correlogram.formula(SW ~ Order/SuperFamily/Family/Genus,
      data=carnivora)
co
plot(co)
### Several correlograms on the same plot:
cos <- correlogram.formula(SW + FW ~ Order/SuperFamily/Family/Genus,
      data=carnivora)
cos
plot(cos)
}
\keyword{regression}

\name{compar.cheverud}
\alias{compar.cheverud}
\title{Cheverud's Comparative Method}
\description{
  This function computes the phylogenetic variance component and the
  residual deviation for continous characters, taking into account the
  phylogenetic relationships among species, following the comparative
  method described in Cheverud et al. (1985). The correction proposed by
  Rholf (2001) is used.
}
\usage{
compar.cheverud(y, W, tolerance = 1e-06, gold.tol = 1e-04)
}
\arguments{
  \item{y}{A vector containing the data to analyse.}
  \item{W}{The phylogenetic connectivity matrix. All diagonal elements
    will be ignored.}
  \item{tolerance}{Minimum difference allowed to consider eigenvalues as
    distinct.}
  \item{gold.tol}{Precision to use in golden section search alogrithm.}
}
\details{
  Model: \deqn{y = \rho W y + e}{y = rho.W.y + e}

  where \eqn{e}{e} is the error term, assumed to be normally distributed.
  \eqn{\rho}{rho} is estimated by the maximum likelihood procedure given
  in Rohlf (2001), using a golden section search algorithm. The code of
  this function is indeed adapted from a MatLab code given in appendix
  in Rohlf's article, to correct a mistake in Cheverud's original paper.
}
\value{
  A list with the following components:

  \item{rhohat}{The maximum likelihood estimate of \eqn{\rho}{rho}}
  \item{Wnorm}{The normalized version of \code{W}}
  \item{residuals}{Error terms (\eqn{e}{e})}
}
\references{
  Cheverud, J. M., Dow, M. M. and Leutenegger, W. (1985) The quantitative
  assessment of phylogenetic constraints in comparative analyses: sexual
  dimorphism in body weight among primates. \emph{Evolution},
  \bold{39}, 1335--1351.

  Rohlf, F. J. (2001) Comparative methods for the analysis of continuous
  variables: geometric interpretations. \emph{Evolution}, \bold{55},
  2143--2160.

  Harvey, P. H. and Pagel, M. D. (1991) \emph{The Comparative Method in
    Evolutionary Biology}. Oxford University Press.
}
\author{Julien Dutheil \email{dutheil@evolbio.mpg.de}}
\seealso{\code{\link{compar.lynch}}}
\examples{
### Example from Harvey and Pagel's book:
y<-c(10,8,3,4)
W <- matrix(c(1,1/6,1/6,1/6,1/6,1,1/2,1/2,1/6,1/2,1,1,1/6,1/2,1,1), 4)
compar.cheverud(y,W)
### Example from Rohlf's 2001 article:
W<- matrix(c(
  0,1,1,2,0,0,0,0,
  1,0,1,2,0,0,0,0,
  1,1,0,2,0,0,0,0,
  2,2,2,0,0,0,0,0,
  0,0,0,0,0,1,1,2,
  0,0,0,0,1,0,1,2,
  0,0,0,0,1,1,0,2,
  0,0,0,0,2,2,2,0
),8)
W <- 1/W
W[W == Inf] <- 0
y<-c(-0.12,0.36,-0.1,0.04,-0.15,0.29,-0.11,-0.06)
compar.cheverud(y,W)
}
\keyword{regression}

\name{rTraitDisc}
\alias{rTraitDisc}
\title{Discrete Character Simulation}
\usage{
rTraitDisc(phy, model = "ER", k = if (is.matrix(model)) ncol(model) else 2,
           rate = 0.1, states = LETTERS[1:k], freq = rep(1/k, k),
           ancestor = FALSE, root.value = 1, ...)
}
\arguments{
  \item{phy}{an object of class \code{"phylo"}.}
  \item{model}{a character, a square numeric matrix, or a function
    specifying the model (see details).}
  \item{k}{the number of states of the character.}
  \item{rate}{the rate of change used if \code{model} is a character; it
    is \emph{not} recycled if \code{model = "ARD"} of \code{model =
      "SYM"}.}
  \item{states}{the labels used for the states; by default ``A'', ``B'',
    \dots}
  \item{freq}{a numeric vector giving the equilibrium relative
    frequencies of each state; by default the frequencies are equal.}
  \item{ancestor}{a logical value specifying whether to return the
    values at the nodes as well (by default, only the values at the tips
    are returned).}
  \item{root.value}{an integer giving the value at the root (by default,
    it's the first state). To have a random value, use \code{root.value
      = sample(k)}.}
  \item{\dots}{further arguments passed to \code{model} if it is a
    function.}
}
\description{
  This function simulates the evolution of a discrete character along a
  phylogeny. If \code{model} is a character or a matrix, evolution is
  simulated with a Markovian model; the transition probabilities are
  calculated for each branch with \eqn{P = e^{Qt}} where \eqn{Q} is the
  rate matrix given by \code{model} and \eqn{t} is the branch length.
  The calculation is done recursively from the root. See Paradis (2006,
  p. 101) for a general introduction applied to evolution.
}
\details{
  There are three possibilities to specify \code{model}:

\itemize{
  \item{A matrix:}{it must be a numeric square matrix; the diagonal is
    always ignored. The arguments \code{k} and \code{rate} are ignored.}

  \item{A character:}{these are the same short-cuts than in the function
  \code{\link{ace}}: \code{"ER"} is an equal-rates model, \code{"ARD"}
  is an all-rates-different model, and \code{"SYM"} is a symmetrical
  model. Note that the argument \code{rate} must be of the appropriate
  length, i.e., 1, \eqn{k(k - 1)}, or \eqn{k(k - 1)/2} for the three models,
  respectively. The rate matrix \eqn{Q} is then filled column-wise.}

  \item{A function:}{it must be of the form \code{foo(x, l)} where
    \code{x} is the trait of the ancestor and \code{l} is the branch
    length. It must return the value of the descendant as an integer.}
}}
\value{
  A factor with names taken from the tip labels of \code{phy}. If
  \code{ancestor = TRUE}, the node labels are used if present,
  otherwise, ``Node1'', ``Node2'', etc.
}
\references{
  Paradis, E. (2006) \emph{Analyses of Phylogenetics and Evolution with
    R.} New York: Springer.
}
\author{Emmanuel Paradis}
\seealso{
  \code{\link{rTraitCont}}, \code{\link{rTraitMult}}, \code{\link{ace}}
}
\examples{
data(bird.orders)
### the two followings are the same:
rTraitDisc(bird.orders)
rTraitDisc(bird.orders, model = matrix(c(0, 0.1, 0.1, 0), 2))

### two-state model with irreversibility:
rTraitDisc(bird.orders, model = matrix(c(0, 0, 0.1, 0), 2))

### simple two-state model:
tr <- rcoal(n <- 40, br = runif)
x <- rTraitDisc(tr, ancestor = TRUE)
plot(tr, show.tip.label = FALSE)
nodelabels(pch = 19, col = x[-(1:n)])
tiplabels(pch = 19, col = x[1:n])

### an imaginary model with stasis 0.5 time unit after a node, then
### random evolution:
foo <- function(x, l) {
    if (l < 0.5) return(x)
    sample(2, size = 1)
}
tr <- rcoal(20, br = runif)
x <- rTraitDisc(tr, foo, ancestor = TRUE)
plot(tr, show.tip.label = FALSE)
co <- c("blue", "yellow")
cot <- c("white", "black")
Y <- x[1:20]
A <- x[-(1:20)]
nodelabels(A, bg = co[A], col = cot[A])
tiplabels(Y, bg = co[Y], col = cot[Y])
}
\keyword{datagen}

\name{def}
\alias{def}
\title{Definition of Vectors for Plotting or Annotating}
\description{
  This function can be used to define vectors to annotate a set of taxon
  names, labels, etc. It should facilitate the (re)definition of colours
  or similar attributes for plotting trees or other graphics.
}
\usage{
def(x, ..., default = NULL, regexp = FALSE)
}
\arguments{
  \item{x}{a vector of mode character.}
  \item{\dots}{a series of statements defining the attributes.}
  \item{default}{the default to be used (see details).}
  \item{regexp}{a logical value specifying whether the statements
    defined in \code{\dots} should be taken as regular expressions.}
}
\details{
The idea of this function is to make the definition of colours, etc.,
simpler than what is done usually. A typical use is:

\code{def(tr$tip.label, Homo_sapiens = "blue")}

which will return a vector of character strings all "black" except one
matching the tip label "Homo_sapiens" which will be "blue". Another use
could be:

\code{def(tr$tip.label, Homo_sapiens = 2)}

which will return a vector a numerical values all 1 except for
"Homo_sapiens" which will be 2. Several definitions can be done, e.g.:

\code{def(tr$tip.label, Homo_sapiens = "blue", Pan_paniscus = "red")}

The default value is determined with respect to the mode of the values
given with the \code{\dots} (either "black" or 1).

If \code{regexp = TRUE} is used, then the names of the statements must be
quoted, e.g.:

\code{def(tr$tip.label, "^Pan_" = "red", regexp = TRUE)}

will return "red" for all labels starting with "Pan_".
}
\value{
a vector of the same length than \code{x}.
}
\author{Emmanuel Paradis}
\examples{
data(bird.orders)
a <- def(bird.orders$tip.label, Galliformes = 2)
str(a) # numeric
plot(bird.orders, font = a)
co <- def(bird.orders$tip.label, Passeriformes = "red", Trogoniformes = "blue")
str(co) # character
plot(bird.orders, tip.color = co)
### use of a regexp (so we need to quote it) to colour all orders
### with names starting with "C" (and change the default):
co2 <- def(bird.orders$tip.label, "^C" = "gold", default = "grey", regexp = TRUE)
plot(bird.orders, tip.color = co2)
}
\keyword{manip}

\name{balance}
\alias{balance}
\title{Balance of a Dichotomous Phylogenetic Tree}
\usage{
balance(phy)
}
\arguments{
  \item{phy}{an object of class \code{"phylo"}.}
}
\description{
  This function computes the balance of a phylogenetic tree, that is for
  each node of the tree the numbers of descendants (i.e. tips) on each
  of its daughter-branch. The tree must be fully dichotomous.
}
\value{
  a numeric matrix with two columns and one row for each node of the
  tree. The columns give the numbers of descendants on each
  daughter-branches (the order of both columns being arbitrary). If the
  phylogeny \code{phy} has an element \code{node.label}, this is used as
  rownames for the returned matrix; otherwise the numbers (of mode
  character) of the matrix \code{edge} of \code{phy} are used as rownames.
}
\references{
  Aldous, D. J. (2001) Stochastic models and descriptive statistics for
  phylogenetic trees, from Yule to today. \emph{Statistical Science},
  \bold{16}, 23--34.
}
\author{Emmanuel Paradis}
\keyword{manip}

\name{binaryPGLMM}
\alias{binaryPGLMM}
\alias{binaryPGLMM.sim}
\alias{print.binaryPGLMM}
\title{Phylogenetic Generalized Linear Mixed Model for Binary Data}
\description{
  binaryPGLMM performs linear regression for binary phylogenetic data, estimating regression coefficients with approximate standard errors. It simultaneously estimates the strength of phylogenetic signal in the residuals and gives an approximate conditional likelihood ratio test for the hypothesis that there is no signal. Therefore, when applied without predictor (independent) variables, it gives a test for phylogenetic signal for binary data. The method uses a GLMM approach, alternating between penalized quasi-likelihood (PQL) to estimate the "mean components" and restricted maximum likelihood (REML) to estimate the "variance components" of the model.

  binaryPGLMM.sim is a companion function that simulates binary phylogenetic data of the same structure analyzed by binaryPGLMM.
}
\usage{
binaryPGLMM(formula, data = list(), phy, s2.init = 0.1,
            B.init = NULL, tol.pql = 10^-6, maxit.pql = 200,
            maxit.reml = 100)

binaryPGLMM.sim(formula, data = list(), phy, s2 = NULL, B = NULL, nrep = 1)

\method{print}{binaryPGLMM}(x, digits = max(3, getOption("digits") - 3), ...)
}
\arguments{
  \item{formula}{a two-sided linear formula object describing the
    fixed-effects of the model; for example, Y ~ X.}
  \item{data}{a data frame containing the variables named in formula.}
  \item{phy}{a phylogenetic tree as an object of class "phylo".}
  \item{s2.init}{an initial estimate of s2, the scaling component of the
    variance in the PGLMM. A value of s2 = 0 implies no phylogenetic
    signal. Note that the variance-covariance matrix given by the
    phylogeny phy is scaled to have determinant = 1.}
  \item{B.init}{initial estimates of B, the matrix containing regression
    coefficients in the model. This matrix must have
    dim(B.init)=c(p+1,1), where p is the number of predictor
    (independent) variables; the first element of B corresponds to the
    intercept, and the remaining elements correspond in order to the
    predictor (independent) variables in the model.}
  \item{tol.pql}{a control parameter dictating the tolerance for
    convergence for the PQL optimization.}
  \item{maxit.pql}{a control parameter dictating the maximum number of
    iterations for the PQL optimization.}
  \item{maxit.reml}{a control parameter dictating the maximum number of
    iterations for the REML optimization.}
  \item{x}{an object of class "binaryPGLMM".}
  \item{s2}{in binaryPGLMM.sim, value of s2. See s2.init.}
  \item{B}{in binaryPGLMM.sim, value of B, the matrix containing regression coefficients in the model. See B.init.}
  \item{nrep}{in binaryPGLMM.sim,  number of compete data sets produced.}
  \item{digits}{the number of digits to print.}
  \item{\dots}{further arguments passed to \code{print}.}
}
\details{
     The function estimates parameters for the model

  \deqn{Pr(Y = 1) = q }
  \deqn{q = inverse.logit(b0 + b1 * x1 + b2 * x2 + \dots + \epsilon)}
  \deqn{\epsilon ~ Gaussian(0, s2 * V) }

where \eqn{V} is a variance-covariance matrix derived from a phylogeny (typically under the assumption of Brownian motion evolution). Although mathematically there is no requirement for \eqn{V} to be ultrametric, forcing \eqn{V} into ultrametric form can aide in the interpretation of the model, because in regression for binary dependent variables, only the off-diagonal elements (i.e., covariances) of matrix \eqn{V} are biologically meaningful (see Ives & Garland 2014).

The function converts a phylo tree object into a variance-covariance matrix, and further standardizes this matrix to have determinant = 1. This in effect standardizes the interpretation of the scalar s2. Although mathematically not required, it is a very good idea to standardize the predictor (independent) variables to have mean 0 and variance 1. This will make the function more robust and improve the interpretation of the regression coefficients. For categorical (factor) predictor variables, you will need to construct 0-1 dummy variables, and these should not be standardized (for obvious reasons).

The estimation method alternates between PQL to obtain estimates of the mean components of the model (this is the standard approach to estimating GLMs) and REML to obtain estimates of the variance components. This method gives relatively fast and robust estimation. Nonetheless, the estimates of the coefficients B will generally be upwards bias, as is typical of estimation for binary data. The standard errors of B are computed from the PQL results conditional on the estimate of s2 and therefore should tend to be too small. The function returns an approximate P-value for the hypothesis of no phylogenetic signal in the residuals (i.e., H0:s2 = 0) using an approximate likelihood ratio test based on the conditional REML likelihood (rather than the marginal likelihood). Simulations have shown that these P-values tend to be high (giving type II errors: failing to identify variances that in fact are statistically significantly different from zero).

It is a good idea to confirm statistical inferences using parametric bootstrapping, and the companion function binaryPGLMM.sim gives a simply tool for this. See Examples below.
}
\value{
  An object of class "binaryPGLMM".

  \item{formula}{formula specifying the regression model.}
  \item{B}{estimates of the regression coefficients.}
  \item{B.se}{approximate PQL standard errors of the regression
    coefficients.}
  \item{B.cov}{approximate PQL covariance matrix for the regression
    coefficients.}
  \item{B.zscore}{approximate PQL Z scores for the regression
    coefficients.}
  \item{B.pvalue}{approximate PQL tests for the regression coefficients
    being different from zero.}
  \item{s2}{phylogenetic signal measured as the scalar magnitude of the
    phylogenetic variance-covariance matrix s2 * V.}
  \item{P.H0.s2}{approximate likelihood ratio test of the hypothesis H0
    that s2 = 0. This test is based on the conditional REML (keeping the
    regression coefficients fixed) and is prone to inflated type 1 errors.}
  \item{mu}{for each data point y, the estimate of p that y = 1.}
  \item{b}{for each data point y, the estimate of inverse.logit(p).}
  \item{X}{the predictor (independent) variables returned in matrix form
    (including 1s in the first column).}
  \item{H}{residuals of the form b + (Y - mu)/(mu * (1 - mu)).}
  \item{B.init}{the user-provided initial estimates of B. If B.init is
    not provided, these are estimated using glm() assuming no phylogenetic
    signal. The glm() estimates can generate convergence problems, so
    using small values (e.g., 0.01) is more robust but slower.}
  \item{VCV}{the standardized phylogenetic variance-covariance matrix.}
  \item{V}{estimate of the covariance matrix of H.}
  \item{convergeflag}{flag for cases when convergence failed.}
  \item{iteration}{number of total iterations performed.}
  \item{converge.test.B}{final tolerance for B.}
  \item{converge.test.s2}{final tolerance for s2.}
  \item{rcondflag}{number of times B is reset to 0.01. This is done when
    rcond(V) < 10^(-10), which implies that V cannot be inverted.}
  \item{Y}{in binaryPGLMM.sim, the simulated values of Y.}
}
\author{Anthony R. Ives}
\references{
  Ives, A. R. and Helmus, M. R. (2011) Generalized linear mixed models
  for phylogenetic analyses of community structure. \emph{Ecological
    Monographs}, \bold{81}, 511--525.

  Ives, A. R. and Garland, T., Jr. (2014) Phylogenetic regression for
  binary dependent variables. Pages 231--261 \emph{in} L. Z. Garamszegi,
  editor. \emph{Modern Phylogenetic Comparative Methods and Their
  Application in Evolutionary Biology}. Springer-Verlag, Berlin
  Heidelberg.

}
\seealso{
  package \pkg{pez} and its function \code{communityPGLMM};
  package \pkg{phylolm} and its function \code{phyloglm};
  package \pkg{MCMCglmm}
}
\examples{
## Illustration of binaryPGLMM() with simulated data

# Generate random phylogeny

n <- 100
phy <- compute.brlen(rtree(n=n), method = "Grafen", power = 1)

# Generate random data and standardize to have mean 0 and variance 1
X1 <- rTraitCont(phy, model = "BM", sigma = 1)
X1 <- (X1 - mean(X1))/var(X1)

# Simulate binary Y
sim.dat <- data.frame(Y=array(0, dim=n), X1=X1, row.names=phy$tip.label)
sim.dat$Y <- binaryPGLMM.sim(Y ~ X1, phy=phy, data=sim.dat, s2=.5,
                             B=matrix(c(0,.25),nrow=2,ncol=1), nrep=1)$Y

# Fit model
binaryPGLMM(Y ~ X1, phy=phy, data=sim.dat)

\dontrun{
# Compare with phyloglm()
library(phylolm)
summary(phyloglm(Y ~ X1, phy=phy, data=sim.dat))

# Compare with glm() that does not account for phylogeny
summary(glm(Y ~ X1, data=sim.dat, family="binomial"))

# Compare with logistf() that does not account
# for phylogeny but is less biased than glm()
library(logistf)
logistf(Y ~ X1, data=sim.dat)

# Compare with MCMCglmm
library(MCMCglmm)

V <- vcv(phy)
V <- V/max(V)
detV <- exp(determinant(V)$modulus[1])
V <- V/detV^(1/n)

invV <- Matrix(solve(V),sparse=T)
sim.dat$species <- phy$tip.label
rownames(invV) <- sim.dat$species

nitt <- 43000
thin <- 10
burnin <- 3000

prior <- list(R=list(V=1, fix=1), G=list(G1=list(V=1, nu=1000, alpha.mu=0, alpha.V=1)))
summary(MCMCglmm(Y ~ X1, random=~species, ginvers=list(species=invV),
    data=sim.dat, slice=TRUE, nitt=nitt, thin=thin, burnin=burnin,
    family="categorical", prior=prior, verbose=FALSE))

## Examine bias in estimates of B1 and s2 from binaryPGLMM with
# simulated data. Note that this will take a while.

Reps = 1000

s2 <- 0.4
B1 <- 1

meanEsts <- data.frame(n = Inf, B1 = B1, s2 = s2, Pr.s2 = 1, propconverged = 1)

for (n in c(160, 80, 40, 20)) {

  meanEsts.n <- data.frame(B1 = 0, s2 = 0, Pr.s2 = 0, convergefailure = 0)
    for (rep in 1:Reps) {
      phy <- compute.brlen(rtree(n = n), method = "Grafen", power = 1)
      X <- rTraitCont(phy, model = "BM", sigma = 1)
      X <- (X - mean(X))/var(X)

      sim.dat <- data.frame(Y = array(0, dim = n), X = X, row.names = phy$tip.label)
      sim <- binaryPGLMM.sim(Y ~ 1 + X, phy = phy, data = sim.dat, s2 = s2,
                                       B = matrix(c(0,B1), nrow = 2, ncol = 1), nrep = 1)
      sim.dat$Y <- sim$Y

      z <- binaryPGLMM(Y ~ 1 + X, phy = phy, data = sim.dat)

      meanEsts.n[rep, ] <- c(z$B[2], z$s2, z$P.H0.s2, z$convergeflag == "converged")
  }
converged <- meanEsts.n[,4]
meanEsts <- rbind(meanEsts,
                  c(n, mean(meanEsts.n[converged==1,1]),
                            mean(meanEsts.n[converged==1,2]),
                            mean(meanEsts.n[converged==1, 3] < 0.05),
                            mean(converged)))
}
meanEsts

# Results output for B1 = 0.5, s2 = 0.4; n-Inf gives the values used to
# simulate the data
#    n       B1        s2      Pr.s2 propconverged
# 1 Inf 1.000000 0.4000000 1.00000000         1.000
# 2 160 1.012719 0.4479946 0.36153072         0.993
# 3  80 1.030876 0.5992027 0.24623116         0.995
# 4  40 1.110201 0.7425203 0.13373860         0.987
# 5  20 1.249886 0.8774708 0.05727377         0.873


## Examine type I errors for estimates of B0 and s2 from binaryPGLMM()
# with simulated data. Note that this will take a while.

Reps = 1000

s2 <- 0
B0 <- 0
B1 <- 0

H0.tests <- data.frame(n = Inf, B0 = B0, s2 = s2, Pr.B0 = .05,
                       Pr.s2 = .05, propconverged = 1)
for (n in c(160, 80, 40, 20)) {

  ests.n <- data.frame(B1 = 0, s2 = 0, Pr.B0 = 0, Pr.s2 = 0, convergefailure = 0)
  for (rep in 1:Reps) {
    phy <- compute.brlen(rtree(n = n), method = "Grafen", power = 1)
    X <- rTraitCont(phy, model = "BM", sigma = 1)
    X <- (X - mean(X))/var(X)

    sim.dat <- data.frame(Y = array(0, dim = n), X = X, row.names = phy$tip.label)
    sim <- binaryPGLMM.sim(Y ~ 1, phy = phy, data = sim.dat, s2 = s2,
                           B = matrix(B0, nrow = 1, ncol = 1), nrep = 1)
    sim.dat$Y <- sim$Y

    z <- binaryPGLMM(Y ~ 1, phy = phy, data = sim.dat)

    ests.n[rep, ] <- c(z$B[1], z$s2, z$B.pvalue, z$P.H0.s2, z$convergeflag == "converged")
  }

converged <- ests.n[,5]
H0.tests <- rbind(H0.tests,
                  c(n, mean(ests.n[converged==1,1]),
                    mean(ests.n[converged==1,2]),
                    mean(ests.n[converged==1, 3] < 0.05),
                    mean(ests.n[converged==1, 4] < 0.05),
                    mean(converged)))
}
H0.tests

# Results for type I errors for B0 = 0 and s2 = 0; n-Inf gives the values
# used to simulate the data. These results show that binaryPGLMM() tends to
# have lower-than-nominal p-values; fewer than 0.05 of the simulated
# data sets have H0:B0=0 and H0:s2=0 rejected at the alpha=0.05 level.
#     n            B0         s2      Pr.B0      Pr.s2 propconverged
# 1 Inf  0.0000000000 0.00000000 0.05000000 0.05000000         1.000
# 2 160 -0.0009350357 0.07273163 0.02802803 0.04804805         0.999
# 3  80 -0.0085831477 0.12205876 0.04004004 0.03403403         0.999
# 4  40  0.0019303847 0.25486307 0.02206620 0.03711133         0.997
# 5  20  0.0181394905 0.45949266 0.02811245 0.03313253         0.996
}}
\keyword{regression}

\name{vcv}
\alias{vcv}
\alias{vcv.phylo}
\alias{vcv.corPhyl}
\title{Phylogenetic Variance-covariance or Correlation Matrix}
\usage{
vcv(phy, ...)
\method{vcv}{phylo}(phy, model = "Brownian", corr = FALSE, ...)
\method{vcv}{corPhyl}(phy, corr = FALSE, ...)
}
\arguments{
  \item{phy}{an object of the correct class (see above).}
  \item{model}{a character giving the model used to compute the
    variances and covariances; only \code{"Brownian"} is available (for
    other models, a correlation structure may be used).}
  \item{corr}{a logical indicating whether the correlation matrix should
    be returned (\code{TRUE}); by default the variance-covariance matrix
    is returned (\code{FALSE}).}
  \item{\dots}{further arguments to be passed to or from other methods.}
}
\description{
  This function computes the expected variances and covariances of a
  continuous trait assuming it evolves under a given model.

  This is a generic function with methods for objects of class
  \code{"phylo"} and \code{"corPhyl"}.
}
\value{
  a numeric matrix with the names of the tips as colnames and rownames.
}
\references{
  Garland, T. Jr. and Ives, A. R. (2000) Using the past to predict the
  present: confidence intervals for regression equations in phylogenetic
  comparative methods. \emph{American Naturalist}, \bold{155}, 346--364.
}

\author{Emmanuel Paradis}
\note{
  Do not confuse this function with \code{\link[stats]{vcov}} which
  computes the variance-covariance matrix among parameters of a fitted
  model object.
}
\seealso{
  \code{\link{corBrownian}}, \code{\link{corMartins}},
  \code{\link{corGrafen}}, \code{\link{corPagel}},
  \code{\link{corBlomberg}}, \code{\link{vcv2phylo}}
}
\examples{
tr <- rtree(5)
## all are the same:
vcv(tr)
vcv(corBrownian(1, tr))
vcv(corPagel(1, tr))
}
\keyword{manip}
\keyword{multivariate}

\name{latag2n}
\alias{latag2n}
\title{Leading and Trailing Alignment Gaps to N}
\description{
  Substitutes leading and trailing alignment gaps in aligned sequences
  into \code{N} (i.e., A, C, G, or T). The gaps in the middle of the
  sequences are left unchanged.
}
\usage{
latag2n(x)
}
\arguments{
  \item{x}{an object of class \code{"DNAbin"} with the aligned sequences.}
}
\details{
  This function is called by others in \pkg{ape} and in \pkg{pegas}. It
  is documented here in case it needs to be called by other packages.
}
\value{an object of class \code{"DNAbin"}.}
\author{Emmanuel Paradis}
\seealso{\code{\link{DNAbin}}}
\examples{
x <- as.DNAbin(matrix(c("-", "A", "G", "-", "T", "C"), 2, 3))
y <- latag2n(x)
alview(x)
alview(y)
}
\keyword{manip}

\name{phydataplot}
\alias{phydataplot}
\alias{ring}
\title{Tree Annotation}
\description{
  \code{phydataplot} plots data on a tree in a way that adapts to the
  type of tree. \code{ring} does the same for circular trees.

  Both functions match the data with the labels of the tree.
}
\usage{
phydataplot(x, phy, style = "bars", offset = 1, scaling = 1,
            continuous = FALSE, width = NULL, legend = "below",
            funcol = rainbow, ...)
ring(x, phy, style = "ring", offset = 1, ...)
}
\arguments{
  \item{x}{a vector, a factor, a matrix, or a data frame.}
  \item{phy}{the tree (which must be already plotted).}
  \item{style}{a character string specifying the type of graphics; can
    be abbreviated (see details).}
  \item{offset}{the space between the tips of the tree and the plot.}
  \item{scaling}{the scaling factor to apply to the data.}
  \item{continuous}{(used if style="mosaic") a logical specifying
    whether to treat the values in \code{x} as continuous or not; can be
    an integer value giving the number of categories.}
  \item{width}{(used if style = "mosaic") the width of the cells; by
    default, all the available space is used.}
  \item{legend}{(used if style = "mosaic") the place where to draw the
    legend; one of \code{"below"} (the default), \code{"side"}, or
    \code{"none"}, or an unambiguous abbreviation of these.}
  \item{funcol}{(used if style = "mosaic") the function used to generate
    the colours (see details and examples).}
  \item{\dots}{further arguments passed to the graphical functions.}
}
\details{
  The possible values for \code{style} are ``bars'', ``segments'',
  ``image'', ``arrows'', ``boxplot'', ``dotchart'', or ``mosaic'' for
  \code{phydataplot}, and ``ring'', ``segments'', or ``arrows'' for
  \code{ring}.

  \code{style = "image"} works only with square matrices (e.g.,
  similarities). If you want to plot a DNA alignment in the same way
  than \code{\link{image.DNAbin}}, try \code{style = "mosaic"}.

  \code{style = "mosaic"} can plot any kind of matrices, possibly after
  discretizing its values (using \code{continuous}). The default colour
  palette is taken from the function \code{\link[grDevices]{rainbow}}.
  If you want to use specified colours, a function simply returning the
  vector of colours must be used, possibly with names if you want to
  assign a specific colour to each value (see examples).
}
\note{
  For the moment, only rightwards trees are supported (does not apply to
  circular trees).
}
\author{Emmanuel Paradis}
\seealso{
  \code{\link{plot.phylo}}, \code{\link{nodelabels}},
  \code{\link{fancyarrows}}
}
\examples{
## demonstrates matching with names:
tr <- rcoal(n <- 10)
x <- 1:n
names(x) <- tr$tip.label
plot(tr, x.lim = 11)
phydataplot(x, tr)
## shuffle x but matching names with tip labels reorders them:
phydataplot(sample(x), tr, "s", lwd = 3, lty = 3)

## adapts to the tree:
plot(tr, "f", x.l = c(-11, 11), y.l = c(-11, 11))
phydataplot(x, tr, "s")

## leave more space with x.lim to show a barplot and a dotchart:
plot(tr, x.lim = 22)
phydataplot(x, tr, col = "yellow")
phydataplot(x, tr, "d", offset = 13)

ts <- rcoal(N <- 100)
X <- rTraitCont(ts) # names are set
dd <- dist(X)
op <- par(mar = rep(0, 4))
plot(ts, x.lim = 10, cex = 0.4, font = 1)
phydataplot(as.matrix(dd), ts, "i", offset = 0.2)

par(xpd = TRUE, mar = op$mar)
co <- c("blue", "red"); l <- c(-2, 2)
X <- X + abs(min(X)) # move scale so X >= 0
plot(ts, "f", show.tip.label = FALSE, x.lim = l, y.lim = l, open.angle = 30)
phydataplot(X, ts, "s", col = co, offset = 0.05)
ring(X, ts, "ring", col = co, offset = max(X) + 0.1) # the same info as a ring

## as many rings as you want...
co <- c("blue", "yellow")
plot(ts, "r", show.tip.label = FALSE, x.l = c(-1, 1), y.l = c(-1, 1))
for (o in seq(0, 0.4, 0.2)) {
    co <- rev(co)
    ring(0.2, ts, "r", col = rep(co, each = 5), offset = o)
}

lim <- c(-5, 5)
co <- rgb(0, 0.4, 1, alpha = 0.1)
y <- seq(0.01, 1, 0.01)
plot(ts, "f", x.lim = lim, y.lim = lim, show.tip.label = FALSE)
ring(y, ts, offset = 0, col = co, lwd = 0.1)
for (i in 1:3) {
    y <- y + 1
    ring(y, ts, offset = 0, col = co, lwd = 0.1)
}

## rings can be in the background
plot(ts, "r", plot = FALSE)
ring(1, ts, "r", col = rainbow(100), offset = -1)
par(new = TRUE)
plot(ts, "r", font = 1, edge.color = "white")

## might be more useful:
co <- c("lightblue", "yellow")
plot(ts, "r", plot = FALSE)
ring(0.1, ts, "r", col = sample(co, size = N, rep = TRUE), offset = -.1)
par(new = TRUE)
plot(ts, "r", font = 1)

## if x is matrix:
tx <- rcoal(m <- 20)
X <- runif(m, 0, 0.5); Y <- runif(m, 0, 0.5)
X <- cbind(X, Y, 1 - X - Y)
rownames(X) <- tx$tip.label
plot(tx, x.lim = 6)
co <- rgb(diag(3))
phydataplot(X, tx, col = co)
## a variation:
plot(tx, show.tip.label = FALSE, x.lim = 5)
phydataplot(X, tx, col = co, offset = 0.05, border = NA)

plot(tx, "f", show.tip.label = FALSE, open.angle = 180)
ring(X, tx, col = co, offset = 0.05)

Z <- matrix(rnorm(m * 5), m)
rownames(Z) <- rownames(X)
plot(tx, x.lim = 5)
phydataplot(Z, tx, "bo", scaling = .5, offset = 0.5,
            boxfill = c("gold", "skyblue"))

## plot an alignment with a NJ tree:
data(woodmouse)
trw <- nj(dist.dna(woodmouse))
plot(trw, x.lim = 0.1, align.tip = TRUE, font = 1)
phydataplot(woodmouse[, 1:50], trw, "m", 0.02, border = NA)

## use type = "mosaic" on a 30x5 matrix:
tr <- rtree(n <- 30)
p <- 5
x <- matrix(sample(3, size = n*p, replace = TRUE), n, p)
dimnames(x) <- list(paste0("t", 1:n), LETTERS[1:p])
plot(tr, x.lim = 35, align.tip = TRUE, adj = 1)
phydataplot(x, tr, "m", 2)
## change the aspect:
plot(tr, x.lim = 35, align.tip = TRUE, adj = 1)
phydataplot(x, tr, "m", 2, width = 2, border = "white", lwd = 3, legend = "side")
## user-defined colour:
f <- function(n) c("yellow", "blue", "red")
phydataplot(x, tr, "m", 18, width = 2, border = "white", lwd = 3,
            legend = "side", funcol = f)

## alternative colour function...:
## fb <- function(n) c("3" = "red", "2" = "blue", "1" = "yellow")
## ... but since the values are sorted alphabetically,
## both f and fb will produce the same plot.

## use continuous = TRUE with two different scales:
x[] <- 1:(n*p)
plot(tr, x.lim = 35, align.tip = TRUE, adj = 1)
phydataplot(x, tr, "m", 2, width = 1.5, continuous = TRUE, legend = "side",
            funcol = colorRampPalette(c("white", "darkgreen")))
phydataplot(x, tr, "m", 18, width = 1.5, continuous = 5, legend = "side",
            funcol = topo.colors)
}
\keyword{aplot}

\name{ape-internal}
\alias{perm.rowscols}
\alias{phylogram.plot}
\alias{cladogram.plot}
\alias{circular.plot}
\alias{unrooted.plot}
\alias{unrooted.xy}
\alias{BOTHlabels}
\alias{floating.pie.asp}
\alias{plotPhyloCoor}
\alias{postprocess.prop.part}
\alias{ONEwise}
\alias{reorderRcpp}
\alias{polar2rect}
\alias{rect2polar}
\alias{neworder_phylo}
\alias{neworder_pruningwise}
\alias{node_depth}
\alias{node_depth_edgelength}
\alias{node_height}
\alias{node_height_clado}
\alias{seq_root2tip}
\title{Internal Ape Functions}
\description{
  Internal \pkg{ape} functions which are undocumented but still exported
  because called by other packages. Use with care!
}
\keyword{internal}

\name{where}
\alias{where}
\title{Find Patterns in DNA Sequences}
\description{
  This function finds patterns in a single or a set of DNA sequences.
}
\usage{
where(x, pattern)
}
\arguments{
  \item{x}{an object of class \code{"DNAbin"}.}
  \item{pattern}{a character string to be searched in \code{x}.}
}
\details{
  If \code{x} is a vector, the function returns a single vector giving
  the position(s) where the pattern was found. If \code{x} is a matrix
  or a list, it returns a list with the positions of the pattern for
  each sequence.

  Patterns may be overlapping. For instance, if \code{pattern = "tata"}
  and the sequence starts with `tatata', then the output will be c(1, 3).
}
\value{
  a vector of integers or a list of such vectors.
}
\author{Emmanuel Paradis}
\seealso{
  \code{\link{DNAbin}}, \code{\link{image.DNAbin}}
}
\examples{
data(woodmouse)
where(woodmouse, "tata")
}
\keyword{manip}

\name{bd.time}
\alias{bd.time}
\title{Time-Dependent Birth-Death Models}
\description{
  This function fits a used-defined time-dependent birth-death
  model.
}
\usage{
bd.time(phy, birth, death, BIRTH = NULL, DEATH = NULL,
        ip, lower, upper, fast = FALSE, boot = 0, trace = 0)
}
\arguments{
  \item{phy}{an object of class \code{"phylo"}.}
  \item{birth}{either a numeric (if speciation rate is assumed
    constant), or a (vectorized) function specifying how the birth
    (speciation) probability changes through time (see details).}
  \item{death}{id. for extinction probability.}
  \item{BIRTH}{(optional) a vectorized function giving the primitive
    of \code{birth}.}
  \item{DEATH}{id. for \code{death}.}
  \item{ip}{a numeric vector used as initial values for the estimation
    procedure. If missing, these values are guessed.}
  \item{lower, upper}{the lower and upper bounds of the parameters. If
    missing, these values are guessed too.}
  \item{fast}{a logical value specifying whether to use faster
    integration (see details).}
  \item{boot}{the number of bootstrap replicates to assess the
    confidence intervals of the parameters. Not run by default.}
  \item{trace}{an integer value. If non-zero, the fitting procedure is
    printed every \code{trace} steps. This can be helpful if convergence
    is particularly slow.}
}
\details{
  Details on how to specify the birth and death functions and their
  primitives can be found in the help page of \code{\link{yule.time}}.

  The model is fitted by minimizing the least squares deviation between
  the observed and the predicted distributions of branching times. These
  computations rely heavily on numerical integrations. If \code{fast =
  FALSE}, integrations are done with R's \code{\link[stats]{integrate}}
  function. If \code{fast = TRUE}, a faster but less accurate function
  provided in \pkg{ape} is used. If fitting a complex model to a large
  phylogeny, a strategy might be to first use the latter option, and
  then to use the estimates as starting values with \code{fast = FALSE}.
}
\value{
  A list with the following components:

\itemize{
  \item{par}{a vector of estimates with names taken from the parameters
    in the specified functions.}
  \item{SS}{the minimized sum of squares.}
  \item{convergence}{output convergence criterion from
    \code{\link[stats]{nlminb}}.}
  \item{message}{id.}
  \item{iterations}{id.}
  \item{evaluations}{id.}
}}
\references{
  Paradis, E. (2011) Time-dependent speciation and extinction from
  phylogenies: a least squares approach. \emph{Evolution}, \bold{65},
  661--672.
}
\author{Emmanuel Paradis}
\seealso{
  \code{\link{ltt.plot}}, \code{\link{birthdeath}},
  \code{\link{yule.time}}, \code{\link{LTT}}
}
\examples{
set.seed(3)
tr <- rbdtree(0.1, 0.02)
bd.time(tr, 0, 0) # fits a simple BD model
bd.time(tr, 0, 0, ip = c(.1, .01)) # 'ip' is useful here
## the classic logistic:
birth.logis <- function(a, b) 1/(1 + exp(-a*t - b))
\dontrun{
bd.time(tr, birth.logis, 0, ip = c(0, -2, 0.01))
## slow to get:
## $par
##            a            b        death
## -0.003486961 -1.995983179  0.016496454
##
## $SS
## [1] 20.73023
}
}
\keyword{models}

\name{clustal}
\alias{clustal}
\alias{clustalomega}
\alias{muscle}
\alias{tcoffee}
\title{Multiple Sequence Alignment with External Applications}
\description{
  These functions call their respective program from \R to align a set
  of nucleotide sequences of class \code{"DNAbin"} or
  \code{"AAbin"}. The application(s) must be installed seperately and it
  is highly recommended to do this so that the executables are in a
  directory located on the PATH of the system.
}
\usage{
clustal(x, y, guide.tree, pw.gapopen = 10, pw.gapext = 0.1,
        gapopen = 10, gapext = 0.2, exec = NULL, MoreArgs = "",
        quiet = TRUE, original.ordering = TRUE, file)
clustalomega(x, y, guide.tree, exec = NULL,MoreArgs = "",
              quiet = TRUE, original.ordering = TRUE, file)
muscle(x, y, guide.tree, exec, MoreArgs = "",
        quiet = TRUE, original.ordering = TRUE, file)
tcoffee(x, exec = "t_coffee", MoreArgs = "", quiet = TRUE,
        original.ordering = TRUE)
}
\arguments{
  \item{x}{an object of class \code{"DNAbin"} or \code{"AAbin"} (can be
    missing).}
  \item{y}{an object of class \code{"DNAbin"} or \code{"AAbin"} used for
    profile alignment (can be missing).}
  \item{guide.tree}{guide tree, an object of class \code{"phylo"} (can
    be missing).}
  \item{pw.gapopen, pw.gapext}{gap opening and gap extension penalties
    used by Clustal during pairwise alignments.}
  \item{gapopen, gapext}{idem for global alignment.}
  \item{exec}{a character string giving the name of the program, with
    its path if necessary. \code{clustal} tries to guess this argument
    depending on the operating system (see details).}
  \item{MoreArgs}{a character string giving additional options.}
  \item{quiet}{a logical: the default is to not print on \R's console the
    messages from the external program.}
  \item{original.ordering}{a logical specifying whether to return the
    aligned sequences in the same order than in \code{x} (\code{TRUE} by
    default).}
  \item{file}{a file with its path if results should be stored (can be
    missing).}
}
\details{
  It is highly recommended to install the executables properly so that
  they are in a directory located on the PATH (i.e., accessible from any
  other directory). Alternatively, the full path to the executable
  may be given (e.g., \code{exec = "~/muscle/muscle"}), or a (symbolic)
  link may be copied in the working directory. For Debian and its
  derivatives (e.g., Ubuntu), it is recommended to use the binaries
  distributed by Debian.

  \code{clustal} tries to guess the name of the executable program
  depending on the operating system. Specifically, the followings are
  used: ``clustalw'' under Linux, ``clustalw2'' under MacOS, and
  ``clustalw2.exe'' under Windows. For \code{clustalomega},
  ``clustalo[.exe]'' is the default on all systems (with no specific
  path).

  When called without arguments (i.e., \code{clustal()}, \dots), the
  function prints the options of the program which may be passed to
  \code{MoreArgs}.

  Since \pkg{ape} 5.1, \code{clustal}, \code{clustalomega}, and
  \code{muscle} can align AA sequences as well as DNA sequences.
}
\value{
  an object of class \code{"DNAbin"} or \code{"AAbin"} with the aligned
  sequences.
}
\references{
  Chenna, R., Sugawara, H., Koike, T., Lopez, R., Gibson, T. J.,
  Higgins, D. G. and Thompson, J. D. (2003) Multiple sequence alignment
  with the Clustal series of programs. \emph{Nucleic Acids Research}
  \bold{31}, 3497--3500. \url{http://www.clustal.org/}

  Edgar, R. C. (2004) MUSCLE: Multiple sequence alignment with high
  accuracy and high throughput. \emph{Nucleic Acids Research},
  \bold{32}, 1792--1797.
  \url{http://www.drive5.com/muscle/muscle_userguide3.8.html}

  Notredame, C., Higgins, D. and Heringa, J. (2000) T-Coffee: A novel
  method for multiple sequence alignments. \emph{Journal of Molecular
  Biology}, \bold{302}, 205--217.
  \url{http://www.tcoffee.org/}

  Sievers, F., Wilm, A., Dineen, D., Gibson, T. J., Karplus, K., Li, W.,
  Lopez, R., McWilliam, H., Remmert, M., S\"oding, J., Thompson,
  J. D. and Higgins, D. G. (2011) Fast, scalable generation of
  high-quality protein multiple sequence alignments using Clustal
  Omega. \emph{Molecular Systems Biology}, \bold{7}, 539.
  \url{http://www.clustal.org/}
}
\author{Emmanuel Paradis}
\seealso{
  \code{\link{image.DNAbin}}, \code{\link{del.gaps}},
  \code{\link{all.equal.DNAbin}}, \code{\link{alex}},
  \code{\link{alview}}, \code{\link{checkAlignment}}
}
\examples{
\dontrun{
### display the options:
clustal()
clustalomega()
muscle()
tcoffee()

data(woodmouse)
### open gaps more easily:
clustal(woodmouse, pw.gapopen = 1, pw.gapext = 1)
### T-Coffee requires negative values (quite slow; muscle() is much faster):
tcoffee(woodmouse,  MoreArgs = "-gapopen=-10 -gapext=-2")
}}
\keyword{manip}

\name{carnivora}
\docType{data}
\alias{carnivora}
\title{Carnivora body sizes and life history traits}
\description{
  Dataset adapted from Gittleman (1986), including 2 morphological variables (body and brain sizes),  8 life history traits variables and 4 taxonomic variables.
}
\usage{data(carnivora)}
\format{
  A data frame with 112 observations on 17 variables.

  \tabular{rlll}{
    [,1]  \tab Order       \tab factor  \tab Carnivora order \cr
    [,2]  \tab SuperFamily \tab factor  \tab Super family (Caniformia or Feliformia) \cr
    [,3]  \tab Family      \tab factor  \tab Carnivora family \cr
    [,4]  \tab Genus       \tab factor  \tab Carnivora genus \cr
    [,5]  \tab Species     \tab factor  \tab Carnivora species \cr
    [,6]  \tab FW          \tab numeric \tab Female body weight (kg) \cr
    [,7]  \tab SW          \tab numeric \tab Average body weight of adult male and adult female (kg) \cr
    [,8]  \tab FB          \tab numeric \tab Female brain weight (g) \cr
    [,9]  \tab SB          \tab numeric \tab Average brain weight of adult male and adult female (g) \cr
    [,10] \tab LS          \tab numeric \tab Litter size \cr
    [,11] \tab GL          \tab numeric \tab Gestation length (days) \cr
    [,12] \tab BW          \tab numeric \tab Birth weigth (g) \cr
    [,13] \tab WA          \tab numeric \tab Weaning age (days) \cr
    [,14] \tab AI          \tab numeric \tab Age of independance (days) \cr
    [,15] \tab LY          \tab numeric \tab Longevity (months) \cr
    [,16] \tab AM          \tab numeric \tab Age of sexual maturity (days) \cr
    [,17] \tab IB          \tab numeric \tab Inter-birth interval (months) \cr
  }
}
\source{
  Gittleman, J. L. (1986) Carnivore life history patterns: allometric,
  phylogenetic and ecological associations. \emph{American Naturalist},
  \bold{127}: 744--771.
}
\examples{
data(carnivora)
## Fig. 1 in Gittleman (1986):
plot(carnivora$BW ~ carnivora$FW, pch = (1:8)[carnivora$Family], log = "xy",
     xlab = "Female body weight (kg)", ylab = "Birth weigth (g)",
     ylim = c(1, 2000))
legend("bottomright", legend = levels(carnivora$Family), pch = 1:8)
plot(carnivora$BW ~ carnivora$FB, pch = (1:8)[carnivora$Family], log = "xy",
     xlab = "Female brain weight (g)", ylab = "Birth weigth (g)",
     ylim = c(1, 2000))
legend("bottomright", legend = levels(carnivora$Family), pch = 1:8)
}
\keyword{datasets}

\name{branching.times}
\alias{branching.times}
\title{Branching Times of a Phylogenetic Tree}
\usage{
branching.times(phy)
}
\arguments{
  \item{phy}{an object of class \code{"phylo"}.}
}
\description{
  This function computes the branching times of a phylogenetic tree,
  that is the distance from each node to the tips, under the assumption that
  the tree is ultrametric. Note that the function does not check that the
  tree is effectively ultrametric, so if it is not, the returned result
  may not be meaningful.
}
\value{
  a numeric vector with the branching times. If the phylogeny \code{phy}
  has an element \code{node.label}, this is used as names for the
  returned vector; otherwise the numbers (of mode character) of the
  matrix \code{edge} of \code{phy} are used as names.
}
\author{Emmanuel Paradis}
\seealso{
\code{\link{is.ultrametric}}
}
\keyword{manip}

\name{as.phylo}
\alias{as.phylo}
\alias{as.phylo.hclust}
\alias{as.phylo.phylog}
\alias{as.hclust.phylo}
\alias{old2new.phylo}
\alias{new2old.phylo}
\alias{as.network.phylo}
\alias{as.igraph}
\alias{as.igraph.phylo}
\title{Conversion Among Tree and Network Objects}
\description{
  \code{as.phylo} is a generic function which converts an object into a
  tree of class \code{"phylo"}. There are currently two methods for
  objects of class \code{"hclust"} and of class \code{"phylog"}
  (implemented in the package ade4).

  \code{as.hclust.phylo} is a method of the generic
  \code{\link[stats]{as.hclust}} which converts an object of class
  \code{"phylo"} into one of class \code{"hclust"}. This can used to
  convert an object of class \code{"phylo"} into one of class
  \code{"dendrogram"} (see examples).

  \code{as.network} and \code{as.igraph} convert trees of class
  \code{"phylo"} into these respective classes defined in the packages
  of the same names (where the generics are defined).

  \code{old2new.phylo} and \code{new2old.phylo} are utility functions
  for converting between the old and new coding of the class
  \code{"phylo"}.
}
\usage{
as.phylo(x, ...)
\method{as.phylo}{hclust}(x, ...)
\method{as.phylo}{phylog}(x, ...)
\method{as.hclust}{phylo}(x, ...)
old2new.phylo(phy)
new2old.phylo(phy)
\method{as.network}{phylo}(x, directed = is.rooted(x), ...)
\method{as.igraph}{phylo}(x, directed = is.rooted(x), use.labels = TRUE, ...)
}
\arguments{
  \item{x}{an object to be converted into another class.}
  \item{directed}{a logical value: should the network be directed? By
    default, this depends on whether the tree is rooted or not.}
  \item{use.labels}{a logical specifying whether to use labels to build
    the network of class \code{"igraph"}. If \code{TRUE} and the tree
    has no node labels, then some default labels are created first. If
    \code{FALSE}, the network is built with integers.}
  \item{\dots}{further arguments to be passed to or from other methods.}
  \item{phy}{an object of class \code{"phylo"}.}
}
\value{
  An object of class \code{"hclust"}, \code{"phylo"}, \code{"network"},
  or \code{"igraph"}.
}
\note{
  In an object of class \code{"hclust"}, the \code{height} gives the
  distance between the two sets that are being agglomerated. So these
  distances are divided by two when setting the branch lengths of a
  phylogenetic tree.
}
\author{Emmanuel Paradis}
\seealso{
  \code{\link[stats]{hclust}}, \code{\link[stats]{as.hclust}},
  \code{\link[stats]{dendrogram}}, \code{\link[ade4]{phylog}},
  \code{\link{as.phylo.formula}}
}
\examples{
data(bird.orders)
hc <- as.hclust(bird.orders)
tr <- as.phylo(hc)
all.equal(bird.orders, tr) # TRUE

### shows the three plots for tree objects:
dend <- as.dendrogram(hc)
layout(matrix(c(1:3, 3), 2, 2))
plot(bird.orders, font = 1)
plot(hc)
par(mar = c(8, 0, 0, 0)) # leave space for the labels
plot(dend)

### how to get identical plots with
### plot.phylo and plot.dendrogram:
layout(matrix(1:2, 2, 1))
plot(bird.orders, font = 1, no.margin = TRUE, label.offset = 0.4)
par(mar = c(0, 0, 0, 8))
plot(dend, horiz = TRUE)
layout(1)

\dontrun{
### convert into networks:
if (require(network)) {
    x <- as.network(rtree(10))
    print(x)
    plot(x, vertex.cex = 1:4)
    plot(x, displaylabels = TRUE)
}
tr <- rtree(5)
if (require(igraph)) {
    print((x <- as.igraph(tr)))
    plot(x)
    print(as.igraph(tr, TRUE, FALSE))
    print(as.igraph(tr, FALSE, FALSE))
}
}
}
\keyword{manip}

\name{reconstruct}
\alias{reconstruct}
\title{Continuous Ancestral Character Estimation}
\description{
  This function estimates ancestral character states, and the associated
  uncertainty, for continuous characters. It mainly works as the ace
  function, from which it differs, first, in the fact that computations
  are not performed by numerical optimisation but through matrix
  calculus. Second, besides classical Brownian-based reconstruction
  methods, it reconstructs ancestral states under Arithmetic Brownian
  Motion (ABM, i.e. Brownian with linear trend) and Ornstein-Uhlenbeck
  process (OU, i.e. Brownian with an attractive optimum).
}
\usage{
reconstruct(x, phyInit, method = "ML", alpha = NULL, CI = TRUE)
}
\arguments{
  \item{x}{a numerical vector.}
  \item{phyInit}{an object of class \code{"phylo"}.}
  \item{method}{a character specifying the method used for
    estimation. Six choices are possible: \code{"ML"}, \code{"REML"},
    \code{"GLS"}, \code{"GLS_ABM"}, \code{"GLS_OU"} or
    \code{"GLS_OUS"}.}
  \item{alpha}{a numerical value which accounts for the attractive
    strength parameter of \code{"GLS_OU"} or \code{"GLS_OUS"} (used only
    in these cases). If alpha = NULL (the default), then it is estimated
    by maximum likelihood using \code{optim} which may lead to
    convergence issue.}
  \item{CI}{a logical specifying whether to return the 95\% confidence
    intervals of the ancestral state estimates.}
}
\details{
  For \code{"ML"}, \code{"REML"} and \code{"GLS"}, the default model is
  Brownian motion. This model can be fitted by maximum likelihood
  (\code{method = "ML"}, Felsenstein 1973, Schluter et al. 1997) - the
  default, residual maximum likelihood (\code{method = "REML"}), or
  generalized least squares (\code{method = "GLS"}, Martins and Hansen
  1997, Garland T and Ives AR 2000).

  \code{"GLS_ABM"} is based on Brownian motion with trend model. Both
  \code{"GLS_OU"} and \code{"GLS_OUS"} are based on Ornstein-Uhlenbeck
  model.

  \code{"GLS_OU"} and \code{"GLS_OUS"} differs in the fact that
  \code{"GLS_OUS"} assume that the process starts from the optimum,
  while the root state has to be estimated for \code{"GLS_OU"}, which
  may rise some issues (see Royer-Carenzi and Didier, 2016). Users may
  provide the attractive strength parameter \code{alpha}, for these two
  models.

  \code{"GLS_ABM"}, \code{"GLS_OU"} and \code{"GLS_OUS"} are all fitted
  by generalized least squares (Royer-Carenzi and Didier, 2016).
}
\value{
  an object of class \code{"ace"} with the following elements:

  \item{ace}{the estimates of the ancestral character values.}
  \item{CI95}{the estimated 95\% confidence intervals.}
  \item{sigma2}{if \code{method = "ML"}, the maximum likelihood estimate
    of the Brownian parameter.}
  \item{loglik}{if \code{method = "ML"}, the maximum log-likelihood.}
}
\references{
  Felsenstein, J. (1973) Maximum likelihood estimation of evolutionary
  trees from continuous characters. \emph{American Journal of Human
  Genetics}, \bold{25}, 471--492.

  Garland T. and Ives A.R. (2000) Using the past to predict the present:
  confidence intervals for regression equations in phylogenetic
  comparative methods. \emph{American Naturalist}, \bold{155},
  346--364.

  Martins, E. P. and Hansen, T. F. (1997) Phylogenies and the
  comparative method: a general approach to incorporating phylogenetic
  information into the analysis of interspecific data. \emph{American
    Naturalist}, \bold{149}, 646--667.

  Royer-Carenzi, M. and Didier, G. (2016) A comparison of ancestral
  state reconstruction methods for quantitative
  characters. \emph{Journal of Theoretical Biology}, \bold{404},
  126--142.

  Schluter, D., Price, T., Mooers, A. O. and Ludwig, D. (1997)
  Likelihood of ancestor states in adaptive radiation. \emph{Evolution},
  \bold{51}, 1699--1711.

  Yang, Z. (2006) \emph{Computational Molecular Evolution}. Oxford:
  Oxford University Press.
}
\author{Manuela Royer-Carenzi, Gilles Didier}
\seealso{
  \code{\link{MPR}}, \code{\link{corBrownian}}, \code{\link{compar.ou}}

  Reconstruction of ancestral sequences can be done with the package
  \pkg{phangorn} (see function \code{?ancestral.pml}).
}
\note{
\code{GLS_ABM} should not be used on ultrametric tree.

\code{GLS_OU} may lead to aberrant reconstructions.
}
\examples{
### Some random data...
data(bird.orders)
x <- rnorm(23, m=100)
### Reconstruct ancestral quantitative characters:
reconstruct(x, bird.orders)
reconstruct(x, bird.orders, method = "GLS_OUS", alpha=NULL)
}
\keyword{models}

\name{parafit}
\alias{parafit}
\alias{print.parafit}
\alias{gopher.D}
\alias{lice.D}
\alias{HP.links}
\title{ Test of host-parasite coevolution }
\description{
Function \code{\link{parafit}} tests the hypothesis of coevolution between a clade of hosts and a clade of parasites. The null hypothesis (H0) of the global test is that the evolution of the two groups, as revealed by the two phylogenetic trees and the set of host-parasite association links, has been independent. Tests of individual host-parasite links are also available as an option.

The method, which is described in detail in Legendre et al. (2002), requires some estimates of the phylogenetic trees or phylogenetic distances, and also a description of the host-parasite associations (H-P links) observed in nature.
}
\usage{
parafit(host.D, para.D, HP, nperm = 999, test.links = FALSE,
        seed = NULL, correction = "none", silent = FALSE)
}

\arguments{
  \item{host.D }{ A matrix of phylogenetic or patristic distances among the hosts (object class: \code{matrix}, \code{data.frame} or \code{dist}). A matrix of patristic distances exactly represents the information in a phylogenetic tree. }
  \item{para.D }{ A matrix of phylogenetic or patristic distances among the parasites (object class: \code{matrix}, \code{data.frame} or \code{dist}). A matrix of patristic distances exactly represents the information in a phylogenetic tree. }
  \item{HP }{ A rectangular matrix with hosts as rows and parasites as columns. The matrix contains 1's when a host-parasite link has been observed in nature between the host in the row and the parasite in the column, and 0's otherwise. }
  \item{nperm}{ Number of permutations for the tests. If \code{nperm =
   0}, permutation tests will not be computed. The default value is \code{nperm = 999}. For large data files, the permutation test is rather slow since the permutation procedure is not compiled. }
  \item{test.links }{ \code{test.links = TRUE} will test the significance of individual host-parasite links. Default: \code{test.links = FALSE}. }
  \item{seed }{ \code{seed = NULL} (default): a seed is chosen at random by the function. That seed is used as the starting point for all tests of significance, i.e. the global H-P test and the tests of individual H-P links if they are requested. Users can select a seed of their choice by giving any integer value to \code{seed}, for example \code{seed = -123456}. Running the function again with the same seed value will produce the exact same test results. }
  \item{correction}{ Correction methods for negative eigenvalues (details below): \code{correction="lingoes"} and \code{correction="cailliez"}. Default value: \code{"none"}.  }
  \item{silent}{ Informative messages and the time to compute the tests will not be written to the \R console if silent=TRUE. Useful when the function is called by a numerical simulation function. }
}

\details{
Two types of test are produced by the program: a global test of coevolution and, optionally, a test on the individual host-parasite (H-P) link.

The function computes principal coordinates for the host and the parasite distance matrices. The principal coordinates (all of them) act as a complete representation of either the phylogenetic distance matrix or the phylogenetic tree.

Phylogenetic distance matrices are normally Euclidean. Patristic distance matrices are additive, thus they are metric and Euclidean. Euclidean matrices are fully represented by real-valued principal coordinate axes. For non-Euclidean matrices, negative eigenvalues are produced; complex principal coordinate axes are associated with the negative eigenvalues. So, the program rejects matrices that are not Euclidean and stops.

Negative eigenvalues can be corrected for by one of two methods: the Lingoes or the Caillez correction. It is up to the user to decide which correction method should be applied. This is done by selecting the option \code{correction="lingoes"} or \code{correction="cailliez"}. Details on these correction methods are given in the help file of the \code{pcoa} function.

The principle of the global test is the following (H0: independent evolution of the hosts and parasites): (1) Compute matrix D = C t(A) B. Note: D is a fourth-corner matrix (sensu Legendre et al. 1997), where A is the H-P link matrix, B is the matrix of principal coordinates computed from the host.D matrix, and C is the matrix of principal coordinates computed from the para.D matrix. (2) Compute the statistic ParaFitGlobal, the sum of squares of all values in matrix D. (3) Permute at random, separately, each row of matrix A, obtaining matrix A.perm. Compute D.perm = C %*% t(A.perm) %*% B, and from it, compute a permuted value ParaFitGlobal.perm for the statistic. Save this value in a vector trace.perm for the tests of individual links (below). (4) Repeat step 4 a large number of times. (5) Add the reference value of ParaFitGlobal to the distribution of ParaFitGlobal.perm values. Calculate the permutational probability associated to ParaFitGlobal.

The test of each individual H-P link is carried out as follows (H0: this particular link is random): (1) Remove one link (k) from matrix A. (2) Compute matrix D = C t(A) B. (3a) Compute trace(k), the sum of squares of all values in matrix D. (3b) Compute the statistic ParaFitLink1 = (trace - trace(k)) where trace is the ParaFitGlobal statistic. (3c) Compute the statistic ParaFitLink2 = (trace - trace(k)) / (tracemax - trace) where tracemax is the maximum value that can be taken by trace. (4) Permute at random, separately, each row of matrix A, obtaining A.perm. Use the same sequences of permutations as were used in the test of ParaFitGlobal. Using the values of trace and trace.perm saved during the global test, compute the permuted values of the two statistics, ParaFit1.perm and ParaFit2.perm. (5) Repeat step 4 a large number of times. (6) Add the reference value of ParaFit1 to the distribution of ParaFit1.perm values; add the reference value of ParaFit2 to the distribution of ParaFit2.perm values. Calculate the permutational probabilities associated to ParaFit1 and ParaFit2.

The \code{print.parafit} function prints out the results of the global test and, optionally, the results of the tests of the individual host-parasite links.
}

\value{

  \item{ParaFitGlobal }{The statistic of the global H-P test. }
  \item{p.global }{The permutational p-value associated with the ParaFitGlobal statistic. }
  \item{link.table }{The results of the tests of individual H-P links, including the ParaFitLink1 and ParaFitLink2 statistics and the p-values obtained from their respective permutational tests. }
  \item{para.per.host }{Number of parasites per host. }
  \item{host.per.para }{Number of hosts per parasite. }
  \item{nperm }{Number of permutations for the tests. }
  }

\author{ Pierre Legendre, Universite de Montreal }

\references{
Hafner, M. S, P. D. Sudman, F. X. Villablanca, T. A. Spradling, J. W. Demastes and S. A. Nadler. 1994. Disparate rates of molecular evolution in cospeciating hosts and parasites. \emph{Science}, \bold{265}, 1087--1090.

Legendre, P., Y. Desdevises and E. Bazin. 2002. A statistical test for host-parasite coevolution. \emph{Systematic Biology}, \bold{51(2)}, 217--234.
}

\seealso{\code{\link{pcoa}} }

\examples{
## Gopher and lice data from Hafner et al. (1994)

data(gopher.D)
data(lice.D)
data(HP.links)

res <- parafit(gopher.D, lice.D, HP.links, nperm=99, test.links=TRUE)
# res     # or else: print(res)
}

\keyword{ multivariate }

\name{kronoviz}
\alias{kronoviz}
\title{Plot Multiple Chronograms on the Same Scale}
\description{
  The main argument is a list of (rooted) trees which are plotted on the
  same scale.
}
\usage{
kronoviz(x, layout = length(x), horiz = TRUE, ...)
}
\arguments{
  \item{x}{a list of (rooted) trees of class \code{"phylo"}.}
  \item{layout}{an integer giving the number of trees plotted
    simultaneously; by default all.}
  \item{horiz}{a logical specifying whether the trees should be plotted
    rightwards (the default) or upwards.}
  \item{\dots}{further arguments passed to \code{plot.phylo}.}
}
\details{
  The size of the individual plots is proportional to the size of the
  trees.
}
\value{NULL}
\author{Emmanuel Paradis}
\seealso{
  \code{\link{plot.phylo}}
}
\examples{
TR <- replicate(10, rcoal(sample(11:20, size = 1)), simplify = FALSE)
kronoviz(TR)
kronoviz(TR, horiz = FALSE, type = "c", show.tip.label = FALSE)
}
\keyword{hplot}

\name{rtree}
\alias{rtree}
\alias{rcoal}
\alias{rmtree}
\title{Generates Random Trees}
\description{
  These functions generate trees by splitting randomly the edges
  (\code{rtree}) or randomly clustering the tips (\code{rcoal}).
  \code{rtree} generates general trees, and \code{rcoal} generates
  coalescent trees. The algorithms are described in Paradis (2012).
}
\usage{
rtree(n, rooted = TRUE, tip.label = NULL, br = runif, equiprob = FALSE, ...)
rcoal(n, tip.label = NULL, br = "coalescent", ...)
rmtree(N, n, rooted = TRUE, tip.label = NULL, br = runif,
       equiprob = FALSE, ...)
}
\arguments{
  \item{n}{an integer giving the number of tips in the tree.}
  \item{rooted}{a logical indicating whether the tree should be rooted
    (the default).}
  \item{tip.label}{a character vector giving the tip labels; if not
    specified, the tips "t1", "t2", ..., are given.}
  \item{br}{one of the following: (i) an \R function used to generate the
    branch lengths (\code{rtree}; use \code{NULL} to simulate only a
    topology), or the coalescence times (\code{rcoal}); (ii) a character
    to simulate a genuine coalescent tree for \code{rcoal} (the
    default); or (iii) a numeric vector for the branch lengths or the
    coalescence times.}
  \item{equiprob}{(new since \pkg{ape} 5.4-1) a logical specifying
    whether topologies are generated in equal frequencies. If,
    \code{FALSE}, the unbalanced topologies are generated in higher
    proportions than the balanced ones.}
  \item{\dots}{further argument(s) to be passed to \code{br}.}
  \item{N}{an integer giving the number of trees to generate.}
}
\details{
  The trees generated are bifurcating. If \code{rooted = FALSE} in
  (\code{rtree}), the tree is trifurcating at its root.

  The default function to generate branch lengths in \code{rtree} is
  \code{runif}. If further arguments are passed to \code{br}, they need
  to be tagged (e.g., \code{min = 0, max = 10}).

  \code{rmtree} calls successively \code{rtree} and set the class of
  the returned object appropriately.
}
\value{
  An object of class \code{"phylo"} or of class \code{"multiPhylo"} in
  the case of \code{rmtree}.
}
\references{
  Paradis, E. (2012) \emph{Analysis of Phylogenetics and Evolution with
    R (Second Edition).} New York: Springer.
}
\author{Emmanuel Paradis}
\seealso{
  \code{\link{stree}}, \code{\link{rlineage}}
}
\examples{
layout(matrix(1:9, 3, 3))
### Nine random trees:
for (i in 1:9) plot(rtree(20))
### Nine random cladograms:
for (i in 1:9) plot(rtree(20, FALSE), type = "c")
### generate 4 random trees of bird orders:
data(bird.orders)
layout(matrix(1:4, 2, 2))
for (i in 1:4)
  plot(rcoal(23, tip.label = bird.orders$tip.label), no.margin = TRUE)
layout(1)
par(mar = c(5, 4, 4, 2))
}
\keyword{datagen}

\name{mat3}
\alias{mat3}
\title{Three Matrices}
\description{
  Three matrices respectively representing Serological (asymmetric),
  DNA hybridization (asymmetric) and Anatomical (symmetric) distances
  among 9 families.
}
\usage{
data(mat3)
}
\format{
  A data frame with 27 observations and 9 variables.
}
\source{
  Lapointe, F.-J., J. A. W. Kirsch and J. M. Hutcheon. 1999. Total
  evidence, consensus, and bat phylogeny: a distance-based
  approach. Molecular Phylogenetics and Evolution 11: 55-66.
}
\seealso{
  \code{\link{mat5Mrand}}, \code{\link{mat5M3ID}}
}
\keyword{datasets}

\name{c.phylo}
\alias{c.phylo}
\alias{c.multiPhylo}
\alias{.compressTipLabel}
\alias{.uncompressTipLabel}
\title{Building Lists of Trees}
\description{
  These functions help to build lists of trees of class \code{"multiPhylo"}.
}
\usage{
\method{c}{phylo}(..., recursive = TRUE)
\method{c}{multiPhylo}(..., recursive = TRUE)
.compressTipLabel(x, ref = NULL)
.uncompressTipLabel(x)
}
\arguments{
  \item{\dots}{one or several objects of class \code{"phylo"} and/or
    \code{"multiPhylo"}.}
  \item{recursive}{see details.}
  \item{x}{an object of class \code{"phylo"} or \code{"multiPhylo"}.}
  \item{ref}{an optional vector of mode character to constrain the order
    of the tips. By default, the order from the first tree is used.}
}
\details{
  These \code{c} methods check all the arguments, and return by default
  a list of single trees unless some objects are not trees or lists of
  trees, in which case \code{recursive} is switched to FALSE and a
  warning message is given. If \code{recursive = FALSE}, the objects are
  simply concatenated into a list. Before \pkg{ape} 4.0, \code{recursive}
  was always set to FALSE.

  \code{.compressTipLabel} transforms an object of class
  \code{"multiPhylo"} by checking that all trees have the same tip
  labels and renumbering the tips in the \code{edge} matrix so that the
  tip numbers are also the same taking the first tree as the reference
  (duplicated labels are not allowed). The returned object has a unique
  vector of tip labels (\code{attr(x, "TipLabel")}).

  \code{.uncompressTipLabel} does the reverse operation.
}
\value{
  An object of class \code{"multiPhylo"}.
}
\author{Emmanuel Paradis}
\seealso{\code{\link{summary.phylo}}, \code{\link{multiphylo}}}
\examples{
x <- c(rtree(4), rtree(2))
x
y <- c(rtree(4), rtree(4))
z <- c(x, y)
z
print(z, TRUE)
try(.compressTipLabel(x)) # error
a <- .compressTipLabel(y)
.uncompressTipLabel(a) # back to y
## eventually compare str(a) and str(y)
}
\keyword{manip}

\name{del.gaps}
\alias{del.gaps}
\alias{del.colgapsonly}
\alias{del.rowgapsonly}
\title{Delete Alignment Gaps in DNA Sequences}
\description{
  These functions remove gaps (\code{"-"}) in a sample of DNA sequences.
}
\usage{
del.gaps(x)
del.colgapsonly(x, threshold = 1, freq.only = FALSE)
del.rowgapsonly(x, threshold = 1, freq.only = FALSE)
}
\arguments{
  \item{x}{a matrix, a list, or a vector containing the DNA
    sequences; only matrices for \code{del.colgapsonly} and for
    \code{del.rowgapsonly}.}
  \item{threshold}{the largest gap proportion to delete the column or row.}
  \item{freq.only}{if \code{TRUE}, returns only the numbers of gaps for
    each column or row.}
}
\details{
  \code{del.gaps} remove all gaps, so the returned sequences may not
  have all the same lengths and are therefore returned in a list.

  \code{del.colgapsonly} removes the columns with a proportion at least
  \code{threshold} of gaps. Thus by default, only the columns with gaps
  only are removed (useful when a small matrix is extracted from a large
  alignment). \code{del.rowgapsonly} does the same for the rows.

  The sequences can be either in \code{"DNAbin"} or in another format,
  but the returned object is always of class \code{"DNAbin"}.
}
\value{
  \code{del.gaps} returns a vector (if there is only one input sequence)
  or a list of class \code{"DNAbin"}; \code{del.colgapsonly} and
  \code{del.rowgapsonly} return a matrix of class \code{"DNAbin"} or a
  numeric vector (with names for the second function) if \code{freq.only
  = TRUE}.
}
\author{Emmanuel Paradis}
\seealso{
  \code{\link{base.freq}}, \code{\link{seg.sites}},
  \code{\link{image.DNAbin}}, \code{\link{checkAlignment}}
}
\keyword{univar}

\name{FastME}
\alias{FastME}
\alias{fastme}
\alias{fastme.bal}
\alias{fastme.ols}
\title{
  Tree Estimation Based on the Minimum Evolution Algorithm
}
\description{
  The two FastME functions (balanced and OLS) perform the
  minimum evolution algorithm of Desper and Gascuel (2002).
}
\usage{
  fastme.bal(X, nni = TRUE, spr = TRUE, tbr = FALSE)
  fastme.ols(X, nni = TRUE)
}
\arguments{
  \item{X}{a distance matrix; may be an object of class \code{"dist"}.}
  \item{nni}{a logical value; TRUE to perform NNIs (default).}
  \item{spr}{ditto for SPRs.}
  \item{tbr}{ignored (see details).}
}
\details{
  The code to perform topology searches based on TBR (tree bisection and
  reconnection) did not run correctly and has been removed after the
  release of \pkg{ape} 5.3. A warning is issued if \code{tbr = TRUE}.
}
\value{
  an object of class \code{"phylo"}.
}
\references{
  Desper, R. and Gascuel, O. (2002) Fast and accurate phylogeny
  reconstruction algorithms based on the minimum-evolution principle.
  \emph{Journal of Computational Biology}, \bold{9}, 687--705.
}
\author{
  original C code by Richard Desper; adapted and ported to R
  by Vincent Lefort \email{vincent.lefort@lirmm.fr}
}
\seealso{
  \code{\link{nj}}, \code{\link{bionj}},
  \code{\link{write.tree}}, \code{\link{read.tree}},
  \code{\link{dist.dna}}
}
\examples{
### From Saitou and Nei (1987, Table 1):
x <- c(7, 8, 11, 13, 16, 13, 17, 5, 8, 10, 13,
       10, 14, 5, 7, 10, 7, 11, 8, 11, 8, 12,
       5, 6, 10, 9, 13, 8)
M <- matrix(0, 8, 8)
M[lower.tri(M)] <- x
M <- t(M)
M[lower.tri(M)] <- x
dimnames(M) <- list(1:8, 1:8)
tr <- fastme.bal(M)
plot(tr, "u")
### a less theoretical example
data(woodmouse)
trw <- fastme.bal(dist.dna(woodmouse))
plot(trw)
}
\keyword{models}

\name{dnds}
\alias{dnds}
\title{dN/dS Ratio}
\description{
  This function computes the pairwise ratios dN/dS for a set of aligned
  DNA sequences using Li's (1993) method.
}
\usage{
dnds(x, code = 1, codonstart = 1, quiet = FALSE)
}
\arguments{
\item{x}{an object of class \code{"DNAbin"} (matrix or list) with the
  aligned sequences.}
\item{code}{an integer value giving the genetic code to be
  used. Currently only 1 (standard code) and 2 (vertebrate mitochondrial
  code) are supported.}
\item{codonstart}{an integer giving where to start the translation. This
  should be 1, 2, or 3, but larger values are accepted and have for
  effect to start the translation further within the sequence.}
\item{quiet}{single logical value: whether to indicate progress of
  calculations.}
}
\value{
  an object of class \code{"dist"}.
}
\references{
  Li, W.-H. (1993) Unbiased estimation of the rates of synonymous and
  nonsynonymous substitution. \emph{Journal of Molecular Evolution},
  \bold{36}, 96--99.
}
\author{Emmanuel Paradis}
\seealso{
\code{\link{AAbin}}, \code{\link{trans}}, \code{\link{alview}}
}
\examples{
data(woodmouse)
res <- dnds(woodmouse, quiet = TRUE) # NOT correct
res2 <- dnds(woodmouse, code = 2, quiet = TRUE) # using the correct code
identical(res, res2)
}

\name{ace}
\alias{ace}
\alias{print.ace}
\alias{logLik.ace}
\alias{deviance.ace}
\alias{AIC.ace}
\alias{anova.ace}
\title{Ancestral Character Estimation}
\description{
  \code{ace} estimates ancestral character states, and the associated
  uncertainty, for continuous and discrete characters. If \code{marginal
    = TRUE}, a marginal estimation procedure is used. With this method,
  the likelihood values at a given node are computed using only the
  information from the tips (and branches) descending from this node.

  The present implementation of marginal reconstruction for discrete
  characters does not calculate the most likely state for each node,
  integrating over all the possible states, over all the other nodes in
  the tree, in proportion to their probability. For more details, see
  the Note below.

  \code{logLik}, \code{deviance}, and \code{AIC} are generic functions
  used to extract the log-likelihood, the deviance, or the Akaike
  information criterion of a fitted object. If no such values are
  available, \code{NULL} is returned.

  \code{anova} is another generic function which is used to compare
  nested models: the significance of the additional parameter(s) is
  tested with likelihood ratio tests. You must ensure that the models
  are effectively nested (if they are not, the results will be
  meaningless). It is better to list the models from the smallest to the
  largest.
}
\usage{
ace(x, phy, type = "continuous", method = if (type == "continuous")
   "REML" else "ML", CI = TRUE,
    model = if (type == "continuous") "BM" else "ER",
    scaled = TRUE, kappa = 1, corStruct = NULL, ip = 0.1,
    use.expm = FALSE, use.eigen = TRUE, marginal = FALSE)
\method{print}{ace}(x, digits = 4, ...)
\method{logLik}{ace}(object, ...)
\method{deviance}{ace}(object, ...)
\method{AIC}{ace}(object, ..., k = 2)
\method{anova}{ace}(object, ...)
}
\arguments{
  \item{x}{a vector or a factor; an object of class \code{"ace"} in the
    case of \code{print}.}
  \item{phy}{an object of class \code{"phylo"}.}
  \item{type}{the variable type; either \code{"continuous"} or
    \code{"discrete"} (or an abbreviation of these).}
  \item{method}{a character specifying the method used for
    estimation. Four choices are possible: \code{"ML"}, \code{"REML"},
    \code{"pic"}, or \code{"GLS"}.}
  \item{CI}{a logical specifying whether to return the 95\% confidence
    intervals of the ancestral state estimates (for continuous
    characters) or the likelihood of the different states (for discrete
    ones).}
  \item{model}{a character specifying the model (ignored if \code{method
      = "GLS"}), or a numeric matrix if \code{type = "discrete"} (see
    details).}
  \item{scaled}{a logical specifying whether to scale the contrast
    estimate (used only if \code{method = "pic"}).}
  \item{kappa}{a positive value giving the exponent transformation of
    the branch lengths (see details).}
  \item{corStruct}{if \code{method = "GLS"}, specifies the correlation
    structure to be used (this also gives the assumed model).}
  \item{ip}{the initial value(s) used for the ML estimation procedure
    when \code{type == "discrete"} (possibly recycled).}
  \item{use.expm}{a logical specifying whether to use the package
    \pkg{expm} to compute the matrix exponential (relevant only if
    \code{type = "d"}). If \code{FALSE}, the function \code{matexpo}
    from \pkg{ape} is used (see details). This option is ignored if
    \code{use.eigen = TRUE} (see next).}
  \item{use.eigen}{a logical (relevant if \code{type = "d"}); if
    \code{TRUE} then the probability matrix is computed with an eigen
    decomposition instead of a matrix exponential (see details).}
  \item{marginal}{a logical (relevant if \code{type = "d"}). By default,
    the joint reconstruction of the ancestral states are done. Set this
    option to \code{TRUE} if you want the marginal reconstruction (see
    details.)}
  \item{digits}{the number of digits to be printed.}
  \item{object}{an object of class \code{"ace"}.}
  \item{k}{a numeric value giving the penalty per estimated parameter;
    the default is \code{k = 2} which is the classical Akaike
    information criterion.}
  \item{\dots}{further arguments passed to or from other methods.}
}
\details{
  If \code{type = "continuous"}, the default model is Brownian motion
  where characters evolve randomly following a random walk. This model
  can be fitted by residual maximum likelihood (the default), maximum
  likelihood (Felsenstein 1973, Schluter et al. 1997), least squares
  (\code{method = "pic"}, Felsenstein 1985), or generalized least
  squares (\code{method = "GLS"}, Martins and Hansen 1997, Cunningham et
  al. 1998). In the last case, the specification of \code{phy} and
  \code{model} are actually ignored: it is instead given through a
  correlation structure with the option \code{corStruct}.

  In the setting \code{method = "ML"} and \code{model = "BM"} (this used
  to be the default until \pkg{ape} 3.0-7) the maximum likelihood
  estimation is done simultaneously on the ancestral values and the
  variance of the Brownian motion process; these estimates are then used
  to compute the confidence intervals in the standard way. The REML
  method first estimates the ancestral value at the root (aka, the
  phylogenetic mean), then the variance of the Brownian motion process
  is estimated by optimizing the residual log-likelihood. The ancestral
  values are finally inferred from the likelihood function giving these
  two parameters. If \code{method = "pic"} or \code{"GLS"}, the
  confidence intervals are computed using the expected variances under
  the model, so they depend only on the tree.

  It could be shown that, with a continous character, REML results in
  unbiased estimates of the variance of the Brownian motion process
  while ML gives a downward bias. Therefore the former is recommanded.

  For discrete characters (\code{type = "discrete"}), only maximum
  likelihood estimation is available (Pagel 1994) (see \code{\link{MPR}}
  for an alternative method). The model is specified through a numeric
  matrix with integer values taken as indices of the parameters. The
  numbers of rows and of columns of this matrix must be equal, and are
  taken to give the number of states of the character. For instance,
  \code{matrix(c(0, 1, 1, 0), 2)} will represent a model with two
  character states and equal rates of transition, \code{matrix(c(0, 1,
  2, 0), 2)} a model with unequal rates, \code{matrix(c(0, 1, 1, 1, 0,
  1, 1, 1, 0), 3)} a model with three states and equal rates of
  transition (the diagonal is always ignored). There are short-cuts to
  specify these models: \code{"ER"} is an equal-rates model (e.g., the
  first and third examples above), \code{"ARD"} is an
  all-rates-different model (the second example), and \code{"SYM"} is a
  symmetrical model (e.g., \code{matrix(c(0, 1, 2, 1, 0, 3, 2, 3, 0),
  3)}). If a short-cut is used, the number of states is determined from
  the data.

  By default, the likelihood of the different ancestral states of
  discrete characters are computed with a joint estimation procedure
  using a procedure similar to the one described in Pupko et al. (2000).
  If \code{marginal = TRUE}, a marginal estimation procedure is used
  (this was the only choice until ape 3.1-1). With this method, the
  likelihood values at a given node are computed using only the
  information from the tips (and branches) descending from this node.
  With the joint estimation, all information is used for each node. The
  difference between these two methods is further explained in
  Felsenstein (2004, pp. 259-260) and in Yang (2006, pp. 121-126). The
  present implementation of the joint estimation uses a ``two-pass''
  algorithm which is much faster than stochastic mapping while the
  estimates of both methods are very close.

  With discrete characters it is necessary to compute the exponential of
  the rate matrix. The only possibility until \pkg{ape} 3.0-7 was the
  function \code{\link{matexpo}} in \pkg{ape}. If \code{use.expm = TRUE}
  and \code{use.eigen = FALSE}, the function \code{\link[expm]{expm}},
  in the package of the same name, is used. \code{matexpo} is faster but
  quite inaccurate for large and/or asymmetric matrices. In case of
  doubt, use the latter. Since \pkg{ape} 3.0-10, it is possible to use
  an eigen decomposition avoiding the need to compute the matrix
  exponential; see details in Lebl (2013, sect. 3.8.3). This is much
  faster and is now the default.

  Since version 5.2 of \pkg{ape}, \code{ace} can take state uncertainty
  for discrete characters into account: this should be coded with \R's
  \code{\link[base]{NA}} only. More details:

  \url{https://www.mail-archive.com/r-sig-phylo@r-project.org/msg05286.html}
}
\note{
  Liam Revell points out that for discrete characters the ancestral
  likelihood values returned with \code{marginal = FALSE} are actually
  the marginal estimates, while setting \code{marginal = TRUE} returns
  the conditional (scaled) likelihoods of the subtree:

  \url{http://blog.phytools.org/2015/05/about-how-acemarginaltrue-does-not.html}
}
\value{
  an object of class \code{"ace"} with the following elements:

  \item{ace}{if \code{type = "continuous"}, the estimates of the
    ancestral character values.}
  \item{CI95}{if \code{type = "continuous"}, the estimated 95\%
    confidence intervals.}
  \item{sigma2}{if \code{type = "continuous"}, \code{model = "BM"}, and
    \code{method = "ML"}, the maximum likelihood estimate of the
    Brownian parameter.}
  \item{rates}{if \code{type = "discrete"}, the maximum likelihood
    estimates of the transition rates.}
  \item{se}{if \code{type = "discrete"}, the standard-errors of
    estimated rates.}
  \item{index.matrix}{if \code{type = "discrete"}, gives the indices of
    the \code{rates} in the rate matrix.}
  \item{loglik}{if \code{method = "ML"}, the maximum log-likelihood.}
  \item{lik.anc}{if \code{type = "discrete"}, the scaled likelihoods of
    each ancestral state.}
  \item{call}{the function call.}
}
\references{
  Cunningham, C. W., Omland, K. E. and Oakley, T. H. (1998)
  Reconstructing ancestral character states: a critical
  reappraisal. \emph{Trends in Ecology & Evolution}, \bold{13},
  361--366.

  Felsenstein, J. (1973) Maximum likelihood estimation
  of evolutionary trees from continuous characters. \emph{American
  Journal of Human Genetics}, \bold{25}, 471--492.

  Felsenstein, J. (1985) Phylogenies and the comparative
  method. \emph{American Naturalist}, \bold{125}, 1--15.

  Felsenstein, J. (2004) \emph{Inferring Phylogenies}. Sunderland:
  Sinauer Associates.

  Lebl, J. (2013) \emph{Notes on Diffy Qs: Differential Equations for
  Engineers}. \url{https://www.jirka.org/diffyqs/}.

  Martins, E. P. and Hansen, T. F. (1997) Phylogenies and the
  comparative method: a general approach to incorporating phylogenetic
  information into the analysis of interspecific data. \emph{American
    Naturalist}, \bold{149}, 646--667.

  Pagel, M. (1994) Detecting correlated evolution on phylogenies: a
  general method for the comparative analysis of discrete
  characters. \emph{Proceedings of the Royal Society of London. Series
    B. Biological Sciences}, \bold{255}, 37--45.

  Pupko, T., Pe'er, I, Shamir, R., and Graur, D. (2000) A fast algorithm
  for joint reconstruction of ancestral amino acid sequences.
  \emph{Molecular Biology and Evolution}, \bold{17}, 890--896.

  Schluter, D., Price, T., Mooers, A. O. and Ludwig, D. (1997)
  Likelihood of ancestor states in adaptive radiation. \emph{Evolution},
  \bold{51}, 1699--1711.

  Yang, Z. (2006) \emph{Computational Molecular Evolution}. Oxford:
  Oxford University Press.
}
\author{Emmanuel Paradis, Ben Bolker}
\seealso{
  \code{\link{MPR}}, \code{\link{corBrownian}}, \code{\link{compar.ou}},
  \code{\link[stats]{anova}}

  Reconstruction of ancestral sequences can be done with the package
  \pkg{phangorn} (see function \code{?ancestral.pml}).
}
\examples{
### Some random data...
data(bird.orders)
x <- rnorm(23)
### Compare the three methods for continuous characters:
ace(x, bird.orders)
ace(x, bird.orders, method = "pic")
ace(x, bird.orders, method = "GLS",
    corStruct = corBrownian(1, bird.orders))
### For discrete characters:
x <- factor(c(rep(0, 5), rep(1, 18)))
ans <- ace(x, bird.orders, type = "d")
#### Showing the likelihoods on each node:
plot(bird.orders, type = "c", FALSE, label.offset = 1)
co <- c("blue", "yellow")
tiplabels(pch = 22, bg = co[as.numeric(x)], cex = 2, adj = 1)
nodelabels(thermo = ans$lik.anc, piecol = co, cex = 0.75)
}
\keyword{models}

\name{as.bitsplits}
\alias{as.bitsplits}
\alias{as.bitsplits.prop.part}
\alias{print.bitsplits}
\alias{sort.bitsplits}
\alias{bitsplits}
\alias{countBipartitions}
\alias{as.prop.part}
\alias{as.prop.part.bitsplits}
\title{Split Frequencies and Conversion Among Split Classes}
\description{
  \code{bitsplits} returns the bipartitions (aka splits) for a single
  tree or a list of trees.

  \code{countBipartitions} returns the frequencies of the bipartitions
  from a reference tree (phy) observed in a list of trees (X).

  \code{as.bitsplits} and \code{as.prop.part} are generic functions for
  converting between the \code{"bitsplits"} and \code{"prop.part"}
  classes.
}
\usage{
bitsplits(x)
countBipartitions(phy, X)
as.bitsplits(x)
\method{as.bitsplits}{prop.part}(x)
\method{print}{bitsplits}(x, ...)
\method{sort}{bitsplits}(x, decreasing = FALSE, ...)
as.prop.part(x, ...)
\method{as.prop.part}{bitsplits}(x, include.trivial = FALSE, ...)
}
\arguments{
  \item{x}{an object of the appropriate class.}
  \item{phy}{an object of class \code{"phylo"}.}
  \item{X}{an object of class \code{"multiPhylo"}.}
  \item{decreasing}{a logical value to sort the bipartitions in
    increasing (the default) or decreasing order of their frequency.}
  \item{include.trivial}{a logical value specifying whether to include
    the trivial split with all tips in the returned object.}
  \item{\dots}{further arguments passed to or from other methods.}
}
\details{
  These functions count bipartitions as defined by internal branches, so
  they do not work with rooted trees (see examples). The structure of
  the class \code{"bitsplits"} is described in a separate document
  on ape's web site.
}
\value{
  \code{bitsplits}, \code{as.bitsplits}, and \code{sort} return an object
  of class \code{"bitsplits"}.

  \code{countBipartitions} returns a vector of integers.

  \code{as.prop.part} returns an object of class \code{"prop.part"}.
}
\author{Emmanuel Paradis}
\seealso{\code{\link{prop.part}}, \code{\link{is.compatible}}}
\examples{
tr <- rtree(20)
pp <- prop.part(tr)
as.bitsplits(pp)
## doesn't work for rooted trees...:
countBipartitions(rtree(10), rmtree(100, 10))
## ... but OK with unrooted trees:
countBipartitions(rtree(10, rooted = FALSE), rmtree(100, 10, rooted = FALSE))
}
\keyword{manip}

\name{Initialize.corPhyl}
\alias{Initialize.corPhyl}
\title{Initialize a `corPhyl' Structure Object}
\usage{
	\method{Initialize}{corPhyl}(object, data, ...)
}
\arguments{
	\item{object}{An object inheriting from class \code{corPhyl}.}
	\item{data}{The data to use. If it contains rownames, they are matched with the tree tip labels, otherwise data are supposed to be in the same order than tip labels and a warning is sent.}
	\item{\dots}{some methods for this generic require additional arguments. None are used in this method.}
}
\description{
	Initialize a \code{corPhyl} correlation structure object.
	Does the same as \code{Initialize.corStruct}, but also checks the row names of data and builds an index.
}
\value{
	An initialized object of same class as \code{object}.
}
\author{Julien Dutheil \email{dutheil@evolbio.mpg.de}}
\seealso{
  \code{\link{corClasses}}, \code{\link[nlme]{Initialize.corStruct}}.
}
\keyword{models}
\keyword{manip}

\name{alview}
\alias{alview}
\title{Print DNA or AA Sequence Alignement}
\description{
  This function displays in the console or a file an alignment of DNA or
  AAsequences. The first sequence is printed on the first row and the
  bases of the other sequences are replaced by dots if they are
  identical with the first sequence.
}
\usage{
alview(x, file = "", uppercase = TRUE, showpos = TRUE)
}
\arguments{
  \item{x}{a matrix or a list of DNA sequences (class \code{"DNAbin"})
    or a matrix of AA sequences (class \code{"AAbin"}).}
  \item{file}{a character string giving the name of the file where to print the sequences; by default, they are printed in the console.}
  \item{uppercase}{a logical specifying whether to print the bases as
    uppercase letters.}
  \item{showpos}{either a logical value specifying whether to display
    the site positions, or a numeric vector giving these positions (see
    examples).}
}
\details{
The first line of the output shows the position of the last column of the printed alignment.
}
\author{Emmanuel Paradis}
\seealso{
  \code{\link{DNAbin}}, \code{\link{image.DNAbin}}, \code{\link{alex}},
  \code{\link{clustal}}, \code{\link{checkAlignment}}, \code{\link{all.equal.DNAbin}}
}
\examples{
data(woodmouse)
alview(woodmouse[, 1:50])
alview(woodmouse[, 1:50], uppercase = FALSE)
## display only some sites:
j <- c(10, 49, 125, 567) # just random
x <- woodmouse[, j]
alview(x, showpos = FALSE) # no site position displayed
alview(x, showpos = j)
\dontrun{
alview(woodmouse, file = "woodmouse.txt")
}
}
\keyword{IO}

\name{speciesTree}
\alias{speciesTree}
\title{Species Tree Estimation}
\description{
  This function calculates the species tree from a set of gene trees.
}
\usage{
speciesTree(x, FUN = min)
}
\arguments{
  \item{x}{a list of trees, e.g., an object of class
    \code{"multiPhylo"}.}
  \item{FUN}{a function used to compute the divergence times of each
    pair of tips.}
}
\details{
  For all trees in \code{x}, the divergence time of each pair of tips is
  calculated: these are then `summarized' with \code{FUN} to build a new
  distance matrix used to calculate the species tree with a
  single-linkage hierarchical clustering. The default for \code{FUN}
  computes the maximum tree (maxtree) of Liu et al. (2010). Using
  \code{FUN = mean} gives the shallowest divergence tree of Maddison and
  Knowles (2006).
}
\value{
  an object of class \code{"phylo"}.
}
\references{
  Liu, L., Yu, L. and Pearl, D. K. (2010) Maximum tree: a consistent
  estimator of the species tree. \emph{Journal of Mathematical Biology},
  \bold{60}, 95--106.

  Maddison, W. P. and Knowles, L. L. (2006) Inferring phylogeny despite
  incomplete lineage sorting. \emph{Systematic Biology}, \bold{55}, 21--30.
}
\author{Emmanuel Paradis}
\examples{
### example in Liu et al. (2010):
tr1 <- read.tree(text = "(((B:0.05,C:0.05):0.01,D:0.06):0.04,A:0.1);")
tr2 <- read.tree(text = "(((A:0.07,C:0.07):0.02,D:0.09):0.03,B:0.12);")
TR <- c(tr1, tr2)
TSmax <- speciesTree(TR) # MAXTREE
TSsha <- speciesTree(TR, mean) # shallowest divergence

kronoviz(c(tr1, tr2, TSmax, TSsha), horiz = FALSE,
         type = "c", cex = 1.5, font = 1)
mtext(c("Gene tree 1", "Gene tree 2", "Species tree - MAXTREE"),
      at = -c(7.5, 4, 1))
mtext("Species tree - Shallowest Divergence")
layout(1)
}
\keyword{models}

\name{mantel.test}
\alias{mantel.test}
\title{Mantel Test for Similarity of Two Matrices}
\description{
  This function computes Mantel's permutation test for similarity of two
  matrices. It permutes the rows and columns of the second matrix
  randomly and calculates a \eqn{Z}-statistic.
}
\usage{
mantel.test(m1, m2, nperm = 999, graph = FALSE,
            alternative = "two.sided",  ...)
}
\arguments{
  \item{m1}{a numeric matrix giving a measure of pairwise distances,
    correlations, or similarities among observations.}
  \item{m2}{a second numeric matrix giving another measure of pairwise
    distances, correlations, or similarities among observations.}
  \item{nperm}{the number of times to permute the data.}
  \item{graph}{a logical indicating whether to produce a summary graph
    (by default the graph is not plotted).}
  \item{alternative}{a character string defining the alternative
    hypothesis:  \code{"two.sided"} (default),  \code{"less"},
    \code{"greater"}, or any unambiguous abbreviation of these.}
  \item{\dots}{further arguments to be passed to \code{plot()} (to add a
    title, change the axis labels, and so on).}
}
\details{
  The function calculates a \eqn{Z}-statistic for the Mantel test, equal to
  the sum of the  pairwise product of the lower triangles of the
  permuted matrices, for each permutation of rows and columns. It
  compares the permuted distribution with the \eqn{Z}-statistic observed
  for the actual data.

  The present implementation can analyse symmetric as well as (since
  version 5.1 of \pkg{ape}) asymmetric matrices (see Mantel 1967,
  Sects. 4 and 5). The diagonals of both matrices are ignored.

  If \code{graph = TRUE}, the functions plots the density estimate of
  the permutation distribution along with the observed \eqn{Z}-statistic
  as a vertical line.

  The \code{\dots} argument allows the user to give further options to
  the \code{plot} function: the title main be changed with \code{main=},
  the axis labels with \code{xlab =}, and \code{ylab =}, and so on.
}
\value{
  \item{z.stat}{the \eqn{Z}-statistic (sum of rows*columns of lower
    triangle) of the data matrices.}
  \item{p}{\eqn{P}-value (quantile of the observed \eqn{Z}-statistic in
    the permutation distribution).}
  \item{alternative}{the alternative hypothesis.}
}
\references{
  Mantel, N. (1967) The detection of disease clustering and a
  generalized regression approach. \emph{Cancer Research}, \bold{27},
  209--220.

  Manly, B. F. J. (1986) \emph{Multivariate statistical methods: a primer.}
  London: Chapman & Hall.
}
\author{
  Original code in S by Ben Bolker, ported to \R by Julien Claude
}
\examples{
q1 <- matrix(runif(36), nrow = 6)
q2 <- matrix(runif(36), nrow = 6)
diag(q1) <- diag(q2) <- 0
mantel.test(q1, q2, graph = TRUE,
            main = "Mantel test: a random example with 6 X 6 matrices
representing asymmetric relationships",
            xlab = "z-statistic", ylab = "Density",
            sub = "The vertical line shows the observed z-statistic")
}
\keyword{multivariate}

\name{richness.yule.test}
\alias{richness.yule.test}
\title{Test of Diversification-Shift With the Yule Process}
\description{
  This function performs a test of shift in diversification rate using
  probabilities from the Yule process.
}
\usage{
richness.yule.test(x, t)
}
\arguments{
  \item{x}{a matrix or a data frame with at least two columns: the first
    one gives the number of species in clades with a trait supposed to
    increase or decrease diversification rate, and the second one the number of
    species in the sister-clades without the trait. Each
    row represents a pair of sister-clades.}
  \item{t}{a numeric vector giving the divergence times of each pair of
    clades in \code{x}.}
}
\value{
  a data frame with the \eqn{\chi^2}{chi2}, the number of degrees of
  freedom (= 1), and the \emph{P}-value.
}
\references{
  Paradis, E. (2012) Shift in diversification in sister-clade
  comparisons: a more powerful test. \emph{Evolution}, \bold{66},
  288--295.
}
\author{Emmanuel Paradis}
\seealso{
  \code{\link{slowinskiguyer.test}}, \code{\link{mcconwaysims.test}},
  \code{\link{diversity.contrast.test}}
}
\examples{
### see example(mcconwaysims.test)
}
\keyword{htest}

\name{corPagel}
\alias{corPagel}
\alias{coef.corPagel}
\alias{corMatrix.corPagel}
\title{Pagel's ``lambda'' Correlation Structure}
\usage{
corPagel(value, phy, form = ~1, fixed = FALSE)
\method{corMatrix}{corPagel}(object, covariate = getCovariate(object),
                   corr = TRUE, ...)
\method{coef}{corPagel}(object, unconstrained = TRUE, \dots)
}
\arguments{
  \item{value}{the (initial) value of the parameter
    \eqn{\lambda}{lambda}.}
  \item{phy}{an object of class \code{"phylo"}.}
  \item{form}{a one sided formula of the form ~ t, or ~ t | g, specifying the taxa covariate t and, optionally, a grouping factor g. A covariate for this correlation structure must be character valued, with entries matching the tip labels in the phylogenetic tree. When a grouping factor is present in form, the correlation structure is assumed to apply only to observations within the same grouping level; observations with different grouping levels are assumed to be uncorrelated. Defaults to ~ 1, which corresponds to using the order of the observations in the data as a covariate, and no groups.}
  \item{fixed}{a logical specifying whether \code{gls} should
    estimate \eqn{\lambda}{lambda} (the default) or keep it fixed.}
  \item{object}{an (initialized) object of class \code{"corPagel"}.}
  \item{covariate}{an optional covariate vector (matrix), or list of covariate vectors (matrices), at which values the correlation matrix, or list of correlation matrices, are to be evaluated. Defaults to getCovariate(object).}
  \item{corr}{a logical value specifying whether to return the
    correlation matrix (the default) or the variance-covariance matrix.}
  \item{unconstrained}{a logical value. If \code{TRUE} (the default),
    the coefficients are returned in unconstrained form (the same used
    in the optimization algorithm). If \code{FALSE} the coefficients are
    returned in ``natural'', possibly constrained, form.}
  \item{\dots}{further arguments passed to or from other methods.}
}
\description{
  The correlation structure from the present model is derived from the
  Brownian motion model by multiplying the off-diagonal elements (i.e.,
  the covariances) by \eqn{\lambda}{lambda}. The variances are thus the
  same than for a Brownian motion model.
}
\value{
  an object of class \code{"corPagel"}, the coefficients from an object
  of this class, or the correlation matrix of an initialized object of
  this class. In most situations, only \code{corPagel} will be called
  by the user.
}
\author{Emmanuel Paradis}
\references{
  Freckleton, R. P., Harvey, P. H. and M. Pagel, M. (2002) Phylogenetic
  analysis and comparative data: a test and review of evidence.
  \emph{American Naturalist}, \bold{160}, 712--726.

  Pagel, M. (1999) Inferring the historical patterns of biological
  evolution. \emph{Nature}, \bold{401},877--884.
}
\keyword{models}

\name{drop.tip}
\alias{drop.tip}
\alias{keep.tip}
\alias{extract.clade}
\title{Remove Tips in a Phylogenetic Tree}
\description{
  \code{drop.tip} removes the terminal branches of a phylogenetic tree,
  possibly removing the corresponding internal branches. \code{keep.tip}
  does the opposite operation (i.e., returns the induced tree).

  \code{extract.clade} does the inverse operation: it keeps all the tips
  from a given node, and deletes all the other tips.
}
\usage{
drop.tip(phy, tip, trim.internal = TRUE, subtree = FALSE,
         root.edge = 0, rooted = is.rooted(phy), collapse.singles = TRUE,
         interactive = FALSE)
keep.tip(phy, tip)
extract.clade(phy, node, root.edge = 0, collapse.singles = TRUE,
              interactive = FALSE)
}
\arguments{
  \item{phy}{an object of class \code{"phylo"}.}
  \item{tip}{a vector of mode numeric or character specifying the tips
    to delete.}
  \item{trim.internal}{a logical specifying whether to delete the
    corresponding internal branches.}
  \item{subtree}{a logical specifying whether to output in the tree how
    many tips have been deleted and where.}
  \item{root.edge}{an integer giving the number of internal branches to
    be used to build the new root edge. This has no effect if
    \code{trim.internal = FALSE}.}
  \item{rooted}{a logical indicating whether the tree must be treated as
    rooted or not. This allows to force the tree to be considered as
    unrooted (see examples).}
  \item{collapse.singles}{a logical specifying whether to delete the
    internal nodes of degree 2.}
  \item{node}{a node number or label.}
  \item{interactive}{if \code{TRUE} the user is asked to select the tips
    or the node by clicking on the tree which must be plotted.}
}
\details{
  The argument \code{tip} can be either character or numeric. In the
  first case, it gives the labels of the tips to be deleted; in the
  second case the numbers of these labels in the vector
  \code{phy$tip.label} are given.

  This also applies to \code{node}, but if this argument is character
  and the tree has no node label, this results in an error. If more than
  one value is given with \code{node} (i.e., a vector of length two or
  more), only the first one is used with a warning.

  If \code{trim.internal = FALSE}, the new tips are given \code{"NA"} as
  labels, unless there are node labels in the tree in which case they
  are used.

  If \code{subtree = TRUE}, the returned tree has one or several
  terminal branches indicating how many tips have been removed (with a
  label \code{"[x_tips]"}). This is done for as many monophyletic groups
  that have been deleted.

  Note that \code{subtree = TRUE} implies \code{trim.internal = TRUE}.

  To undestand how the option \code{root.edge} works, see the examples
  below.
}
\value{
  an object of class \code{"phylo"}.
}
\author{Emmanuel Paradis, Klaus Schliep, Joseph Brown}
\seealso{
  \code{\link{bind.tree}}, \code{\link{root}}
}
\examples{
data(bird.families)
tip <- c(
"Eopsaltriidae", "Acanthisittidae", "Pittidae", "Eurylaimidae",
"Philepittidae", "Tyrannidae", "Thamnophilidae", "Furnariidae",
"Formicariidae", "Conopophagidae", "Rhinocryptidae", "Climacteridae",
"Menuridae", "Ptilonorhynchidae", "Maluridae", "Meliphagidae",
"Pardalotidae", "Petroicidae", "Irenidae", "Orthonychidae",
"Pomatostomidae", "Laniidae", "Vireonidae", "Corvidae",
"Callaeatidae", "Picathartidae", "Bombycillidae", "Cinclidae",
"Muscicapidae", "Sturnidae", "Sittidae", "Certhiidae",
"Paridae", "Aegithalidae", "Hirundinidae", "Regulidae",
"Pycnonotidae", "Hypocoliidae", "Cisticolidae", "Zosteropidae",
"Sylviidae", "Alaudidae", "Nectariniidae", "Melanocharitidae",
"Paramythiidae","Passeridae", "Fringillidae")
plot(drop.tip(bird.families, tip))
plot(drop.tip(bird.families, tip, trim.internal = FALSE))
data(bird.orders)
plot(drop.tip(bird.orders, 6:23, subtree = TRUE))
plot(drop.tip(bird.orders, c(1:5, 20:23), subtree = TRUE))
plot(drop.tip(bird.orders, c(1:20, 23), subtree = TRUE))
plot(drop.tip(bird.orders, c(1:20, 23), subtree = TRUE, rooted = FALSE))
### Examples of the use of `root.edge'
tr <- read.tree(text = "(A:1,(B:1,(C:1,(D:1,E:1):1):1):1):1;")
drop.tip(tr, c("A", "B"), root.edge = 0) # = (C:1,(D:1,E:1):1);
drop.tip(tr, c("A", "B"), root.edge = 1) # = (C:1,(D:1,E:1):1):1;
drop.tip(tr, c("A", "B"), root.edge = 2) # = (C:1,(D:1,E:1):1):2;
drop.tip(tr, c("A", "B"), root.edge = 3) # = (C:1,(D:1,E:1):1):3;
}
\keyword{manip}

\name{rTraitMult}
\alias{rTraitMult}
\title{Multivariate Character Simulation}
\description{
  This function simulates the evolution of a multivariate set of traits
  along a phylogeny. The calculation is done recursively from the
  root.
}
\usage{
rTraitMult(phy, model, p = 1, root.value = rep(0, p), ancestor = FALSE,
           asFactor = NULL, trait.labels = paste("x", 1:p, sep = ""), ...)
}
\arguments{
  \item{phy}{an object of class \code{"phylo"}.}
  \item{model}{a function specifying the model (see details).}
  \item{p}{an integer giving the number of traits.}
  \item{root.value}{a numeric vector giving the values at the root.}
  \item{ancestor}{a logical value specifying whether to return the
    values at the nodes as well (by default, only the values at the tips
    are returned).}
  \item{asFactor}{the indices of the traits that are returned as factors
    (discrete traits).}
  \item{trait.labels}{a vector of mode character giving the names of the
    traits.}
  \item{\dots}{further arguments passed to \code{model} if it is a
    function.}
}
\details{
  The model is specified with an \R function of the form \code{foo(x,
    l)} where \code{x} is a vector of the traits of the ancestor and
  \code{l} is the branch length. Other arguments may be added. The
  function must return a vector of length \code{p}.
}
\value{
  A data frame with \code{p} columns whose names are given by
  \code{trait.labels} and row names taken from the labels of the tree.
}
\author{Emmanuel Paradis}
\seealso{
  \code{\link{rTraitCont}}, \code{\link{rTraitDisc}}, \code{\link{ace}}
}
\examples{
## correlated evolution of 2 continuous traits:
mod <- function(x, l) {
    y1 <- rnorm(1, x[1] + 0.5*x[2], 0.1)
    y2 <- rnorm(1, 0.5*x[1] + x[2], 0.1)
    c(y1, y2)
}
set.seed(11)
tr <- makeNodeLabel(rcoal(20))
x <- rTraitMult(tr, mod, 2, ancestor = TRUE)
op <- par(mfcol = c(2, 1))
plot(x, type = "n")
text(x, labels = rownames(x), cex = 0.7)
oq <- par(mar = c(0, 1, 0, 1), xpd = TRUE)
plot(tr, font = 1, cex = 0.7)
nodelabels(tr$node.label, cex = 0.7, adj = 1)
par(c(op, oq))
}
\keyword{datagen}

\name{boot.phylo}
\alias{boot.phylo}
\alias{prop.part}
\alias{prop.clades}
\alias{print.prop.part}
\alias{summary.prop.part}
\alias{plot.prop.part}
\title{Tree Bipartition and Bootstrapping Phylogenies}
\description{
  These functions analyse bipartitions found in a series of trees.

  \code{prop.part} counts the number of bipartitions found in a series
  of trees given as \code{\dots}. If a single tree is passed, the
  returned object is a list of vectors with the tips descending from
  each node (i.e., clade compositions indexed by node number).

  \code{prop.clades} counts the number of times the bipartitions present
  in \code{phy} are present in a series of trees given as \code{\dots} or
  in the list previously computed and given with \code{part}.

  \code{boot.phylo} performs a bootstrap analysis.
}
\usage{
boot.phylo(phy, x, FUN, B = 100, block = 1,
           trees = FALSE, quiet = FALSE,
           rooted = is.rooted(phy), jumble = TRUE,
            mc.cores = 1)
prop.part(..., check.labels = TRUE)
prop.clades(phy, ..., part = NULL, rooted = FALSE)
\method{print}{prop.part}(x, ...)
\method{summary}{prop.part}(object, ...)
\method{plot}{prop.part}(x, barcol = "blue", leftmar = 4, col = "red", ...)
}
\arguments{
  \item{phy}{an object of class \code{"phylo"}.}
  \item{x}{in the case of \code{boot.phylo}: a taxa (rows) by characters
    (columns) matrix; in the case of \code{print} and \code{plot}: an
    object of class \code{"prop.part"}.}
  \item{FUN}{the function used to estimate \code{phy} (see details).}
  \item{B}{the number of bootstrap replicates.}
  \item{block}{the number of columns in \code{x} that will be resampled
    together (see details).}
  \item{trees}{a logical specifying whether to return the bootstraped
    trees (\code{FALSE} by default).}
  \item{quiet}{a logical: a progress bar is displayed by default.}
  \item{rooted}{a logical specifying whether the trees should be treated
    as rooted or not.}
  \item{jumble}{a logical value. By default, the rows of \code{x} are
    randomized to avoid artificially too large bootstrap values
    associated with very short branches.}
  \item{mc.cores}{the number of cores (CPUs) to be used (passed to
    \pkg{parallel}).}
  \item{\dots}{either (i) a single object of class \code{"phylo"}, (ii) a
    series of such objects separated by commas, or (iii) a list
    containing such objects. In the case of \code{plot} further
    arguments for the plot (see details).}
  \item{check.labels}{a logical specifying whether to check the labels
    of each tree. If \code{FALSE}, it is assumed that all trees have the
    same tip labels, and that they are in the same order (see details).}
  \item{part}{a list of partitions as returned by \code{prop.part}; if
    this is used then \code{\dots} is ignored.}
  \item{object}{an object of class \code{"prop.part"}.}
  \item{barcol}{the colour used for the bars displaying the number of
    partitions in the upper panel.}
  \item{leftmar}{the size of the margin on the left to display the tip
    labels.}
  \item{col}{the colour used to visualise the bipartitions.}
}
\details{
  The argument \code{FUN} in \code{boot.phylo} must be the function used
  to estimate the tree from the original data matrix. Thus, if the tree
  was estimated with neighbor-joining (see \code{nj}), one maybe wants
  something like \code{FUN = function(xx) nj(dist.dna(xx))}.

  \code{block} in \code{boot.phylo} specifies the number of columns to
  be resampled altogether. For instance, if one wants to resample at the
  codon-level, then \code{block = 3} must be used.

  Using \code{check.labels = FALSE} in \code{prop.part} decreases
  computing times. This requires that (i) all trees have the same tip
  labels, \emph{and} (ii) these labels are ordered similarly in all
  trees (in other words, the element \code{tip.label} are identical in
  all trees).

  The plot function represents a contingency table of the different
  partitions (on the \emph{x}-axis) in the lower panel, and their observed
  numbers in the upper panel. Any further arguments (\dots) are used to
  change the aspects of the points in the lower panel: these may be
  \code{pch}, \code{col}, \code{bg}, \code{cex}, etc. This function
  works only if there is an attribute \code{labels} in the object.

  The print method displays the partitions and their numbers. The
  summary method extracts the numbers only.
}
\note{
  \code{prop.clades} calls internally \code{prop.part} with the option
  \code{check.labels = TRUE}, which may be very slow. If the trees
  passed as \code{\dots} fulfills conditions (i) and (ii) above, then it
  might be faster to first call, e.g., \code{pp <- prop.part(...)}, then
  use the option \code{part}: \code{prop.clades(phy, part = pp)}.

  Since \pkg{ape} 3.5, \code{prop.clades} should return sensible results
  for all values of \code{rooted}: if \code{FALSE}, the numbers of
  bipartitions (or splits); if \code{TRUE}, the number of clades (of
  hopefully rooted trees).
}
\value{
  \code{prop.part} returns an object of class \code{"prop.part"} which
  is a list with an attribute \code{"number"}. The elements of this list
  are the observed clades, and the attribute their respective
  numbers. If the default \code{check.labels = FALSE} is used, an
  attribute \code{"labels"} is added, and the vectors of the returned
  object contains the indices of these labels instead of the labels
  themselves.

  \code{prop.clades} and \code{boot.phylo} return a numeric vector
  which \emph{i}th element is the number associated to the \emph{i}th
  node of \code{phy}. If \code{trees = TRUE}, \code{boot.phylo} returns
  a list whose first element (named \code{"BP"}) is like before, and the
  second element (\code{"trees"}) is a list with the bootstraped
  trees.

  \code{summary} returns a numeric vector.
}
\references{
  Efron, B., Halloran, E. and Holmes, S. (1996) Bootstrap confidence
  levels for phylogenetic trees. \emph{Proceedings of the National
    Academy of Sciences USA}, \bold{93}, 13429--13434.

  Felsenstein, J. (1985) Confidence limits on phylogenies: an approach
  using the bootstrap. \emph{Evolution}, \bold{39}, 783--791.
}
\author{Emmanuel Paradis}
\seealso{
  \code{\link{as.bitsplits}}, \code{\link{dist.topo}},
  \code{\link{consensus}}, \code{\link{nodelabels}}
}
\examples{
data(woodmouse)
f <- function(x) nj(dist.dna(x))
tr <- f(woodmouse)
### Are bootstrap values stable?
for (i in 1:5)
  print(boot.phylo(tr, woodmouse, f, quiet = TRUE))
### How many partitions in 100 random trees of 10 labels?...
TR <- rmtree(100, 10)
pp10 <- prop.part(TR)
length(pp10)
### ... and in 100 random trees of 20 labels?
TR <- rmtree(100, 20)
pp20 <- prop.part(TR)
length(pp20)
plot(pp10, pch = "x", col = 2)
plot(pp20, pch = "x", col = 2)

set.seed(2)
tr <- rtree(10) # rooted
## the following used to return a wrong result with ape <= 3.4:
prop.clades(tr, tr)
prop.clades(tr, tr, rooted = TRUE)
tr <- rtree(10, rooted = FALSE)
prop.clades(tr, tr) # correct

### an illustration of the use of prop.clades with bootstrap trees:

fun <- function(x) as.phylo(hclust(dist.dna(x), "average")) # upgma() in phangorn
tree <- fun(woodmouse)
## get 100 bootstrap trees:
bstrees <- boot.phylo(tree, woodmouse, fun, trees = TRUE)$trees
## get proportions of each clade:
clad <- prop.clades(tree, bstrees, rooted = TRUE)
## get proportions of each bipartition:
boot <- prop.clades(tree, bstrees)
layout(1)
par(mar = rep(2, 4))
plot(tree, main = "Bipartition vs. Clade Support Values")
drawSupportOnEdges(boot)
nodelabels(clad)
legend("bottomleft", legend = c("Bipartitions", "Clades"), pch = 22,
       pt.bg = c("green", "lightblue"), pt.cex = 2.5)

\dontrun{
## an example of double bootstrap:
nrep1 <- 100
nrep2 <- 100
p <- ncol(woodmouse)
DB <- 0

for (b in 1:nrep1) {
    X <- woodmouse[, sample(p, p, TRUE)]
    DB <- DB + boot.phylo(tr, X, f, nrep2, quiet = TRUE)
}
DB
## to compare with:
boot.phylo(tr, woodmouse, f, 1e4)
}
}
\keyword{manip}
\keyword{htest}

\name{write.nexus.data}
\alias{write.nexus.data}
\title{Write Character Data in NEXUS Format}
\description{
  This function writes in a file a list of data in the NEXUS format. The
  names of the vectors of the list are used as taxon names.
}
\usage{
write.nexus.data(x, file, format = "dna", datablock = TRUE,
                 interleaved = TRUE, charsperline = NULL,
                 gap = NULL, missing = NULL)
}
\arguments{
  \item{x}{a matrix or a list of data each made of a single vector
    of mode character where each element is a character state (e.g.,
    \dQuote{A}, \dQuote{C}, \dots) Objects of class of \dQuote{DNAbin}
    are accepted.}
  \item{file}{a file name specified by either a variable of mode
    character, or a double-quoted string.}
  \item{format}{a character string specifying the format of the
    sequences. Four choices are possible: \code{"dna"} (the default)
    \code{"protein"}, \code{"standard"} or \code{"continuous"} or any
    unambiguous abbreviation of these (case insensitive).}
  \item{datablock}{a logical, if \code{TRUE} the data are written in a
    single DATA block. If \code{FALSE}, the data are written in TAXA and
    CHARACTER blocks. Default is \code{TRUE}.}
  \item{interleaved}{a logical, if \code{TRUE} the data is written in
    interleaved format with number of characters per line as specified
    with \code{charsperline = numerical_value}. If \code{FALSE}, the
    data are written in sequential format. Default is \code{TRUE}.}
  \item{charsperline}{a numeric value specifying the number of
    characters per line when used with \code{interleaved =
      TRUE}. Default is 80.}
  \item{gap}{a character specifying the symbol for gap. Default is
    \dQuote{\code{-}}.}
  \item{missing}{a character specifying the symbol for missing
    data. Default is \dQuote{\code{?}}.}
}
\details{
  If the sequences have no names, then they are given \dQuote{1},
  \dQuote{2}, ..., as names in the file.

  Sequences must be all of the same length.
}
\value{
  None (invisible \sQuote{NULL}).
}
\references{
  Maddison, D. R., Swofford, D. L. and Maddison, W. P. (1997) NEXUS: an
  extensible file format for systematic information. \emph{Systematic
    Biology}, \bold{46}, 590--621.
}
\author{Johan Nylander \email{nylander@scs.fsu.edu} and Thomas Guillerme}
\seealso{
  \code{\link{read.nexus}},\code{\link{write.nexus}},
  \code{\link{read.nexus.data}}
}
\examples{
\dontrun{
## Write interleaved DNA data with 100 characters per line in a DATA block
data(woodmouse)
write.nexus.data(woodmouse, file= "wood.ex.nex", interleaved = TRUE, charsperline = 100)
## Write sequential DNA data in TAXA and CHARACTERS blocks
data(cynipids)
write.nexus.data(cynipids, file = "cyn.ex.nex", format = "protein",
                 datablock = FALSE, interleaved = FALSE)
unlink(c("wood.ex.nex", "cyn.ex.nex"))
}}
\keyword{file}

\name{plot.varcomp}
\alias{plot.varcomp}
\title{Plot Variance Components}
\description{
  Plot previously estimated variance components.
}
\usage{
\method{plot}{varcomp}(x, xlab = "Levels", ylab = "Variance", type = "b", ...)
}
\arguments{
  \item{x}{ A \var{varcomp} object}
  \item{xlab}{ x axis label}
  \item{ylab}{ y axis label }
  \item{type}{ plot type ("l", "p" or "b", see \code{\link{plot}})}
  \item{\dots}{Further argument sent to the \code{\link[lattice]{xyplot}} function.}
}
\value{
  The same as \code{\link[lattice]{xyplot}}.
}
\author{Julien Dutheil \email{dutheil@evolbio.mpg.de}}
\seealso{\code{\link{varcomp}}}
\keyword{hplot}

\name{is.binary}
\alias{is.binary}
\alias{is.binary.phylo}
\alias{is.binary.multiPhylo}
\alias{is.binary.tree}
\title{Test for Binary Tree}
\description{
  This function tests whether a phylogenetic tree is binary.
}
\usage{
is.binary(phy)
\method{is.binary}{phylo}(phy)
\method{is.binary}{multiPhylo}(phy)
\method{is.binary}{tree}(phy)
}
\arguments{
  \item{phy}{an object of class \code{"phylo"} or \code{"multiPhylo"}.}
}
\details{
  The test differs whether the tree is rooted or not. An urooted tree is
  considered binary if all its nodes are of degree three (i.e., three
  edges connect to each node). A rooted tree is considered binary if all
  nodes (including the root node) have exactly two descendant nodes, so
  that they are of degree three expect the root which is of degree 2.

  \code{is.binary.tree} is deprecated and will be removed soon:
  currently it calls \code{is.binary}.
}
\value{
  a logical vector.
}
\seealso{
\code{\link{is.rooted}}, \code{\link{is.ultrametric}}, \code{\link{multi2di}}
}
\author{Emmanuel Paradis}
\examples{
is.binary(rtree(10))
is.binary(rtree(10, rooted = FALSE))
is.binary(stree(10))
x <- setNames(rmtree(10, 10), LETTERS[1:10])
is.binary(x)
}
\keyword{logic}

\name{pcoa}
\alias{pcoa}
\alias{biplot.pcoa}
\title{ Principal Coordinate Analysis }
\description{
Function \code{\link{pcoa}} computes principal coordinate decomposition (also called classical scaling) of a distance matrix D (Gower 1966). It implements two correction methods for negative eigenvalues.
}
\usage{
pcoa(D, correction="none", rn=NULL)

\method{biplot}{pcoa}(x, Y=NULL, plot.axes = c(1,2), dir.axis1=1,
       dir.axis2=1, rn=NULL, main=NULL, ...)
}

\arguments{
  \item{D}{ A distance matrix of class \code{dist} or \code{matrix}. }
  \item{correction}{ Correction methods for negative eigenvalues (details below): \code{"lingoes"} and \code{"cailliez"}. Default value: \code{"none"}.  }
  \item{rn}{ An optional vector of row names, of length n, for the n objects. }
  \item{x}{ Output object from \code{\link{pcoa}}. }
  \item{Y}{ Any rectangular data table containing explanatory variables to be projected onto the ordination plot. That table may contain, for example, the community composition data used to compute D, or any transformation of these data; see examples. }
  \item{plot.axes}{ The two PCoA axes to plot. }
  \item{dir.axis1}{ = -1 to revert axis 1 for the projection of points and variables. Default value: +1. }
  \item{dir.axis2}{ = -1 to revert axis 2 for the projection of points
    and variables. Default value: +1. }
  \item{main}{An optional title.}
  \item{...}{ Other graphical arguments passed to function. }
}

\details{
This function implements two methods for correcting for negative values in principal coordinate analysis (PCoA). Negative eigenvalues can be produced in PCoA when decomposing distance matrices produced by coefficients that are not Euclidean (Gower and Legendre 1986, Legendre and Legendre 1998).

In \code{pcoa}, when negative eigenvalues are present in the decomposition results, the distance matrix D can be modified using either the Lingoes or the Cailliez procedure to produce results without negative eigenvalues.

In the Lingoes (1971) procedure, a constant c1, equal to twice absolute value of the largest negative value of the original principal coordinate analysis, is added to each original squared distance in the distance matrix, except the diagonal values. A newe principal coordinate analysis, performed on the modified distances, has at most (n-2) positive eigenvalues, at least 2 null eigenvalues, and no negative eigenvalue.

In the Cailliez (1983) procedure, a constant c2 is added to the original distances in the distance matrix, except the diagonal values. The calculation of c2 is described in Legendre and Legendre (1998). A new principal coordinate analysis, performed on the modified distances, has at most (n-2) positive eigenvalues, at least 2 null eigenvalues, and no negative eigenvalue.

In all cases, only the eigenvectors corresponding to positive eigenvalues are shown in the output list. The eigenvectors are scaled to the square root of the corresponding eigenvalues. Gower (1966) has shown that eigenvectors scaled in that way preserve the original distance (in the D matrix) among the objects. These eigenvectors can be used to plot ordination graphs of the objects.

We recommend not to use PCoA to produce ordinations from the chord, chi-square, abundance profile, or Hellinger distances. It is easier to first transform the community composition data using the following transformations, available in the \code{decostand} function of the \code{vegan} package, and then carry out a principal component analysis (PCA) on the transformed data:

\describe{
\item{ }{Chord transformation: decostand(spiders,"normalize") }
\item{ }{Transformation to relative abundance profiles: decostand(spiders,"total") }
\item{ }{Hellinger transformation: decostand(spiders,"hellinger") }
\item{ }{Chi-square transformation: decostand(spiders,"chi.square") }
}

The ordination results will be identical and the calculations shorter. This two-step ordination method, called transformation-based PCA (tb-PCA), was described by Legendre and Gallagher (2001).

The \code{biplot.pcoa} function produces plots for any pair of principal coordinates. The original variables can be projected onto the ordination plot.
}

\value{

  \item{correction }{The values of parameter \code{correction} and variable 'correct' in the function. }
  \item{note }{A note describing the type of correction done, if any. }
  \item{values }{The eigenvalues and related information: }
  \item{Eigenvalues}{All eigenvalues (positive, null, negative). }
  \item{Relative_eig}{Relative eigenvalues. }
  \item{Corr_eig}{Corrected eigenvalues (Lingoes correction); Legendre and Legendre (1998, p. 438, eq. 9.27). }
  \item{Rel_corr_eig}{Relative eigenvalues after Lingoes or Cailliez correction. }
  \item{Broken_stick}{Expected fractions of variance under the broken stick model. }
  \item{Cumul_eig}{Cumulative relative eigenvalues. }
  \item{Cum_corr_eig}{Cumulative corrected relative eigenvalues. }
  \item{Cumul_br_stick}{Cumulative broken stick fractions. }
  \item{vectors}{The principal coordinates with positive eigenvalues. }
  \item{trace}{The trace of the distance matrix. This is also the sum of all eigenvalues, positive and negative. }
  \item{vectors.cor }{The principal coordinates with positive eigenvalues from the distance matrix corrected using the method specified by parameter \code{correction}. }
  \item{trace.cor }{The trace of the corrected distance matrix. This is also the sum of its eigenvalues. }
}

\references{
Cailliez, F. (1983) The analytical solution of the additive constant problem. \emph{Psychometrika}, \bold{48}, 305--308.

Gower, J. C. (1966) Some distance properties of latent root and vector methods used in multivariate analysis. \emph{Biometrika}, \bold{53}, 325--338.

Gower, J. C. and Legendre, P. (1986) Metric and Euclidean properties of
dissimilarity coefficients. \emph{Journal of Classification}, \bold{3}, 5--48.

Legendre, P. and Gallagher, E. D. (2001) Ecologically meaningful transformations for ordination of species data. \emph{Oecologia}, \bold{129}, 271--280.

Legendre, P. and Legendre, L. (1998) \emph{Numerical Ecology, 2nd English
  edition.} Amsterdam: Elsevier Science BV.

Lingoes, J. C. (1971) Some boundary conditions for a monotone analysis of symmetric matrices. \emph{Psychometrika}, \bold{36}, 195--203.
}

\author{ Pierre Legendre, Universite de Montreal }

\examples{
# Oribatid mite data from Borcard and Legendre (1994)

\dontrun{
if (require(vegan)) {
data(mite)  # Community composition data, 70 peat cores, 35 species

# Select rows 1:30. Species 35 is absent from these rows. Transform to log
mite.log <- log(mite[1:30,-35]+1)  # Equivalent: log1p(mite[1:30,-35])

# Principal coordinate analysis and simple ordination plot
mite.D <- vegdist(mite.log, "bray")
res <- pcoa(mite.D)
res$values
biplot(res)

# Project unstandardized and standardized species on the PCoA ordination plot
mite.log.st = apply(mite.log, 2, scale, center=TRUE, scale=TRUE)

par(mfrow=c(1,2))
biplot(res, mite.log)
biplot(res, mite.log.st)

# Reverse the ordination axes in the  plot
par(mfrow=c(1,2))
biplot(res, mite.log, dir.axis1=-1, dir.axis2=-1)
biplot(res, mite.log.st, dir.axis1=-1, dir.axis2=-1)
}
}
}

\keyword{ multivariate }

\name{summary.phylo}
\alias{summary.phylo}
\alias{Ntip}
\alias{Ntip.phylo}
\alias{Ntip.multiPhylo}
\alias{Nnode}
\alias{Nnode.phylo}
\alias{Nnode.multiPhylo}
\alias{Nedge}
\alias{Nedge.phylo}
\alias{Nedge.multiPhylo}
\title{Print Summary of a Phylogeny}
\usage{
\method{summary}{phylo}(object, \dots)

Ntip(phy)
\method{Ntip}{phylo}(phy)
\method{Ntip}{multiPhylo}(phy)

Nnode(phy, ...)
\method{Nnode}{phylo}(phy, internal.only = TRUE, ...)
\method{Nnode}{multiPhylo}(phy, internal.only = TRUE, ...)

Nedge(phy)
\method{Nedge}{phylo}(phy)
\method{Nedge}{multiPhylo}(phy)
}
\arguments{
  \item{object, phy}{an object of class \code{"phylo"} or
    \code{"multiPhylo"}.}
  \item{\dots}{further arguments passed to or from other methods.}
  \item{internal.only}{a logical indicating whether to return the number
    of internal nodes only (the default), or of internal and terminal
    (tips) nodes (if \code{FALSE}).}
}
\description{
  The first function prints a compact summary of a phylogenetic tree (an
  object of class \code{"phylo"}). The three other functions return the
  number of tips, nodes, or edges, respectively.
}
\details{
  The summary includes the numbers of tips and of nodes, summary
  statistics of the branch lengths (if they are available) with mean,
  variance, minimum, first quartile, median, third quartile, and
  maximum, listing of the first ten tip labels, and (if available) of
  the first ten node labels. It is also printed whether some of these
  optional elements (branch lengths, node labels, and root edge) are not
  found in the tree.

  \code{summary} simply prints its results on the standard output and is
  not meant for programming.
}
\value{
  A NULL value in the case of \code{summary}, a single numeric value for
  the three other functions.
}
\author{Emmanuel Paradis}
\seealso{
  \code{\link{read.tree}}, \code{\link[base]{summary}} for the generic R
  function, \code{\link{multiphylo}}, \code{\link{c.phylo}}
}
\examples{
data(bird.families)
summary(bird.families)
Ntip(bird.families)
Nnode(bird.families)
Nedge(bird.families)
}
\keyword{manip}

\name{root}
\alias{root}
\alias{root.phylo}
\alias{root.multiPhylo}
\alias{unroot}
\alias{unroot.phylo}
\alias{unroot.multiPhylo}
\alias{is.rooted}
\alias{is.rooted.phylo}
\alias{is.rooted.multiPhylo}
\title{Roots Phylogenetic Trees}
\description{
  \code{root} reroots a phylogenetic tree with respect to the specified
  outgroup or at the node specified in \code{node}.

  \code{unroot} unroots a phylogenetic tree, or returns it unchanged if
  it is already unrooted.

  \code{is.rooted} tests whether a tree is rooted.
}
\usage{
root(phy, ...)
\method{root}{phylo}(phy, outgroup, node = NULL, resolve.root = FALSE,
     interactive = FALSE, edgelabel = FALSE, ...)
\method{root}{multiPhylo}(phy, outgroup, ...)

unroot(phy)
\method{unroot}{phylo}(phy)
\method{unroot}{multiPhylo}(phy)

is.rooted(phy)
\method{is.rooted}{phylo}(phy)
\method{is.rooted}{multiPhylo}(phy)
}
\arguments{
  \item{phy}{an object of class \code{"phylo"} or \code{"multiPhylo"}.}
  \item{outgroup}{a vector of mode numeric or character specifying the
    new outgroup.}
  \item{node}{alternatively, a node number where to root the tree.}
  \item{resolve.root}{a logical specifying whether to resolve the new
    root as a bifurcating node.}
  \item{interactive}{if \code{TRUE} the user is asked to select the node
    by clicking on the tree which must be plotted.}
  \item{edgelabel}{a logical value specifying whether to treat node
    labels as edge labels and thus eventually switching them so that
    they are associated with the correct edges when using
    \code{\link{drawSupportOnEdges}} (see Czech et al. 2016).}
  \item{\dots}{arguments passed among methods (e.g., when rooting lists
    of trees).}
}
\details{
  The argument \code{outgroup} can be either character or numeric. In
  the first case, it gives the labels of the tips of the new outgroup;
  in the second case the numbers of these labels in the vector
  \code{phy$tip.label} are given.

  If \code{outgroup} is of length one (i.e., a single value), then the
  tree is rerooted using the node below this tip as the new root.

  If \code{outgroup} is of length two or more, the most recent common
  ancestor (MRCA) \emph{of the ingroup} is used as the new root. Note
  that the tree is unrooted before being rerooted, so that if
  \code{outgroup} is already the outgroup, then the returned tree is not
  the same than the original one (see examples). If \code{outgroup} is
  not monophyletic, the operation fails and an error message is issued.

  If \code{resolve.root = TRUE}, \code{root} adds a zero-length branch
  below the MRCA of the ingroup.

  A tree is considered rooted if either only two branches connect to the
  root, or if there is a \code{root.edge} element. In all other cases,
  \code{is.rooted} returns \code{FALSE}.
}
\note{
  The use of \code{resolve.root = TRUE} together with \code{node = }
  gives an error if the specified node is the current root of the
  tree. This is because there is an ambiguity when resolving a node in
  an unrooted tree with no explicit outgroup. If the node is not the
  current root, the ambiguity is solved arbitrarily by considering the
  clade on the right of \code{node} (when the tree is plotted by
  default) as the ingroup. See a detailed explanation there:

  \url{https://www.mail-archive.com/r-sig-phylo@r-project.org/msg03805.html}.
}
\value{
  an object of class \code{"phylo"} or \code{"multiPhylo"} for
  \code{root} and \code{unroot}; a logical vector for \code{is.rooted}.
}
\references{
  Czech, L., Huerta-Cepas, J. and Stamatakis, A. (2017) A critical
  review on the use of support values in tree viewers and bioinformatics
  toolkits. \emph{Molecular Biology and Evolution}, \bold{34},
  1535--1542. \url{https://doi.org/10.1093/molbev/msx055}
}
\author{Emmanuel Paradis}
\seealso{
  \code{\link{bind.tree}}, \code{\link{drop.tip}},
  \code{\link{nodelabels}}, \code{\link{identify.phylo}}
}
\examples{
data(bird.orders)
plot(root(bird.orders, 1))
plot(root(bird.orders, 1:5))

tr <- root(bird.orders, 1)
is.rooted(bird.orders) # yes
is.rooted(tr)          # no
### This is because the tree has been unrooted first before rerooting.
### You can delete the outgroup...
is.rooted(drop.tip(tr, "Struthioniformes"))
### ... or resolve the basal trichotomy in two ways:
is.rooted(multi2di(tr))
is.rooted(root(bird.orders, 1, r = TRUE))
### To keep the basal trichotomy but forcing the tree as rooted:
tr$root.edge <- 0
is.rooted(tr)

x <- setNames(rmtree(10, 10), LETTERS[1:10])
is.rooted(x)
}
\keyword{manip}

\name{yule}
\alias{yule}
\title{Fits the Yule Model to a Phylogenetic Tree}
\usage{
yule(phy, use.root.edge = FALSE)
}
\arguments{
  \item{phy}{an object of class \code{"phylo"}.}
  \item{use.root.edge}{a logical specifying whether to consider the root
    edge in the calculations.}
}
\description{
  This function fits by maximum likelihood a Yule model, i.e., a
  birth-only model to the branching times computed from a phylogenetic
  tree.
}
\details{
  The tree must be fully dichotomous.

  The maximum likelihood estimate of the speciation rate is obtained by
  the ratio of the number of speciation events on the cumulative number
  of species through time; these two quantities are obtained with the
  number of nodes in the tree, and the sum of the branch lengths,
  respectively.

  If there is a `root.edge' element in the phylogenetic tree, and
  \code{use.root.edge = TRUE}, then it is assumed that it has a
  biological meaning and is counted as a branch length, and the root is
  counted as a speciation event; otherwise the number of speciation
  events is the number of nodes - 1.

  The standard-error of lambda is computed with the second derivative of
  the log-likelihood function.
}
\value{
  An object of class "yule" which is a list with the following
  components:
  \item{lambda}{the maximum likelihood estimate of the speciation
    (birth) rate.}
  \item{se}{the standard-error of lambda.}
  \item{loglik}{the log-likelihood at its maximum.}
}
\author{Emmanuel Paradis}
\seealso{
  \code{\link{branching.times}}, \code{\link{diversi.gof}},
  \code{\link{diversi.time}}, \code{\link{ltt.plot}},
  \code{\link{birthdeath}}, \code{\link{bd.ext}}, \code{\link{yule.cov}}
}
\keyword{models}

\name{cophyloplot}
\alias{cophyloplot}
\title{Plots two phylogenetic trees face to face with links between the tips.}
\description{
  This function plots two trees face to face with the links if specified. It is possible to rotate the branches of each tree around the nodes by clicking.
}
\usage{
cophyloplot(x, y, assoc = NULL, use.edge.length = FALSE, space = 0,
       length.line = 1, gap = 2, type = "phylogram", rotate = FALSE,
       col = par("fg"), lwd = par("lwd"), lty = par("lty"),
       show.tip.label = TRUE, font = 3, \dots)
}

\arguments{
  \item{x, y}{two objects of class \code{"phylo"}.}
  \item{assoc}{a matrix with 2 columns specifying the associations
    between the tips. If NULL, no links will be drawn.}
  \item{use.edge.length}{a logical indicating whether the branch lengths
    should be used to plot the trees; default is FALSE.}
  \item{space}{a positive value that specifies the distance between the
    two trees.}
  \item{length.line}{a positive value that specifies the length of the
    horizontal line associated to each taxa. Default is 1.}
  \item{gap}{a value specifying the distance between the tips of the
    phylogeny and the lines.}
  \item{type}{a character string specifying the type of phylogeny to be
    drawn; it must be one of "phylogram" (the default) or "cladogram".}
  \item{rotate}{a logical indicating whether the nodes of the phylogeny
    can be rotated by clicking. Default is FALSE.}
  \item{col}{a character vector indicating the color to be used for the
    links; recycled as necessary.}
  \item{lwd}{id. for the width.}
  \item{lty}{id. for the line type.}
  \item{show.tip.label}{a logical indicating whether to show the tip
    labels on the phylogeny (defaults to 'TRUE', i.e. the labels are
    shown).}
  \item{font}{an integer specifying the type of font for the
    labels: 1 (plain text), 2 (bold), 3 (italic, the default), or 4
    (bold italic).}
  \item{\dots}{(unused)}
}
\details{
The aim of this function is to plot simultaneously two phylogenetic trees with associated taxa. The two trees do not necessarily have the same number of tips and more than one tip in one phylogeny can be associated with a tip in the other.

The association matrix used to draw the links has to be a matrix with two columns containing the names of the tips. One line in the matrix represents one link on the plot. The first column of the matrix has to contain tip labels of the first tree (\code{phy1}) and the second column of the matrix, tip labels of the second tree (\code{phy2}). There is no limit (low or high) for the number of lines in the matrix. A matrix with two colums and one line will give a plot with one link.

Arguments \code{gap}, \code{length.line} and \code{space} have to be changed to get a nice plot of the two phylogenies. Note that the function takes into account the length of the character strings corresponding to the names at the tips, so that the lines do not overwrite those names.

The \code{rotate} argument can be used to transform both phylogenies in order to get the more readable plot (typically by decreasing the number of crossing lines). This can be done by clicking on the nodes. The escape button or right click take back to the console.
}
\author{Damien de Vienne \email{damien.de-vienne@u-psud.fr}}
\seealso{
  \code{\link{plot.phylo}}, \code{\link{rotate}}, \code{\link{rotateConstr}}
}
\examples{
#two random trees
tree1 <- rtree(40)
tree2 <- rtree(20)

#creation of the association matrix:
association <- cbind(tree2$tip.label, tree2$tip.label)

cophyloplot(tree1, tree2, assoc = association,
            length.line = 4, space = 28, gap = 3)

#plot with rotations
\dontrun{
cophyloplot(tree1, tree2, assoc=association, length.line=4, space=28, gap=3, rotate=TRUE)
}
}
\keyword{hplot}

\name{compar.gee}
\alias{compar.gee}
\alias{print.compar.gee}
\alias{drop1.compar.gee}
\alias{predict.compar.gee}
\title{Comparative Analysis with GEEs}
\description{
  \code{compar.gee} performs the comparative analysis using generalized
  estimating equations as described by Paradis and Claude (2002).

  \code{drop1} tests single effects of a fitted model output from
  \code{compar.gee}.

  \code{predict} returns the predicted (fitted) values of the model.
}
\usage{
compar.gee(formula, data = NULL, family = "gaussian", phy, corStruct,
          scale.fix = FALSE, scale.value = 1)
\method{drop1}{compar.gee}(object, scope, quiet = FALSE, ...)
\method{predict}{compar.gee}(object, newdata = NULL, type = c("link", "response"), ...)
}
\arguments{
  \item{formula}{a formula giving the model to be fitted.}
  \item{data}{the name of the data frame where the variables in
    \code{formula} are to be found; by default, the variables are looked
    for in the global environment.}
  \item{family}{a function specifying the distribution assumed for the
    response; by default a Gaussian distribution (with link identity) is
    assumed (see \code{?family} for details on specifying the
    distribution, and on changing the link function).}
  \item{phy}{an object of class \code{"phylo"} (ignored if
    \code{corStruct} is used).}
  \item{corStruct}{a (phylogenetic) correlation structure.}
  \item{scale.fix}{logical, indicates whether the scale parameter should
    be fixed (TRUE) or estimated (FALSE, the default).}
  \item{scale.value}{if \code{scale.fix = TRUE}, gives the value for the
    scale (default: \code{scale.value = 1}).}
  \item{object}{an object of class \code{"compar.gee"} resulting from
    fitting \code{compar.gee}.}
  \item{scope}{<unused>.}
  \item{quiet}{a logical specifying whether to display a warning message
    about eventual ``marginality principle violation''.}
  \item{newdata}{a data frame with column names matching the variables
    in the formula of the fitted object (see
    \code{\link[stats]{predict}} for details).}
  \item{type}{a character string specifying the type of predicted
    values. By default, the linear (link) prediction is returned.}
  \item{\dots}{further arguments to be passed to \code{drop1}.}
}
\details{
  If a data frame is specified for the argument \code{data}, then its
  rownames are matched to the tip labels of \code{phy}. The user must be
  careful here since the function requires that both series of names
  perfectly match, so this operation may fail if there is a typing or
  syntax error. If both series of names do not match, the values in the
  data frame are taken to be in the same order than the tip labels of
  \code{phy}, and a warning message is issued.

  If \code{data = NULL}, then it is assumed that the variables are in
  the same order than the tip labels of \code{phy}.
}
\note{
  The calculation of the phylogenetic degrees of freedom is likely to be
  approximative for non-Brownian correlation structures (this will be
  refined soon).

  The calculation of the quasilikelihood information criterion (QIC)
  needs to be tested.
}
\value{
  \code{compar.gee} returns an object of class \code{"compar.gee"} with
  the following components:
  \item{call}{the function call, including the formula.}
  \item{effect.assign}{a vector of integers assigning the coefficients
    to the effects (used by \code{drop1}).}
  \item{nobs}{the number of observations.}
  \item{QIC}{the quasilikelihood information criterion as defined by Pan
    (2001).}
  \item{coefficients}{the estimated coefficients (or regression parameters).}
  \item{residuals}{the regression residuals.}
  \item{family}{a character string, the distribution assumed for the response.}
  \item{link}{a character string, the link function used for the mean function.}
  \item{scale}{the scale (or dispersion parameter).}
  \item{W}{the variance-covariance matrix of the estimated coefficients.}
  \item{dfP}{the phylogenetic degrees of freedom (see Paradis and Claude
    for details on this).}

  \code{drop1} returns an object of class \code{"\link[stats]{anova}"}.

  \code{predict} returns a vector or a data frame if \code{newdata} is used.
}
\references{
  Pan, W. (2001) Akaike's information criterion in generalized
  estimating equations. \emph{Biometrics}, \bold{57}, 120--125.

  Paradis, E. and Claude J. (2002) Analysis of comparative data using
  generalized estimating equations. \emph{Journal of theoretical
    Biology}, \bold{218}, 175--185.
}

\author{Emmanuel Paradis}

\seealso{
  \code{\link{read.tree}}, \code{\link{pic}},
  \code{\link{compar.lynch}}, \code{\link[stats]{drop1}}
}
\examples{
### The example in Phylip 3.5c (originally from Lynch 1991)
### (the same analysis than in help(pic)...)
tr <- "((((Homo:0.21,Pongo:0.21):0.28,Macaca:0.49):0.13,Ateles:0.62):0.38,Galago:1.00);"
tree.primates <- read.tree(text = tr)
X <- c(4.09434, 3.61092, 2.37024, 2.02815, -1.46968)
Y <- c(4.74493, 3.33220, 3.36730, 2.89037, 2.30259)
### Both regressions... the results are quite close to those obtained
### with pic().
compar.gee(X ~ Y, phy = tree.primates)
compar.gee(Y ~ X, phy = tree.primates)
### Now do the GEE regressions through the origin: the results are quite
### different!
compar.gee(X ~ Y - 1, phy = tree.primates)
compar.gee(Y ~ X - 1, phy = tree.primates)
}
\keyword{regression}

\name{apetools}
\alias{apetools}
\alias{Xplorefiles}
\alias{Xplor}
\alias{editFileExtensions}
\alias{bydir}
\title{Tools to Explore Files}
\description{
  These functions help to find files on the local disk.
}
\usage{
Xplorefiles(from = "HOME", recursive = TRUE, ignore.case = TRUE)
editFileExtensions()
bydir(x)
Xplor(from = "HOME")
}
\arguments{
  \item{from}{the directory where to start the file search; by default,
    the `HOME' directory. Use \code{from = getwd()} to start from the
    current working directory.}
  \item{recursive}{whether to search the subdirectories; \code{TRUE} by
    default.}
  \item{ignore.case}{whether to ignore the case of the file extensions;
    \code{TRUE} by default.}
  \item{x}{a list returned by \code{Xplorefiles}.}
}
\details{
  \code{Xplorefiles} looks for all files with a specified extension in
  their names. The default is to look for the following file types:
  CLUSTAL (.aln), FASTA (.fas, .fasta), FASTQ (.fq, .fastq), NEWICK
  (.nwk, .newick, .tre, .tree), NEXUS (.nex, .nexus), and PHYLIP
  (.phy). This list can be modified with \code{editFileExtensions}.

  \code{bydir} sorts the list of files by directories.

  \code{Xplor} combines the other operations and opens the results in
  a Web browser with clickable links to the directories and files.
}
\value{
  \code{Xplorefiles} returns a list. \code{bydir} prints the file
  listings on the console.
}
\author{Emmanuel Paradis}
\examples{
\dontrun{
x <- Xplorefiles()
x # all data files on your disk
bydir(x) # sorted by directories
bydir(x["fasta"]) # only the FASTA files
Xplorefiles(getwd(), recursive = FALSE) # look only in current dir
Xplor()
}}
\keyword{manip}

\name{corphylo}
\alias{corphylo}
\alias{print.corphylo}
\title{Correlations among Multiple Traits with Phylogenetic Signal}
\description{
  This function calculates Pearson correlation coefficients for multiple continuous traits that may have phylogenetic signal, allowing users to specify measurement error as the standard error of trait values at the tips of the phylogenetic tree.  Phylogenetic signal for each trait is estimated from the data assuming that trait evolution is given by a Ornstein-Uhlenbeck process.  Thus, the function allows the estimation of phylogenetic signal in multiple traits while incorporating correlations among traits. It is also possible to include independent variables (covariates) for each trait to remove possible confounding effects.  corphylo() returns the correlation matrix for trait values, estimates of phylogenetic signal for each trait, and regression coefficients for independent variables affecting each trait.
}
\usage{
corphylo(X, U = list(), SeM = NULL, phy = NULL, REML = TRUE,
method = c("Nelder-Mead", "SANN"), constrain.d = FALSE, reltol = 10^-6,
maxit.NM = 1000, maxit.SA = 1000, temp.SA = 1, tmax.SA = 1, verbose = FALSE)

\method{print}{corphylo}(x, digits = max(3, getOption("digits") - 3), ...)
}
\arguments{
  \item{X}{a n x p matrix with p columns containing the values for the n taxa. Rows of X should have rownames matching the taxon names in phy.}
  \item{U}{a list of p matrices corresponding to the p columns of X, with each matrix containing independent variables for the corresponding column of X. The rownames of each matrix within U must be the same as X, or alternatively, the order of values in rows must match those in X. If U is omitted, only the mean (aka intercept) for each column of X is estimated. If U[[i]] is NULL, only an intercept is estimated for X[, i]. If all values of U[[i]][j] are the same, this variable is automatically dropped from the analysis (i.e., there is no offset in the regression component of the model).}
  \item{SeM}{a n x p matrix with p columns containing standard errors of the trait values in X. The rownames of SeM must be the same as X, or alternatively, the order of values in rows must match those in X. If SeM is omitted, the trait values are assumed to be known without error. If only some traits have mesurement errors, the remaining traits can be given zero-valued standard errors.}
  \item{phy}{a phylo object giving the phylogenetic tree.  The rownames of phy must be the same as X, or alternatively, the order of values in rows must match those in X.}
  \item{REML}{whether REML or ML is used for model fitting.}
  \item{method}{in optim(), either Nelder-Mead simplex minimization or SANN (simulated annealing) minimization is used. If SANN is used, it is followed by Nelder-Mead minimization.}
  \item{constrain.d}{if constrain.d is TRUE, the estimates of d are constrained to be between zero and 1. This can make estimation more stable and can be tried if convergence is problematic. This does not necessarily lead to loss of generality of the results, because before using corphylo, branch lengths of phy can be transformed so that the "starter" tree has strong phylogenetic signal.}
  \item{reltol}{a control parameter dictating the relative tolerance for convergence in the optimization; see optim().}
  \item{maxit.NM}{a control parameter dictating the maximum number of iterations in the optimization with Nelder-Mead minimization; see optim().}
  \item{maxit.SA}{a control parameter dictating the maximum number of iterations in the optimization with SANN minimization; see optim().}
  \item{temp.SA}{a control parameter dictating the starting temperature in the optimization with SANN minimization; see optim().}
  \item{tmax.SA}{a control parameter dictating the number of function evaluations at each temperature in the optimization with SANN minimization; see optim().}
  \item{verbose}{if TRUE, the model logLik and running estimates of the
    correlation coefficients and values of d are printed each iteration
    during optimization.}
  \item{x}{an objects of class corphylo.}
  \item{digits}{the number of digits to be printed.}
  \item{\dots}{arguments passed to and from other methods.}
}
\details{
     For the case of two variables, the function estimates parameters for the model of the form, for example,

  \deqn{X[1] =  B[1,0] + B[1,1] * u[1,1] + \epsilon[1]}
  \deqn{X[2] =  B[2,0] + B[2,1] * u[2,1] + \epsilon[2]}
  \deqn{\epsilon ~ Gaussian(0, V) }

where \eqn{B[1,0]}, \eqn{B[1,1]}, \eqn{B[2,0]}, and \eqn{B[2,1]} are regression coefficients, and \eqn{V} is a variance-covariance matrix containing the correlation coefficient r, parameters of the OU process \eqn{d1} and \eqn{d2}, and diagonal matrices \eqn{M1} and \eqn{M2} of measurement standard errors for \eqn{X[1]} and \eqn{X[2]}. The matrix \eqn{V} is \eqn{2n x 2n}, with \eqn{n x n} blocks given by

\deqn{V[1,1] = C[1,1](d1) + M1}
\deqn{V[1,2] = C[1,2](d1,d2)}
\deqn{V[2,1] = C[2,1](d1,d2)}
\deqn{V[2,2] = C[2,2](d2) + M2}

where \eqn{C[i,j](d1,d2)} are derived from phy under the assumption of joint OU evolutionary processes for each trait (see Zheng et al. 2009).  This formulation extends in the obvious way to more than two traits.

}
\value{
  An object of class "corphylo".

  \item{cor.matrix}{the p x p matrix of correlation coefficients.}
  \item{d}{values of d from the OU process for each trait.}
  \item{B}{estimates of the regression coefficients, including intercepts. Coefficients are named according to the list U. For example, B1.2 is the coefficient corresponding to U[[1]][, 2], and if column 2 in U[[1]] is named "colname2", then the coefficient will be B1.colname2. Intercepts have the form B1.0.}
  \item{B.se}{standard errors of the regression coefficients.}
  \item{B.cov}{covariance matrix for regression coefficients.}
  \item{B.zscore}{Z scores for the regression coefficients.}
  \item{B.pvalue}{tests for the regression coefficients being different from zero.}
  \item{logLik}{he log likelihood for either the restricted likelihood (REML = TRUE) or the overall likelihood (REML = FALSE).}
  \item{AIC}{AIC for either the restricted likelihood (REML = TRUE) or the overall likelihood (REML = FALSE).}
  \item{BIC}{BIC for either the restricted likelihood (REML = TRUE) or the overall likelihood (REML = FALSE).}
  \item{REML}{whether REML is used rather than ML (TRUE or FALSE).}
  \item{constrain.d}{whether or not values of d were constrained to be between 0 and 1 (TRUE or FALSE).}
  \item{XX}{values of X in vectorized form, with each trait X[, i] standardized to have mean zero and standard deviation one.}
  \item{UU}{design matrix with values in UU corresponding to XX; each variable U[[i]][, j] is standardized to have mean zero and standard deviation one.}
  \item{MM}{vector of measurement standard errors corresponding to XX, with the standard errors suitably standardized.}
  \item{Vphy}{the phylogenetic covariance matrix computed from phy and standardized to have determinant equal to one.}
  \item{R}{covariance matrix of trait values relative to the standardized values of XX.}
  \item{V}{overall estimated covariance matrix of residuals for XX including trait correlations, phylogenetic signal, and measurement error variances. This matrix can be used to simulate data for parametric bootstrapping. See examples.}
  \item{C}{matrix V excluding measurement error variances.}
  \item{convcode}{he convergence code provided by optim().}
  \item{niter}{number of iterations performed by optim().}
}
\author{Anthony R. Ives}
\references{
  Zheng, L., A. R. Ives, T. Garland, B. R. Larget, Y. Yu, and K. F. Cao. 2009. New multivariate tests for phylogenetic signal and trait correlations applied to ecophysiological phenotypes of nine \emph{Manglietia} species. \emph{Functional Ecology} \bold{23}:1059--1069.

}
\examples{
## Simple example using data without correlations or phylogenetic
## signal. This illustrates the structure of the input data.

phy <- rcoal(10, tip.label = 1:10)
X <- matrix(rnorm(20), nrow = 10, ncol = 2)
rownames(X) <- phy$tip.label
U <- list(NULL, matrix(rnorm(10, mean = 10, sd = 4), nrow = 10, ncol = 1))
rownames(U[[2]]) <- phy$tip.label
SeM <- matrix(c(0.2, 0.4), nrow = 10, ncol = 2)
rownames(SeM) <- phy$tip.label

corphylo(X = X, SeM = SeM, U = U, phy = phy, method = "Nelder-Mead")

\dontrun{
## Simulation example for the correlation between two variables. The
## example compares the estimates of the correlation coefficients from
## corphylo when measurement error is incorporated into the analyses with
## three other cases: (i) when measurement error is excluded, (ii) when
## phylogenetic signal is ignored (assuming a "star" phylogeny), and (iii)
## neither measurement error nor phylogenetic signal are included.

## In the simulations, variable 2 is associated with a single
## independent variable. This requires setting up a list U that has 2
## elements: element U[[1]] is NULL and element U[[2]] is a n x 1 vector
## containing simulated values of the independent variable.

# Set up parameter values for simulating data
n <- 50
phy <- rcoal(n, tip.label = 1:n)

R <- matrix(c(1, 0.7, 0.7, 1), nrow = 2, ncol = 2)
d <- c(0.3, .95)
B2 <- 1

Se <- c(0.2, 1)
SeM <- matrix(Se, nrow = n, ncol = 2, byrow = T)
rownames(SeM) <- phy$tip.label

# Set up needed matrices for the simulations
p <- length(d)

star <- stree(n)
star$edge.length <- array(1, dim = c(n, 1))
star$tip.label <- phy$tip.label

Vphy <- vcv(phy)
Vphy <- Vphy/max(Vphy)
Vphy <- Vphy/exp(determinant(Vphy)$modulus[1]/n)

tau <- matrix(1, nrow = n, ncol = 1) %*% diag(Vphy) - Vphy
C <- matrix(0, nrow = p * n, ncol = p * n)
for (i in 1:p) for (j in 1:p) {
	Cd <- (d[i]^tau * (d[j]^t(tau)) * (1 - (d[i] * d[j])^Vphy))/(1 - d[i] * d[j])
	C[(n * (i - 1) + 1):(i * n), (n * (j - 1) + 1):(j * n)] <- R[i, j] * Cd
}
MM <- matrix(SeM^2, ncol = 1)
V <- C + diag(as.numeric(MM))

## Perform a Cholesky decomposition of Vphy. This is used to generate
## phylogenetic signal: a vector of independent normal random variables,
## when multiplied by the transpose of the Cholesky deposition of Vphy will
## have covariance matrix equal to Vphy.
iD <- t(chol(V))

# Perform Nrep simulations and collect the results
Nrep <- 100
cor.list <- matrix(0, nrow = Nrep, ncol = 1)
cor.noM.list <- matrix(0, nrow = Nrep, ncol = 1)
cor.noP.list <- matrix(0, nrow = Nrep, ncol = 1)
cor.noMP.list <- matrix(0, nrow = Nrep, ncol = 1)
d.list <- matrix(0, nrow = Nrep, ncol = 2)
d.noM.list <- matrix(0, nrow = Nrep, ncol = 2)
B.list <- matrix(0, nrow = Nrep, ncol = 3)
B.noM.list <- matrix(0, nrow = Nrep, ncol = 3)
B.noP.list <- matrix(0, nrow = Nrep, ncol = 3)
for (rep in 1:Nrep) {
	XX <- iD %*% rnorm(2 * n)
	X <- matrix(XX, nrow = n, ncol = 2)
	rownames(X) <- phy$tip.label

	U <- list(NULL, matrix(rnorm(n, mean = 2, sd = 10), nrow = n, ncol = 1))
	rownames(U[[2]]) <- phy$tip.label
	colnames(U[[2]]) <- "V1"
	X[,2] <- X[,2] + B2[1] * U[[2]][,1] - B2[1] * mean(U[[2]][,1])

	z <- corphylo(X = X, SeM = SeM, U = U, phy = phy, method = "Nelder-Mead")
	z.noM <- corphylo(X = X, U = U, phy = phy, method = "Nelder-Mead")
	z.noP <- corphylo(X = X, SeM = SeM, U = U, phy = star, method = "Nelder-Mead")

	cor.list[rep] <- z$cor.matrix[1, 2]
	cor.noM.list[rep] <- z.noM$cor.matrix[1, 2]
	cor.noP.list[rep] <- z.noP$cor.matrix[1, 2]
	cor.noMP.list[rep] <- cor(cbind(lm(X[,1] ~ 1)$residuals, lm(X[,2] ~ U[[2]])$residuals))[1,2]

	d.list[rep, ] <- z$d
	d.noM.list[rep, ] <- z.noM$d

	B.list[rep, ] <- z$B
	B.noM.list[rep, ] <- z.noM$B
	B.noP.list[rep, ] <- z.noP$B

	show(c(rep, z$convcode, z$cor.matrix[1, 2], z$d))
}
correlation <- rbind(R[1, 2], mean(cor.list), mean(cor.noM.list),
                     mean(cor.noP.list), mean(cor.noMP.list))
rownames(correlation) <- c("True", "With SeM and Phy", "Without SeM",
                           "Without Phy", "Without Phy or SeM")
correlation

signal.d <- rbind(d, colMeans(d.list), colMeans(d.noM.list))
rownames(signal.d) <- c("True", "With SeM and Phy", "Without SeM")
signal.d

est.B <- rbind(c(0, 0, B2), colMeans(B.list), colMeans(B.noM.list),
               colMeans(B.noP.list))
rownames(est.B) <- c("True", "With SeM and Phy", "Without SeM", "Without Phy")
colnames(est.B) <- rownames(z$B)
est.B

# Example simulation output
# correlation
                        # [,1]
# True               0.7000000
# With SeM and Phy   0.7055958
# Without SeM        0.3125253
# Without Phy        0.4054043
# Without Phy or SeM 0.3476589

# signal.d
                     # [,1]      [,2]
# True             0.300000 0.9500000
# With SeM and Phy 0.301513 0.9276663
# Without SeM      0.241319 0.4872675

# est.B
                        # B1.0      B2.0     B2.V1
# True              0.00000000 0.0000000 1.0000000
# With SeM and Phy -0.01285834 0.2807215 0.9963163
# Without SeM       0.01406953 0.3059110 0.9977796
# Without Phy       0.02139281 0.3165731 0.9942140
}}
\keyword{regression}

\name{chiroptera}
\alias{chiroptera}
\title{Bat Phylogeny}
\description{
  This phylogeny of bats (Mammalia: Chiroptera) is a supertree (i.e. a
  composite phylogeny constructed from several sources; see source for
  details).
}
\usage{
data(chiroptera)
}
\format{
  The data are stored in RData (binary) format.
}
\source{
  Jones, K. E., Purvis, A., MacLarnon, A., Bininda-Emonds, O. R. P. and
  Simmons, N. B. (2002) A phylogenetic supertree of the bats (Mammalia:
  Chiroptera). \emph{Biological Reviews of the Cambridge Philosophical
    Society}, \bold{77}, 223--259.
}
\seealso{
  \code{\link{read.nexus}}, \code{\link{zoom}}
}
\examples{
data(chiroptera)
str(chiroptera)
op <- par()
par(cex = 0.3)
plot(chiroptera, type = "c")
par(cex = op$cex)
}
\keyword{datasets}

\name{identify.phylo}
\alias{identify.phylo}
\title{Graphical Identification of Nodes and Tips}
\usage{
\method{identify}{phylo}(x, nodes = TRUE, tips = FALSE,
                  labels = FALSE, quiet = FALSE, ...)
}
\arguments{
  \item{x}{an object of class \code{"phylo"}.}
  \item{nodes}{a logical specifying whether to identify the node.}
  \item{tips}{a logical specifying whether to return the tip
    information.}
  \item{labels}{a logical specifying whether to return the labels; by
    default only the numbers are returned.}
  \item{quiet}{a logical controlling whether to print a message inviting
    the user to click on the tree.}
  \item{\dots}{further arguments to be passed to or from other methods.}
}
\description{
  This function allows to identify a clade on a plotted tree by clicking
  on the plot with the mouse. The tree, specified in the argument
  \code{x}, must be plotted beforehand.
}
\details{
  By default, the clade is identified by its number as found in the
  `edge' matrix of the tree. If \code{tips = TRUE}, the tips descending
  from the identified node are returned, possibly together with the
  node. If \code{labels = TRUE}, the labels are returned (if the tree
  has no node labels, then the node numbered is returned).

  The node is identified by the shortest distance where the click
  occurs. If the click occurs close to a tip, the function returns its
  information.
}
\note{
  This function does not add anything on the plot, but it can be wrapped
  with, e.g., \code{\link{nodelabels}} (see example), or its results can
  be sent to, e.g., \code{\link{drop.tip}}.
}
\value{
  A list with one or two vectors named \code{"tips"} and/or
  \code{"nodes"} with the identification of the tips and/or of the
  nodes.
}
\author{Emmanuel Paradis}
\seealso{
  \code{\link{plot.phylo}}, \code{\link{nodelabels}},
  \code{\link[graphics]{identify}} for the generic function
}
\examples{
\dontrun{
tr <- rtree(20)
f <- function(col) {
    o <- identify(tr)
    nodelabels(node=o$nodes, pch = 19, col = col)
}
plot(tr)
f("red") # click close to a node
f("green")
}
}
\keyword{aplot}

\name{mixedFontLabel}
\alias{mixedFontLabel}
\title{Mixed Font Labels for Plotting}
\description{
  This function helps to format labels with bits of text in different
  font shapes (italics, bold, or bolditalics) and different
  separators. The output is intended to be used for plotting.
}
\usage{
mixedFontLabel(..., sep = " ", italic = NULL, bold = NULL,
               parenthesis = NULL,
               always.upright = c("sp.", "spp.", "ssp."))
}
\arguments{
  \item{\dots}{vectors of mode character to be formatted. They may be
    of different lengths in which case the shortest ones are
    recycled.}
  \item{sep}{a vector of mode character giving the separators to be
    printed between the elements in \code{\dots}.}
  \item{italic}{a vector of integers specifying the elements in
    \code{\dots} to be printed in italics.}
  \item{bold}{id. in boldface.}
  \item{parenthesis}{id. within parentheses.}
  \item{always.upright}{of vector of mode character giving the strings
    to not print in italics. Use \code{always.upright = ""} to cancel
    this option.}
}
\details{
  The idea is to have different bits of text in different vectors that
  are put together to make a vector of \R expressions. This vector is
  interpreted by graphical functions to format the text. A simple use
  may be \code{mixedFontLabel(genus, species, italic = 1:2)}, but it is
  more interesting when mixing fonts (see examples).

  To have an element in bolditalics, its number must given in both
  \code{italic} and \code{bold}.

  The vector returned by this function may be assigned as the
  \code{tip.label} element of a tree of class \code{"phylo"}, or even as
  its \code{node.label} element.
}
\value{
  A vector of mode expression.
}
\author{Emmanuel Paradis}
\seealso{
  \code{\link{makeLabel}}, \code{\link{makeNodeLabel}},
  \code{\link{label2table}}, \code{\link{updateLabel}},
  \code{\link{checkLabel}}
}
\examples{
tr <- read.tree(text = "((a,(b,c)),d);")
genus <- c("Gorilla", "Pan", "Homo", "Pongo")
species <- c("gorilla", "spp.", "sapiens", "pygmaeus")
geo <- c("Africa", "Africa", "World", "Asia")
tr$tip.label <- mixedFontLabel(genus, species, geo, italic = 1:2,
  parenthesis = 3)
layout(matrix(c(1, 2), 2))
plot(tr)
tr$tip.label <- mixedFontLabel(genus, species, geo, sep = c(" ", " | "),
  italic = 1:2, bold = 3)
plot(tr)
layout(1)
}
\keyword{manip}

\name{ltt.plot}
\alias{ltt.plot}
\alias{ltt.lines}
\alias{mltt.plot}
\alias{ltt.coplot}
\alias{ltt.plot.coords}
\title{Lineages Through Time Plot}
\description{
  These functions provide tools for plotting the numbers of lineages
  through time from phylogenetic trees.
}
\usage{
ltt.plot(phy, xlab = "Time", ylab = "N",
         backward = TRUE, tol = 1e-6, ...)
ltt.lines(phy, backward = TRUE, tol = 1e-6, ...)
mltt.plot(phy, ..., dcol = TRUE, dlty = FALSE, legend = TRUE,
          xlab = "Time", ylab = "N", log = "", backward = TRUE,
          tol = 1e-6)
ltt.coplot(phy, backward = TRUE, ...)
ltt.plot.coords(phy, backward = TRUE, tol = 1e-6)
}
\arguments{
  \item{phy}{an object of class \code{"phylo"}; this could be an object
    of class \code{"multiPhylo"} in the case of \code{mltt.plot}.}
  \item{xlab}{a character string (or a variable of mode character)
    giving the label for the \eqn{x}-axis (default is "Time").}
  \item{ylab}{idem for the \eqn{y}-axis (default is "N").}
  \item{backward}{a logical value: should the time axis be traced from
    the present (the default), or from the root of the tree?}
  \item{tol}{a numeric value (see details).}
  \item{\dots}{in the cases of \code{ltt.plot()}, \code{ltt.lines()},
    or \code{ltt.coplot()} these are further (graphical) arguments to be
    passed to \code{plot()}, \code{lines()}, or \code{plot.phylo()},
    respectively (see details on how to transform the axes); in
    the case of \code{mltt.plot()} these are additional trees to be plotted
    (see details).}
  \item{dcol}{a logical specifying whether the different curves should
    be differentiated with colors (default is \code{TRUE}).}
  \item{dlty}{a logical specifying whether the different curves should
    be differentiated with patterns of dots and dashes (default is
    \code{FALSE}).}
  \item{legend}{a logical specifying whether a legend should be
    plotted.}
  \item{log}{a character string specifying which axis(es) to be
    log-transformed; must be one of the followings: \code{""},
    \code{"x"}, \code{"y"}, or \code{"xy"}.}
}
\details{
  \code{ltt.plot} does a simple lineages through time (LTT)
  plot. Additional arguments (\code{\dots}) may be used to change, for
  instance, the limits on the axes (with \code{xlim} and/or
  \code{ylim}) or other graphical settings (\code{col} for the color,
  \code{lwd} for the line thickness, \code{lty} for the line type may be
  useful; see \code{\link[graphics]{par}} for an exhaustive listing of
  graphical parameters). The \eqn{y}-axis can be log-transformed by
  adding the following option: \code{log = "y"}.

  The option \code{tol} is used as follows: first the most distant tip
  from the root is found, then all tips whose distance to the root is
  not different from the previous one more than \code{tol} are
  considered to be contemporaneous with it.

  If the tree is not ultrametric, the plot is done assuming the tips,
  except the most distant from the root, represent extinction events. If
  a root edge is present, it is taken into account.

  \code{ltt.lines} adds a LTT curve to an existing plot. Additional
  arguments (\code{\dots}) may be used to change the settings of the added
  line.

  \code{mltt.plot} does a multiple LTT plot taking as arguments one or
  several trees. These trees may be given as objects of class
  \code{"phylo"} (single trees) and/or \code{"multiPhylo"} (multiple
  trees). Any number of objects may be given. This function is mainly
  for exploratory analyses with the advantages that the axes are set
  properly to view all lines, and the legend is plotted by default. The
  plot will certainly make sense if all trees have their
  most-distant-from-the-root tips contemporaneous (i.e., trees with only
  extinct lineages will not be represented properly). For more flexible
  settings of line drawings, it may be better to combine
  \code{ltt.plot()} with successive calls of \code{ltt.lines()} (see
  examples).

  \code{ltt.coplot} is meant to show how to set a tree and a LTT plots
  on the same scales. All extra arguments modify only the appearance of
  the tree. The code can be easily edited and tailored.
}
\value{
  \code{ltt.plot.coords} returns a two-column matrix with the time
  points and the number of lineages, respectively. The \eqn{i}th value
  of the second column is the number of lineages for the interval
  defined by the \eqn{(i - 1)}th and the \eqn{i}th values of the first
  column. These are then plotted with the option \code{type = "S"} by
  the other functions.
}
\references{
  Harvey, P. H., May, R. M. and Nee, S. (1994) Phylogenies without
  fossils. \emph{Evolution}, \bold{48}, 523--529.

  Nee, S., Holmes, E. C., Rambaut, A. and Harvey, P. H. (1995) Inferring
  population history from molecular phylogenies. \emph{Philosophical
    Transactions of the Royal Society of London. Series B. Biological
    Sciences}, \bold{349}, 25--31.
}
\author{Emmanuel Paradis}
\seealso{
  \code{\link{kronoviz}}, \code{\link{skyline}}, \code{\link{LTT}},
  \code{\link{branching.times}}, \code{\link{birthdeath}},
  \code{\link{bd.ext}}, \code{\link{yule.cov}}, \code{\link{bd.time}};
  \code{\link[graphics]{plot}} for the basic plotting function in R
}
\examples{
data(bird.families)
opar <- par(mfrow = c(2, 1))
ltt.plot(bird.families)
title("Lineages Through Time Plot of the Bird Families")
ltt.plot(bird.families, log = "y")
title(main = "Lineages Through Time Plot of the Bird Families",
      sub = "(with logarithmic transformation of the y-axis)")
par(opar)

### to plot the tree and the LTT plot together
data(bird.orders)
layout(matrix(1:4, 2, 2))
plot(bird.families, show.tip.label = FALSE)
ltt.plot(bird.families, main = "Bird families")
plot(bird.orders, show.tip.label = FALSE)
ltt.plot(bird.orders, main = "Bird orders")
layout(1)

### better with ltt.coplot():
ltt.coplot(bird.families, show.tip.label = FALSE, x.lim = 27.5)
data(chiroptera)
chiroptera <- compute.brlen(chiroptera)
ltt.coplot(chiroptera, show.tip.label = FALSE, type = "c")

### with extinct lineages and a root edge:
omar <- par("mar")
set.seed(31)
tr <- rlineage(0.2, 0.15)
tr$root.edge <- 5
ltt.coplot(tr, show.tip.label = FALSE, x.lim = 55)
## compare with:
## ltt.coplot(drop.fossil(tr), show.tip.label = FALSE)
layout(1)
par(mar = omar)

mltt.plot(bird.families, bird.orders)
### Generates 10 random trees with 23 tips:
TR <- replicate(10, rcoal(23), FALSE)
### Give names to each tree:
names(TR) <- paste("random tree", 1:10)
### And specify the class of the list so that mltt.plot()
### does not trash it!
class(TR) <- "multiPhylo"
mltt.plot(TR, bird.orders)
### And now for something (not so) completely different:
ltt.plot(bird.orders, lwd = 2)
for (i in 1:10) ltt.lines(TR[[i]], lty = 2)
legend(-20, 10, lwd = c(2, 1), lty = c(1, 2), bty = "n",
       legend = c("Bird orders", "Random (coalescent) trees"))
}
\keyword{hplot}
\keyword{aplot}

\name{getAnnotationsGenBank}
\alias{getAnnotationsGenBank}
\title{Read Annotations from GenBank}
\description{
  This function connects to the GenBank database and reads sequence annotations
  using accession number(s) given as argument.
}
\usage{
getAnnotationsGenBank(access.nb, quiet = TRUE)
}
\arguments{
  \item{access.nb}{a vector of mode character giving the accession
    numbers.}
  \item{quiet}{a logical value indicating whether to show the progress
    of the downloads.}
}
\details{
  The sequence annotations (a.k.a. feature list) are returned in a data
  frame with five or six columns: start, end, type, product, others, and
  gene (the last being optional). This is the same information that can
  be downloaded from NCBI's Web interface by clicking on `Send to:',
  `File', and then selecting `Feature Table' under `Format'.

  A warning is given if some features are incomplete (this information
  is then dropped from the returned object).

  A warning is given if some accession numbers are not found on GenBank.
}
\value{
  On of the followings: (i) a data frame if \code{access.nb} contains a
  single accession number; (ii) a list of data frames if
  \code{access.nb} contains several accession numbers, the names are set
  with \code{access.nb} (if some accession numbers are not found on
  GenBank, the corresponding entries are set to \code{NULL}); (iii)
  \code{NULL} if all accession numbers are not found on GenBank.
}
\seealso{\code{\link{read.GenBank}}, \code{\link{read.gff}},
  \code{\link{DNAbin}}
}
\author{Emmanuel Paradis}
\references{\url{https://www.ncbi.nlm.nih.gov/Sequin/table.html}}
\examples{
## The 8 sequences of tanagers (Ramphocelus):
ref <- c("U15717", "U15718", "U15719", "U15720",
         "U15721", "U15722", "U15723", "U15724")
## Copy/paste or type the following commands if you
## want to try them.
\dontrun{
annot.rampho <- getAnnotationsGenBank(ref)
annot.rampho
## check all annotations are the same:
unique(do.call(rbind, annot.rampho)[, -5])
}
}
\keyword{IO}

\name{bird.families}
\alias{bird.families}
\title{Phylogeny of the Families of Birds From Sibley and Ahlquist}
\description{
  This data set describes the phylogenetic relationships of the families
  of birds as reported by Sibley and Ahlquist (1990). Sibley and
  Ahlquist inferred this phylogeny from an extensive number of DNA/DNA
  hybridization experiments. The ``tapestry'' reported by these two
  authors (more than 1000 species out of the ca. 9000 extant bird
  species) generated a lot of debates.

  The present tree is based on the relationships among families. A few
  families were not included in the figures in Sibley and Ahlquist, and
  thus are not included here as well. The branch lengths were calculated
  from the values of \eqn{\Delta T_{50}H}{Delta T50H} as found in Sibley
  and Ahlquist (1990, figs. 354, 355, 356, and 369).
}
\usage{
data(bird.families)
}
\format{
  The data are stored as an object of class \code{"phylo"} which
  structure is described in the help page of the function
  \code{\link{read.tree}}.
}
\source{
  Sibley, C. G. and Ahlquist, J. E. (1990) Phylogeny and classification
  of birds: a study in molecular evolution. New Haven: Yale University Press.
}
\seealso{
  \code{\link{read.tree}}, \code{\link{bird.orders}}
}
\examples{
data(bird.families)
op <- par()
par(cex = 0.3)
plot(bird.families)
par(op)
}
\keyword{datasets}

\name{trex}
\alias{trex}
\title{Tree Explorer With Multiple Devices}
\description{
  This function requires a plotted tree: the user is invited to click
  close to a node and the corresponding subtree (or clade) is plotted on
  a new window.
}
\usage{
trex(phy, title = TRUE, subbg = "lightyellow3",
     return.tree = FALSE, ...)
}
\arguments{
  \item{phy}{an object of class \code{"phylo"}.}
  \item{title}{a logical or a character string (see details).}
  \item{subbg}{a character string giving the background colour for the
    subtree.}
  \item{return.tree}{a logical: if \code{TRUE}, the subtree is returned
    after being plotted and the operation is stopped.}
  \item{\dots}{further arguments to pass to \code{plot.phylo}.}
}
\details{
  This function works with a tree (freshly) plotted on an interactive
  graphical device (i.e., not a file). After calling \code{trex}, the
  user clicks close to a node of the tree, then the clade from this node
  is plotted on a \emph{new} window. The user can click as many times on
  the main tree: the clades are plotted successively on the \emph{same}
  new window. The process is stopped by a right-click. If the user clicks
  too close to the tips, a message ``Try again!'' is printed.

  Each time \code{trex} is called, the subtree is plotted on a new
  window without closing or deleting those possibly already
  plotted. They may be distinguished with the options \code{title}
  and/or \code{subbg}.

  In all cases, the device where \code{phy} is plotted is the active
  window after the operation. It should \emph{not} be closed during the
  whole process.

  If \code{title = TRUE}, a default title is printed on the new window
  using the node label, or the node number if there are no node labels
  in the tree. If \code{title = FALSE}, no title is printed. If
  \code{title} is a character string, it is used for the title.
}
\value{
  an object of class \code{"phylo"} if \code{return.tree = TRUE}
}
\author{Emmanuel Paradis}
\seealso{
  \code{\link{plot.phylo}}, \code{\link{identify.phylo}}
}
\examples{
\dontrun{
tr <- rcoal(1000)
plot(tr, show.tip.label = FALSE)
trex(tr) # left-click as many times as you want, then right-click
tr <- makeNodeLabel(tr)
trex(tr, subbg = "lightgreen") # id.

## generate a random colour with control on the darkness:
rRGB <- function(a, b)
    rgb(runif(1, a, b), runif(1, a, b), runif(1, a, b))

### with a random pale background:
trex(tr, subbg = rRGB(0.8, 1))
## the above can be called many times...
graphics.off() # close all graphical devices
}}
\keyword{hplot}

\name{mst}
\alias{mst}
\alias{plot.mst}
\title{Minimum Spanning Tree}
\usage{
mst(X)
\method{plot}{mst}(x, graph = "circle", x1 = NULL, x2 = NULL, \dots)
}
\arguments{
  \item{X}{either a matrix that can be interpreted as a distance matrix,
    or an object of class \code{"dist"}.}
  \item{x}{an object of class \code{"mst"} (e.g. returned by \code{mst()}).}
  \item{graph}{a character string indicating the type of graph to plot
    the minimum spanning tree; two choices are possible: \code{"circle"} where
    the observations are plotted regularly spaced on a circle, and
    \code{"nsca"} where the two first axes of a non-symmetric correspondence
    analysis are used to plot the observations (see Details below). If
    both arguments \code{x1} and \code{x2} are given, the argument
    \code{graph} is ignored.}
  \item{x1}{a numeric vector giving the coordinates of the observations
    on the \emph{x}-axis. Both \code{x1} and \code{x2} must be specified
    to be used.}
  \item{x2}{a numeric vector giving the coordinates of the observations
    on the \emph{y}-axis. Both \code{x1} and \code{x2} must be specified
    to be used.}
  \item{\dots}{further arguments to be passed to \code{plot()}.}
}
\description{
  The function \code{mst} finds the minimum spanning tree between a set of
  observations using a matrix of pairwise distances.

  The \code{plot} method plots the minimum spanning tree showing the
  links where the observations are identified by their numbers.
}
\details{
  These functions provide two ways to plot the minimum spanning tree which
  try to space as much as possible the observations in order to show as
  clearly as possible the links. The option \code{graph = "circle"}
  simply plots regularly the observations on a circle, whereas
  \code{graph = "nsca"} uses a non-symmetric correspondence analysis
  where each observation is represented at the centroid of its neighbours.

  Alternatively, the user may use any system of coordinates for the
  obsevations, for instance a principal components analysis (PCA) if the
  distances were computed from an original matrix of continous variables.
}
\value{
  an object of class \code{"mst"} which is a square numeric matrix of size
  equal to the number of observations with either \code{1} if a link
  between the corresponding observations was found, or \code{0}
  otherwise. The names of the rows  and columns of the distance matrix,
  if available, are given as rownames and colnames to the returned object.
}
\author{
  Yvonnick Noel \email{noel@univ-lille3.fr},
  Julien Claude \email{julien.claude@umontpellier.fr} and
  Emmanuel Paradis
}
\seealso{
  \code{\link{dist.dna}}, \code{\link{dist.gene}},
  \code{\link[stats]{dist}}, \code{\link[graphics]{plot}}
}
\examples{
require(stats)
X <- matrix(runif(200), 20, 10)
d <- dist(X)
PC <- prcomp(X)
M <- mst(d)
opar <- par()
par(mfcol = c(2, 2))
plot(M)
plot(M, graph = "nsca")
plot(M, x1 = PC$x[, 1], x2 = PC$x[, 2])
par(opar)
}
\keyword{multivariate}

\name{yule.time}
\alias{yule.time}
\title{Fits the Time-Dependent Yule Model}
\usage{
yule.time(phy, birth, BIRTH = NULL, root.time = 0, opti = "nlm", start = 0.01)
}
\arguments{
  \item{phy}{an object of class \code{"phylo"}.}
  \item{birth}{a (vectorized) function specifying how the birth
    (speciation) probability changes through time (see details).}
  \item{BIRTH}{a (vectorized) function giving the primitive of
    \code{birth}.}
  \item{root.time}{a numeric value giving the time of the root node
    (time is measured from the past towards the present).}
  \item{opti}{a character string giving the function used for
    optimisation of the likelihood function. Three choices are possible:
    \code{"nlm"}, \code{"nlminb"}, or \code{"optim"}, or any unambiguous
    abbreviation of these.}
  \item{start}{the initial values used in the optimisation.}
}
\description{
  This function fits by maximum likelihood the time-dependent Yule
  model. The time is measured from the past (\code{root.time}) to the
  present.
}
\details{
  The model fitted is a straightforward extension of the Yule model with
  covariates (see \code{\link{yule.cov}}). Rather than having
  heterogeneity among lineages, the speciation probability is the same
  for all lineages at a given time, but can change through time.

  The function \code{birth} \emph{must} meet these two requirements: (i)
  the parameters to be estimated are the formal arguments; (ii) time is
  named \code{t} in the body of the function. However, this is the
  opposite for the primitive \code{BIRTH}: \code{t} is the formal
  argument, and the parameters are used in its body. See the examples.

  It is recommended to use \code{BIRTH} if possible, and required if
  speciation probability is constant on some time interval. If this
  primitive cannot be provided, a numerical integration is done with
  \code{\link[stats]{integrate}}.

  The standard-errors of the parameters are computed with the Hessian of
  the log-likelihood function.
}
\value{
  An object of class \code{"yule"} (see \code{\link{yule}}).
}
\author{Emmanuel Paradis}
\references{
  Hubert, N., Paradis, E., Bruggemann, H. and Planes, S. (2011) Community
  assembly and diversification in Indo-Pacific coral reef
  fishes. \emph{Ecology and Evolution}, \bold{1}, 229--277.
}
\seealso{
  \code{\link{branching.times}}, \code{\link{ltt.plot}},
  \code{\link{birthdeath}}, \code{\link{yule}}, \code{\link{yule.cov}},
  \code{\link{bd.time}}
}
\examples{
### define two models...
birth.logis <- function(a, b) 1/(1 + exp(-a*t - b)) # logistic
birth.step <- function(l1, l2, Tcl) { # 2 rates with one break-point
    ans <- rep(l1, length(t))
    ans[t > Tcl] <- l2
    ans
}
### ... and their primitives:
BIRTH.logis <- function(t) log(exp(-a*t) + exp(b))/a + t
BIRTH.step <- function(t)
{
    out <- numeric(length(t))
    sel <- t <= Tcl
    if (any(sel)) out[sel] <- t[sel] * l1
    if (any(!sel)) out[!sel] <- Tcl * l1 + (t[!sel] - Tcl) * l2
    out
}
data(bird.families)
### fit both models:
yule.time(bird.families, birth.logis)
yule.time(bird.families, birth.logis, BIRTH.logis) # same but faster
\dontrun{yule.time(bird.families, birth.step)}  # fails
yule.time(bird.families, birth.step, BIRTH.step,
          opti = "nlminb", start = c(.01, .01, 100))
}
\keyword{models}

\name{compute.brtime}
\alias{compute.brtime}
\title{Compute and Set Branching Times}
\description{
  This function computes the branch lengths of a tree giving its
  branching times (aka node ages or heights).
}
\usage{
compute.brtime(phy, method = "coalescent", force.positive = NULL)
}
\arguments{
  \item{phy}{an object of class \code{"phylo"}.}
  \item{method}{either \code{"coalescent"} (the default), or a numeric
    vector giving the branching times.}
  \item{force.positive}{a logical value (see details).}
}
\details{
  By default, a set of random branching times is generated from a simple
  coalescent, and the option \code{force.positive} is set to \code{TRUE}
  so that no branch length is negative.

  If a numeric vector is passed to \code{method}, it is taken as the
  branching times of the nodes with respect to their numbers (i.e., the
  first element of \code{method} is the branching time of the node
  numbered \eqn{n + 1} [= the root], the second element of the node
  numbered \eqn{n + 2}, and so on), so \code{force.positive} is set to
  \code{FALSE}. This may result in negative branch lengths. To avoid
  this, one should use \code{force.positive = TRUE} in which case the
  branching times are eventually reordered.
}
\value{
  An object of class \code{"phylo"} with branch lengths and ultrametric.
}
\author{Emmanuel Paradis}
\seealso{
  \code{\link{compute.brlen}}, \code{\link{branching.times}}
}
\examples{
tr <- rtree(10)
layout(matrix(1:4, 2))
plot(compute.brtime(tr)); axisPhylo()
plot(compute.brtime(tr, force.positive = FALSE)); axisPhylo()
plot(compute.brtime(tr, 1:9)); axisPhylo() # a bit nonsense
plot(compute.brtime(tr, 1:9, TRUE)); axisPhylo()
layout(1)
}
\keyword{manip}

\name{bind.tree}
\alias{bind.tree}
\alias{+.phylo}
\title{Binds Trees}
\usage{
bind.tree(x, y, where = "root", position = 0, interactive = FALSE)
\special{x + y}
}
\arguments{
  \item{x}{an object of class \code{"phylo"}.}
  \item{y}{an object of class \code{"phylo"}.}
  \item{where}{an integer giving the number of the node or tip of the
    tree \code{x} where the tree \code{y} is binded (\code{"root"} is a
    short-cut for the root).}
  \item{position}{a numeric value giving the position from the tip or
    node given by \code{node} where the tree \code{y} is binded;
    negative values are ignored.}
  \item{interactive}{if \code{TRUE} the user is asked to choose the tip
    or node of \code{x} by clicking on the tree which must be plotted.}
}
\description{
  This function binds together two phylogenetic trees to give a single
  object of class \code{"phylo"}.
}
\details{
  The argument \code{x} can be seen as the receptor tree, whereas
  \code{y} is the donor tree. The root of \code{y} is then grafted on a
  location of \code{x} specified by \code{where} and, possibly,
  \code{position}. If \code{y} has a root edge, this is added as in
  internal branch in the resulting tree.

  \code{x + y} is a shortcut for:

  \preformatted{
    bind.tree(x, y, position = if (is.null(x$root.edge)) 0 else
    x$root.edge)
  }

  If only one of the trees has no branch length, the branch lengths of
  the other one are ignored with a warning.

  If one (or both) of the trees has no branch length, it is possible to
  specify a value of 'position' to graft 'y' below the node of 'x'
  specified by 'where'. In this case, the exact value of 'position' is
  not important as long as it is greater than zero. The new node will be
  multichotomous if 'y' has no root edge. This can be solved by giving
  an arbitrary root edge to 'y' beforehand (e.g., \code{y$root.edge <-
  1}): it will be deleted during the binding operation.
}
\value{
  an object of class \code{"phylo"}.
}
\author{Emmanuel Paradis}
\seealso{
  \code{\link{drop.tip}}, \code{\link{root}}
}
\examples{
### binds the two clades of bird orders
cat("((Struthioniformes:21.8,Tinamiformes:21.8):4.1,",
    "((Craciformes:21.6,Galliformes:21.6):1.3,Anseriformes:22.9):3.0):2.1;",
    file = "ex1.tre", sep = "\n")
cat("(Turniciformes:27.0,(Piciformes:26.3,((Galbuliformes:24.4,",
    "((Bucerotiformes:20.8,Upupiformes:20.8):2.6,",
    "(Trogoniformes:22.1,Coraciiformes:22.1):1.3):1.0):0.6,",
    "(Coliiformes:24.5,(Cuculiformes:23.7,(Psittaciformes:23.1,",
    "(((Apodiformes:21.3,Trochiliformes:21.3):0.6,",
    "(Musophagiformes:20.4,Strigiformes:20.4):1.5):0.6,",
    "((Columbiformes:20.8,(Gruiformes:20.1,Ciconiiformes:20.1):0.7):0.8,",
    "Passeriformes:21.6):0.9):0.6):0.6):0.8):0.5):1.3):0.7):1.0;",
    file = "ex2.tre", sep = "\n")
tree.bird1 <- read.tree("ex1.tre")
tree.bird2 <- read.tree("ex2.tre")
unlink(c("ex1.tre", "ex2.tre")) # clean-up
(birds <- tree.bird1 + tree.bird2)
layout(matrix(c(1, 2, 3, 3), 2, 2))
plot(tree.bird1)
plot(tree.bird2)
plot(birds)

### examples with random trees
x <- rtree(4, tip.label = LETTERS[1:4])
y <- rtree(4, tip.label = LETTERS[5:8])
x <- makeNodeLabel(x, prefix = "x_")
y <- makeNodeLabel(y, prefix = "y_")
x$root.edge <- y$root.edge <- .2

z <- bind.tree(x, y, po=.2)
plot(y, show.node.label = TRUE, font = 1, root.edge = TRUE)
title("y")
plot(x, show.node.label = TRUE, font = 1, root.edge = TRUE)
title("x")
plot(z, show.node.label = TRUE, font = 1, root.edge = TRUE)
title("z <- bind.tree(x, y, po=.2)")

## make sure the terminal branch length is long enough:
x$edge.length[x$edge[, 2] == 2] <- 0.2

z <- bind.tree(x, y, 2, .1)
plot(y, show.node.label = TRUE, font = 1, root.edge = TRUE)
title("y")
plot(x, show.node.label = TRUE, font = 1, root.edge = TRUE)
title("x")
plot(z, show.node.label = TRUE, font = 1, root.edge = TRUE)
title("z <- bind.tree(x, y, 2, .1)")

x <- rtree(50)
y <- rtree(50)
x$root.edge <- y$root.edge <- .2
z <- x + y
plot(y, show.tip.label = FALSE, root.edge = TRUE); axisPhylo()
title("y")
plot(x, show.tip.label = FALSE, root.edge = TRUE); axisPhylo()
title("x")
plot(z, show.tip.label = FALSE, root.edge = TRUE); axisPhylo()
title("z <- x + y")
layout(1)
}
\keyword{manip}

\name{node.dating}
\alias{node.dating}
\alias{estimate.mu}
\alias{estimate.dates}
\title{node.dating}
\description{
  Estimate the dates of a rooted phylogenetic tree from the tip dates.
}
\usage{
estimate.mu(t, node.dates, p.tol = 0.05)
estimate.dates(t, node.dates, mu = estimate.mu(t, node.dates),
               min.date = -.Machine$double.xmax, show.steps = 0,
               opt.tol = 1e-8, nsteps = 1000,
               lik.tol = 0, is.binary = is.binary.phylo(t))
}
\arguments{
  \item{t}{an object of class "phylo"}
  \item{node.dates}{a numeric vector of dates for the tips, in the same
    order as 't$tip.label' or a vector of dates for all of the nodes.}
  \item{p.tol}{p-value cutoff for failed regression.}
  \item{mu}{mutation rate.}
  \item{min.date}{the minimum bound on the dates of nodes}
  \item{show.steps}{print the log likelihood every show.steps. If 0 will
    supress output.}
  \item{opt.tol}{tolerance for optimization precision.}
  \item{lik.tol}{tolerance for likelihood comparison.}
  \item{nsteps}{the maximum number of steps to run.}
  \item{is.binary}{if TRUE, will run a faster optimization method that
    only works if the tree is binary; otherwise will use optimize() as
    the optimization method.}
}
\value{
  The estimated mutation rate as a numeric vector of length one for estimate.mu.

  The estimated dates of all of the nodes of the tree as a numeric vector with
  length equal to the number of nodes in the tree.
}
\details{
  This code duplicates the functionality of the program Tip.Dates (see references).
   The dates of the internal nodes of 't' are estimated using a maximum likelihood
  approach.

  't' must be rooted and have branch lengths in units of expected substitutions per
  site.

  'node.dates' can be either a numeric vector of dates for the tips or a numeric
  vector for all of the nodes of 't'.  'estimate.mu' will use all of the values
  given in 'node.dates' to estimate the mutation rate.  Dates can be censored with
  NA. 'node.dates' must contain all of the tip dates when it is a parameter of
  'estimate.dates'.  If only tip dates are given, then 'estimate.dates' will run an
  initial step to estimate the dates of the internal nodes.  If 'node.dates'
  contains dates for some of the nodes, 'estimate.dates' will use those dates as
  priors in the inital step.  If all of the dates for nodes are given, then
  'estimate.dates' will not run the inital step.

  If 'is.binary' is set to FALSE, 'estimate.dates' uses the "optimize" function as
  the optimization method.  By default, R's "optimize" function uses a precision
  of ".Machine$double.eps^0.25", which is about 0.0001 on a 64-bit system.  This
  should be set to a smaller value if the branch lengths of 't' are very short.  If
  'is.binary' is set to TRUE, estimate dates uses calculus to deterimine the maximum
  likelihood at each step, which is faster. The bounds of permissible values are
  reduced by 'opt.tol'.

  'estimate.dates' has several criteria to decide how many steps it will run.  If
  'lik.tol' and 'nsteps' are both 0, then 'estimate.dates' will only run the initial
  step.  If 'lik.tol' is greater than 0 and 'nsteps' is 0, then 'estimate.dates'
  will run until the difference between successive steps is less than 'lik.tol'.  If
  'lik.tol' is 0 and 'nsteps' is greater than 0, then 'estimate.dates' will run the
  inital step and then 'nsteps' steps.  If 'lik.tol' and 'nsteps' are both greater
  than 0, then 'estimate.dates' will run the inital step and then either 'nsteps'
  steps or until the difference between successive steps is less than 'lik.tol'.
}
\note{
  This model assumes that the tree follows a molecular clock.  It only performs a
  rudimentary statistical test of the molecular clock hypothesis.
}
\author{Bradley R. Jones <email: brj1@sfu.ca>}
\references{
  Felsenstein, J. (1981) Evolutionary trees from DNA sequences: a maximum likelihood
  approach. \emph{Journal of Molecular Evolution}, \bold{17}, 368--376.

  Rambaut, A. (2000) Estimating the rate of molecular evolution:
  incorporating non-contemporaneous sequences into maximum likelihood
  phylogenies. \emph{Bioinformatics}, \bold{16}, 395--399.

  Jones, Bradley R., and Poon, Art F. Y. (2016)
  node.dating: dating ancestors in phylogenetic trees in R
  \emph{Bioinformatics}, \bold{33}, 932--934.
}
\seealso{
  \code{\link[stats]{optimize}, \link{rtt}},
  \code{\link{plotTreeTime}}
}
\examples{
t <- rtree(100)
tip.date <- rnorm(t$tip.label, mean = node.depth.edgelength(t)[1:Ntip(t)])^2
t <- rtt(t, tip.date)
mu <- estimate.mu(t, tip.date)

## Run for 100 steps
node.date <- estimate.dates(t, tip.date, mu, nsteps = 100)

## Run until the difference between successive log likelihoods is
## less than $10^{-4}$ starting with the 100th step's results
node.date <- estimate.dates(t, node.date, mu, nsteps = 0, lik.tol = 1e-4)

## To rescale the tree over time
t$edge.length <- node.date[t$edge[, 2]] - node.date[t$edge[, 1]]
}
\keyword{model}

\name{data.nex}
\docType{data}
\alias{data.nex}
\alias{cynipids}
\title{NEXUS Data Example}
\description{
    Example of Protein data in NEXUS format (Maddison et al., 1997).
    Data is written in interleaved format using a single DATA block.
    Original data from Rokas et al (2002).
}
\usage{data(cynipids)}
\format{ASCII text in NEXUS format}
\references{
  Maddison, D. R., Swofford, D. L. and Maddison, W. P. (1997) NEXUS: an
  extensible file format for systematic information. \emph{Systematic
    Biology}, \bold{46}, 590--621.

  Rokas, A., Nylander, J. A. A., Ronquist, F. and Stone, G. N. (2002) A
  maximum likelihood analysis of eight phylogenetic markers in Gallwasps
  (Hymenoptera: Cynipidae): implications for insect phylogenetic
  studies. \emph{Molecular Phylogenetics and Evolution}, \bold{22},
  206--219.
}
\keyword{datasets}

\name{lmorigin}
\alias{lmorigin}
\alias{print.lmorigin}
\alias{lmorigin.ex1}
\alias{lmorigin.ex2}
\title{ Multiple regression through the origin }
\description{
Function \code{\link{lmorigin}} computes a multiple linear regression and performs tests of significance of the equation parameters (F-test of R-square and t-tests of regression coefficients) using permutations.

The regression line can be forced through the origin. Testing the significance in that case requires a special permutation procedure. This option was developed for the analysis of independent contrasts, which requires regression through the origin. A permutation test, described by Legendre & Desdevises (2009), is needed to analyze contrasts that are not normally distributed.
}
\usage{
lmorigin(formula, data, origin=TRUE, nperm=999, method=NULL, silent=FALSE)
}

\arguments{
  \item{formula }{ A formula specifying the bivariate model, as in
  \code{\link{lm}} and \code{\link{aov}}. }
  \item{data}{ A data frame containing the two variables specified in the formula. }
  \item{origin}{ \code{origin = TRUE} (default) to compute regression through the origin; \code{origin = FALSE} to compute multiple regression with estimation of the intercept. }
  \item{nperm}{ Number of permutations for the tests. If \code{nperm =
   0}, permutation tests will not be computed. The default value is \code{nperm = 999}. For large data files, the permutation test is rather slow since the permutation procedure is not compiled. }
  \item{method}{ \code{method = "raw"} computes t-tests of the regression coefficients by permutation of the raw data. \code{method = "residuals"} computes t-tests of the regression coefficients by permutation of the residuals of the full model. If \code{method = NULL}, permutation of the raw data is used to test the regression coefficients in regression through the origin; permutation of the residuals of the full model is used to test the regression coefficients in ordinary multiple regression. }
  \item{silent}{ Informative messages and the time to compute the tests will not be written to the \R console if silent=TRUE. Useful when the function is called by a numerical simulation function. }
}

\details{
The permutation F-test of R-square is always done by permutation of the raw data. When there is a single explanatory variable, permutation of the raw data is used for the t-test of the single regression coefficient, whatever the method chosen by the user. The rationale is found in Anderson & Legendre (1999).

The \code{print.lmorigin} function prints out the results of the parametric tests (in all cases) and the results of the permutational tests (when nperm > 0).
}

\value{

  \item{reg }{The regression output object produced by function \code{lm}. }
  \item{p.param.t.2tail }{Parametric probabilities for 2-tailed tests of the regression coefficients. }
  \item{p.param.t.1tail }{Parametric probabilities for 1-tailed tests of the regression coefficients. Each test is carried out in the direction of the sign of the coefficient. }
  \item{p.perm.t.2tail }{Permutational probabilities for 2-tailed tests of the regression coefficients. }
  \item{p.perm.t.1tail }{Permutational probabilities for 1-tailed tests of the regression coefficients. Each test is carried out in the direction of the sign of the coefficient. }
  \item{p.perm.F }{Permutational probability for the F-test of R-square. }
  \item{origin }{TRUE is regression through the origin has been computed, FALSE if multiple regression with estimation of the intercept has been used. }
  \item{nperm }{Number of permutations used in the permutation tests. }
  \item{method }{Permutation method for the t-tests of the regression coefficients: \code{method = "raw"} or \code{method = "residuals"}.  }
  \item{var.names }{Vector containing the names of the variables used in the regression. }
  \item{call }{The function call.}
}

\author{ Pierre Legendre, Universite de Montreal }

\references{
Anderson, M. J. and Legendre, P. (1999) An empirical comparison of permutation methods for tests of partial regression coefficients in a linear model. \emph{Journal of Statistical Computation and Simulation}, \bold{62}, 271--303.

Legendre, P. and Desdevises, Y. (2009) Independent contrasts and regression through the origin. \emph{Journal of Theoretical Biology}, \bold{259}, 727--743.

Sokal, R. R. and Rohlf, F. J. (1995) \emph{Biometry - The principles and
  practice of statistics in biological research. Third edition.} New
  York: W. H. Freeman.
}

\examples{
## Example 1 from Sokal & Rohlf (1995) Table 16.1
## SO2 air pollution in 41 cities of the USA
data(lmorigin.ex1)
out <- lmorigin(SO2 ~ ., data=lmorigin.ex1, origin=FALSE, nperm=99)
out

## Example 2: Contrasts computed on the phylogenetic tree of Lamellodiscus
## parasites. Response variable: non-specificity index (NSI); explanatory
## variable: maximum host size. Data from Table 1 of Legendre & Desdevises
## (2009).
data(lmorigin.ex2)
out <- lmorigin(NSI ~ MaxHostSize, data=lmorigin.ex2, origin=TRUE, nperm=99)
out

## Example 3: random numbers
y <- rnorm(50)
X <- as.data.frame(matrix(rnorm(250),50,5))
out <- lmorigin(y ~ ., data=X, origin=FALSE, nperm=99)
out

}

\keyword{ multivariate }

\name{diversity.contrast.test}
\alias{diversity.contrast.test}
\title{Diversity Contrast Test}
\description{
  This function performs the diversity contrast test comparing pairs of
  sister-clades.
}
\usage{
diversity.contrast.test(x, method = "ratiolog",
        alternative = "two.sided", nrep = 0, ...)
}
\arguments{
  \item{x}{a matrix or a data frame with at least two columns: the first
    one gives the number of species in clades with a trait supposed to
    increase or decrease diversification rate, and the second one the
    number of species in the sister-clades without the trait. Each row
    represents a pair of sister-clades.}
  \item{method}{a character string specifying the kind of test:
    \code{"ratiolog"} (default), \code{"proportion"},
    \code{"difference"}, \code{"logratio"}, or any unambiguous
    abbreviation of these.}
  \item{alternative}{a character string defining the alternative
    hypothesis:  \code{"two.sided"} (default), \code{"less"},
    \code{"greater"}, or any unambiguous abbreviation of these.}
  \item{nrep}{the number of replications of the randomization test; by
    default, a Wilcoxon test is done.}
  \item{\dots}{arguments passed to the function
    \code{\link[stats]{wilcox.test}}.}
}
\details{
  If \code{method = "ratiolog"}, the test described in Barraclough et
  al. (1996) is performed. If \code{method = "proportion"}, the version
  in Barraclough et al. (1995) is used. If \code{method = "difference"},
  the signed difference is used (Sargent 2004). If \code{method = "logratio"},
  then this is Wiegmann et al.'s (1993) version. These
  four tests are essentially different versions of the same test (Vamosi
  and Vamosi 2005, Vamosi 2007). See Paradis (2012) for a comparison of
  their statistical performance with other tests.

  If \code{nrep = 0}, a Wilcoxon test is done on the species diversity
  contrasts with the null hypothesis is that they are distributed around
  zero. If \code{nrep > 0}, a randomization procedure is done where the
  signs of the diversity contrasts are randomly chosen. This is used to
  create a distribution of the test statistic which is compared with the
  observed value (the sum of the diversity contrasts).
}
\value{
  a single numeric value with the \emph{P}-value.
}
\references{
  Barraclough, T. G., Harvey, P. H. and  Nee, S. (1995) Sexual
  selection and taxonomic diversity in passerine birds.
  \emph{Proceedings of the Royal Society of London. Series B. Biological
    Sciences}, \bold{259}, 211--215.

  Barraclough, T. G., Harvey, P. H., and Nee,  S. (1996) Rate of
  \emph{rbc}L gene sequence evolution and species diversification in
  flowering plants (angiosperms). \emph{Proceedings of the Royal Society
    of London. Series B. Biological Sciences}, \bold{263}, 589--591.

  Paradis, E. (2012) Shift in diversification in sister-clade
  comparisons: a more powerful test. \emph{Evolution}, \bold{66},
  288--295.

  Sargent, R. D. (2004) Floral symmetry affects speciation rates in
  angiosperms. \emph{Proceedings of the Royal Society of London. Series
  B. Biological Sciences}, \bold{271}, 603--608.

  Vamosi, S. M. (2007) Endless tests: guidelines for analysing non-nested
  sister-group comparisons. An addendum. \emph{Evolutionary Ecology
  Research}, \bold{9}, 717.

  Vamosi, S. M. and Vamosi, J. C. (2005) Endless tests: guidelines for
  analysing non-nested sister-group comparisons. \emph{Evolutionary
  Ecology Research}, \bold{7}, 567--579.

  Wiegmann, B., Mitter, C. and Farrell, B. 1993. Diversification of
  carnivorous parasitic insects: extraordinary radiation or specialized
  dead end? \emph{American Naturalist}, \bold{142}, 737--754.
}
\author{Emmanuel Paradis}
\seealso{
  \code{\link{slowinskiguyer.test}}, \code{\link{mcconwaysims.test}}
  \code{\link{richness.yule.test}}
}
\examples{
### data from Vamosi & Vamosi (2005):
fleshy <- c(1, 1, 1, 1, 1, 3, 3, 5, 9, 16, 33, 40, 50, 100, 216, 393, 850, 947,1700)
dry <- c(2, 64, 300, 89, 67, 4, 34, 10, 150, 35, 2, 60, 81, 1, 3, 1, 11, 1, 18)
x <- cbind(fleshy, dry)
diversity.contrast.test(x)
diversity.contrast.test(x, alt = "g")
diversity.contrast.test(x, alt = "g", nrep = 1e4)
slowinskiguyer.test(x)
mcconwaysims.test(x)
}
\keyword{htest}

\name{slowinskiguyer.test}
\alias{slowinskiguyer.test}
\title{Slowinski-Guyer Test of Homogeneous Diversification}
\description{
  This function performs the Slowinski--Guyer test that a trait or
  variable does not increase diversification rate.
}
\usage{
slowinskiguyer.test(x, detail = FALSE)
}
\arguments{
  \item{x}{a matrix or a data frame with at least two columns: the first
    one gives the number of species in clades with a trait supposed to
    increase diversification rate, and the second one the number of
    species in the corresponding sister-clade without the trait. Each
    row represents a pair of sister-clades.}
  \item{detail}{if \code{TRUE}, the individual P-values are appended.}
}
\details{
  The Slowinski--Guyer test compares a series of sister-clades where one
  of the two is characterized by a trait supposed to increase
  diversification rate. The null hypothesis is that the trait does not
  affect diversification. If the trait decreased diversification rate,
  then the null hypothesis cannot be rejected.

  The present function has mainly a historical interest. The
  Slowinski--Guyer test generally performs poorly: see Paradis (2012)
  alternatives and the functions cited below.
}
\value{
  a data frame with the \eqn{\chi^2}{chi2}, the number of degrees of
  freedom, and the \emph{P}-value. If \code{detail = TRUE}, a list is
  returned with the data frame and a vector of individual
  \emph{P}-values for each pair of sister-clades.
}
\references{
  Paradis, E. (2012) Shift in diversification in sister-clade
  comparisons: a more powerful test. \emph{Evolution}, \bold{66},
  288--295.

  Slowinski, J. B. and Guyer, C. (1993) Testing whether certain traits
  have caused amplified diversification: an improved method based on a
  model of random speciation and extinction. \emph{American Naturalist},
  \bold{142}, 1019--1024.
}
\author{Emmanuel Paradis}
\seealso{
  \code{\link{balance}}, \code{\link{mcconwaysims.test}},
  \code{\link{diversity.contrast.test}},
  \code{\link{richness.yule.test}},
  \code{\link[geiger]{rc}} in \pkg{geiger},
  \code{\link[apTreeshape]{shift.test}} in \pkg{apTreeshape}
}
\examples{
### from Table 1 in Slowinski and Guyer(1993):
viviparous <- c(98, 8, 193, 36, 7, 128, 2, 3, 23, 70)
oviparous <- c(234, 17, 100, 4, 1, 12, 6, 1, 481, 11)
x <- data.frame(viviparous, oviparous)
slowinskiguyer.test(x, TRUE) # 'P ~ 0.32' in the paper
xalt <- x
xalt[3, 2] <- 1
slowinskiguyer.test(xalt)
}
\keyword{htest}

\name{edges}
\alias{edges}
\alias{fancyarrows}
\title{Draw Additional Edges on a Plotted Tree}
\description{
  \code{edges} draws edges on a plotted tree. \code{fancyarrows}
  enhances \code{\link[graphics]{arrows}} with triangle and harpoon
  heads; it can be called from \code{edges}.
}
\usage{
edges(nodes0, nodes1, arrows = 0, type = "classical", ...)
fancyarrows(x0, y0, x1, y1, length = 0.25, angle = 30, code = 2,
            col = par("fg"), lty = par("lty"), lwd = par("lwd"),
            type = "triangle", ...)
}
\arguments{
  \item{nodes0, nodes1}{vectors of integers giving the tip and/or node
    numbers where to start and to end the edges (eventually recycled).}
  \item{arrows}{an integer between 0 and 3; 0: lines (the default); 1:
    an arrow head is drawn at \code{nodes0}; 2: at \code{nodes1}; 3:
    both.}
  \item{type}{if the previous argument is not 0, the type of arrow head:
    \code{"classical"} (just lines, the default), \code{"triangle"},
    \code{"harpoon"}, or any unambiguous abbreviations of these. For
    \code{fancyarrows} only the last two are available.}
  \item{x0, y0, x1, y1}{the coordinates of the start and end points for
    \code{fancyarrows} (these are not recycled and so should be vectors
    of the same length).}
  \item{length, angle, code, col, lty, lwd}{default options similar to
    those of \code{\link[graphics]{arrows}}.}
  \item{\dots}{further arguments passed to \code{\link[graphics]{segments}}.}
}
\details{
  The first function is helpful when drawing reticulations on a phylogeny,
  especially if computed from the edge matrix.
}
\author{Emmanuel Paradis}
\seealso{
  \code{\link{plot.phylo}}, \code{\link{nodelabels}}
}
\examples{
set.seed(2)
tr <- rcoal(6)
plot(tr, "c")
edges(10, 9, col = "red", lty = 2)
edges(10:11, 8, col = c("blue", "green")) # recycling of 'nodes1'
edges(1, 2, lwd = 2, type = "h", arrows = 3, col = "green")
nodelabels()
}
\keyword{aplot}

\name{gammaStat}
\alias{gammaStat}
\title{Gamma-Statistic of Pybus and Harvey}
\usage{
gammaStat(phy)
}
\arguments{
  \item{phy}{an object of class \code{"phylo"}.}
}
\description{
  This function computes the gamma-statistic which summarizes the
  information contained in the inter-node intervals of a phylogeny. It
  is assumed that the tree is ultrametric. Note that the function does
  not check that the tree is effectively ultrametric, so if it is not,
  the returned result may not be meaningful.
}
\value{
  a numeric vector of length one.
}
\details{
  The gamma-statistic is a summary of the information contained in the
  inter-node intervals of a phylogeny; it follows, under the assumption
  that the clade diversified with constant rates, a normal distribution
  with mean zero and standard-deviation unity (Pybus and Harvey
  2000). Thus, the null hypothesis that the clade diversified with
  constant rates may be tested with \code{2*(1 -
    pnorm(abs(gammaStat(phy))))} for a two-tailed test, or \code{1 -
    pnorm(abs(gammaStat(phy)))} for a one-tailed test, both returning
  the corresponding P-value.
}
\references{
  Pybus, O. G. and Harvey, P. H. (2000) Testing macro-evolutionary
  models using incomplete molecular phylogenies. \emph{Proceedings of
    the Royal Society of London. Series B. Biological Sciences},
  \bold{267}, 2267--2272.
}
\author{Emmanuel Paradis}
\seealso{
  \code{\link{branching.times}}, \code{\link{ltt.plot}}, \code{\link{skyline}}
}
\keyword{univar}

\name{updateLabel}
\alias{updateLabel}
\alias{updateLabel.DNAbin}
\alias{updateLabel.AAbin}
\alias{updateLabel.character}
\alias{updateLabel.phylo}
\alias{updateLabel.evonet}
\alias{updateLabel.data.frame}
\alias{updateLabel.matrix}
\title{Update Labels}
\description{
  This function changes labels (names or rownames) giving two vectors (\code{old} and \code{new}). It is a generic function with several methods as described below.
}
\usage{
updateLabel(x, old, new, ...)
\method{updateLabel}{character}(x, old, new, exact = TRUE, ...)
\method{updateLabel}{DNAbin}(x, old, new, exact = TRUE, ...)
\method{updateLabel}{AAbin}(x, old, new, exact = TRUE, ...)
\method{updateLabel}{phylo}(x, old, new, exact = TRUE, nodes = FALSE, ...)
\method{updateLabel}{evonet}(x, old, new, exact = TRUE, nodes = FALSE, ...)
\method{updateLabel}{data.frame}(x, old, new, exact = TRUE, ...)
\method{updateLabel}{matrix}(x, old, new, exact = TRUE, ...)
}
\arguments{
  \item{x}{an object where to change the labels.}
  \item{old, new}{two vectors of mode character (must be of the same length).}
  \item{exact}{a logical value (see details).}
  \item{nodes}{a logical value specifying whether to also update the node labels of the tree or network.}
  \item{\dots}{further arguments passed to and from methods.}
}
\details{
This function can be used to change some of the labels (see examples) or all of them if their ordering is not sure.

If \code{exact = TRUE} (the default), the values in \code{old} are matched exactly with the labels; otherwise (\code{exact = FALSE}), the values in \code{old} are considered as regular expressions and searched in the labels with \code{\link{grep}}.
}
\value{
  an object of the same class than \code{x}.
}
\author{Emmanuel Paradis}
\seealso{
  \code{\link{makeLabel}}, \code{\link{makeNodeLabel}},
  \code{\link{mixedFontLabel}}, \code{\link{stripLabel}},
  \code{\link{checkLabel}}
}
\examples{
\dontrun{
## the tree by Nyakatura & Bininda-Emonds (2012, BMC Biology)
x <- "https://static-content.springer.com/esm/art"
y <- "3A10.1186"
z <- "2F1741-7007-10-12/MediaObjects/12915_2011_534_MOESM5_ESM.NEX"
## The commande below may not print correctly in HTML because of the
## percentage symbol; see the text or PDF help page.
url <- paste(x, y, z, sep = "%")
TC <- read.nexus(url)
tr <- TC$carnivoreST_bestEstimate
old <- c("Uncia_uncia", "Felis_manul", "Leopardus_jacobitus")
new <- c("Panthera_uncia", "Otocolobus_manul", "Leopardus_jacobita")
tr.updated <- updateLabel(tr, old, new)
}

tr <- rtree(6)
## the order of the labels are randomized by this function
old <- paste0("t", 1:6)
new <- paste0("x", 1:6)
updateLabel(tr, old, new)
tr
}
\keyword{manip}

\name{skylineplot}
\alias{skylineplot}
\alias{plot.skyline}
\alias{lines.skyline}
\alias{skylineplot.deluxe}
\title{Drawing Skyline Plot Graphs}
\usage{
\method{plot}{skyline}(x, show.years=FALSE, subst.rate, present.year, \dots)
\method{lines}{skyline}(x, show.years=FALSE, subst.rate, present.year, \dots)
skylineplot(z, \dots)
skylineplot.deluxe(tree, \dots)
}
\arguments{
  \item{x}{skyline plot data (i.e. an object of class \code{"skyline"}).}
  \item{z}{Either an ultrametric tree (i.e. an object of class \code{"phylo"}),
           or coalescent intervals (i.e. an object of class \code{"coalescentIntervals"}), or
	   collapsed coalescent intervals (i.e. an object of class \code{"collapsedIntervals"}).}
  \item{tree}{ultrametric tree (i.e. an object of class \code{"phylo"}).}
  \item{show.years}{option that determines whether the time is plotted in units of
        of substitutions (default) or in years (requires specification of substution rate
	and year of present).}
 \item{subst.rate}{substitution rate (see option show.years).}
 \item{present.year}{present year (see option show.years).}

  \item{\dots}{further arguments to be passed on to \code{skyline()} and \code{plot()}.}
}
\description{
 These functions provide various ways to draw \emph{skyline plot} graphs
 on the current graphical device. Note that \code{skylineplot(z, \dots)} is simply
 a shortcut for \code{plot(skyline(z, \dots))}.
 The skyline plot itself is an estimate of effective population size through time,
 and is computed using the function \code{\link{skyline}}.
}

\details{
 See \code{\link{skyline}} for more details (incl. references) about the skyline plot method.
}
\author{Korbinian Strimmer}
\seealso{
\code{\link[graphics]{plot}} and \code{\link[graphics]{lines}} for the basic plotting
function in R, \code{\link{coalescent.intervals}}, \code{\link{skyline}}
}
\examples{
# get tree
data("hivtree.newick") # example tree in NH format
tree.hiv <- read.tree(text = hivtree.newick) # load tree

#### classic skyline plot
skylineplot(tree.hiv) # shortcut

#### plot classic and generalized skyline plots and estimate epsilon
sk.opt <- skylineplot.deluxe(tree.hiv)
sk.opt$epsilon

#### classic and generalized skyline plot ####
sk1 <- skyline(tree.hiv)
sk2 <- skyline(tree.hiv, 0.0119)

# use years rather than substitutions as unit for the time axis
plot(sk1, show.years=TRUE, subst.rate=0.0023, present.year = 1997, col=c(grey(.8),1))
lines(sk2,  show.years=TRUE, subst.rate=0.0023, present.year = 1997)
legend(.15,500, c("classic", "generalized"), col=c(grey(.8),1),lty=1)

#### various skyline plots for different epsilons
layout(mat= matrix(1:6,2,3,byrow=TRUE))
ci <- coalescent.intervals(tree.hiv)
plot(skyline(ci, 0.0));title(main="0.0")
plot(skyline(ci, 0.007));title(main="0.007")
plot(skyline(ci, 0.0119),col=4);title(main="0.0119")
plot(skyline(ci, 0.02));title(main="0.02")
plot(skyline(ci, 0.05));title(main="0.05")
plot(skyline(ci, 0.1));title(main="0.1")
layout(mat= matrix(1:1,1,1,byrow=TRUE))
}
\keyword{hplot}

\name{dbd}
\alias{dyule}
\alias{dbd}
\alias{dbdTime}
\title{Probability Density Under Birth--Death Models}
\description{
  These functions compute the probability density under some
  birth--death models, that is the probability of obtaining \emph{x}
  species after a time \emph{t} giving how speciation and extinction
  probabilities vary through time (these may be constant, or even equal
  to zero for extinction).
}
\usage{
dyule(x, lambda = 0.1, t = 1, log = FALSE)
dbd(x, lambda, mu, t, conditional = FALSE, log = FALSE)
dbdTime(x, birth, death, t, conditional = FALSE,
        BIRTH = NULL, DEATH = NULL, fast = FALSE)
}
\arguments{
  \item{x}{a numeric vector of species numbers (see Details).}
  \item{lambda}{a numerical value giving the probability of speciation;
    can be a vector with several values for \code{dyule}.}
  \item{mu}{id. for extinction.}
  \item{t}{id. for the time(s).}
  \item{log}{a logical value specifying whether the probabilities should
    be returned log-transformed; the default is \code{FALSE}.}
  \item{conditional}{a logical specifying whether the probabilities
    should be computed conditional under the assumption of no extinction
    after time \code{t}.}
  \item{birth, death}{a (vectorized) function specifying how the
    speciation or extinction probability changes through time (see
    \code{\link{yule.time}} and below).}
  \item{BIRTH, DEATH}{a (vectorized) function giving the primitive
    of \code{birth} or \code{death}.}
  \item{fast}{a logical value specifying whether to use faster
    integration (see \code{\link{bd.time}}).}
}
\details{
  These three functions compute the probabilities to observe \code{x}
  species starting from a single one after time \code{t} (assumed to be
  continuous). The first function is a short-cut for the second one with
  \code{mu = 0} and with default values for the two other arguments.
  \code{dbdTime} is for time-varying \code{lambda} and \code{mu}
  specified as \R functions.

  \code{dyule} is vectorized simultaneously on its three arguments
  \code{x}, \code{lambda}, and \code{t}, according to \R's rules of
  recycling arguments. \code{dbd} is vectorized simultaneously \code{x}
  and \code{t} (to make likelihood calculations easy), and
  \code{dbdTime} is vectorized only on \code{x}; the other arguments are
  eventually shortened with a warning if necessary.

  The returned value is, logically, zero for values of \code{x} out of
  range, i.e., negative or zero for \code{dyule} or if \code{conditional
  = TRUE}. However, it is not checked if the values of \code{x} are
  positive non-integers and the probabilities are computed and returned.

  The details on the form of the arguments \code{birth}, \code{death},
  \code{BIRTH}, \code{DEATH}, and \code{fast} can be found in the links
  below.
}
\note{
  If you use these functions to calculate a likelihood function, it is
  strongly recommended to compute the log-likelihood with, for instance
  in the case of a Yule process, \code{sum(dyule( , log = TRUE))} (see
  examples).
}
\value{
  a numeric vector.
}
\references{
  Kendall, D. G. (1948) On the generalized ``birth-and-death''
  process. \emph{Annals of Mathematical Statistics}, \bold{19}, 1--15.
}
\author{Emmanuel Paradis}
\seealso{
  \code{\link{bd.time}},  \code{\link{yule.time}}
}
\examples{
x <- 0:10
plot(x, dyule(x), type = "h", main = "Density of the Yule process")
text(7, 0.85, expression(list(lambda == 0.1, t == 1)))

y <- dbd(x, 0.1, 0.05, 10)
z <- dbd(x, 0.1, 0.05, 10, conditional = TRUE)
d <- rbind(y, z)
colnames(d) <- x
barplot(d, beside = TRUE, ylab = "Density", xlab = "Number of species",
        legend = c("unconditional", "conditional on\nno extinction"),
        args.legend = list(bty = "n"))
title("Density of the birth-death process")
text(17, 0.4, expression(list(lambda == 0.1, mu == 0.05, t == 10)))

\dontrun{
### generate 1000 values from a Yule process with lambda = 0.05
x <- replicate(1e3, Ntip(rlineage(0.05, 0)))

### the correct way to calculate the log-likelihood...:
sum(dyule(x, 0.05, 50, log = TRUE))

### ... and the wrong way:
log(prod(dyule(x, 0.05, 50)))

### a third, less preferred, way:
sum(log(dyule(x, 0.05, 50)))
}}
\keyword{utilities}

\name{chronos}
\alias{chronos}
\alias{makeChronosCalib}
\alias{chronos.control}
\alias{print.chronos}
\title{Molecular Dating by Penalised Likelihood and Maximum Likelihood}
\description{
  \code{chronos} is the main function fitting a chronogram to a
  phylogenetic tree whose branch lengths are in number of substitution
  per sites.

  \code{makeChronosCalib} is a tool to prepare data frames with the
  calibration points of the phylogenetic tree.

  \code{chronos.control} creates a list of parameters to be passed
  to \code{chronos}.
}
\usage{
chronos(phy, lambda = 1, model = "correlated", quiet = FALSE,
        calibration = makeChronosCalib(phy),
        control = chronos.control())
\method{print}{chronos}(x, ...)
makeChronosCalib(phy, node = "root", age.min = 1,
   age.max = age.min, interactive = FALSE, soft.bounds = FALSE)
chronos.control(...)
}
\arguments{
  \item{phy}{an object of class \code{"phylo"}.}
  \item{lambda}{value of the smoothing parameter.}
  \item{model}{a character string specifying the model of substitution
    rate variation among branches. The possible choices are:
    ``correlated'', ``relaxed'', ``discrete'', or an unambiguous
    abbreviation of these.}
  \item{quiet}{a logical value; by default the calculation progress are
    displayed.}
  \item{calibration}{a data frame (see details).}
  \item{control}{a list of parameters controlling the optimisation
    procedure (see details).}
  \item{x}{an object of class \code{c("chronos", "phylo")}.}
  \item{node}{a vector of integers giving the node numbers for which a
    calibration point is given. The default is a short-cut for the
    root.}
  \item{age.min, age.max}{vectors of numerical values giving the minimum
    and maximum ages of the nodes specified in \code{node}.}
  \item{interactive}{a logical value. If \code{TRUE}, then \code{phy} is
    plotted and the user is asked to click close to a node and enter the
    ages on the keyboard.}
  \item{soft.bounds}{(currently unused)}
  \item{\dots}{in the case of \code{chronos.control}: one of the five
    parameters controlling optimisation (unused in the case of
    \code{print.chronos}).}
}
\details{
  \code{chronos} replaces \code{chronopl} but with a different interface
  and some extensions (see References).

  The known dates (argument \code{calibration}) must be given in a data
  frame with the following column names: node, age.min, age.max, and
  soft.bounds (the last one is yet unused). For each row, these are,
  respectively: the number of the node in the ``phylo'' coding standard,
  the minimum age for this node, the maximum age, and a logical value
  specifying whether the bounds are soft. If age.min = age.max, this
  means that the age is exactly known. This data frame can be built with
  \code{makeChronosCalib} which returns by default a data frame with a
  single row giving age = 1 for the root. The data frame can be built
  interactively by clicking on the plotted tree.

  The argument \code{control} allows one to change some parameters of
  the optimisation procedure. This must be a list with names. The
  available options with their default values are:

  \itemize{
    \item{tol = 1e-8: }{tolerance for the estimation of the substitution
      rates.}
    \item{iter.max = 1e4: }{the maximum number of iterations at each
      optimization step.}
    \item{eval.max = 1e4: }{the maximum number of function evaluations at
      each optimization step.}
    \item{nb.rate.cat = 10: }{the number of rate categories if \code{model
	= "discrete"} (set this parameter to 1 to fit a strict clock
      model).}
    \item{dual.iter.max = 20: }{the maximum number of alternative
      iterations between rates and dates.}
    \item{epsilon = 1e-6: }{the convergence diagnostic criterion.}
  }

  The command \code{chronos.control()} returns a list with the default
  values of these parameters. They may be modified by passing them to
  this function, or directly in the list.
}
\value{
  \code{chronos} returns an object of class \code{c("chronos",
  "phylo")}. There is a print method for it. There are additional
  attributes which can be visualised with \code{str} or extracted with
  \code{attr}.

  \code{makeChronosCalib} returns a data frame.

  \code{chronos.control} returns a list.
}
\references{
  Kim, J. and Sanderson, M. J. (2008) Penalized likelihood phylogenetic
  inference: bridging the parsimony-likelihood gap. \emph{Systematic
    Biology}, \bold{57}, 665--674.

  Paradis, E. (2013) Molecular dating of phylogenies by likelihood
  methods: a comparison of models and a new information
  criterion. \emph{Molecular Phylogenetics and Evolution}, \bold{67},
  436--444.

  Sanderson, M. J. (2002) Estimating absolute rates of molecular
  evolution and divergence times: a penalized likelihood
  approach. \emph{Molecular Biology and Evolution}, \bold{19},
  101--109.
}
\author{Emmanuel Paradis, Santiago Claramunt, Guillaume Louvel}
\seealso{\code{\link{chronoMPL}}}
\examples{
tr <- rtree(10)
### the default is the correlated rate model:
chr <- chronos(tr)
### strict clock model:
ctrl <- chronos.control(nb.rate.cat = 1)
chr.clock <- chronos(tr, model = "discrete", control = ctrl)
### How different are the rates?
attr(chr, "rates")
attr(chr.clock, "rates")
\dontrun{
cal <- makeChronosCalib(tr, interactive = TRUE)
cal
### if you made mistakes, you can edit the data frame with:
### fix(cal)
chr <- chronos(tr, calibration = cal)
}
}
\keyword{models}

\name{skyline}
\alias{skyline}
\alias{skyline.phylo}
\alias{skyline.coalescentIntervals}
\alias{skyline.collapsedIntervals}
\alias{find.skyline.epsilon}
\title{Skyline Plot Estimate of Effective Population Size}
\usage{
skyline(x, \dots)
\method{skyline}{phylo}(x, \dots)
\method{skyline}{coalescentIntervals}(x, epsilon=0, \dots)
\method{skyline}{collapsedIntervals}(x, old.style=FALSE, \dots)
find.skyline.epsilon(ci, GRID=1000, MINEPS=1e-6, \dots)
}
\arguments{
  \item{x}{Either an ultrametric tree (i.e. an object of class
    \code{"phylo"}), or coalescent intervals (i.e. an object of class
    \code{"coalescentIntervals"}), or collapsed coalescent intervals
    (i.e. an object of class \code{"collapsedIntervals"}).}
  \item{epsilon}{collapsing parameter that controls the amount of smoothing
    (allowed range: from \code{0} to \code{ci$total.depth}, default value: 0). This is the same parameter as in
    \link{collapsed.intervals}.}
  \item{old.style}{Parameter to choose between two slightly different variants of the
     generalized skyline plot (Strimmer and Pybus, pers. comm.). The default value \code{FALSE} is
     recommended.}
  \item{ci}{coalescent intervals (i.e. an object of class \code{"coalescentIntervals"})}
  \item{GRID}{Parameter for the grid search for \code{epsilon} in \code{find.skyline.epsilon}.}
  \item{MINEPS}{Parameter for the grid search for \code{epsilon} in \code{find.skyline.epsilon}.}
  \item{\dots}{Any of the above parameters.}
}
\description{
 \code{skyline} computes the \emph{generalized skyline plot} estimate of effective population size
 from an estimated phylogeny.  The demographic history is approximated by
 a step-function.  The number of parameters of the skyline plot (i.e. its smoothness)
 is controlled by a parameter \code{epsilon}.

 \code{find.skyline.epsilon} searches for an optimal value of the \code{epsilon} parameter,
 i.e. the value that maximizes the AICc-corrected log-likelihood (\code{logL.AICc}).
}
\details{
\code{skyline} implements the \emph{generalized skyline plot}  introduced in
Strimmer and Pybus (2001).  For \code{epsilon = 0} the
generalized skyline plot degenerates to the
\emph{classic skyline plot} described in
Pybus et al. (2000).  The latter is in turn directly related to lineage-through-time plots
(Nee et al., 1995).
}

\value{
\code{skyline} returns an object of class \code{"skyline"} with the following entries:

  \item{time}{ A vector with the time at the end of each coalescent
    interval (i.e. the accumulated interval lengths from the beginning of the first interval
    to the end of an interval)}
  \item{interval.length}{ A vector with the length of each interval.}
  \item{population.size}{A vector with the effective population size of each interval.}
  \item{parameter.count}{ Number of free parameters in the skyline plot.}
  \item{epsilon}{The value of the underlying smoothing parameter.}
  \item{logL}{Log-likelihood of skyline plot (see Strimmer and Pybus, 2001).}
  \item{logL.AICc}{AICc corrected log-likelihood (see Strimmer and Pybus, 2001).}

  \code{find.skyline.epsilon} returns the value of the \code{epsilon} parameter
  that maximizes \code{logL.AICc}.
}
\author{Korbinian Strimmer}
\seealso{
\code{\link{coalescent.intervals}}, \code{\link{collapsed.intervals}},
\code{\link{skylineplot}}, \code{\link{ltt.plot}}.
}
\references{
  Strimmer, K. and Pybus, O. G. (2001) Exploring the demographic history
  of DNA sequences using the generalized skyline plot. \emph{Molecular
    Biology and Evolution}, \bold{18}, 2298--2305.

  Pybus, O. G, Rambaut, A. and Harvey, P. H. (2000) An integrated
  framework for the inference of viral population history from
  reconstructed genealogies. \emph{Genetics}, \bold{155}, 1429--1437.

  Nee, S., Holmes, E. C., Rambaut, A. and Harvey, P. H. (1995) Inferring
  population history from molecular phylogenies. \emph{Philosophical
    Transactions of the Royal Society of London. Series B. Biological
    Sciences}, \bold{349}, 25--31.
}
\examples{
# get tree
data("hivtree.newick") # example tree in NH format
tree.hiv <- read.tree(text = hivtree.newick) # load tree

# corresponding coalescent intervals
ci <- coalescent.intervals(tree.hiv) # from tree

# collapsed intervals
cl1 <- collapsed.intervals(ci,0)
cl2 <- collapsed.intervals(ci,0.0119)

#### classic skyline plot ####
sk1 <- skyline(cl1)        # from collapsed intervals 
sk1 <- skyline(ci)         # from coalescent intervals
sk1 <- skyline(tree.hiv)   # from tree
sk1

plot(skyline(tree.hiv))
skylineplot(tree.hiv) # shortcut

plot(sk1, show.years=TRUE, subst.rate=0.0023, present.year = 1997)

#### generalized skyline plot ####

sk2 <- skyline(cl2)              # from collapsed intervals
sk2 <- skyline(ci, 0.0119)       # from coalescent intervals
sk2 <- skyline(tree.hiv, 0.0119) # from tree
sk2

plot(sk2)

# classic and generalized skyline plot together in one plot
plot(sk1, show.years=TRUE, subst.rate=0.0023, present.year = 1997, col=c(grey(.8),1))
lines(sk2,  show.years=TRUE, subst.rate=0.0023, present.year = 1997)
legend(.15,500, c("classic", "generalized"), col=c(grey(.8),1),lty=1)


# find optimal epsilon parameter using AICc criterion
find.skyline.epsilon(ci)

sk3 <- skyline(ci, -1) # negative epsilon also triggers estimation of epsilon
sk3$epsilon
}
\keyword{manip}

\name{image.DNAbin}
\alias{image.DNAbin}
\title{Plot of DNA Sequence Alignement}
\description{
  This function plots an image of an alignment of nucleotide sequences.
}
\usage{
\method{image}{DNAbin}(x, what, col, bg = "white", xlab = "", ylab = "",
      show.labels = TRUE, cex.lab = 1, legend = TRUE,
      grid = FALSE, show.bases = FALSE, base.cex = 1,
      base.font = 1, base.col = "black", ...)
}
\arguments{
  \item{x}{a matrix of DNA sequences (class \code{"DNAbin"}).}
  \item{what}{a vector of characters specifying the bases to
    visualize. If missing, this is set to ``a'', ``g'', ``c'', ``t'',
    ``n'', and ``-'' (in this order).}
  \item{col}{a vector of colours. If missing, this is set to ``red'',
    ``yellow'', ``green'', ``blue'', ``grey'', and ``black''. If it is
    shorter (or longer) than \code{what}, it is recycled (or shortened).}
  \item{bg}{the colour used for nucleotides whose base is not among
    \code{what}.}
  \item{xlab}{the label for the \emph{x}-axis; none by default.}
  \item{ylab}{Idem for the \emph{y}-axis. Note that by default, the
    labels of the sequences are printed on the \emph{y}-axis (see next option).}
  \item{show.labels}{a logical controlling whether the sequence labels
    are printed (\code{TRUE} by default).}
  \item{cex.lab}{a single numeric controlling the size of the sequence labels.
    Use \code{cex.axis} to control the size of the annotations on the
    \emph{x}-axis.}
  \item{legend}{a logical controlling whether the legend is plotted
    (\code{TRUE} by default).}
  \item{grid}{a logical controlling whether to draw a grid (\code{FALSE}
    by default).}
  \item{show.bases}{a logical controlling whether to show the base symbols
    (\code{FALSE} by default).}
  \item{base.cex, base.font, base.col}{control the aspect of the base
    symbols (ignored if the previous is \code{FALSE}).}
  \item{\dots}{further arguments passed to
    \code{\link[graphics]{image.default}} (e.g., \code{xlab},
    \code{cex.axis}).}
}
\details{
  The idea of this function is to allow flexible plotting and colouring
  of a nucleotide alignment. By default, the most common bases (a, g, c,
  t, and n) and alignment gap are plotted using a standard colour
  scheme.

  It is possible to plot only one base specified as \code{what} with a
  chosen colour: this might be useful to check, for instance, the
  distribution of alignment gaps (\code{image(x, "-")}) or missing data
  (see examples).
}
\author{Emmanuel Paradis}
\seealso{
  \code{\link{DNAbin}}, \code{\link{del.gaps}}, \code{\link{alex}},
  \code{\link{alview}}, \code{\link{all.equal.DNAbin}},
  \code{\link{clustal}}, \code{\link[graphics]{grid}},
  \code{\link{image.AAbin}}
}
\examples{
data(woodmouse)
image(woodmouse)
rug(seg.sites(woodmouse), -0.02, 3, 1)
image(woodmouse, "n", "blue") # show missing data
image(woodmouse, c("g", "c"), "green") # G+C
par(mfcol = c(2, 2))
### barcoding style:
for (x in c("a", "g", "c", "t"))
    image(woodmouse, x, "black", cex.lab = 0.5, cex.axis = 0.7)
par(mfcol = c(1, 1))
### zoom on a portion of the data:
image(woodmouse[11:15, 1:50], c("a", "n"), c("blue", "grey"))
grid(50, 5, col = "black")
### see the guanines on a black background:
image(woodmouse, "g", "yellow", "black")
}
\keyword{hplot}

\name{multi2di}
\alias{multi2di}
\alias{multi2di.phylo}
\alias{multi2di.multiPhylo}
\alias{di2multi}
\alias{di2multi.phylo}
\alias{di2multi.multiPhylo}
\title{Collapse and Resolve Multichotomies}
\description{
  These two functions collapse or resolve multichotomies in phylogenetic
  trees.
}
\usage{
multi2di(phy, ...)
\method{multi2di}{phylo}(phy, random = TRUE, equiprob = TRUE, ...)
\method{multi2di}{multiPhylo}(phy, random = TRUE, equiprob = TRUE, ...)
di2multi(phy, ...)
\method{di2multi}{phylo}(phy, tol = 1e-08, ...)
\method{di2multi}{multiPhylo}(phy, tol = 1e-08, ...)
}
\arguments{
  \item{phy}{an object of class \code{"phylo"} or \code{"multiPhylo"}.}
  \item{random}{a logical value specifying whether to resolve the
    multichotomies randomly (the default) or in the order they appear in
    the tree (if \code{random = FALSE}).}
  \item{equiprob}{a logical value: should topologies generated in equal
    probabilities; see details in \code{\link{rtree}} (ignored if
    \code{random = FALSE}).}
  \item{tol}{a numeric value giving the tolerance to consider a branch
    length significantly greater than zero.}
  \item{\dots}{arguments passed among methods.}
}
\details{
  \code{multi2di} transforms all multichotomies into a series of
  dichotomies with one (or several) branch(es) of length zero.

  \code{di2multi} deletes all branches smaller than \code{tol} and
  collapses the corresponding dichotomies into a multichotomy.
}
\seealso{\code{\link{is.binary}}}
\author{Emmanuel Paradis}
\value{
  an object of the same class than the input.
}
\examples{
data(bird.families)
is.binary(bird.families)
is.binary(multi2di(bird.families))
all.equal(di2multi(multi2di(bird.families)), bird.families)
### To see the results of randomly resolving a trichotomy:
tr <- read.tree(text = "(a:1,b:1,c:1);")
layout(matrix(1:4, 2, 2))
for (i in 1:4)
  plot(multi2di(tr), use.edge.length = FALSE, cex = 1.5)
layout(1)
}
\keyword{manip}

\name{weight.taxo}
\alias{weight.taxo}
\alias{weight.taxo2}
\title{Define Similarity Matrix}
\usage{
  weight.taxo(x)
  weight.taxo2(x, y)
}
\arguments{
  \item{x, y}{a vector or a factor.}
}
\description{
  \code{weight.taxo} computes a matrix whose entries [i, j] are set to 1
  if x[i] == x[j], 0 otherwise.

  \code{weight.taxo2} computes a matrix whose entries [i, j] are set to 1
  if x[i] == x[j] AND y[i] != y[j], 0 otherwise.

  The diagonal [i, i] is always set to 0.

  The returned matrix can be used as a weight matrix in
  \code{\link{Moran.I}}. \code{x} and \code{y} may be vectors of
  factors.

  See further details in \code{vignette("MoranI")}.
}
\value{
  a square numeric matrix.
}
\author{Emmanuel Paradis}
\seealso{
  \code{\link{Moran.I}}, \code{\link{correlogram.formula}}
}
\keyword{manip}

\name{corGrafen}
\alias{corGrafen}
\alias{coef.corGrafen}
\alias{corMatrix.corGrafen}
\title{Grafen's (1989) Correlation Structure}
\usage{
corGrafen(value, phy, form=~1, fixed = FALSE)
\method{coef}{corGrafen}(object, unconstrained = TRUE, ...)
\method{corMatrix}{corGrafen}(object,
                  covariate = getCovariate(object), corr = TRUE, ...)
}
\arguments{
  \item{value}{The \eqn{\rho}{rho} parameter}
  \item{phy}{An object of class \code{phylo} representing the phylogeny
    (branch lengths are ignored) to consider}
  \item{object}{An (initialized) object of class \code{corGrafen}}
  \item{corr}{a logical value. If 'TRUE' the function returns the
    correlation matrix, otherwise it returns the variance/covariance
    matrix.}
  \item{fixed}{an optional logical value indicating whether the
    coefficients should be allowed to vary in the optimization, or kept
    fixed at their initial value. Defaults to 'FALSE', in which case the
    coefficients are allowed to vary.}
  \item{form}{a one sided formula of the form ~ t, or ~ t | g, specifying the taxa covariate t and, optionally, a grouping factor g. A covariate for this correlation structure must be character valued, with entries matching the tip labels in the phylogenetic tree. When a grouping factor is present in form, the correlation structure is assumed to apply only to observations within the same grouping level; observations with different grouping levels are assumed to be uncorrelated. Defaults to ~ 1, which corresponds to using the order of the observations in the data as a covariate, and no groups.}
  \item{covariate}{an optional covariate vector (matrix), or list of covariate vectors (matrices), at which values the correlation matrix, or list of correlation matrices, are to be evaluated. Defaults to getCovariate(object).}
  \item{unconstrained}{a logical value. If 'TRUE' the coefficients are
    returned in unconstrained form (the same used in the optimization
    algorithm). If 'FALSE' the coefficients are returned in "natural",
    possibly constrained, form. Defaults to 'TRUE'}
  \item{\dots}{some methods for these generics require additional
    arguments. None are used in these methods.}
}
\description{
  Grafen's (1989) covariance structure. Branch lengths are computed using
  Grafen's method (see \code{\link{compute.brlen}}). The covariance
  matrice is then the traditional variance-covariance matrix for a
  phylogeny.
}
\value{
  An object of class \code{corGrafen} or the rho coefficient from an
  object of this class or the correlation matrix of an initialized
  object of this class.
}
\author{Julien Dutheil \email{dutheil@evolbio.mpg.de}}
\seealso{
  \code{\link{corClasses}}, \code{\link{compute.brlen}}, \code{\link{vcv.phylo}}.
}
\references{
  Grafen, A. (1989) The phylogenetic regression. \emph{Philosophical
    Transactions of the Royal society of London. Series B. Biological
    Sciences}, \bold{326}, 119--157.
}
\keyword{models}

\name{rotate}
\alias{rotate}
\alias{rotateConstr}
\title{Swapping Sister Clades}
\description{
  For a given node, \code{rotate} exchanges the position of two clades
  descending from this node. It can handle dichotomies as well as
  polytomies. In the latter case, two clades from the polytomy are
  selected for swapping.

  \code{rotateConstr} rotates internal branches giving a constraint on
  the order of the tips.
}
\usage{
rotate(phy, node, polytom = c(1, 2))
rotateConstr(phy, constraint)
}
\arguments{
  \item{phy}{an object of class \code{"phylo"}.}
  \item{node}{a vector of mode numeric or character specifying the
    number of the node.}
  \item{polytom}{a vector of mode numeric and length two specifying the
    two clades that should be exchanged in a polytomy.}
  \item{constraint}{a vector of mode character specifying the order of
    the tips as they should appear when plotting the tree (from bottom
    to top).}
}
\details{
  \code{phy} can be either rooted or unrooted, contain polytomies and lack
  branch lengths. In the presence of very short branch lengths it is
  convenient to plot the phylogenetic tree without branch lengths in order
  to identify the number of the node in question.

  \code{node} can be any of the interior nodes of a phylogenetic tree
  including the root node. Number of the nodes can be identified by the
  nodelabels function. Alternatively, you can specify a vector of length
  two that contains either the number or the names of two tips that
  coalesce in the node of interest.

  If the node subtends a polytomy, any two clades of the the polytomy
  can be chosen by polytom. On a plotted phylogeny, the clades are
  numbered from bottom to top and polytom is used to index the two
  clades one likes to swop.
}
\value{
  an object of class \code{"phylo"}.
}
\author{Christoph Heibl \email{heibl@lmu.de}, Emmanuel Paradis}
\seealso{
  \code{\link{plot.phylo}}, \code{\link{nodelabels}},
  \code{\link{root}}, \code{\link{drop.tip}}}
\examples{
# create a random tree:
tre <- rtree(25)

# visualize labels of internal nodes:
plot(tre, use.edge.length=FALSE)
nodelabels()

# rotate clades around node 30:
tre.new <- rotate(tre, 30)

# compare the results:
par(mfrow=c(1,2)) # split graphical device
plot(tre) # plot old tre
plot(tre.new) # plot new tree

# visualize labels of terminal nodes:
plot(tre)
tiplabels()

# rotate clades containing nodes 12 and 20:
tre.new <- rotate(tre, c(12, 21))

# compare the results:
par(mfrow=c(1,2)) # split graphical device
plot(tre) # plot old tre
plot(tre.new) # plot new tree

# or you migth just specify tiplabel names:
tre.new <- rotate(tre, c("t3", "t14"))

# compare the results:
par(mfrow=c(1,2)) # devide graphical device
plot(tre) # plot old tre
plot(tre.new) # plot new tree

# a simple example for rotateConstr:
A <- read.tree(text = "((A,B),(C,D));")
B <- read.tree(text = "(((D,C),B),A);")
B <- rotateConstr(B, A$tip.label)
plot(A); plot(B, d = "l")

# something more interesting (from ?cophyloplot):
tr1 <- rtree(40)
## drop 20 randomly chosen tips:
tr2 <- drop.tip(tr1, sample(tr1$tip.label, size = 20))
## rotate the root and reorder the whole:
tr2 <- rotate(tr2, 21)
tr2 <- read.tree(text = write.tree(tr2))
X <- cbind(tr2$tip.label, tr2$tip.label) # association matrix
cophyloplot(tr1, tr2, assoc = X, space = 28)
## before reordering tr2 we have to find the constraint:
co <- tr2$tip.label[order(match(tr2$tip.label, tr1$tip.label))]
newtr2 <- rotateConstr(tr2, co)
cophyloplot(tr1, newtr2, assoc = X, space = 28)
}
\keyword{manip}

\name{write.tree}
\alias{write.tree}
\title{Write Tree File in Parenthetic Format}
\usage{
write.tree(phy, file = "", append = FALSE,
           digits = 10, tree.names = FALSE)
}
\arguments{
  \item{phy}{an object of class \code{"phylo"} or \code{"multiPhylo"}.}
  \item{file}{a file name specified by either a variable of mode character,
    or a double-quoted string; if \code{file = ""} (the default) then the
    tree is written on the standard output connection (i.e. the console).}
  \item{append}{a logical, if \code{TRUE} the tree is appended to the file
    without erasing the data possibly existing in the file, otherwise
    the file (if it exists) is overwritten (\code{FALSE} the default).}
  \item{digits}{a numeric giving the number of digits used for printing
    branch lengths.}
  \item{tree.names}{either a logical or a vector of mode character. If
    \code{TRUE} then any tree names will be written prior to the tree on
    each line. If character, specifies the name of \code{"phylo"}
    objects which can be written to the file.}
}
\description{
  This function writes in a file a tree in parenthetic format using the
  Newick (also known as New Hampshire) format.
}
\value{
  a vector of mode character if \code{file = ""}, none (invisible
  \code{NULL}) otherwise.
}
\details{
  The node labels and the root edge length, if available, are written in
  the file.

  If \code{tree.names == TRUE} then a variant of the Newick format is
  written for which the name of a tree precedes the Newick format tree
  (parentheses are eventually deleted beforehand). The tree names are
  taken from the \code{names} attribute if present (they are ignored if
  \code{tree.names} is a character vector).

  The tip labels (and the node labels if present) are checked before
  being printed: the leading and trailing spaces, and the leading left
  and trailing right parentheses are deleted; the other spaces are
  replaced by underscores; the commas, colons, semicolons, and the other
  parentheses are replaced with dashes.
}
\references{
  Felsenstein, J. The Newick tree format.
  \url{http://evolution.genetics.washington.edu/phylip/newicktree.html}

  Olsen, G. Interpretation of the "Newick's 8:45" tree format standard.
  \url{http://evolution.genetics.washington.edu/phylip/newick_doc.html}
}

\author{Emmanuel Paradis, Daniel Lawson
  \email{dan.lawson@bristol.ac.uk}, and Klaus Schliep
  \email{kschliep@snv.jussieu.fr}}
\seealso{
  \code{\link{read.tree}}, \code{\link{read.nexus}},
  \code{\link{write.nexus}}
}
\keyword{manip}
\keyword{IO}

\name{delta.plot}
\alias{delta.plot}
\title{Delta Plots}
\usage{
delta.plot(X, k = 20, plot = TRUE, which = 1:2)
}
\arguments{
  \item{X}{a distance matrix, may be an object of class ``dist''.}
  \item{k}{an integer giving the number of intervals in the plot.}
  \item{plot}{a logical specifying whether to draw the
    \eqn{\delta}{delta} plot (the default).}
  \item{which}{a numeric vector indicating which plots are done; 1: the
    histogram of the \eqn{\delta_q}{delta_q} values, 2: the plot of the
    individual \eqn{\bar{\delta}}{delta.bar} values. By default, both
    plots are done.}
}
\description{
  This function makes a \eqn{\delta}{delta} plot following Holland et
  al. (2002).
}
\details{
  See Holland et al. (2002) for details and interpretation.

  The computing time of this function is proportional to the fourth
  power of the number of observations (\eqn{O(n^4)}), so calculations
  may be very long with only a slight increase in sample size.
}
\value{
  This function returns invisibly a named list with two components:

  \itemize{
    \item{counts}{the counts for the histogram of
    \eqn{\delta_q}{delta_q} values}
    \item{delta.bar}{the mean \eqn{\delta}{delta} value for each
    observation}
  }
}
\references{
  Holland, B. R., Huber, K. T., Dress, A. and Moulton, V. (2002) Delta
  plots: a tool for analyzing phylogenetic distance data.
  \emph{Molecular Biology and Evolution}, \bold{12}, 2051--2059.
}
\author{Emmanuel Paradis}
\seealso{
  \code{\link{dist.dna}}
}
\examples{
data(woodmouse)
d <- dist.dna(woodmouse)
delta.plot(d)
layout(1)
delta.plot(d, 40, which = 1)
}
\keyword{hplot}

\name{evonet}
\alias{evonet}
\alias{as.evonet}
\alias{as.evonet.phylo}
\alias{read.evonet}
\alias{write.evonet}
\alias{print.evonet}
\alias{plot.evonet}
\alias{reorder.evonet}
\alias{as.phylo.evonet}
\alias{as.networx.evonet}
\alias{as.network.evonet}
\alias{as.igraph.evonet}
\alias{Nedge.evonet}
\title{Evolutionary Networks}
\description{
  \code{evonet} builds a network from a tree of class
  \code{"phylo"}. There are \code{print}, \code{plot}, and
  \code{reorder} methods as well as a few conversion functions.
}
\usage{
evonet(phy, from, to = NULL)
\method{print}{evonet}(x, ...)
\method{plot}{evonet}(x, col = "blue", lty = 1, lwd = 1, alpha = 0.5,
              arrows = 0, arrow.type = "classical", ...)
\method{Nedge}{evonet}(phy)
\method{reorder}{evonet}(x, order = "cladewise", index.only = FALSE, ...)
\method{as.phylo}{evonet}(x, ...)
\method{as.networx}{evonet}(x, weight = NA, ...)
\method{as.network}{evonet}(x, directed = TRUE, ...)
\method{as.igraph}{evonet}(x, directed = TRUE, use.labels = TRUE, ...)

as.evonet(x, ...)
\method{as.evonet}{phylo}(x, ...)

read.evonet(file = "", text = NULL, comment.char = "", ...)
write.evonet(x, file = "", ...)
}
\arguments{
  \item{phy}{an object of class \code{"phylo"}.}
  \item{x}{an object of class \code{"evonet"}.}
  \item{from}{a vector (or a matrix if \code{to = NULL}) giving the node
    or tip numbers involved in the reticulations.}
  \item{to}{a vector of the same length than \code{from}.}
  \item{col, lty, lwd}{colors, line type and width of the reticulations
    (recycled if necessary).}
  \item{alpha}{a value between 0 and 1 specifying the transparency of
    the reticulations.}
  \item{arrows, arrow.type}{see \code{\link{fancyarrows}}.}
  \item{order, index.only}{see \code{\link{reorder.phylo}}.}
  \item{weight}{a numeric vector giving the weights for the
    reticulations when converting to the class \code{"networx"}
    (recycled or shortened if needed).}
  \item{directed}{a logical: should the network be considered as
    directed? \code{TRUE} by default.}
  \item{use.labels}{a logical specifying whether to use the tip and node
    labels when building the network of class \code{"igraph"}.}
  \item{file, text, comment.char}{see \code{\link{read.tree}}.}
  \item{\dots}{arguments passed to other methods.}
}
\details{
  \code{evonet} is a constructor function that checks the arguments.

  The classes \code{"networx"}, \code{"network"}, and \code{"igraph"}
  are defined in the packages \pkg{phangorn}, \pkg{network}, and
  \pkg{igraph}, respectively.

  \code{read.evonet} reads networks from files in extended newick format
  (Cardona et al. 2008).
}
\value{
  an object of class \code{c("evonet", "phylo")} which is made of an
  object of class \code{"\link{phylo}"} plus an element
  \code{reticulation} coding additional edges among nodes and uses the
  same coding rules than the \code{edge} matrix.

  The conversion functions return an object of the appropriate class.
}
\author{Emmanuel Paradis, Klaus Schliep}
\seealso{
  \code{\link[phangorn]{as.networx}} in package \pkg{phangorn}
}
\references{
  Cardona, G., Rossell, F., and Valiente, G. (2008) Extended Newick: it
  is time for a standard representation of phylogenetic
  networks. \emph{BMC Bioinformatics}, \bold{9}, 532.
}
\examples{
tr <- rcoal(5)
(x <- evonet(tr, 6:7, 8:9))
plot(x)
## simple example of extended Newick format:
(enet <- read.evonet(text = "((a:2,(b:1)#H1:1):1,(#H1,c:1):2);"))
plot(enet, arrows=1)
## from Fig. 2 in Cardona et al. 2008:
z <- read.evonet(text =
"((1,((2,(3,(4)Y#H1)g)e,(((Y#H1, 5)h,6)f)X#H2)c)a,((X#H2,7)d,8)b)r;")
z
plot(z)
\dontrun{
if (require(igraph)) {
    plot(as.igraph(z))
}}}
\keyword{manip}
\keyword{hplot}

\name{as.alignment}
\alias{as.alignment}
\alias{as.DNAbin}
\alias{as.DNAbin.character}
\alias{as.DNAbin.list}
\alias{as.DNAbin.alignment}
\alias{as.character.DNAbin}
\alias{as.DNAbin.DNAString}
\alias{as.DNAbin.DNAStringSet}
\alias{as.DNAbin.PairwiseAlignmentsSingleSubject}
\alias{as.DNAbin.DNAMultipleAlignment}
\title{Conversion Among DNA Sequence Internal Formats}
\description{
  These functions transform a set of DNA sequences among various
  internal formats.
}
\usage{
as.alignment(x)
as.DNAbin(x, ...)

\method{as.DNAbin}{character}(x, ...)

\method{as.DNAbin}{list}(x, ...)

\method{as.DNAbin}{alignment}(x, ...)

\method{as.DNAbin}{DNAString}(x, ...)

\method{as.DNAbin}{DNAStringSet}(x, ...)

\method{as.DNAbin}{PairwiseAlignmentsSingleSubject}(x, ...)

\method{as.DNAbin}{DNAMultipleAlignment}(x, ...)

\method{as.character}{DNAbin}(x, ...)
}
\arguments{
  \item{x}{a matrix or a list containing the DNA sequences, or an object
    of class \code{"alignment"}.}
  \item{\dots}{further arguments to be passed to or from other methods.}
}
\details{
  For \code{as.alignment}, the sequences given as argument should be
  stored as matrices or lists of single-character strings (the format
  used in \pkg{ape} before version 1.10). The returned object is in the
  format used in the package \pkg{seqinr} to store aligned sequences.

  \code{as.DNAbin} is a generic function with methods so that it works
  with sequences stored into vectors, matrices, or lists. It can convert
  some S4 classes from the package \pkg{Biostrings} in BioConductor. For
  consistency within \pkg{ape}, this uses an S3-style syntax. To convert
  objects of class \code{"DNAStringSetList"}, see the examples.

  \code{as.character} is a generic function: the present method
  converts objects of class \code{"DNAbin"} into the format used
  before \pkg{ape} 1.10 (matrix of single characters, or list of vectors
  of single characters). This function must be used first to convert
  objects of class \code{"DNAbin"} into the class \code{"alignment"}.
}
\value{
  an object of class \code{"alignment"} in the case of
  \code{"as.alignment"}; an object of class \code{"DNAbin"} in the case
  of \code{"as.DNAbin"}; a matrix of mode character or a list containing
  vectors of mode character in the case of \code{"as.character"}.
}
\author{Emmanuel Paradis}
\seealso{
  \code{\link{DNAbin}}, \code{\link{read.dna}},
  \code{\link{read.GenBank}}, \code{\link{write.dna}}
}
\examples{
data(woodmouse)
x <- as.character(woodmouse)
x[, 1:20]
str(as.alignment(x))
identical(as.DNAbin(x), woodmouse)
### conversion from BioConductor:
\dontrun{
if (require(Biostrings)) {
data(phiX174Phage)
X <- as.DNAbin(phiX174Phage)
## base frequencies:
base.freq(X) # from ape
alphabetFrequency(phiX174Phage) # from Biostrings
### for objects of class "DNAStringSetList"
X <- lapply(x, as.DNAbin) # a list of lists
### to put all sequences in a single list:
X <- unlist(X, recursive = FALSE)
class(X) <- "DNAbin"
}
}
}
\keyword{manip}

\name{consensus}
\alias{consensus}
\title{Concensus Trees}
\usage{
consensus(..., p = 1, check.labels = TRUE)
}
\arguments{
  \item{\dots}{either (i) a single object of class \code{"phylo"}, (ii) a
    series of such objects separated by commas, or (iii) a list
    containing such objects.}
  \item{p}{a numeric value between 0.5 and 1 giving the proportion for a
    clade to be represented in the consensus tree.}
  \item{check.labels}{a logical specifying whether to check the labels
    of each tree. If \code{FALSE} (the default), it is assumed that all
    trees have the same tip labels, and that they are in the same order
    (see details).}
}
\description{
  Given a series of trees, this function returns the consensus tree. By
  default, the strict-consensus tree is computed. To get the
  majority-rule consensus tree, use \code{p = 0.5}. Any value between
  0.5 and 1 can be used.
}
\details{
  Using \code{check.labels = FALSE} results in
  considerable decrease in computing times. This requires that all
  trees have the same tip labels, \emph{and} these labels are
  ordered similarly in all trees (in other words, the element
  \code{tip.label} are identical in all trees).
}
\value{
  an object of class \code{"phylo"}.
}
\references{
  Felsenstein, J. (2004) \emph{Inferring Phylogenies}. Sunderland:
  Sinauer Associates.
}
\author{Emmanuel Paradis}
\seealso{
  \code{\link{prop.part}}, \code{\link{dist.topo}}
}
\keyword{manip}

\name{print.phylo}
\alias{print.phylo}
\alias{print.multiPhylo}
\alias{str.multiPhylo}
\title{Compact Display of a Phylogeny}
\usage{
\method{print}{phylo}(x, printlen = 6 ,...)
\method{print}{multiPhylo}(x, details = FALSE ,...)
\method{str}{multiPhylo}(object, ...)
}
\arguments{
  \item{x}{an object of class \code{"phylo"} or \code{"multiPhylo"}.}
  \item{object}{an object of class \code{"multiPhylo"}.}
  \item{printlen}{the number of labels to print (6 by default).}
  \item{details}{a logical indicating whether to print information on
    all trees.}
  \item{\dots}{further arguments passed to or from other methods.}
}
\description{
  These functions prints a compact summary of a phylogeny, or a list of
  phylogenies, on the console.
}
\value{
  NULL.
}
\author{Ben Bolker and Emmanuel Paradis}
\seealso{
  \code{\link{read.tree}}, \code{\link{summary.phylo}},
  \code{\link[base]{print}} for the generic \R function
}
\examples{
x <- rtree(10)
print(x)
print(x, printlen = 10)
x <- rmtree(2, 10)
print(x)
print(x, TRUE)
str(x)
}
\keyword{manip}

\encoding{utf8}
\name{all.equal.phylo}
\alias{all.equal.phylo}
\title{Global Comparison of two Phylogenies}
\usage{
\method{all.equal}{phylo}(target, current, use.edge.length = TRUE,
                   use.tip.label = TRUE, index.return = FALSE,
                   tolerance = .Machine$double.eps ^ 0.5,
                   scale = NULL, \dots)
}
\arguments{
  \item{target}{an object of class \code{"phylo"}.}
  \item{current}{an object of class \code{"phylo"}.}
  \item{use.edge.length}{if \code{FALSE} only the topologies are
    compared; the default is \code{TRUE}.}
  \item{use.tip.label}{if \code{FALSE} the unlabelled trees are
    compared; the default is \code{TRUE}.}
  \item{index.return}{if \code{TRUE} the function returns a two-column
    matrix giving the correspondence between the nodes of both trees.}
  \item{tolerance}{the numeric tolerance used to compare the branch
    lengths.}
  \item{scale}{a positive number, comparison of branch lengths is made
    after scaling (i.e., dividing) them by this number.}
  \item{\dots}{further arguments passed to or from other methods.}
}
\description{
  This function makes a global comparison of two phylogenetic trees.
}
\details{
  This function is meant to be an adaptation of the generic function
  \code{all.equal} for the comparison of phylogenetic trees.

  A single phylogenetic tree may have several representations in the Newick
  format and in the \code{"phylo"} class of objects used in `ape'. One
  aim of the present function is to be able to identify whether two
  objects of class \code{"phylo"} represent the same phylogeny.
}
\note{
  The algorithm used here does not work correctly for the comparison of
  topologies (i.e., ignoring tip labels) of unrooted trees. This also
  affects \code{\link{unique.multiPhylo}} which calls the present function. See:

  \url{https://www.mail-archive.com/r-sig-phylo@r-project.org/msg01445.html}.
}
\value{
  A logical value, or a two-column matrix.
}
\author{\enc{Benoît}{Benoit} Durand \email{b.durand@alfort.AFSSA.FR}}
\seealso{
  \code{\link[base]{all.equal}} for the generic \R function, \code{\link{comparePhylo}}
}
\examples{
### maybe the simplest example of two representations
### for the same rooted tree...:
t1 <- read.tree(text = "(a:1,b:1);")
t2 <- read.tree(text = "(b:1,a:1);")
all.equal(t1, t2)
### ... compare with this:
identical(t1, t2)
### one just slightly more complicated...:
t3 <- read.tree(text = "((a:1,b:1):1,c:2);")
t4 <- read.tree(text = "(c:2,(a:1,b:1):1);")
all.equal(t3, t4) # == all.equal.phylo(t3, t4)
### ... here we force the comparison as lists:
all.equal.list(t3, t4)
}
\keyword{manip}

\name{matexpo}
\alias{matexpo}
\title{Matrix Exponential}
\usage{
matexpo(x)
}
\arguments{
  \item{x}{a square matrix of mode numeric.}
}
\description{
  This function computes the exponential of a square matrix using a
  spectral decomposition.
}
\value{
  a numeric matrix of the same dimensions than `x'.
}
\author{Emmanuel Paradis}
\examples{
### a simple rate matrix:
m <- matrix(0.1, 4, 4)
diag(m) <- -0.3
### towards equilibrium:
for (t in c(1, 5, 10, 50)) print(matexpo(m*t))
}
\keyword{array}
\keyword{multivariate}

\name{SDM}
\alias{SDM}
\title{Construction of Consensus Distance Matrix With SDM}
\description{
  This function implements the SDM method of Criscuolo et al. (2006) for
  a set of n distance matrices.
}
\usage{
SDM(...)
}
\arguments{
  \item{\dots}{2n elements (with n > 1), the first n elements are the
    distance matrices: these can be (symmetric) matrices, objects of
    class \code{"dist"}, or a mix of both. The next n elements are the
    sequence length from which the matrices have been estimated (can be
    seen as a degree of confidence in matrices).}
}
\details{
  Reconstructs a consensus distance matrix from a set of input distance
  matrices on overlapping sets of taxa. Potentially missing values in
  the supermatrix are represented by \code{NA}. An error is returned if
  the input distance matrices can not resolve to a consensus matrix.
}
\value{
  a 2-element list containing a distance matrix labelled by the union of
  the set of taxa of the input distance matrices, and a variance matrix
  associated to the returned distance matrix.
}
\references{
  Criscuolo, A., Berry, V., Douzery, E. J. P. , and Gascuel, O. (2006)
  SDM: A fast distance-based approach for (super)tree building in
  phylogenomics. \emph{Systematic Biology}, \bold{55}, 740--755.
}
\author{Andrei Popescu}
\seealso{
  \code{\link{bionj}}, \code{\link{fastme}}, \code{\link{njs}},
  \code{\link{mvrs}}, \code{\link{triangMtd}}
}
\keyword{models}

\name{treePop}
\alias{treePop}
\title{Tree Popping}
\description{
  Method for reconstructing phylogenetic trees from an object of class
  splits using tree popping.
}
\usage{
treePop(obj)
}
\arguments{
  \item{obj}{an object of class \code{"bitsplit"}.}
}
\value{
  an object of class "phylo" which displays all the splits
  in the input object.
}
\author{Andrei Popescu}
\keyword{models}

\name{rlineage}
\alias{rlineage}
\alias{rbdtree}
\alias{rphylo}
\alias{drop.fossil}
\title{Tree Simulation Under the Time-Dependent Birth--Death Models}
\description{
  These three functions simulate phylogenies under any time-dependent
  birth--death model: \code{rlineage} generates a complete tree including
  the species going extinct before present; \code{rbdtree} generates a
  tree with only the species living at present (thus the tree is
  ultrametric); \code{rphylo} generates a tree with a fixed number of
  species at present time. \code{drop.fossil} is a utility function to
  remove the extinct species.
}
\usage{
rlineage(birth, death, Tmax = 50, BIRTH = NULL,
         DEATH = NULL, eps = 1e-6)
rbdtree(birth, death, Tmax = 50, BIRTH = NULL,
        DEATH = NULL, eps = 1e-6)
rphylo(n, birth, death, BIRTH = NULL, DEATH = NULL,
       T0 = 50, fossils = FALSE, eps = 1e-06)
drop.fossil(phy, tol = 1e-8)
}
\arguments{
  \item{birth, death}{a numeric value or a (vectorized) function
    specifying how speciation and extinction rates vary through time.}
  \item{Tmax}{a numeric value giving the length of the simulation.}
  \item{BIRTH, DEATH}{a (vectorized) function which is the primitive
    of \code{birth} or \code{death}. This can be used to speed-up the
    computation. By default, a numerical integration is done.}
  \item{eps}{a numeric value giving the time resolution of the
    simulation; this may be increased (e.g., 0.001) to shorten
    computation times.}
  \item{n}{the number of species living at present time.}
  \item{T0}{the time at present (for the backward-in-time algorithm).}
  \item{fossils}{a logical value specifying whether to output the
    lineages going extinct.}
  \item{phy}{an object of class \code{"phylo"}.}
  \item{tol}{a numeric value giving the tolerance to consider a species
    as extinct.}
}
\details{
  These three functions use continuous-time algorithms: \code{rlineage}
  and \code{rbdtree} use the forward-in-time algorithms described in
  Paradis (2011), whereas \code{rphylo} uses a backward-in-time
  algorithm from Stadler (2011). The models are time-dependent
  birth--death models as  described in Kendall (1948). Speciation
  (birth) and extinction (death) rates may be constant or vary through
  time according to an \R function specified by the user. In the latter
  case, \code{BIRTH} and/or \code{DEATH} may be used if the primitives
  of \code{birth} and \code{death} are known. In these functions time is
  the formal argument and must be named \code{t}.

  Note that \code{rphylo} simulates trees in a way similar to what
  the package \pkg{TreeSim} does, the difference is in the
  parameterization of the time-dependent models which is here the same
  than used in the two other functions. In this parameterization scheme,
  time is measured from past to present (see details in Paradis 2015
  which includes a comparison of these algorithms).

  The difference between \code{rphylo} and \code{rphylo(... fossils
    = TRUE)} is the same than between \code{rbdtree} and \code{rlineage}.
}
\value{
  An object of class \code{"phylo"}.
}
\references{
  Kendall, D. G. (1948) On the generalized ``birth-and-death''
  process. \emph{Annals of Mathematical Statistics}, \bold{19}, 1--15.

  Paradis, E. (2011) Time-dependent speciation and extinction from
  phylogenies: a least squares approach. \emph{Evolution}, \bold{65},
  661--672.

  Paradis, E. (2015) Random phylogenies and the distribution of
  branching times. \emph{Journal of Theoretical Biology}, \bold{387},
  39--45.

  Stadler, T. (2011) Simulating trees with a fixed number of extant
  species. \emph{Systematic Biology}, \bold{60}, 676--684.
}
\author{Emmanuel Paradis}
\seealso{
  \code{\link{yule}}, \code{\link{yule.time}}, \code{\link{birthdeath}},
  \code{\link{rtree}}, \code{\link{stree}}
}
\examples{
set.seed(10)
plot(rlineage(0.1, 0)) # Yule process with lambda = 0.1
plot(rlineage(0.1, 0.05)) # simple birth-death process
b <- function(t) 1/(1 + exp(0.2*t - 1)) # logistic
layout(matrix(0:3, 2, byrow = TRUE))
curve(b, 0, 50, xlab = "Time", ylab = "")
mu <- 0.07
segments(0, mu, 50, mu, lty = 2)
legend("topright", c(expression(lambda), expression(mu)),
       lty = 1:2, bty = "n")
plot(rlineage(b, mu), show.tip.label = FALSE)
title("Simulated with 'rlineage'")
plot(rbdtree(b, mu), show.tip.label = FALSE)
title("Simulated with 'rbdtree'")
}
\keyword{datagen}

\name{collapsed.intervals}
\alias{collapsed.intervals}
\title{Collapsed Coalescent Intervals}
\usage{
collapsed.intervals(ci, epsilon=0)
}
\arguments{
  \item{ci}{coalescent intervals (i.e. an object of class \code{"coalescentIntervals"}).}
  \item{epsilon}{collapsing parameter that controls the amount of smoothing
  (allowed range: from \code{0} to \code{ci$total.depth})}
}
\description{
 This function takes a \code{"coalescentIntervals"} objects and collapses neighbouring
 coalescent intervals into a single combined interval so that every collapsed interval is
 larger than \code{epsilon}. Collapsed coalescent intervals are used, e.g., to obtain the
 generalized skyline plot (\code{\link{skyline}}). For \code{epsilon = 0} no interval
 is collapsed.
}
\details{
Proceeding from the tips to the root of the tree each small
interval is pooled with the neighboring interval closer to the root. If the
neighboring interval is also small, then pooling continues until the composite
interval is larger than \code{epsilon}. Note that this approach prevents the
occurrence of zero-length intervals at the present.
For more details see Strimmer and Pybus (2001).
}
\value{
An object of class \code{"collapsedIntervals"} with the following entries:

  \item{lineages}{ A vector with the number of lineages at the start of each coalescent
    interval.}
  \item{interval.length}{ A vector with the length of each coalescent
    interval.}
   \item{collapsed.interval}{A vector indicating for each coalescent interval to which
     collapsed interval it belongs.}
  \item{interval.count}{ The total number of coalescent
    intervals.}
   \item{collapsed.interval.count}{The number of collapsed intervals.}
  \item{total.depth}{ The sum of the lengths of all coalescent
    intervals.}
  \item{epsilon}{The value of the underlying smoothing parameter.}
}
\author{Korbinian Strimmer}
\seealso{
\code{\link{coalescent.intervals}},\code{\link{skyline}}.
}
\references{
  Strimmer, K. and Pybus, O. G. (2001) Exploring the demographic history
  of DNA sequences using the generalized skyline plot. \emph{Molecular
    Biology and Evolution}, \bold{18}, 2298--2305.
}
\examples{
data("hivtree.table") # example tree
# colescent intervals from vector of interval lengths
ci <- coalescent.intervals(hivtree.table$size)
ci
# collapsed intervals
cl1 <- collapsed.intervals(ci,0)
cl2 <- collapsed.intervals(ci,0.0119)
cl1
cl2
}
\keyword{manip}

\name{AAbin}
\alias{AAbin}
\alias{print.AAbin}
\alias{[.AAbin}
\alias{as.character.AAbin}
\alias{labels.AAbin}
\alias{image.AAbin}
\alias{as.AAbin}
\alias{as.AAbin.AAString}
\alias{as.AAbin.AAStringSet}
\alias{as.AAbin.AAMultipleAlignment}
\alias{as.AAbin.character}
\alias{as.phyDat.AAbin}
\alias{dist.aa}
\alias{AAsubst}
\alias{c.AAbin}
\alias{cbind.AAbin}
\alias{rbind.AAbin}
\alias{as.AAbin.list}
\alias{as.list.AAbin}
\alias{as.matrix.AAbin}
\title{Amino Acid Sequences}
\description{
  These functions help to create and manipulate AA sequences.
}
\usage{
\method{print}{AAbin}(x, \dots)

\method{[}{AAbin}(x, i, j, drop = FALSE)

\method{c}{AAbin}(..., recursive = FALSE)

\method{rbind}{AAbin}(\dots)
\method{cbind}{AAbin}(\dots, check.names = TRUE, fill.with.Xs = FALSE,
             quiet = FALSE)

\method{as.character}{AAbin}(x, \dots)

\method{labels}{AAbin}(object, \dots)

\method{image}{AAbin}(x, what, col, bg = "white", xlab = "", ylab = "",
      show.labels = TRUE, cex.lab = 1, legend = TRUE, grid = FALSE,
      show.aa = FALSE, aa.cex = 1, aa.font = 1, aa.col = "black",\dots)

as.AAbin(x, \dots)
\method{as.AAbin}{character}(x, \dots)

\method{as.AAbin}{list}(x, ...)

\method{as.AAbin}{AAString}(x, ...)

\method{as.AAbin}{AAStringSet}(x, ...)

\method{as.AAbin}{AAMultipleAlignment}(x, ...)

\method{as.list}{AAbin}(x, ...)

\method{as.matrix}{AAbin}(x, ...)

\method{as.phyDat}{AAbin}(x, \dots)

dist.aa(x, pairwise.deletion = FALSE, scaled = FALSE)
AAsubst(x)
}
\arguments{
\item{x, object}{an object of class \code{"AAbin"} (or else depending on
the function).}
\item{i, j}{indices of the rows and/or columns to select or to
drop. They may be numeric, logical, or character (in the same way than
for standard \R objects).}
\item{drop}{logical; if \code{TRUE}, the returned object is of the
lowest possible dimension.}
\item{recursive}{logical; whether to go down lists and concatenate its
elements.}
  \item{check.names}{a logical specifying whether to check the rownames
    before binding the columns (see details).}
  \item{fill.with.Xs}{a logical indicating whether to keep all
    possible individuals as indicating by the rownames, and eventually
    filling the missing data with insertion gaps (ignored if
    \code{check.names = FALSE}).}
  \item{quiet}{a logical to switch off warning messages when some rows
    are dropped.}
\item{what}{a vector of characters specifying the amino acids to
visualize. Currently, the only possible choice is to show the three
categories hydrophobic, small, and hydrophilic.}
\item{col}{a vector of colours. If missing, this is set to ``red'',
``yellow'' and ``blue''.}
\item{bg}{the colour used for AA codes not among \code{what} (typically
X and *).}
\item{xlab}{the label for the \emph{x}-axis; none by default.}
\item{ylab}{Idem for the \emph{y}-axis. Note that by default, the labels
of the sequences are printed on the \emph{y}-axis (see next option).}
\item{show.labels}{a logical controlling whether the sequence labels are
printed (\code{TRUE} by default).}
\item{cex.lab}{a single numeric controlling the size of the sequence
labels. Use \code{cex.axis} to control the size of the annotations on
the \emph{x}-axis.}
\item{legend}{a logical controlling whether the legend is plotted
(\code{TRUE} by default).}
\item{grid}{a logical controlling whether to draw a grid (\code{FALSE} by
default).}
\item{show.aa}{a logical controlling whether to show the AA symbols (\code{FALSE} by
default).}
\item{aa.cex, aa.font, aa.col}{control the aspect of the AA symbols
(ignored if the previous is \code{FALSE}).}
\item{pairwise.deletion}{a logical indicating whether to delete the
sites with missing data in a pairwise way. The default is to delete the
sites with at least one missing data for all sequences.}
\item{scaled}{a logical value specifying whether to scale the number of
AA differences by the sequence length.}
\item{\dots}{further arguments to be passed to or from other methods.}
}
\details{
These functions help to manipulate amino acid sequences of class
\code{"AAbin"}. These objects are stored in vectors, matrices, or lists
which can be manipulated with the usual \code{[} operator.

There is a conversion function to and from characters.

The function \code{dist.aa} computes the number of AA differences
between each pair of sequences in a matrix; this can be scaled by the
sequence length. See the function \code{\link[phangorn]{dist.ml}} in
\pkg{phangorn} for evolutionary distances with AA sequences.

The function \code{AAsubst} returns the indices of the polymorphic sites
(similar to \code{\link{seg.sites}} for DNA sequences; see examples below).

The two functions \code{cbind.AAbin} and \code{rbind.AAbin} work in the
same way than the similar methods for the class \code{"DNAbin"}: see
\code{\link{cbind.DNAbin}} for more explanations about their respective
behaviours.
}
\value{
an object of class \code{"AAbin"}, \code{"character"},
\code{"dist"}, or \code{"numeric"}, depending on the function.
}
\author{Emmanuel Paradis, Franz Krah}
\seealso{
\code{\link{read.FASTA}}, \code{\link{trans}}, \code{\link{alview}}
}
\examples{
data(woodmouse)
AA <- trans(woodmouse, 2)
seg.sites(woodmouse)
AAsubst(AA)
}
\keyword{manip}

\name{base.freq}
\alias{base.freq}
\alias{GC.content}
\alias{Ftab}
\title{Base frequencies from DNA Sequences}
\description{
  \code{base.freq} computes the frequencies (absolute or relative) of
  the four DNA bases (adenine, cytosine, guanine, and thymidine) from a
  sample of sequences.

  \code{GC.content} computes the proportion of G+C (using the previous
  function). All missing or unknown sites are ignored.

  \code{Ftab} computes the contingency table with the absolute
  frequencies of the DNA bases from a pair of sequences.
}
\usage{
base.freq(x, freq = FALSE, all = FALSE)
GC.content(x)
Ftab(x, y = NULL)
}
\arguments{
  \item{x}{a vector, a matrix, or a list which contains the DNA
    sequences.}
  \item{y}{a vector with a single DNA sequence.}
  \item{freq}{a logical specifying whether to return the proportions
    (the default) or the absolute frequencies (counts).}
  \item{all}{a logical; by default only the counts of A, C, G, and T are
    returned. If \code{all = TRUE}, all counts of bases, ambiguous codes,
    missing data, and alignment gaps are returned.}
}
\details{
  The base frequencies are computed over all sequences in the
  sample.

  For \code{Ftab}, if the argument \code{y} is given then both \code{x}
  and \code{y} are coerced as vectors and must be of equal length. If
  \code{y} is not given, \code{x} must be a matrix or a list and only
  the two first sequences are used.
}
\value{
  A numeric vector with names \code{c("a", "c", "g", "t")} (and possibly
  \code{"r", "m", ...}, a single numeric value, or a four by four matrix
  with similar dimnames.
}
\author{Emmanuel Paradis}
\seealso{
  \code{\link{seg.sites}}, \code{\link[pegas]{nuc.div}},
  \code{\link{DNAbin}}
}
\examples{
data(woodmouse)
base.freq(woodmouse)
base.freq(woodmouse, TRUE)
base.freq(woodmouse, TRUE, TRUE)
GC.content(woodmouse)
Ftab(woodmouse)
Ftab(woodmouse[1, ], woodmouse[2, ]) # same than above
Ftab(woodmouse[14:15, ]) # between the last two
}
\keyword{univar}
\keyword{manip}

\name{plot.phylo.extra}
\alias{plot.phylo.extra}
\alias{plotBreakLongEdges}
\alias{drawSupportOnEdges}
\title{Extra Fuctions to Plot and Annotate Phylogenies}
\description{
  These are extra functions to plot and annotate phylogenies, mostly
  calling basic graphical functions in \pkg{ape}.
}
\usage{
plotBreakLongEdges(phy, n = 1, ...)
drawSupportOnEdges(value, ...)
}
\arguments{
  \item{phy}{an object of class \code{"phylo"}.}
  \item{n}{the numner of long branches to be broken.}
  \item{value}{the values to be printed on the internal branches of the tree.}
  \item{\dots}{further arguments to be passed to \code{plot.phylo} or to
    \code{edgelabels}.}
}
\details{
  \code{drawSupportOnEdges} assumes the tree is unrooted, so the vector
  \code{value} should have as many values than the number of internal
  branches (= number of nodes - 1). If there is one additional value, it
  is assumed that it relates to the root node and is dropped (see examples).
}
\value{NULL}
\author{Emmanuel Paradis}
\seealso{
  \code{\link{plot.phylo}}, \code{\link{edgelabels}},
  \code{\link{boot.phylo}}, \code{\link{plotTreeTime}}
}
\examples{
tr <- rtree(10)
tr$edge.length[c(1, 18)] <- 100
op <- par(mfcol = 1:2)
plot(tr); axisPhylo()
plotBreakLongEdges(tr, 2); axisPhylo()

## from ?boot.phylo:
f <- function(x) nj(dist.dna(x))
data(woodmouse)
tw <- f(woodmouse) # NJ tree with K80 distance
set.seed(1)
## bootstrap with 100 replications:
(bp <- boot.phylo(tw, woodmouse, f, quiet = TRUE))
## the first value relates to the root node and is always 100
## it is ignored below:
plot(tw, "u")
drawSupportOnEdges(bp)
## more readable but the tree is really unrooted:
plot(tw)
drawSupportOnEdges(bp)
par(op)
}
\keyword{hplot}

\name{all.equal.DNAbin}
\alias{all.equal.DNAbin}
\title{Compare DNA Sets}
\description{
  Comparison of DNA sequence sets, particularly when aligned.
}
\usage{
\method{all.equal}{DNAbin}(target, current, plot = FALSE, ...)
}
\arguments{
  \item{target, current}{the two sets of sequences to be compared.}
  \item{plot}{a logical value specifying whether to plot the sites that
    are different (only if the labels of both alignments are the same).}
  \item{\dots}{further arguments passed to \code{\link{image.DNAbin}}.}
}
\details{
  If the two sets of DNA sequences are exactly identical, this function
  returns \code{TRUE}. Otherwise, a detailed comparison is made only if
  the labels (i.e., rownames) of \code{target} and \code{current} are the
  same (possibly in different orders). In all other cases, a brief
  description of the differences is returned (sometimes with
  recommendations to make further comparisons).

  This function can be used for testing in programs using
  \code{\link[base]{isTRUE}} (see examples below).
}
\value{
  \code{TRUE} if the two sets are identical; a list with two elements
  (message and different.sites) if a detailed comparison is done; or a
  vector of mode character.
}
\author{Emmanuel Paradis}
\seealso{
  \code{\link{image.DNAbin}}, \code{\link{clustal}},
  \code{\link{checkAlignment}},
  the generic function: \code{\link[base]{all.equal}}
}
\examples{
data(woodmouse)
woodm2 <- woodmouse
woodm2[1, c(1:5, 10:12, 30:40)] <- as.DNAbin("g")
res <- all.equal(woodmouse, woodm2, plot = TRUE)
str(res)

## if used for testing in R programs:
isTRUE(all.equal(woodmouse, woodmouse)) # TRUE
isTRUE(all.equal(woodmouse, woodm2)) # FALSE

all.equal(woodmouse, woodmouse[15:1, ])
all.equal(woodmouse, woodmouse[-1, ])
all.equal(woodmouse, woodmouse[, -1])

\dontrun{
## To run the followings you need internet and Clustal and MUSCLE
## correctly installed.
## Data from Johnson et al. (2006, Science)
refs <- paste("DQ082", 505:545, sep = "")
DNA <- read.GenBank(refs)
DNA.clustal <- clustal(DNA)
DNA.muscle <- muscle(DNA)
isTRUE(all.equal(DNA.clustal, DNA.muscle)) # FALSE
all.equal(DNA.clustal, DNA.muscle, TRUE)
}
}
\keyword{manip}

\name{corBlomberg}
\alias{corBlomberg}
\alias{coef.corBlomberg}
\alias{corMatrix.corBlomberg}
\title{Blomberg et al.'s Correlation Structure}
\usage{
corBlomberg(value, phy, form = ~1, fixed = FALSE)
\method{corMatrix}{corBlomberg}(object, covariate = getCovariate(object),
                   corr = TRUE, ...)
\method{coef}{corBlomberg}(object, unconstrained = TRUE, \dots)
}
\arguments{
  \item{value}{the (initial) value of the parameter \eqn{g}{g}.}
  \item{phy}{an object of class \code{"phylo"}.}
  \item{form}{a one sided formula of the form ~ t, or ~ t | g,
    specifying the taxa covariate t and, optionally, a grouping factor
    g. A covariate for this correlation structure must be character
    valued, with entries matching the tip labels in the phylogenetic
    tree. When a grouping factor is present in form, the correlation
    structure is assumed to apply only to observations within the same
    grouping level; observations with different grouping levels are
    assumed to be uncorrelated. Defaults to ~ 1, which corresponds to
    using the order of the observations in the data as a covariate, and
    no groups.}
  \item{fixed}{a logical specifying whether \code{gls} should
    estimate \eqn{\gamma}{gamma} (the default) or keep it fixed.}
  \item{object}{an (initialized) object of class \code{"corBlomberg"}.}
  \item{covariate}{an optional covariate vector (matrix), or list of
    covariate vectors (matrices), at which values the correlation
    matrix, or list of correlation matrices, are to be
    evaluated. Defaults to getCovariate(object).}
  \item{corr}{a logical value specifying whether to return the
    correlation matrix (the default) or the variance-covariance matrix.}
  \item{unconstrained}{a logical value. If \code{TRUE} (the default),
    the coefficients are returned in unconstrained form (the same used
    in the optimization algorithm). If \code{FALSE} the coefficients are
    returned in ``natural'', possibly constrained, form.}
  \item{\dots}{further arguments passed to or from other methods.}
}
\description{
  The ``ACDC'' (accelerated/decelerated) model assumes that continuous
  traits evolve under a Brownian motion model which rates accelerates
  (if \eqn{g}{g} < 1) or decelerates (if \eqn{g}{g} > 1) through
  time. If \eqn{g}{g} = 1, then the model reduces to a Brownian motion
  model.
}
\value{
  an object of class \code{"corBlomberg"}, the coefficients from an
  object of this class, or the correlation matrix of an initialized
  object of this class. In most situations, only \code{corBlomberg} will
  be called by the user.
}
\author{Emmanuel Paradis}
\references{
  Blomberg, S. P., Garland, Jr, T., and Ives, A. R. (2003) Testing for
  phylogenetic signal in comparative data: behavioral traits are more
  labile. \emph{Evolution}, \bold{57}, 717--745.
}
\keyword{models}

\name{rTraitCont}
\alias{rTraitCont}
\title{Continuous Character Simulation}
\usage{
rTraitCont(phy, model = "BM", sigma = 0.1, alpha = 1, theta = 0,
           ancestor = FALSE, root.value = 0, ...)
}
\arguments{
  \item{phy}{an object of class \code{"phylo"}.}
  \item{model}{a character (either \code{"BM"} or \code{"OU"}) or a
    function specifying the model (see details).}
  \item{sigma}{a numeric vector giving the standard-deviation of the
    random component for each branch (can be a single value).}
  \item{alpha}{if \code{model = "OU"}, a numeric vector giving the
    strength of the selective constraint for each branch (can be a
    single value).}
  \item{theta}{if \code{model = "OU"}, a numeric vector giving the
    optimum for each branch (can be a single value).}
  \item{ancestor}{a logical value specifying whether to return the
    values at the nodes as well (by default, only the values at the tips
    are returned).}
  \item{root.value}{a numeric giving the value at the root.}
  \item{\dots}{further arguments passed to \code{model} if it is a
    function.}
}
\description{
  This function simulates the evolution of a continuous character along a
  phylogeny. The calculation is done recursively from the root. See
  Paradis (2012, pp. 232 and 324) for an introduction.
}
\details{
  There are three possibilities to specify \code{model}:

\itemize{
  \item{\code{"BM"}:}{a Browian motion model is used. If the arguments
  \code{sigma} has more than one value, its length must be equal to the
  the branches of the tree. This allows to specify a model with variable
  rates of evolution. You must be careful that branch numbering is done
  with the tree in ``postorder'' order: to see the order of the branches
  you can use: \code{tr <- reorder(tr, "po"); plor(tr); edgelabels()}.
  The arguments \code{alpha} and \code{theta} are ignored.}

  \item{\code{"OU"}:}{an Ornstein-Uhlenbeck model is used. The above
  indexing rule is used for the three parameters \code{sigma},
  \code{alpha}, and \code{theta}. This may be interesting for the last
  one to model varying phenotypic optima. The exact updating formula
  from Gillespie (1996) are used which are reduced to BM formula if
  \code{alpha = 0}.}

  \item{A function:}{it must be of the form \code{foo(x, l)} where
  \code{x} is the trait of the ancestor and \code{l} is the branch
  length. It must return the value of the descendant. The arguments
  \code{sigma}, \code{alpha}, and \code{theta} are ignored.}
}}
\value{
  A numeric vector with names taken from the tip labels of
  \code{phy}. If \code{ancestor = TRUE}, the node labels are used if
  present, otherwise, ``Node1'', ``Node2'', etc.
}
\references{
  Gillespie, D. T. (1996) Exact numerical simulation of the
  Ornstein-Uhlenbeck process and its integral. \emph{Physical Review E},
  \bold{54}, 2084--2091.

  Paradis, E. (2012) \emph{Analysis of Phylogenetics and Evolution with
    R (Second Edition).} New York: Springer.
}
\author{Emmanuel Paradis}
\seealso{
  \code{\link{rTraitDisc}}, \code{\link{rTraitMult}}, \code{\link{ace}}
}
\examples{
data(bird.orders)
rTraitCont(bird.orders) # BM with sigma = 0.1
### OU model with two optima:
tr <- reorder(bird.orders, "postorder")
plot(tr)
edgelabels()
theta <- rep(0, Nedge(tr))
theta[c(1:4, 15:16, 23:24)] <- 2
## sensitive to 'alpha' and 'sigma':
rTraitCont(tr, "OU", theta = theta, alpha=.1, sigma=.01)
### an imaginary model with stasis 0.5 time unit after a node, then
### BM evolution with sigma = 0.1:
foo <- function(x, l) {
    if (l <= 0.5) return(x)
    x + (l - 0.5)*rnorm(1, 0, 0.1)
}
tr <- rcoal(20, br = runif)
rTraitCont(tr, foo, ancestor = TRUE)
### a cumulative Poisson process:
bar <- function(x, l) x + rpois(1, l)
(x <- rTraitCont(tr, bar, ancestor = TRUE))
plot(tr, show.tip.label = FALSE)
Y <- x[1:20]
A <- x[-(1:20)]
nodelabels(A)
tiplabels(Y)
}
\keyword{datagen}

\name{nodelabels}
\alias{nodelabels}
\alias{tiplabels}
\alias{edgelabels}
\title{Labelling the Nodes, Tips, and Edges of a Tree}
\description{
  These functions add labels to or near the nodes, the tips, or the
  edges of a tree using text or plotting symbols. The text can be
  framed.
}
\usage{
nodelabels(text, node, adj = c(0.5, 0.5), frame = "rect",
           pch = NULL, thermo = NULL, pie = NULL, piecol = NULL,
           col = "black", bg = "lightblue", horiz = FALSE,
           width = NULL, height = NULL, ...)
tiplabels(text, tip, adj = c(0.5, 0.5), frame = "rect",
          pch = NULL, thermo = NULL, pie = NULL, piecol = NULL,
          col = "black", bg = "yellow", horiz = FALSE,
          width = NULL, height = NULL, offset = 0, ...)
edgelabels(text, edge, adj = c(0.5, 0.5), frame = "rect",
           pch = NULL, thermo = NULL, pie = NULL, piecol = NULL,
           col = "black", bg = "lightgreen", horiz = FALSE,
           width = NULL, height = NULL, date = NULL, ...)

}
\arguments{
  \item{text}{a vector of mode character giving the text to be
    printed. Can be left empty.}
  \item{node}{a vector of mode numeric giving the numbers of the nodes
    where the text or the symbols are to be printed. Can be left empty.}
  \item{tip}{a vector of mode numeric giving the numbers of the tips
    where the text or the symbols are to be printed. Can be left empty.}
  \item{edge}{a vector of mode numeric giving the numbers of the edges
    where the text or the symbols are to be printed. Can be left empty.}
  \item{adj}{one or two numeric values specifying the horizontal and
    vertical, respectively, justification of the text or symbols. By
    default, the text is centered horizontally and vertically. If a
    single value is given, this alters only the horizontal position of
    the text.}
  \item{frame}{a character string specifying the kind of frame to be
    printed around the text. This must be one of "rect" (the default),
    "circle", "none", or any unambiguous abbreviation of these.}
  \item{pch}{a numeric giving the type of plotting symbol to be used;
    this is eventually recycled. See \code{\link[graphics]{par}} for R's
    plotting symbols. If \code{pch} is used, then \code{text} is
    ignored.}
  \item{thermo}{a numeric vector giving some proportions (values between
    0 and 1) for each node, or a numeric matrix giving some proportions
    (the rows must sum to one).}
  \item{pie}{same than \code{thermo}.}
  \item{piecol}{a list of colours (given as a character vector) to be
    used by \code{thermo} or \code{pie}; if left \code{NULL}, a series
    of colours given by the function \code{rainbow} is used.}
  \item{col}{a character string giving the color to be used for the
    text or the plotting symbols; this is eventually recycled.}
  \item{bg}{a character string giving the color to be used for the
    background of the text frames or of the plotting symbols if it
    applies; this is eventually recycled.}
  \item{\dots}{further arguments passed to the \code{text} or
    \code{points} functions (e.g. \code{cex} to alter the size of the
    text or the symbols, or \code{font} for the text; see the examples
    below).}
  \item{horiz, width, height}{parameters controlling the aspect of
    thermometers; by default, their width and height are determined
    automatically.}
  \item{offset}{offset of the tip labels (can be negative).}
  \item{date}{specifies the positions of labels on edges of chronograms
    with respect to the time scale.}
}
\details{
  These three functions have the same optional arguments and the same
  functioning.

  If the arguments \code{text} is missing and \code{pch} and
  \code{thermo} are left as \code{NULL}, then the numbers of the nodes
  (or of the tips) are printed.

  If \code{node}, \code{tip}, or \code{edge} is missing, then the text
  or the symbols are printed on all nodes, tips, or edges.

  The option \code{cex} can be used to change the size of all types of
  labels.

  A simple call of these functions with no arguments (e.g.,
  \code{nodelabels()}) prints the numbers of all nodes (or tips).

  In the case of \code{tiplabels}, it would be useful to play with the
  options \code{x.lim} and \code{label.offset} (and possibly
  \code{show.tip.label}) of \code{plot.phylo} in most cases (see the
  examples).
}
\author{Emmanuel Paradis, Ben Bolker, and Jim Lemon}
\seealso{
  \code{\link{plot.phylo}}, \code{\link{edges}},
  \code{\link{mixedFontLabel}}
}
\examples{
tr <- read.tree(text = "((Homo,Pan),Gorilla);")
plot(tr)
nodelabels("7.3 Ma", 4, frame = "r", bg = "yellow", adj = 0)
nodelabels("5.4 Ma", 5, frame = "c", bg = "tomato", font = 3)

## A trick by Liam Revell when there are many categories:
plot(tr, x.lim = c(-1, 4))
nodelabels(node = 4, pie = matrix(rep(1, 100), 1), cex = 5)
op <- par(fg = "transparent")
nodelabels(node = 5, pie = matrix(rep(1, 100), 1), cex = 5)
par(op)

data(bird.orders)
plot(bird.orders, use.edge.length = FALSE, font = 1)
bs <- round(runif(22, 90, 100), 0) # some imaginary bootstrap values
bs2 <- round(runif(22, 90, 100), 0)
bs3 <- round(runif(22, 90, 100), 0)
nodelabels(bs, adj = 1.2)
nodelabels(bs2, adj = -0.2, bg = "yellow")

### something more classical
plot(bird.orders, use.edge.length = FALSE, font = 1)
nodelabels(bs, adj = -0.2, frame = "n", cex = 0.8)
nodelabels(bs2, adj = c(1.2, 1), frame = "n", cex = 0.8)
nodelabels(bs3, adj = c(1.2, -0.2), frame = "n", cex = 0.8)

### the same but we play with the font
plot(bird.orders, use.edge.length = FALSE, font = 1)
nodelabels(bs, adj = -0.2, frame = "n", cex = 0.8, font = 2)
nodelabels(bs2, adj = c(1.2, 1), frame = "n", cex = 0.8, font = 3)
nodelabels(bs3, adj = c(1.2, -0.2), frame = "n", cex = 0.8)

plot(bird.orders, "c", use.edge.length = FALSE, font = 1)
nodelabels(thermo = runif(22), cex = .8)

plot(bird.orders, "u", FALSE, font = 1, lab4ut = "a")
nodelabels(cex = .75, bg = "yellow")

### representing two characters at the tips (you could have as many
### as you want)
plot(bird.orders, "c", FALSE, font = 1, label.offset = 3,
     x.lim = 31, no.margin = TRUE)
tiplabels(pch = 21, bg = gray(1:23/23), cex = 2, adj = 1.4)
tiplabels(pch = 19, col = c("yellow", "red", "blue"), adj = 2.5, cex = 2)
### This can be used to highlight tip labels:
plot(bird.orders, font = 1)
i <- c(1, 7, 18)
tiplabels(bird.orders$tip.label[i], i, adj = 0)
### Some random data to compare piecharts and thermometres:
tr <- rtree(15)
x <- runif(14, 0, 0.33)
y <- runif(14, 0, 0.33)
z <- runif(14, 0, 0.33)
x <- cbind(x, y, z, 1 - x - y - z)
layout(matrix(1:2, 1, 2))
plot(tr, "c", FALSE, no.margin = TRUE)
nodelabels(pie = x, cex = 1.3)
text(4.5, 15, "Are you \"pie\"...", font = 4, cex = 1.5)
plot(tr, "c", FALSE, no.margin = TRUE)
nodelabels(thermo = x, col = rainbow(4), cex = 1.3)
text(4.5, 15, "... or \"thermo\"?", font = 4, cex = 1.5)
plot(tr, "c", FALSE, no.margin = TRUE)
nodelabels(thermo = x, col = rainbow(4), cex = 1.3)
plot(tr, "c", FALSE, no.margin = TRUE)
nodelabels(thermo = x, col = rainbow(4), width = 3, horiz = TRUE)
layout(1)
plot(tr, main = "Showing Edge Lengths")
edgelabels(round(tr$edge.length, 3), srt = 90)
plot(tr, "p", FALSE)
edgelabels("above", adj = c(0.5, -0.25), bg = "yellow")
edgelabels("below", adj = c(0.5, 1.25), bg = "lightblue")
}
\keyword{aplot}

\name{rDNAbin}
\alias{rDNAbin}
\title{Random DNA Sequences}
\description{
  This function generates random sets of DNA sequences.
}
\usage{
rDNAbin(n, nrow, ncol, base.freq = rep(0.25, 4), prefix = "Ind_")
}
\arguments{
\item{n}{a vector of integers giving the lengths of the sequences. Can
  be missing in which case \code{nrow} and \code{ncol} must be given.}
\item{nrow, ncol}{two single integer values giving the number of
  sequences and the number of sites, respectively (ignored if \code{n}
  is given).}
\item{base.freq}{the base frequencies.}
\item{prefix}{the prefix used to give labels to the sequences; by
  default these are Ind_1, \dots Ind_n (or Ind_nrow).}
}
\details{
  If \code{n} is used, this function generates a list with sequence lengths given by the values in \code{n}. If \code{n} is missing, a matrix is
  generated.

  The purpose of this function is to generate a set of sequences of a
  specific size. To simulate sequences on a phylogenetic tree, see
  \code{\link[phangorn]{simSeq}} in \pkg{phangorn} (very efficient), and
  the package \pkg{phylosim} (more for pedagogy).
}
\value{
  an object of class \code{"DNAbin"}.
}
\note{
  It is not recommended to use this function to generate objects larger
  than two billion bases (2 Gb).
}
\author{Emmanuel Paradis}
\seealso{
  \code{\link{DNAbin}}
}
\examples{
rDNAbin(1:10)
rDNAbin(rep(10, 10))
rDNAbin(nrow = 10, ncol = 10)
}
\keyword{datagen}

\name{collapse.singles}
\alias{collapse.singles}
\alias{has.singles}
\title{Collapse Single Nodes}
\description{
  \code{collapse.singles} deletes the single nodes (i.e., with a single
  descendant) in a tree.

  \code{has.singles} tests for the presence of single node(s) in a tree.
}
\usage{
collapse.singles(tree, root.edge = FALSE)
has.singles(tree)
}
\arguments{
  \item{tree}{an object of class \code{"phylo"}.}
  \item{root.edge}{whether to get the singleton edges from the root
    until the first bifurcating node and put them as \code{root.edge} of
    the returned tree. By default, this is ignored or if the tree has no
    edge lengths (see examples).}
}
\value{
  an object of class \code{"phylo"}.
}
\author{Emmanuel Paradis, Klaus Schliep}
\seealso{
  \code{\link{plot.phylo}}, \code{\link{read.tree}}
}
\examples{
## a tree with 3 tips and 3 nodes:
e <- c(4L, 6L, 6L, 5L, 5L, 6L, 1L, 5L, 3L, 2L)
dim(e) <- c(5, 2)
tr <- structure(list(edge = e, tip.label = LETTERS[1:3], Nnode = 3L),
                class = "phylo")
tr
has.singles(tr)
## the following shows that node #4 (ie, the root) is a singleton
## and node #6 is the first bifurcating node
tr$edge
## A bifurcating tree has less nodes than it has tips:
## the following used to fail with ape 4.1 or lower:
plot(tr)
collapse.singles(tr) # only 2 nodes
## give branch lengths to use the 'root.edge' option:
tr$edge.length <- runif(5)
str(collapse.singles(tr, TRUE)) # has a 'root.edge'
}
\keyword{manip}

\name{checkLabel}
\alias{checkLabel}
\title{Checking Labels}
\description{
  Checking and correcting character strings, particularly before writing
  a Newick tree.
}
\usage{checkLabel(x)}
\arguments{\item{x}{a vector of mode character.}}
\details{
  This function deletes the leading and trailing spaces (including
  tabulations, new lines, and left or right parentheses at the beginning
  or end of the strings), substitutes the spaces inside the strings by
  underscores, and substitutes commas, colons, semicolons, and
  parentheses inside the strings by dashes.
}
\value{a vector of mode character.}
\author{Emmanuel Paradis}
\seealso{
  \code{\link{makeLabel}}, \code{\link{makeNodeLabel}},
  \code{\link{mixedFontLabel}}, \code{\link{stripLabel}},
  \code{\link{updateLabel}}
}
\examples{
checkLabel(" Homo sapiens\t(Primates; World)   ")
}
\keyword{manip}

\name{makeLabel}
\alias{makeLabel}
\alias{makeLabel.character}
\alias{makeLabel.phylo}
\alias{makeLabel.multiPhylo}
\alias{makeLabel.DNAbin}
\title{Label Management}
\description{
  This is a generic function with methods for character vectors, trees
  of class \code{"phylo"}, lists of trees of class \code{"multiPhylo"},
  and DNA sequences of class \code{"DNAbin"}. All options for the class
  character may be used in the other methods.
}
\usage{
makeLabel(x, ...)
\method{makeLabel}{character}(x, len = 99, space = "_", make.unique = TRUE,
          illegal = "():;,[]", quote = FALSE, ...)
\method{makeLabel}{phylo}(x, tips = TRUE, nodes = TRUE, ...)
\method{makeLabel}{multiPhylo}(x, tips = TRUE, nodes = TRUE, ...)
\method{makeLabel}{DNAbin}(x, ...)
}
\arguments{
  \item{x}{a vector of mode character or an object for which labels are
    to be changed.}
  \item{len}{the maximum length of the labels: those longer than `len'
    will be truncated.}
  \item{space}{the character to replace spaces, tabulations, and
    linebreaks.}
  \item{make.unique}{a logical specifying whether duplicate labels
    should be made unique by appending numerals; \code{TRUE} by
    default.}
  \item{illegal}{a string specifying the characters to be deleted.}
  \item{quote}{a logical specifying whether to quote the labels;
    \code{FALSE} by default.}
  \item{tips}{a logical specifying whether tip labels are to be
    modified; \code{TRUE} by default.}
  \item{nodes}{a logical specifying whether node labels are to be
    modified; \code{TRUE} by default.}
  \item{\dots}{further arguments to be passed to or from other methods.}
}
\details{
  The option \code{make.unique} does not work exactly in the same way
  then the function of the same name: numbers are suffixed to all labels
  that are identical (without separator). See the examples.

  If there are 10--99 identical labels, the labels returned are "xxx01",
  "xxx02", etc, or "xxx001", "xxx002", etc, if they are 100--999, and so
  on. The number of digits added preserves the option `len'.

  The default for `len' makes labels short enough to be read by
  PhyML. Clustal accepts labels up to 30 character long.
}
\note{
  The current version does not perform well when trying to make very
  short unique labels (e.g., less than 5 character long).
}
\value{
  An object of the appropriate class.
}
\author{Emmanuel Paradis}
\seealso{
  \code{\link{makeNodeLabel}}, \code{\link[base]{make.unique}},
  \code{\link[base]{make.names}}, \code{\link[base]{abbreviate}},
  \code{\link{mixedFontLabel}}, \code{\link{label2table}},
  \code{\link{updateLabel}}, \code{\link{checkLabel}}
}
\examples{
x <- rep("a", 3)
makeLabel(x)
make.unique(x) # <- from R's base
x <- rep("aaaaa", 2)
makeLabel(x, len = 3) # made unique and of length 3
makeLabel(x, len = 3, make.unique = FALSE)
}
\keyword{manip}

\name{CADM.global}
\alias{CADM}
\alias{CADM.global}
\alias{CADM.post}
\title{ Congruence among distance matrices }
\description{
Function \code{\link{CADM.global}} compute and test the coefficient of concordance among several distance matrices through a permutation test.

Function \code{\link{CADM.post}} carries out a posteriori permutation tests of the contributions of individual distance matrices to the overall concordance of the group.

Use in phylogenetic analysis: to identify congruence among distance matrices (D) representing different genes or different types of data. Congruent D matrices correspond to data tables that can be used together in a combined phylogenetic or other type of multivariate analysis.
}
\usage{
CADM.global(Dmat, nmat, n, nperm=99, make.sym=TRUE, weights=NULL,
            silent=FALSE)
CADM.post  (Dmat, nmat, n, nperm=99, make.sym=TRUE, weights=NULL,
             mult="holm", mantel=FALSE, silent=FALSE)
}

\arguments{
  \item{Dmat}{ A text file listing the distance matrices one after the other, with or without blank lines in-between. Each matrix is in the form of a square distance matrix with 0's on the diagonal. }
  \item{nmat}{ Number of distance matrices in file Dmat. }
  \item{n}{ Number of objects in each distance matrix. All matrices must have the same number of objects. }
  \item{nperm}{ Number of permutations for the tests of significance. }
  \item{make.sym}{ TRUE: turn asymmetric matrices into symmetric matrices by averaging the two triangular portions. FALSE: analyse asymmetric matrices as they are. }
  \item{weights}{ A vector of positive weights for the distance matrices. Example: weights = c(1,2,3). NULL (default): all matrices have same weight in the calculation of W. }
  \item{mult}{ Method for correcting P-values in multiple testing. The methods are "holm" (default), "sidak", and "bonferroni". The Bonferroni correction is overly conservative; it is not recommended. It is included to allow comparisons with the other methods. }
  \item{mantel}{ TRUE: Mantel statistics will be computed from ranked distances, as well as permutational P-values. FALSE (default): Mantel statistics and tests will not be computed. }
  \item{silent}{ TRUE: informative messages will not be printed, but stopping messages will. Option useful for simulation work. FALSE: informative messages will be printed. }
}
\details{
\code{Dmat} must contain two or more distance matrices, listed one after the other, all of the same size, and corresponding to the same objects in the same order. Raw data tables can be transformed into distance matrices before comparison with other such distance matrices, or with data that have been obtained as distance matrices, e.g. serological or DNA hybridization data. The distances will be transformed to ranks before computation of the coefficient of concordance and other statistics.

\code{CADM.global} tests the global null hypothesis that all matrices are incongruent. If the global null is rejected, function \code{CADM.post} can be used to identify the concordant (H0 rejected) and discordant matrices (H0 not rejected) in the group. If a distance matrix has a negative value for the \code{Mantel.mean} statistic, that matrix clearly does not belong to the group. Remove that matrix (if there are more than one, remove first the matrix that has the most strongly negative value for \code{Mantel.mean}) and run the analysis again.

The corrections used for multiple testing are applied to the list of P-values (P) produced in the a posteriori tests; they take into account the number of tests (k) carried out simulatenously (number of matrices, parameter \code{nmat}).

The Holm correction is computed after ordering the P-values in a list with the smallest value to the left. Compute adjusted P-values as:

\deqn{P_{corr} = (k-i+1)*P}{P_corr = (k-i+1)*P}

where i is the position in the ordered list. Final step: from left to right, if an adjusted \eqn{P_{corr}}{P_corr} in the ordered list is smaller than the one occurring at its left, make the smallest one equal to the largest one.

The Sidak correction is:

\deqn{P_{corr} = 1 - (1 - P)^k}{P_corr = 1 - (1 - P)^k}

The Bonferonni correction is:

\deqn{P_{corr} = k*P}{P_corr = k*P}
}

\value{

\code{CADM.global} produces a small table containing the W, Chi2, and Prob.perm statistics described in the following list.
\code{CADM.post} produces a table stored in element \code{A_posteriori_tests}, containing Mantel.mean, Prob, and Corrected.prob statistics in rows; the columns correspond to the k distance matrices under study, labeled Dmat.1 to Dmat.k.
If parameter \code{mantel} is TRUE, tables of Mantel statistics and P-values are computed among the matrices.

  \item{W }{Kendall's coefficient of concordance, W (Kendall and Babington Smith 1939; see also Legendre 2010). }
  \item{Chi2 }{Friedman's chi-square statistic (Friedman 1937) used in the permutation test of W. }
  \item{Prob.perm }{Permutational probability. }

  \item{Mantel.mean }{Mean of the Mantel correlations, computed on rank-transformed distances, between the distance matrix under test and all the other matrices in the study. }
  \item{Prob }{Permutational probabilities, uncorrected. }
  \item{Corrected prob }{Permutational probabilities corrected using the method selected in parameter \code{mult}. }

  \item{Mantel.cor }{Matrix of Mantel correlations, computed on rank-transformed distances, among the distance matrices. }
  \item{Mantel.prob }{One-tailed P-values associated with the Mantel correlations of the previous table. The probabilities are computed in the right-hand tail. H0 is tested against the alternative one-tailed hypothesis that the Mantel correlation under test is positive. No correction is made for multiple testing. }
}

\references{
Campbell, V., Legendre, P. and Lapointe, F.-J. (2009) Assessing congruence among ultrametric distance matrices. \emph{Journal of Classification}, \bold{26}, 103--117.

Campbell, V., Legendre, P. and Lapointe, F.-J. (2011) The performance of the Congruence Among Distance Matrices (CADM) test in phylogenetic analysis. \emph{BMC Evolutionary Biology}, \bold{11}, 64.

Friedman, M. (1937) The use of ranks to avoid the assumption of normality implicit in the analysis of variance. \emph{Journal of the American Statistical Association}, \bold{32}, 675--701.

Kendall, M. G. and Babington Smith, B. (1939) The problem of m rankings. \emph{Annals of Mathematical Statistics}, \bold{10}, 275--287.

Lapointe, F.-J., Kirsch, J. A. W. and Hutcheon, J. M. (1999) Total evidence, consensus, and bat phylogeny: a distance-based approach. \emph{Molecular Phylogenetics and Evolution}, \bold{11}, 55--66.

Legendre, P. (2010) Coefficient of concordance. Pp. 164-169 in: Encyclopedia of Research Design, Vol. 1. N. J. Salkind, ed. SAGE Publications, Inc., Los Angeles.

Legendre, P. and Lapointe, F.-J. (2004) Assessing congruence among distance matrices: single malt Scotch whiskies
revisited. \emph{Australian and New Zealand Journal of Statistics}, \bold{46}, 615--629.

Legendre, P. and Lapointe, F.-J. (2005) Congruence entre matrices de distance. P. 178-181 in: Makarenkov, V., G. Cucumel et F.-J. Lapointe [eds] Comptes rendus des 12emes Rencontres de la Societe Francophone de Classification, Montreal, 30 mai - 1er juin 2005.

Siegel, S. and Castellan, N. J., Jr. (1988) \emph{Nonparametric statistics for the behavioral sciences. 2nd edition}. New York: McGraw-Hill.
}

\author{Pierre Legendre, Universite de Montreal}

\examples{
# Examples 1 and 2: 5 genetic distance matrices computed from simulated DNA
# sequences representing 50 taxa having evolved along additive trees with
# identical evolutionary parameters (GTR+ Gamma + I). Distance matrices were
# computed from the DNA sequence matrices using a p distance corrected with the
# same parameters as those used to simulate the DNA sequences. See Campbell et
# al. (2009) for details.

# Example 1: five independent additive trees. Data provided by V. Campbell.

data(mat5Mrand)
res.global <- CADM.global(mat5Mrand, 5, 50)

# Example 2: three partly similar trees, two independent trees.
# Data provided by V. Campbell.

data(mat5M3ID)
res.global <- CADM.global(mat5M3ID, 5, 50)
res.post   <- CADM.post(mat5M3ID, 5, 50, mantel=TRUE)

# Example 3: three matrices respectively representing Serological
# (asymmetric), DNA hybridization (asymmetric) and Anatomical (symmetric)
# distances among 9 families. Data from Lapointe et al. (1999).

data(mat3)
res.global <- CADM.global(mat3, 3, 9, nperm=999)
res.post   <- CADM.post(mat3, 3, 9, nperm=999, mantel=TRUE)

# Example 4, showing how to bind two D matrices (cophenetic matrices
# in this example) into a file using rbind(), then run the global test.

a <- rtree(5)
b <- rtree(5)
A <- cophenetic(a)
B <- cophenetic(b)
x <- rownames(A)
B <- B[x, x]
M <- rbind(A, B)
CADM.global(M, 2, 5)
}

\keyword{ multivariate }
\keyword{ nonparametric }

\name{nj}
\alias{nj}
\title{Neighbor-Joining Tree Estimation}
\description{
  This function performs the neighbor-joining tree estimation of Saitou
  and Nei (1987).
}
\usage{
nj(X)
}
\arguments{
  \item{X}{a distance matrix; may be an object of class ``dist''.}
}
\value{
  an object of class \code{"phylo"}.
}
\references{
  Saitou, N. and Nei, M. (1987) The neighbor-joining method: a new
  method for reconstructing phylogenetic trees. \emph{Molecular Biology
    and Evolution}, \bold{4}, 406--425.

  Studier, J. A. and Keppler, K. J. (1988) A note on the
  neighbor-joining algorithm of Saitou and Nei. \emph{Molecular Biology
    and Evolution}, \bold{5}, 729--731.
}
\author{Emmanuel Paradis}
\seealso{
  \code{\link{write.tree}}, \code{\link{read.tree}},
  \code{\link{dist.dna}}, \code{\link{bionj}},
  \code{\link{fastme}}, \code{\link{njs}}
}
\examples{
### From Saitou and Nei (1987, Table 1):
x <- c(7, 8, 11, 13, 16, 13, 17, 5, 8, 10, 13,
       10, 14, 5, 7, 10, 7, 11, 8, 11, 8, 12,
       5, 6, 10, 9, 13, 8)
M <- matrix(0, 8, 8)
M[lower.tri(M)] <- x
M <- t(M)
M[lower.tri(M)] <- x
dimnames(M) <- list(1:8, 1:8)
tr <- nj(M)
plot(tr, "u")
### a less theoretical example
data(woodmouse)
trw <- nj(dist.dna(woodmouse))
plot(trw)
}
\keyword{models}

\name{reorder.phylo}
\alias{reorder.phylo}
\alias{reorder.multiPhylo}
\alias{cladewise}
\alias{postorder}
\title{Internal Reordering of Trees}
\description{
  \code{reorder} changes the internal structure of a phylogeny stored as
  an object of class \code{"phylo"}. The tree returned is the same than
  the one input, but the ordering of the edges could be different.

  \code{cladewise} and \code{postorder} are convenience functions to
  return only the indices of the reordered edge matrices (see examples).
}
\usage{
\method{reorder}{phylo}(x, order = "cladewise", index.only = FALSE, ...)
\method{reorder}{multiPhylo}(x, order = "cladewise", ...)
cladewise(x)
postorder(x)
}
\arguments{
  \item{x}{an object of class \code{"phylo"} or \code{"multiPhylo"}.}
  \item{order}{a character string: either \code{"cladewise"} (the
    default), \code{"postorder"}, \code{"pruningwise"}, or any
    unambiguous abbreviation of these.}
  \item{index.only}{should the function return only the ordered indices
    of the rows of the edge matrix?}
  \item{\dots}{further arguments passed to or from other methods.}
}
\details{
  Because in a tree coded as an object of class \code{"phylo"} each
  branch is represented by a row in the element `edge', there is an
  arbitrary choice for the ordering of these rows. \code{reorder} allows
  to reorder these rows according to three rules: in the
  \code{"cladewise"} order each clade is formed by a series of
  contiguous rows. In the \code{"postorder"} order, the rows are
  arranged so that computations following pruning-like algorithm the
  tree (or postorder tree traversal) can be done by descending along
  these rows (conversely, a preorder tree traversal can be performed by
  moving from the last to the first row). The \code{"pruningwise"} order
  is an alternative ``pruning'' order which is actually a bottom-up
  traversal order (Valiente 2002). (This third choice might be removed
  in the future as it merely duplicates the second one which is more
  efficient.) The possible multichotomies and branch lengths are preserved.

  Note that for a given order, there are several possible orderings of
  the rows of `edge'.
}
\value{
  an object of class \code{"phylo"} (with the attribute \code{"order"}
  set accordingly), or a numeric vector if \code{index.only = TRUE}; if
  \code{x} is of class \code{"multiPhylo"}, then an object of the same
  class.
}
\references{
  Valiente, G. (2002) \emph{Algorithms on Trees and Graphs.} New York:
  Springer.
}
\author{Emmanuel Paradis}
\seealso{
  \code{\link{read.tree}} to read tree files in Newick format,
  \code{\link[stats]{reorder}} for the generic function
}
\examples{
data(bird.families)
tr <- reorder(bird.families, "postorder")
all.equal(bird.families, tr) # uses all.equal.phylo actually
all.equal.list(bird.families, tr) # bypasses the generic

## get the number of descendants for each tip or node:
nr_desc <-  function(x) {
    res <- numeric(max(x$edge))
    res[1:Ntip(x)] <- 1L
    for (i in postorder(x)) {
       tmp <- x$edge[i,1]
       res[tmp] <- res[tmp] + res[x$edge[i, 2]]
   }
   res
}
## apply it to a random tree:
tree <- rtree(10)
plot(tree, show.tip.label = FALSE)
tiplabels()
nodelabels()
nr_desc(tree)
}
\keyword{manip}

\name{multiphylo}
\alias{multiphylo}
\alias{[.multiPhylo}
\alias{[[.multiPhylo}
\alias{$.multiPhylo}
\alias{[<-.multiPhylo}
\alias{[[<-.multiPhylo}
\alias{$<-.multiPhylo}
\title{Manipulating Lists of Trees}
\description{
  These are extraction and replacement operators for lists of trees
  stored in the class \code{"multiPhylo"}.
}
\usage{
\method{[}{multiPhylo}(x, i)
\method{[[}{multiPhylo}(x, i)
\method{$}{multiPhylo}(x, name)
\method{[}{multiPhylo}(x, ...) <- value
\method{[[}{multiPhylo}(x, ...) <- value
\method{$}{multiPhylo}(x, ...) <- value
}
\arguments{
  \item{x, value}{an object of class \code{"phylo"} or \code{"multiPhylo"}.}
  \item{i}{index(ices) of the tree(s) to select from a list; this may be a
    vector of integers, logicals, or names.}
  \item{name}{a character string specifying the tree to be extracted.}
  \item{\dots}{index(ices) of the tree(s) to replace; this may be a
    vector of integers, logicals, or names.}
}
\details{
  The subsetting operator \code{[} keeps the class correctly
  (\code{"multiPhylo"}).

The replacement operators check the labels of \code{value} if \code{x}
has a single vector of tip labels for all trees (see examples).
}
\value{
  An object of class \code{"phylo"} (\code{[[}, \code{$}) or of class
  \code{"multiPhylo"} (\code{[} and the replacement operators).
}
\author{Emmanuel Paradis}
\seealso{
  \code{\link{summary.phylo}}, \code{\link{c.phylo}}
}
\examples{
x <- rmtree(10, 20)
names(x) <- paste("tree", 1:10, sep = "")
x[1:5]
x[1] # subsetting
x[[1]] # extraction
x$tree1 # same than above
x[[1]] <- rtree(20)

y <- .compressTipLabel(x)
## up to here 'x' and 'y' have exactly the same information
## but 'y' has a unique vector of tip labels for all the trees
x[[1]] <- rtree(10) # no error
try(y[[1]] <- rtree(10)) # error

try(x[1] <- rtree(20)) # error
## use instead one of the two:
x[1] <- list(rtree(20))
x[1] <- c(rtree(20))

x[1:5] <- rmtree(5, 20) # replacement
x[11:20] <- rmtree(10, 20) # elongation
x # 20 trees
}
\keyword{manip}

\name{write.dna}
\alias{write.dna}
\alias{write.FASTA}
\title{Write DNA Sequences in a File}
\usage{
write.dna(x, file, format = "interleaved", append = FALSE,
          nbcol = 6, colsep = " ", colw = 10, indent = NULL,
          blocksep = 1)
write.FASTA(x, file, header = NULL, append = FALSE)
}
\arguments{
  \item{x}{a list or a matrix of DNA sequences, or of AA sequences for
    \code{write.FASTA}.}
  \item{file}{a file name specified by either a variable of mode character,
    or a double-quoted string.}
  \item{format}{a character string specifying the format of the DNA
    sequences. Three choices are possible: \code{"interleaved"},
    \code{"sequential"}, or \code{"fasta"}, or any unambiguous
    abbreviation of these.}
  \item{append}{a logical, if \code{TRUE} the data are appended to the
    file without erasing the data possibly existing in the file,
    otherwise the file (if it exists) is overwritten (\code{FALSE} the
    default).}
  \item{nbcol}{a numeric specifying the number of columns per row (6 by
    default); may be negative implying that the nucleotides are printed
    on a single line.}
  \item{colsep}{a character used to separate the columns (a single
    space by default).}
  \item{colw}{a numeric specifying the number of nucleotides per column
    (10 by default).}
  \item{indent}{a numeric or a character specifying how the blocks of
    nucleotides are indented (see details).}
  \item{blocksep}{a numeric specifying the number of lines between the
    blocks of nucleotides (this has an effect only if `format =
    "interleaved"').}
  \item{header}{a vector of mode character giving the header to be
    written in the FASTA file before the sequences. By default, there is
    no header.}
}
\description{
  These functions write in a file a list of DNA sequences in sequential,
  interleaved, or FASTA format. \code{write.FASTA} can write either DNA
  or AA sequences.
}
\details{
  Three formats are supported in the present function: see the help page
  of \code{\link{read.dna}} and the references below for a description.

  If the sequences have no names, then they are given "1", "2", ... as
  labels in the file.

  With the interleaved and sequential formats, the sequences must be all
  of the same length. The names of the sequences are not truncated.

  The argument \code{indent} specifies how the rows of nucleotides are
  indented. In the interleaved and sequential formats, the rows with
  the taxon names are never indented; the subsequent rows are indented
  with 10 spaces by default (i.e., if \code{indent = NULL}). In the FASTA
  format, the rows are not indented by default. This default behaviour
  can be modified by specifying a value to \code{indent}: the rows are then
  indented with ``indent'' (if it is a character) or `indent' spaces (if
  it is a numeric). For example, specifying \code{indent = "   "} or
  \code{indent = 3} will have the same effect (use \code{indent = "\\t"}
  for a tabulation).

  The different options are intended to give flexibility in formatting
  the sequences. For instance, if the sequences are very long it may be
  judicious to remove all the spaces beween columns (colsep = ""), in
  the margins (indent = 0), and between the blocks (blocksep = 0) to
  produce a smaller file.

  \code{write.dna(, format = "fasta")} can be very slow if the sequences
  are long (> 10 kb). \code{write.FASTA} is much faster in this
  situation but the formatting is not flexible: each sequence is printed
  on a single line, which is OK for big files that are not intended to
  be open with a text editor.
}
\note{
  Specifying a negative value for `nbcol' (meaning that the nucleotides
  are printed on a single line) gives the same output for the
  interleaved and sequential formats.

  The names of the sequences can be truncated with the function
  \code{\link{makeLabel}}. In particular, Clustal is limited to 30
  characters, and PHYML seems limited to 99 characters.
}
\value{
  None (invisible `NULL').
}
\author{Emmanuel Paradis}
\references{
  Anonymous. FASTA format. \url{http://en.wikipedia.org/wiki/FASTA_format}

  Felsenstein, J. (1993) Phylip (Phylogeny Inference Package) version
  3.5c. Department of Genetics, University of Washington.
  \url{http://evolution.genetics.washington.edu/phylip/phylip.html}
}
\seealso{
  \code{\link{read.dna}}, \code{\link{read.GenBank}},
  \code{\link{makeLabel}}
}
\keyword{IO}

\name{pic.ortho}
\alias{pic.ortho}
\title{Phylogenetically Independent Orthonormal Contrasts}
\description{
  This function computes the orthonormal contrasts using the method
  described by Felsenstein (2008). Only a single trait can be analyzed;
  there can be several observations per species.
}
\usage{
pic.ortho(x, phy, var.contrasts = FALSE, intra = FALSE)
}
\arguments{
  \item{x}{a numeric vector or a list of numeric vectors.}
  \item{phy}{an object of class \code{"phylo"}.}
  \item{var.contrasts}{logical, indicates whether the expected
    variances of the contrasts should be returned (default to
    \code{FALSE}).}
  \item{intra}{logical, whether to return the intraspecific contrasts.}
}
\details{
  The data \code{x} can be in two forms: a vector if there is a single
  observation for each species, or a list whose elements are vectors
  containing the individual observations for each species. These vectors
  may be of different lengths.

  If \code{x} has names, its values are matched to the tip labels of
  \code{phy}, otherwise its values are taken to be in the same order
  than the tip labels of \code{phy}.
}
\value{
  either a vector of contrasts, or a two-column matrix with the
  contrasts in the first column and their expected variances in the
  second column (if \code{var.contrasts = TRUE}). If the tree has node
  labels, these are used as labels of the returned object.

  If \code{intra = TRUE}, the attribute \code{"intra"}, a list of
  vectors with the intraspecific contrasts or \code{NULL} for the
  species with a one observation, is attached to the returned object.
}
\references{
  Felsenstein, J. (2008) Comparative methods with sampling error and
  within-species variation: Contrasts revisited and revised.
  \emph{American Naturalist}, \bold{171}, 713--725.
}
\author{Emmanuel Paradis}
\seealso{
  \code{\link{pic}}, \code{\link{varCompPhylip}}
}
\examples{
tr <- rcoal(30)
### a single observation per species:
x <- rTraitCont(tr)
pic.ortho(x, tr)
pic.ortho(x, tr, TRUE)
### different number of observations per species:
x <- lapply(sample(1:5, 30, TRUE), rnorm)
pic.ortho(x, tr, intra = TRUE)
}
\keyword{regression}

\name{mat5Mrand}
\alias{mat5Mrand}
\title{Five Independent Trees}
\description{
  Five independent additive trees.
}
\usage{
data(mat5Mrand)
}
\format{
  A data frame with 250 observations and 50 variables.
}
\source{
  Data provided by V. Campbell.
}
\seealso{
  \code{\link{mat5M3ID}}, \code{\link{mat3}}
}
\keyword{datasets}

\name{read.tree}
\alias{read.tree}
\alias{phylo}
\title{Read Tree File in Parenthetic Format}
\usage{
read.tree(file = "", text = NULL, tree.names = NULL, skip = 0,
    comment.char = "", keep.multi = FALSE, ...)
}
\arguments{
  \item{file}{a file name specified by either a variable of mode character,
    or a double-quoted string; if \code{file = ""} (the default) then the
    tree is input on the keyboard, the entry being terminated with a
    blank line.}
  \item{text}{alternatively, the name of a variable of mode character
    which contains the tree(s) in parenthetic format. By default, this
    is ignored (set to \code{NULL}, meaning that the tree is read in a
    file); if \code{text} is not \code{NULL}, then the argument
    \code{file} is ignored.}
  \item{tree.names}{if there are several trees to be read, a vector of
    mode character that gives names to the individual trees; if
    \code{NULL} (the default), the trees are named \code{"tree1"},
    \code{"tree2"}, ...}
  \item{skip}{the number of lines of the input file to skip before
    beginning to read data (this is passed directly to\code{ scan()}).}
  \item{comment.char}{a single character, the remaining of the line
    after this character is ignored (this is passed directly to
    \code{scan()}).}
  \item{keep.multi}{if \code{TRUE} and \code{tree.names = NULL} then
    single trees are returned in \code{"multiPhylo"} format, with any
    name that is present (see details). Default is \code{FALSE}.}
  \item{\dots}{further arguments to be passed to \code{scan()}.}
}
\description{
  This function reads a file which contains one or several trees in
  parenthetic format known as the Newick or New Hampshire format.
}
\details{
  The default option for \code{file} allows to type directly the tree on
  the keyboard (or possibly to copy from an editor and paste in R's
  console) with, e.g., \code{mytree <- read.tree()}.

  `read.tree' tries to represent correctly trees with a badly
  represented root edge (i.e. with an extra pair of parentheses). For
  instance, the tree "((A:1,B:1):10);" will be read like "(A:1,B:1):10;"
  but a warning message will be issued in the former case as this is
  apparently not a valid Newick format. If there are two root edges
  (e.g., "(((A:1,B:1):10):10);"), then the tree is not read and an error
  message is issued.

  If there are any characters preceding the first "(" in a line then
  this is assigned to the name. This is returned when a "multiPhylo"
  object is returned and \code{tree.names = NULL}.

  Until \pkg{ape} 4.1, the default of \code{comment.char} was \code{"#"}
  (as in \code{scan}). This has been changed so that extended Newick
  files can be read.
}
\value{
  an object of class \code{"phylo"} with the following components:
  \item{edge}{a two-column matrix of mode numeric where each row
    represents an edge of the tree; the nodes and the tips are
    symbolized with numbers; the tips are numbered 1, 2, \dots, and the
    nodes are numbered after the tips. For each row, the first column
    gives the ancestor.}
  \item{edge.length}{(optional) a numeric vector giving the lengths of the
    branches given by \code{edge}.}
  \item{tip.label}{a vector of mode character giving the names of the
    tips; the order of the names in this vector corresponds to the
    (positive) number in \code{edge}.}
  \item{Nnode}{the number of (internal) nodes.}
  \item{node.label}{(optional) a vector of mode character giving the
    names of the nodes.}
  \item{root.edge}{(optional) a numeric value giving the length of the
    branch at the root if it exists.}

  If several trees are read in the file, the returned object is of class
  \code{"multiPhylo"}, and is a list of objects of class \code{"phylo"}.
  The name of each tree can be specified by \code{tree.names}, or can be
  read from the file (see details).
}
\references{
  Felsenstein, J. The Newick tree format.
  \url{http://evolution.genetics.washington.edu/phylip/newicktree.html}

  Olsen, G. Interpretation of the "Newick's 8:45" tree format standard.
  \url{http://evolution.genetics.washington.edu/phylip/newick_doc.html}

  Paradis, E. (2008) Definition of Formats for Coding Phylogenetic Trees
  in R. \url{http://ape-package.ird.fr/misc/FormatTreeR_24Oct2012.pdf}

  Paradis, E. (2012) \emph{Analysis of Phylogenetics and Evolution with
    R (Second Edition).} New York: Springer.
}

\author{Emmanuel Paradis and Daniel Lawson \email{dan.lawson@bristol.ac.uk}}
\seealso{
  \code{\link{write.tree}}, \code{\link{read.nexus}},
  \code{\link{write.nexus}}, \code{\link[base]{scan}} for the basic R
  function to read data in a file
}
\examples{
### An extract from Sibley and Ahlquist (1990)
s <- "owls(((Strix_aluco:4.2,Asio_otus:4.2):3.1,Athene_noctua:7.3):6.3,Tyto_alba:13.5);"
cat(s, file = "ex.tre", sep = "\n")
tree.owls <- read.tree("ex.tre")
str(tree.owls)
tree.owls
tree.owls <- read.tree("ex.tre", keep.multi = TRUE)
tree.owls
names(tree.owls)
unlink("ex.tre") # delete the file "ex.tre"
### Only the first three species using the option `text'
TREE <- "((Strix_aluco:4.2,Asio_otus:4.2):3.1,Athene_noctua:7.3);"
TREE
tree.owls.bis <- read.tree(text = TREE)
str(tree.owls.bis)
tree.owls.bis

## tree with singleton nodes:
ts <- read.tree(text="((((a))),d);")
plot(ts, node.depth = 2) # the default will overlap the singleton node with the tip
nodelabels()

## skeleton tree with a singleton node:
tx <- read.tree(text = "(((,)),);")
plot(tx, node.depth = 2)
nodelabels()

## a tree with single quoted labels (the 2nd label is not quoted):
z <- "(('a: France, Spain (Europe)',b),'c: Australia [Outgroup]');"
tz <- read.tree(text = z)
plot(tz, font = 1)
}
\keyword{manip}
\keyword{IO}

\name{additive}
\alias{additive}
\alias{ultrametric}
\title{Incomplete Distance Matrix Filling}
\description{
  Fills missing entries from incomplete distance matrix using the
  additive or the ultrametric procedure (see reference for details).
}
\usage{
additive(X)
ultrametric(X)
}
\arguments{
  \item{X}{a distance matrix or an object of class \code{"dist"}.}
}
\value{
  a distance matrix.
}
\references{
  Makarenkov, V. and Lapointe, F.-J. (2004) A weighted least-squares
  approach for inferring phylogenies from incomplete distance
  matrices. \emph{Bioinformatics}, \bold{20}, 2113--2121.
}
\author{Andrei Popescu}
\keyword{manip}

\name{plot.correlogram}
\alias{plot.correlogram}
\alias{plot.correlogramList}
\title{Plot a Correlogram}
\usage{
  \method{plot}{correlogram}(x, legend = TRUE, test.level = 0.05,
                col = c("grey", "red"), type = "b", xlab = "",
                ylab = "Moran's I", pch = 21, cex = 2, ...)
  \method{plot}{correlogramList}(x, lattice = TRUE, legend = TRUE,
                test.level = 0.05, col = c("grey", "red"),
                xlab = "", ylab = "Moran's I",
                type = "b", pch = 21, cex = 2, ...)
}
\arguments{
  \item{x}{an object of class \code{"correlogram"} or of class
    \code{"correlogramList"} (both produced by
    \code{\link{correlogram.formula}}).}
  \item{legend}{should a legend be added on the plot?}
  \item{test.level}{the level used to discriminate the plotting symbols
    with colours considering the P-values.}
  \item{col}{two colours for the plotting symbols: the first one is used
    if the P-value is greater than or equal to \code{test.level}, the
    second one otherwise.}
  \item{type}{the type of plot to produce (see
    \code{\link[graphics]{plot}} for possible choices).}
  \item{xlab}{an optional character string for the label on the x-axis
    (none by default).}
  \item{ylab}{the default label on the y-axis.}
  \item{pch}{the type of plotting symbol.}
  \item{cex}{the default size for the plotting symbols.}
  \item{lattice}{when plotting several correlograms, should they be
    plotted in trellis-style with lattice (the default), or together on
    the same plot?}
  \item{\dots}{other parameters passed to the \code{plot} or \code{lines}
    function.}
}
\description{
  These functions plot correlagrams previously computed with
  \code{\link{correlogram.formula}}.
}
\details{
  When plotting several correlograms with lattice, some options have no
  effect: \code{legend}, \code{type}, and \code{pch} (\code{pch=19} is
  always used in this situation).

  When using \code{pch} between 1 and 20 (i.e., non-filled symbols, the
  colours specified in \code{col} are also used for the lines joining
  the points. To keep black lines, it is better to leave \code{pch}
  between 21 and 25.
}
\author{Emmanuel Paradis}
\seealso{
  \code{\link{correlogram.formula}}, \code{\link{Moran.I}}
}
\keyword{hplot}

\name{read.gff}
\alias{read.gff}
\title{Read GFF Files}
\description{
  This function reads a file in general feature format version 3 (GFF3)
  and returns a data frame.
}
\usage{
read.gff(file, na.strings = c(".", "?"), GFF3 = TRUE)
}
\arguments{
  \item{file}{a file name specified by a character string.}
  \item{na.strings}{the strings in the GFF file that will be converted
    as NA's (missing values).}
  \item{GFF3}{a logical value specifying whether if the file is
    formatted according to version 3 of GFF.}
}
\details{
  The returned data frame has its (column) names correctly set (see
  References) and the categorical variables (seqid, source, type,
  strand, and phase) set as factors.

  This function should be more efficient than using \code{read.delim}.

  GFF2 (aka GTF) files can also be read: use \code{GFF3 = FALSE} to have
  the correct field names. Note that GFF2 files and GFF3 files have the
  same structure, although some fields are slightly different (see
  reference).

  The file can be gz-compressed (see examples), but not zipped.
}
\value{NULL}
\author{Emmanuel Paradis}
\references{
  \url{https://en.wikipedia.org/wiki/General_feature_format}
}
\examples{
\dontrun{
## requires to be connected on Internet
d <- "ftp://ftp.ensembl.org/pub/release-86/gff3/homo_sapiens/"
f <- "Homo_sapiens.GRCh38.86.chromosome.MT.gff3.gz"
download.file(paste0(d, f), "mt_gff3.gz")
gff.mito <- read.gff("mt_gff3.gz")
## the lengths of the sequence features:
gff.mito$end - (gff.mito$start - 1)
table(gff.mito$type)
## where the exons start:
gff.mito$start[gff.mito$type == "exon"]
}
}
\keyword{IO}

\name{write.nexus}
\alias{write.nexus}
\title{Write Tree File in Nexus Format}
\usage{
write.nexus(..., file = "", translate = TRUE)
}
\arguments{
  \item{\dots}{either (i) a single object of class \code{"phylo"}, (ii) a
    series of such objects separated by commas, or (iii) a list
    containing such objects.}
  \item{file}{a file name specified by either a variable of mode character,
    or a double-quoted string; if \code{file = ""} (the default) then the
    tree is written on the standard output connection.}
  \item{translate}{a logical, if \code{TRUE} (the default) a translation
    of the tip labels is done which are replaced in the parenthetic
    representation with tokens.}
}
\description{
  This function writes trees in a file with the NEXUS format.
}
\details{
  If several trees are given, they must all have the same tip labels.

  If among the objects given some are not trees of class \code{"phylo"},
  they are simply skipped and not written in the file.

  See \code{\link{write.tree}} for details on how tip (and node) labels
  are checked before being printed.
}
\value{
  None (invisible `NULL').
}
\references{
  Maddison, D. R., Swofford, D. L. and Maddison, W. P. (1997) NEXUS: an
  extensible file format for systematic information. \emph{Systematic
    Biology}, \bold{46}, 590--621.
}

\author{Emmanuel Paradis}
\seealso{
  \code{\link{read.nexus}}, \code{\link{read.tree}},
  \code{\link{write.tree}}, \code{\link{read.nexus.data}},
  \code{\link{write.nexus.data}}
}
\keyword{manip}
\keyword{IO}

\name{ewLasso}
\alias{ewLasso}
\title{
  Incomplete distances and edge weights of unrooted topology
}
\description{
  This function implements a method for checking whether an incomplete
  set of distances satisfy certain conditions that might make it
  uniquely determine the edge weights of a given topology, T. It prints
  information about whether the graph with vertex set the set of leaves,
  denoted by X, and edge set the set of non-missing distance pairs,
  denoted by L, is connected or strongly non-bipartite. It then also
  checks whether L is a triplet cover for T.
}
\usage{
ewLasso(X, phy)
}
\arguments{
  \item{X}{a distance matrix.}
  \item{phy}{an unrooted tree of class \code{"phylo"}.}
}
\details{
  Missing values must be represented by either \code{NA} or a negative value.

  This implements a method for checking whether an incomplete set of
  distances satisfies certain conditions that might make it uniquely
  determine the edge weights of a given topology, T. It prints
  information about whether the graph, G, with vertex set the set of
  leaves, denoted by X, and edge set the set of non-missing distance
  pairs, denoted by L, is connected or strongly non-bipartite. It also
  checks whether L is a triplet cover for T. If G is not connected, then
  T does not need to be the only topology satisfying the input
  incomplete distances. If G is not strongly non-bipartite then the
  edge-weights of the edges of T are not the unique ones for which the
  input distance is satisfied. If L is a triplet cover, then the input
  distance matrix uniquely determines the edge weights of T. See Dress
  et al. (2012) for details.
}
\value{
  NULL, the results are printed in the console.
}
\references{
  Dress, A. W. M., Huber, K. T., and Steel, M. (2012) `Lassoing' a
  phylogentic tree I: basic properties, shellings and covers.
  \emph{Journal of Mathematical Biology}, \bold{65(1)}, 77--105.
}
\author{Andrei Popescu}
\keyword{multivariate}

\name{coalescent.intervals}
\alias{coalescent.intervals}
\alias{coalescent.intervals.phylo}
\alias{coalescent.intervals.default}
\title{Coalescent Intervals}
\usage{
coalescent.intervals(x)
}
\arguments{
  \item{x}{either an ultra-metric phylogenetic tree (i.e. an object of
    class \code{"phylo"}) or, alternatively, a vector of interval lengths.}
}
\description{
 This function extracts or generates information about coalescent intervals
 (number of lineages, interval lengths, interval count, total depth) from
 a phylogenetic tree or a list of internode distances. The input tree
 needs to be ultra-metric (i.e. clock-like).
}
\value{
An object of class \code{"coalescentIntervals"} with the following entries:

  \item{lineages}{ A vector with the number of lineages at the start of each coalescent
    interval.}
  \item{interval.length}{ A vector with the length of each coalescent
    interval.}
  \item{interval.count}{ The total number of coalescent
    intervals.}
  \item{total.depth}{ The sum of the lengths of all coalescent
    intervals.}
}
\seealso{
\code{\link{branching.times}}, \code{\link{collapsed.intervals}},
\code{\link{read.tree}}.
}
\author{Korbinian Strimmer}
\examples{
data("hivtree.newick") # example tree in NH format
tree.hiv <- read.tree(text = hivtree.newick) # load tree
ci <- coalescent.intervals(tree.hiv) # from tree
ci
data("hivtree.table") # same tree, but in table format
ci <- coalescent.intervals(hivtree.table$size) # from vector of interval lengths
ci
}
\keyword{manip}

\name{corClasses}
\alias{corClasses}
\alias{corPhyl}
\title{Phylogenetic Correlation Structures}
\description{
  Classes of phylogenetic correlation structures (\code{"corPhyl"})
  available in \pkg{ape}.

  \itemize{
    \item{corBrownian}{Brownian motion model (Felsenstein 1985)}
    \item{corMartins}{The covariance matrix defined in Martins and Hansen
      (1997)}
    \item{corGrafen}{The covariance matrix defined in Grafen (1989)}
    \item{corPagel}{The covariance matrix defined in Freckelton et al. (2002)}
    \item{corBlomberg}{The covariance matrix defined in Blomberg et al. (2003)}
  }

  See the help page of each class for references and detailed
  description.
}
\seealso{
  \code{\link[nlme]{corClasses}} and \code{\link[nlme]{gls}} in the
  \pkg{nlme} librarie, \code{\link{corBrownian}},
  \code{\link{corMartins}}, \code{\link{corGrafen}},
  \code{\link{corPagel}}, \code{\link{corBlomberg}},
  \code{\link{vcv}}, \code{\link{vcv2phylo}}
}
\author{Julien Dutheil \email{dutheil@evolbio.mpg.de}, Emmanuel
  Paradis}
\examples{
library(nlme)
txt <- "((((Homo:0.21,Pongo:0.21):0.28,Macaca:0.49):0.13,Ateles:0.62):0.38,Galago:1.00);"
tree.primates <- read.tree(text = txt)
X <- c(4.09434, 3.61092, 2.37024, 2.02815, -1.46968)
Y <- c(4.74493, 3.33220, 3.36730, 2.89037, 2.30259)
Species <- c("Homo", "Pongo", "Macaca", "Ateles", "Galago")
dat <- data.frame(Species = Species, X = X, Y = Y)

m1 <- gls(Y ~ X, dat, correlation=corBrownian(1, tree.primates, form = ~Species))
summary(m1)
m2 <- gls(Y ~ X, dat, correlation=corMartins(1, tree.primates, form = ~Species))
summary(m2)
corMatrix(m2$modelStruct$corStruct)
m3 <- gls(Y ~ X, dat, correlation=corGrafen(1, tree.primates, form = ~Species))
summary(m3)
corMatrix(m3$modelStruct$corStruct)
}
\keyword{models}

\name{mrca}
\alias{mrca}
\alias{getMRCA}
\title{Find Most Recent Common Ancestors Between Pairs}
\description{
  \code{mrca} returns for each pair of tips (and nodes) its most
  recent common ancestor (MRCA).

  \code{getMRCA} returns the MRCA of two or more tips.
}
\usage{
mrca(phy, full = FALSE)
getMRCA(phy, tip)
}
\arguments{
  \item{phy}{an object of class \code{"phylo"}.}
  \item{full}{a logical indicating whether to return the MRCAs among
    all tips and nodes (if \code{TRUE}); the default is to return only
    the MRCAs among tips.}
  \item{tip}{a vector of mode numeric or character specifying the tips;
    can also be node numbers.}
}
\details{
  For \code{mrca}, the diagonal is set to the number of the tips (and
  nodes if \code{full = TRUE}). If \code{full = FALSE}, the colnames and
  rownames are set with the tip labels of the tree; otherwise the
  numbers are given as names.

  For \code{getMRCA}, if \code{tip} is of length one or zero then
  \code{NULL} is returned.
}
\value{
  a matrix of mode numeric (\code{mrca}) or a single numeric value
  (\code{getMRCA}).
}
\author{Emmanuel Paradis, Klaus Schliep, Joseph W. Brown}
\keyword{manip}

\name{mcconwaysims.test}
\alias{mcconwaysims.test}
\title{McConway-Sims Test of Homogeneous Diversification}
\description{
  This function performs the McConway--Sims test that a trait or
  variable does not affect diversification rate.
}
\usage{
mcconwaysims.test(x)
}
\arguments{
  \item{x}{a matrix or a data frame with at least two columns: the first
    one gives the number of species in clades with a trait supposed to
    increase or decrease diversification rate, and the second one the number of
    species in the sister-clades without the trait. Each
    row represents a pair of sister-clades.}
}
\details{
  The McConway--Sims test compares a series of sister-clades where one
  of the two is characterized by a trait supposed to affect
  diversification rate. The null hypothesis is that the trait does not
  affect diversification. The alternative hypothesis is that
  diversification rate is increased or decreased by the trait (by
  contrast to the Slowinski--Guyer test). The test is a likelihood-ratio
  of a null Yule model and an alternative model with two parameters.
}
\value{
  a data frame with the \eqn{\chi^2}{chi2}, the number of degrees of
  freedom, and the \emph{P}-value.
}
\references{
  McConway, K. J. and Sims, H. J. (2004) A likelihood-based method for
  testing for nonstochastic variation of diversification rates in
  phylogenies. \emph{Evolution}, \bold{58}, 12--23.

  Paradis, E. (2012) Shift in diversification in sister-clade
  comparisons: a more powerful test. \emph{Evolution}, \bold{66},
  288--295.
}
\author{Emmanuel Paradis}
\seealso{
  \code{\link{balance}}, \code{\link{slowinskiguyer.test}},
  \code{\link[geiger]{rc}} in \pkg{geiger},
  \code{\link[apTreeshape]{shift.test}} in \pkg{apTreeshape}
}
\examples{
### simulate 10 clades with lambda = 0.1 and mu = 0.09:
n0 <- replicate(10, balance(rbdtree(.1, .09, Tmax = 35))[1])
### simulate 10 clades with lambda = 0.15 and mu = 0.1:
n1 <- replicate(10, balance(rbdtree(.15, .1, Tmax = 35))[1])
x <- cbind(n1, n0)
mcconwaysims.test(x)
slowinskiguyer.test(x)
richness.yule.test(x, 35)
}
\keyword{htest}

\name{bd.ext}
\alias{bd.ext}
\title{Extended Version of the Birth-Death Models to Estimate Speciation
  and Extinction Rates}
\usage{
bd.ext(phy, S, conditional = TRUE)
}
\arguments{
  \item{phy}{an object of class \code{"phylo"}.}
  \item{S}{a numeric vector giving the number of species for each tip.}
  \item{conditional}{whether probabilities should be conditioned on no
    extinction (mainly to compare results with previous analyses; see
    details).}
}
\description{
  This function fits by maximum likelihood a birth-death model to the
  combined phylogenetic and taxonomic data of a given clade. The
  phylogenetic data are given by a tree, and the taxonomic data by the
  number of species for the its tips.
}
\details{
  A re-parametrization of the birth-death model studied by Kendall
  (1948) so that the likelihood has to be maximized over \emph{d/b} and
  \emph{b - d}, where \emph{b} is the birth rate, and \emph{d} the death
  rate.

  The standard-errors of the estimated parameters are computed using a
  normal approximation of the maximum likelihood estimates.

  If the argument \code{S} has names, then they are matched to the tip
  labels of \code{phy}. The user must be careful here since the function
  requires that both series of names perfectly match, so this operation
  may fail if there is a typing or syntax error. If both series of names
  do not match, the values \code{S} are taken to be in the same order
  than the tip labels of \code{phy}, and a warning message is issued.

  Note that the function does not check that the tree is effectively
  ultrametric, so if it is not, the returned result may not be
  meaningful.

  If \code{conditional = TRUE}, the probabilities of the taxonomic data
  are calculated conditioned on no extinction (Rabosky et al. 2007). In
  previous versions of the present function (until ape 2.6-1),
  unconditional probabilities were used resulting in underestimated
  extinction rate. Though it does not make much sense to use
  \code{conditional = FALSE}, this option is provided to compare results
  from previous analyses: if the species richnesses are relatively low,
  both versions will give similar results (see examples).
}
\references{
  Paradis, E. (2003) Analysis of diversification: combining phylogenetic
  and taxonomic data. \emph{Proceedings of the Royal Society of
    London. Series B. Biological Sciences}, \bold{270}, 2499--2505.

  Rabosky, D. L., Donnellan, S. C., Talaba, A. L. and Lovette,
  I. J. (2007) Exceptional among-lineage variation in diversification
  rates during the radiation of Australia's most diverse vertebrate
  clade. \emph{Proceedings of the Royal Society of London. Series
  B. Biological Sciences}, \bold{274}, 2915--2923.
}
\author{Emmanuel Paradis}
\seealso{
  \code{\link{birthdeath}}, \code{\link{branching.times}},
  \code{\link{diversi.gof}}, \code{\link{diversi.time}},
  \code{\link{ltt.plot}}, \code{\link{yule}}, \code{\link{yule.cov}},
  \code{\link{bd.time}}
}
\examples{
### An example from Paradis (2003) using the avian orders:
data(bird.orders)
### Number of species in each order from Sibley and Monroe (1990):
S <- c(10, 47, 69, 214, 161, 17, 355, 51, 56, 10, 39, 152,
       6, 143, 358, 103, 319, 23, 291, 313, 196, 1027, 5712)
bd.ext(bird.orders, S)
bd.ext(bird.orders, S, FALSE) # same than older versions
}
\keyword{models}

\name{unique.multiPhylo}
\alias{unique.multiPhylo}
\title{Revomes Duplicate Trees}
\description{
  This function scans a list of trees, and returns a list with the
  duplicate trees removed. By default the labelled topologies are
  compared.
}
\usage{
\method{unique}{multiPhylo}(x, incomparables = FALSE,
        use.edge.length = FALSE,
        use.tip.label = TRUE, ...)
}
\arguments{
  \item{x}{an object of class \code{"multiPhylo"}.}
  \item{incomparables}{unused (for compatibility with the generic).}
  \item{use.edge.length}{a logical specifying whether to consider the edge
    lengths in the comparisons; the default is \code{FALSE}.}
  \item{use.tip.label}{a logical specifying whether to consider the tip
    labels in the comparisons; the default is \code{TRUE}.}
  \item{\dots}{further arguments passed to or from other methods.}
}
\value{
  an object of class \code{"multiPhylo"} with an attribute
  \code{"old.index"} indicating which trees of the original list are
  similar (the tree of smaller index is taken as reference).
}
\author{Emmanuel Paradis}
\seealso{
  \code{all.equal.phylo}, \code{\link[base]{unique}} for the generic R
  function, \code{read.tree}, \code{read.nexus}
}
\examples{
TR <- rmtree(50, 4)
length(unique(TR)) # not always 15...
howmanytrees(4)
}
\keyword{manip}

\name{read.GenBank}
\alias{read.GenBank}
\title{Read DNA Sequences from GenBank via Internet}
\usage{
read.GenBank(access.nb, seq.names = access.nb, species.names = TRUE,
             as.character = FALSE, chunk.size = 400, quiet = TRUE)
}
\description{
  This function connects to the GenBank database, and reads nucleotide
  sequences using accession numbers given as arguments.
}
\arguments{
  \item{access.nb}{a vector of mode character giving the accession numbers.}
  \item{seq.names}{the names to give to each sequence; by default the
    accession numbers are used.}
  \item{species.names}{a logical indicating whether to attribute the
    species names to the returned object.}
  \item{as.character}{a logical controlling whether to return the
    sequences as an object of class \code{"DNAbin"} (the default).}
  \item{chunk.size}{the number of sequences downloaded together (see
    details).}
  \item{quiet}{a logical value indicating whether to show the progress
    of the downloads. If \code{TRUE}, will also print the (full) name of
    the FASTA file containing the downloaded sequences.}
}
\details{
  The function uses the site \url{https://www.ncbi.nlm.nih.gov/} from
  where the sequences are retrieved.

  If \code{species.names = TRUE}, the returned list has an attribute
  \code{"species"} containing the names of the species taken from the
  field ``ORGANISM'' in GenBank.

  Since \pkg{ape} 3.6, this function retrieves the sequences in FASTA
  format: this is more efficient and more flexible (scaffolds and
  contigs can be read) than what was done in previous versions. The
  option \code{gene.names} has been removed in \pkg{ape} 5.4; this
  information is also present in the description.

  Setting \code{species.names = FALSE} is much faster (could be useful
  if you read a series of scaffolds or contigs, or if you already have
  the species names).

  The argument \code{chunk.size} is set by default to 400 which is
  likely to work in many cases. If an error occurs such as ``Cannot open
  file \dots'' showing the list of the accession numbers, then you may
  try decreasing \code{chunk.size} to 200 or 300.

  If \code{quiet = FALSE}, the display is done chunk by chunk, so the
  message ``Downloading sequences: 400 / 400 ...'' means that the
  download from sequence 1 to sequence 400 is under progress (it is not
  possible to display a more accurate message because the download
  method depends on the platform).
}
\value{
  A list of DNA sequences made of vectors of class \code{"DNAbin"}, or
  of single characters (if \code{as.character = TRUE}) with two
  attributes (species and description).
}
\seealso{
  \code{\link{read.dna}}, \code{\link{write.dna}},
  \code{\link{dist.dna}}, \code{\link{DNAbin}}
}
\author{Emmanuel Paradis}
\examples{
## This won't work if your computer is not connected
## to the Internet

## Get the 8 sequences of tanagers (Ramphocelus)
## as used in Paradis (1997)
ref <- c("U15717", "U15718", "U15719", "U15720",
         "U15721", "U15722", "U15723", "U15724")
## Copy/paste or type the following commands if you
## want to try them.
\dontrun{
Rampho <- read.GenBank(ref)
## get the species names:
attr(Rampho, "species")
## build a matrix with the species names and the accession numbers:
cbind(attr(Rampho, "species"), names(Rampho))
## print the first sequence
## (can be done with `Rampho$U15717' as well)
Rampho[[1]]
## the description from each FASTA sequence:
attr(Rampho, "description")
}
}
\keyword{IO}

\name{MPR}
\alias{MPR}
\title{Most Parsimonious Reconstruction}
\description{
  This function does ancestral character reconstruction by parsimony as
  described in Hanazawa et al. (1995) and modified by Narushima and
  Hanazawa (1997).
}
\usage{
MPR(x, phy, outgroup)
}
\arguments{
  \item{x}{a vector of integers.}
  \item{phy}{an object of class \code{"phylo"}; the tree must be
    unrooted and fully dichotomous.}
  \item{outgroup}{an integer or a character string giving the tip of
    \code{phy} used as outgroup.}
}
\details{
  Hanazawa et al. (1995) and Narushima and Hanazawa (1997) used Farris's
  (1970) and Swofford and Maddison's (1987) framework to reconstruct
  ancestral states using parsimony. The character is assumed to take
  integer values. The algorithm finds the sets of values for each node
  as intervals with lower and upper values.

  It is recommended to root the tree with the outgroup before the
  analysis, so plotting the values with \code{\link{nodelabels}} is
  simple.
}
\value{
  a matrix of integers with two columns named ``lower'' and ``upper''
  giving the lower and upper values of the reconstructed sets for each
  node.
}
\references{
  Farris, J. M. (1970) Methods for computing Wagner trees.
  \emph{Systematic Zoology}, \bold{19}, 83--92.

  Hanazawa, M., Narushima, H. and Minaka, N. (1995) Generating most
  parsimonious reconstructions on a tree: a generalization of the
  Farris--Swofford--Maddison method. \emph{Discrete Applied
    Mathematics}, \bold{56}, 245--265.

  Narushima, H. and Hanazawa, M. (1997) A more efficient algorithm for
  MPR problems in phylogeny. \emph{Discrete Applied Mathematics},
  \bold{80}, 231--238.

  Swofford, D. L. and Maddison, W. P. (1987) Reconstructing ancestral
  character states under Wagner parsimony. \emph{Mathematical
    Biosciences}, \bold{87}, 199--229.
}\author{Emmanuel Paradis}
\seealso{
  \code{\link{ace}}, \code{\link{root}}, \code{\link{nodelabels}}
}
\examples{
## the example in Narushima and Hanazawa (1997):
tr <- read.tree(text = "(((i,j)c,(k,l)b)a,(h,g)e,f)d;")
x <- c(1, 3, 0, 6, 5, 2, 4)
names(x) <- letters[6:12]
(o <- MPR(x, tr, "f"))
plot(tr)
nodelabels(paste0("[", o[, 1], ",", o[, 2], "]"))
tiplabels(x[tr$tip.label], adj = -2)
## some random data:
x <- rpois(30, 1)
tr <- rtree(30, rooted = FALSE)
MPR(x, tr, "t1")
}
\keyword{models}

\name{plot.phylo}
\alias{plot.phylo}
\alias{plot.multiPhylo}
\title{Plot Phylogenies}
\description{
  These functions plot phylogenetic trees on the current graphical
  device.
}
\usage{
\method{plot}{phylo}(x, type = "phylogram", use.edge.length = TRUE,
    node.pos = NULL, show.tip.label = TRUE, show.node.label = FALSE,
    edge.color = "black", edge.width = 1, edge.lty = 1, font = 3,
    cex = par("cex"), adj = NULL, srt = 0, no.margin = FALSE,
    root.edge = FALSE, label.offset = 0, underscore = FALSE,
    x.lim = NULL, y.lim = NULL, direction = "rightwards",
    lab4ut = NULL, tip.color = "black", plot = TRUE,
    rotate.tree = 0, open.angle = 0, node.depth = 1,
    align.tip.label = FALSE, ...)
\method{plot}{multiPhylo}(x, layout = 1, ...)
}
\arguments{
  \item{x}{an object of class \code{"phylo"} or of class
    \code{"multiPhylo"}.}
  \item{type}{a character string specifying the type of phylogeny to be
    drawn; it must be one of "phylogram" (the default), "cladogram",
    "fan", "unrooted", "radial" or any unambiguous abbreviation of
    these.}
  \item{use.edge.length}{a logical indicating whether to use the edge
    lengths of the phylogeny to draw the branches (the default) or not
    (if \code{FALSE}). This option has no effect if the object of class
    \code{"phylo"} has no `edge.length' element.}
  \item{node.pos}{a numeric taking the value 1 or 2 which specifies the
    vertical position of the nodes with respect to their descendants. If
    \code{NULL} (the default), then the value is determined in relation
    to `type' and `use.edge.length' (see details).}
  \item{show.tip.label}{a logical indicating whether to show the tip
    labels on the phylogeny (defaults to \code{TRUE}, i.e. the labels
    are shown).}
  \item{show.node.label}{a logical indicating whether to show the node
    labels on the phylogeny (defaults to \code{FALSE}, i.e. the labels
    are not shown).}
  \item{edge.color}{a vector of mode character giving the colours used
    to draw the branches of the plotted phylogeny. These are taken to be
    in the same order than the component \code{edge} of \code{phy}. If
    fewer colours are given than the length of \code{edge}, then the
    colours are recycled.}
  \item{edge.width}{a numeric vector giving the width of the branches of
    the plotted phylogeny. These are taken to be in the same order than
    the component \code{edge} of \code{phy}. If fewer widths are given
    than the length of \code{edge}, then these are recycled.}
  \item{edge.lty}{same than the previous argument but for line types;
    1: plain, 2: dashed, 3: dotted, 4: dotdash, 5: longdash, 6: twodash.}
  \item{font}{an integer specifying the type of font for the labels: 1
    (plain text), 2 (bold), 3 (italic, the default), or 4 (bold
    italic).}
  \item{cex}{a numeric value giving the factor scaling of the tip and
    node labels (Character EXpansion). The default is to take the
    current value from the graphical parameters.}
  \item{adj}{a numeric specifying the justification of the text strings
    of the labels: 0 (left-justification), 0.5 (centering), or 1
    (right-justification). This option has no effect if \code{type =
      "unrooted"}. If \code{NULL} (the default) the value is set with
    respect of \code{direction} (see details).}
  \item{srt}{a numeric giving how much the labels are rotated in degrees
    (negative values are allowed resulting in clock-like rotation); the
    value has an effect respectively to the value of
    \code{direction} (see Examples). This option has no effect if
    \code{type = "unrooted"}.}
  \item{no.margin}{a logical. If \code{TRUE}, the margins are set to
    zero and the plot uses all the space of the device (note that this
    was the behaviour of \code{plot.phylo} up to version 0.2-1 of `ape'
    with no way to modify it by the user, at least easily).}
  \item{root.edge}{a logical indicating whether to draw the root edge
    (defaults to FALSE); this has no effect if `use.edge.length = FALSE'
    or if `type = "unrooted"'.}
  \item{label.offset}{a numeric giving the space between the nodes and
    the tips of the phylogeny and their corresponding labels. This
    option has no effect if \code{type = "unrooted"}.}
  \item{underscore}{a logical specifying whether the underscores in tip
    labels should be written as spaces (the default) or left as are (if
    \code{TRUE}).}
  \item{x.lim}{a numeric vector of length one or two giving the limit(s)
    of the x-axis. If \code{NULL}, this is computed with respect to
    various parameters such as the string lengths of the labels and the
    branch lengths. If a single value is given, this is taken as the
    upper limit.}
  \item{y.lim}{same than above for the y-axis.}
  \item{direction}{a character string specifying the direction of the
    tree. Four values are possible: "rightwards" (the default),
    "leftwards", "upwards", and "downwards".}
  \item{lab4ut}{(= labels for unrooted trees) a character string
    specifying the display of tip labels for unrooted trees (can be
    abbreviated): either \code{"horizontal"} where all labels are
    horizontal (the default if \code{type = "u"}), or \code{"axial"}
    where the labels are displayed in the axis of the corresponding
    terminal branches. This option has an effect if \code{type = "u"},
    \code{"f"}, or \code{"r"}.}
  \item{tip.color}{the colours used for the tip labels, eventually
    recycled (see examples).}
  \item{plot}{a logical controlling whether to draw the tree. If
    \code{FALSE}, the graphical device is set as if the tree was
    plotted, and the coordinates are saved as well.}
  \item{rotate.tree}{for "fan", "unrooted", or "radial" trees: the
    rotation of the whole tree in degrees (negative values are
    accepted).}
  \item{open.angle}{if \code{type = "f"} or \code{"r"}, the angle in
    degrees left blank. Use a non-zero value if you want to call
    \code{\link{axisPhylo}} after the tree is plotted.}
  \item{node.depth}{an integer value (1 or 2) used if branch lengths are
    not used to plot the tree; 1: the node depths are proportional to
    the number of tips descending from each node (the default and was the
    only possibility previously), 2: they are evenly spaced.}
  \item{align.tip.label}{a logical value or an integer. If \code{TRUE},
    the tips are aligned and dotted lines are drawn between the tips of
    the tree and the labels. If an integer, the tips are aligned and
    this gives the type of the lines (\code{lty}).}
  \item{layout}{the number of trees to be plotted simultaneously.}
  \item{\dots}{further arguments to be passed to \code{plot} or to
    \code{plot.phylo}.}
}
\details{
  If \code{x} is a list of trees (i.e., an object of class
  \code{"multiPhylo"}), then any further argument may be passed with
  \code{...} and could be any one of those listed above for a single
  tree.

  The font format of the labels of the nodes and the tips is the same.

  If \code{no.margin = TRUE}, the margins are set to zero and are not
  restored after plotting the tree, so that the user can access the
  coordinates system of the plot.

  The option `node.pos' allows the user to alter the vertical position
  (i.e., ordinates) of the nodes. If \code{node.pos = 1}, then the
  ordinate of a node is the mean of the ordinates of its direct
  descendants (nodes and/or tips). If \code{node.pos = 2}, then the
  ordinate of a node is the mean of the ordinates of all the tips of
  which it is the ancestor. If \code{node.pos = NULL} (the default),
  then its value is determined with respect to other options: if
  \code{type = "phylogram"} then `node.pos = 1'; if \code{type =
    "cladogram"} and \code{use.edge.length = FALSE} then `node.pos = 2';
  if \code{type = "cladogram"} and \code{use.edge.length = TRUE} then
  `node.pos = 1'. Remember that in this last situation, the branch
  lengths make sense when projected on the x-axis.

  If \code{adj} is not specified, then the value is determined with
  respect to \code{direction}: if \code{direction = "leftwards"} then
  \code{adj = 1} (0 otherwise).

  If the arguments \code{x.lim} and \code{y.lim} are not specified by the
  user, they are determined roughly by the function. This may not always
  give a nice result: the user may check these values with the
  (invisibly) returned list (see ``Value:'').

  If you use \code{align.tip.label = TRUE} with \code{type = "fan"}, you
  will have certainly to set  \code{x.lim} and \code{y.lim} manually.

  If you resize manually the graphical device (windows or X11) you may
  need to replot the tree.
}
\note{
  The argument \code{asp} cannot be passed with \code{\dots}.
}
\value{
  \code{plot.phylo} returns invisibly a list with the following
  components which values are those used for the current plot:

  \item{type}{}
  \item{use.edge.length}{}
  \item{node.pos}{}
  \item{node.depth}{}
  \item{show.tip.label}{}
  \item{show.node.label}{}
  \item{font}{}
  \item{cex}{}
  \item{adj}{}
  \item{srt}{}
  \item{no.margin}{}
  \item{label.offset}{}
  \item{x.lim}{}
  \item{y.lim}{}
  \item{direction}{}
  \item{tip.color}{}
  \item{Ntip}{}
  \item{Nnode}{}
  \item{root.time}{}
  \item{align.tip.label}{}
}
\author{Emmanuel Paradis}
\seealso{
  \code{\link{read.tree}}, \code{\link{trex}}, \code{\link{kronoviz}},
  \code{\link{add.scale.bar}}, \code{\link{axisPhylo}},
  \code{\link{nodelabels}}, \code{\link{edges}},
  \code{\link[graphics]{plot}} for the basic plotting function in R
}
\examples{
### An extract from Sibley and Ahlquist (1990)
cat("(((Strix_aluco:4.2,Asio_otus:4.2):3.1,",
   "Athene_noctua:7.3):6.3,Tyto_alba:13.5);",
   file = "ex.tre", sep = "\n")
tree.owls <- read.tree("ex.tre")
plot(tree.owls)
unlink("ex.tre") # delete the file "ex.tre"

### Show the types of trees.
layout(matrix(1:6, 3, 2))
plot(tree.owls, main = "With branch lengths")
plot(tree.owls, type = "c")
plot(tree.owls, type = "u")
plot(tree.owls, use.edge.length = FALSE, main = "Without branch lengths")
plot(tree.owls, type = "c", use.edge.length = FALSE)
plot(tree.owls, type = "u", use.edge.length = FALSE)
layout(1)

data(bird.orders)
### using random colours and thickness
plot(bird.orders,
     edge.color = sample(colors(), length(bird.orders$edge)/2),
     edge.width = sample(1:10, length(bird.orders$edge)/2, replace = TRUE))
title("Random colours and branch thickness")
### rainbow colouring...
X <- c("red", "orange", "yellow", "green", "blue", "purple")
plot(bird.orders,
     edge.color = sample(X, length(bird.orders$edge)/2, replace = TRUE),
     edge.width = sample(1:10, length(bird.orders$edge)/2, replace = TRUE))
title("Rainbow colouring")
plot(bird.orders, type = "c", use.edge.length = FALSE,
     edge.color = sample(X, length(bird.orders$edge)/2, replace = TRUE),
     edge.width = rep(5, length(bird.orders$edge)/2))
segments(rep(0, 6), 6.5:1.5, rep(2, 6), 6.5:1.5, lwd = 5, col = X)
text(rep(2.5, 6), 6.5:1.5, paste(X, "..."), adj = 0)
title("Character mapping...")
plot(bird.orders, "u", font = 1, cex = 0.75)
data(bird.families)
plot(bird.families, "u", lab4ut = "axial", font = 1, cex = 0.5)
plot(bird.families, "r", font = 1, cex = 0.5)
### cladogram with oblique tip labels
plot(bird.orders, "c", FALSE, direction = "u", srt = -40, x.lim = 25.5)
### facing trees with different informations...
tr <- bird.orders
tr$tip.label <- rep("", 23)
layout(matrix(1:2, 1, 2), c(5, 4))
plot(bird.orders, "c", FALSE, adj = 0.5, no.margin = TRUE, label.offset = 0.8,
     edge.color = sample(X, length(bird.orders$edge)/2, replace = TRUE),
     edge.width = rep(5, length(bird.orders$edge)/2))
text(7.5, 23, "Facing trees with\ndifferent informations", font = 2)
plot(tr, "p", direction = "l", no.margin = TRUE,
     edge.width = sample(1:10, length(bird.orders$edge)/2, replace = TRUE))
### Recycling of arguments gives a lot of possibilities
### for tip labels:
plot(bird.orders, tip.col = c(rep("red", 5), rep("blue", 18)),
     font = c(rep(3, 5), rep(2, 17), 1))
plot(bird.orders, tip.col = c("blue", "green"),
     cex = 23:1/23 + .3, font = 1:3)
co <- c(rep("blue", 9), rep("green", 35))
plot(bird.orders, "f", edge.col = co)
plot(bird.orders, edge.col = co)
layout(1)
}
\keyword{hplot}

\name{read.caic}
\alias{read.caic}
\title{Read Tree File in CAIC Format}
\description{
This function reads one tree from a CAIC file.
A second file containing branch lengths values may also be passed (experimental).
}
\usage{
read.caic(file, brlen = NULL, skip = 0, comment.char = "#", ...)
}
\arguments{
  \item{file}{a file name specified by either a variable of mode character, or a double-quoted string.}
  \item{brlen}{a file name for the branch lengths file.}
  \item{skip}{the number of lines of the input file to skip before beginning to read data (this is passed directly to scan()).}
  \item{comment.char}{a single character, the remaining of the line after this character is ignored (this is passed directly to scan()).}
  \item{\dots}{Further arguments to be passed to scan().}
}
\details{
  Read a tree from a file in the format used by the CAIC and MacroCAIc program.
}
\value{
  an object of class \code{"phylo"}.
}
\references{
  Purvis, A. and Rambaut, A. (1995) Comparative analysis by independent
  contrasts (CAIC): an Apple Macintosh application for analysing
  comparative data. \emph{CABIOS}, \bold{11} :241--251.
}
\author{Julien Dutheil \email{dutheil@evolbio.mpg.de}}
\section{Warning}{The branch length support is still experimental and was not fully tested.}
\seealso{ \code{\link{read.tree}}, \code{\link{read.nexus}} }
\examples{
### The same example than in read.tree, without branch lengths.
### An extract from Sibley and Ahlquist (1990)
cat("AAA","Strix_aluco","AAB","Asio_otus",
   "AB","Athene_noctua","B","Tyto_alba",
   file = "ex.tre", sep = "\n")
tree.owls <- read.caic("ex.tre")
plot(tree.owls)
tree.owls
unlink("ex.tre") # delete the file "ex.tre"
}
\keyword{hplot}

\name{is.monophyletic}
\alias{is.monophyletic}
\title{
  Is Group Monophyletic
}
\usage{
is.monophyletic(phy, tips, reroot = !is.rooted(phy), plot = FALSE, ...)
}
\description{
    This function tests whether a list of tip labels is monophyletic on a given tree.
}
\arguments{
    \item{phy}{
        a phylogenetic tree description of class \code{"phylo"}.
    }
    \item{tips}{
       a vector of mode numeric or character specifying the tips to be tested.
    }
    \item{reroot}{
       a logical. If \code{FALSE}, then the input tree is not unrooted before the test.
    }
    \item{plot}{
        a logical. If \code{TRUE}, then the tree is plotted with the specified group \code{tips} highlighted.
    }
    \item{\dots}{
       further arguments passed to \code{plot}.
    }
}
\details{
    If \code{phy} is rooted, the test is done on the rooted tree, otherwise
    the tree is first unrooted, then arbitrarily rerooted, in order to be
    independent on the current position of the root. That is, the test
    asks if \code{tips} could be monophyletic given any favourably rooting
    of \code{phy}.

    If \code{phy} is unrooted the test is done on an unrooted tree, unless
    \code{reroot = FALSE} is specified.

    If tip labels in the list \code{tips} are given as characters, they need
    to be spelled as in the object \code{phy}.
}
\value{
    \code{TRUE} or \code{FALSE}.
}
\author{
    Johan Nylander \email{jnylander@users.sourceforge.net}
}
\seealso{
    \code{\link{which.edge}}, \code{\link{drop.tip}}, \code{\link{mrca}}.
}
\examples{
    ## Test one monophyletic and one paraphyletic group on the bird.orders tree
    \dontrun{data("bird.orders")}
    \dontrun{is.monophyletic(phy = bird.orders, tips = c("Ciconiiformes", "Gruiformes"))}
    \dontrun{is.monophyletic(bird.orders, c("Passeriformes", "Ciconiiformes", "Gruiformes"))}
    \dontshow{\dontrun{rm(bird.orders)}}
}
\keyword{utilities}

\name{add.scale.bar}
\alias{add.scale.bar}
\title{Add a Scale Bar to a Phylogeny Plot}
\usage{
add.scale.bar(x, y, length = NULL, ask = FALSE,
              lwd = 1, lcol = "black", ...)
}
\arguments{
  \item{x}{x location of the bar (can be left missing).}
  \item{y}{y location of the bar (can be left missing).}
  \item{length}{a numeric value giving the length of the scale bar. If
    none is supplied, a value is calculated from the data.}
  \item{ask}{a logical; if \code{TRUE} the user is asked to click where
    to draw the bar. The default is \code{FALSE}.}
  \item{lwd}{the width of the bar.}
  \item{lcol}{the colour of the bar (use \code{col} for the colour of
    the text).}
  \item{\dots}{further arguments to be passed to \code{text}.}
}
\description{
  This function adds a horizontal bar giving the scale of the branch
  lengths to a plot of a phylogenetic tree on the current graphical
  device.
}
\details{
  By default, the bar is placed in a corner of the graph depending on
  the direction of the tree. Otherwise both \code{x} and \code{y} must
  be specified (if only one is given it is ignored).

  The further arguments (\code{\dots}) are used to format the text. They
  may be \code{font}, \code{cex}, \code{col}, and so on (see examples
  below, and the help page on \code{\link[graphics]{text}}).

  The function \code{\link[graphics]{locator}}  may be used to
  determine the \code{x} and \code{y} arguments.
}
\author{Emmanuel Paradis}
\seealso{
  \code{\link{plot.phylo}}, \code{\link{axisPhylo}},
  \code{\link[graphics]{locator}}
}
\examples{
tr <- rtree(10)
layout(matrix(1:2, 2, 1))
plot(tr)
add.scale.bar()
plot(tr)
add.scale.bar(cex = 0.7, font = 2, col = "red")
layout(1)
}
\keyword{aplot}

\name{rtt}
\alias{rtt}
\title{Root a Tree by Root-to-Tip Regression}
\description{
  This function roots a phylogenetic tree with dated tips in the location
  most compatible with the assumption of a strict molecular clock.
}
\usage{
rtt(t, tip.dates, ncpu = 1, objective = correlation,
    opt.tol = .Machine$double.eps^0.25)
}
\arguments{
  \item{t}{an object of class \code{"phylo"}.}
  \item{tip.dates}{a vector of sampling times associated to the tips of
    \code{t}, in the same order as \code{t$tip.label}.}
  \item{ncpu}{number of cores to use.}
  \item{objective}{one of \code{"correlation"}, \code{"rms"}, or
    \code{"rsquared"}.}
  \item{opt.tol}{tolerance for optimization precision.}
}
\details{
  This function duplicates one part the functionality of the program
  Path-O-Gen (see references). The root position is chosen to produce
  the best linear regression of root-to-tip distances against sampling
  times.

  \code{t} must have branch lengths in units of expected substitutions
  per site.

  \code{tip.dates} should be a vector of sampling times, in any time
  unit, with time increasing toward the present. For example, this may
  be in units of ``days since study start'' or ``years since 10,000
  BCE'', but not ``millions of yearsago''.

  Setting \code{ncpu} to a value larger than 1 requires the \code{parallel}
  library.

  \code{objective} is the measure which will be used to define the
  ``goodness'' of a regression fit. It may be one of \code{"correlation"}
  (strongest correlation between tip date and distance from root),
  \code{"rms"} (lowest root-mean-squared error), or \code{"rsquared"}
  (highest R-squared value).

  \code{opt.tol} is used to optimize the location of the root along the best
  branch. By default, R's \code{optimize} function uses a precision of
  \code{.Machine$double.eps^0.25}, which is about 0.0001 on a 64-bit system.
  This should be set to a smaller value if the branch lengths of \code{t} are
  very short.
}
\value{
  an object of class \code{"phylo"}.
}
\note{
  This function only chooses the best root. It does not rescale the branch
  lengths to time, or perform a statistical test of the molecular clock
  hypothesis.
}
\author{
  Rosemary McCloskey\email{rmccloskey@cfenet.ubc.ca},
  Emmanuel Paradis
}
\references{
  Rambaut, A. (2009). Path-O-Gen: temporal signal investigation
  tool.

  Rambaut, A. (2000). Estimating the rate of molecular evolution:
  incorporating non-contemporaneous sequences into maximum likelihood
  phylogenies. \emph{Bioinformatics}, \bold{16}, 395-399.
}
\examples{
t <- rtree(100)
tip.date <- rnorm(t$tip.label)^2
rtt(t, tip.date)
}

\name{Moran.I}
\alias{Moran.I}
\title{Moran's I Autocorrelation Index}
\usage{
  Moran.I(x, weight, scaled = FALSE, na.rm = FALSE,
          alternative = "two.sided")
}
\arguments{
  \item{x}{a numeric vector.}
  \item{weight}{a matrix of weights.}
  \item{scaled}{a logical indicating whether the coefficient should be
    scaled so that it varies between -1 and +1 (default to
    \code{FALSE}).}
  \item{na.rm}{a logical indicating whether missing values should be
    removed.}
  \item{alternative}{a character string specifying the alternative
    hypothesis that is tested against the null hypothesis of no
    phylogenetic correlation; must be of one "two.sided", "less", or
    "greater", or any unambiguous abbrevation of these.}
}
\description{
  This function computes Moran's I autocorrelation coefficient of
  \code{x} giving a matrix of weights using the method described by
  Gittleman and Kot (1990).
}
\details{
  The matrix \code{weight} is used as ``neighbourhood'' weights, and
  Moran's I coefficient is computed using the formula:
  \deqn{I = \frac{n}{S_0} \frac{\sum_{i=1}^n\sum_{j=1}^n w_{i,j}(y_i -
      \overline{y})(y_j - \overline{y})}{\sum_{i=1}^n {(y_i -
	\overline{y})}^2}}{\code{I = n/S0 * (sum\{i=1..n\} sum\{j=1..n\} wij(yi - ym))(yj - ym)
      / (sum\{i=1..n\} (yi - ym)^2)}}
  with
  \itemize{
    \item \eqn{y_i}{yi} = observations
    \item \eqn{w_{i,j}}{wij} = distance weight
    \item \eqn{n} = number of observations
    \item \eqn{S_0}{S0} = \eqn{\sum_{i=1}^n\sum_{j=1}^n wij}{\code{sum_{i=1..n} sum{j=1..n} wij}}
  }

  The null hypothesis of no phylogenetic correlation is tested assuming
  normality of I under this null hypothesis. If the observed value
  of I is significantly greater than the expected value, then the values
  of \code{x} are positively autocorrelated, whereas if Iobserved <
  Iexpected, this will indicate negative autocorrelation.
}
\value{
  A list containing the elements:

  \item{observed}{the computed Moran's I.}
  \item{expected}{the expected value of I under the null hypothesis.}
  \item{sd}{the standard deviation of I under the null hypothesis.}
  \item{p.value}{the P-value of the test of the null hypothesis against
    the alternative hypothesis specified in \code{alternative}.}
}
\references{
  Gittleman, J. L. and Kot, M. (1990) Adaptation: statistics and a null
  model for estimating phylogenetic effects. \emph{Systematic Zoology},
  \bold{39}, 227--241.
}
\author{Julien Dutheil \email{dutheil@evolbio.mpg.de} and
  Emmanuel Paradis}
\seealso{\code{\link{weight.taxo}}}
\examples{
tr <- rtree(30)
x <- rnorm(30)
## weights w[i,j] = 1/d[i,j]:
w <- 1/cophenetic(tr)
## set the diagonal w[i,i] = 0 (instead of Inf...):
diag(w) <- 0
Moran.I(x, w)
Moran.I(x, w, alt = "l")
Moran.I(x, w, alt = "g")
Moran.I(x, w, scaled = TRUE) # usualy the same
}
\keyword{models}
\keyword{regression}

\name{mcmc.popsize}
\alias{mcmc.popsize}
\alias{extract.popsize}
\alias{plot.popsize}
\alias{lines.popsize}
\title{Reversible Jump MCMC to Infer Demographic History}
\usage{
mcmc.popsize(tree,nstep, thinning=1, burn.in=0,progress.bar=TRUE,
    method.prior.changepoints=c("hierarchical", "fixed.lambda"), max.nodes=30,
   lambda=0.5, gamma.shape=0.5, gamma.scale=2,
    method.prior.heights=c("skyline", "constant", "custom"),
    prior.height.mean,
    prior.height.var)
extract.popsize(mcmc.out, credible.interval=0.95, time.points=200, thinning=1, burn.in=0)
\method{plot}{popsize}(x, show.median=TRUE, show.years=FALSE,
             subst.rate, present.year, xlab = NULL,
             ylab = "Effective population size", log = "y", ...)
\method{lines}{popsize}(x, show.median=TRUE,show.years=FALSE, subst.rate, present.year, ...)

}
\arguments{
  \item{tree}{Either an ultrametric tree (i.e. an object of class \code{"phylo"}),
           or coalescent intervals (i.e. an object of class \code{"coalescentIntervals"}). }
  \item{nstep}{Number of MCMC steps, i.e. length of the Markov chain (suggested value: 10,000-50,000).}
  \item{thinning}{Thinning factor (suggest value: 10-100).}
  \item{burn.in}{Number of steps dropped from the chain to allow for a burn-in phase (suggest value: 1000).}

  \item{progress.bar}{Show progress bar during the MCMC run.}

  \item{method.prior.changepoints}{If \code{hierarchical}is chosen (the default) then the smoothing parameter lambda is drawn from
     a gamma distribution with some specified shape and scale parameters.
     Alternatively, for \code{fixed.lambda} the value of lambda is   a given constant.
  }

  \item{max.nodes}{Upper limit for the number of internal nodes of the approximating spline (default: 30).}
  \item{lambda}{Smoothing parameter. For \code{method="fixed.lambda"} the specifed value of lambda determines
      the mean of the prior distribution   for the number of internal nodes of the approximating
      spline for the demographic function (suggested value: 0.1-1.0).}
  \item{gamma.shape}{Shape parameter of the gamma function from which \code{lambda} is drawn for
    \code{method="hierarchical"}.}
   \item{gamma.scale}{Scale parameter of the gamma function from which \code{lambda} is drawn for
    \code{method="hierarchical"}.}
  \item{method.prior.heights}{Determines the prior for the heights of the change points.
          If \code{custom} is chosen then two functions describing the mean and variance
	  of the heigths in depence of time have to be specified (via \code{prior.height.mean}
	  and \code{prior.height.var} options).  Alternatively, two built-in priors are available:
	  \code{constant} assumes constant population size and variance determined by Felsenstein
	  (1992), and \code{skyline} assumes a skyline plot (see Opgen-Rhein et al. 2004 for
	  more details).}
  \item{prior.height.mean}{Function describing the mean of the prior distribution for the heights
                           (only used if \code{method.prior.heights = custom}).}

  \item{prior.height.var}{Function describing the variance of the prior distribution for the heights
                           (only used if \code{method.prior.heights = custom}).}
  \item{mcmc.out}{Output from \code{mcmc.popsize} - this is needed as input for \code{extract.popsize}.}
 \item{credible.interval}{Probability mass of the confidence band (default: 0.95).}

 \item{time.points}{Number of discrete time points in the table output by \code{extract.popsize}.}

 \item{x}{Table with population size versus time, as computed by \code{extract.popsize}. }

 \item{show.median}{Plot median rather than mean as point estimate for demographic function (default: TRUE).}

  \item{show.years}{Option that determines whether the time is plotted in units of
    of substitutions (default) or in years (requires specification of substution rate
    and year of present).}
  \item{subst.rate}{Substitution rate (see option show.years).}
  \item{present.year}{Present year (see option show.years).}
  \item{xlab}{label on the x-axis (depends on the value of
    \code{show.years}).}
  \item{ylab}{label on the y-axis.}
  \item{log}{log-transformation of axes; by default, the y-axis is
    log-transformed.}
  \item{\dots}{Further arguments to be passed on  to \code{plot} or \code{lines}.}
}
\description{
 These functions implement a reversible jump MCMC framework to infer the demographic history,
 as well as corresponding confidence bands,
 from a genealogical tree. The computed demographic history is a continous
 and smooth function in time.
 \code{mcmc.popsize} runs the actual MCMC chain and outputs information about the
 sampling steps, \code{extract.popsize} generates from this MCMC
 output a table of population size in time, and  \code{plot.popsize} and \code{lines.popsize}
 provide utility functions to plot the corresponding demographic functions.
}

\details{
 Please refer to Opgen-Rhein et al. (2005) for methodological details, and the help page of
 \code{\link{skyline}} for information on a related approach.
}
\author{
  Rainer Opgen-Rhein and Korbinian Strimmer. Parts of the rjMCMC
  sampling procedure are adapted from \R code by Karl Broman.
}
\seealso{
\code{\link{skyline}} and \code{\link{skylineplot}}. }
\references{
  Opgen-Rhein, R., Fahrmeir, L. and Strimmer, K. 2005. Inference of
  demographic history from genealogical trees using reversible jump
  Markov chain Monte Carlo. \emph{BMC Evolutionary Biology}, \bold{5},
  6.
}
\examples{
# get tree
data("hivtree.newick") # example tree in NH format
tree.hiv <- read.tree(text = hivtree.newick) # load tree

# run mcmc chain
mcmc.out <- mcmc.popsize(tree.hiv, nstep=100, thinning=1, burn.in=0,progress.bar=FALSE) # toy run
#mcmc.out <- mcmc.popsize(tree.hiv, nstep=10000, thinning=5, burn.in=500) # remove comments!!

# make list of population size versus time
popsize  <- extract.popsize(mcmc.out)

# plot and compare with skyline plot
sk <- skyline(tree.hiv)
plot(sk, lwd=1, lty=3, show.years=TRUE, subst.rate=0.0023, present.year = 1997)
lines(popsize, show.years=TRUE, subst.rate=0.0023, present.year = 1997)
}
\keyword{manip}

\name{compar.lynch}
\alias{compar.lynch}
\title{Lynch's Comparative Method}
\usage{
compar.lynch(x, G, eps = 1e-4)
}
\arguments{
  \item{x}{eiher a matrix, a vector, or a data.frame containing the data
    with species as rows and variables as columns.}
  \item{G}{a matrix that can be interpreted as an among-species correlation
    matrix.}
  \item{eps}{a numeric value to detect convergence of the EM algorithm.}
}
\description{
  This function computes the heritable additive value and the residual
  deviation for continous characters, taking into account the
  phylogenetic relationships among species, following the comparative
  method described in Lynch (1991).
}
\details{
  The parameter estimates are computed following the EM
  (expectation-maximization) algorithm. This algorithm usually leads to
  convergence but may lead to local optima of the likelihood
  function. It is recommended to run several times the function in order
  to detect these potential local optima. The `optimal' value for
  \code{eps} depends actually on the range of the data and may be
  changed by the user in order to check the stability of the parameter
  estimates. Convergence occurs when the differences between two
  successive iterations of the EM algorithm leads to differences between
  both residual and additive values less than or equal to \code{eps}.
}
\note{
  The present function does not perform the estimation of ancestral
  phentoypes as proposed by Lynch (1991). This will be implemented in
  a future version.
}
\value{
  A list with the following components:
  \item{vare}{estimated residual variance-covariance matrix.}
  \item{vara}{estimated additive effect variance covariance matrix.}
  \item{u}{estimates of the phylogeny-wide means.}
  \item{A}{addtitive value estimates.}
  \item{E}{residual values estimates.}
  \item{lik}{logarithm of the likelihood for the entire set of observed
    taxon-specific mean.}
}
\references{
  Lynch, M. (1991) Methods for the analysis of comparative data in
  evolutionary biology. \emph{Evolution}, \bold{45}, 1065--1080.
}
\author{Julien Claude \email{julien.claude@umontpellier.fr}}
\seealso{
  \code{\link{pic}}, \code{\link{compar.gee}}
}
\examples{
### The example in Lynch (1991)
cat("((((Homo:0.21,Pongo:0.21):0.28,",
   "Macaca:0.49):0.13,Ateles:0.62):0.38,Galago:1.00);",
   file = "ex.tre", sep = "\n")
tree.primates <- read.tree("ex.tre")
unlink("ex.tre")
X <- c(4.09434, 3.61092, 2.37024, 2.02815, -1.46968)
Y <- c(4.74493, 3.33220, 3.36730, 2.89037, 2.30259)
compar.lynch(cbind(X, Y),
             G = vcv.phylo(tree.primates, cor = TRUE))
}
\keyword{regression}

\name{BIONJ}
\alias{bionj}
\title{
  Tree Estimation Based on an Improved Version of the NJ Algorithm
}
\description{
  This function performs the BIONJ algorithm of Gascuel (1997).
}
\usage{
bionj(X)
}
\arguments{
  \item{X}{a distance matrix; may be an object of class \code{"dist"}.}
}
\value{
  an object of class \code{"phylo"}.
}
\references{
  Gascuel, O. (1997) BIONJ: an improved version of the NJ algorithm
  based on a simple model of sequence data.
  \emph{Molecular Biology and Evolution}, \bold{14:}, 685--695.
}
\author{
  original C code by Hoa Sien Cuong and Olivier Gascuel; adapted and
  ported to \R by Vincent Lefort \email{vincent.lefort@lirmm.fr}
}
\seealso{
  \code{\link{nj}}, \code{\link{fastme}}, \code{\link{mvr}},
  \code{\link{bionjs}}, \code{\link{SDM}}, \code{\link{dist.dna}}
}
\examples{
### From Saitou and Nei (1987, Table 1):
x <- c(7, 8, 11, 13, 16, 13, 17, 5, 8, 10, 13,
       10, 14, 5, 7, 10, 7, 11, 8, 11, 8, 12,
       5, 6, 10, 9, 13, 8)
M <- matrix(0, 8, 8)
M[lower.tri(M)] <- x
M <- t(M)
M[lower.tri(M)] <- x
dimnames(M) <- list(1:8, 1:8)
tr <- bionj(M)
plot(tr, "u")
### a less theoretical example
data(woodmouse)
trw <- bionj(dist.dna(woodmouse))
plot(trw)
}
\keyword{models}

\encoding{utf8}
\name{diversi.gof}
\alias{diversi.gof}
\title{Tests of Constant Diversification Rates}
\usage{
diversi.gof(x, null = "exponential", z = NULL)
}
\arguments{
  \item{x}{a numeric vector with the branching times.}
  \item{null}{a character string specifying the null distribution for
    the branching times. Only two choices are possible: either
    \code{"exponential"}, or \code{"user"}.}
  \item{z}{used if \code{null = "user"}; gives the expected distribution
    under the model.}
}
\description{
  This function computes two tests of the distribution of branching
  times using the \enc{Cramér}{Cramer}--von Mises and Anderson--Darling
  goodness-of-fit tests. By default, it is assumed that the
  diversification rate is constant, and an exponential distribution is
  assumed for the branching times. In this case, the expected
  distribution under this model is computed with a rate estimated from
  the data. Alternatively, the user may specify an expected cumulative
  density function (\code{z}): in this case, \code{x} and \code{z} must
  be of the same length. See the examples for how to compute the latter
  from a sample of expected branching times.
}
\details{
  The \enc{Cramér}{Cramer}--von Mises and Anderson--Darling tests
  compare the empirical density function (EDF) of the observations to an
  expected cumulative density function. By contrast to the
  Kolmogorov--Smirnov test where the greatest difference between these
  two functions is used, in both tests all differences are taken into
  account.

  The distributions of both test statistics depend on the null
  hypothesis, and on whether or not some parameters were estimated from
  the data. However, these distributions are not known precisely and
  critical values were determined by Stephens (1974) using
  simulations. These critical values were used for the present function.
}
\value{
  A NULL value is returned, the results are simply printed.
}
\references{
  Paradis, E. (1998) Testing for constant diversification rates using
  molecular phylogenies: a general approach based on statistical tests
  for goodness of fit. \emph{Molecular Biology and Evolution},
  \bold{15}, 476--479.

  Stephens, M. A. (1974) EDF statistics for goodness of fit and some
  comparisons. \emph{Journal of the American Statistical Association},
  \bold{69}, 730--737.
}
\author{Emmanuel Paradis}
\seealso{
  \code{\link{branching.times}}, \code{\link{diversi.time}}
  \code{\link{ltt.plot}}, \code{\link{birthdeath}}, \code{\link{yule}},
  \code{\link{yule.cov}}
}
\examples{
data(bird.families)
x <- branching.times(bird.families)
### suppose we have a sample of expected branching times `y';
### for simplicity, take them from a uniform distribution:
y <- runif(500, 0, max(x) + 1) # + 1 to avoid A2 = Inf
### now compute the expected cumulative distribution:
x <- sort(x)
N <- length(x)
ecdf <- numeric(N)
for (i in 1:N) ecdf[i] <- sum(y <= x[i])/500
### finally do the test:
diversi.gof(x, "user", z = ecdf)
}
\keyword{univar}

\name{alex}
\alias{alex}
\title{Alignment Explorer With Multiple Devices}
\description{
  This function helps to explore DNA alignments by zooming in. The user
  clicks twice defining the opposite corners of the portion which is
  extracted and drawned on a new window.
}
\usage{
alex(x, ...)
}
\arguments{
  \item{x}{an object of class \code{"DNAbin"}.}
  \item{\dots}{further arguments to pass to \code{image.DNAbin}.}
}
\details{
  This function works with a DNA alignment (freshly) plotted on an
  interactive graphical device (i.e., not a file) with \code{image}.
  After calling \code{alex}, the user clicks twice defining a rectangle
  in the alignment, then this portion of the alignment is extacted and
  plotted on a \emph{new} window. The user can click as many times on
  the alignment. The process is stopped by a right-click. If the user
  clicks twice outside the alignment, a message ``Try again!'' is
  printed.

  Each time \code{alex} is called, the alignment is plotted on a new
  window without closing or deleting those possibly already plotted.

  In all cases, the device where \code{x} is plotted is the active
  window after the operation. It should \emph{not} be closed during the
  whole process.
}
\value{NULL}
\author{Emmanuel Paradis}
\seealso{
  \code{\link{image.DNAbin}}, \code{\link{trex}}, \code{\link{alview}}
}
\examples{
\dontrun{
data(woodmouse)
image(woodmouse)
alex(woodmouse)
}}
\keyword{hplot}

\name{as.matching}
\alias{as.matching}
\alias{matching}
\alias{as.matching.phylo}
\alias{as.phylo.matching}
\title{Conversion Between Phylo and Matching Objects}
\description{
  These functions convert objects between the classes \code{"phylo"} and
  \code{"matching"}.
}
\usage{
as.matching(x, ...)
\method{as.matching}{phylo}(x, labels = TRUE, ...)
\method{as.phylo}{matching}(x, ...)
}
\arguments{
  \item{x}{an object to convert as an object of class \code{"matching"}
    or of class \code{"phylo"}.}
  \item{labels}{a logical specifying whether the tip and node labels
    should be included in the returned matching.}
  \item{\dots}{further arguments to be passed to or from other methods.}
}
\details{
  A matching is a representation where each tip and each node are given
  a number, and sibling groups are grouped in a ``matching pair'' (see
  Diaconis and Holmes 1998, for details). This coding system can be used
  only for binary (fully dichotomous) trees.

  Diaconis and Holmes (1998) gave some conventions to insure that a
  given tree has a unique representation as a matching. I have tried to
  follow them in the present functions.
}
\value{
  \code{as.matching} returns an object of class \code{"matching"} with
  the following component:

  \item{matching}{a two-column numeric matrix where the columns
    represent the sibling pairs.}
  \item{tip.label}{(optional) a character vector giving the tip labels
    where the ith element is the label of the tip numbered i in
    \code{matching}.}
  \item{node.label}{(optional) a character vector giving the node
    labels in the same order than in \code{matching} (i.e. the ith
    element is the label of the node numbered i + n in \code{matching},
    with n the number of tips).}

  \code{as.phylo.matching} returns an object of class \code{"phylo"}.
}
\note{
  Branch lengths are not supported in the present version.
}
\author{Emmanuel Paradis}
\references{
  Diaconis, P. W. and Holmes, S. P. (1998) Matchings and phylogenetic
  trees. \emph{Proceedings of the National Academy of Sciences USA},
  \bold{95}, 14600--14602.
}
\seealso{\code{\link{as.phylo}}}
\examples{
data(bird.orders)
m <- as.matching(bird.orders)
str(m)
m
tr <- as.phylo(m)
all.equal(tr, bird.orders, use.edge.length = FALSE)
}
\keyword{manip}

\name{njs}
\alias{njs}
\alias{bionjs}
\title{Tree Reconstruction from Incomplete Distances With NJ* or bio-NJ*}
\description{
  Reconstructs a phylogenetic tree from a distance matrix with possibly
  missing values.
}
\usage{
njs(X, fs = 15)
bionjs(X, fs = 15)
}
\arguments{
  \item{X}{a distance matrix.}
  \item{fs}{argument \emph{s} of the agglomerative criterion: it is
    coerced as an integer and must at least equal to one.}
}
\details{
  Missing values represented by either \code{NA} or any negative number.

  Basically, the Q* criterion is applied to all the pairs of leaves, and
  the \emph{s} highest scoring ones are chosen for further analysis by
  the agglomeration criteria that better handle missing distances (see
  references for details).
}
\value{
  an object of class \code{"phylo"}.
}
\references{
  Criscuolo, A., Gascuel, O. (2008) Fast NJ-like algorithms to deal with
  incomplete distance matrices. \emph{BMC Bioinformatics}, \bold{9},
  166.
}
\author{Andrei Popescu}
\seealso{
  \code{\link{nj}}, \code{\link{bionj}}, \code{\link{triangMtds}}
}
\examples{
data(woodmouse)
d <- dist.dna(woodmouse)
dm <- d
dm[sample(length(dm), size = 3)] <- NA
dist.topo(njs(dm), nj(d)) # often 0
dm[sample(length(dm), size = 10)] <- NA
dist.topo(njs(dm), nj(d)) # sometimes 0
}
\keyword{models}

\name{ape-package}
\alias{ape-package}
\alias{ape}
\docType{package}
\title{
Analyses of Phylogenetics and Evolution
}
\description{
  \pkg{ape} provides functions for reading, writing, manipulating,
  analysing, and simulating phylogenetic trees and DNA sequences,
  computing DNA distances, translating into AA sequences, estimating
  trees with distance-based methods, and a range of methods for
  comparative analyses and analysis of diversification. Functionalities
  are also provided for programming new phylogenetic methods.

  The complete list of functions can be displayed with
  \code{library(help = ape)}.

  More information on \pkg{ape} can be found at \url{http://ape-package.ird.fr/}.
}

\author{
  Emmanuel Paradis, Ben Bolker, Julien Claude, Hoa Sien Cuong, Richard
  Desper, Benoit Durand, Julien Dutheil, Olivier Gascuel, Christoph
  Heibl, Daniel Lawson, Vincent Lefort, Pierre Legendre, Jim Lemon,
  Yvonnick Noel, Johan Nylander, Rainer Opgen-Rhein, Andrei-Alin
  Popescu, Klaus Schliep, Korbinian Strimmer, Damien de Vienne

  Maintainer: Emmanuel Paradis <Emmanuel.Paradis@ird.fr>
}
\references{
  Paradis, E. (2012) \emph{Analysis of Phylogenetics and Evolution with
    R (Second Edition).} New York: Springer.

  Paradis, E., Claude, J. and Strimmer, K. (2004) APE: analyses of
  phylogenetics and evolution in R language. \emph{Bioinformatics},
  \bold{20}, 289--290.

  Popescu, A.-A., Huber, K. T. and Paradis, E. (2012) ape 3.0: new tools
  for distance based phylogenetics and evolutionary analysis in
  R. \emph{Bioinformatics}, \bold{28}, 1536--1537.

  Paradis, E. and Schliep, K. (2019) ape 5.0: an environment for modern
  phylogenetics and evolutionary analyses in R. \emph{Bioinformatics},
  \bold{35}, 526--528.
}
\keyword{package}

\name{birthdeath}
\alias{birthdeath}
\alias{print.birthdeath}
\title{Estimation of Speciation and Extinction Rates With Birth-Death Models}
\usage{
birthdeath(phy)
\method{print}{birthdeath}(x, ...)
}
\arguments{
  \item{phy}{an object of class \code{"phylo"}.}
  \item{x}{an object of class \code{"birthdeath"}.}
  \item{\dots}{further arguments passed to the \code{print} function.}
}
\description{
  This function fits by maximum likelihood a birth-death model to the
  branching times computed from a phylogenetic tree using the method of
  Nee et al. (1994).
}
\details{
  Nee et al. (1994) used a re-parametrization of the birth-death model
  studied by Kendall (1948) so that the likelihood has to be maximized
  over \emph{d/b} and \emph{b - d}, where \emph{b} is the birth rate,
  and \emph{d} the death rate. This is the approach used by the present
  function.

  This function computes the standard-errors of the estimated parameters
  using a normal approximations of the maximum likelihood estimates:
  this is likely to be inaccurate because of asymmetries of the
  likelihood function (Nee et al. 1995). In addition, 95 % confidence
  intervals of both parameters are computed using profile likelihood:
  they are particularly useful if the estimate of \emph{d/b} is at the
  boundary of the parameter space (i.e. 0, which is often the case).

  Note that the function does not check that the tree is effectively
  ultrametric, so if it is not, the returned result may not be meaningful.
}
\value{
  An object of class \code{"birthdeath"} which is a list with the
  following components:
  \item{tree}{the name of the tree analysed.}
  \item{N}{the number of species.}
  \item{dev}{the deviance (= -2 log lik) at its minimum.}
  \item{para}{the estimated parameters.}
  \item{se}{the corresponding standard-errors.}
  \item{CI}{the 95\% profile-likelihood confidence intervals.}
}
\references{
  Kendall, D. G. (1948) On the generalized ``birth-and-death''
  process. \emph{Annals of Mathematical Statistics}, \bold{19}, 1--15.

  Nee, S., May, R. M. and Harvey, P. H. (1994) The reconstructed
  evolutionary process. \emph{Philosophical Transactions of the Royal
    Society of London. Series B. Biological Sciences}, \bold{344}, 305--311.

  Nee, S., Holmes, E. C., May, R. M. and Harvey, P. H. (1995) Estimating
  extinctions from molecular phylogenies. in \emph{Extinction Rates},
  eds. Lawton, J. H. and May, R. M., pp. 164--182, Oxford University Press.
}
\author{Emmanuel Paradis}
\seealso{
  \code{\link{branching.times}}, \code{\link{diversi.gof}},
  \code{\link{diversi.time}}, \code{\link{ltt.plot}},
  \code{\link{yule}}, \code{\link{bd.ext}}, \code{\link{yule.cov}},
  \code{\link{bd.time}}
}
\keyword{models}

\name{plotTreeTime}
\alias{plotTreeTime}
\title{Plot Tree With Time Axis}
\description{
  This function plots a non-ultrametric tree where the tips are not
  contemporary together with their dates on the x-axis.
}
\usage{
plotTreeTime(phy, tip.dates, show.tip.label = FALSE, y.lim = NULL,
             color = TRUE, ...)
}
\arguments{
  \item{phy}{an object of class \code{"phylo"}.}
  \item{tip.dates}{a vector of the same length than the number of tips
    in \code{phy} (see details).}
  \item{show.tip.label}{a logical value; see \code{\link{plot.phylo}}.}
  \item{y.lim}{by default, one fifth of the plot is left below the tree;
    use this option to change this behaviour.}
  \item{color}{a logical value specifying whether to use colors for the
    lines linking the tips to the time axis. If \code{FALSE}, a grey
    scale is used.}
  \item{\dots}{other arguments to be passed to \code{plot.phylo}.}
}
\details{
  The vector \code{tip.dates} may be numeric or of class
  \dQuote{\link[base]{Date}}. In either case, the time axis is set
  accordingly. The length of this vector must be equal to the number of
  tips of the tree: the dates are matched to the tips numbers. Missing
  values are allowed.
}
\value{NULL}
\author{Emmanuel Paradis}
\seealso{
  \code{\link{plot.phylo}}, \code{\link{estimate.dates}}
}
\examples{
dates <- as.Date(.leap.seconds)
tr <- rtree(length(dates))
plotTreeTime(tr, dates)

## handling NA's:
dates[11:26] <- NA
plotTreeTime(tr, dates)

## dates can be on an arbitrary scale, e.g., [-1, 1]:
plotTreeTime(tr, runif(Ntip(tr), -1, 1))
}
\keyword{hplot}

\name{bird.orders}
\alias{bird.orders}
\title{Phylogeny of the Orders of Birds From Sibley and Ahlquist}
\description{
  This data set describes the phylogenetic relationships of the orders
  of birds as reported by Sibley and Ahlquist (1990). Sibley and
  Ahlquist inferred this phylogeny from an extensive number of DNA/DNA
  hybridization experiments. The ``tapestry'' reported by these two
  authors (more than 1000 species out of the ca. 9000 extant bird
  species) generated a lot of debates.

  The present tree is based on the relationships among orders. The
  branch lengths were calculated from the values of \eqn{\Delta
    T_{50}H}{Delta T50H} as found in Sibley and Ahlquist (1990,
  fig. 353).
}
\usage{
data(bird.orders)
}
\format{
  The data are stored as an object of class \code{"phylo"} which
  structure is described in the help page of the function
  \code{\link{read.tree}}.
}
\source{
  Sibley, C. G. and Ahlquist, J. E. (1990) Phylogeny and classification
  of birds: a study in molecular evolution. New Haven: Yale University Press.
}
\seealso{
  \code{\link{read.tree}}, \code{\link{bird.families}}
}
\examples{
data(bird.orders)
plot(bird.orders)
}
\keyword{datasets}

\name{checkAlignment}
\alias{checkAlignment}
\title{Check DNA Alignments}
\description{
  This function performs a series of diagnostics on a DNA alignement.
}
\usage{
checkAlignment(x, check.gaps = TRUE, plot = TRUE, what = 1:4)
}
\arguments{
\item{x}{an object of class \code{"DNAbin"}.}
\item{check.gaps}{a logical value specifying whether to check the
  distribution of alignment gaps.}
\item{plot}{a logical value specifying whether to do the plots.}
\item{what}{an integer value giving the plot to be done. By default,
  four plots are done on the same figure.}
}
\details{
  This function prints on the console a series of diagnostics on the
  set a aligned DNA sequences. If alignment gaps are present, their
  width distribution is analysed, as well as the width of contiguous
  base segments. The pattern of nucleotide diversity on each site is
  also analysed, and a relevant table is printed.

  If \code{plot = TRUE}, four plots are done: an image of the
  alignement, the distribution of gap widths (if present), the Shannon
  index of nucleotide diversity along the sequence, and the number of
  observed bases along the sequence.

  If the sequences contain many gaps, it might be better to set
  \code{check.gaps = FALSE} to skip the analysis of contiguous
  segments.
}
\value{NULL}
\author{Emmanuel Paradis}
\seealso{
\code{\link{alview}}, \code{\link{image.DNAbin}}, \code{\link{all.equal.DNAbin}}
}
\examples{
data(woodmouse)
checkAlignment(woodmouse)
layout(1)
}

\name{pic}
\alias{pic}
\title{Phylogenetically Independent Contrasts}
\description{
  Compute the phylogenetically independent contrasts using the method
  described by Felsenstein (1985).
}
\usage{
pic(x, phy, scaled = TRUE, var.contrasts = FALSE,
    rescaled.tree = FALSE)
}
\arguments{
  \item{x}{a numeric vector.}
  \item{phy}{an object of class \code{"phylo"}.}
  \item{scaled}{logical, indicates whether the contrasts should be
    scaled with their expected variances (default to \code{TRUE}).}
  \item{var.contrasts}{logical, indicates whether the expected
    variances of the contrasts should be returned (default to
    \code{FALSE}).}
  \item{rescaled.tree}{logical, if \code{TRUE} the rescaled tree is
    returned together with the main results.}
}
\details{
  If \code{x} has names, its values are matched to the tip labels of
  \code{phy}, otherwise its values are taken to be in the same order
  than the tip labels of \code{phy}.

  The user must be careful here since the function requires that both
  series of names perfectly match. If both series of names do not match,
  the values in the \code{x} are taken to be in the same order than the
  tip labels of \code{phy}, and a warning message is issued.
}
\value{
  either a vector of phylogenetically independent contrasts (if
  \code{var.contrasts = FALSE}), or a two-column matrix with the
  phylogenetically independent contrasts in the first column and their
  expected variance in the second column (if \code{var.contrasts =
  TRUE}). If the tree has node labels, these are used as labels of the
  returned object.

  If \code{rescaled.tree = TRUE}, a list is returned with two elements
  named ``contr'' with the above results and ``rescaled.tree'' with the
  tree and its rescaled branch lengths (see Felsenstein 1985).
}
\references{
  Felsenstein, J. (1985) Phylogenies and the comparative method.
  \emph{American Naturalist}, \bold{125}, 1--15.
}
\author{Emmanuel Paradis}
\seealso{
  \code{\link{read.tree}}, \code{\link{compar.gee}},
  \code{\link{compar.lynch}}, \code{\link{pic.ortho}},
  \code{\link{varCompPhylip}}
}
\examples{
### The example in Phylip 3.5c (originally from Lynch 1991)
cat("((((Homo:0.21,Pongo:0.21):0.28,",
   "Macaca:0.49):0.13,Ateles:0.62):0.38,Galago:1.00);",
   file = "ex.tre", sep = "\n")
tree.primates <- read.tree("ex.tre")
X <- c(4.09434, 3.61092, 2.37024, 2.02815, -1.46968)
Y <- c(4.74493, 3.33220, 3.36730, 2.89037, 2.30259)
names(X) <- names(Y) <- c("Homo", "Pongo", "Macaca", "Ateles", "Galago")
pic.X <- pic(X, tree.primates)
pic.Y <- pic(Y, tree.primates)
cor.test(pic.X, pic.Y)
lm(pic.Y ~ pic.X - 1) # both regressions
lm(pic.X ~ pic.Y - 1) # through the origin
unlink("ex.tre") # delete the file "ex.tre"
}
\keyword{regression}

\name{dist.dna}
\alias{dist.dna}
\title{Pairwise Distances from DNA Sequences}
\usage{
dist.dna(x, model = "K80", variance = FALSE,
         gamma = FALSE, pairwise.deletion = FALSE,
         base.freq = NULL, as.matrix = FALSE)
}
\arguments{
  \item{x}{a matrix or a list containing the DNA sequences; this must be
    of class \code{"DNAbin"} (use \code{\link{as.DNAbin}} is they are
    stored as character).}
  \item{model}{a character string specifying the evolutionary model to be
    used; must be one of \code{"raw"}, \code{"N"}, \code{"TS"},
    \code{"TV"}, \code{"JC69"}, \code{"K80"} (the default),
    \code{"F81"}, \code{"K81"}, \code{"F84"}, \code{"BH87"},
    \code{"T92"}, \code{"TN93"}, \code{"GG95"}, \code{"logdet"},
    \code{"paralin"}, \code{"indel"}, or \code{"indelblock"}.}
  \item{variance}{a logical indicating whether to compute the variances
    of the distances; defaults to \code{FALSE} so the variances are not
    computed.}
  \item{gamma}{a value for the gamma parameter possibly used to apply a
    correction to the distances (by default no correction is applied).}
  \item{pairwise.deletion}{a logical indicating whether to delete the
    sites with missing data in a pairwise way. The default is to delete
    the sites with at least one missing data for all sequences (ignored
    if \code{model = "indel"} or \code{"indelblock"}).}
  \item{base.freq}{the base frequencies to be used in the computations
    (if applicable). By default, the base frequencies are computed from
    the whole set of sequences.}
  \item{as.matrix}{a logical indicating whether to return the results as
    a matrix. The default is to return an object of class
    \link[stats]{dist}.}
}
\description{
  This function computes a matrix of pairwise distances from DNA
  sequences using a model of DNA evolution. Eleven substitution models
  (and the raw distance) are currently available.
}
\details{
  The molecular evolutionary models available through the option
  \code{model} have been extensively described in the literature. A
  brief description is given below; more details can be found in the
  references.

\itemize{
  \item{\code{raw}, \code{N}: }{This is simply the proportion or the number of
    sites that differ between each pair of sequences. This may be useful
    to draw ``saturation plots''. The options \code{variance} and
    \code{gamma} have no effect, but \code{pairwise.deletion} can.}

  \item{\code{TS}, \code{TV}: }{These are the numbers of transitions and
    transversions, respectively.}

  \item{\code{JC69}: }{This model was developed by Jukes and Cantor (1969). It
    assumes that all substitutions (i.e. a change of a base by another
    one) have the same probability. This probability is the same for all
    sites along the DNA sequence. This last assumption can be relaxed by
    assuming that the substition rate varies among site following a
    gamma distribution which parameter must be given by the user. By
    default, no gamma correction is applied. Another assumption is that
    the base frequencies are balanced and thus equal to 0.25.}

  \item{\code{K80}: }{The distance derived by Kimura (1980), sometimes referred
    to as ``Kimura's 2-parameters distance'', has the same underlying
    assumptions than the Jukes--Cantor distance except that two kinds of
    substitutions are considered: transitions (A <-> G, C <-> T), and
    transversions (A <-> C, A <-> T, C <-> G, G <-> T). They are assumed
    to have different probabilities. A transition is the substitution of
    a purine (C, T) by another one, or the substitution of a pyrimidine
    (A, G) by another one. A transversion is the substitution of a
    purine by a pyrimidine, or vice-versa. Both transition and
    transversion rates are the same for all sites along the DNA
    sequence. Jin and Nei (1990) modified the Kimura model to allow for
    variation among sites following a gamma distribution. Like for the
    Jukes--Cantor model, the gamma parameter must be given by the
    user. By default, no gamma correction is applied.}

  \item{\code{F81}: }{Felsenstein (1981) generalized the Jukes--Cantor model
    by relaxing the assumption of equal base frequencies. The formulae
    used in this function were taken from McGuire et al. (1999)}.

  \item{\code{K81}: }{Kimura (1981) generalized his model (Kimura 1980) by
    assuming different rates for two kinds of transversions: A <-> C and
    G <-> T on one side, and A <-> T and C <-> G on the other. This is
    what Kimura called his ``three substitution types model'' (3ST), and
    is sometimes referred to as ``Kimura's 3-parameters distance''}.

  \item{\code{F84}: }{This model generalizes K80 by relaxing the assumption
    of equal base frequencies. It was first introduced by Felsenstein in
    1984 in Phylip, and is fully described by Felsenstein and Churchill
    (1996). The formulae used in this function were taken from McGuire
    et al. (1999)}.

  \item{\code{BH87}: }{Barry and Hartigan (1987) developed a distance based
    on the observed proportions of changes among the four bases. This
    distance is not symmetric.}

  \item{\code{T92}: }{Tamura (1992) generalized the Kimura model by relaxing
    the assumption of equal base frequencies. This is done by taking
    into account the bias in G+C content in the sequences. The
    substitution rates are assumed to be the same for all sites along
    the DNA sequence.}

  \item{\code{TN93}: }{Tamura and Nei (1993) developed a model which assumes
    distinct rates for both kinds of transition (A <-> G versus C <->
    T), and transversions. The base frequencies are not assumed to be
    equal and are estimated from the data. A gamma correction of the
    inter-site variation in substitution rates is possible.}

  \item{\code{GG95}: }{Galtier and Gouy (1995) introduced a model where the
    G+C content may change through time. Different rates are assumed for
    transitons and transversions.}

  \item{\code{logdet}: }{The Log-Det distance, developed by Lockhart et
    al. (1994), is related to BH87. However, this distance is
    symmetric. Formulae from Gu and Li (1996) are used.
    \code{dist.logdet} in \pkg{phangorn} uses a different
    implementation that gives substantially different distances for
    low-diverging sequences.}

  \item{\code{paralin}: }{Lake (1994) developed the paralinear distance which
    can be viewed as another variant of the Barry--Hartigan distance.}

  \item{\code{indel}: }{this counts the number of sites where there is an
    insertion/deletion gap in one sequence and not in the other.}

  \item{\code{indelblock}: }{same than before but contiguous gaps are
    counted as a single unit. Note that the distance between \code{-A-} and
    \code{A--} is 3 because there are three different blocks of gaps, whereas
    the ``indel'' distance will be 2.}
}}
\note{
  If the sequences are very different, most evolutionary distances are
  undefined and a non-finite value (Inf or NaN) is returned. You may do
  \code{dist.dna(, model = "raw")} to check whether some values are
  higher than 0.75.
}
\value{
  an object of class \link[stats]{dist} (by default), or a numeric
  matrix if \code{as.matrix = TRUE}. If \code{model = "BH87"}, a numeric
  matrix is returned because the Barry--Hartigan distance is not
  symmetric.

  If \code{variance = TRUE} an attribute called \code{"variance"} is
  given to the returned object.
}
\references{
  Barry, D. and Hartigan, J. A. (1987) Asynchronous distance between
  homologous DNA sequences. \emph{Biometrics}, \bold{43}, 261--276.

  Felsenstein, J. (1981) Evolutionary trees from DNA sequences: a
  maximum likelihood approach. \emph{Journal of Molecular Evolution},
  \bold{17}, 368--376.

  Felsenstein, J. and Churchill, G. A. (1996) A Hidden Markov model
  approach to variation among sites in rate of evolution.
  \emph{Molecular Biology and Evolution}, \bold{13}, 93--104.

  Galtier, N. and Gouy, M. (1995) Inferring phylogenies from DNA
  sequences of unequal base compositions. \emph{Proceedings of the
    National Academy of Sciences USA}, \bold{92}, 11317--11321.

  Gu, X. and Li, W.-H. (1996) Bias-corrected paralinear and LogDet
  distances and tests of molecular clocks and phylogenies under
  nonstationary nucleotide frequencies. \emph{Molecular Biology and
    Evolution}, \bold{13}, 1375--1383.

  Jukes, T. H. and Cantor, C. R. (1969) Evolution of protein
  molecules. in \emph{Mammalian Protein Metabolism}, ed. Munro, H. N.,
  pp. 21--132, New York: Academic Press.

  Kimura, M. (1980) A simple method for estimating evolutionary rates of
  base substitutions through comparative studies of nucleotide
  sequences. \emph{Journal of Molecular Evolution}, \bold{16}, 111--120.

  Kimura, M. (1981) Estimation of evolutionary distances between
  homologous nucleotide sequences. \emph{Proceedings of the National
    Academy of Sciences USA}, \bold{78}, 454--458.

  Jin, L. and Nei, M. (1990) Limitations of the evolutionary parsimony
  method of phylogenetic analysis. \emph{Molecular Biology and
    Evolution}, \bold{7}, 82--102.

  Lake, J. A. (1994) Reconstructing evolutionary trees from DNA and
  protein sequences: paralinear distances. \emph{Proceedings of the
    National Academy of Sciences USA}, \bold{91}, 1455--1459.

  Lockhart, P. J., Steel, M. A., Hendy, M. D. and Penny, D. (1994)
  Recovering evolutionary trees under a more realistic model of sequence
  evolution. \emph{Molecular Biology and Evolution}, \bold{11},
  605--602.

  McGuire, G., Prentice, M. J. and Wright, F. (1999). Improved error
  bounds for genetic distances from DNA sequences. \emph{Biometrics},
  \bold{55}, 1064--1070.

  Tamura, K. (1992) Estimation of the number of nucleotide substitutions
  when there are strong transition-transversion and G + C-content
  biases. \emph{Molecular Biology and Evolution}, \bold{9}, 678--687.

  Tamura, K. and Nei, M. (1993) Estimation of the number of nucleotide
  substitutions in the control region of mitochondrial DNA in humans and
  chimpanzees. \emph{Molecular Biology and Evolution}, \bold{10}, 512--526.
}
\author{Emmanuel Paradis}
\seealso{
  \code{\link{read.GenBank}}, \code{\link{read.dna}},
  \code{\link{write.dna}},  \code{\link{DNAbin}},
  \code{\link{dist.gene}}, \code{\link{cophenetic.phylo}},
  \code{\link[stats]{dist}}
}
\keyword{manip}
\keyword{multivariate}
\keyword{cluster}

\name{yule.cov}
\alias{yule.cov}
\title{Fits the Yule Model With Covariates}
\usage{
yule.cov(phy, formula, data = NULL)
}
\arguments{
  \item{phy}{an object of class \code{"phylo"}.}
  \item{formula}{a formula specifying the model to be fitted.}
  \item{data}{the name of the data frame where the variables in
    \code{formula} are to be found; by default, the variables are looked
    for in the global environment.}
}
\description{
  This function fits by maximum likelihood the Yule model with
  covariates, that is a birth-only model where speciation rate is
  determined by a generalized linear model.
}
\details{
  The model fitted is a generalization of the Yule model where the
  speciation rate is determined by:

  \deqn{\ln\frac{\lambda_i}{1 - \lambda_i} = \beta_1 x_{i1} + \beta_2 x_{i2}
    + \dots + \alpha }{ln(li / (1 - li)) = b1 xi1 + b2 xi2 + ... a}

  where \eqn{\lambda_i}{li} is the speciation rate for species i,
  \eqn{x_{i1}, x_{i2}, \dots}{xi1, xi2, ...} are species-specific
  variables, and \eqn{\beta_1, \beta_2, \dots, \alpha}{b1, b2, ..., a}
  are parameters to be estimated. The term on the left-hand side above
  is a logit function often used in generalized linear models for
  binomial data (see \code{\link[stats]{family}}). The above model can
  be written in matrix form:

  \deqn{\mathrm{logit} \lambda_i = x_i' \beta}{logit li = xi' b}

  The standard-errors of the parameters are computed with the second
  derivatives of the log-likelihood function. (See References for other
  details on the estimation procedure.)

  The function needs three things:

\itemize{
  \item a phylogenetic tree which may contain multichotomies;

  \item a formula which specifies the predictors of the model described
  above: this is given as a standard \R formula and has no response (no
  left-hand side term), for instance: \code{~ x + y}, it can include
  interactions (\code{~ x + a * b}) (see \code{\link[stats]{formula}}
  for details);

  \item the predictors specified in the formula must be accessible to
  the function (either in the global space, or though the \code{data}
  option); they can be numeric vectors or factors. The length and the
  order of these data are important: the number of values (length) must
  be equal to the number of tips of the tree + the number of nodes. The
  order is the following: first the values for the tips in the same
  order than for the labels, then the values for the nodes sequentially
  from the root to the most terminal nodes (i.e., in the order given by
  \code{phy$edge}).
}

The user must obtain the values for the nodes separately.

Note that the method in its present implementation assumes that the
change in a species trait is more or less continuous between two nodes
or between a node and a tip. Thus reconstructing the ancestral values
with a Brownian motion model may be consistent with the present
method. This can be done with the function \code{\link{ace}}.
}
\value{
  A NULL value is returned, the results are simply printed. The output
  includes the deviance of the null (intercept-only) model and a
  likelihood-ratio test of the fitted model against the null model.
  Note that the deviance of the null model is different from the one
  returned by \code{\link{yule}} because of the different parametrizations.
}
\references{
  Paradis, E. (2005) Statistical analysis of diversification with
  species traits. \emph{Evolution}, \bold{59}, 1--12.
}
\author{Emmanuel Paradis}
\seealso{
  \code{\link{branching.times}}, \code{\link{diversi.gof}},
  \code{\link{diversi.time}}, \code{\link{ltt.plot}},
  \code{\link{birthdeath}}, \code{\link{bd.ext}}, \code{\link{yule}}
}
\examples{
### a simple example with some random data
data(bird.orders)
x <- rnorm(45) # the tree has 23 tips and 22 nodes
### the standard-error for x should be as large as
### the estimated parameter
yule.cov(bird.orders, ~ x)
### another example with a tree that has a multichotomy
data(bird.families)
y <- rnorm(272) # 137 tips + 135 nodes
yule.cov(bird.families, ~ y)
}
\keyword{models}

\name{DNAbin2indel}
\alias{DNAbin2indel}
\title{Recode Blocks of Indels}
\description{
  This function scans a set of aligned DNA sequences and returns a
  matrix with information of the localisations and lengths on alignment
  gaps.
}
\usage{
DNAbin2indel(x)
}
\arguments{
  \item{x}{an object of class \code{"DNAbin"}.}
}
\details{
  The output matrix has the same dimensions than the input one with,
  either a numeric value where an alignment gap starts giving the length
  of the gap, or zero. The rownames are kept.
}
\value{
  a numeric matrix.
}
\author{Emmanuel Paradis}
\seealso{
  \code{\link{DNAbin}}, \code{\link{as.DNAbin}}, \code{\link{del.gaps}},
  \code{\link{seg.sites}}, \code{\link{image.DNAbin}},
  \code{\link{checkAlignment}}
}
\keyword{manip}
